package energycrops;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import repast.simphony.context.Context;
import repast.simphony.engine.environment.RunEnvironmentBuilder;
import repast.simphony.parameter.Parameters;
import repast.simphony.parameter.SimpleParameterSetter;
import repast.simphony.random.RandomHelper;
import repast.simphony.scenario.ModelInitializer;
import repast.simphony.scenario.Scenario;
import repast.simphony.engine.environment.RunState;

public class EnergyCropsInitializer implements ModelInitializer {
	/**
	 * This is ran after the model has been loaded. This is only ran once, but the settings set
	 * through the {@link Scenario} will apply to every run of the simulation.
	 * 
	 * @param scen the {@link Scenario} object that hold settings for the run
	 */
	public void initialize(Scenario scen, RunEnvironmentBuilder builder) {
		
		
		scen.addParameterSetter(new SimpleParameterSetter() {
			/**
			 * Invoked each run prior to any repast.simphony. system initialization for that run. The
			 * specified params can be used to change the parameters used by the run. In this 
			 * case we are just setting up what the random seed should be.
			 * 
			 * @param params
			 *            the parameters object that is the parameters for the next run
			 */
			
			
			
			
			
			public void next(Parameters params) {
				FileOutputStream fos;
				try {
					fos = new FileOutputStream("output.txt");
					PrintStream ps = new PrintStream(fos);
					System.setOut(ps);
				} catch (FileNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				try {
					fos = new FileOutputStream("error.txt");
					PrintStream ps = new PrintStream(fos);
					System.setErr(ps);
				} catch (FileNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}


				RandomHelper.setSeed(1);
			}
		});
	}

}

