package energycrops;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

import repast.simphony.engine.environment.RunEnvironment;
import repast.simphony.parameter.Parameters;

public class LeaseMarket {
	public static Variables Variables;
	private int acres_of_current_plot_on_market;
	private int acres_of_current_plot_on_marginal_market;
	private int newmarginalland;
	private int natural_pasture_acres_for_rent;
	private int improved_pasture_acres_for_rent;
	private int hay_acres_for_rent;
	private int crop_acres_for_rent;
	private boolean stopmarginalleasemarket;
	private boolean stopcroplandleasemarket;
	private CroplandComparator sComparator;
	public boolean continue_market;
	private Comparator mComparator;

	public LeaseMarket(Variables VS) {
		this.Variables = VS;
		sComparator = new CroplandComparator();
		mComparator = new MarginallandComparator();
	}

	private boolean someoneWantRentCropland() {
		
		for (int i = 0; i < Variables.getfarmerlist().size(); i++) {
			Producer prod = (Producer) Variables.getfarmerlist().get(i);
			prod.update_acres();
			prod.marginal_and_cropland_plots();
			if ((needCropLand(prod.getfarmer_name()) + needMarginalLand(prod.getfarmer_name()) - (int) prod.after_purchase_number_of_lands_cropland) > 0) {
				return true;
			}
		}
		return false;
	}

	private boolean someoneWantRentMarginalland() {
		for (int i = 0; i < Variables.getfarmerlist().size(); i++) {
			Producer prod = (Producer) Variables.getfarmerlist().get(i);
			if (needMarginalLand(prod.getfarmer_name() - (int) prod.after_purchase_number_of_lands_marginal) > 0) {
				return true;
			}
		}
		return false;
	}

	public int needCropLand(int ProducerID) {
		Connection conn;
		int rent = 0;
		if (Variables.get_cropLandNeeds()[ProducerID - 1] == null) {
		try {
			conn = DriverManager.getConnection("jdbc:odbc:producerDB", "java", "1234");
			Statement stmt = conn.createStatement();
			ResultSet rs = stmt
					.executeQuery("SELECT rent_cropland FROM MIP WHERE "
							+ "farmerID=" + ProducerID + "and " + "year="
							+ Variables.getyear());

			while (rs.next()) {
				rent = rs.getInt("rent_cropland");
			}

			rs.close();
			stmt.close();
			conn.close();
		} catch (SQLException e) {
			System.out.println("Statement is wrong: " + e.getMessage());
			e.printStackTrace();
		}
		Variables.get_cropLandNeeds()[ProducerID - 1] = rent;
		return rent;
		} else {
			return Variables.get_cropLandNeeds()[ProducerID - 1];
		}
	}

	public void cropland_lease_market() {
		boolean flag_rent = false;
		if (someoneWantRentCropland()) {
		
			for (int i = 0; i < Variables.getlandlist().size(); i++) {
				SAMA fdl3 = (SAMA) Variables.getlandlist().get(i);
				if ( fdl3.getfor_rent() == true) { //fdl3.getpatchtype()==1 &&
					flag_rent = true;
					break;
				}
			}

			//System.out.println("endless loop");
			// TODO: could this lead to an infinite loop?
			if (flag_rent) {
				Variables.set_lease_bid_list_cropland(new ArrayList());
				//this.record_number_of_lands_cropland();
				//System.out.println("SELECT CALLED CROP LEASE PLOT");
				select_lease_plot_cropland();
							
			} else {
				//System.out.println("NO MORE CROPLAND FOR RENT");
				setstopcroplandleasemarket(true);
			}
			
			if(getstopcroplandleasemarket() == false) {
			if(Variables.getcurrent_cropland_plot() != null) {
				this.create_lease_bid_cropland();
				//System.out.println("crop create bid callled");
			} else {
				flag_rent = false;
			}
			if (flag_rent ==true) { // && this.continue_market
				//System.out.println("cropland lease market called");
				cropland_lease_market();
			}
		}
		}
	}

	public void marginal_land_lease_market(boolean initialized) {
//		set_id_land_market();
		boolean flag_rent = false;
		if (someoneWantRentMarginalland()) {
			for (int i = 0; i < Variables.getlandlist().size(); i++) {
				SAMA fdl3 = (SAMA) Variables.getlandlist().get(i);
				if ((fdl3.getpatchtype() == 2 || fdl3.getpatchtype() == 3) && fdl3.getfor_rent() == true) {
						flag_rent = true;
						break;
				}
			}
			//System.out.println("marginalland_lease_market in LeaseMarket.java" + " flag_rent=" + flag_rent);

			// TODO: could this lead to an infinite loop?
			if (
					//!initialized &&
					flag_rent) {
				Variables.set_lease_bid_list_marginalland(new ArrayList());
				//this.record_number_of_lands_marginal();
				//System.out.println("SELECT CALLED");
				select_lease_plot_Marginalland();
			}
			else {
				//System.out.println("No More Marginal Land for Rent");
				setstopmarginalleasemarket(true);
				
			}
			
			if(getstopmarginalleasemarket() == false) {
			if (Variables.getcurrent_marginal_plot() != null) {
				this.create_lease_bid_Marginalland();
				//System.out.println("create bid called");
			} else {
				flag_rent = false;
			}
			if (this.continue_market && flag_rent == true) {
				//System.out.println("lease market marginal called");
				marginal_land_lease_market(true);
			}
			}
		}
	}

	public void select_lease_plot_cropland() {
		boolean flag_for_rent = false;
		ArrayList<SAMA> rent_land_list = new ArrayList<SAMA>();
		for (int i = 0; i < Variables.getlandlist().size(); i++) {
			SAMA sama = (SAMA) Variables.getlandlist().get(i);

			if (sama.getfor_rent() == true) {
				//if (sama.getpatchtype() == 1) {
					flag_for_rent = true;
					rent_land_list.add(sama);
				//}
			}
		}

//		Arrays.sort((SAMA[])rent_land_list.toArray(), sComparator);
		Collections.sort(rent_land_list, sComparator);
		
	//	System.out.println("land for rent:" + rent_land_list.size() + "year" + Variables.getyear());
		
		if (rent_land_list.size() > 0) {
//			SAMA sama = (SAMA) rent_land_list
//					.get((int) (Math.random() * rent_land_list.size()));
			SAMA sama = (SAMA) rent_land_list.get(0);
			if (flag_for_rent == true) {
				Variables.setcurrent_cropland_plot(sama);
				acres_of_current_plot_on_market = sama.getacres();
				for (int i = 0; i < Variables.getfarmerlist().size(); i++) {
					Producer prod = (Producer) Variables.getfarmerlist().get(i);
					prod.setcan_bid_on_plot(false);
					prod.screen_farmers_plot(sama);
					if(prod.getcan_bid()==true){
						prod.plot_screening(sama);
					}
				}
			}
		}
	}

	public void create_lease_bid_Marginalland() {
		Parameters p = RunEnvironment.getInstance().getParameters();
		double cash_reserve_percent = (Double) p.getValue("cashReservePercent");
		int min_cash_crop_acre = (Integer) p.getValue("minCashCropAcre");
		double d_a_ratio = (Double) p.getValue("daRatio");
		double tax_rate = (Double) p.getValue("taxrate");
		int min_family_withdrawal = (Integer) p.getValue("minFamilyWithdrawal");
		int min_cash_hay_acre = (Integer) p.getValue("mincashhayacre");
		double VC_Cow = (Double) p.getValue("vccow");
		double FC_Cow_Labour = (Double) p.getValue("fccowlabour");
		double min_ratio = (Double) p.getValue("minRatio");
		double inv_mach_2 = (Double) p.getValue("inv_Mach_2");
		double inv_mach_3 = (Double) p.getValue("inv_Mach_3");
		double inv_mach_4 = (Double) p.getValue("inv_Mach_4");
		double inv_mach_5 = (Double) p.getValue("inv_Mach_5");
		double inv_mach_6 = (Double) p.getValue("inv_Mach_6");
		double inv_mach_7 = (Double) p.getValue("inv_Mach_7");
		double inv_mach_8 = (Double) p.getValue("inv_Mach_8");
		double inv_mach_9 = (Double) p.getValue("inv_Mach_9");
		double inv_handling = (Double) p.getValue("invhandling");
		double inv_cow_machine = (Double) p.getValue("invcowmachine");
		double family_living_bid = (Double) p.getValue("family_living_bid");
		int acres_leased = 0;
		boolean someProducerWantRent = false;
		Variables.set_lease_bid_list_marginalland(null);
		for (int i = 0; i < Variables.getfarmerlist().size(); i++) {
			Producer prod = (Producer) Variables.getfarmerlist().get(i);
			prod.update_acres();
			prod.marginal_and_cropland_plots();
			this.record_number_of_lands_marginal();
			double total_plots_after = prod.gettotal_marginal_plots();
			//	System.out.println("total_plots_after:" + total_plots_after + " "
					//	+ prod.getfarmer_name());

				double total_plots_rented = total_plots_after - prod.number_of_lands_marginal;
				int needs_marginal_land = needMarginalLand(prod.getfarmer_name());
			
			if (needs_marginal_land < Integer.MAX_VALUE && 
				needs_marginal_land - prod.number_of_lands_marginal > 0) {

			//	System.out.println("Rent Marginal Lands: " + "name="
					//	+ prod.getfarmer_name() + "need="
					//	+ needMarginalLand(prod.getfarmer_name())
					//	+ "number of lands=" + prod.number_of_lands);

				boolean should_bid_rent = true;

				// SAMA sama = (SAMA) Variables.getlandlist().get(
				// Variables.getcurrent_plot_on_market());
				SAMA sama = Variables.getcurrent_marginal_plot();
//				System.out.println("MARGINAL_SAMA=" + sama.getID());

				prod.setcurrent_bid_marginalland(0);

				double total_acres = (prod.getoption_0_acres()
						+ prod.getoption_1_acres() + prod.getoption_2_acres()
						+ prod.getoption_3_acres() + prod.getoption_4_acres()
						+ prod.getoption_5_acres() + prod.getoption_6_acres()
						+ prod.getoption_7_acres() + prod.getoption_8_acres()
						+ prod.getoption_9_acres() + prod.getnatural_pasture()
						+ prod.getrent_out_natural_pasture()
						+ prod.getrent_out_improved_pasture()
						+ prod.getrent_out_hayland_pasture()
						+ prod.getwillows_on_natural_pasture() + prod.getwillows_on_improved_pasture() + prod.getwillows_on_hayland_pasture()
						+ prod.getimproved_pasture()
						+ prod.gethayland_pasture()
						+ prod.getimproved_bale_first_cut()
						+ prod.getimproved_bale_second_cut()
						+ prod.gethay_production_one_cut() + prod
						.gethay_production_two_cuts());
				
				double crop_acres = (prod.getoption_0_acres()
						+ prod.getoption_1_acres() + prod.getoption_2_acres()
						+ prod.getoption_3_acres() + prod.getoption_4_acres()
						+ prod.getoption_5_acres() + prod.getoption_6_acres()
						+ prod.getoption_7_acres() + prod.getoption_8_acres() + prod
						.getoption_9_acres());
				
				double hay_acres = (prod.getnatural_pasture()
				+ prod.getrent_out_natural_pasture()
				+ prod.getrent_out_improved_pasture()
				+ prod.getrent_out_hayland_pasture()
				+ prod.getwillows_on_natural_pasture() + prod.getwillows_on_improved_pasture() + prod.getwillows_on_hayland_pasture()
				+ prod.getimproved_pasture()
				+ prod.gethayland_pasture()
				+ prod.getimproved_bale_first_cut()
				+ prod.getimproved_bale_second_cut()
				+ prod.gethay_production_one_cut() + prod
				.gethay_production_two_cuts());
				
				
				double expected_income = prod.getexpected_income();

				double income_tax = expected_income * tax_rate;
				double expected_income_aftertax = expected_income - income_tax;
					
				//System.out.println("Income " + expected_income_aftertax + "farmer" + prod.getfarmer_name());
				double current_bid_marginallease = expected_income_aftertax  / total_acres * prod.risk_parameter;
				if(current_bid_marginallease < 0) {
					current_bid_marginallease = 0;
				}
				prod.setcurrent_bid_marginalland(current_bid_marginallease);
			//	System.out.println("marginalland_bid:"
				//		+ prod.getcurrent_bid_marginalland());
				//System.out.println("acres of current plot on marginal Market="
					//	+ acres_of_current_plot_on_marginal_market);
				if (prod.getcurrent_bid_marginalland() > 0) {
					

					double down_payment = 0.25;
					double min_cash = (crop_acres * min_cash_crop_acre) +(hay_acres * min_cash_hay_acre) + (min_family_withdrawal) + (prod.getcash() * cash_reserve_percent);
					
					double capital_available = prod.getcash() - min_cash;

					double newdebt = (prod.getDEBT() + ((inv_mach_2 * min_ratio * prod
							.getoption_2_number_machines())
							+ (inv_mach_3 * min_ratio * prod
									.getoption_3_number_machines())
							+ (inv_mach_4 * min_ratio * prod
									.getoption_4_number_machines())
							+ (inv_mach_5 * min_ratio * prod
									.getoption_5_number_machines())
							+ (inv_mach_6 * min_ratio * prod
									.getoption_6_number_machines())
							+ (inv_mach_7 * min_ratio * prod
									.getoption_7_number_machines())
							+ (inv_mach_8 * min_ratio * prod
									.getoption_8_number_machines())
							+ (inv_mach_9 * min_ratio * prod
									.getoption_9_number_machines())
							+ (inv_handling * min_ratio * prod.getcows_fc_handling_system())
							+ (inv_cow_machine * min_ratio * prod.getcows_fc_machinery()		
									
									
							+ (prod.getcows_head() * VC_Cow) + prod
							.getcows_labour()
							* FC_Cow_Labour)));

					double newasset = (prod.getASSETS()
							+ (inv_mach_2 * prod.getoption_2_number_machines())
							+ (inv_mach_3 * prod.getoption_3_number_machines())
							+ (inv_mach_4 * prod.getoption_4_number_machines())
							+ (inv_mach_5 * prod.getoption_5_number_machines())
							+ (inv_mach_6 * prod.getoption_6_number_machines())
							+ (inv_mach_7 * prod.getoption_7_number_machines())
							+ (inv_mach_8 * prod.getoption_8_number_machines())
							+ (inv_mach_9 * prod.getoption_9_number_machines()) 
							+ (inv_handling * prod.getcows_fc_handling_system())
							+ (inv_cow_machine * prod.getcows_fc_machinery())	
							
							+ (prod
							.getcows_head() * Variables.getprice_calf()));

					double marketvaluerentland = sama.getAvg_prod_patch()
							/ Variables.getmean_patch_quality()
							* Variables.getmarginallease_rate() * sama.getacres();

					double max_debt_asset_bid_total = (((d_a_ratio * newasset) + (d_a_ratio * marketvaluerentland)) - newdebt)
							/ (d_a_ratio * down_payment + (1 - down_payment));

					

					double bid_finances = (int) (capital_available / down_payment);
					//System.out.println("bid_finances_marginal=" + bid_finances);
					if (max_debt_asset_bid_total < bid_finances) {
						bid_finances = (int) max_debt_asset_bid_total;
					}
				//	System.out.println("bid_finances_marginal=" + bid_finances);
					bid_finances = (int) (bid_finances
							/ acres_of_current_plot_on_marginal_market * prod.risk_parameter);
					//System.out.println("bid_finances_marginal=" + bid_finances);
					if (bid_finances < prod.getcurrent_bid_marginalland()) {
						prod.setcurrent_bid_marginalland(bid_finances);
					}
				}
				if (prod.getcurrent_bid_marginalland() < 0) {
					prod.setcurrent_bid_marginalland(0);
				}

				if (prod.getcurrent_bid_marginalland() > 0) {
					if (Variables.get_lease_bid_list_marginalland() == null) {
						ArrayList bidl = new ArrayList();

						bidl.add(new BidListMarginalland(prod.getfarmer_name(),
								prod.getcurrent_bid_marginalland()));
						Variables.set_lease_bid_list_marginalland(bidl);

					} else {
						ArrayList bidl = Variables
								.get_lease_bid_list_marginalland();
						bidl.add(new BidListMarginalland(prod.getfarmer_name(),
								prod.getcurrent_bid_marginalland()));
						Variables.set_lease_bid_list_marginalland(bidl);
					}
					someProducerWantRent = true;
				}
			} else {
				prod.update_acres();
				prod.marginal_and_cropland_plots();
				//prod.update_farmers_land_info();

			}
		}
		
		if(Variables.get_lease_bid_list_marginalland() == null) {
			SAMA sama = Variables.getcurrent_marginal_plot();
			sama.setfor_rent(false);
			//System.out.println("sama setfor_rent is false with sama="+sama.getID());
			sama.setfor_sale(true);
			this.continue_market = false;
			sama.setbidders(0);
			for (int i = 0; i < Variables.getfarmerlist().size(); i++) {
				Producer prod = (Producer) Variables.getfarmerlist().get(i);
				prod.update_acres();

				if (prod.getcan_bid_on_plot() == true) {
					sama.setbidders(sama.getbidders() + 1);
				}
			}
		}

		SAMA sama = Variables.getcurrent_marginal_plot();
		if (someProducerWantRent) {
			double adjusted_lease_rate = 0;
			double lease_value = 0;
			double bid_1 = 0;
			double bid_2 = 0;

			ArrayList al = Variables.get_lease_bid_list_marginalland();
			if (al.size() > 1) {
				for (int i = 0; i < al.size(); i++) {
					BidListMarginalland bidlist = (BidListMarginalland) al
							.get(i);

					if (bidlist.getcurrent_bid_marginalland() > bid_1) {
						bid_1 = bidlist.getcurrent_bid_marginalland();
						Variables.setleaser(bidlist.getproducer_id());
						// System.out.println("OTTAWA:" + bid_1);
					} else {
						if (bidlist.getcurrent_bid_marginalland() > bid_2) {
							bid_2 = bidlist.getcurrent_bid_marginalland();
							// System.out.println("SASKATOON:" + bid_2);
						}
					}
				}

			} else {
				if (al.size() == 1) {
					BidListMarginalland bidlist = (BidListMarginalland) al
							.get(0);
					bid_1 = bidlist.getcurrent_bid_marginalland();
					Variables.setleaser(bidlist.getproducer_id());

				}
			}

			// System.out.println("someProducerWantRent");
		//	System.out.println("Leighsize=" + al.size() + "bid_1= " + bid_1
			//		+ " bid_2=" + bid_2);
			if (al.size() <= 2) {

				bid_2 = 0;

			}

			// SAMA sama = (SAMA) Variables.getlandlist().get(
			// Variables.getcurrent_plot_on_market());
			
//			System.out.println("MARGINAL_SAMA=" + sama.getID());
			double plot_q = sama.getAvg_prod_patch();
			double market_rate = plot_q / Variables.getmean_patch_quality()
					* Variables.getmarginallease_rate();
			// System.out.println("market_rate:" + market_rate);

			if (bid_1 > 0) {
				if (bid_2 > 0) {
					lease_value = (bid_1 + bid_2) / 2;
					// System.out.println("LEASEVALUE:" + lease_value);
				} else {
					lease_value = bid_1;
					// System.out.println("leasevalue2:" + lease_value);

				}
				market_rate = sama.getAvg_prod_patch()
						/ Variables.getmean_patch_quality()
						* Variables.getmarginallease_rate();

				sama.setcurrent_producer(Variables.getleaser());

				sama.setfor_rent(false);
				Producer prod = null;
				//System.out.println("farmerlist size="
					//	+ Variables.getfarmerlist().size());
				if (Variables.getfarmerlist().size() > 0) {
					int leaser_name = Variables.getleaser();
					for (Producer pr : (ArrayList<Producer>) Variables
							.getfarmerlist()) {
						if (pr.getfarmer_name() == leaser_name) {
							prod = pr;
							break;
						}
					}

					prod.number_of_lands_marginal = (int) prod.gettotal_marginal_plots()
							- prod.init_number_of_lands_marginal;

					prod.add_land(sama);
					acres_leased = sama.getacres();
					//System.out.println("marginallandlease:" + acres_leased);
					sama.setrenter(prod.getfarmer_name());
					sama.setfor_rent(false);
					// for(Producer p : (ArrayList<Producer>)
					// Variables.get_lease_bid_list_marginalland()) {
					// if(p.getfarmer_name()==prod.getfarmer_name()) {
					// Variables.get_lease_bid_list_marginalland().remove(o)
					// }
					// }
					//System.out.println("Marginal Land Succeed: " + "Sama="
						//	+ sama.getID() + " Prod=" + prod.getfarmer_name());
					//System.out.println("leaseprice="+lease_value+" mean_patch_quality="+Variables.getmean_patch_quality()
							//+" avg_prod_patch="+sama.getAvg_prod_patch());
					
					sama.setdistance_to_farm((int) (Math.sqrt(Math.pow(prod
							.getX()
							- sama.getX(), 2)
							+ Math.pow(prod.getY() - sama.getY(), 2))));
					sama.setcame_from_bid(false);

					sama.setlease_term(0);

					adjusted_lease_rate = (int) (Math.round(lease_value
							* Variables.getmean_patch_quality()
							/ sama.getAvg_prod_patch()));
					sama.setlease_payment(lease_value);
					//System.out.println("Lease Price " + lease_value);
					MarginalLeasePrice mlp = new MarginalLeasePrice();
					mlp.setmarginallease_price((int) lease_value);
					mlp.setlease_farmer(prod.getfarmer_name());
					ArrayList marginallease_list_array = Variables.getmarginalland_lease_list();
					marginallease_list_array.add(mlp);
					Variables.setmarginalland_lease_list(marginallease_list_array);

					prod.update_acres();

					//prod.update_debt();

					prod.balance_sheet();

					//prod.update_farmers_land_info();

				}
			}
		} else {

				sama.setfor_rent(false);
				sama.setfor_sale(true);
				sama.setbidders(0);
				this.continue_market = false;
				System.out.println("continue_market is false");
				for (int i = 0; i < Variables.getfarmerlist().size(); i++) {
					Producer prod = (Producer) Variables.getfarmerlist().get(i);
					prod.update_acres();

					if (prod.getcan_bid_on_plot() == true) {
						sama.setbidders(sama.getbidders() + 1);
					}
				}				
			}
	}

	public void create_lease_bid_cropland() {
		Parameters p = RunEnvironment.getInstance().getParameters();
		double max_percent_cf = (Double) p.getValue("maxPercentCF");
		double interest_rate = (Double) p.getValue("interestRate");
		int min_cash_hay_acre = (Integer) p.getValue("mincashhayacre");
		double d_a_ratio = (Double) p.getValue("daRatio");
		double tax_rate = (Double) p.getValue("taxrate");
		double min_ratio = (Double) p.getValue("minRatio");
		double inv_mach_0 = (Double) p.getValue("inv_Mach_0");
		double inv_mach_1 = (Double) p.getValue("inv_Mach_1");
		double inv_mach_2 = (Double) p.getValue("inv_Mach_2");
		double inv_mach_3 = (Double) p.getValue("inv_Mach_3");
		double inv_mach_4 = (Double) p.getValue("inv_Mach_4");
		double inv_mach_5 = (Double) p.getValue("inv_Mach_5");
		double inv_mach_6 = (Double) p.getValue("inv_Mach_6");
		double inv_mach_7 = (Double) p.getValue("inv_Mach_7");
		double inv_mach_8 = (Double) p.getValue("inv_Mach_8");
		double inv_mach_9 = (Double) p.getValue("inv_Mach_9");
		double inv_handling = (Double) p.getValue("invhandling");
		double inv_cow_machine = (Double) p.getValue("invcowmachine");
		int min_family_withdrawal = (Integer) p.getValue("minFamilyWithdrawal");
		int min_cash_crop_acre = (Integer) p.getValue("minCashCropAcre");
		double FC_Cow_Labour = (Double) p.getValue("fccowlabour");
		int acres_leased = 0;
		double marketvaluerentland = 0;
		double VC_Cow = (Double) p.getValue("vccow");
		double cash_reserve_percent = (Double) p.getValue("cashReservePercent");
		boolean someProducerWantRent = false;
		Variables.set_lease_bid_list_cropland(null);
		for (int i = 0; i < Variables.getfarmerlist().size(); i++) {
			Producer prod = (Producer) Variables.getfarmerlist().get(i);
			prod.update_acres();
			prod.marginal_and_cropland_plots();
			this.record_number_of_lands_cropland();
			double total_plots_after = prod.gettotal_cropland_plots() + prod.gettotal_marginal_plots();
			
			int needs_crop_land = needCropLand(prod.getfarmer_name()) + needMarginalLand(prod.getfarmer_name());
			
			
			if ( needs_crop_land < Integer.MAX_VALUE && 
					needs_crop_land - prod.number_of_lands_cropland> 0)  {

				
				if(prod.getcan_bid_on_plot()==true){
					//System.out.println("distance ok"+ prod.getfarmer_name());
					boolean should_bid_rent = true;
				
				SAMA sama = Variables.getcurrent_cropland_plot();

				prod.setcurrent_bid(0);

				double total_acres = (prod.getoption_0_acres()
						+ prod.getoption_1_acres() + prod.getoption_2_acres()
						+ prod.getoption_3_acres() + prod.getoption_4_acres()
						+ prod.getoption_5_acres() + prod.getoption_6_acres()
						+ prod.getoption_7_acres() + prod.getoption_8_acres()
						+ prod.getoption_9_acres() + prod.getnatural_pasture()
						+ prod.getrent_out_natural_pasture()
						+ prod.getrent_out_improved_pasture()
						+ prod.getrent_out_hayland_pasture()
						+ prod.getwillows_on_natural_pasture() + prod.getwillows_on_improved_pasture() + prod.getwillows_on_hayland_pasture()
						+ prod.getpoplar_on_natural_pasture() + prod.getpoplar_on_improved_pasture() + prod.getpoplar_on_hayland_pasture()
						+ prod.getprairie_sandreed_on_natural_pasture() + prod.getprairie_sandreed_on_improved_pasture() + prod.getprairie_sandreed_on_hayland_pasture()
						+ prod.getimproved_pasture()
						+ prod.gethayland_pasture()
						+ prod.getimproved_bale_first_cut()
						+ prod.getimproved_bale_second_cut()
						+ prod.gethay_production_one_cut() + prod
						.gethay_production_two_cuts());
				// System.out.println("acres trying to rent:" + total_acres);
				double crop_acres = (prod.getoption_0_acres()
						+ prod.getoption_1_acres() + prod.getoption_2_acres()
						+ prod.getoption_3_acres() + prod.getoption_4_acres()
						+ prod.getoption_5_acres() + prod.getoption_6_acres()
						+ prod.getoption_7_acres() + prod.getoption_8_acres() + prod
						.getoption_9_acres()
						+ prod.getrent_out_cropland());
				
				double hay_acres = (prod.getnatural_pasture()
				+ prod.getrent_out_cropland()
				+ prod.getrent_out_natural_pasture()
				+ prod.getrent_out_improved_pasture()
				+ prod.getrent_out_hayland_pasture()
				+ prod.getwillows_on_natural_pasture() + prod.getwillows_on_improved_pasture() + prod.getwillows_on_hayland_pasture()
				+ prod.getpoplar_on_natural_pasture() + prod.getpoplar_on_improved_pasture() + prod.getpoplar_on_hayland_pasture()
				+ prod.getprairie_sandreed_on_natural_pasture() + prod.getprairie_sandreed_on_improved_pasture() + prod.getprairie_sandreed_on_hayland_pasture()
				+ prod.getimproved_pasture()
				+ prod.gethayland_pasture()
				+ prod.getimproved_bale_first_cut()
				+ prod.getimproved_bale_second_cut()
				+ prod.gethay_production_one_cut() + prod
				.gethay_production_two_cuts());
				
				double expected_income = prod.getexpected_income();

				double income_tax = expected_income * tax_rate;
				double expected_income_aftertax = expected_income - income_tax - prod.getfamily_living();
				double current_bid = expected_income_aftertax / total_acres
						* prod.risk_parameter;
				
				current_bid = sama.getAvg_prod_patch()/Variables.getmean_patch_quality() * current_bid;
				
				
				
				//System.out.println("bidl:" + current_bid + "farmer" + prod.getfarmer_name());
				if(current_bid == Double.POSITIVE_INFINITY){ //Double.POSITIVE_INFINITY ||Float.POSITIVE_INFINITY
					//System.out.println("BID IS INFINITE");
					current_bid = 0;
				}
				
				if(current_bid <= 0) {
					current_bid = 0;
				}
				prod.setcurrent_bid(current_bid);
				
								
				if (prod.getcurrent_bid() > 0) {
					
					double min_cash = (crop_acres * min_cash_crop_acre) + (hay_acres * min_cash_hay_acre) + (prod.getcash() * cash_reserve_percent - prod.getfamily_living() + prod.gettotal_crop_lease_payment() + prod.gettotal_marginal_lease_payment() + prod.getdebt_payment());
					double down_payment = 0.25;

					double capital_available = prod.getcash() - min_cash;

					double exp_total_cf = prod.getcash() + prod.getexpected_income() -  income_tax - min_family_withdrawal - prod.gettotal_crop_lease_payment() - prod.gettotal_marginal_lease_payment() - prod.getdebt_payment() + prod.getoff_farm_inc() - min_cash ;
					
					
					

					double newdebt = (prod.getDEBT()  + ((inv_mach_0 * min_ratio * prod
									.getoption_0_number_machines())
							+ (inv_mach_1 * min_ratio * prod
									.getoption_1_number_machines())
							+ (inv_mach_2 * min_ratio * prod
							.getoption_2_number_machines())
							+ (inv_mach_3 * min_ratio * prod
									.getoption_3_number_machines())
							+ (inv_mach_4 * min_ratio * prod
									.getoption_4_number_machines())
							+ (inv_mach_5 * min_ratio * prod
									.getoption_5_number_machines())
							+ (inv_mach_6 * min_ratio * prod
									.getoption_6_number_machines())
							+ (inv_mach_7 * min_ratio * prod
									.getoption_7_number_machines())
							+ (inv_mach_8 * min_ratio * prod
									.getoption_8_number_machines())
							+ (inv_mach_9 * min_ratio * prod
									.getoption_9_number_machines() + 
							(inv_handling * min_ratio * prod.getcows_fc_handling_system())
							+ (inv_cow_machine * min_ratio * prod.getcows_fc_machinery()		
							+ (prod.getcows_head() * VC_Cow) + prod.getcows_labour()
							* FC_Cow_Labour))));
					// System.out.println("newdebt:" + newdebt);
					double newasset = prod.getASSETS() + (inv_mach_0 * prod.getoption_0_number_machines())
					+ (inv_mach_1 * prod.getoption_1_number_machines())
					+ (inv_mach_2 * prod.getoption_2_number_machines())
					+ (inv_mach_3 * prod.getoption_3_number_machines())
					+ (inv_mach_4 * prod.getoption_4_number_machines())
					+ (inv_mach_5 * prod.getoption_5_number_machines())
					+ (inv_mach_6 * prod.getoption_6_number_machines())
					+ (inv_mach_7 * prod.getoption_7_number_machines())
					+ (inv_mach_8 * prod.getoption_8_number_machines())
					+ (inv_mach_9 * prod.getoption_9_number_machines()) 
					+ (inv_handling * prod.getcows_fc_handling_system())
							+ (inv_cow_machine * prod.getcows_fc_machinery())	
							
							+ (prod
							.getcows_head() * Variables.getprice_calf());
					// System.out.println("newasset:" + newasset);
					
					if(sama.getpatchtype() == 1){
					marketvaluerentland = sama.getAvg_prod_patch()
							/ Variables.getmean_patch_quality()
							* Variables.getcroplease_rate() * total_acres;
					// System.out.println("marketvaluerentland:" +
					// marketvaluerentland + " " + prod.getfarmer_name());
					}
					if(sama.getpatchtype()== 2 || sama.getpatchtype() == 3){
					marketvaluerentland = sama.getAvg_prod_patch()
						/ Variables.getmean_patch_quality()
						* Variables.getmarginallease_rate() * total_acres;
					}
					
					
					double max_debt_asset_bid_total = ((d_a_ratio * newasset
							+ d_a_ratio * marketvaluerentland - newdebt) / (d_a_ratio
							* down_payment + (1 - down_payment)));

				

					// System.out.println("maxdabid:" + max_debt_asset_bid);
					double bid_finances = (int) (capital_available / down_payment);
					// System.out.println("bid_finances=" + bid_finances);
					
					
						if (max_debt_asset_bid_total < bid_finances) {
							bid_finances = (int) max_debt_asset_bid_total;
						}
					
					// System.out.println("bid_finances=" + bid_finances
					// + " acres=" + acres_of_current_plot_on_market);
					bid_finances = (int) (bid_finances
							/ acres_of_current_plot_on_market * prod.risk_parameter);
					// System.out.println("bid_finances=" + bid_finances);
					if (bid_finances < prod.getcurrent_bid()) {
						prod.setcurrent_bid(bid_finances);
						
					}
					
					double new_debt_pay_cow_mach = (1 - down_payment) * (newasset)
					* Variables.getloan_factor_payment_5();
		
			
			} else {
				current_bid = 0;
			}
					
				
				if (prod.getcurrent_bid() < 0) {
					prod.setcurrent_bid(0);
//					System.out.println("current bid is less than zero");
				} else if (prod.getcurrent_bid() > 0) {
					if (Variables.get_lease_bid_list_cropland() == null) {
						ArrayList bidl = new ArrayList();

						bidl.add(new BidListCropland(prod.getfarmer_name(),
								current_bid));
						Variables.set_lease_bid_list_cropland(bidl);
						
					} else {
						ArrayList bidl = Variables
								.get_lease_bid_list_cropland();
						bidl.add(new BidListCropland(prod.getfarmer_name(),
								current_bid));
						Variables.set_lease_bid_list_cropland(bidl);
					}
					
					
					if (prod.getcurrent_bid() > 0){
						someProducerWantRent = true;
					}
				}
				}else {
					//System.out.println("distance too far"+ prod.getfarmer_name());
				}
			} else {
				
				
				//this.continue_market = false;
				prod.update_acres();
				prod.marginal_and_cropland_plots();

			
			}
		} 
		
		if(Variables.get_lease_bid_list_cropland() == null) {
			SAMA sama = Variables.getcurrent_cropland_plot();
			sama.setfor_rent(false);
			//System.out.println("sama setfor_rent is false with sama="+sama.getID());
			sama.setfor_sale(true);
			this.continue_market = false;
			sama.setbidders(0);
			for (int i = 0; i < Variables.getfarmerlist().size(); i++) {
				Producer prod = (Producer) Variables.getfarmerlist().get(i);
				prod.update_acres();

				if (prod.getcan_bid_on_plot() == true) {
					sama.setbidders(sama.getbidders() + 1);
				}
			}
		}
		
		SAMA sama = Variables.getcurrent_cropland_plot();
		if (someProducerWantRent) {
			double adjusted_lease_rate = 0;
			double lease_value = 0;
			double market_rate = 0;
			double bid_1 = 0;
			double bid_2 = 0;

			double[] bids = calculate_bids(bid_1, bid_2);
			bid_1 = bids[0];
			bid_2 = bids[1];


			double plot_q = sama.getAvg_prod_patch();
			
			if (bid_1 > 0) {
				if (bid_2 > 0) {
					lease_value = (bid_1 + bid_2) / 2;

				} else {
					lease_value = bid_1;

				}
				if(sama.getpatchtype() == 1){
				market_rate = sama.getAvg_prod_patch()
						/ Variables.getmean_patch_quality()
						* Variables.getcroplease_rate();
				}
				if(sama.getpatchtype() == 2 || sama.getpatchtype()== 3){
				market_rate = sama.getAvg_prod_patch()
						/ Variables.getmean_patch_quality()
						* Variables.getmarginallease_rate();
				}
				sama.setcurrent_producer(Variables.getleaser());
			
				acres_leased = sama.getacres();
				sama.setfor_rent(false);
				Producer prod = null;
				if (Variables.getfarmerlist().size() > 0) {
					int leaser_name = Variables.getleaser();
					for (Producer pr : (ArrayList<Producer>) Variables
							.getfarmerlist()) {
						if (pr.getfarmer_name() == leaser_name) {
							prod = pr;
							break;
						}
					}

					

					// System.out.println("newcropland:" + newcropland);
					prod.add_land(sama);
					prod.update_acres();
					prod.marginal_and_cropland_plots();
					Variables.remove_leaser(prod);
//					System.out.println("sama=" + sama.getID() + " producer="
//							+ prod.getfarmer_name()
//							+ " producer.number_of_lands="
//							+ prod.number_of_lands_cropland + " Producer landlist size="
//							+ prod.getmylandList().size()
//							+ " Producer init number of lands="
//							+ prod.init_number_of_lands_cropland);
					prod.number_of_lands_cropland = (int) ((int) prod.gettotal_cropland_plots() + prod.gettotal_marginal_plots()
							- prod.init_number_of_lands_cropland);
					sama.setrenter(prod.getfarmer_name());
					// System.out.println("producerLANDLIST: "
					// + prod.getmylandList().size());
					
					//System.out.println("Cropland Succeed:" + "sama=" + sama.getID() + "PROD=" + prod.getfarmer_name() + "year" + Variables.getyear());
					//System.out.println("leaseprice="+lease_value);
					sama.setdistance_to_farm((int) (Math.sqrt(Math.pow(prod
							.getX()
							- sama.getX(), 2)
							+ Math.pow(prod.getY() - sama.getY(), 2))));
					sama.setcame_from_bid(false);

					sama.setlease_term(7);

					
					adjusted_lease_rate = (int) (Math.round(lease_value
							* Variables.getmean_patch_quality()
							/ sama.getAvg_prod_patch()));

				
					//System.out.println("lease value "+ sama.getlease_payment());
					if(sama.getpatchtype() == 1){
					sama.setlease_payment(lease_value);
					Variables.setcrop_plots_leased(Variables.getcrop_plots_leased()+1);	
					CropLeasePrice lp = new CropLeasePrice();
					lp.setcroplease_price((int) lease_value);
					lp.setlease_farmer(prod.getfarmer_name());
					ArrayList lease_list_array = Variables.getcropland_lease_list();
					lease_list_array.add(lp);
					Variables.setcropland_lease_list(lease_list_array);
					}
					if(sama.getpatchtype()== 2 || sama.getpatchtype()== 3){
						sama.setlease_payment_pasture(lease_value);
						Variables.setmarginal_plots_leased(Variables.getmarginal_plots_leased()+1);	
						MarginalLeasePrice mlp = new MarginalLeasePrice();
						mlp.setmarginallease_price((int) lease_value);
						mlp.setlease_farmer(prod.getfarmer_name());
						ArrayList marginallease_list_array = Variables.getmarginalland_lease_list();
						marginallease_list_array.add(mlp);
						Variables.setmarginalland_lease_list(marginallease_list_array);	
					}
					

					prod.balance_sheet();

					
					sama.setfor_rent(false);

				}
			} else {
				sama.setfor_rent(false);
				//System.out.println("sama setfor_rent is false with sama="+sama.getID());
				sama.setfor_sale(true);
				this.continue_market = false;
				sama.setbidders(0);
				for (int i = 0; i < Variables.getfarmerlist().size(); i++) {
					Producer prod = (Producer) Variables.getfarmerlist().get(i);
					prod.update_acres();

					if (prod.getcan_bid_on_plot() == true) {
						sama.setbidders(sama.getbidders() + 1);
					}
				}

			}

		}
		
		
		
	}

	private double[] calculate_bids(double bid_1, double bid_2) {
		ArrayList al = Variables.get_lease_bid_list_cropland();
		if (al.size() > 1) {
			for (int i = 0; i < al.size(); i++) {
				BidListCropland bidlist = (BidListCropland) al.get(i);
				if (bidlist.getcurrent_bid() > bid_1) {
					bid_1 = bidlist.getcurrent_bid();
					Variables.setleaser(bidlist.getproducer_id());
					// System.out.println("REPAST:" + bid_1);
				} else {
					if (bidlist.getcurrent_bid() > bid_2) {
						bid_2 = bidlist.getcurrent_bid();
						// System.out.println("JAVA:" + bid_2);
					}
				}
			}

		} else {
			if (al.size() == 1) {
				BidListCropland bidlist = (BidListCropland) al.get(0);
				bid_1 = bidlist.getcurrent_bid();
				Variables.setleaser(bidlist.getproducer_id());
				 //System.out.println("Leigh:" + bid_1);

			}
		}

		// System.out.println("someProducerWantRent");
		// System.out.println("Leighsize=" + al.size() + " bid_2=" + bid_2);
		if (al.size() <= 2) {

			bid_2 = 0;

		}
		
		if(al.size() == 0) {
			//System.out.println("No farmers left to bid on land");
			bid_1 = 0; 
			bid_2 = 0;
			
		}

		double[] bids = new double[2];
		bids[0] = bid_1;
		bids[1] = bid_2;

		return bids;

	}

	public int needMarginalLand(int ProducerID) {
		Connection conn;
		int rent_marginalland = 0;
		if (Variables.get_marginalLandNeeds()[ProducerID - 1] == null) {
		try {
			conn = DriverManager.getConnection("jdbc:odbc:producerDB", "java", "1234");
			Statement stmt = conn.createStatement();
			ResultSet rs = stmt
					.executeQuery("SELECT rent_pasture_land FROM MIP WHERE "
							+ "farmerID=" + ProducerID + "and " + "year="
							+ Variables.getyear());

			while (rs.next()) {
				rent_marginalland = rs.getInt("rent_pasture_land");

			}

			rs.close();
			stmt.close();
			conn.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			System.out.println("Statement is wrong: " + e.getMessage());
			e.printStackTrace();
		}
		// System.out.println("Year: " + Variables.getyear() + "RENT CROP LAND:"
		// + rent + "Producer: " + ProducerID);
		Variables.get_marginalLandNeeds()[ProducerID - 1] = rent_marginalland;
		return rent_marginalland;
		} else {
			return Variables.get_marginalLandNeeds()[ProducerID - 1];
		}

	}

	public void select_lease_plot_Marginalland() {
		boolean flag_for_rent = false;
		ArrayList<SAMA> rent_marginalland_list = new ArrayList<SAMA>();
		for (int i = 0; i < Variables.getlandlist().size(); i++) {
			SAMA fdl4 = (SAMA) Variables.getlandlist().get(i);
			if(fdl4.getfor_rent() == true) {
			if ((fdl4.getpatchtype() == 3 || fdl4.getpatchtype() == 2)){
					
				flag_for_rent = true;
				rent_marginalland_list.add(fdl4);
			} 
		}
		}
		Collections.sort(rent_marginalland_list, mComparator);

	//	System.out.println("Marginal land rent list   " + rent_marginalland_list.size());
		
		if (rent_marginalland_list.size() > 0) {
//			SAMA fdl3 = (SAMA) rent_land_list
//					.get((int) (Math.random() * rent_land_list.size()));
			SAMA fdl3 = (SAMA) rent_marginalland_list.get(0);
			//System.out.println("Current Marginal land on market= "
					//+ fdl3.getID() + "flag_for_rent=" + flag_for_rent);
			if (flag_for_rent == true) {
				// Variables.setcurrent_plot_on_market(fdl3.getid_land_market());
				Variables.setcurrent_marginal_plot(fdl3);
				//System.out.println("Current Marginal land on market= "
					//	+ Variables.getcurrent_marginal_plot().getID());
				acres_of_current_plot_on_marginal_market = fdl3.getacres();
				for (int i = 0; i < Variables.getfarmerlist().size(); i++) {
					Producer prod = (Producer) Variables.getfarmerlist().get(i);
					prod.setcan_bid_on_plot(false);
					prod.screen_farmers_plot(fdl3);
				}
			}
		}
	}

	public void settotal_acres_for_rent_crop_market(int i) {
		acres_of_current_plot_on_market = i;
	}

	public int gettotal_acres_for_rent_crop_market() {
		return acres_of_current_plot_on_market;
	}

	public int gettotal_acres_for_rent_marginal_market() {
		return acres_of_current_plot_on_marginal_market;
	}

	public void settotal_acres_for_rent_marginal_market(int i) {
		acres_of_current_plot_on_marginal_market = i;
	}

	public int getnewmarginalland() {
		return newmarginalland;
	}

	public int getcrop_acres_for_rent() {
		return crop_acres_for_rent;
	}

	public void setcrop_acres_for_rent(int i) {
		crop_acres_for_rent = i;
	}

	public int gethay_acres_for_rent() {
		return hay_acres_for_rent;
	}

	public void sethay_acres_for_rent(int i) {
		hay_acres_for_rent = i;
	}

	public int getimproved_pasture_acres_for_rent() {
		return improved_pasture_acres_for_rent;
	}

	public void setimproved_pasture_acres_fore_rent(int i) {
		improved_pasture_acres_for_rent = i;
	}

	public int getnatural_pasture_acres_for_rent() {
		return natural_pasture_acres_for_rent;
	}

	public void setnatural_pasture_acres_for_rent(int i) {
		natural_pasture_acres_for_rent = i;
	}
	
	public boolean getstopmarginalleasemarket () {
		return stopmarginalleasemarket;
	}
	
	public void setstopmarginalleasemarket (boolean i) {
		stopmarginalleasemarket = i;
	}
	
	public boolean getstopcroplandleasemarket () {
		return stopcroplandleasemarket;
	}
	
	public void setstopcroplandleasemarket (boolean i) {
		stopcroplandleasemarket = i;
	}
	
	private void record_number_of_lands_cropland(){
		ArrayList<Producer> producers = Variables.getfarmerlist();
		for (Producer prod : producers) {
			prod.number_of_lands_cropland = (int) ((int) prod.gettotal_cropland_plots() + prod.gettotal_marginal_plots() - prod.init_number_of_lands_cropland);
			//System.out.println("HELLO total_cropland_plots" + prod.number_of_lands_cropland  + "farmer" + prod.getfarmer_name());
		}
	}
	
	private void record_number_of_lands_marginal() {
		ArrayList<Producer> producers = Variables.getfarmerlist();
		for (Producer prod : producers) {

			prod.number_of_lands_marginal = (int) prod.gettotal_marginal_plots() - prod.init_number_of_lands_marginal;
		//	System.out.println("AHHH total_marginalland_plots" + prod.number_of_lands_marginal + "farmer" + prod.getfarmer_name());
		}
	}

	public void set_id_land_market() {
		for (int i = 0; i < Variables.getlandlist().size(); i++) {
			SAMA fdl1 = (SAMA) Variables.getlandlist().get(i);
			fdl1.setid_land_market(i);
		}
	}
}
