package energycrops;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Iterator;
import java.io.File;
import repast.simphony.batch.BatchScenarioLoader;
import repast.simphony.dataLoader.ContextCreator;
import repast.simphony.engine.controller.Controller;
import repast.simphony.context.Context;
import repast.simphony.engine.environment.ControllerRegistry;
import repast.simphony.engine.environment.RunEnvironment;
import repast.simphony.engine.environment.RunEnvironmentBuilder;
import repast.simphony.engine.environment.RunState;
import repast.simphony.parameter.Parameters;
import repast.simphony.scenario.ModelInitializer;
import repast.simphony.util.ContextUtils;

public class Output extends ProducerAgent  {

	
	
	

	private int total_acres_for_rent_crop_market;
	private int total_acres_for_rent_marginal_market;
	private int crop_acres_for_rent;
	private int hay_acres_for_rent;
	private int improved_pasture_acres_for_rent;
	private int natural_pasture_acres_for_rent;
	private int croplandloopcounter;
	private int marginallandloopcounter;
	private int patch_purchased;

	private double type;
	private boolean type_1;
	private boolean type_2;
	private boolean type_3;
	private boolean stopcropmarketloop;
	private boolean stopmarginalmarketloop;

	private int updateneedcropland;
	private int updateneedmarginalland;
	private int updateneedbuy_cropland;
	private int updateneedbuy_marginalland;
	private int newbuycropland;
	private int newbuymarginalland;
	private int newmarginalland;
	private int newcropland;
	private int total_plots_before;
	private int total_plots_after;
	private int total_plots_bought;

	private LeaseMarket leaseMarket;
	private PurchaseMarket purchaseMarket;
	
	private boolean initialized;
	private MarginallandPurchaseComparator mComparator;
	private boolean continue_market;



	public Output(Variables VS) {
		super.Variables = VS;
		this.leaseMarket = new LeaseMarket(super.Variables);
		mComparator = new MarginallandPurchaseComparator();
		this.purchaseMarket = new PurchaseMarket();
	
		
	}

	@Override
	public void step4() {
		Parameters p = RunEnvironment.getInstance().getParameters();
		int initial_lease_rate = (Integer)p.getValue("initialleaserate");
		int initial_lease_rate_pasture = (Integer)p.getValue("initialleaseratepasture");
		if (Variables.getyear() == 0) {
			Variables.setcrop_exp_lease(initial_lease_rate);
			Variables.setmarginal_exp_lease(initial_lease_rate_pasture);
		}		
		
		
		if (Variables.getyear() > 0) {
			
			simulation_phase();
			
		}
		
		export_data();
		
		
		if(Variables.getrestartmodel() == false) {
	
		Variables.setyear(Variables.getyear() + 1);
		}
	}

	public void simulation_phase() {
		if (Variables.getfarmerlist().size() > 0) {
			producer_type();
			
			set_id_land_market();
			initial_screen_farmers();
			set_exp_lease_investor();
			land_markets();
			
			update_lease();
			

			for (int i = 0; i < Variables.getfarmerlist().size(); i++) {
				Producer fdf = (Producer) Variables.getfarmerlist().get(i);
				if(fdf.getchecklandmarketresults()==true) {
					if(fdf.getfarmer_name() == 350){
						//System.out.println("famer 350 check land market");
					}
					
				fdf.check_land_market_results();
				
				}
				else {
					if(fdf.gettacticalused() == true) {
						if(fdf.getfarmer_name() == 350){
						//	System.out.println("famer 350 tactical used");
						}
						fdf.existing_machinery_package(); //simulate depreciation
						fdf.cow_equip_depreciation();
						fdf.set_crop_mix();
						fdf.actual_crop_production();
						fdf.production();
						//fdf.crop_insurance();
						fdf.government_payments();
						fdf.fixed_costs();
						fdf.update_age();
						fdf.farm_accounting();
						fdf.exit_industry();
						fdf.update_farmers_land_info();
						
					} 
					else {
						if(fdf.getinfeasiblesolution()== false){

						fdf.postProcess();
					
						}else{
							if(fdf.getfarmer_name() == 350){
							//	System.out.println("famer 350 infeasible solution");
							}
							fdf.tactical_crops_conventional_farmer();
							fdf.tactical_crops_notill();
							fdf.existing_machinery_package(); //simulate depreciation
							fdf.set_crop_mix();
							fdf.set_livestock();
							fdf.set_livestock_equipment_expansion();
							fdf.cow_equip_depreciation();
							fdf.actual_crop_production();
							fdf.production();
							//fdf.crop_insurance();
							fdf.government_payments();
							fdf.fixed_costs();
							fdf.update_age();
							fdf.farm_accounting();
							fdf.exit_industry();
							fdf.update_farmers_land_info();
							
						}
						
					}
				}
				

			}
			
		}
		
	}
	
	
	
	

	
	private void record_init_number_of_lands_marginal() {
		ArrayList<Producer> producers = Variables.getfarmerlist();
		for (Producer prod : producers) {
			prod.init_number_of_lands_marginal = (int) prod.gettotal_marginal_plots();
		//	System.out.println("BLAH total_marginalland_plots" + prod.init_number_of_lands_marginal + "farmer" + prod.getfarmer_name());
		}
	}
	
	private void record_initial_number_of_lands_cropland() {
		ArrayList<Producer> producers = Variables.getfarmerlist();
		for (Producer prod : producers) {
			prod.init_number_of_lands_cropland = (int) ((int) prod.gettotal_cropland_plots() + prod.gettotal_marginal_plots());
			//System.out.println("BLAH total_cropland_plots" + prod.init_number_of_lands_cropland  + "farmer" + prod.getfarmer_name());
		}
	}
	
	
	

	public void producer_type() {
		for (int i = 0; i < Variables.getfarmerlist().size(); i++) {
			Producer prod = (Producer) Variables.getfarmerlist().get(i);

			type = prod.getfarmer_type();
			if (type == 1) {
				type_1 = true;
			}
			if (type == 2) {
				type_2 = true;
			}
			if (type == 3) {
				type_3 = true;

			}

		}
	}

	public void update_lease() {

		double avg_lease = 0;
		int avg_lease_number = 0;

		for (int j = 0; j < Variables.getlandlist().size(); j++) {
			SAMA sama = (SAMA) Variables.getlandlist().get(j);
			if (sama.getrenter() != 9999) {
				avg_lease_number = avg_lease_number + 1;
				avg_lease = avg_lease + sama.getlease_payment()
						* Variables.getall_patches_avg_prod()
						/ sama.getAvg_prod_patch();
			}
		}
		Variables.setavg_lease(avg_lease / avg_lease_number);
	}

	public void set_exp_lease_investor() {

		Parameters p = RunEnvironment.getInstance().getParameters();

		double adjustment_lease_prices = (Double) p
				.getValue("adjustment_lease_prices");

		double e_change_1 = (Variables.getexpected_price_list()[0] - Variables
				.getlast_year_exp_list()[0])
				/ Variables.getlast_year_exp_list()[0]; // Canola
		double e_change_2 = (Variables.getexpected_price_list()[1] - Variables
				.getlast_year_exp_list()[1])
				/ Variables.getlast_year_exp_list()[1]; // Wheat
		double e_change_3 = (Variables.getexpected_price_list()[2] - Variables
				.getlast_year_exp_list()[2])
				/ Variables.getlast_year_exp_list()[2]; // Barley
		double e_change_4 = (Variables.getexpected_price_list()[3] - Variables
				.getlast_year_exp_list()[3])
				/ Variables.getlast_year_exp_list()[3];  //calf
		double e_change_5 = (Variables.getexpected_price_list()[4] - Variables
				.getlast_year_exp_list()[4])
				/ Variables.getlast_year_exp_list()[4]; //hay

		double e_change_6 = (Variables.getexpected_price_list()[5] - Variables
				.getlast_year_exp_list()[5])
				/ Variables.getlast_year_exp_list()[5]; //flax

		double e_change_7 = (Variables.getexpected_price_list()[6] - Variables
				.getlast_year_exp_list()[6])
				/ Variables.getlast_year_exp_list()[6]; //peas

		double e_change_8 = (Variables.getexpected_price_list()[7] - Variables
				.getlast_year_exp_list()[7])
				/ Variables.getlast_year_exp_list()[7]; //lentils

		double exp_lease1 = (Variables.getcroplease_rate() + ((e_change_1
				* Variables.getcroplease_rate() * adjustment_lease_prices)
				+ (e_change_2 * Variables.getcroplease_rate() * adjustment_lease_prices)
				+ (e_change_3 * Variables.getcroplease_rate() * adjustment_lease_prices)
				+ (e_change_6 * Variables.getcroplease_rate() * adjustment_lease_prices)
				+ (e_change_7 * Variables.getcroplease_rate() * adjustment_lease_prices) + (e_change_8
				* Variables.getcroplease_rate() * adjustment_lease_prices))) * adjustment_lease_prices;
		Variables.setcrop_exp_lease(exp_lease1);
		//System.out.println("crop lease rate" + exp_lease1);
		double exp_lease2 = (Variables.getmarginallease_rate() + ((e_change_4 * Variables.getmarginallease_rate() * adjustment_lease_prices)
				+ (e_change_5 * Variables.getmarginallease_rate() * adjustment_lease_prices))) * adjustment_lease_prices;
		
		Variables.setmarginal_exp_lease(exp_lease2);
		//System.out.println("marginal lease rate" + exp_lease2);
	}

	public void set_id_land_market() {
		for (int i = 0; i < Variables.getlandlist().size(); i++) {
			SAMA fdl1 = (SAMA) Variables.getlandlist().get(i);
			fdl1.setid_land_market(i);
		}
	}

	public void land_markets() {
		ArrayList cropland_price_list = new ArrayList();
		ArrayList marginalland_price_list = new ArrayList();
		ArrayList cropland_lease_list = new ArrayList();
		ArrayList marginalland_lease_list = new ArrayList();
		Variables.setcropland_price_list(cropland_price_list);
		Variables.setmarginalland_price_list(marginalland_price_list);
		Variables.setcropland_lease_list(cropland_lease_list);
		Variables.setmarginalland_lease_list(marginalland_lease_list);
		Variables.setplots_sold_farmers(0);
		Variables.setplots_sold_investor(0);
		Variables.setcrop_plots_sold_farmers(0);
		Variables.setmarginal_plots_leased(0);
		Variables.setcrop_plots_leased(0);
		Variables.setmarginal_plots_sold_farmers(0);
		
		boolean for_sale = false;
		for (int i = 0; i < Variables.getlandlist().size(); i++) {
			SAMA sama = (SAMA) Variables.getlandlist().get(i);
			if (sama.getfor_sale() == true) {
				for_sale = true;
				}
		}
		
		if (for_sale == true) {
			
			this.continue_market = true;
			this.record_initial_number_of_lands_cropland();
			this.purchaseMarket.farmland_purchase_market_cropland();
			Variables.resetCropLandNeeds();
						
			//this.purchaseMarket.setContinueMarket(true);
			//this.record_init_number_of_lands_marginal();
			//this.purchaseMarket.farmland_purchase_market_marginalland();
			Variables.resetMarginalLandNeeds();
			
			
			
			
			
		} else {
			this.continue_market = false;
		}

		if (Variables.getmarginalland_price_list().size() != 0) {
			double marginalland_price = 0;
			for (int j = 0; j < Variables.getmarginalland_price_list().size(); j++) {
				MarginalLandPrice mlp = (MarginalLandPrice) Variables.getmarginalland_price_list()
						.get(j);
				marginalland_price = marginalland_price + mlp.getmarginallandPrice();
				//System.out.println("initial land price:" + land_price);
			}
			Variables.setmarginalland_price((int) (Math.round(marginalland_price
					/ Variables.getmarginalland_price_list().size())));
			//System.out.println("Marginal Land Price=" + Variables.getmarginalland_price());

		}
		
		if (Variables.getcropland_price_list().size() != 0) {
			double cropland_price = 0;
			for (int i = 0; i < Variables.getcropland_price_list().size(); i++) {
				CropLandPrice clp = (CropLandPrice) Variables.getcropland_price_list()
						.get(i);
				cropland_price = cropland_price + clp.getcroplandPrice();
				//System.out.println("initial land price:" + land_price);
			}
			Variables.setcropland_price((int) (Math.round(cropland_price
					/ Variables.getcropland_price_list().size())));
			//System.out.println("Crop Land Price=" + Variables.getcropland_price());

		}
		
		
		
		
		
		leaseMarket.setstopcroplandleasemarket(false);
		leaseMarket.continue_market = true;
		leaseMarket.cropland_lease_market();
		Variables.resetCropLandNeeds();
		
//		leaseMarket.setstopmarginalleasemarket(false);
//		leaseMarket.continue_market = true;
//		leaseMarket.marginal_land_lease_market(this.initialized);
		Variables.resetMarginalLandNeeds();

		if (Variables.getcropland_lease_list().size() != 0) {
			double lease_rate1 = 0;
			for (int i = 0; i < Variables.getcropland_lease_list().size(); i++) {
				CropLeasePrice lprice = (CropLeasePrice) Variables.getcropland_lease_list()
						.get(i);
				lease_rate1 = lease_rate1 + lprice.getcroplease_price();
			}
			Variables.setcroplease_rate((int) (Math.round(lease_rate1
					/ Variables.getcropland_lease_list().size())));
			//System.out.println("Crop Land Lease=" + Variables.getcroplease_rate());
		}

		if (Variables.getmarginalland_lease_list().size() != 0) {
			double lease_rate2 = 0;
			for (int j = 0; j < Variables.getmarginalland_lease_list().size(); j++) {
				MarginalLeasePrice mlprice = (MarginalLeasePrice) Variables.getmarginalland_lease_list().get(j);
				lease_rate2 = lease_rate2 + mlprice.getmarginallease_price();
			}
			Variables.setmarginallease_rate((int) (Math.round(lease_rate2
					/ Variables.getmarginalland_lease_list().size())));
			//System.out.println("Marginal Land Lease=" + Variables.getmarginallease_rate());
		}
		
		int unmanaged = 0;
		for (int i = 0; i < Variables.getlandlist().size(); i++) {
			SAMA sama = (SAMA) Variables.getlandlist().get(i);
			if (sama.getfor_sale() == true) {
				unmanaged = unmanaged + 1;
			}
		}
		Variables.setunmanaged(unmanaged);

		for (int i = 0; i < Variables.getlandlist().size(); i++) {
			SAMA sama = (SAMA) Variables.getlandlist().get(i);
			if (sama.getlease_term() == 0 && sama.getrenter() != 9999) {
				sama.setlast_adj_croplease_rate(Variables.getcroplease_rate());
				sama.setlast_adj_marginallease_rate(Variables.getmarginallease_rate());
			}
		}
		adjust_croplease();
		adjust_marginallease();
	}

	public void initial_screen_farmers() {
		for (int i = 0; i < Variables.getfarmerlist().size(); i++) {
			Producer prod = (Producer) Variables.getfarmerlist().get(i);
			prod.initial_screen_farmers();
			if(prod.getcan_bid()==true){
			prod.setcan_bid_on_cropland(true);
			prod.setcan_bid_on_marginalland(true);
			} else {
			prod.setcan_bid_on_cropland(false);
			prod.setcan_bid_on_marginalland(false);
		}
	}

	}





	private ArrayList get_land_for_sale() {
		ArrayList lands = new ArrayList();
		for (int i = 0; i < Variables.getlandlist().size(); i++) {
			SAMA sama = (SAMA) Variables.getlandlist().get(i);
			if (sama.getfor_sale() == true)
				lands.add(sama);
		}
		return lands;
	}

	private String convertIntArrayToString(ArrayList bidL) {
		// TODO Auto-generated method stub
		return null;
	}

	public void initial_screen_farmers_lease() {
		for (int i = 0; i < Variables.getfarmerlist().size(); i++) {
			Producer prod = (Producer) Variables.getfarmerlist().get(i);
			SAMA sama = (SAMA) Variables.getlandlist().get(
					Variables.getcurrent_plot_on_market() - 1);
			if(prod.getcan_bid()==true){
				prod.setcan_bid_on_cropland(true);
				prod.setcan_bid_on_marginalland(true);
				}
			else {
				prod.setcan_bid_on_cropland(false);
				prod.setcan_bid_on_marginalland(false);
			}
		}
	}


	public void commit_lease_cropland() {

		for (int i = 0; i < Variables.getfarmerlist().size(); i++) {
			Producer prod = (Producer) Variables.getfarmerlist().get(i);
			if (prod.getfarmer_type() == 1 || prod.getfarmer_type() == 2) {
				if (prod.getshould_bid_rent()) {
					BidListCropland bidl = new BidListCropland();

					bidl.setcurrent_bid(prod.getcurrent_bid());
					bidl.setproducer_id(prod.getfarmer_name());
					ArrayList al1 = Variables.getbid_list();
					al1.add(bidl);
					Variables.setbid_list(al1);
				}
			}
		}
		double adjusted_lease_rate = 0;
		double lease_value = 0;
		int acres_leased = 0;
		double bid_1 = 0;
		double bid_2 = 0;

		ArrayList al = Variables.getbid_list();
		if (al != null) {
			if (al.size() > 1) {
				for (int i = 0; i < al.size(); i++) {
					BidListCropland bidlist = (BidListCropland) al.get(i);
					if (bidlist.getcurrent_bid() > bid_1) {
						bid_1 = bidlist.getcurrent_bid();
						Variables.setleaser(bidlist.getproducer_id());
					} else {
						if (bidlist.getcurrent_bid() > bid_2) {
							bid_2 = bidlist.getcurrent_bid();
						}
					}
				}
			} else {
				if (al.size() == 1) {
					BidListCropland bidlist = (BidListCropland) al.get(0);
					bid_1 = bidlist.getcurrent_bid();
					Variables.setleaser(bidlist.getproducer_id());
				}
			}

			if (al.size() <= 2) {
				bid_2 = 0;
			}

			SAMA sama = (SAMA) Variables.getlandlist().get(
					Variables.getcurrent_plot_on_market());
			double plot_q = sama.getAvg_prod_patch();
			double market_rate = plot_q / Variables.getmean_patch_quality()
					* Variables.getcroplease_rate();

			if (bid_1 > 0) {
				if (bid_2 > 0) {
					lease_value = (bid_1 + bid_2) / 2;

				} else {
					lease_value = bid_1;
				}
				market_rate = sama.getAvg_prod_patch()
						/ Variables.getmean_patch_quality()
						* Variables.getcroplease_rate();

				sama.setcurrent_producer(Variables.getleaser());
				System.out.println("GETLEASER=" + Variables.getleaser());
				sama.setrenter(Variables.getleaser());
				sama.setfor_rent(false);
				Producer prod = (Producer) Variables.getfarmerlist().get(
						Variables.getleaser());
				prod.add_land(sama);
				prod.number_of_lands_cropland = prod.getmylandList().size()
						- prod.init_number_of_lands_cropland;
				acres_leased = sama.getacres();
				System.out.println("croplandlease:" + acres_leased);
				sama.setdistance_to_farm((int) (Math.sqrt(Math.pow(prod.getX()
						- sama.getX(), 2)
						+ Math.pow(prod.getY() - sama.getY(), 2))));
				sama.setcame_from_bid(false);

				sama.setlease_payment(lease_value);
				// System.out.println("leasevalue too high 1:" + lease_value);
				sama.setlease_term(0);

				adjusted_lease_rate = (int) (Math.round(lease_value
						* Variables.getmean_patch_quality()
						/ sama.getAvg_prod_patch()));

				prod.update_acres();
				prod.buy_machine();

				prod.set_expected_income();

				prod.balance_sheet();

				CropLeasePrice lp = new CropLeasePrice();
				lp.setcroplease_price((int) adjusted_lease_rate);
				lp.setlease_farmer(prod.getID());
				ArrayList lease_list_array = Variables.getcropland_lease_list();
				lease_list_array.add(lp);
				Variables.setcropland_lease_list(lease_list_array);
			} else {

				sama.setfor_rent(false);
				sama.setfor_sale(true);
				sama.setbidders(0);
				for (int i = 0; i < Variables.getfarmerlist().size(); i++) {
					Producer prod = (Producer) Variables.getfarmerlist().get(i);
					if (prod.getcan_bid_on_plot() == true) {
						sama.setbidders(sama.getbidders() + 1);
					}
				}
			}
		}
	}

	public void sell_lease_marginalland() {

		for (int i = 0; i < Variables.getfarmerlist().size(); i++) {
			Producer prod = (Producer) Variables.getfarmerlist().get(i);
			if (prod.getshould_bid_rent()) {
				BidListMarginalland bidl = new BidListMarginalland();

				bidl.setcurrent_bid_marginalland(prod
						.getcurrent_bid_marginalland());
				bidl.setproducer_id(prod.getID());
				ArrayList al1 = Variables.getbid_list();
				al1.add(bidl);
				Variables.setbid_list(al1);
			}
		}

		double adjusted_lease_rate = 0;
		double lease_value = 0;
		int acres_leased = 0;
		double bid_1 = 0;
		double bid_2 = 0;

		ArrayList al = Variables.getbid_list();
		if (al != null) {
			if (al.size() > 1) {
				for (int i = 0; i < al.size(); i++) {
					BidListMarginalland bidlist = (BidListMarginalland) al
							.get(i);
					if (bidlist.getcurrent_bid_marginalland() > bid_1) {
						bid_1 = bidlist.getcurrent_bid_marginalland();
						Variables.setleaser(bidlist.getproducer_id());
					} else {
						if (bidlist.getcurrent_bid_marginalland() > bid_2) {
							bid_2 = bidlist.getcurrent_bid_marginalland();
						}
					}
				}
			} else {
				if (al.size() == 1) {
					BidListMarginalland bidlist = (BidListMarginalland) al
							.get(0);
					bid_1 = bidlist.getcurrent_bid_marginalland();
					Variables.setleaser(bidlist.getproducer_id());
				}
			}

			if (al.size() <= 2) {
				bid_2 = 0;
			}

			SAMA sama = (SAMA) Variables.getlandlist().get(
					Variables.getcurrent_plot_on_market());
			double plot_q = sama.getAvg_prod_patch();
			double market_rate = plot_q / Variables.getmean_patch_quality()
					* Variables.getmarginallease_rate();

			if (bid_1 > 0) {
				if (bid_2 > 0) {
					lease_value = (bid_1 + bid_2) / 2;

				} else {
					lease_value = bid_1;
				}
				market_rate = sama.getAvg_prod_patch()
						/ Variables.getmean_patch_quality()
						* Variables.getmarginallease_rate();

				// System.out.println("GETLEASER="+Variables.getleaser());
				sama.setcurrent_producer(Variables.getleaser());
				sama.setrenter(Variables.getleaser());
				sama.setfor_rent(false);
				Producer prod = (Producer) Variables.getfarmerlist().get(
						Variables.getleaser());
				prod.add_land(sama);
				acres_leased = sama.getacres();
				// System.out.println("marginallandlease:" + acres_leased);
				sama.setdistance_to_farm((int) (Math.sqrt(Math.pow(prod.getX()
						- sama.getX(), 2)
						+ Math.pow(prod.getY() - sama.getY(), 2))));
				sama.setcame_from_bid(false);

				sama.setlease_payment(lease_value);
				// System.out.println("lease value too high 2:" + lease_value);
				sama.setlease_term(0);

				adjusted_lease_rate = (int) (Math.round(lease_value
						* Variables.getmean_patch_quality()
						/ sama.getAvg_prod_patch()));

				prod.update_acres();
				prod.buy_machine();

				prod.set_expected_income();

				prod.balance_sheet();

				MarginalLeasePrice lp = new MarginalLeasePrice();
				lp.setmarginallease_price((int) adjusted_lease_rate);
				lp.setlease_farmer(prod.getID());
				ArrayList lease_list_array = Variables.getmarginalland_lease_list();
				lease_list_array.add(lp);
				Variables.setmarginalland_lease_list(lease_list_array);
			} else {

				sama.setfor_rent(false);
				sama.setfor_sale(true);
				sama.setbidders(0);
				for (int i = 0; i < Variables.getfarmerlist().size(); i++) {
					Producer prod = (Producer) Variables.getfarmerlist().get(i);
					if (prod.getcan_bid_on_plot() == true) {
						sama.setbidders(sama.getbidders() + 1);
					}
				}
			}
		}
	}

	public void adjust_croplease() {
		double percent_change;

		for (int i = 0; i < Variables.getlandlist().size(); i++) {
			SAMA fdl4 = (SAMA) Variables.getlandlist().get(i);
			if (fdl4.getrenter() != 9999 && fdl4.getlease_term() > 0) {
				if(fdl4.getlast_adj_croplease_rate() == 0){
					fdl4.setlast_adj_croplease_rate(Variables.getcroplease_rate());
				}
				percent_change = Variables.getcroplease_rate()
						/ fdl4.getlast_adj_croplease_rate();
				if (percent_change < 0.8) {
					fdl4.setlease_payment(fdl4.getlease_payment()
							* percent_change);
					fdl4.setlast_adj_croplease_rate(Variables.getcroplease_rate());
				}
				if (percent_change > 1.2) {
					fdl4.setlease_payment(fdl4.getlease_payment()
							* percent_change);
					fdl4.setlast_adj_croplease_rate(Variables.getcroplease_rate());
				}
			
				
			}
		}
	}
	
	public void adjust_marginallease() {
		double percent_change;

		for (int i = 0; i < Variables.getlandlist().size(); i++) {
			SAMA fdl4 = (SAMA) Variables.getlandlist().get(i);
			if (fdl4.getrenter() != 9999 && fdl4.getlease_term() > 0) {
				if(fdl4.getlast_adj_marginallease_rate() == 0){
					fdl4.setlast_adj_marginallease_rate(Variables.getmarginallease_rate());
				}
				percent_change = Variables.getmarginallease_rate()
						/ fdl4.getlast_adj_marginallease_rate();
				if (percent_change < 0.8) {
					fdl4.setlease_payment_pasture(fdl4.getlease_payment_pasture()
							* percent_change);
					fdl4.setlast_adj_marginallease_rate(Variables.getmarginallease_rate());
				}
				if (percent_change > 1.2) {
					fdl4.setlease_payment_pasture(fdl4.getlease_payment_pasture()
							* percent_change);
					fdl4.setlast_adj_marginallease_rate(Variables.getmarginallease_rate());
				}
			}
		}
	}

	// ----------------------------------------------------------------------------------------------------//
	// export data //
	// ----------------------------------------------------------------------------------------------------//

	// ******************************* export_data *************************
	// 
	// The "export data" part will export four output file: GlobalOut,
	// farmerOut, ExitOut, TransferOut.
	// GlobalOut reports global parameters of the model, for example land price,
	// lease rate, etc.
	// farmerOut reports information of all the existed farmers in each run.
	// ExitOut reports the information of all the exited farmers and the reason
	// of their exit.
	// TransferOut report the information of all next generation farmers.
	//
	// Only GlobalOut is shown in AMModel, other three files are shown in
	// ABMFarmer.
	//
	// The function is cited by buildSchedule
	// The function cites: report in ABMFarmer

	public void export_data() {

		for (int i = 0; i < Variables.getfarmerlist().size(); i++) {
			Producer fdf = (Producer) Variables.getfarmerlist().get(i);
			
			if(fdf.getfarmer_name()== 350){
				//System.out.println("farmer inside export" + fdf.getfarmer_name() +"year" + Variables.getyear());	
				
		}
			fdf.update_farmers_land_info();
			fdf.report();
		}

		try {
			Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
		} catch (ClassNotFoundException ce) {
			System.out.println("SQLExceptiong:" + ce.getMessage());
		}
		try {
			Connection conn = DriverManager.getConnection(
					"jdbc:odbc:producerDB", "java", "1234");
			Statement stmt = conn.createStatement();
			stmt.executeUpdate("insert into GlobalOut values ('"
					+ Variables.getglobalOutID() + "','"
					+ Variables.getscenario() + "', '"
					+ Variables.getrun_number() + "', '" + Variables.getyear()
					+ "', '" + Variables.getcropland_price() + "', '"
					+ Variables.getmarginalland_price() + "', '"
					+ Variables.getcroplease_rate() + "', '"
					+ Variables.getmarginallease_rate() + "', '"
					+ Variables.getfarmerlist().size() + "', '"
					+ Variables.getbankrupt() + "', '"
					+ Variables.getcashflow() + "', '" + Variables.getoldage()
					+ "', '" + Variables.gettransfers() + "', '"
					+ Variables.getunmanaged() + "', '"
					+ Variables.getplots_sold_investor() + "', '"
					+ Variables.getplots_sold_farmers() + "', '"
					+ Variables.getcrop_plots_sold_farmers() + "', '"
					+ Variables.getmarginal_plots_sold_farmers() + "')");
			stmt.close();
			conn.close();
		} catch (SQLException ce) {
			System.out.println("SQLException:" + ce.getMessage());
		}
		Variables.setglobalOutID(Variables.getglobalOutID() + 1);

	}

	public int needMarginalLand(int ProducerID) {
		Connection conn;
		int rent_marginalland = 0;
		try {
			conn = DriverManager.getConnection("jdbc:odbc:producerDB", "java",
					"1234");
			Statement stmt = conn.createStatement();
			ResultSet rs = stmt
					.executeQuery("SELECT rent_pasture_land FROM MIP WHERE "
							+ "farmerID=" + ProducerID + "and " + "year="
							+ Variables.getyear());

			while (rs.next()) {
				rent_marginalland = rs.getInt("rent_pasture_land");

			}

			rs.close();
			stmt.close();
			conn.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			System.out.println("Statement is wrong: " + e.getMessage());
			e.printStackTrace();
		}
		// System.out.println("Year: " + Variables.getyear() + "RENT CROP LAND:"
		// + rent + "Producer: " + ProducerID);
		return rent_marginalland;

	}

	public int getcrop_acres_for_rent() {
		return crop_acres_for_rent;
	}

	public void setcrop_acres_for_rent(int i) {
		crop_acres_for_rent = i;
	}

	public int gethay_acres_for_rent() {
		return hay_acres_for_rent;
	}

	public void sethay_acres_for_rent(int i) {
		hay_acres_for_rent = i;
	}

	public int getimproved_pasture_acres_for_rent() {
		return improved_pasture_acres_for_rent;
	}

	public void setimproved_pasture_acres_fore_rent(int i) {
		improved_pasture_acres_for_rent = i;
	}

	public int getnatural_pasture_acres_for_rent() {
		return natural_pasture_acres_for_rent;
	}

	public void setnatural_pasture_acres_for_rent(int i) {
		natural_pasture_acres_for_rent = i;
	}

	public boolean gettype_1() {
		return type_1;
	}

	public boolean gettype_2() {
		return type_2;
	}

	public boolean gettype_3() {
		return type_3;
	}

	public double gettype() {
		return type;
	}

	public void settype(double i) {
		type = i;
	}

	public int getupdateneedcropland() {
		return updateneedcropland;
	}

	public int getnewcropland() {
		return newcropland;
	}

	public void setupdateneedcropland(int i) {
		updateneedcropland = i;
	}

	public void setnewcropland(int i) {
		newcropland = i;
	}

	public int getupdateneedmarginalland() {
		return updateneedmarginalland;
	}

	public void setupdateneedmarginalland(int ProducerID) {
		updateneedmarginalland = ProducerID;
	}

	public void setnewmarginalland(int i) {
		newmarginalland = i;
	}

	public int getcroplandloopcounter() {
		return croplandloopcounter;
	}

	public void setcroplandloopcounter(int i) {
		croplandloopcounter = i;
	}

	public int getmarginallandloopcounter() {
		return marginallandloopcounter;
	}

	public void setmarginallandloopcounter(int i) {
		marginallandloopcounter = i;
	}

	public boolean getstopmarginalmarketloop() {
		return stopmarginalmarketloop;
	}

	public void setstopmarginalmarketloop(boolean i) {
		stopmarginalmarketloop = i;
	}

	public int getupdateneedbuy_cropland(int ProduerID) {
		return updateneedbuy_cropland;
	}

	public void setupdateneedbuy_cropland(int ProducerID) {
		updateneedbuy_cropland = ProducerID;
	}

	public int getupdateneedbuy_marginalland(int ProducerID) {
		return updateneedbuy_marginalland;
	}

	public void setupdateneedbuy_marginalland(int ProduerID) {
		updateneedbuy_marginalland = ProduerID;
	}

	public int getnewbuycropland(int ProducerID) {
		return newbuycropland;
	}

	public void setnewbuycropland(int ProducerID) {
		newbuycropland = ProducerID;
	}

	public int getnewbuymarginalland(int ProducerID) {
		return newbuymarginalland;
	}

	public void setnewbuymarginalland(int ProducerID) {
		newbuymarginalland = ProducerID;
	}

	public int gettotal_plots_before() {
		return total_plots_before;
	}

	public void settotal_plots_before(int i) {
		total_plots_before = i;
	}

	public int gettotal_plots_after() {
		return total_plots_after;
	}

	public void settotal_plots_after(int i) {
		total_plots_after = i;
	}

	public int gettotal_plots_bought() {
		return total_plots_bought;
	}
}