package energycrops;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Collections;

import repast.simphony.engine.environment.RunEnvironment;
import repast.simphony.parameter.Parameters;

public class PurchaseMarket extends ProducerAgent {
	private MarginallandPurchaseComparator mComparator;
	private CroplandPurchaseComparator sComparator;
	private boolean continue_market;

	private boolean stopcropmarketloop;
	private int patch_purchased;
	private int total_plots_bought_cropland;
	private int total_plots_after_cropland;

	public PurchaseMarket() {
		mComparator = new MarginallandPurchaseComparator();
		sComparator = new CroplandPurchaseComparator();
	}

	/*
	 * tell the purchase market to continue or not based on the passed-in
	 * parameter
	 */
	public void setContinueMarket(boolean continue_market) {
		this.continue_market = continue_market;
	}

	public void farmland_purchase_market_marginalland() {

		select_plot_buy_marginalland();
		// System.out.println("AFTER SELECT PLOT MARGINAL");
		create_bid_Marginalland();

		if (Variables.get_buy_bid_list_marginalland() != null
				&& Variables.get_buy_bid_list_marginalland().size() != 0) {
			// System.out.println("Sell Marginal Lands");
			sell_land_marginalland();
		} else {
			SAMA sama = (SAMA) Variables.getlandlist().get(
					Variables.getcurrent_plot_on_market());
			sama.setfor_sale(false);
			sama.setfor_rent(true);

			// System.out.println("equalszero:");
		}
		boolean for_sale = false;

		ArrayList<SAMA> s = Variables.getlandlist();
		for (SAMA sama : s) {
			if (sama.getfor_sale() == true
					&& (sama.getpatchtype() == 2 || sama.getpatchtype() == 3)) {
				for_sale = true;
				break;
			}
		}

		if (this.continue_market && for_sale == true) {
			farmland_purchase_market_marginalland();
		}
	}

	public void select_plot_buy_marginalland() {
		// System.out.println("select plot marginal land");
		boolean for_sale = false;
		ArrayList<SAMA> land_for_sale = new ArrayList<SAMA>();
		for (int i = 0; i < Variables.getlandlist().size(); i++) {
			SAMA sama = (SAMA) Variables.getlandlist().get(i);
			if (sama.getfor_sale() == true) {
				if (sama.getpatchtype() == 2 || sama.getpatchtype() == 3) {
					// System.out.println("SELECT PLOT 2 AND 3");
					for_sale = true;
					land_for_sale.add(sama);
				}

			}
		}

		Collections.sort(land_for_sale, mComparator);

		// System.out.println("margianl land for sale:" + land_for_sale.size());

		if (for_sale == true) {
			// int N_patch_ID = (int) (Math.random() * land_for_sale.size());
			// SAMA samasellmarginalland = (SAMA) land_for_sale.get(N_patch_ID);
			SAMA samasellmarginalland = land_for_sale.get(0);
			Variables.setcurrent_plot_on_market(samasellmarginalland
					.getid_land_market());
			ArrayList<Producer> ps = Variables.getfarmerlist();
			for (Producer prod : ps) {
				prod.setcan_bid_on_plot(false);
				if (prod.getcan_bid() == true) {
					prod.plot_screening(samasellmarginalland);
				}
			}
		}
	}

	public void create_bid_Marginalland() {

		double total_plots_bought = 0;
		double total_plots_after = 0;
		Parameters p = RunEnvironment.getInstance().getParameters();

		double increase_no_till = (Double) p.getValue("increaseNoTill");

		ArrayList new_bid_list = new ArrayList();
		Variables.setbid_list(new_bid_list);

		for (int i = 0; i < Variables.getfarmerlist().size(); i++) {

			Producer prod = (Producer) Variables.getfarmerlist().get(i);
			prod.setcurrent_bid_marginalland(0);

		}

		Variables.set_buy_bid_list_marginalland(null); // Empty the bid list of
		// marginal lands before
		// producers bidding on
		// current plot
		// System.out.println("CALLED_MARGINALLAND_CREATE_BID_HERE");
		for (int i = 0; i < Variables.getfarmerlist().size(); i++) {
			Producer prod = (Producer) Variables.getfarmerlist().get(i);
			prod.update_acres();
			prod.marginal_and_cropland_plots();
			total_plots_after = prod.gettotal_marginal_plots();
			total_plots_bought = total_plots_after
					- prod.init_number_of_lands_marginal;
			// System.out.println("MarginalProducer="+prod.getfarmer_name()+" init="+prod.init_number_of_lands
			// +" plots_bought="+total_plots_bought+" needMarginal="+needMarginalLand(prod.getfarmer_name()));

			int needs_marginal_land = needMarginalLand(prod.getfarmer_name()) + needCropLand(prod.getfarmer_name());
			
			if (needs_marginal_land < Integer.MAX_VALUE
					&& needs_marginal_land
							- (total_plots_bought + total_plots_bought_cropland) > 0) {

				prod.setcan_bid_on_marginalland(true);

				if (prod.getcan_bid_on_plot() == true) {
					SAMA sama = (SAMA) Variables.getlandlist().get(
							Variables.getcurrent_plot_on_market());
					prod.create_bid_marginalland(sama);
					// System.out.print("MARGINAL LAND BID NEEDED");

				}
			} else {
				prod.setcan_bid_on_marginalland(false);
			}
		}
		for (int i = 0; i < Variables.getfarmerlist().size(); i++) {
			Producer prod = (Producer) Variables.getfarmerlist().get(i);
			ArrayList alfl = prod.getmylandList();

			if (prod.getcan_bid_on_plot() == true) {
				if (alfl.size() != 0) {
					int patch_id = (int) (Math.random() * alfl.size());
					SAMA sama = (SAMA) alfl.get(patch_id);

				}

			}
		}
		int farmers_bidding = 0;
		for (int i = 0; i < Variables.getfarmerlist().size(); i++) {
			Producer prod = (Producer) Variables.getfarmerlist().get(i);
			if (prod.getcurrent_bid() > 0) {
				farmers_bidding = farmers_bidding + 1;
			}
		}
		Variables.setfarmers_bidding(farmers_bidding);
	}

	public void sell_land_marginalland() {

		Parameters p = RunEnvironment.getInstance().getParameters();

		double down_payment = (Double) p.getValue("downPayment");
		double must_sell_min = (Double) p.getValue("must_sell_min");
		double must_sell_prob = (Double) p.getValue("must_sell_prob");
		double lease_man_fee_percent = (Double) p
				.getValue("lease_man_fee_percent");
		double land_owner_risk = (Double) p.getValue("land_owner_risk");
		double prob_investor_bid = (Double) p.getValue("prob_investor_bid");
		double market_value;
		double mean_bid = 0;
		double adjusted_price = 0;
		double adjusted_lease = 0;
		int acres_purchased_marginalland = 0;
		double bid_1_price;
		double bid_2_price;
		SAMA fdl2 = (SAMA) Variables.getlandlist().get(
				Variables.getcurrent_plot_on_market());
		market_value = fdl2.getAvg_prod_patch()
				/ Variables.getmean_patch_quality()
				* Variables.getmarginalland_price();
		// System.out.println("MEAN PATCH Q" +
		// Variables.getmean_patch_quality());
		// System.out.println("AVG Prod" + fdl2.getAvg_prod_patch());
		adjusted_lease = fdl2.getAvg_prod_patch()
				/ Variables.getmean_patch_quality()
				* Variables.getmarginal_exp_lease();
		// System.out.println("Patch quality :" +
		// Variables.getmean_patch_quality() + "lease:" +
		// Variables.getexp_lease());
		double min_accept = land_owner_risk * adjusted_lease
				* (1 - lease_man_fee_percent) / 0.03;
		// System.out.println("min accpet "+ min_accept);
		// System.out.println("owner_risk="+land_owner_risk+"adjusted_lease="+adjusted_lease+" 1 - lease_man_fee_percent="+(1
		// - lease_man_fee_percent));

		if (Math.random() <= must_sell_prob) {
			fdl2.setneed_sell(true);
		}

		double investor_bid = 0;
		if (fdl2.getneed_sell() == true || Variables.getunmanaged() > 60) {
			min_accept = must_sell_min * min_accept;
			// System.out.println("MIN ACCEPT "+ min_accept);
		}
		if (Math.random() <= prob_investor_bid) {
			investor_bid = min_accept;
			// System.out.println("Investor Bid is true " + investor_bid);
		}

		ArrayList bidl = Variables.get_buy_bid_list_marginalland();

		double bid_1 = 0;
		double bid_2 = 0;
		BidListMarginalland bidlis = (BidListMarginalland) bidl.get(0);
		// System.out.println("bidlis:" + bidlis);
		bid_1 = bidlis.getcurrent_bid_marginalland();
		// System.out.println("bidl:" + bidl);
		int farmer_buyer = bidlis.getproducer_id();

		if (bidl.size() > 0) {
			// System.out.println("bdil.size:" + bidl.size());
			for (int i = 1; i < bidl.size(); i++) {
				BidListMarginalland bidlist = (BidListMarginalland) bidl.get(i);
				if (bidlist.getcurrent_bid_marginalland() > bid_1) {
					bid_1 = bidlist.getcurrent_bid_marginalland();
					farmer_buyer = bidlist.getproducer_id();
					// System.out.println("FARMER_BUYER="+farmer_buyer);
				} else {
					if (bidlist.getcurrent_bid_marginalland() > bid_2) {
						bid_2 = bidlist.getcurrent_bid_marginalland();
						// System.out.println("BID2="+bid_2);
					}
				}
			}
		}

		if (bidl.size() <= 2) {
			bid_2 = 0;
			// System.out.println("BIDL.SIZEISLESSTHANZERO:");
		}

		double adjusted_bid = 0;
		Producer prod = null;

		for (Producer p1 : (ArrayList<Producer>) Variables.getfarmerlist()) {
			if (p1.getfarmer_name() == farmer_buyer) {
				prod = p1;
				break;
			}
		}
		// prod = (Producer) Variables.getfarmerlist().get(farmer_buyer);

		if (bid_2 < investor_bid) {
			bid_2 = (int) investor_bid;
		}
		if (bid_2 > 0) {
			adjusted_bid = (bid_2 + prod.getcurrent_bid_marginalland()) / 2;
			// System.out.println("IF ADJUSTED BID" + adjusted_bid);
		} else {
			adjusted_bid = prod.getcurrent_bid_marginalland();
			// System.out.println("ELSE Adjusted bid" + adjusted_bid);
		}

		if (adjusted_bid > prod.getbid_finances()) {
			adjusted_bid = prod.getbid_finances();
			// System.out.println("Adjusted bid (bid finances)" + adjusted_bid);
		}

		// System.out.println("Farmer_Bidder="+prod.getfarmer_name()+"current_bid="+prod.getcurrent_bid_marginalland()+"Marginal land investor_bid:"
		// + investor_bid + "min_accept:"
		// + min_accept + "adjust_bid:" + adjusted_bid);
		if (adjusted_bid > min_accept && adjusted_bid > investor_bid) {
			Variables
					.setplots_sold_farmers(Variables.getplots_sold_farmers() + 1);
			double price_paid = (adjusted_bid + min_accept) / 2;
			// System.out.println("priceperacre:" + price_paid);
			SAMA sama = (SAMA) Variables.getlandlist().get(
					Variables.getcurrent_plot_on_market());
			sama.setcurrent_producer(prod.getID());
			sama.setOwner(prod.getfarmer_name());
			// System.out.println("Marginalland Buyer=" + prod.getfarmer_name()
			// + "Sama=" + sama.getID());
			prod.add_land(sama);
			prod.update_acres();
			prod.marginal_and_cropland_plots();
			prod.number_of_lands_marginal = (int) prod
					.gettotal_marginal_plots()
					- prod.init_number_of_lands_marginal;
			acres_purchased_marginalland = sama.getacres();

			// System.out.println("marginal_acres_purchased:" +
			// acres_purchased_marginalland);
			sama.setfor_sale(false);
			sama.setlease_term(0);
			sama.setlease_payment(0);
			sama.setdistance_to_farm((int) (Math.sqrt(Math.pow(sama.getX()
					- prod.getX(), 2)
					+ Math.pow(sama.getY() - prod.getY(), 2))));

			sama.setcame_from_bid(false);
			prod.setcan_bid(false);
			prod.setcan_bid_on_plot(false);

			Variables.setbuyer(prod.getID());

			double total_price = price_paid * acres_purchased_marginalland;
			// System.out.println("buylandprice:" + total_price);
			prod.setcash((int) (Math.round(prod.getcash() - down_payment
					* total_price)));
			double payment = Math.round((1 - down_payment) * total_price
					* Variables.getloan_factor_payment_20());
			debtList debtl = new debtList();
			debtl.setyears_remaining(20);
			debtl.setannual_payment((int) payment);
			debtl.setdebt((int) (Math.round((1 - down_payment) * total_price)));
			ArrayList debt_array_list = prod.getdebt_list();
			debt_array_list.add(debtl);
			prod.setdebt_list(debt_array_list);

			adjusted_price = price_paid * Variables.getmean_patch_quality()
					/ fdl2.getAvg_prod_patch();
			// System.out.println("price_paid="+price_paid);

			prod.balance_sheet();
			// prod.update_debt();

			MarginalLandPrice mlp = new MarginalLandPrice();
			mlp.setmarginallandPrice(price_paid);

			ArrayList mal = Variables.getmarginalland_price_list();
			mal.add(mlp);
			Variables.setmarginalland_price_list(mal);

		} else {
			if (investor_bid > 0) {
				double price = (investor_bid + min_accept) / 2;

				adjusted_price = price * Variables.getmean_patch_quality()
						/ fdl2.getAvg_prod_patch();

				MarginalLandPrice lp1 = new MarginalLandPrice();
				lp1.setmarginallandPrice(price);

				ArrayList a = Variables.getmarginalland_price_list();

				a.add(lp1);

				Variables.setmarginalland_price_list(a);

				Variables.setplots_sold_investor(Variables
						.getplots_sold_investor() + 1);

			}
			fdl2.setfor_sale(false);
			fdl2.setfor_rent(true);
		}
	}

	public int needMarginalLand(int ProducerID) {
		Connection conn;
		int rent_marginalland = 0;

		if (Variables.get_marginalLandNeeds()[ProducerID - 1] == null) {
			try {
				conn = DriverManager.getConnection("jdbc:odbc:producerDB",
						"java", "1234");
				Statement stmt = conn.createStatement();
				ResultSet rs = stmt
						.executeQuery("SELECT rent_pasture_land FROM MIP WHERE "
								+ "farmerID="
								+ ProducerID
								+ "and "
								+ "year="
								+ Variables.getyear());

				while (rs.next()) {
					rent_marginalland = rs.getInt("rent_pasture_land");

				}

				rs.close();
				stmt.close();
				conn.close();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				System.out.println("Statement is wrong: " + e.getMessage());
				e.printStackTrace();
			}
			// System.out.println("Year: " + Variables.getyear() +
			// "RENT CROP LAND:"
			// + rent + "Producer: " + ProducerID);
			Variables.get_marginalLandNeeds()[ProducerID - 1] = rent_marginalland;
			return rent_marginalland;
		} else {
			return Variables.get_marginalLandNeeds()[ProducerID - 1];
		}
	}

	public void farmland_purchase_market_cropland() {
		if (getstopcropmarketloop() == false) {

			select_plot_buy_cropland();
			create_bid_cropland();

			if (Variables.get_buy_bid_list_cropland() != null
					&& Variables.get_buy_bid_list_cropland().size() != 0) {
				// System.out.println("farmland_purchase_market_cropland second if clause in Output.java");

				sell_land_cropland();

			}

			else {
				SAMA sama = (SAMA) Variables.getlandlist().get(
						Variables.getcurrent_plot_on_market());
				sama.setfor_sale(false);
				sama.setfor_rent(true);
			}
			boolean for_sale = false;
			for (int i = 0; i < Variables.getlandlist().size(); i++) {
				SAMA sama = (SAMA) Variables.getlandlist().get(i);
				if (sama.getfor_sale() == true) {
					for_sale = true;
				}
			}
			if (for_sale == true) {
				farmland_purchase_market_cropland();
			}
		}
	}

	public void select_plot_buy_cropland() {
		boolean for_sale = false;
		ArrayList<SAMA> land_for_sale = new ArrayList<SAMA>();
		for (int i = 0; i < Variables.getlandlist().size(); i++) {
			SAMA sama = (SAMA) Variables.getlandlist().get(i);
			if (getpatch_purchased() == sama.getID()) {
				sama.setfor_sale(false);
			}
			if (sama.getfor_sale() == true) { // && sama.getpatchtype() == 1) {
				for_sale = true;
				land_for_sale.add(sama);
			}
		}

		Collections.sort(land_for_sale, sComparator);

		// System.out.println("land for sale:" + land_for_sale.size());
		if (land_for_sale.size() == 0) {
			setstopcropmarketloop(true);
			// System.out.println("STOP CROPLAND MARKET");
		}

		if (for_sale == true) {
			// int N_patch_ID = (int) (Math.random() * land_for_sale.size());
			// SAMA samasellcropland = (SAMA) land_for_sale.get(N_patch_ID);
			SAMA samasellcropland = land_for_sale.get(0);
			Variables.setcurrent_plot_on_market(samasellcropland
					.getid_land_market());
			for (int i = 0; i < Variables.getfarmerlist().size(); i++) {
				Producer prod = (Producer) Variables.getfarmerlist().get(i);
				prod.setcan_bid_on_plot(false);
				if (prod.getcan_bid() == true) {
					prod.plot_screening(samasellcropland);
				}
			}
		}
	}

	public void create_bid_cropland() {
		double total_plots_after = 0;
		double total_plots_bought = 0;
		Parameters p = RunEnvironment.getInstance().getParameters();

		double increase_no_till = (Double) p.getValue("increaseNoTill");

		// //ArrayList new_bid_list = new ArrayList();
		// Variables.setbid_list(new_bid_list);

		for (int i = 0; i < Variables.getfarmerlist().size(); i++) {

			Producer prod = (Producer) Variables.getfarmerlist().get(i);
			prod.setcurrent_bid(0);
		}

		if (getstopcropmarketloop() == false) {

			Variables.set_buy_bid_list_cropland(null);
			for (int i = 0; i < Variables.getfarmerlist().size(); i++) {
				Producer prod = (Producer) Variables.getfarmerlist().get(i);
				prod.update_acres();
				prod.marginal_and_cropland_plots();
				total_plots_after_cropland = (int) ((int) prod.gettotal_cropland_plots() + prod.gettotal_marginal_plots());
				// System.out.println("total_plots_after:" + total_plots_after +
				// " "
				// + prod.getfarmer_name());

				total_plots_bought = total_plots_after_cropland
						- prod.init_number_of_lands_cropland;
				// System.out.println("plots bought:" + total_plots_bought);

				int needs_crop_land = needCropLand(prod.getfarmer_name()) + needMarginalLand(prod.getfarmer_name());

				if (needs_crop_land < Integer.MAX_VALUE
						&& needs_crop_land - total_plots_bought > 0) {

					prod.setcan_bid_on_cropland(true);
					if (prod.getcan_bid_on_plot() == true) {
						SAMA sama = (SAMA) Variables.getlandlist().get(
								Variables.getcurrent_plot_on_market());

						prod.create_bid_cropland(sama);

					} else {

					}
				} else {

					prod.setcan_bid_on_cropland(false);
				}
			}
		}

		for (int i = 0; i < Variables.getfarmerlist().size(); i++) {
			Producer prod = (Producer) Variables.getfarmerlist().get(i);
			ArrayList alfl = prod.getmylandList();

			if (prod.getcan_bid_on_plot() == true) {
				if (alfl.size() != 0) {
					int patch_id = (int) (Math.random() * alfl.size());
					SAMA sama = (SAMA) alfl.get(patch_id);

				}

			}
		}
		int farmers_bidding = 0;
		for (int i = 0; i < Variables.getfarmerlist().size(); i++) {
			Producer prod = (Producer) Variables.getfarmerlist().get(i);
			if (prod.getcurrent_bid() > 0) {
				farmers_bidding = farmers_bidding + 1;
			}
		}
		Variables.setfarmers_bidding(farmers_bidding);
	}

	public void sell_land_cropland() {

		Parameters p = RunEnvironment.getInstance().getParameters();

		double down_payment = (Double) p.getValue("downPayment");
		double must_sell_min = (Double) p.getValue("must_sell_min");
		double must_sell_prob = (Double) p.getValue("must_sell_prob");
		double lease_man_fee_percent = (Double) p
				.getValue("lease_man_fee_percent");
		double land_owner_risk = (Double) p.getValue("land_owner_risk");
		double prob_investor_bid = (Double) p.getValue("prob_investor_bid");
		double market_value;
		double mean_bid = 0;
		double adjusted_price = 0;
		double adjusted_lease = 0;
		int acres_purchased = 0;
		double bid_1_price;
		double bid_2_price;
		SAMA fdl2 = (SAMA) Variables.getlandlist().get(
				Variables.getcurrent_plot_on_market());
		if(fdl2.getpatchtype()== 1){
		market_value = fdl2.getAvg_prod_patch()
				/ Variables.getmean_patch_quality()
				* Variables.getcropland_price();
		adjusted_lease = fdl2.getAvg_prod_patch()
		/ Variables.getmean_patch_quality()
		* Variables.getcrop_exp_lease();
		}
		if(fdl2.getpatchtype()== 2 || fdl2.getpatchtype()== 3){
			market_value = fdl2.getAvg_prod_patch()
			/ Variables.getmean_patch_quality()
			* Variables.getmarginalland_price();	
			adjusted_lease = fdl2.getAvg_prod_patch()
			/ Variables.getmean_patch_quality()
			* Variables.getmarginal_exp_lease();
		}
		
		
		// System.out.println("adjusted_lease_sell_land:" + adjusted_lease);
		double min_accept = land_owner_risk * adjusted_lease
				* (1 - lease_man_fee_percent) / 0.03;

		if (Math.random() <= must_sell_prob) {
			fdl2.setneed_sell(true);
		}

		double investor_bid = 0;
		if (Math.random() <= prob_investor_bid) {
			investor_bid = min_accept;
		}

		if (fdl2.getneed_sell() == true || Variables.getunmanaged() > 60) {
			min_accept = must_sell_min * min_accept;
		}

		ArrayList bidl = Variables.get_buy_bid_list_cropland();

		double bid_1 = 0;
		double bid_2 = 0;
		BidListCropland bidlis = (BidListCropland) bidl.get(0);
		// System.out.println("bidlis:" + bidlis);
		bid_1 = bidlis.getcurrent_bid();
		// System.out.println("bidl:" + bidl);
		int farmer_buyer = bidlis.getproducer_id();

		if (bidl.size() > 0) {

			for (int i = 0; i < bidl.size(); i++) {
				BidListCropland bidlist = (BidListCropland) bidl.get(i);
				if (bidlist.getcurrent_bid() > bid_1) {
					bid_1 = bidlist.getcurrent_bid();
					farmer_buyer = bidlist.getproducer_id();
					// System.out.println("BUYLANDHERE:");
				} else {
					if (bidlist.getcurrent_bid() > bid_2) {
						bid_2 = bidlist.getcurrent_bid();
						// System.out.println("BUYLANDTHERE:");
					}
				}
			}
		}

		if (bidl.size() <= 2) {
			bid_2 = 0;
			// System.out.println("BIDL.SIZEISLESSTHANZERO:");
		}

		double adjusted_bid = 0;
		Producer prod = null;

		for (Producer p1 : (ArrayList<Producer>) Variables.getfarmerlist()) {
			if (p1.getfarmer_name() == farmer_buyer) {
				prod = p1;
				break;
			}
		}
		// prod = (Producer) Variables.getfarmerlist().get(farmer_buyer);

		if (bid_2 < investor_bid) {
			bid_2 = (int) investor_bid;
		}
		if (bid_2 > 0) {
			adjusted_bid = (bid_2 + prod.getcurrent_bid()) / 2;
		} else {
			adjusted_bid = prod.getcurrent_bid();
		}

		// Sys//em.out.println(prod.getcurrent_bid() + " current_bid " + bid_2
		// + " bid_2 " + adjusted_bid + " Adjusted and bid_finances "
		// + prod.getbid_finances());
		if (adjusted_bid > prod.getbid_finances()) {
			adjusted_bid = prod.getbid_finances();
		}

		// System.out.println("investor:" + investor_bid + "min_accept:"
		// + min_accept + "adjust:" + adjusted_bid);
		if (adjusted_bid > min_accept && adjusted_bid > investor_bid) {
			Variables
					.setplots_sold_farmers(Variables.getplots_sold_farmers() + 1);
			double price_paid = ((adjusted_bid + min_accept) / 2);
			
			SAMA sama = (SAMA) Variables.getlandlist().get(
					Variables.getcurrent_plot_on_market());
			sama.setcurrent_producer(prod.getID());
			sama.setOwner(prod.getfarmer_name());
			if(sama.getpatchtype()== 1) {
				Variables.setcrop_plots_sold_farmers(Variables.getcrop_plots_sold_farmers()+1);
			}
			if(sama.getpatchtype()== 2 || sama.getpatchtype()== 3){
				Variables.setmarginal_plots_sold_farmers(Variables.getmarginal_plots_sold_farmers()+1);
			}

			boolean purchased_land = true;
			// System.out.println("LAND ID:" + sama.getid_land_market());
			// System.out.println("PLOT BOUGHT:" + sama.getID());
			// System.out.println("Buyer=" + prod.getfarmer_name());

			setpatch_purchased(sama.getID());
			// System.out.println("patch_purchased first:" +
			// getpatch_purchased());

			prod.add_land(sama);
			prod.update_acres();
			prod.marginal_and_cropland_plots();
			prod.after_purchase_number_of_lands_cropland = (int) prod
					.gettotal_cropland_plots()
					- prod.init_number_of_lands_cropland;

			acres_purchased = sama.getacres();

			// System.out.println("acres_purchased:" + acres_purchased + " " +
			// prod.getID());
			sama.setfor_sale(false);

			sama.setlease_term(0);
			sama.setlease_payment(0);
			sama.setdistance_to_farm((int) (Math.sqrt(Math.pow(sama.getX()
					- prod.getX(), 2)
					+ Math.pow(sama.getY() - prod.getY(), 2))));

			sama.setcame_from_bid(false);
			prod.setcan_bid(false);
			prod.setcan_bid_on_plot(false);

			Variables.setbuyer(prod.getID()); // This should be prod.getID()

			double total_price = price_paid * acres_purchased;
			// System.out.println("buylandprice:" + price_paid_cropland);
			prod.setcash((int) (Math.round(prod.getcash() - down_payment
					* total_price)));
			double payment = Math.round((1 - down_payment) * total_price
					* Variables.getloan_factor_payment_20());
			debtList debtl = new debtList();
			debtl.setyears_remaining(20);
			debtl.setannual_payment((int) payment);
			debtl.setdebt((int) (Math.round((1 - down_payment) * total_price)));
			ArrayList debt_array_list = prod.getdebt_list();
			debt_array_list.add(debtl);
			prod.setdebt_list(debt_array_list);
			
			
			adjusted_price = price_paid
					* Variables.getmean_patch_quality()
					/ fdl2.getAvg_prod_patch();
			

			// System.out.println("AFTER BUY" + prod.getmylandList().size()
			// + "farmer" + prod.getfarmer_name());

			prod.buy_machine();
			prod.set_expected_income();
			prod.balance_sheet();
			// prod.update_debt();
			// prod.initial_screen_farmers();
			
			if(sama.getpatchtype() == 1) {
			CropLandPrice lp = new CropLandPrice();
			lp.setcroplandPrice(price_paid);

			ArrayList al = Variables.getcropland_price_list();
			al.add(lp);
			Variables.setcropland_price_list(al);
			}
			if(sama.getpatchtype() == 2 || sama.getpatchtype()== 3) {
				MarginalLandPrice mlp = new MarginalLandPrice();
				mlp.setmarginallandPrice(price_paid);

				ArrayList mal = Variables.getmarginalland_price_list();
				mal.add(mlp);
				Variables.setmarginalland_price_list(mal);
			}
			
			
		} else {
			if (investor_bid > 0) {
				SAMA sama = (SAMA) Variables.getlandlist().get(
						Variables.getcurrent_plot_on_market());
				double price = (investor_bid + min_accept) / 2;

				adjusted_price = price * Variables.getmean_patch_quality()
						/ fdl2.getAvg_prod_patch();
				if(sama.getpatchtype() == 1) {
				CropLandPrice lp1 = new CropLandPrice();
				lp1.setcroplandPrice(adjusted_price);

				ArrayList a = Variables.getcropland_price_list();

				a.add(lp1);

				Variables.setcropland_price_list(a);
				}
				if(sama.getpatchtype() == 2 || sama.getpatchtype()==3){
				MarginalLandPrice lp1 = new MarginalLandPrice();
				lp1.setmarginallandPrice(adjusted_price);

				ArrayList a = Variables.getmarginalland_price_list();

				a.add(lp1);

				Variables.setmarginalland_price_list(a);
				}
				Variables.setplots_sold_investor(Variables
						.getplots_sold_investor() + 1);

			} else {
				this.continue_market = false;
			}

			fdl2.setfor_sale(false);
			fdl2.setfor_rent(true);

		}
		if (min_accept > adjusted_bid) {
			SAMA sama = (SAMA) Variables.getlandlist().get(
					Variables.getcurrent_plot_on_market());
			sama.setfor_sale(false);
			sama.setfor_rent(true);
			// System.out.println("MIN ACCEPT NOT MET RENT OUT LAND"
			// + sama.getID()); // /This shows up again for same piece of
			// land.
			this.continue_market = false;
			prod.update_acres();
			prod.marginal_and_cropland_plots();
		}

	}

	public int needCropLand(int ProducerID) {
		Connection conn;
		int rent = 0;

		if (Variables.get_cropLandNeeds()[ProducerID - 1] == null) {
			try {
				conn = DriverManager.getConnection("jdbc:odbc:producerDB",
						"java", "1234");
				Statement stmt = conn.createStatement();
				ResultSet rs = stmt
						.executeQuery("SELECT rent_cropland FROM MIP WHERE "
								+ "farmerID=" + ProducerID + "and " + "year="
								+ Variables.getyear());

				while (rs.next()) {
					rent = rs.getInt("rent_cropland");

				}

				rs.close();
				stmt.close();
				conn.close();
			} catch (SQLException e) {
				System.out.println("Statement is wrong: " + e.getMessage());
				e.printStackTrace();
			}
			Variables.get_cropLandNeeds()[ProducerID - 1] = rent;
			return rent;
		} else {
			return Variables.get_cropLandNeeds()[ProducerID - 1];
		}
	}

	public boolean getstopcropmarketloop() {
		return stopcropmarketloop;
	}

	public void setstopcropmarketloop(boolean ProducerID) {
		stopcropmarketloop = ProducerID;
	}

	public int getpatch_purchased() {
		return patch_purchased;
	}

	public void setpatch_purchased(int i) {
		patch_purchased = i;
	}

}
