package energycrops;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;


import org.apache.commons.math.distribution.*;
import org.jfree.data.function.NormalDistributionFunction2D;

import com.sun.corba.se.impl.orb.NormalDataCollector;
import java.util.*;
import repast.simphony.context.Context;
import repast.simphony.engine.environment.RunEnvironment;
import repast.simphony.parameter.Parameters;
import repast.simphony.space.continuous.ContinuousSpace;
import repast.simphony.space.grid.Grid;
import repast.simphony.valueLayer.GridValueLayer;

public class SAMA extends ProducerAgent{

private int patch_id;                              //number specific to that plot of land
private int patchtype;
private int id_land_market;                        //id in land list used for land market
private int lease_term;
private int tilled_crop;                           // acres of tilled land in crop production on the plot
private int hay_hay;
private int tilled_hay;
private int hay_pasture;
private int tilled_pasture;
private static int current_producer;                        // identifies the farmer currently in control of the patch
private int owner;                                 // the current owner of the plot
private int renter;                                // the current renter of the plot
private int distance_to_farm;						//distance to the homestead of the current farmer
private int years_in_grass;
private int years_in_poplar;
private int years_in_willows;
private int years_in_prairie_sandreed;
private double avg_prod_patch;                      // average productivity rating of the plot based on SAMA data weighted for acres in each use
private double avg_prod_patch_pasture;
private double avg_prod_patch_cropland;
private boolean in_willows;
private boolean in_poplar;
private boolean in_grass;
private boolean in_prairiesandreed;	


private int x;                                      // farm-land coordinate x                                    
private int y;                                      // farm-land coordinate y
private double sama_tilled_quality;                // quality of tilled land based on Saskatchewan Assessment and Management Agency (SAMA) data
private int sama_tilled;                           // land use acres of tilled land from SAMA
private double sama_hay_quality;                   // quality of hay land based on SAMA data
private int sama_hay;                              // land use acres of hay land from SAMA
private double sama_IP_quality;                    // quality of improved pasture land from SAMA
private int sama_IP;                               // land use acres of improved pasture land based on SAMA data
private double sama_np_quality;                    // quality of nature pasture land from SAMA
private int sama_np;                               // land use acres of nature pasture land based on SAMA data
private boolean patch_leased;                      // used to determine if patch is initially leased
private double barley_yield_index;                 // yield of barley on tilled portion of land relative to average yields on stubble based on sask crop insurance data
private double canola_yield_index;                 // yield of canola on tilled portion of land relative to average yields on stubble based on sask crop insurance data
private double wheat_yield_index;                  // yield of wheat on tilled portion of land relative to average yields on stubble based on sask crop insurance data
private double wheat_sf_yield_index;               // yield index for wheat on fallow (adjust wheat on stubble yield to reflect wheat on fallow for the plot)
private double durum_yield_index;
private double flax_yield_index;
private double peas_yield_index;
private double lentils_yield_index;

private boolean for_sale;							//the plot is currently for sale
private boolean for_rent;						//the plot is currently available for rent
private boolean need_sell;						//
private int crop_acres_bid;							//acres that would be in crop production if the land was purchased             
private double lease_payment;						//annual lease payment of the plot of land
private double lease_payment_pasture;
private double last_adj_croplease_rate;
private double last_adj_marginallease_rate;
private int bidders;
private int acres;                                  // total usable acres on the plot         
private double net_income_crop;                     // the expected net income from crop production on the plot
private double net_hay_inc;
private double hay_prod_mcals;
private double early_pasture_mcals;
private double late_pasture_mcals;
private double fall_pasture_mcals;
private double winter_mcals;
private double avg_hay_q;




private boolean came_from_bid;                 
private double e_total_plot_income_crop;            // total-value of a plot when it is used in crop (includes natural pasture and hay)
private double plot_income_crop;
private double gross_income_crop;
private double net_crop_inc;
private double[] yield_exp_list;             // individual farmers yield expectation list
private double[] price_exp_list;             // individual farmers price expectation list 
private String producers_crop_mix;
private boolean alive; // boolean for grass alive/dead
private static final int waste = 2;
private static final int land_leased = 1;
private static final int land_owned = 0;
private boolean can_change; 


Producer prod;
Generals Generals;

public SAMA(Context context, Variables VS, Generals GS, int xi, int yi, int id){ 
	
	this.x = xi;
	this.y = yi;
	this.Generals = GS;
	this.Variables = VS;	
	this.patch_id = id;
	
	Parameters p = RunEnvironment.getInstance().getParameters();
	int TotalLands = (Integer)p.getValue("totallands");
	
	if(patch_id <=TotalLands){
		try{
			Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
		}catch(ClassNotFoundException ce){
			//System.out.println("SQLExceptiong:"+ce.getMessage());
		}
		try{
			Connection conn=DriverManager.getConnection("jdbc:odbc:producerDB","java","1234");
			Statement stmt = conn.createStatement();
			ResultSet rs=stmt.executeQuery("select * from patchInfo where id = "+patch_id);
			while(rs.next()){

				sama_tilled_quality=rs.getDouble("sama-tilled-quality");
				sama_tilled=rs.getInt("sama-tilled");
				sama_hay_quality=rs.getDouble("sama-hay-quality");
				sama_hay=rs.getInt("sama-hay");
				sama_IP_quality=rs.getDouble("sama-IP-quality");
				sama_IP=rs.getInt("sama-IP");
				sama_np_quality=rs.getDouble("sama-np-quality");
				sama_np=rs.getInt("sama-np");
				int patchLeased = rs.getInt("patch-leased");
				patch_leased = true;
				if(patchLeased == 0){
					patch_leased = false;
				}
				patchtype = rs.getInt("Patch-Type");
				
				barley_yield_index = rs.getDouble("barley-yield-index");
				canola_yield_index = rs.getDouble("canola-yield-Index");
				flax_yield_index = rs.getDouble("Flax-Yield-Index");
				lentils_yield_index = rs.getDouble("lentils-yield-index");     
				wheat_yield_index = rs.getDouble("wheat-yield-index");
				durum_yield_index = rs.getDouble("durum-yield-index");
				peas_yield_index = rs.getDouble("peas-yield-index");     
				wheat_sf_yield_index = rs.getDouble("wheat-sf-yield-index");
				         
				
				
			}
			rs.close();
			stmt.close();
			conn.close();
		}catch(SQLException ce){
			System.out.println("SQLException SAMA:"+ce.getMessage());
		}
			
		setfor_sale(false);
		setfor_rent(false);
			
			if(patch_leased == true) {
				alive = true;
			}
			else {
				alive = false;
			}
	}
	
	context.add(this);
	
	
	Grid grid = (Grid)context.getProjection("Simple Grid");
	ContinuousSpace space = (ContinuousSpace)context.getProjection("Continuous Space");
	
	grid.moveTo(this, x, y);
	
	space.moveTo(this, x, y, 0);
	GridValueLayer vl = (GridValueLayer)context.getValueLayer("Land Field");
	if(patch_id <= TotalLands){
		if(alive)
			vl.set(land_leased, grid.getLocation(this).toIntArray(null));
		else
		vl.set(land_owned, grid.getLocation(this).toIntArray(null));
	}
	else {
		vl.set(waste, grid.getLocation(this).toIntArray(null));
	}
	
		
}

	@Override
	public void step2(){
		Parameters p = RunEnvironment.getInstance().getParameters();
		int total_lands = (Integer)p.getValue("totallands");
		
		if(getID()<=total_lands){
			
			if(Variables.getyear()==0){
				//System.out.println("Whatever never");
				initialization_phase();
			}
			else{
				//System.out.println("Whatever");
				simulation_phase();
			}
		}
	}

	public void initialization_phase(){
		set_quality_acres_tenure();
		setLandUses();
		set_parameters();
		set_yield_exp();
		set_price_expecation_list();
	}

	public void simulation_phase(){
		set_parameters();
		set_yield_exp();		
		set_price_expecation_list();		
		need_sell = false;		
	}

public void set_quality_acres_tenure(){
	
	Parameters p = RunEnvironment.getInstance().getParameters();
	
	int initial_lease_rate = (Integer)p.getValue("initialleaserate");
	int initial_lease_rate_pasture = (Integer)p.getValue("initialleaseratepasture");
	
	
	if(getrenter() != 9999){
		setlease_term((int)(Math.random()*7+1));
	
			lease_payment = initial_lease_rate * getAvg_prod_patch()/ Variables.getmean_patch_quality();
			lease_payment_pasture = initial_lease_rate_pasture * getAvg_prod_patch()/Variables.getmean_patch_quality();
		//System.out.println("AVGPRODUCTIONPATCH:" + getAvg_prod_patch());
		//System.out.println("meanpatch:" + Variables.getmean_patch_quality());
		//System.out.println("SAMA Lease rate:" + lease_payment);
		last_adj_croplease_rate = initial_lease_rate;	
		last_adj_marginallease_rate = initial_lease_rate_pasture;
	}
}

//**********************************  setLandUses  *******************************************
// The function is cited by set_land_use in ABMModel.

public void setLandUses(){
	if(sama_tilled_quality<30 && sama_tilled>0){
		sama_IP_quality = (sama_IP * sama_IP_quality + sama_tilled * sama_tilled_quality)/(sama_tilled+sama_IP);
		sama_IP = sama_IP + sama_tilled;
		sama_tilled = 0;
		sama_tilled_quality = 0;
	}
	if(sama_hay_quality < 30 && sama_hay>0){
		sama_IP_quality = (sama_IP*sama_IP_quality + sama_hay*sama_hay_quality)/(sama_hay+sama_IP) ;
		sama_IP = sama_IP+sama_hay;
		sama_hay = 0;
		sama_hay_quality =0;
	} 
	if(sama_tilled_quality < 40 && sama_tilled>0){
		sama_hay_quality = (sama_hay*sama_hay_quality + sama_tilled*sama_tilled_quality)/(sama_hay+sama_tilled);
		sama_hay = sama_hay + sama_tilled;
		sama_tilled = 0;
		setTilled(sama_tilled);
		sama_tilled_quality = 0;
		setTilledQuality(sama_tilled_quality);
	}
	if(sama_tilled<10 && sama_tilled>0){
		sama_hay_quality = (sama_hay*sama_hay_quality + sama_tilled*sama_tilled_quality)/(sama_hay+sama_tilled);
		setHayQuality(sama_hay_quality);
		sama_hay = sama_tilled + sama_hay;
		setHay(sama_hay);
		sama_tilled = 0;
		setTilled(sama_tilled);
		sama_tilled_quality = 0;
		setTilledQuality(sama_tilled_quality);
	}	
    
	sethay_hay(sama_hay);
    settilled_crop(sama_tilled);
    int acres = sama_hay + sama_tilled + sama_np + sama_IP;
	setacres(acres);
	if(acres==0){
	//	System.out.println("acres of land"+getID()+" = 0");
	} else {
		//System.out.println("acres of land"+getID()+" = " + acres);
	}
}



public void set_parameters(){
	
	price_exp_list = Variables.getexpected_price_list();
}

public void set_yield_exp(){
	yield_exp_list = Variables.getexpected_yield_list();	
}

public void set_price_expecation_list(){
		
		
	price_exp_list = new double[] {Variables.getexpected_price_list()[0], Variables.getexpected_price_list()[1], Variables.getexpected_price_list()[2], Variables.getexpected_price_list()[3], Variables.getexpected_price_list()[4], Variables.getexpected_price_list()[5], Variables.getexpected_price_list()[6], Variables.getexpected_price_list()[7], Variables.getexpected_price_list()[8]};

	
	
			}


	
public void setcan_change(){
	setcan_change(true);
}

public int getX(){
	return x;
}

public int getY(){
	return y;
}

public int getID(){
	return patch_id;
}

public int getacres(){
	return acres;
}

public void setacres(int i){
	acres = i;
}

public void setpatch_leased(boolean i){
	patch_leased = i;
}

public boolean getpatch_leased(){
	return patch_leased;
}

public double getTilledQuality(){
	return sama_tilled_quality;
}

public int getTilled(){
	return sama_tilled;
}

public double getHayQuality(){
	return sama_hay_quality;
}

public int getHay(){
	return sama_hay;
}

public double getIPQuality(){
	return sama_IP_quality;
}

public int getIP(){
	return sama_IP;
}

public double getnpQuality(){
	return sama_np_quality;
}

public int getnp(){
	return sama_np;
}
	
public void setAvg_prod_patch(double newavg_prod_patch){
	avg_prod_patch = newavg_prod_patch;
}

public double getAvg_prod_patch(){
	return avg_prod_patch;
}

public void setAvg_prod_patch_pasture(double newavg_prod_patch_pasture){
	avg_prod_patch_pasture = newavg_prod_patch_pasture;
}

public double getAvg_prod_patch_pasture() {
	return avg_prod_patch_pasture;
}

public void setAvg_prod_patch_cropland(double newavg_prod_patch_cropland){
	avg_prod_patch_cropland = newavg_prod_patch_cropland;
}

public double getAvg_prod_patch_cropland(){
	return avg_prod_patch_cropland;
}

public void setIPQuality(double newIPQuality){
	sama_IP_quality = newIPQuality;
}

public void setIP(int newIP){
	sama_IP = newIP;
}

public void setTilled(int newTilled){
	sama_tilled = newTilled;
}

public void setTilledQuality(double newTilledQuality){
	sama_tilled_quality = newTilledQuality;
}

public void setHay(int newHay){
	sama_hay = newHay;
}

public void setHayQuality(double newHayQuality){
	sama_hay_quality = newHayQuality;
}	


public String getproducers_crop_mix(){
	return producers_crop_mix;
	
}

public void setproducers_crop_mix(String i){
	producers_crop_mix = i;
}

public double getnet_income_crop(){
	return net_income_crop;
}

public void setnet_income_crop(double i){
	net_income_crop = i;
}

public void setfor_sale(boolean i){
	for_sale = i;
}

public boolean getfor_sale(){
	return for_sale;
}

public void setfor_rent(boolean i){
	for_rent = i;
}

public boolean getfor_rent(){
	return for_rent;
}

public double getlease_payment(){
	return lease_payment;
}



public void setlease_payment(double i){
	lease_payment = i;
}

public double getlease_payment_pasture() {
	return lease_payment_pasture;
}

public void setlease_payment_pasture(double i){
	lease_payment_pasture = i;
}


public boolean getneed_sell(){
	return need_sell;
}

public void setneed_sell(boolean i){
	need_sell = i;
}

public void setid_land_market(int i){
	id_land_market = i;
}

public int getid_land_market(){
	return id_land_market;
}

public double gete_total_plot_income_crop(){
	return e_total_plot_income_crop;
}

public void sete_total_plot_income_crop(double i){
	e_total_plot_income_crop = i;
}

public double getFlaxYieldIndex(){
	return flax_yield_index;
}

public double getBarleyYieldIndex(){
	return barley_yield_index;
}

public double getCanolaYieldIndex(){
	return canola_yield_index;
}

public double getWheatYieldIndex(){
	return wheat_yield_index;
}

public double getWheatSfYieldIndex(){
	return wheat_sf_yield_index;
}
	
public void settilled_crop(int i){
	tilled_crop=i;
}

public int gettilled_crop(){
	return tilled_crop;
}

public void sethay_hay(int i) {
	hay_hay = i;
}

public int gethay_hay(){
	return hay_hay;
}

public void settilled_hay(int i) {
	tilled_hay = i;
}

public int gettilled_hay(){
	return tilled_hay;
}

public void sethay_pasture(int i) {
	hay_pasture = i;
}

public int gethay_pasture() {
	return hay_pasture;
}

public void settilled_pasture(int i) {
	tilled_pasture = i;
}

public int gettilled_pasture() {
	return tilled_pasture;
}


public static int getcurrent_producer(){
	return current_producer;
}

public void setcurrent_producer(int i){
	//System.out.println("I value: "+i);
	current_producer = i;
}

public void setrenter(int i){
	renter = i;
}	

public int getrenter(){
	return renter;
}

public int getOwner(){
	return owner;
}
	
public void setOwner(int i){
	owner = i;
}

public void setdistance_to_farm(int i){
	distance_to_farm = i;
}

public int getdistance_to_farm(){
	return distance_to_farm;
}

public int getcrop_acres_bid(){
	return crop_acres_bid;
}

public void setcrop_acres_bid(int i){
	crop_acres_bid = i;
}

public int getlease_term(){
	return lease_term;
}

public void setlease_term(int i){
	lease_term = i;
}

public double getlast_adj_croplease_rate(){
	return last_adj_croplease_rate;
}

public void setlast_adj_croplease_rate(double i){
	last_adj_croplease_rate = i;
}

public double getlast_adj_marginallease_rate(){
	return last_adj_marginallease_rate;
}

public void setlast_adj_marginallease_rate(double i){
	last_adj_marginallease_rate = i;
}

public boolean getcame_from_bid(){
	return came_from_bid;
}

public void setcame_from_bid(boolean i){
	came_from_bid = i;
}

public int getbidders(){
	return bidders;
}

public void setbidders(int i){
	bidders = i;
}

public double getplot_income_crop(){
	return plot_income_crop;
}

public void setplot_income_crop(double i){
	plot_income_crop=i;
}	

public double getgross_income_crop(){
	return gross_income_crop;
}

public void setgross_income_crop(double i){
	gross_income_crop = i;
}

public double getnet_crop_inc(){
	return net_crop_inc;
}

public void setnet_crop_inc(double i){
	net_crop_inc = i;
}

public boolean getcan_change() {
	return can_change;
}


public void setcan_change(boolean i){
	can_change = i;
}

public double getavg_hay_q () {
	return avg_hay_q;
}

public void setavg_hay_q (double i) {
	avg_hay_q = i;
}

public void setyears_in_grass(int i) {
	years_in_grass = i;
}

public int getyears_in_grass() {
	return years_in_grass;
}

public int getpatchtype() {
	return patchtype;
}

public void setpatchtype (int i) {
	patchtype = i;
}


public void setyears_in_poplar(int i){
	years_in_poplar = i;
}

public int getyears_in_poplar () {
	return years_in_poplar;
}

public void setyears_in_willows (int i) {
	years_in_willows = i;
}

public int getyears_in_willows () {
	return years_in_willows;
}

public void setyears_in_prairie_sandreed (int i) {
	years_in_prairie_sandreed = i;
}

public int getyears_in_prairie_sandreed () {
	return years_in_prairie_sandreed;
}

public double getPeasYieldIndex () {
	return peas_yield_index;
}

public void setPeasYieldIndex (double i) {
	peas_yield_index = i;
}

public double getLentilsYieldIndex () {
	return lentils_yield_index;
}

public void setLentilsYieldIndex (double i) {
	lentils_yield_index = i;
}

public double getDurumYieldIndex () {
	return durum_yield_index;
}

public void setDurumYieldIndex (double i) {
	durum_yield_index = i;
}

public boolean getin_willows () {
	return in_willows;
}

public void setin_willows (boolean i) {
	in_willows = i;
}

public boolean getin_poplar () {
	return in_poplar;
}

public void setin_poplar (boolean i) {
	in_poplar = i;
}

public boolean getin_grass () {
	return in_grass;
}

public void setin_grass (boolean i) {
	in_grass = i;
}

public boolean getin_prairiesandreed () {
	return in_prairiesandreed;
}

public void setin_prairiesandreed (boolean i) {
	in_prairiesandreed = i;
}


}


