package energycrops;

import java.util.ArrayList;

import java.sql.Array;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Connection;

import repast.simphony.engine.environment.RunEnvironment;
import repast.simphony.parameter.Parameters;

public class Variables {

	private double[] flax_bootstrapped_yields;
	private double[] flax_bootstrapped_prices;
	private double[] canola_bootstrapped_yields;
	private double[] canola_bootstrapped_prices;
	private double[] wheat_bootstrapped_yields;
	private double[] wheat_bootstrapped_prices;
	private double[] durum_bootstrapped_yields;
	private double[] durum_bootstrapped_prices;
	private double[] barley_bootstrapped_yields;
	private double[] barley_bootstrapped_prices;
	private double[] peas_bootstrapped_yields;
	private double[] peas_bootstrapped_prices;
	private double[] lentils_bootstrapped_yields;
	private double[] lentils_bootstrapped_prices;
	private double[] hay_bootstrapped_yields;
	private double[] hay_bootstrapped_prices;
	private double[] calf_bootstrapped_prices;
	private static int initial_run_number;

	private int year; // is used to calculate expectations and retrive prices
						// and yields
	private int scenario;
	private int run_number; // current run of the simulation
	private double[] crop_canola_price_list; // farm level crop price of crop
												// canola in $ per bu actual
												// price used in simulation
	private double[] crop_wheat_price_list; // farm level crop price of crop
											// wheat in $ per bu actual price
											// used in simulation
	private double[] crop_barley_price_list; // farm level crop price of crop
												// barley in $ per bu actual
												// price used in simulation
	private double[] crop_flax_price_list;
	private double[] crop_peas_price_list;
	private double[] crop_lentils_price_list;

	private double[] crop_canola_yield_list; // average yield of crop canola in
												// bu for all years in the
												// simulation
	private double[] crop_wheat_yield_list; // average yield of crop wheat in bu
											// for all years in the simulation
	private double[] crop_barley_yield_list; // average yield of crop barley in
												// bu for all years in the
												// simulation
	private double[] crop_flax_yield_list;
	private double[] crop_peas_yield_list;
	private double[] crop_lentils_yield_list;
	private double[] crop_durum_yield_list;
	private double[] crop_durum_price_list;
	private double[] hay_yield_list;
	private double[] income_margin_list;

	private double[] calf_price_list;
	private double[] hay_price_list;

	private double yield_canola; // current year yield of canola
	private double yield_wheat; // current year yield of wheat
	private double yield_barley; // current year yield of barley
	private double yield_durum;
	private double yield_flax;
	private double yield_peas;
	private double yield_lentils;

	private double yield_willows;
	private double price_willows;

	private double yield_energy_crops_2;
	private double yield_energy_crops_3;

	private double price_energy_crops_2;
	private double price_energy_crops_3;

	private double mean_patch_quality; // average quality of all patches
	private double mean_patch_quality_pasture;
	private double mean_patch_quality_cropland;

	private double all_patches_avg_prod;

	private double hay_yield_1;
	private double max_hay_yield_earlypasture;
	private double max_hay_yield_latepasture;
	private double max_hay_yield_fall;

	private double price_canola; // current year price of canola in $/bu
	private double price_wheat; // current year price of wheat in $/bu
	private double price_durum;
	private double price_barley; // current year price of barley in $/bu
	private double price_flax;
	private double price_peas;
	private double price_lentils;
	private static int originalcontextsize;

	private double price_hay;
	private double price_calf;

	private double income_margin;

	private int oldage; // farmers retiring without transfering
	private double avg_lease;
	private double crop_exp_lease;
	private double marginal_exp_lease;

	private double loan_factor_payment_20; // used to calculate loan payment for
											// 20 year loan
	private double loan_factor_payment_25; // used to calculate loan payment for
											// 25 year loan
	private double loan_factor_payment_5; // used to calculate loan payment for
											// 5 year loan

	private int transfers; // total farms that have been transfered to the next
							// generation
	private int bankrupt; // total farmers exiting because of debt exceeding
							// their assets
	private int cashflow; // total farmers exiting because of negative cash
							// flows

	private int max_distance;

	private int buyer;
	private int leaser;
	
	private double poplarnp;
	private double poplarip;
	private double poplarhayland;
	
	DataBaseLivestock dbLivestock = new DataBaseLivestock();
	DataBaseForage dbForage = new DataBaseForage();
	
	private ArrayList cropland_price_list;
	private ArrayList marginalland_price_list;
	private ArrayList cropland_lease_list;
	private ArrayList marginalland_lease_list;
	private ArrayList bid_list;
	private ArrayList landlist;
	private static ArrayList initiallandlist;
	private ArrayList farmerlist;
	private static ArrayList initialfarmerlist;
	private ArrayList land_for_sale;

	private int plots_sold_farmers;
	private int crop_plots_sold_farmers;
	private int crop_plots_sold_investor;
	private int crop_plots_leased;
	private int marginal_plots_leased;
	
	private int marginal_plots_sold_farmers;
	private int marginal_plots_sold_investor;
	private int plots_sold_investor;
	private int farmers_bidding;

	private int unmanaged;
	private int croplease_rate;
	private int marginallease_rate;
	private int cropland_price; // land price at the end of the year
	private int marginalland_price;
	private int land_price_pasture;
	private int current_plot_on_market = 1;

	private double[] last_5_years_price_lentils;
	private double[] last_5_years_price_peas;
	private double[] last_5_years_price_flax;
	private double[] last_5_years_price_canola; // the last 5 years of canola
												
	private double[] last_5_years_price_wheat; // the last 5 years of wheat
	private double[] last_5_years_price_durum;											
	private double[] last_5_years_price_barley; // the last 5 years of barley
												
	private double[] last_5_years_price_livestock;
	private double[] last_5_years_price_hay;

	private double[] last_5_years_yield_lentils;
	private double[] last_5_years_yield_peas;
	private double[] last_5_years_yield_flax;
	private double[] last_5_years_yield_canola; // the last 5 years of canola
												
	private double[] last_5_years_yield_wheat; // the last 5 years of wheat
	private double[] last_5_years_yield_durum;											
	private double[] last_5_years_yield_barley; // the last 5 years of barley
												
	private double[] last_5_years_yield_hay;

	private double[] expected_price_list; // list weighted price for the
										
	private double[] expected_yield_list; // list yield for the previous 5 years
											
	private double[] last_year_exp_list; // list of the last years expected
											
	private int[] crop_mach_new_value_list; // Value of new machinery options
											

	private double[] reference_margin_crop;
	private double[] reference_margin_calf;
	private double[] reference_margin_energy; 
	private double[] last_2_years_eligible_netsales;

	private double mean_patch_prod;
	private double mean_patch_prod_pasture;
	private double mean_patch_prod_cropland;
	private double pv_annuity_land;
	private double year_20_factor;

	private int farmerOutID;
	private int exitOutID;
	private int transferOutID;
	private int globalOutID;

	private int land_price_driverID = 1;
	private ArrayList lease_bid_list_cropland;
	private ArrayList lease_bid_list_marginalland;
	private ArrayList buy_bid_list_cropland;
	private ArrayList buy_bid_list_marginalland;

	private double mcals_ton_np_early;
	private double mcals_ton_np_late;
	private double mcals_ton_np_fall;

	private double mcals_ton_ip_early;
	private double mcals_ton_ip_late;
	private double mcals_ton_ip_fall;

	private double mcals_ton_hayland_early;
	private double mcals_ton_hayland_late;
	private double mcals_ton_hayland_fall;

	private double mcals_ton_ip_baled_one;
	private double mcals_ton_ip_baled_two;
	private double mcals_ton_hayland_baled_one;
	private double mcals_ton_hayland_baled_two;

	private double mcals_required_early_summer;
	private double mcals_required_late_summer;
	private double mcals_required_fall;
	private double mcals_required_winter;
	private SAMA current_marginal_plot;
	private SAMA current_cropland_plot;

	private static Integer[] cropland_needs; // an array of number of croplands
												// needed by each of the farmers
	private static Integer[] marginalland_needs;
	
	private boolean restartmodel;

	
	public Variables() {
		
		
	

	double FY_year_1 = 0;
	double FY_year_2 = 0;
	double FY_year_3 = 0;
	double FY_year_4 = 0;
	double FY_year_5 = 0;
	double FY_year_6 = 0;
	double FY_year_7 = 0;
	double FY_year_8 = 0;
	double FY_year_9 = 0;
	double FY_year_10 = 0;
	double FY_year_11 = 0;
	double FY_year_12 = 0;
	double FY_year_13 = 0;
	double FY_year_14 = 0;
	double FY_year_15 = 0;
	double FY_year_16 = 0;
	double FY_year_17 = 0;
	double FY_year_18 = 0;
	double FY_year_19 = 0;
	double FY_year_20 = 0;
	double FY_year_21 = 0;
	double FY_year_22 = 0;
	double FY_year_23 = 0;
	double FY_year_24 = 0;
	double FY_year_25 = 0;
	double FY_year_26 = 0;
	double FY_year_27 = 0;
	double FY_year_28 = 0;
	double FY_year_29 = 0;
	double FY_year_30 = 0;
	double FP_year_1 = 0;
	double FP_year_2 = 0;
	double FP_year_3 = 0;
	double FP_year_4 = 0;
	double FP_year_5 = 0;
	double FP_year_6 = 0;
	double FP_year_7 = 0;
	double FP_year_8 = 0;
	double FP_year_9 = 0;
	double FP_year_10 = 0;
	double FP_year_11 = 0;
	double FP_year_12 = 0;
	double FP_year_13 = 0;
	double FP_year_14 = 0;
	double FP_year_15 = 0;
	double FP_year_16 = 0;
	double FP_year_17 = 0;
	double FP_year_18 = 0;
	double FP_year_19 = 0;
	double FP_year_20 = 0;
	double FP_year_21 = 0;
	double FP_year_22 = 0;
	double FP_year_23 = 0;
	double FP_year_24 = 0;
	double FP_year_25 = 0;
	double FP_year_26 = 0;
	double FP_year_27 = 0;
	double FP_year_28 = 0;
	double FP_year_29 = 0;
	double FP_year_30 = 0;

	double WY_year_1 = 0;
	double WY_year_2 = 0;
	double WY_year_3 = 0;
	double WY_year_4 = 0;
	double WY_year_5 = 0;
	double WY_year_6 = 0;
	double WY_year_7 = 0;
	double WY_year_8 = 0;
	double WY_year_9 = 0;
	double WY_year_10 = 0;
	double WY_year_11 = 0;
	double WY_year_12 = 0;
	double WY_year_13 = 0;
	double WY_year_14 = 0;
	double WY_year_15 = 0;
	double WY_year_16 = 0;
	double WY_year_17 = 0;
	double WY_year_18 = 0;
	double WY_year_19 = 0;
	double WY_year_20 = 0;
	double WY_year_21 = 0;
	double WY_year_22 = 0;
	double WY_year_23 = 0;
	double WY_year_24 = 0;
	double WY_year_25 = 0;
	double WY_year_26 = 0;
	double WY_year_27 = 0;
	double WY_year_28 = 0;
	double WY_year_29 = 0;
	double WY_year_30 = 0;
	double WP_year_1 = 0;
	double WP_year_2 = 0;
	double WP_year_3 = 0;
	double WP_year_4 = 0;
	double WP_year_5 = 0;
	double WP_year_6 = 0;
	double WP_year_7 = 0;
	double WP_year_8 = 0;
	double WP_year_9 = 0;
	double WP_year_10 = 0;
	double WP_year_11 = 0;
	double WP_year_12 = 0;
	double WP_year_13 = 0;
	double WP_year_14 = 0;
	double WP_year_15 = 0;
	double WP_year_16 = 0;
	double WP_year_17 = 0;
	double WP_year_18 = 0;
	double WP_year_19 = 0;
	double WP_year_20 = 0;
	double WP_year_21 = 0;
	double WP_year_22 = 0;
	double WP_year_23 = 0;
	double WP_year_24 = 0;
	double WP_year_25 = 0;
	double WP_year_26 = 0;
	double WP_year_27 = 0;
	double WP_year_28 = 0;
	double WP_year_29 = 0;
	double WP_year_30 = 0;

	double DY_year_1 = 0;
	double DY_year_2 = 0;
	double DY_year_3 = 0;
	double DY_year_4 = 0;
	double DY_year_5 = 0;
	double DY_year_6 = 0;
	double DY_year_7 = 0;
	double DY_year_8 = 0;
	double DY_year_9 = 0;
	double DY_year_10 = 0;
	double DY_year_11 = 0;
	double DY_year_12 = 0;
	double DY_year_13 = 0;
	double DY_year_14 = 0;
	double DY_year_15 = 0;
	double DY_year_16 = 0;
	double DY_year_17 = 0;
	double DY_year_18 = 0;
	double DY_year_19 = 0;
	double DY_year_20 = 0;
	double DY_year_21 = 0;
	double DY_year_22 = 0;
	double DY_year_23 = 0;
	double DY_year_24 = 0;
	double DY_year_25 = 0;
	double DY_year_26 = 0;
	double DY_year_27 = 0;
	double DY_year_28 = 0;
	double DY_year_29 = 0;
	double DY_year_30 = 0;
	double DP_year_1 = 0;
	double DP_year_2 = 0;
	double DP_year_3 = 0;
	double DP_year_4 = 0;
	double DP_year_5 = 0;
	double DP_year_6 = 0;
	double DP_year_7 = 0;
	double DP_year_8 = 0;
	double DP_year_9 = 0;
	double DP_year_10 = 0;
	double DP_year_11 = 0;
	double DP_year_12 = 0;
	double DP_year_13 = 0;
	double DP_year_14 = 0;
	double DP_year_15 = 0;
	double DP_year_16 = 0;
	double DP_year_17 = 0;
	double DP_year_18 = 0;
	double DP_year_19 = 0;
	double DP_year_20 = 0;
	double DP_year_21 = 0;
	double DP_year_22 = 0;
	double DP_year_23 = 0;
	double DP_year_24 = 0;
	double DP_year_25 = 0;
	double DP_year_26 = 0;
	double DP_year_27 = 0;
	double DP_year_28 = 0;
	double DP_year_29 = 0;
	double DP_year_30 = 0;
	
	double CY_year_1 = 0;
	double CY_year_2 = 0;
	double CY_year_3 = 0;
	double CY_year_4 = 0;
	double CY_year_5 = 0;
	double CY_year_6 = 0;
	double CY_year_7 = 0;
	double CY_year_8 = 0;
	double CY_year_9 = 0;
	double CY_year_10 = 0;
	double CY_year_11 = 0;
	double CY_year_12 = 0;
	double CY_year_13 = 0;
	double CY_year_14 = 0;
	double CY_year_15 = 0;
	double CY_year_16 = 0;
	double CY_year_17 = 0;
	double CY_year_18 = 0;
	double CY_year_19 = 0;
	double CY_year_20 = 0;
	double CY_year_21 = 0;
	double CY_year_22 = 0;
	double CY_year_23 = 0;
	double CY_year_24 = 0;
	double CY_year_25 = 0;
	double CY_year_26 = 0;
	double CY_year_27 = 0;
	double CY_year_28 = 0;
	double CY_year_29 = 0;
	double CY_year_30 = 0;
	double CP_year_1 = 0;
	double CP_year_2 = 0;
	double CP_year_3 = 0;
	double CP_year_4 = 0;
	double CP_year_5 = 0;
	double CP_year_6 = 0;
	double CP_year_7 = 0;
	double CP_year_8 = 0;
	double CP_year_9 = 0;
	double CP_year_10 = 0;
	double CP_year_11 = 0;
	double CP_year_12 = 0;
	double CP_year_13 = 0;
	double CP_year_14 = 0;
	double CP_year_15 = 0;
	double CP_year_16 = 0;
	double CP_year_17 = 0;
	double CP_year_18 = 0;
	double CP_year_19 = 0;
	double CP_year_20 = 0;
	double CP_year_21 = 0;
	double CP_year_22 = 0;
	double CP_year_23 = 0;
	double CP_year_24 = 0;
	double CP_year_25 = 0;
	double CP_year_26 = 0;
	double CP_year_27 = 0;
	double CP_year_28 = 0;
	double CP_year_29 = 0;
	double CP_year_30 = 0;

	double BY_year_1 = 0;
	double BY_year_2 = 0;
	double BY_year_3 = 0;
	double BY_year_4 = 0;
	double BY_year_5 = 0;
	double BY_year_6 = 0;
	double BY_year_7 = 0;
	double BY_year_8 = 0;
	double BY_year_9 = 0;
	double BY_year_10 = 0;
	double BY_year_11 = 0;
	double BY_year_12 = 0;
	double BY_year_13 = 0;
	double BY_year_14 = 0;
	double BY_year_15 = 0;
	double BY_year_16 = 0;
	double BY_year_17 = 0;
	double BY_year_18 = 0;
	double BY_year_19 = 0;
	double BY_year_20 = 0;
	double BY_year_21 = 0;
	double BY_year_22 = 0;
	double BY_year_23 = 0;
	double BY_year_24 = 0;
	double BY_year_25 = 0;
	double BY_year_26 = 0;
	double BY_year_27 = 0;
	double BY_year_28 = 0;
	double BY_year_29 = 0;
	double BY_year_30 = 0;
	double BP_year_1 = 0;
	double BP_year_2 = 0;
	double BP_year_3 = 0;
	double BP_year_4 = 0;
	double BP_year_5 = 0;
	double BP_year_6 = 0;
	double BP_year_7 = 0;
	double BP_year_8 = 0;
	double BP_year_9 = 0;
	double BP_year_10 = 0;
	double BP_year_11 = 0;
	double BP_year_12 = 0;
	double BP_year_13 = 0;
	double BP_year_14 = 0;
	double BP_year_15 = 0;
	double BP_year_16 = 0;
	double BP_year_17 = 0;
	double BP_year_18 = 0;
	double BP_year_19 = 0;
	double BP_year_20 = 0;
	double BP_year_21 = 0;
	double BP_year_22 = 0;
	double BP_year_23 = 0;
	double BP_year_24 = 0;
	double BP_year_25 = 0;
	double BP_year_26 = 0;
	double BP_year_27 = 0;
	double BP_year_28 = 0;
	double BP_year_29 = 0;
	double BP_year_30 = 0;

	double PY_year_1 = 0;
	double PY_year_2 = 0;
	double PY_year_3 = 0;
	double PY_year_4 = 0;
	double PY_year_5 = 0;
	double PY_year_6 = 0;
	double PY_year_7 = 0;
	double PY_year_8 = 0;
	double PY_year_9 = 0;
	double PY_year_10 = 0;
	double PY_year_11 = 0;
	double PY_year_12 = 0;
	double PY_year_13 = 0;
	double PY_year_14 = 0;
	double PY_year_15 = 0;
	double PY_year_16 = 0;
	double PY_year_17 = 0;
	double PY_year_18 = 0;
	double PY_year_19 = 0;
	double PY_year_20 = 0;
	double PY_year_21 = 0;
	double PY_year_22 = 0;
	double PY_year_23 = 0;
	double PY_year_24 = 0;
	double PY_year_25 = 0;
	double PY_year_26 = 0;
	double PY_year_27 = 0;
	double PY_year_28 = 0;
	double PY_year_29 = 0;
	double PY_year_30 = 0;
	double PP_year_1 = 0;
	double PP_year_2 = 0;
	double PP_year_3 = 0;
	double PP_year_4 = 0;
	double PP_year_5 = 0;
	double PP_year_6 = 0;
	double PP_year_7 = 0;
	double PP_year_8 = 0;
	double PP_year_9 = 0;
	double PP_year_10 = 0;
	double PP_year_11 = 0;
	double PP_year_12 = 0;
	double PP_year_13 = 0;
	double PP_year_14 = 0;
	double PP_year_15 = 0;
	double PP_year_16 = 0;
	double PP_year_17 = 0;
	double PP_year_18 = 0;
	double PP_year_19 = 0;
	double PP_year_20 = 0;
	double PP_year_21 = 0;
	double PP_year_22 = 0;
	double PP_year_23 = 0;
	double PP_year_24 = 0;
	double PP_year_25 = 0;
	double PP_year_26 = 0;
	double PP_year_27 = 0;
	double PP_year_28 = 0;
	double PP_year_29 = 0;
	double PP_year_30 = 0;

	double LY_year_1 = 0;
	double LY_year_2 = 0;
	double LY_year_3 = 0;
	double LY_year_4 = 0;
	double LY_year_5 = 0;
	double LY_year_6 = 0;
	double LY_year_7 = 0;
	double LY_year_8 = 0;
	double LY_year_9 = 0;
	double LY_year_10 = 0;
	double LY_year_11 = 0;
	double LY_year_12 = 0;
	double LY_year_13 = 0;
	double LY_year_14 = 0;
	double LY_year_15 = 0;
	double LY_year_16 = 0;
	double LY_year_17 = 0;
	double LY_year_18 = 0;
	double LY_year_19 = 0;
	double LY_year_20 = 0;
	double LY_year_21 = 0;
	double LY_year_22 = 0;
	double LY_year_23 = 0;
	double LY_year_24 = 0;
	double LY_year_25 = 0;
	double LY_year_26 = 0;
	double LY_year_27 = 0;
	double LY_year_28 = 0;
	double LY_year_29 = 0;
	double LY_year_30 = 0;
	double LP_year_1 = 0;
	double LP_year_2 = 0;
	double LP_year_3 = 0;
	double LP_year_4 = 0;
	double LP_year_5 = 0;
	double LP_year_6 = 0;
	double LP_year_7 = 0;
	double LP_year_8 = 0;
	double LP_year_9 = 0;
	double LP_year_10 = 0;
	double LP_year_11 = 0;
	double LP_year_12 = 0;
	double LP_year_13 = 0;
	double LP_year_14 = 0;
	double LP_year_15 = 0;
	double LP_year_16 = 0;
	double LP_year_17 = 0;
	double LP_year_18 = 0;
	double LP_year_19 = 0;
	double LP_year_20 = 0;
	double LP_year_21 = 0;
	double LP_year_22 = 0;
	double LP_year_23 = 0;
	double LP_year_24 = 0;
	double LP_year_25 = 0;
	double LP_year_26 = 0;
	double LP_year_27 = 0;
	double LP_year_28 = 0;
	double LP_year_29 = 0;
	double LP_year_30 = 0;

	double CalfP_year_1 = 0;
	double CalfP_year_2 = 0;
	double CalfP_year_3 = 0;
	double CalfP_year_4 = 0;
	double CalfP_year_5 = 0;
	double CalfP_year_6 = 0;
	double CalfP_year_7 = 0;
	double CalfP_year_8 = 0;
	double CalfP_year_9 = 0;
	double CalfP_year_10 = 0;
	double CalfP_year_11 = 0;
	double CalfP_year_12 = 0;
	double CalfP_year_13 = 0;
	double CalfP_year_14 = 0;
	double CalfP_year_15 = 0;
	double CalfP_year_16 = 0;
	double CalfP_year_17 = 0;
	double CalfP_year_18 = 0;
	double CalfP_year_19 = 0;
	double CalfP_year_20 = 0;
	double CalfP_year_21 = 0;
	double CalfP_year_22 = 0;
	double CalfP_year_23 = 0;
	double CalfP_year_24 = 0;
	double CalfP_year_25 = 0;
	double CalfP_year_26 = 0;
	double CalfP_year_27 = 0;
	double CalfP_year_28 = 0;
	double CalfP_year_29 = 0;
	double CalfP_year_30 = 0;

	double HayY_year_1 = 0;
	double HayY_year_2 = 0;
	double HayY_year_3 = 0;
	double HayY_year_4 = 0;
	double HayY_year_5 = 0;
	double HayY_year_6 = 0;
	double HayY_year_7 = 0;
	double HayY_year_8 = 0;
	double HayY_year_9 = 0;
	double HayY_year_10 = 0;
	double HayY_year_11 = 0;
	double HayY_year_12 = 0;
	double HayY_year_13 = 0;
	double HayY_year_14 = 0;
	double HayY_year_15 = 0;
	double HayY_year_16 = 0;
	double HayY_year_17 = 0;
	double HayY_year_18 = 0;
	double HayY_year_19 = 0;
	double HayY_year_20 = 0;
	double HayY_year_21 = 0;
	double HayY_year_22 = 0;
	double HayY_year_23 = 0;
	double HayY_year_24 = 0;
	double HayY_year_25 = 0;
	double HayY_year_26 = 0;
	double HayY_year_27 = 0;
	double HayY_year_28 = 0;
	double HayY_year_29 = 0;
	double HayY_year_30 = 0;
	double HayP_year_1 = 0;
	double HayP_year_2 = 0;
	double HayP_year_3 = 0;
	double HayP_year_4 = 0;
	double HayP_year_5 = 0;
	double HayP_year_6 = 0;
	double HayP_year_7 = 0;
	double HayP_year_8 = 0;
	double HayP_year_9 = 0;
	double HayP_year_10 = 0;
	double HayP_year_11 = 0;
	double HayP_year_12 = 0;
	double HayP_year_13 = 0;
	double HayP_year_14 = 0;
	double HayP_year_15 = 0;
	double HayP_year_16 = 0;
	double HayP_year_17 = 0;
	double HayP_year_18 = 0;
	double HayP_year_19 = 0;
	double HayP_year_20 = 0;
	double HayP_year_21 = 0;
	double HayP_year_22 = 0;
	double HayP_year_23 = 0;
	double HayP_year_24 = 0;
	double HayP_year_25 = 0;
	double HayP_year_26 = 0;
	double HayP_year_27 = 0;
	double HayP_year_28 = 0;
	double HayP_year_29 = 0;
	double HayP_year_30 = 0;

	try {
		Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
	} catch (ClassNotFoundException ce) {

	}

	try {
		Connection conn = DriverManager.getConnection(
				"jdbc:odbc:producerDB", "java", "1234");
		Statement stmt = conn.createStatement();
		ResultSet rs = stmt
				.executeQuery("select * from FlaxYield where Run = "
						+ Variables.getinitial_run_number());
		while (rs.next()) {
			
			FY_year_1 = rs.getDouble("1");
			FY_year_2 = rs.getDouble("2");
			FY_year_3 = rs.getDouble("3");
			FY_year_4 = rs.getDouble("4");
			FY_year_5 = rs.getDouble("5");
			FY_year_6 = rs.getDouble("6");
			FY_year_7 = rs.getDouble("7");
			FY_year_8 = rs.getDouble("8");
			FY_year_9 = rs.getDouble("9");
			FY_year_10 = rs.getDouble("10");
			FY_year_11 = rs.getDouble("11");
			FY_year_12 = rs.getDouble("12");
			FY_year_13 = rs.getDouble("13");
			FY_year_14 = rs.getDouble("14");
			FY_year_15 = rs.getDouble("15");
			FY_year_16 = rs.getDouble("16");
			FY_year_17 = rs.getDouble("17");
			FY_year_18 = rs.getDouble("18");
			FY_year_19 = rs.getDouble("19");
			FY_year_20 = rs.getDouble("20");
			FY_year_21 = rs.getDouble("21");
			FY_year_22 = rs.getDouble("22");
			FY_year_23 = rs.getDouble("23");
			FY_year_24 = rs.getDouble("24");
			FY_year_25 = rs.getDouble("25");
			FY_year_26 = rs.getDouble("26");
			FY_year_27 = rs.getDouble("27");
			FY_year_28 = rs.getDouble("28");
			FY_year_29 = rs.getDouble("29");
			FY_year_30 = rs.getDouble("30");

			//System.out.println("FY YEAR 30" + FY_year_30);
			
		}
		rs.close();
		stmt.close();
		conn.close();
	} catch (SQLException ce) {
		System.out.println("SQLException PeasYIELD" + ce.getMessage());
	}

	try {
		Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
	} catch (ClassNotFoundException ce) {

	}

	try {
		Connection conn = DriverManager.getConnection(
				"jdbc:odbc:producerDB", "java", "1234");
		Statement stmt = conn.createStatement();
		ResultSet rs = stmt
				.executeQuery("select * from FlaxPrice where Run = "
						+ Variables.getinitial_run_number());
		while (rs.next()) {
			FP_year_1 = rs.getDouble("1");
			FP_year_2 = rs.getDouble("2");
			FP_year_3 = rs.getDouble("3");
			FP_year_4 = rs.getDouble("4");
			FP_year_5 = rs.getDouble("5");
			FP_year_6 = rs.getDouble("6");
			FP_year_7 = rs.getDouble("7");
			FP_year_8 = rs.getDouble("8");
			FP_year_9 = rs.getDouble("9");
			FP_year_10 = rs.getDouble("10");
			FP_year_11 = rs.getDouble("11");
			FP_year_12 = rs.getDouble("12");
			FP_year_13 = rs.getDouble("13");
			FP_year_14 = rs.getDouble("14");
			FP_year_15 = rs.getDouble("15");
			FP_year_16 = rs.getDouble("16");
			FP_year_17 = rs.getDouble("17");
			FP_year_18 = rs.getDouble("18");
			FP_year_19 = rs.getDouble("19");
			FP_year_20 = rs.getDouble("20");
			FP_year_21 = rs.getDouble("21");
			FP_year_22 = rs.getDouble("22");
			FP_year_23 = rs.getDouble("23");
			FP_year_24 = rs.getDouble("24");
			FP_year_25 = rs.getDouble("25");
			FP_year_26 = rs.getDouble("26");
			FP_year_27 = rs.getDouble("27");
			FP_year_28 = rs.getDouble("28");
			FP_year_29 = rs.getDouble("29");
			FP_year_30 = rs.getDouble("30");

		}
		rs.close();
		stmt.close();
		conn.close();
	} catch (SQLException ce) {
		System.out.println("SQLException FlaxPrices" + ce.getMessage());
	}

	try {
		Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
	} catch (ClassNotFoundException ce) {

	}

	try {
		Connection conn = DriverManager.getConnection(
				"jdbc:odbc:producerDB", "java", "1234");
		Statement stmt = conn.createStatement();
		ResultSet rs = stmt
				.executeQuery("select * from WheatYield where Run = "
						+ Variables.getinitial_run_number());
		while (rs.next()) {
			WY_year_1 = rs.getDouble("1");
			WY_year_2 = rs.getDouble("2");
			WY_year_3 = rs.getDouble("3");
			WY_year_4 = rs.getDouble("4");
			WY_year_5 = rs.getDouble("5");
			WY_year_6 = rs.getDouble("6");
			WY_year_7 = rs.getDouble("7");
			WY_year_8 = rs.getDouble("8");
			WY_year_9 = rs.getDouble("9");
			WY_year_10 = rs.getDouble("10");
			WY_year_11 = rs.getDouble("11");
			WY_year_12 = rs.getDouble("12");
			WY_year_13 = rs.getDouble("13");
			WY_year_14 = rs.getDouble("14");
			WY_year_15 = rs.getDouble("15");
			WY_year_16 = rs.getDouble("16");
			WY_year_17 = rs.getDouble("17");
			WY_year_18 = rs.getDouble("18");
			WY_year_19 = rs.getDouble("19");
			WY_year_20 = rs.getDouble("20");
			WY_year_21 = rs.getDouble("21");
			WY_year_22 = rs.getDouble("22");
			WY_year_23 = rs.getDouble("23");
			WY_year_24 = rs.getDouble("24");
			WY_year_25 = rs.getDouble("25");
			WY_year_26 = rs.getDouble("26");
			WY_year_27 = rs.getDouble("27");
			WY_year_28 = rs.getDouble("28");
			WY_year_29 = rs.getDouble("29");
			WY_year_30 = rs.getDouble("30");

		}
		rs.close();
		stmt.close();
		conn.close();
	} catch (SQLException ce) {
		System.out.println("SQLException WheatYIELD" + ce.getMessage());
	}

	try {
		Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
	} catch (ClassNotFoundException ce) {

	}

	try {
		Connection conn = DriverManager.getConnection(
				"jdbc:odbc:producerDB", "java", "1234");
		Statement stmt = conn.createStatement();
		ResultSet rs = stmt
				.executeQuery("select * from WheatPrice where Run = "
						+ Variables.getinitial_run_number());
		while (rs.next()) {
			WP_year_1 = rs.getDouble("1");
			WP_year_2 = rs.getDouble("2");
			WP_year_3 = rs.getDouble("3");
			WP_year_4 = rs.getDouble("4");
			WP_year_5 = rs.getDouble("5");
			WP_year_6 = rs.getDouble("6");
			WP_year_7 = rs.getDouble("7");
			WP_year_8 = rs.getDouble("8");
			WP_year_9 = rs.getDouble("9");
			WP_year_10 = rs.getDouble("10");
			WP_year_11 = rs.getDouble("11");
			WP_year_12 = rs.getDouble("12");
			WP_year_13 = rs.getDouble("13");
			WP_year_14 = rs.getDouble("14");
			WP_year_15 = rs.getDouble("15");
			WP_year_16 = rs.getDouble("16");
			WP_year_17 = rs.getDouble("17");
			WP_year_18 = rs.getDouble("18");
			WP_year_19 = rs.getDouble("19");
			WP_year_20 = rs.getDouble("20");
			WP_year_21 = rs.getDouble("21");
			WP_year_22 = rs.getDouble("22");
			WP_year_23 = rs.getDouble("23");
			WP_year_24 = rs.getDouble("24");
			WP_year_25 = rs.getDouble("25");
			WP_year_26 = rs.getDouble("26");
			WP_year_27 = rs.getDouble("27");
			WP_year_28 = rs.getDouble("28");
			WP_year_29 = rs.getDouble("29");
			WP_year_30 = rs.getDouble("30");

		}
		rs.close();
		stmt.close();
		conn.close();
	} catch (SQLException ce) {
		System.out.println("SQLException WheatPrices" + ce.getMessage());
	}

	
	
	try {
		Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
	} catch (ClassNotFoundException ce) {

	}

	try {
		Connection conn = DriverManager.getConnection(
				"jdbc:odbc:producerDB", "java", "1234");
		Statement stmt = conn.createStatement();
		ResultSet rs = stmt
				.executeQuery("select * from DurumYield where Run = "
						+ Variables.getinitial_run_number());
		while (rs.next()) {
			DY_year_1 = rs.getDouble("1");
			DY_year_2 = rs.getDouble("2");
			DY_year_3 = rs.getDouble("3");
			DY_year_4 = rs.getDouble("4");
			DY_year_5 = rs.getDouble("5");
			DY_year_6 = rs.getDouble("6");
			DY_year_7 = rs.getDouble("7");
			DY_year_8 = rs.getDouble("8");
			DY_year_9 = rs.getDouble("9");
			DY_year_10 = rs.getDouble("10");
			DY_year_11 = rs.getDouble("11");
			DY_year_12 = rs.getDouble("12");
			DY_year_13 = rs.getDouble("13");
			DY_year_14 = rs.getDouble("14");
			DY_year_15 = rs.getDouble("15");
			DY_year_16 = rs.getDouble("16");
			DY_year_17 = rs.getDouble("17");
			DY_year_18 = rs.getDouble("18");
			DY_year_19 = rs.getDouble("19");
			DY_year_20 = rs.getDouble("20");
			DY_year_21 = rs.getDouble("21");
			DY_year_22 = rs.getDouble("22");
			DY_year_23 = rs.getDouble("23");
			DY_year_24 = rs.getDouble("24");
			DY_year_25 = rs.getDouble("25");
			DY_year_26 = rs.getDouble("26");
			DY_year_27 = rs.getDouble("27");
			DY_year_28 = rs.getDouble("28");
			DY_year_29 = rs.getDouble("29");
			DY_year_30 = rs.getDouble("30");

		}
		rs.close();
		stmt.close();
		conn.close();
	} catch (SQLException ce) {
		System.out.println("SQLException DurumYIELD" + ce.getMessage());
	}

	try {
		Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
	} catch (ClassNotFoundException ce) {

	}

	try {
		Connection conn = DriverManager.getConnection(
				"jdbc:odbc:producerDB", "java", "1234");
		Statement stmt = conn.createStatement();
		ResultSet rs = stmt
				.executeQuery("select * from DurumPrice where Run = "
						+ Variables.getinitial_run_number());
		while (rs.next()) {
			DP_year_1 = rs.getDouble("1");
			DP_year_2 = rs.getDouble("2");
			DP_year_3 = rs.getDouble("3");
			DP_year_4 = rs.getDouble("4");
			DP_year_5 = rs.getDouble("5");
			DP_year_6 = rs.getDouble("6");
			DP_year_7 = rs.getDouble("7");
			DP_year_8 = rs.getDouble("8");
			DP_year_9 = rs.getDouble("9");
			DP_year_10 = rs.getDouble("10");
			DP_year_11 = rs.getDouble("11");
			DP_year_12 = rs.getDouble("12");
			DP_year_13 = rs.getDouble("13");
			DP_year_14 = rs.getDouble("14");
			DP_year_15 = rs.getDouble("15");
			DP_year_16 = rs.getDouble("16");
			DP_year_17 = rs.getDouble("17");
			DP_year_18 = rs.getDouble("18");
			DP_year_19 = rs.getDouble("19");
			DP_year_20 = rs.getDouble("20");
			DP_year_21 = rs.getDouble("21");
			DP_year_22 = rs.getDouble("22");
			DP_year_23 = rs.getDouble("23");
			DP_year_24 = rs.getDouble("24");
			DP_year_25 = rs.getDouble("25");
			DP_year_26 = rs.getDouble("26");
			DP_year_27 = rs.getDouble("27");
			DP_year_28 = rs.getDouble("28");
			DP_year_29 = rs.getDouble("29");
			DP_year_30 = rs.getDouble("30");

		}
		rs.close();
		stmt.close();
		conn.close();
	} catch (SQLException ce) {
		System.out.println("SQLException DurumPrices" + ce.getMessage());
	}
	
	
	
	try {
		Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
	} catch (ClassNotFoundException ce) {

	}

	try {
		Connection conn = DriverManager.getConnection(
				"jdbc:odbc:producerDB", "java", "1234");
		Statement stmt = conn.createStatement();
		ResultSet rs = stmt
				.executeQuery("select * from CanolaYield where Run = "
						+ Variables.getinitial_run_number());
		while (rs.next()) {
			CY_year_1 = rs.getDouble("1");
			CY_year_2 = rs.getDouble("2");
			CY_year_3 = rs.getDouble("3");
			CY_year_4 = rs.getDouble("4");
			CY_year_5 = rs.getDouble("5");
			CY_year_6 = rs.getDouble("6");
			CY_year_7 = rs.getDouble("7");
			CY_year_8 = rs.getDouble("8");
			CY_year_9 = rs.getDouble("9");
			CY_year_10 = rs.getDouble("10");
			CY_year_11 = rs.getDouble("11");
			CY_year_12 = rs.getDouble("12");
			CY_year_13 = rs.getDouble("13");
			CY_year_14 = rs.getDouble("14");
			CY_year_15 = rs.getDouble("15");
			CY_year_16 = rs.getDouble("16");
			CY_year_17 = rs.getDouble("17");
			CY_year_18 = rs.getDouble("18");
			CY_year_19 = rs.getDouble("19");
			CY_year_20 = rs.getDouble("20");
			CY_year_21 = rs.getDouble("21");
			CY_year_22 = rs.getDouble("22");
			CY_year_23 = rs.getDouble("23");
			CY_year_24 = rs.getDouble("24");
			CY_year_25 = rs.getDouble("25");
			CY_year_26 = rs.getDouble("26");
			CY_year_27 = rs.getDouble("27");
			CY_year_28 = rs.getDouble("28");
			CY_year_29 = rs.getDouble("29");
			CY_year_30 = rs.getDouble("30");

		}
		rs.close();
		stmt.close();
		conn.close();
	} catch (SQLException ce) {
		System.out.println("SQLException CanolaYIELD" + ce.getMessage());
	}

	try {
		Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
	} catch (ClassNotFoundException ce) {

	}

	try {
		Connection conn = DriverManager.getConnection(
				"jdbc:odbc:producerDB", "java", "1234");
		Statement stmt = conn.createStatement();
		ResultSet rs = stmt
				.executeQuery("select * from CanolaPrice where Run = "
						+ Variables.getinitial_run_number());
		while (rs.next()) {
			CP_year_1 = rs.getDouble("1");
			CP_year_2 = rs.getDouble("2");
			CP_year_3 = rs.getDouble("3");
			CP_year_4 = rs.getDouble("4");
			CP_year_5 = rs.getDouble("5");
			CP_year_6 = rs.getDouble("6");
			CP_year_7 = rs.getDouble("7");
			CP_year_8 = rs.getDouble("8");
			CP_year_9 = rs.getDouble("9");
			CP_year_10 = rs.getDouble("10");
			CP_year_11 = rs.getDouble("11");
			CP_year_12 = rs.getDouble("12");
			CP_year_13 = rs.getDouble("13");
			CP_year_14 = rs.getDouble("14");
			CP_year_15 = rs.getDouble("15");
			CP_year_16 = rs.getDouble("16");
			CP_year_17 = rs.getDouble("17");
			CP_year_18 = rs.getDouble("18");
			CP_year_19 = rs.getDouble("19");
			CP_year_20 = rs.getDouble("20");
			CP_year_21 = rs.getDouble("21");
			CP_year_22 = rs.getDouble("22");
			CP_year_23 = rs.getDouble("23");
			CP_year_24 = rs.getDouble("24");
			CP_year_25 = rs.getDouble("25");
			CP_year_26 = rs.getDouble("26");
			CP_year_27 = rs.getDouble("27");
			CP_year_28 = rs.getDouble("28");
			CP_year_29 = rs.getDouble("29");
			CP_year_30 = rs.getDouble("30");

		}
		rs.close();
		stmt.close();
		conn.close();
	} catch (SQLException ce) {
		System.out.println("SQLException CanolaPrices" + ce.getMessage());
	}

	try {
		Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
	} catch (ClassNotFoundException ce) {

	}

	try {
		Connection conn = DriverManager.getConnection(
				"jdbc:odbc:producerDB", "java", "1234");
		Statement stmt = conn.createStatement();
		ResultSet rs = stmt
				.executeQuery("select * from BarleyYield where Run = "
						+ Variables.getinitial_run_number());
		while (rs.next()) {
			BY_year_1 = rs.getDouble("1");
			BY_year_2 = rs.getDouble("2");
			BY_year_3 = rs.getDouble("3");
			BY_year_4 = rs.getDouble("4");
			BY_year_5 = rs.getDouble("5");
			BY_year_6 = rs.getDouble("6");
			BY_year_7 = rs.getDouble("7");
			BY_year_8 = rs.getDouble("8");
			BY_year_9 = rs.getDouble("9");
			BY_year_10 = rs.getDouble("10");
			BY_year_11 = rs.getDouble("11");
			BY_year_12 = rs.getDouble("12");
			BY_year_13 = rs.getDouble("13");
			BY_year_14 = rs.getDouble("14");
			BY_year_15 = rs.getDouble("15");
			BY_year_16 = rs.getDouble("16");
			BY_year_17 = rs.getDouble("17");
			BY_year_18 = rs.getDouble("18");
			BY_year_19 = rs.getDouble("19");
			BY_year_20 = rs.getDouble("20");
			BY_year_21 = rs.getDouble("21");
			BY_year_22 = rs.getDouble("22");
			BY_year_23 = rs.getDouble("23");
			BY_year_24 = rs.getDouble("24");
			BY_year_25 = rs.getDouble("25");
			BY_year_26 = rs.getDouble("26");
			BY_year_27 = rs.getDouble("27");
			BY_year_28 = rs.getDouble("28");
			BY_year_29 = rs.getDouble("29");
			BY_year_30 = rs.getDouble("30");

		}
		rs.close();
		stmt.close();
		conn.close();
	} catch (SQLException ce) {
		System.out.println("SQLException BarleyYIELD" + ce.getMessage());
	}

	try {
		Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
	} catch (ClassNotFoundException ce) {

	}

	try {
		Connection conn = DriverManager.getConnection(
				"jdbc:odbc:producerDB", "java", "1234");
		Statement stmt = conn.createStatement();
		ResultSet rs = stmt
				.executeQuery("select * from BarleyPrice where Run = "
						+ Variables.getinitial_run_number());
		while (rs.next()) {
			BP_year_1 = rs.getDouble("1");
			BP_year_2 = rs.getDouble("2");
			BP_year_3 = rs.getDouble("3");
			BP_year_4 = rs.getDouble("4");
			BP_year_5 = rs.getDouble("5");
			BP_year_6 = rs.getDouble("6");
			BP_year_7 = rs.getDouble("7");
			BP_year_8 = rs.getDouble("8");
			BP_year_9 = rs.getDouble("9");
			BP_year_10 = rs.getDouble("10");
			BP_year_11 = rs.getDouble("11");
			BP_year_12 = rs.getDouble("12");
			BP_year_13 = rs.getDouble("13");
			BP_year_14 = rs.getDouble("14");
			BP_year_15 = rs.getDouble("15");
			BP_year_16 = rs.getDouble("16");
			BP_year_17 = rs.getDouble("17");
			BP_year_18 = rs.getDouble("18");
			BP_year_19 = rs.getDouble("19");
			BP_year_20 = rs.getDouble("20");
			BP_year_21 = rs.getDouble("21");
			BP_year_22 = rs.getDouble("22");
			BP_year_23 = rs.getDouble("23");
			BP_year_24 = rs.getDouble("24");
			BP_year_25 = rs.getDouble("25");
			BP_year_26 = rs.getDouble("26");
			BP_year_27 = rs.getDouble("27");
			BP_year_28 = rs.getDouble("28");
			BP_year_29 = rs.getDouble("29");
			BP_year_30 = rs.getDouble("30");

		}
		rs.close();
		stmt.close();
		conn.close();
	} catch (SQLException ce) {
		System.out.println("SQLException CanolaPrices" + ce.getMessage());
	}

	try {
		Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
	} catch (ClassNotFoundException ce) {

	}

	try {
		Connection conn = DriverManager.getConnection(
				"jdbc:odbc:producerDB", "java", "1234");
		Statement stmt = conn.createStatement();
		ResultSet rs = stmt
				.executeQuery("select * from PeasYield where Run = "
						+ Variables.getinitial_run_number());
		while (rs.next()) {
			PY_year_1 = rs.getDouble("1");
			PY_year_2 = rs.getDouble("2");
			PY_year_3 = rs.getDouble("3");
			PY_year_4 = rs.getDouble("4");
			PY_year_5 = rs.getDouble("5");
			PY_year_6 = rs.getDouble("6");
			PY_year_7 = rs.getDouble("7");
			PY_year_8 = rs.getDouble("8");
			PY_year_9 = rs.getDouble("9");
			PY_year_10 = rs.getDouble("10");
			PY_year_11 = rs.getDouble("11");
			PY_year_12 = rs.getDouble("12");
			PY_year_13 = rs.getDouble("13");
			PY_year_14 = rs.getDouble("14");
			PY_year_15 = rs.getDouble("15");
			PY_year_16 = rs.getDouble("16");
			PY_year_17 = rs.getDouble("17");
			PY_year_18 = rs.getDouble("18");
			PY_year_19 = rs.getDouble("19");
			PY_year_20 = rs.getDouble("20");
			PY_year_21 = rs.getDouble("21");
			PY_year_22 = rs.getDouble("22");
			PY_year_23 = rs.getDouble("23");
			PY_year_24 = rs.getDouble("24");
			PY_year_25 = rs.getDouble("25");
			PY_year_26 = rs.getDouble("26");
			PY_year_27 = rs.getDouble("27");
			PY_year_28 = rs.getDouble("28");
			PY_year_29 = rs.getDouble("29");
			PY_year_30 = rs.getDouble("30");

		}
		rs.close();
		stmt.close();
		conn.close();
	} catch (SQLException ce) {
		System.out.println("SQLException PeasYIELD" + ce.getMessage());
	}

	try {
		Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
	} catch (ClassNotFoundException ce) {

	}

	try {
		Connection conn = DriverManager.getConnection(
				"jdbc:odbc:producerDB", "java", "1234");
		Statement stmt = conn.createStatement();
		ResultSet rs = stmt
				.executeQuery("select * from PeasPrice where Run = "
						+ Variables.getinitial_run_number());
		while (rs.next()) {
			PP_year_1 = rs.getDouble("1");
			PP_year_2 = rs.getDouble("2");
			PP_year_3 = rs.getDouble("3");
			PP_year_4 = rs.getDouble("4");
			PP_year_5 = rs.getDouble("5");
			PP_year_6 = rs.getDouble("6");
			PP_year_7 = rs.getDouble("7");
			PP_year_8 = rs.getDouble("8");
			PP_year_9 = rs.getDouble("9");
			PP_year_10 = rs.getDouble("10");
			PP_year_11 = rs.getDouble("11");
			PP_year_12 = rs.getDouble("12");
			PP_year_13 = rs.getDouble("13");
			PP_year_14 = rs.getDouble("14");
			PP_year_15 = rs.getDouble("15");
			PP_year_16 = rs.getDouble("16");
			PP_year_17 = rs.getDouble("17");
			PP_year_18 = rs.getDouble("18");
			PP_year_19 = rs.getDouble("19");
			PP_year_20 = rs.getDouble("20");
			PP_year_21 = rs.getDouble("21");
			PP_year_22 = rs.getDouble("22");
			PP_year_23 = rs.getDouble("23");
			PP_year_24 = rs.getDouble("24");
			PP_year_25 = rs.getDouble("25");
			PP_year_26 = rs.getDouble("26");
			PP_year_27 = rs.getDouble("27");
			PP_year_28 = rs.getDouble("28");
			PP_year_29 = rs.getDouble("29");
			PP_year_30 = rs.getDouble("30");

		}
		rs.close();
		stmt.close();
		conn.close();
	} catch (SQLException ce) {
		System.out.println("SQLException PeasPrices" + ce.getMessage());
	}

	try {
		Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
	} catch (ClassNotFoundException ce) {

	}

	try {
		Connection conn = DriverManager.getConnection(
				"jdbc:odbc:producerDB", "java", "1234");
		Statement stmt = conn.createStatement();
		ResultSet rs = stmt
				.executeQuery("select * from LentilsYield where Run = "
						+ Variables.getinitial_run_number());
		while (rs.next()) {
			LY_year_1 = rs.getDouble("1");
			LY_year_2 = rs.getDouble("2");
			LY_year_3 = rs.getDouble("3");
			LY_year_4 = rs.getDouble("4");
			LY_year_5 = rs.getDouble("5");
			LY_year_6 = rs.getDouble("6");
			LY_year_7 = rs.getDouble("7");
			LY_year_8 = rs.getDouble("8");
			LY_year_9 = rs.getDouble("9");
			LY_year_10 = rs.getDouble("10");
			LY_year_11 = rs.getDouble("11");
			LY_year_12 = rs.getDouble("12");
			LY_year_13 = rs.getDouble("13");
			LY_year_14 = rs.getDouble("14");
			LY_year_15 = rs.getDouble("15");
			LY_year_16 = rs.getDouble("16");
			LY_year_17 = rs.getDouble("17");
			LY_year_18 = rs.getDouble("18");
			LY_year_19 = rs.getDouble("19");
			LY_year_20 = rs.getDouble("20");
			LY_year_21 = rs.getDouble("21");
			LY_year_22 = rs.getDouble("22");
			LY_year_23 = rs.getDouble("23");
			LY_year_24 = rs.getDouble("24");
			LY_year_25 = rs.getDouble("25");
			LY_year_26 = rs.getDouble("26");
			LY_year_27 = rs.getDouble("27");
			LY_year_28 = rs.getDouble("28");
			LY_year_29 = rs.getDouble("29");
			LY_year_30 = rs.getDouble("30");

		}
		rs.close();
		stmt.close();
		conn.close();
	} catch (SQLException ce) {
		System.out.println("SQLException LentilsYIELD" + ce.getMessage());
	}

	try {
		Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
	} catch (ClassNotFoundException ce) {

	}

	try {
		Connection conn = DriverManager.getConnection(
				"jdbc:odbc:producerDB", "java", "1234");
		Statement stmt = conn.createStatement();
		ResultSet rs = stmt
				.executeQuery("select * from LentilsPrice where Run = "
						+ Variables.getinitial_run_number());
		while (rs.next()) {
			LP_year_1 = rs.getDouble("1");
			LP_year_2 = rs.getDouble("2");
			LP_year_3 = rs.getDouble("3");
			LP_year_4 = rs.getDouble("4");
			LP_year_5 = rs.getDouble("5");
			LP_year_6 = rs.getDouble("6");
			LP_year_7 = rs.getDouble("7");
			LP_year_8 = rs.getDouble("8");
			LP_year_9 = rs.getDouble("9");
			LP_year_10 = rs.getDouble("10");
			LP_year_11 = rs.getDouble("11");
			LP_year_12 = rs.getDouble("12");
			LP_year_13 = rs.getDouble("13");
			LP_year_14 = rs.getDouble("14");
			LP_year_15 = rs.getDouble("15");
			LP_year_16 = rs.getDouble("16");
			LP_year_17 = rs.getDouble("17");
			LP_year_18 = rs.getDouble("18");
			LP_year_19 = rs.getDouble("19");
			LP_year_20 = rs.getDouble("20");
			LP_year_21 = rs.getDouble("21");
			LP_year_22 = rs.getDouble("22");
			LP_year_23 = rs.getDouble("23");
			LP_year_24 = rs.getDouble("24");
			LP_year_25 = rs.getDouble("25");
			LP_year_26 = rs.getDouble("26");
			LP_year_27 = rs.getDouble("27");
			LP_year_28 = rs.getDouble("28");
			LP_year_29 = rs.getDouble("29");
			LP_year_30 = rs.getDouble("30");

		}
		rs.close();
		stmt.close();
		conn.close();
	} catch (SQLException ce) {
		System.out.println("SQLException LentilsPrices" + ce.getMessage());
	}

	try {
		Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
	} catch (ClassNotFoundException ce) {

	}

	try {
		Connection conn = DriverManager.getConnection(
				"jdbc:odbc:producerDB", "java", "1234");
		Statement stmt = conn.createStatement();
		ResultSet rs = stmt
				.executeQuery("select * from CalfPrice where Run = "
						+ Variables.getinitial_run_number());
		while (rs.next()) {
			CalfP_year_1 = rs.getDouble("1");
			CalfP_year_2 = rs.getDouble("2");
			CalfP_year_3 = rs.getDouble("3");
			CalfP_year_4 = rs.getDouble("4");
			CalfP_year_5 = rs.getDouble("5");
			CalfP_year_6 = rs.getDouble("6");
			CalfP_year_7 = rs.getDouble("7");
			CalfP_year_8 = rs.getDouble("8");
			CalfP_year_9 = rs.getDouble("9");
			CalfP_year_10 = rs.getDouble("10");
			CalfP_year_11 = rs.getDouble("11");
			CalfP_year_12 = rs.getDouble("12");
			CalfP_year_13 = rs.getDouble("13");
			CalfP_year_14 = rs.getDouble("14");
			CalfP_year_15 = rs.getDouble("15");
			CalfP_year_16 = rs.getDouble("16");
			CalfP_year_17 = rs.getDouble("17");
			CalfP_year_18 = rs.getDouble("18");
			CalfP_year_19 = rs.getDouble("19");
			CalfP_year_20 = rs.getDouble("20");
			CalfP_year_21 = rs.getDouble("21");
			CalfP_year_22 = rs.getDouble("22");
			CalfP_year_23 = rs.getDouble("23");
			CalfP_year_24 = rs.getDouble("24");
			CalfP_year_25 = rs.getDouble("25");
			CalfP_year_26 = rs.getDouble("26");
			CalfP_year_27 = rs.getDouble("27");
			CalfP_year_28 = rs.getDouble("28");
			CalfP_year_29 = rs.getDouble("29");
			CalfP_year_30 = rs.getDouble("30");

		}
		rs.close();
		stmt.close();
		conn.close();
	} catch (SQLException ce) {
		System.out.println("SQLException CalfPrices" + ce.getMessage());
	}

	try {
		Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
	} catch (ClassNotFoundException ce) {

	}

	try {
		Connection conn = DriverManager.getConnection(
				"jdbc:odbc:producerDB", "java", "1234");
		Statement stmt = conn.createStatement();
		ResultSet rs = stmt
				.executeQuery("select * from HayYield where Run = "
						+ Variables.getinitial_run_number());
		while (rs.next()) {
			HayY_year_1 = rs.getDouble("1");
			HayY_year_2 = rs.getDouble("2");
			HayY_year_3 = rs.getDouble("3");
			HayY_year_4 = rs.getDouble("4");
			HayY_year_5 = rs.getDouble("5");
			HayY_year_6 = rs.getDouble("6");
			HayY_year_7 = rs.getDouble("7");
			HayY_year_8 = rs.getDouble("8");
			HayY_year_9 = rs.getDouble("9");
			HayY_year_10 = rs.getDouble("10");
			HayY_year_11 = rs.getDouble("11");
			HayY_year_12 = rs.getDouble("12");
			HayY_year_13 = rs.getDouble("13");
			HayY_year_14 = rs.getDouble("14");
			HayY_year_15 = rs.getDouble("15");
			HayY_year_16 = rs.getDouble("16");
			HayY_year_17 = rs.getDouble("17");
			HayY_year_18 = rs.getDouble("18");
			HayY_year_19 = rs.getDouble("19");
			HayY_year_20 = rs.getDouble("20");
			HayY_year_21 = rs.getDouble("21");
			HayY_year_22 = rs.getDouble("22");
			HayY_year_23 = rs.getDouble("23");
			HayY_year_24 = rs.getDouble("24");
			HayY_year_25 = rs.getDouble("25");
			HayY_year_26 = rs.getDouble("26");
			HayY_year_27 = rs.getDouble("27");
			HayY_year_28 = rs.getDouble("28");
			HayY_year_29 = rs.getDouble("29");
			HayY_year_30 = rs.getDouble("30");

		}
		rs.close();
		stmt.close();
		conn.close();
	} catch (SQLException ce) {
		System.out.println("SQLException HayYIELD" + ce.getMessage());
	}

	try {
		Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
	} catch (ClassNotFoundException ce) {

	}

	try {
		Connection conn = DriverManager.getConnection(
				"jdbc:odbc:producerDB", "java", "1234");
		Statement stmt = conn.createStatement();
		ResultSet rs = stmt
				.executeQuery("select * from HayPrice where Run = "
						+ Variables.getinitial_run_number());
		while (rs.next()) {
			HayP_year_1 = rs.getDouble("1");
			HayP_year_2 = rs.getDouble("2");
			HayP_year_3 = rs.getDouble("3");
			HayP_year_4 = rs.getDouble("4");
			HayP_year_5 = rs.getDouble("5");
			HayP_year_6 = rs.getDouble("6");
			HayP_year_7 = rs.getDouble("7");
			HayP_year_8 = rs.getDouble("8");
			HayP_year_9 = rs.getDouble("9");
			HayP_year_10 = rs.getDouble("10");
			HayP_year_11 = rs.getDouble("11");
			HayP_year_12 = rs.getDouble("12");
			HayP_year_13 = rs.getDouble("13");
			HayP_year_14 = rs.getDouble("14");
			HayP_year_15 = rs.getDouble("15");
			HayP_year_16 = rs.getDouble("16");
			HayP_year_17 = rs.getDouble("17");
			HayP_year_18 = rs.getDouble("18");
			HayP_year_19 = rs.getDouble("19");
			HayP_year_20 = rs.getDouble("20");
			HayP_year_21 = rs.getDouble("21");
			HayP_year_22 = rs.getDouble("22");
			HayP_year_23 = rs.getDouble("23");
			HayP_year_24 = rs.getDouble("24");
			HayP_year_25 = rs.getDouble("25");
			HayP_year_26 = rs.getDouble("26");
			HayP_year_27 = rs.getDouble("27");
			HayP_year_28 = rs.getDouble("28");
			HayP_year_29 = rs.getDouble("29");
			HayP_year_30 = rs.getDouble("30");

		}
		rs.close();
		stmt.close();
		conn.close();
	} catch (SQLException ce) {
		System.out.println("SQLException FlaxPrices" + ce.getMessage());
	}

	flax_bootstrapped_yields = new double[] { FY_year_1, FY_year_2,
			FY_year_3, FY_year_4, FY_year_5, FY_year_6, FY_year_7,
			FY_year_8, FY_year_9, FY_year_10, FY_year_11, FY_year_12,
			FY_year_13, FY_year_14, FY_year_15, FY_year_16, FY_year_17,
			FY_year_18, FY_year_19, FY_year_20, FY_year_21, FY_year_22,
			FY_year_23, FY_year_24, FY_year_25, FY_year_26, FY_year_27,
			FY_year_28, FY_year_29, FY_year_30 };

	flax_bootstrapped_prices = new double[] { FP_year_1, FP_year_2,
			FP_year_3, FP_year_4, FP_year_5, FP_year_6, FP_year_7,
			FP_year_8, FP_year_9, FP_year_10, FP_year_11, FP_year_12,
			FP_year_13, FP_year_14, FP_year_15, FP_year_16, FP_year_17,
			FP_year_18, FP_year_19, FP_year_20, FP_year_21, FP_year_22,
			FP_year_23, FP_year_24, FP_year_25, FP_year_26, FP_year_27,
			FP_year_28, FP_year_29, FP_year_30 };

	wheat_bootstrapped_yields = new double[] { WY_year_1, WY_year_2,
			WY_year_3, WY_year_4, WY_year_5, WY_year_6, WY_year_7,
			WY_year_8, WY_year_9, WY_year_10, WY_year_11, WY_year_12,
			WY_year_13, WY_year_14, WY_year_15, WY_year_16, WY_year_17,
			WY_year_18, WY_year_19, WY_year_20, WY_year_21, WY_year_22,
			WY_year_23, WY_year_24, WY_year_25, WY_year_26, WY_year_27,
			WY_year_28, WY_year_29, WY_year_30 };

	wheat_bootstrapped_prices = new double[] { WP_year_1, WP_year_2,
			WP_year_3, WP_year_4, WP_year_5, WP_year_6, WP_year_7,
			WP_year_8, WP_year_9, WP_year_10, WP_year_11, WP_year_12,
			WP_year_13, WP_year_14, WP_year_15, WP_year_16, WP_year_17,
			WP_year_18, WP_year_19, WP_year_20, WP_year_21, WP_year_22,
			WP_year_23, WP_year_24, WP_year_25, WP_year_26, WP_year_27,
			WP_year_28, WP_year_29, WP_year_30 };
		
	durum_bootstrapped_yields = new double[] { DY_year_1, DY_year_2,
			DY_year_3, DY_year_4, DY_year_5, DY_year_6, DY_year_7,
			DY_year_8, DY_year_9, DY_year_10, DY_year_11, DY_year_12,
			DY_year_13, DY_year_14, DY_year_15, DY_year_16, DY_year_17,
			DY_year_18, DY_year_19, DY_year_20, DY_year_21, DY_year_22,
			DY_year_23, DY_year_24, DY_year_25, DY_year_26, DY_year_27,
			DY_year_28, DY_year_29, DY_year_30 };

	durum_bootstrapped_prices = new double[] { DP_year_1, DP_year_2,
			DP_year_3, DP_year_4, DP_year_5, DP_year_6, DP_year_7,
			DP_year_8, DP_year_9, DP_year_10, DP_year_11, DP_year_12,
			DP_year_13, DP_year_14, DP_year_15, DP_year_16, DP_year_17,
			DP_year_18, DP_year_19, DP_year_20, DP_year_21, DP_year_22,
			DP_year_23, DP_year_24, DP_year_25, DP_year_26, DP_year_27,
			DP_year_28, DP_year_29, DP_year_30 };
	

	canola_bootstrapped_yields = new double[] { CY_year_1, CY_year_2,
			CY_year_3, CY_year_4, CY_year_5, CY_year_6, CY_year_7,
			CY_year_8, CY_year_9, CY_year_10, CY_year_11, CY_year_12,
			CY_year_13, CY_year_14, CY_year_15, CY_year_16, CY_year_17,
			CY_year_18, CY_year_19, CY_year_20, CY_year_21, CY_year_22,
			CY_year_23, CY_year_24, CY_year_25, CY_year_26, CY_year_27,
			CY_year_28, CY_year_29, CY_year_30 };

	canola_bootstrapped_prices = new double[] { CP_year_1, CP_year_2,
			CP_year_3, CP_year_4, CP_year_5, CP_year_6, CP_year_7,
			CP_year_8, CP_year_9, CP_year_10, CP_year_11, CP_year_12,
			CP_year_13, CP_year_14, CP_year_15, CP_year_16, CP_year_17,
			CP_year_18, CP_year_19, CP_year_20, CP_year_21, CP_year_22,
			CP_year_23, CP_year_24, CP_year_25, CP_year_26, CP_year_27,
			CP_year_28, CP_year_29, CP_year_30 };

	barley_bootstrapped_yields = new double[] { BY_year_1, BY_year_2,
			BY_year_3, BY_year_4, BY_year_5, BY_year_6, BY_year_7,
			BY_year_8, BY_year_9, BY_year_10, BY_year_11, BY_year_12,
			BY_year_13, BY_year_14, BY_year_15, BY_year_16, BY_year_17,
			BY_year_18, BY_year_19, BY_year_20, BY_year_21, BY_year_22,
			BY_year_23, BY_year_24, BY_year_25, BY_year_26, BY_year_27,
			BY_year_28, BY_year_29, BY_year_30 };

	barley_bootstrapped_prices = new double[] { BP_year_1, BP_year_2,
			BP_year_3, BP_year_4, BP_year_5, BP_year_6, BP_year_7,
			BP_year_8, BP_year_9, BP_year_10, BP_year_11, BP_year_12,
			BP_year_13, BP_year_14, BP_year_15, BP_year_16, BP_year_17,
			BP_year_18, BP_year_19, BP_year_20, BP_year_21, BP_year_22,
			BP_year_23, BP_year_24, BP_year_25, BP_year_26, BP_year_27,
			BP_year_28, BP_year_29, BP_year_30 };

	peas_bootstrapped_yields = new double[] { PY_year_1, PY_year_2,
			PY_year_3, PY_year_4, PY_year_5, PY_year_6, PY_year_7,
			PY_year_8, PY_year_9, PY_year_10, PY_year_11, PY_year_12,
			PY_year_13, PY_year_14, PY_year_15, PY_year_16, PY_year_17,
			PY_year_18, PY_year_19, PY_year_20, PY_year_21, PY_year_22,
			PY_year_23, PY_year_24, PY_year_25, PY_year_26, PY_year_27,
			PY_year_28, PY_year_29, PY_year_30 };

	peas_bootstrapped_prices = new double[] { PP_year_1, PP_year_2,
			PP_year_3, PP_year_4, PP_year_5, PP_year_6, PP_year_7,
			PP_year_8, PP_year_9, PP_year_10, PP_year_11, PP_year_12,
			PP_year_13, PP_year_14, PP_year_15, PP_year_16, PP_year_17,
			PP_year_18, PP_year_19, PP_year_20, PP_year_21, PP_year_22,
			PP_year_23, PP_year_24, PP_year_25, PP_year_26, PP_year_27,
			PP_year_28, PP_year_29, PP_year_30 };

	lentils_bootstrapped_yields = new double[] { LY_year_1, LY_year_2,
			LY_year_3, LY_year_4, LY_year_5, LY_year_6, LY_year_7,
			LY_year_8, LY_year_9, LY_year_10, LY_year_11, LY_year_12,
			LY_year_13, LY_year_14, LY_year_15, LY_year_16, LY_year_17,
			LY_year_18, LY_year_19, LY_year_20, LY_year_21, LY_year_22,
			LY_year_23, LY_year_24, LY_year_25, LY_year_26, LY_year_27,
			LY_year_28, LY_year_29, LY_year_30 };

	lentils_bootstrapped_prices = new double[] { LP_year_1, LP_year_2,
			LP_year_3, LP_year_4, LP_year_5, LP_year_6, LP_year_7,
			LP_year_8, LP_year_9, LP_year_10, LP_year_11, LP_year_12,
			LP_year_13, LP_year_14, LP_year_15, LP_year_16, LP_year_17,
			LP_year_18, LP_year_19, LP_year_20, LP_year_21, LP_year_22,
			LP_year_23, LP_year_24, LP_year_25, LP_year_26, LP_year_27,
			LP_year_28, LP_year_29, LP_year_30 };

	calf_bootstrapped_prices = new double[] { CalfP_year_1, CalfP_year_2,
			CalfP_year_3, CalfP_year_4, CalfP_year_5, CalfP_year_6,
			CalfP_year_7, CalfP_year_8, CalfP_year_9, CalfP_year_10,
			CalfP_year_11, CalfP_year_12, CalfP_year_13, CalfP_year_14,
			CalfP_year_15, CalfP_year_16, CalfP_year_17, CalfP_year_18,
			CalfP_year_19, CalfP_year_20, CalfP_year_21, CalfP_year_22,
			CalfP_year_23, CalfP_year_24, CalfP_year_25, CalfP_year_26,
			CalfP_year_27, CalfP_year_28, CalfP_year_29, CalfP_year_30 };

	hay_bootstrapped_yields = new double[] { HayY_year_1, HayY_year_2,
			HayY_year_3, HayY_year_4, HayY_year_5, HayY_year_6,
			HayY_year_7, HayY_year_8, HayY_year_9, HayY_year_10,
			HayY_year_11, HayY_year_12, HayY_year_13, HayY_year_14,
			HayY_year_15, HayY_year_16, HayY_year_17, HayY_year_18,
			HayY_year_19, HayY_year_20, HayY_year_21, HayY_year_22,
			HayY_year_23, HayY_year_24, HayY_year_25, HayY_year_26,
			HayY_year_27, HayY_year_28, HayY_year_29, HayY_year_30 };

	hay_bootstrapped_prices = new double[] { HayP_year_1, HayP_year_2,
			HayP_year_3, HayP_year_4, HayP_year_5, HayP_year_6,
			HayP_year_7, HayP_year_8, HayP_year_9, HayP_year_10,
			HayP_year_11, HayP_year_12, HayP_year_13, HayP_year_14,
			HayP_year_15, HayP_year_16, HayP_year_17, HayP_year_18,
			HayP_year_19, HayP_year_20, HayP_year_21, HayP_year_22,
			HayP_year_23, HayP_year_24, HayP_year_25, HayP_year_26,
			HayP_year_27, HayP_year_28, HayP_year_29, HayP_year_30 };
	
	

		crop_flax_yield_list = getflax_bootstrapped_yields();

		crop_flax_price_list = getflax_bootstrapped_prices();

		crop_peas_price_list = getpeas_bootstrapped_prices();
		crop_peas_yield_list = getpeas_bootstrapped_yields();

		crop_lentils_price_list = getlentils_bootstrapped_prices();
		crop_lentils_yield_list = getlentils_bootstrapped_yields();

		crop_canola_price_list = getcanola_bootstrapped_prices();
		crop_canola_yield_list = getcanola_bootstrapped_yields();

		crop_wheat_price_list = getwheat_bootstrapped_prices();
		crop_wheat_yield_list = getwheat_bootstrapped_yields();

		crop_durum_price_list = getdurum_bootstrapped_prices();
		crop_durum_yield_list = getdurum_bootstrapped_yields();
		
		crop_barley_price_list = getbarley_bootstrapped_prices();
		crop_barley_yield_list = getbarley_bootstrapped_yields();

		hay_price_list = gethay_bootstrapped_prices();
		hay_yield_list = gethay_bootstrapped_yields();
		calf_price_list = getcalf_bootstrapped_prices();
		

		last_5_years_price_canola = new double[] { 10.42, 7.26, 5.49, 6.05,	7.65 };
		last_5_years_price_wheat = new double[] { 7.94, 3.91, 2.89, 2.93, 4.08 };
		last_5_years_price_barley = new double[] { 4.46, 2.69, 1.87, 2.04, 2.58 };
		last_5_years_price_hay = new double[] { 90.0, 80.0, 85.0, 64.73, 79.96 }; //all correct
		last_5_years_price_livestock = new double[] { 1.10, 1.33, 1.40, 1.11, 1.35 };
		last_5_years_price_durum = new double[] {11.93, 4.46, 3.13, 3.63, 4.65};
		last_5_years_price_peas = new double[] { 6.57, 6.88, 5.05, 5.71, 4.84 };
		last_5_years_price_lentils = new double[] { 13.31, 7.76, 6.75, 10.13, 8.3 };
		last_5_years_price_flax = new double[] { 13.45, 6.35, 6.27, 10.69, 8.15 };

		last_5_years_yield_flax = new double[] { 17.8, 15.9, 19.3, 12.6, 11.6}; //Correct
		last_5_years_yield_peas = new double[] { 34.5, 28.8, 23.9, 37.0, 23.3 }; //Correct
		last_5_years_yield_lentils = new double[] { 15.6, 11.6, 19.2, 17.3,	14.28 }; //Correct
		last_5_years_yield_canola = new double[] { 23.3, 22.2, 27.1, 25.1, 17.0 }; //Correct
		last_5_years_yield_wheat = new double[] { 28.7, 30.4, 30.7, 28.5, 23.9 }; //Correct
		last_5_years_yield_durum = new double[] {28.9, 29.3, 30.1, 24.6, 20.2 }; //Correct
		last_5_years_yield_barley = new double[] { 51.8, 51.1, 51.0, 54.6, 40.2 }; //Correct
		last_5_years_yield_hay = new double[] { 1.4, 1.4, 1.4, 1.2, 0.8};
		
		

		crop_mach_new_value_list = new int[] { 370900, 1153600, 1402800,
				1778640, 1936695, 3185090, 4328185, 5981832, 7574685, 9039902 };

		

		mcals_ton_np_early = 967;
		mcals_ton_np_late = 580;
		mcals_ton_np_fall = 116;

		mcals_ton_ip_early = 1098;
		mcals_ton_ip_late = 659;
		mcals_ton_ip_fall = 132;

		mcals_ton_hayland_early = 1340;
		mcals_ton_hayland_late = 804;
		mcals_ton_hayland_fall = 161;

		mcals_ton_ip_baled_one = 1098;
		mcals_ton_ip_baled_two = 659;
		mcals_ton_hayland_baled_one = 1340;
		mcals_ton_hayland_baled_two = 804;

		mcals_required_early_summer = 1970;
		mcals_required_late_summer = 1237;
		mcals_required_fall = 1636;
		mcals_required_winter = 5075;

		// System.out.println("max_distance:" + max_distance);

		farmerOutID = 0;
		exitOutID = 0;
		oldage = 0;
		year = 0;

	}

	
		

	public void setyear(int i) {
		year = i;
	}

	public int getyear() {
		return year;
	}

	public double[] getexpected_price_list() {
		return expected_price_list;
	}

	public void setexpected_price_list(double[] i) {
		expected_price_list = i;
	}

	public double[] getexpected_yield_list() {
		return expected_yield_list;
	}

	public void setexpected_yield_list(double[] i) {
		expected_yield_list = i;
	}

	public int getfarmerOutID() {
		return farmerOutID;
	}

	public void setfarmerOutID(int i) {
		farmerOutID = i;
	}

	public int getexitOutID() {
		return exitOutID;
	}

	public void setexitOutID(int i) {
		exitOutID = i;
	}

	public int gettransferOutID() {
		return transferOutID;
	}

	public void settransferOutID(int i) {
		transferOutID = i;
	}

	public int getland_price_driverID() {
		return land_price_driverID;
	}

	public void setland_price_driverID(int i) {
		land_price_driverID = i;
	}

	public int getglobalOutID() {
		return globalOutID;
	}

	public void setglobalOutID(int i) {
		globalOutID = i;
	}

	public double[] getlast_year_exp_list() {
		return last_year_exp_list;
	}

	public void setlast_year_exp_list(double[] i) {
		last_year_exp_list = i;
	}

	public double[] getcrop_flax_price_list() {
		return crop_flax_price_list;
	}

	public void setcrop_flax_price_list(double[] i) {
		crop_flax_price_list = i;
	}

	public double[] getcrop_canola_price_list() {
		return crop_canola_price_list;
	}

	public void setcrop_canola_price_list(double[] i) {
		crop_canola_price_list = i;
	}
	
	public double[] getcrop_canola_yield_list() {
		return crop_canola_yield_list;
	}

	public void setcrop_canola_yield_list(double[] i) {
		crop_canola_yield_list = i;
	}
	
	public double[] getcrop_flax_yield_list() {
		return crop_flax_yield_list;
	}

	public void setcrop_flax_yield_list(double[] i) {
		crop_flax_yield_list = i;
	}

	public double[] getcrop_wheat_price_list() {
		return crop_wheat_price_list;
	}
	
	public void setcrop_wheat_price_list(double[] i) {
		crop_wheat_price_list = i;
	}

	public double[] getcrop_wheat_yield_list() {
		return crop_wheat_yield_list;
	}
	
	public void setcrop_wheat_yield_list(double[] i) {
		crop_wheat_yield_list = i;
	}

	public double[] getcrop_barley_price_list() {
		return crop_barley_price_list;
	}
	
	public void setcrop_barley_price_list(double[] i) {
		crop_barley_price_list = i;
	}

	public double[] getcrop_barley_yield_list() {
		return crop_barley_yield_list;
	}
	
	public void setcrop_barley_yield_list(double[] i) {
		crop_barley_yield_list = i;
	}

	public double[] gethay_yield_list() {
		return hay_yield_list;
	}
	
	public void sethay_yield_list(double[] i) {
		hay_yield_list = i;
	}

	public double[] gethay_price_list() {
		return hay_price_list;
	}
	
	public void sethay_price_list(double[] i) {
		hay_price_list = i;
	}

	public double[] getcalf_price_list() {
		return calf_price_list;
	}
	
	public void setcalf_price_list(double[] i) {
		calf_price_list = i;
	}

	public int getrun_number() {
		return run_number;
	}

	public void setrun_number(int i) {
		run_number = i;
	}

	public double gethay_yield_1() {
		return hay_yield_1;
	}

	public void sethay_yield_1(double i) {
		hay_yield_1 = i;
	}

	public double getmax_hay_yield_earlypasture() {
		return max_hay_yield_earlypasture;
	}

	public void setmax_hay_yield_earlypasture(double i) {
		max_hay_yield_earlypasture = i;
	}

	public double getmax_hay_yield_latepasture() {
		return max_hay_yield_latepasture;
	}

	public void setmax_hay_yield_latepasture(double i) {
		max_hay_yield_latepasture = i;
	}

	public double getmax_hay_yield_fall() {
		return max_hay_yield_fall;
	}

	public void setmax_hay_yield_fall(double i) {
		max_hay_yield_fall = i;
	}

	public double getyield_flax() {
		return yield_flax;
	}

	public void setyield_flax(double i) {
		yield_flax = i;
	}

	public double getyield_canola() {
		return yield_canola;
	}

	public void setyield_canola(double i) {
		yield_canola = i;
	}

	public double getprice_flax() {
		return price_flax;
	}

	public void setprice_flax(double i) {
		price_flax = i;
	}

	public double getprice_canola() {
		return price_canola;
	}

	public void setprice_canola(double i) {
		price_canola = i;
	}

	public double getyield_wheat() {
		return yield_wheat;
	}

	public void setyield_wheat(double i) {
		yield_wheat = i;
	}

	public double getprice_wheat() {
		return price_wheat;
	}

	public void setprice_wheat(double i) {
		price_wheat = i;
	}
	
	public double getprice_durum() {
		return price_durum;
	}
	
	public void setprice_durum (double i) {
		price_durum = i;
	}

	public double getyield_barley() {
		return yield_barley;
	}

	public void setyield_barley(double i) {
		yield_barley = i;
	}

	public double getprice_barley() {
		return price_barley;
	}

	public void setprice_barley(double i) {
		price_barley = i;
	}

	public double getprice_calf() {
		return price_calf;
	}

	public void setprice_calf(double i) {
		price_calf = i;
	}

	public void setprice_hay(double i) {
		price_hay = i;
	}

	public double getprice_hay() {
		return price_hay;
	}

	public double[] getlast_5_years_price_flax() {
		return last_5_years_price_flax;
	}

	public void setlast_5_years_price_flax(double[] i) {
		last_5_years_price_flax = i;
	}

	public double[] getlast_5_years_price_canola() {
		return last_5_years_price_canola;
	}

	public void setlast_5_years_price_canola(double[] i) {
		last_5_years_price_canola = i;
	}

	public double[] getlast_5_years_price_wheat() {
		return last_5_years_price_wheat;
	}

	public void setlast_5_years_price_wheat(double[] i) {
		last_5_years_price_wheat = i;
	}
	
	public double[] getlast_5_years_price_durum() {
		return last_5_years_price_durum;
	}
	
	public void setlast_5_years_price_durum(double[] i) {
		last_5_years_price_durum = i;
	}

	public double[] getlast_5_years_price_barley() {
		return last_5_years_price_barley;
	}

	public void setlast_5_years_price_barley(double[] i) {
		last_5_years_price_barley = i;
	}

	public void setlast_5_years_price_hay(double[] i) {
		last_5_years_price_hay = i;
	}

	public double[] getlast_5_years_price_hay() {
		return last_5_years_price_hay;
	}

	public void setlast_5_years_price_livestock(double[] i) {
		last_5_years_price_livestock = i;
	}

	public double[] getlast_5_years_price_livestock() {
		return last_5_years_price_livestock;
	}

	public double[] getlast_5_years_yield_flax() {
		return last_5_years_yield_flax;
	}

	public void setlast_5_years_yield_flax(double[] i) {
		last_5_years_yield_flax = i;
	}

	public double[] getlast_5_years_yield_canola() {
		return last_5_years_yield_canola;
	}

	public void setlast_5_years_yield_canola(double[] i) {
		last_5_years_yield_canola = i;
	}

	public double[] getlast_5_years_yield_wheat() {
		return last_5_years_yield_wheat;
	}

	public void setlast_5_years_yield_wheat(double[] i) {
		last_5_years_yield_wheat = i;
	}

	public double[] getlast_5_years_yield_durum() {
		return last_5_years_yield_durum;
	}
	
	public void setlast_5_years_yield_durum(double[] i) {
		last_5_years_yield_durum = i;
	}
	
	public double[] getlast_5_years_yield_barley() {
		return last_5_years_yield_barley;
	}

	public void setlast_5_years_yield_barley(double[] i) {
		last_5_years_yield_barley = i;
	}

	public double[] getlast_5_years_yield_hay() {
		return last_5_years_yield_hay;
	}

	public void setlast_5_years_yield_hay(double[] i) {
		last_5_years_yield_hay = i;
	}
	
	public double[] getlast_2_years_eligible_netsales () {
		return last_2_years_eligible_netsales;
	}
	
	public void setlast_2_years_eligible_netsales (double[] i) {
		last_2_years_eligible_netsales = i;
	}

	public double[] getreference_margin_crop() {
		return reference_margin_crop;
	}

	public void setreference_margin_crop(double[] i) {
		reference_margin_crop = i;
	}
	
	public double[] getreference_margin_calf() {
		return reference_margin_calf;
	}

	public void setreference_margin_calf(double[] i) {
		reference_margin_calf = i;
	}
	
	public double[] getreference_margin_energy() {
		return reference_margin_energy;
	}

	public void setreference_margin_energy(double[] i) {
		reference_margin_energy = i;
	}

	public int getscenario() {
		return scenario;
	}

	public void setscenario(int i) {
		scenario = i;
	}

	public double getmean_patch_quality() {
		return mean_patch_quality;
	}

	public void setmean_patch_quality(double i) {
		mean_patch_quality = i;
	}

	public double getmean_patch_quality_pasture() {
		return mean_patch_quality_pasture;
	}

	public void setmean_patch_quality_pasture(double i) {
		mean_patch_quality_pasture = i;
	}

	public double getmean_patch_quality_cropland() {
		return mean_patch_quality_cropland;
	}

	public void setmean_patch_quality_cropland(double i) {
		mean_patch_quality_cropland = i;
	}

	public double getmean_patch_prod() {
		return mean_patch_prod;
	}

	public void setall_patches_avg_prod(double i) {
		all_patches_avg_prod = i;
	}

	public double getall_patches_avg_prod() {
		return all_patches_avg_prod;
	}

	public void setmean_patch_prod(double i) {
		mean_patch_prod = i;
	}

	public void setfarmerlist(ArrayList i) {
		farmerlist = i;
	}

	public ArrayList getfarmerlist() {
		return farmerlist;
	}
	
	public static void setinitialfarmerlist(ArrayList i) {
		initialfarmerlist = i;
	}

	public ArrayList getinitialfarmerlist() {
		return initialfarmerlist;
	}
	
	public void setlandlist(ArrayList i) {
		landlist = i;
	}

	public ArrayList getlandlist() {
		return landlist;
	}
	
	public static void setinitiallandlist(ArrayList i) {
		initiallandlist = i;
	}
	
	public ArrayList getinitiallandlist() {
		return initiallandlist;
	}

	public int getmax_distance() {
		return max_distance;
	}

	public void setmax_distance(int i) {
		max_distance = i;
	}

	public double getloan_factor_payment_5() {
		return loan_factor_payment_5;
	}

	public void setloan_factor_payment_5(double i) {
		loan_factor_payment_5 = i;
	}

	public double getloan_factor_payment_20() {
		return loan_factor_payment_20;
	}

	public void setloan_factor_payment_20(double i) {
		loan_factor_payment_20 = i;
	}

	public double getloan_factor_payment_25() {
		return loan_factor_payment_25;
	}

	public void setloan_factor_payment_25(double i) {
		loan_factor_payment_25 = i;
	}

	public int getcashflow() {
		return cashflow;
	}

	public void setcashflow(int i) {
		cashflow = i;
	}

	public int getbankrupt() {
		return bankrupt;
	}

	public void setbankrupt(int i) {
		bankrupt = i;
	}

	public int getoldage() {
		return oldage;
	}

	public void setoldage(int i) {
		oldage = i;
	}

	public int gettransfers() {
		return transfers;
	}

	public void settransfers(int i) {
		transfers = i;
	}

	public int getcropland_price() {
		return cropland_price;
	}

	public void setcropland_price(int i) {
		this.cropland_price = i;
	}

	public int getmarginalland_price() {
		return marginalland_price;
	}

	public void setmarginalland_price(int i) {
		this.marginalland_price = i;
	}

	public int[] getcrop_mach_new_value_list() {
		return crop_mach_new_value_list;
	}

	public double getyear_20_factor() {
		return year_20_factor;
	}

	public void setyear_20_factor(double i) {
		year_20_factor = i;
	}

	public double getpv_annuity_land() {
		return pv_annuity_land;
	}

	public void setpv_annuity_land(double i) {
		pv_annuity_land = i;
	}

	public ArrayList getcropland_price_list() {
		return cropland_price_list;
	}

	public void setcropland_price_list(ArrayList i) {
		cropland_price_list = i;
	}

	public ArrayList getmarginalland_price_list() {
		return marginalland_price_list;
	}

	public void setmarginalland_price_list(ArrayList i) {
		marginalland_price_list = i;
	}

	public ArrayList getcropland_lease_list() {
		return cropland_lease_list;
	}

	public void setcropland_lease_list(ArrayList i) {
		cropland_lease_list = i;
	}

	public ArrayList getmarginalland_lease_list() {
		return marginalland_lease_list;
	}

	public void setmarginalland_lease_list(ArrayList i) {
		marginalland_lease_list = i;
	}

	public ArrayList getbid_list() {
		return bid_list;
	}

	public void setbid_list(ArrayList i) {
		bid_list = (ArrayList) i.clone();
	}

	public ArrayList get_lease_bid_list_cropland() {
		return lease_bid_list_cropland;
	}

	public void set_lease_bid_list_cropland(ArrayList i) {
		lease_bid_list_cropland = i;
	}

	public ArrayList get_buy_bid_list_cropland() {
		return buy_bid_list_cropland;
	}

	public void set_buy_bid_list_cropland(ArrayList i) {
		buy_bid_list_cropland = i;
	}

	public ArrayList get_lease_bid_list_marginalland() {
		return lease_bid_list_marginalland;
	}

	public void set_lease_bid_list_marginalland(ArrayList i) {
		lease_bid_list_marginalland = i;
	}

	public ArrayList get_buy_bid_list_marginalland() {
		return buy_bid_list_marginalland;
	}

	public void set_buy_bid_list_marginalland(ArrayList i) {
		buy_bid_list_marginalland = i;
	}

	public ArrayList getland_for_sale(ArrayList i) {
		return land_for_sale;
	}

	public void setland_for_sale(ArrayList i) {
		land_for_sale = i;
	}

	public int getplots_sold_farmers() {
		return plots_sold_farmers;
	}

	public void setplots_sold_farmers(int i) {
		plots_sold_farmers = i;
	}

	public int getplots_sold_investor() {
		return plots_sold_investor;
	}

	public void setplots_sold_investor(int i) {
		plots_sold_investor = i;
	}

	public int getcroplease_rate() {
		return croplease_rate;
	}

	public void setcroplease_rate(int i) {
		croplease_rate = i;
	}

	public int getmarginallease_rate() {
		return marginallease_rate;
	}

	public void setmarginallease_rate(int i) {
		marginallease_rate = i;
	}

	public int getunmanaged() {
		return unmanaged;
	}

	public void setunmanaged(int i) {
		unmanaged = i;
	}

	public int getcurrent_plot_on_market() {
		return current_plot_on_market;
	}

	public void setcurrent_plot_on_market(int i) {
		current_plot_on_market = i;
	}

	public int getfarmers_bidding() {
		return farmers_bidding;
	}

	public void setfarmers_bidding(int i) {
		farmers_bidding = i;
	}

	public int getleaser() {
		return leaser;
	}

	public void setleaser(int i) {
		leaser = i;
	}

	public int getbuyer() {
		return buyer;
	}

	public void setbuyer(int i) {
		buyer = i;
	}

	public double getavg_lease() {
		return avg_lease;
	}

	public void setavg_lease(double i) {
		avg_lease = i;
	}

	public double getcrop_exp_lease() {
		return crop_exp_lease;
	}

	public void setcrop_exp_lease(double i) {
		crop_exp_lease = i;
	}

	public double getmarginal_exp_lease() {
		return marginal_exp_lease;
	}

	public void setmarginal_exp_lease(double i) {
		marginal_exp_lease = i;
	}

	public double getincome_margin() {
		return income_margin;
	}

	public void setincome_margin(double i) {
		income_margin = i;
	}

	public double[] getincome_margin_list() {
		return income_margin_list;
	}

	public void setincome_margin_list(double[] i) {
		income_margin_list = i;
	}

	public double getmcals_ton_np_early() {
		return mcals_ton_np_early;
	}

	public void setmcals_ton_np_early(double i) {
		mcals_ton_np_early = i;
	}

	public double getmcals_ton_np_late() {
		return mcals_ton_np_late;
	}

	public void setmcals_ton_np_late(double i) {
		mcals_ton_np_late = i;
	}

	public double getmcals_ton_np_fall() {
		return mcals_ton_np_fall;
	}

	public void setmcals_ton_np_fall(double i) {
		mcals_ton_np_fall = i;
	}

	public double getmcals_ton_ip_early() {
		return mcals_ton_ip_early;
	}

	public void setmcals_ton_ip_early(double i) {
		mcals_ton_ip_early = i;
	}

	public double getmcals_ton_ip_late() {
		return mcals_ton_ip_late;
	}

	public void setmcals_ton_ip_late(double i) {
		mcals_ton_ip_late = i;

	}

	public double getmcals_ton_ip_fall() {
		return mcals_ton_ip_fall;
	}

	public void setmcals_ton_ip_fall(double i) {
		mcals_ton_ip_fall = i;
	}

	public double getmcals_ton_hayland_early() {
		return mcals_ton_hayland_early;
	}

	public void setmcals_ton_hayland_early(double i) {
		mcals_ton_hayland_early = i;
	}

	public double getmcals_ton_hayland_late() {
		return mcals_ton_hayland_late;
	}

	public void setmcals_ton_hayland_late(double i) {
		mcals_ton_hayland_late = i;
	}

	public double getmcals_ton_hayland_fall() {
		return mcals_ton_hayland_fall;
	}

	public void setmcals_ton_hayland_fall(double i) {
		mcals_ton_hayland_fall = i;
	}

	public double getmcals_ton_ip_baled_one() {
		return mcals_ton_ip_baled_one;
	}

	public void setmcals_ton_ip_baled_one(double i) {
		mcals_ton_ip_baled_one = i;
	}

	public double getmcals_ton_ip_baled_two() {
		return mcals_ton_ip_baled_two;
	}

	public void setmcals_ton_ip_baled_two(double i) {
		mcals_ton_ip_baled_two = i;
	}

	public double getmcals_ton_hayland_baled_one() {
		return mcals_ton_hayland_baled_one;
	}

	public void setmcals_ton_hayland_baled_one(double i) {
		mcals_ton_hayland_baled_one = i;
	}

	public double getmcals_ton_hayland_baled_two() {
		return mcals_ton_hayland_baled_two;
	}

	public void setmcals_ton_hayland_baled_two(double i) {
		mcals_ton_hayland_baled_two = i;
	}

	public double getmcals_required_early_summer() {
		return mcals_required_early_summer;
	}

	public void setmcals_required_early_summer(double i) {
		mcals_required_early_summer = i;
	}

	public double getmcals_required_late_summer() {
		return mcals_required_late_summer;
	}

	public void setmcals_required_late_summer(double i) {
		mcals_required_late_summer = i;
	}

	public double getmcals_required_fall() {
		return mcals_required_fall;
	}

	public void setmcals_required_fall(double i) {
		mcals_required_fall = i;
	}

	public double getmcals_required_winter() {
		return mcals_required_winter;
	}

	public void setmcals_required_winter(double i) {
		mcals_required_winter = i;
	}

	public double[] getcrop_peas_price_list() {
		return crop_peas_price_list;
	}

	public void setcrop_peas_price_list(double[] i) {
		crop_peas_price_list = i;
	}

	public double[] getcrop_peas_yield_list() {
		return crop_peas_yield_list;
	}

	public void setcrop_peas_yield_list(double[] i) {
		crop_peas_yield_list = i;
	}

	public double[] getcrop_lentils_price_list() {
		return crop_lentils_price_list;
	}

	public void setcrop_lentils_price_list(double[] i) {
		crop_lentils_price_list = i;
	}

	public double[] getcrop_lentils_yield_list() {
		return crop_lentils_yield_list;
	}

	public void setcrop_lentils_yield_list(double[] i) {
		crop_lentils_yield_list = i;
	}
	
	public double[] getcrop_durum_yield_list () {
		return crop_durum_yield_list;
	}
	
	public void setcrop_durum_yield_list (double[] i) {
		crop_durum_yield_list = i;
	}

	public double[] getcrop_durum_price_list () {
		return crop_durum_price_list;
	}
	
	public void setcrop_durum_price_list (double[] i) {
		crop_durum_price_list = i;
	}
	
	public double getyield_peas() {
		return yield_peas;
	}

	public void setyield_peas(double i) {
		yield_peas = i;
	}
	
	public double getyield_durum() {
		return yield_durum;
	}
	
	public void setyield_durum (double i) {
		yield_durum = i;
	}

	public double getyield_lentils() {
		return yield_lentils;
	}

	public void setyield_lentils(double i) {
		yield_lentils = i;
	}

	public double getyield_willows() {
		return yield_willows;
	}

	public void setyield_willows(double i) {
		yield_willows = i;
	}

	public double getprice_willows() {
		return price_willows;
	}

	public void setprice_willows(double i) {
		price_willows = i;
	}

	public double getyield_energy_crops_2() {
		return yield_energy_crops_2;
	}

	public void setyield_energy_crops_2(double i) {
		yield_energy_crops_2 = i;
	}

	public double getprice_energy_crops_2() {
		return price_energy_crops_2;
	}

	public void setprice_energy_crops_2(double i) {
		price_energy_crops_2 = i;
	}

	public double getyield_energy_crops_3() {
		return yield_energy_crops_3;
	}

	public void setyield_energy_crops_3(double i) {
		yield_energy_crops_3 = i;
	}

	public double getprice_energy_crops_3() {
		return price_energy_crops_3;
	}

	public void setprice_energy_crops_3(double i) {
		price_energy_crops_3 = i;
	}

	public double getprice_peas() {
		return price_peas;
	}

	public void setprice_peas(double i) {
		price_peas = i;
	}

	public double getprice_lentils() {
		return price_lentils;
	}

	public void setprice_lentils(double i) {
		price_lentils = i;
	}

	public double[] getlast_5_years_price_lentils() {
		return last_5_years_price_lentils;
	}

	public void setlast_5_years_price_lentils(double[] i) {
		last_5_years_price_lentils = i;
	}

	public double[] getlast_5_years_price_peas() {
		return last_5_years_price_peas;
	}

	public void setlast_5_years_price_peas(double[] i) {
		last_5_years_price_peas = i;
	}

	//
	public double[] getlast_5_years_yield_lentils() {
		return last_5_years_yield_lentils;
	}

	public void setlast_5_years_yield_lentils(double[] i) {
		last_5_years_yield_lentils = i;
	}

	public double[] getlast_5_years_yield_peas() {
		return last_5_years_yield_peas;
	}

	public void setlast_5_years_yield_peas(double[] i) {
		last_5_years_yield_peas = i;
	}

	public void remove_leaser(Producer prod) {
		// ArrayList aList = this.get_lease_bid_list_cropland();
		// BidListCropland blCropland = new BidListCropland()

	}

	public void setcurrent_marginal_plot(SAMA fdl3) {
		current_marginal_plot = fdl3;
	}

	public SAMA getcurrent_marginal_plot() {
		return current_marginal_plot;
	}

	public void setcurrent_cropland_plot(SAMA sama) {
		current_cropland_plot = sama;
	}

	public SAMA getcurrent_cropland_plot() {
		return current_cropland_plot;
	}

	public double[] getflax_bootstrapped_yields() {
		return flax_bootstrapped_yields;
	}
	
	public void setflax_boostrapped_yields(double[] i) {
		flax_bootstrapped_yields = i;
	}

	public double[] getflax_bootstrapped_prices() {
		return flax_bootstrapped_prices;
	}
	
	public void setflax_boostrapped_prices(double[] i) {
		flax_bootstrapped_prices = i;
	}

	public double[] getcanola_bootstrapped_yields() {
		return canola_bootstrapped_yields;
	}

	public double[] getcanola_bootstrapped_prices() {
		return canola_bootstrapped_prices;
	}

	public double[] getwheat_bootstrapped_yields() {
		return wheat_bootstrapped_yields;
	}

	public double[] getwheat_bootstrapped_prices() {
		return wheat_bootstrapped_prices;
	}

	public double[] getdurum_bootstrapped_yields() {
		return durum_bootstrapped_yields;
	}

	public double[] getdurum_bootstrapped_prices() {
		return durum_bootstrapped_prices;
	}

	public double[] getbarley_bootstrapped_yields() {
		return barley_bootstrapped_yields;
	}

	public double[] getbarley_bootstrapped_prices() {
		return barley_bootstrapped_prices;
	}

	public double[] getpeas_bootstrapped_yields() {
		return peas_bootstrapped_yields;
	}

	public double[] getpeas_bootstrapped_prices() {
		return peas_bootstrapped_prices;
	}

	public double[] getlentils_bootstrapped_yields() {
		return lentils_bootstrapped_yields;
	}

	public double[] getlentils_bootstrapped_prices() {
		return lentils_bootstrapped_prices;
	}

	public double[] gethay_bootstrapped_yields() {
		return hay_bootstrapped_yields;
	}

	public double[] gethay_bootstrapped_prices() {
		return hay_bootstrapped_prices;
	}

	public double[] getcalf_bootstrapped_prices() {
		return calf_bootstrapped_prices;
	}

	public static int getinitial_run_number() {
		return initial_run_number;
	}

	public static  void setinitial_run_number(int i) {
		initial_run_number = i;
	}

	public static void init_land_needs(int numberOfFarmers) {
		Variables.cropland_needs = new Integer[numberOfFarmers];
		Variables.marginalland_needs = new Integer[numberOfFarmers];
	}

	public static Integer[] get_cropLandNeeds() {
		return Variables.cropland_needs;
	}

	public void resetCropLandNeeds() {
		Variables.cropland_needs = new Integer[Variables.cropland_needs.length];
	}

	public static Integer[] get_marginalLandNeeds() {
		return Variables.marginalland_needs;
	}

	public void resetMarginalLandNeeds() {
		Variables.marginalland_needs = new Integer[Variables.marginalland_needs.length];
	}
	
	public boolean getrestartmodel () {
		return restartmodel;
	}
	
	public void setrestartmodel (boolean i) {
		restartmodel = i;
	}
	
	public static int getoriginalcontextsize  () {
		return originalcontextsize;
	}
	
	public void setoriginalcontextsize (int i) {
		originalcontextsize = i;
	}
	
	public double getpoplarnp () {
		return poplarnp;
	}
	
	public void setpoplarnp (double i) {
		poplarnp = i;
	}
	
	public double getpoplarip () {
		return poplarip;
	}
	
	public void setpoplarip (double i) {
		poplarip = i;
	}
	
	public double getpoplarhayland () {
		return poplarhayland;
	}
	
	public void setpoplarhayland (double i) {
		poplarhayland = i;
	}
	
	public int getcrop_plots_sold_farmers () {
		return crop_plots_sold_farmers;
	}
	
	public void setcrop_plots_sold_farmers (int i) {
		crop_plots_sold_farmers = i;
	}
	
	public int getcrop_plots_sold_investor () {
		return crop_plots_sold_investor;
	}
	
	public void setcrop_plots_sold_investor (int i) {
		crop_plots_sold_investor = i;
	}
	
	public int getmarginal_plots_sold_farmers () {
		return marginal_plots_sold_farmers;
	}
	
	public void setmarginal_plots_sold_farmers (int i) {
		marginal_plots_sold_farmers = i;
	}
	
	public int getmarginal_plots_sold_investor () {
		return marginal_plots_sold_investor;
	}
	
	public void setmarginal_plots_sold_investor (int i) {
		marginal_plots_sold_investor = i;
	}
	
	public int getcrop_plots_leased() {
		return crop_plots_leased;
	}
	
	public void setcrop_plots_leased (int i) {
		crop_plots_leased = i;
	}
	
	public int getmarginal_plots_leased() {
		return marginal_plots_leased;
	}
	
	public void setmarginal_plots_leased (int i) {
		marginal_plots_leased = i;
	}
}
