package energycrops;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Random;

import lpsolve.LpSolve;
import lpsolve.LpSolveException;
import repast.simphony.context.Context;
import repast.simphony.util.ContextUtils;
import repast.simphony.engine.environment.RunEnvironment;
import repast.simphony.parameter.Parameters;
import repast.simphony.space.continuous.ContinuousSpace;
import repast.simphony.space.grid.Grid;

public class Producer extends ProducerAgent {

	private int age; // age of the farm operator
	private int ID; // farmer order number in the farmer list
	private int farmer_type;
	private int generation; // family generation of farm agent
	private int plots_needed; // farmers initial land allocation
	private double summer_fallow_percent;
	private int begin_patch_ID; // the number of first patch the farmer has,
	private double strategic_borrow;
	private double loan_payment;
	private double interest_payment;
	private double principal_payment;
	private double current_assets;
	private double current_debt;
	private double current_daratio;
	private double trucking_distance;
	private double trucking_distance_energy_crops;
	private int farmers_x_distance;
	private int farmers_y_distance;
	private int renter_cropland;
	private int buyer_cropland;
	private int debt;
	private double initial_d_a_ratio;
	private double debt_payment;
	private int off_farm_inc;
	private double ncfbi;
	private double family_living;
	private int years_neg_cash;
	private int equity; // asset less debt
	private double crop_machine_option; // current crop machinery package
	private double machine_option_cost;
	private double plot_income_crop; // actual crop income from the plot
	private double gross_income_crop;
	private double gross_income;
	private double gross_income_livestock;
	private double gross_income_energycrops;
	private double gross_income_hay;
	private double yield_mult;
	private int x; // homestead coordinate x
	private int y; // homestead coordinate y
	private int bid_finances;
	private double total_land_lease_payment; // Summation of all lease payments
	private double total_crop_lease_payment;
	private double total_marginal_lease_payment;
	public int total_crop_acres; // total acres used for crop production
	public int total_crop_acres_last_yr;
	public int total_crop_acres_two_yrs;
	public int total_crop_acres_three_yrs;
	public int total_crop_acres_four_yrs;
	public int total_crop_acres_five_yrs;
	private int handling_transfer;
	private double crccow;
	private double NewCostCow;
	private double new_cows;
	private double sell_old_cows;
	private double sell_cull_cows;
	private double invest_cows;
	private int cropland_value_int;
	private int marginalland_value_int;
	private double long_run_hay_storage_in;
	private double long_run_hay_storage_out;
	public int total_hay;
	public int total_improved_pasture;
	public int total_natural_pasture;
	private int cash; // cash available to the farm
	private int capital_value; // current value of machinery
	private int misc_value; //current value of misc farm tools, etc
	private int year;
	private int land_value; // current value of land
	private int cow_value; // current value of cows
	private double total_crop_income; // crop income less vc tonne, vc acre,
	private int farmer_id; // farmer's ID
	private int assets; // total current value of assets
	private double crop_machine_inv; // investment required in crop machinery
	private int crop_machine_value; // current value of crop machinery
	private int old_equipment_value;
	private int crop_machine_age; // current age of crop machinery
	private int handling_system_age;
	private int cow_machine_age;
	private int handling_system_value;
	private int cow_machine_value;
	private int livestock_equipment_value;
	private double cows_handling_system_limit;
	private double cows_machine_limit;
	private double[] cows_handling_constraint;
	private double[] cows_machine_constraint;
	private double[] cows_acres_required;
	private double total_repairs; // total cost of repairs in the year
	private double exp_cf;
	private double transfer_value;
	private double transfer_borrow;
	public double risk_parameter; // risk parameter of the farmer
	private boolean off_farm_employ; // if the farm has off farm employment
	private boolean can_bid_on_plot; // farmer can bid on the current plot
	private boolean can_bid; // farmer can bid in general
	private boolean can_contribute;
	private boolean checklandmarketresults;
	private boolean tacticalused;
	private boolean infeasiblesolution;
	private boolean participate_agristability;
	private boolean selloldequipment;
	private double current_bid;
	private double current_bid_marginalland;
	private int new_machinery_inv; // machinery investment that will need to
	private double[] yield_exp_list; // individual farmers yield expectation
	private double[] price_exp_list; // individual farmers price expectation
	private String why_exit;
	private boolean die = false;
	private double total_gross_crop_inc;
	private double total_annual_gross_inc;
	private double total_net_crop_income;
	private double total_net_calf_income;
	private double total_net_energy_income;
	private double total_net_crop_income_per_acre;
	private double total_net_hay_income;
	private double total_net_inc;
	private double rent_cropland;
	private double buy_cropland;
	protected ArrayList mylandList;
	private ArrayList debt_list = new ArrayList(); // tracks each debt
	private double[] contribution_margin; // gross contribution margin
	private double[] contribution;
	private double[] operating_captial;
	private double[] borrowing; // operating capital required by the
	private double[] daratio; // daratio constraint limits borrowing amount
	private double[] hay_transfer;
	private double[] barley_transfer;
	private double[] wheat_transfer;
	private double[] barley_strawtransfer;
	private double[] wheat_strawtransfer;
	private double[] early_pasture_mcals;
	private double[] late_pasture_mcals;
	private double[] fall_pasture_mcals;
	private double[] winter_pasture_mcals;
	private double[] forage_breaking;
	private double[] earlymcalsrequired;
	private double[] latemcalsrequired;
	private double[] fallmcalsrequired;
	private double[] wintermcalsrequired;
	private double[] sellcalves;
	private double[] willow_transfer;
	private double[] poplar_transfer;
	private double[] prairie_sandreed_transfer;
	private double[] maxwheatlimit_constraint;
	private double[] maxbarleylimit_constraint;
	private double[] maxdurumlimit_constraint;
	private double expected_income;
	private double recourse_income;
	private double farmer_exp_canola_price; //individual farmer price expectation using CV
	private double farmer_exp_wheat_price;
	private double farmer_exp_flax_price;
	private double farmer_exp_barley_price;
	private double farmer_exp_lentils_price;
	private double farmer_exp_durum_price;
	private double farmer_exp_peas_price;
	private double farmer_exp_calf_price;
	private double farmer_exp_heifer_price;
	private double farmer_exp_cull_price;
	private double farmer_exp_hay_price;
	private double total_acres_farmed;
	private double[] crop_mix;
	private double[] pasture_mix;
	private double[] livestock_variables;
	private double[] energy_crops_variables;
	private double[] max_feeding_mcals;
	private double crop_custom_hire;
	private int option_0_acres; // number of acres determined by MIP for option
	private int option_1_acres; // number of acres determined by MIP for option
	private int option_2_acres; // number of acres determined by MIP for option
	private int option_3_acres; // number of acres determined by MIP for option
	private int option_4_acres; // number of acres determined by MIP for option
	private int option_5_acres; // number of acres determined by MIP for option
	private int option_6_acres; // number of acres determined by MIP for option
	private int option_7_acres; // number of acres determined by MIP for option
	private int option_8_acres; // number of acres determined by MIP for option
	private int option_9_acres; // number of acres determined by MIP for option
	private int option_0_number_machines;
	private int option_1_number_machines;
	private int option_2_number_machines;
	private int option_3_number_machines;
	private int option_4_number_machines;
	private int option_5_number_machines;
	private int option_6_number_machines;
	private int option_7_number_machines;
	private int option_8_number_machines;
	private int option_9_number_machines;
	private double vc_acre;
	private int total_plots_owned; // total plot the farmer owns
	private int total_plots_leased; // total plots the farmer rents
	private int total_acres_owned; // total acres owned by farmer
	private int total_acres_leased; // total acres rented
	private double fallow; // used in set_crop_mix
	private double wheatfallow; // used in set_crop_mix
	private double canolastubble; // used in set_crop_mix
	private double barleystubble; // used in set_crop_mix
	private double flaxstubble; // used in set_crop_mix
	private double peasstubble;
	private double wheatstubble; // used in set_crop_mix
	private double durumstubble;
	private double wheatnotill;
	private double durumnotill;
	private double canolanotill;
	private double barleynotill;
	private double flaxnotill;
	private double peasnotill;
	private double lentilsnotill;
	private double feedwheatnotill;
	private double feedbarleynotill;
	private double feedwheatcon;
	private double feedbarleycon;
	private double np_cow_acre;
	private double ip_cow_acre;
	private double hayland_cow_acre;
	private double total_cow_acre;
	private static double option0acres; // used in set_machinery_mix
	private static double option1acres; // used in set_machinery_mix
	private static double option2acres;
	private static double option3acres;
	private static double option4acres;
	private static double option5acres;
	private static double option6acres;
	private static double option7acres;
	private static double option8acres;
	private static double option9acres;
	private static double option0numbermachines; // used in set_machinery_mix
	private static double option1numbermachines; // used in set_machinery_mix
	private static double option2numbermachines;
	private static double option3numbermachines;
	private static double option4numbermachines;
	private static double option5numbermachines;
	private static double option6numbermachines;
	private static double option7numbermachines;
	private static double option8numbermachines;
	private static double option9numbermachines;
	private double[] machinery_variables;
	private double amount_borrow;
	private double tillage_fallow; // acres of tillage fallow conventional
	private double wheat_on_fallow; // acres of wheat on fallow conventional
	private double canola_stubble; // acres of canola on stubble for
	private double barley_stubble; // acres of barley on stubble for
	private double wheat_stubble; // acres of wheat on stubble for conventional
	private double durum_stubble;
	private double flax_stubble; // acres of flax on stubble for conventional
	private double peas_stubble; // acres of peas on stubble for conventional
	private double barley_notill; // acres of barley on stubble for no-till
	private double canola_notill; // acres of canola on stubble for no-till
	private double wheat_notill; // acres of wheat on stubble for no-till farmer
	private double durum_notill;
	private double flax_notill; // acres of flax no-till
	private double peas_notill; // acres of peas no-till
	private double lentils_notill; // acres of lentisl no-till
	private double barley_yield_index; // yield of barley on tilled portion of
	private double canola_yield_index; // yield of canola on tilled portion of
	private double wheat_yield_index; // yield of wheat on tilled portion of
	private double wheat_sf_yield_index; // yield index for wheat on fallow
	private double flax_yield_index;
	private double lentils_yield_index;
	private double peas_yield_index;
	private boolean should_bid_rent;
	private int income_tax;
	private double crop_insurance_coverage_level;
	private double wheat_premium;
	private double durum_premium;
	private double barley_premium;
	private double canola_premium;
	private double flax_premium;
	private double peas_premium;
	private double lentils_premium;
	private double wheat_premium_gov;
	private double durum_premium_gov;
	private double barley_premium_gov;
	private double canola_premium_gov;
	private double flax_premium_gov;
	private double peas_premium_gov;
	private double lentils_premium_gov;
	private double producer_premium_canola_stubble;
	private double producer_premium_wheat_stubble;
	private double producer_premium_durum_stubble;
	private double producer_premium_wheat_fallow;
	private double producer_premium_barley_stubble;
	private double producer_premium_flax_stubble;
	private double producer_premium_peas_stubble;
	private double government_premium_canola_stubble;
	private double government_premium_barley_stubble;
	private double government_premium_wheat_stubble;
	private double government_premium_durum_stubble;
	private double government_premium_flax_stubble;
	private double government_premium_wheat_fallow;
	private double government_premium_peas_stubble;
	private double producer_premium_canola_notill;
	private double producer_premium_barley_notill;
	private double producer_premium_wheat_notill;
	private double producer_premium_durum_notill;
	private double producer_premium_flax_notill;
	private double producer_premium_peas_notill;
	private double producer_premium_lentils_notill;
	private double government_premium_canola_notill;
	private double government_premium_barley_notill;
	private double government_premium_wheat_notill;
	private double government_premium_durum_notill;
	private double government_premium_flax_notill;
	private double government_premium_lentils_notill;
	private double government_premium_peas_notill;
	private double premiums_paid_producer;
	private double premiums_paid_government;	
	private double avg_producer_premium_con; //used in initialization as average in agristability expenses
	private double avg_producer_premium_notill;
	private double willows_on_natural_pasture;
	private double willows_on_improved_pasture;
	private double willows_on_hayland_pasture;
	private double willows_initial_investment;
	private double poplar_on_natural_pasture;
	private double poplar_on_improved_pasture;
	private double poplar_on_hayland_pasture;
	private double poplar_initial_investment;
	private double prairie_sandreed_on_natural_pasture;
	private double prairie_sandreed_on_improved_pasture;
	private double prairie_sandreed_on_hayland_pasture;
	private double prairie_sandreed_initial_investment;	
	private double poplar_yield_np_3;
	private double poplar_yield_np_6;
	private double poplar_yield_np_9;
	private double poplar_yield_np_12_21;	
	private double poplar_yield_ip_3;
	private double poplar_yield_ip_6;
	private double poplar_yield_ip_9;
	private double poplar_yield_ip_12_21;	
	private double poplar_yield_hayland_3;
	private double poplar_yield_hayland_6;
	private double poplar_yield_hayland_9;
	private double poplar_yield_hayland_12_21;	
	private double willow_yield_np_3;
	private double willow_yield_np_6;
	private double willow_yield_np_9;
	private double willow_yield_np_12_21;	
	private double willow_yield_ip_3;
	private double willow_yield_ip_6;
	private double willow_yield_ip_9;
	private double willow_yield_ip_12_21;	
	private double willow_yield_hayland_3;
	private double willow_yield_hayland_6;
	private double willow_yield_hayland_9;
	private double willow_yield_hayland_12_21;	
	private double willows_annualized_return_np;
	private double willows_annualized_return_ip;
	private double willows_annualized_return_hayland;	
	private double willows_annualized_cost_np;
	private double willows_annualized_cost_ip;
	private double willows_annualized_cost_hayland;	
	private double poplar_annualized_return_np;
	private double poplar_annualized_return_ip;
	private double poplar_annualized_return_hayland;	
	private double poplar_annualized_cost_np;
	private double poplar_annualized_cost_ip;
	private double poplar_annualized_cost_hayland;		
	

	private double rent_out_cropland;
	private double rent_out_natural_pasture;
	private double rent_out_improved_pasture;
	private double rent_out_hayland_pasture;	
	private double sizing_cropland_value;
	private double sizing_pastureland_value;	
	private double insurance_payout;
	private double total_insurance_payout;	
	private double total_eligible_netsales;
	private double total_crop_eligible_netsales;
	private double total_calf_eligible_netsales;
	private double total_energycrop_eligible_netsales;
	private int last_year_eligible_netsales;
	private int last_year_crop_eligible_netsales;
	private int last_year_calf_eligible_netsales;
	private int last_year_energycrop_eligible_netsales;
	private int two_yearsago_eligible_netsales;
	private int two_yearsago_crop_eligible_netsales;
	private int two_yearsago_energycrop_eligible_netsales;
	private int two_yearsago_calf_eligible_netsales;
	private int three_yearsago_eligible_netsales;
	private int three_yearsago_crop_eligible_netsales;
	private int three_yearsago_energycrop_eligible_netsales;
	private int three_yearsago_calf_eligible_netsales;
	private int four_yearsago_eligible_netsales;
	private int four_yearsago_crop_eligible_netsales;
	private int four_yearsago_energycrop_eligible_netsales;
	private int four_yearsago_calf_eligible_netsales;
	private int five_yearsago_eligible_netsales;
	private int five_yearsago_crop_eligible_netsales;
	private int five_yearsago_energycrop_eligible_netsales;
	private int five_yearsago_calf_eligible_netsales;
	private int eligible_sales_2006;
	private int eligible_sales_2007;	
	private double RM_2007_Con;
	private double RM_2006_Con;
	private double RM_2005_Con;
	private double RM_2004_Con;
	private double RM_2003_Con;
	private double RM_2007_NoTill;
	private double RM_2006_NoTill;
	private double RM_2005_NoTill;
	private double RM_2004_NoTill;
	private double RM_2003_NoTill;
	private double RM_Calf_2007;
	private double RM_Calf_2006;
	private double RM_Calf_2005;
	private double RM_Calf_2004;
	private double RM_Calf_2003;	
	private double farmer_contribution_agriinvest;
	private double fund_1;   //fund one is the farmer contributions in AgriInvest
	private double fund_2;   //fund two is the government matched contributions in AgriInvest plus the intetest from both fund one and fund two
	private double old_fund_1_balance;
	private double old_fund_2_balance;
	private double government_match_agriinvest;
	private double total_contribution_agriinvest;
	private double agristability_payment;
	private double reference_margin_cost;
	private double maximum_balance;
	private double account_balance;
	private double agriinvest_account_balance;
	private double interest_earned_fund_1;
	private double interest_earned_fund_2;
	private double agriinvest_withdrawal;
	private double agriinvest_withdrawal_fund_2;
	private double agriinvest_withdrawal_fund_1;
	private double total_income_margin;
	private double total_income_margin_percent;
	private double crop_rm_lastyear;
	private double crop_rm_two_years_ago; 
	private double crop_rm_three_years_ago;
	private double crop_rm_four_years_ago;
	private double crop_rm_five_years_ago;
	private double calf_rm_lastyear;
	private double calf_rm_two_years_ago; 
	private double calf_rm_three_years_ago;
	private double calf_rm_four_years_ago;
	private double calf_rm_five_years_ago;
	private double total_farm_reference_margin;
	private double crop_reference_margin;
	private double calf_reference_margin;
	private double energycrop_reference_margin;
	private double[] pre_farm_reference_margin_energycrop;
	private double[] pre_farm_reference_margin_crop;
	private double[] pre_farm_reference_margin_calf;
	private double total_farm_income_margin;	
	public int init_number_of_lands_marginal;
	public int init_number_of_lands_cropland;
	public int number_of_lands_marginal;
	public int number_of_lands_cropland;
	public int after_purchase_number_of_lands_cropland;
	public int after_purchase_number_of_lands_marginal;
	public double total_marginal_plots;
	public double total_cropland_plots;
	public double total_plots;
	public double total_marginal_plots_owned;
	public double total_marginal_plots_leased;
	public double total_cropland_plots_owned;
	public double total_cropland_plots_leased;	
	private double natural_pasture; //acres of natural pasture determined by MIP
	private double improved_pasture;
	private double hayland_pasture;
	private double pasture_carryover_one;  //pasture carryover to late pasture
	private double pasture_carryover_two;  //pasture carryover to fall pasture
	private double improved_bale_first_cut;
	private double improved_bale_second_cut;
	private double hay_production_one_cut;
	private double hay_production_two_cuts;
	private double buy_hay;
	private double buy_feed_wheat;
	private double buy_feed_barley;
	private double feed_early_summer_hay;
	private double feed_late_summer_hay;
	private double feed_fall_hay;
	private double feed_winter_hay;
	private double feed_wheat;
	private double feed_barley;
	private double feed_barley_notill;
	private double feed_wheat_notill;
	private double feed_barley_con;
	private double feed_wheat_con;
	private double barley_straw;
	private double wheat_straw;
	private double sell_hay;
	private double cows_head;
	private double n_cows;
	private double old_cows;
	private double n_cows_last_yr;
	private double n_cows_two_yrs;
	private double n_cows_three_yrs;
	private double n_cows_four_yrs;
	private double n_cows_five_yrs;
	private int cows_labour;
	private int rent_pasture_land;	
	private int livestock_labour;
	private double naturalpasture;
	private double improvedpasture;
	private double haylandpasture;
	private double willowsnaturalpasture;
	private double willowsimprovedpasture;
	private double willowshaylandpasture;
	private double willowsinitialinvestment;
	private double poplarnaturalpasture;
	private double poplarimprovedpasture;
	private double poplarhaylandpasture;
	private double poplarinitialinvestment;
	private double prairiesandreednaturalpasture;
	private double prairiesandreedimprovedpasture;
	private double prairiesandreedhaylandpasture;
	private double prairiesandreedinitialinvestment;	
	private double prairiesandreed_yield_np;
	private double prairiesandreed_yield_ip;
	private double prairiesandreed_yield_hayland;		
	private double pasturecarryoverone;
	private double pasturecarryovertwo;
	private double improvedbaleone;
	private double improvedbaletwo;
	private double haybaleone;
	private double haybaletwo;
	private double breakingcost;
	private double buyhay;
	private double buyfeedwheat;
	private double buyfeedbarley;	
	private double feedearlysummerhay;
	private double feedlatesummerhay;
	private double feedfallhay;
	private double feedwinterhay;	
	private double feedhay;
	private double feedwheat;
	private double feedbarley;
	private double feedwheatstraw;
	private double feedbarleystraw;
	private double sellhay;
	private double total_acres_before;
	private double breaking_cost; //annualized cost of breaking forage	
	private double exp_np_early_yield;
	private double exp_np_late_yield;
	private double exp_np_fall_yield;
	private double exp_ip_early_yield;
	private double exp_ip_late_yield;
	private double exp_ip_fall_yield;
	private double exp_hay_early_yield;
	private double exp_hay_late_yield;
	private double exp_hay_fall_yield;
	private double exp_ip_early_yield_bale_one;
	private double exp_ip_late_yield_bale_two;
	private double exp_hay_early_yield_bale_one;
	private double exp_hay_late_yield_bale_two;	
	private double ip_bale_one_yield;
	private double ip_bale_two_yield;
	private double hay_bale_one_yield;
	private double hay_bale_two_yield;	
	private double early_summer_mcals_required;
	private double late_summer_mcals_required;
	private double fall_mcals_required;
	private double winter_mcals_required;	
	private double total_np_mcals_early;
	private double total_np_mcals_late;
	private double total_np_mcals_fall;	
	private double total_ip_mcals_early;
	private double total_ip_mcals_late;
	private double total_ip_mcals_fall;	
	private double total_hayland_mcals_early;
	private double total_hayland_mcals_late;
	private double total_hayland_mcals_fall;	
	private double total_bale_mcals_early;
	private double total_bale_mcals_late;	
	private double actual_early_summer_mcals;
	private double actual_late_summer_mcals;
	private double actual_fall_mcals;
	private double actual_winter_mcals;	
	private double required_less_actual_early_mcals;
	private double required_less_actual_late_mcals;
	private double required_less_actual_fall_mcals;	
	private double exp_mcals_np_early_yield;
	private double exp_mcals_np_late_yield;
	private double exp_mcals_np_fall_yield;	
	private double exp_mcals_ip_early_yield;
	private double exp_mcals_ip_late_yield;
	private double exp_mcals_ip_fall_yield;	
	private double exp_mcals_hayland_early_yield;
	private double exp_mcals_hayland_late_yield;
	private double exp_mcals_hayland_fall_yield;	
	private double exp_mcals_ip_bale_one;
	private double exp_mcals_ip_bale_two;
	private double exp_mcals_hay_bale_one;
	private double exp_mcals_hay_bale_two;	
	private double total_improved_bale_one_mcals;
	private double total_improved_bale_two_mcals;
	private double total_haybaleone_mcals;
	private double total_haybaletwo_mcals;	
	private double weighted_avg_mcals_bale_one;
	private double weighted_avg_mcals_bale_two;	
	private double total_ip_bale_yield_one;
	private double total_hay_bale_yield_one;
	private double total_ip_bale_yield_two;
	private double total_hay_bale_yield_two;
	private double early_bale_avg_mcals;
	private double late_bale_avg_mcals;	
	private double[] early_mcal_energy_content;
	private double[] late_mcal_energy_content;
	private double[] fall_mcal_energy_content;
	private double[] winter_mcal_energy_content;	
	private double tonnes_crop_wheat_stubble;
	private double tonnes_crop_barley_stubble;
	private double tonnes_crop_wheat_sf;
	private double tonnes_crop_barley_notill;
	private double tonnes_crop_wheat_notill;
	private double tonnes_crop_feed_barley_notill;
	private double tonnes_crop_feed_wheat_notill;
	private double tonnes_crop_feed_barley_con;
	private double tonnes_crop_feed_wheat_con;
	private double purchase_hay;
	private double purchase_barley;
	private double earlyhay;
	private double latehay;
	private double fallhay;
	private double winterhay;
	private double winterbarley;
	private double winterwheat;
	private double barleystraw;
	private double wheatstraw;
	private double hayforsale;
	private double barleyforsale;
	private double wheatforsale;	
	private double cows_fc_handling_system;
	private double cows_fc_machinery;	
	private int average_years_in_grass;
	private int plots_in_grass;
	private int plots_in_prairie_sandreed;
	private int plots_in_willows;
	private int plots_in_poplar;
	private int average_years_in_prairie_sandreed;
	private int average_years_in_willows;
	private int average_years_in_poplar;
	private boolean will_cows;
	private boolean can_bid_on_cropland;
	private boolean can_bid_on_marginalland;
	private double total_mcals;	
	private int total_land_owned;
	private int total_land_leased;
	
	public void Generals(Variables VS) {
		Variables = VS;
	}

	Generals GS;
	Variables VS;

	public Producer(Context context, Variables VS, Generals GS, int px, int py,
			int ID) {
		this.farmer_id = ID;
		this.x = px;
		this.y = py;
		this.VS = VS;
		this.GS = GS;

		Parameters p = RunEnvironment.getInstance().getParameters();

		try {
			Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
		} catch (ClassNotFoundException ce) {
			System.out.println("SQLExceptiong:" + ce.getMessage());
		}		
		try {
			Connection conn = DriverManager.getConnection("jdbc:odbc:producerDB", "java", "1234");
			Statement stmt = conn.createStatement();
			ResultSet rs = stmt
					.executeQuery("select * from farmerInfo where id=" + ID);
			
			while (rs.next()) {
				age = rs.getInt("age");
				plots_needed = rs.getInt("plots-needed");
				summer_fallow_percent = rs.getDouble("paramether");
				begin_patch_ID = rs.getInt("begin-patch-id");
				debt = rs.getInt("debt");
				off_farm_inc = rs.getInt("off-farm-income");
				initial_d_a_ratio = rs.getDouble("D-A");
				if (off_farm_inc > 0) {
					off_farm_employ = true;
				}
				int w_cows=rs.getInt("will-cows");
				will_cows = false;
				
				if(w_cows==1) {
					will_cows = false;
					farmer_type = 1;
				}				
				if(w_cows==2) {
					will_cows = true;
					farmer_type = 2;
				}				
				if(w_cows==3) {
					will_cows = true;
					farmer_type = 3;
				}				
				if(summer_fallow_percent > .50) {
					summer_fallow_percent = .50;
				}
			}			
			rs.close();
			stmt.close();
			conn.close();			
		} catch (SQLException ce) {
			System.out.println("SQLException:" + ce.getMessage());
		}
				
		generation = 1;

		int risk_att = (int) (Math.random() * 3) + 1; // set risk parameter;
		
		if (risk_att == 1) {
			risk_parameter = 0.7;
		}
		if (risk_att == 2) {
			risk_parameter = 0.6;
		}
		if (risk_att == 3) {
			risk_parameter = 0.5;
		}
				
		double crop_insurance_coverage = (double) (Math.random() * 100); 
		
		if (crop_insurance_coverage <= 4.4) {
			crop_insurance_coverage_level = 0;
			wheat_premium = 0;
			durum_premium = 0;
			barley_premium = 0;
			canola_premium = 0;
			flax_premium = 0;
			peas_premium = 0;
			lentils_premium = 0;
			wheat_premium_gov = 0;
			durum_premium_gov = 0;
			barley_premium_gov = 0;
			canola_premium_gov = 0;
			flax_premium_gov = 0;
			peas_premium_gov = 0;
			lentils_premium_gov = 0;
		}		
		if (crop_insurance_coverage > 4.4 && crop_insurance_coverage <= 18) {
			crop_insurance_coverage_level = 0.60;
			wheat_premium = 0.0012;
			durum_premium = 0.002;
			barley_premium = 0.0028;
			canola_premium = 0.0048;
			flax_premium = 0.0055; 
			peas_premium = 0.0012; 
			lentils_premium = 0.0166; 
			wheat_premium_gov = 0.0018;
			durum_premium_gov = 0.0072;
			barley_premium_gov = 0.0042;
			canola_premium_gov = 0.0072;
			flax_premium_gov = 0.0082; 
			peas_premium_gov = 0.0018; 
			lentils_premium_gov = 0.0248; 
		}		
		if (crop_insurance_coverage > 18 && crop_insurance_coverage <= 52.1) {
			crop_insurance_coverage_level = 0.70;
			wheat_premium = 0.0043;
			durum_premium = 0.0049;
			barley_premium = 0.0075;
			canola_premium = 0.0076;
			flax_premium = 0.01; 
			peas_premium = 0.0025; 
			lentils_premium = 0.0269; 
			wheat_premium_gov = 0.0064;
			durum_premium_gov = 0.0073;
			barley_premium_gov = 0.0113;
			canola_premium_gov = 0.0114;
			flax_premium_gov = 0.015; 
			peas_premium_gov = 0.0037; 
			lentils_premium_gov = 0.0404; 
		}		
		if (crop_insurance_coverage > 52.1 && crop_insurance_coverage <= 100) {
			crop_insurance_coverage_level = 0.80;
			wheat_premium = 0.0078;
			durum_premium = 0.0079;
			barley_premium = 0.0131;
			canola_premium = 0.0125;
			flax_premium = 0.0189; 
			peas_premium = 0.0048; 
			lentils_premium = 0.0377; 
			wheat_premium_gov = 0.0117;
			durum_premium_gov = 0.0119;
			barley_premium_gov = 0.0196;
			canola_premium_gov = 0.0188;
			flax_premium_gov = 0.0284; 
			peas_premium_gov = 0.0072; 
			lentils_premium_gov = 0.0565; 
		}
		
		context.add(this); // add a new farm to the root context
		Grid grid = (Grid) context.getProjection("Simple Grid");
		ContinuousSpace space = (ContinuousSpace) context
				.getProjection("Continuous Space");
		grid.moveTo(this, x, y);
		space.moveTo(this, x, y, 0);
		setID(ID);
	}

	@Override
	public void step3() {
		if (Variables.getyear() == 0) {
			initialization_phase();
		} else {
			simulation_phase();
		}
	}
	
	public void initialization_phase() {		
		set_total_land();	
		set_total_land_lease_payment();
		update_acres();
		marginal_and_cropland_plots();		
		set_years_in_grass();
		set_initial_number_cows();
		set_initial_crop_machinery();
		set_initial_cow_machinery_and_handling_system();
		set_yield_exp();
		crop_insurance_premium();
		
		set_assets();				
		balance_sheet();
		update_acres();
		
		
		years_neg_cash = (int) (Math.random() * 3);
	}

	public void simulation_phase() {
	if(mylandList.size()>0) {				
			check_credit_borrowing_ability();
		}
	}

	public void set_total_land() {
		total_plots_owned = 0;
		total_plots_leased = 0;
		total_land_owned = 0; //used in landmarkets
		total_land_leased = 0; // used in landmarkets
		
		if(getmylandList() == null) {
			}
		else {
		
		for (int i = 0; i < getmylandList().size(); i++) {
			SAMA fdl1 = (SAMA) getmylandList().get(i);
						
			if (fdl1.getpatch_leased() == false) {				
				total_plots_owned = total_plots_owned + 1;
						
			} else {
				total_plots_leased = total_plots_leased + 1;
			}
			if(fdl1.getpatchtype() == 1) {
				if (fdl1.getOwner() == getfarmer_name()) {
					total_cropland_plots_owned = total_cropland_plots_owned + 1;
				}
				else if (fdl1.getrenter() == getfarmer_name()) {
					total_cropland_plots_leased = total_cropland_plots_leased + 1;
				}
			}
			if(fdl1.getpatchtype() == 2 || fdl1.getpatchtype() == 3) {
				if (fdl1.getOwner() == getfarmer_name()) {
					total_marginal_plots_owned = total_marginal_plots_owned + 1;
				}
				else if (fdl1.getrenter() == getfarmer_name()) {
					total_marginal_plots_leased = total_marginal_plots_leased + 1;
				}
			}
		}
		}
		total_marginal_plots = total_marginal_plots_owned + total_marginal_plots_leased;
		total_cropland_plots = total_cropland_plots_owned + total_cropland_plots_leased;
	}

	public void set_years_in_grass() {
		Parameters p = RunEnvironment.getInstance().getParameters();
		double barley_mcals = 0;
		double straw_mcals = 0;
		double pr_rating = 0;
		double pr_max_hay_yield = (Double)p.getValue("prmaxhayyield");	
		double Increase_NoTill = (Double) p.getValue("increaseNoTill");
		yield_mult = 1 + Increase_NoTill;
		
		for(int i=0;i<mylandList.size();i++) {
			SAMA fdl = (SAMA)mylandList.get(i);
			if(fdl.getpatchtype() == 2 || fdl.getpatchtype() == 3) {
				int count = i;
				count++;
			fdl.setyears_in_grass((int)(Math.random()*5+1));
			fdl.setin_grass(true);
			fdl.setin_prairiesandreed(false);
			setplots_in_grass(count);
			//setplots_in_prairie_sandreed(count);
			fdl.setyears_in_prairie_sandreed(0);
			fdl.setyears_in_willows(0);
			fdl.setyears_in_poplar(0);
			}			
			if(will_cows == true) {				
				if(fdl.getnpQuality() > pr_max_hay_yield) {
					pr_rating = pr_max_hay_yield;					
					exp_np_early_yield = (pr_rating / pr_max_hay_yield * ((Variables.getexpected_yield_list()[3])));
					exp_np_late_yield = (pr_rating / pr_max_hay_yield *  ((Variables.getexpected_yield_list()[3] * 0.6)));
					exp_np_fall_yield = (pr_rating / pr_max_hay_yield * ((Variables.getexpected_yield_list()[3] * 0.2)));
					exp_mcals_np_early_yield = (exp_np_early_yield * Variables.getmcals_ton_np_early());
					exp_mcals_np_late_yield = (exp_np_late_yield * Variables.getmcals_ton_np_late());
					exp_mcals_np_fall_yield =(exp_np_fall_yield * Variables.getmcals_ton_np_fall());
				}				
				else {
					pr_rating = fdl.getnpQuality();
					exp_np_early_yield = (pr_rating / pr_max_hay_yield  * Variables.getexpected_yield_list()[3]);// *((yield_exp_list[3])));
					exp_np_late_yield = (pr_rating / pr_max_hay_yield *  ((Variables.getexpected_yield_list()[3] * 0.6)));
					exp_np_fall_yield = (pr_rating / pr_max_hay_yield * ((Variables.getexpected_yield_list()[3] * 0.2)));
					exp_mcals_np_early_yield = (exp_np_early_yield * Variables.getmcals_ton_np_early());
					exp_mcals_np_late_yield = (exp_np_late_yield * Variables.getmcals_ton_np_late());
					exp_mcals_np_fall_yield =(exp_np_fall_yield * Variables.getmcals_ton_np_fall());
				}				
				if(fdl.getIPQuality() > pr_max_hay_yield) {
					pr_rating = pr_max_hay_yield;					
					exp_ip_early_yield = (pr_rating / pr_max_hay_yield * ((Variables.getexpected_yield_list()[3])));
					exp_ip_late_yield = (pr_rating / pr_max_hay_yield *  ((Variables.getexpected_yield_list()[3] * 0.6)));
					exp_ip_fall_yield = (pr_rating / pr_max_hay_yield * ((Variables.getexpected_yield_list()[3] * 0.2)));
					exp_ip_early_yield_bale_one = (pr_rating / pr_max_hay_yield * Variables.getexpected_yield_list()[3]);				
					exp_ip_late_yield_bale_two = (exp_ip_early_yield + (0.6 * exp_ip_early_yield)) ;	
					exp_mcals_ip_early_yield = (exp_ip_early_yield * Variables.getmcals_ton_ip_early());
					exp_mcals_ip_late_yield = (exp_ip_late_yield * Variables.getmcals_ton_ip_late());
					exp_mcals_ip_fall_yield = (exp_ip_fall_yield * Variables.getmcals_ton_ip_fall());
				}				
				else {
					pr_rating = fdl.getIPQuality();
					exp_ip_early_yield = (pr_rating / pr_max_hay_yield * ((Variables.getexpected_yield_list()[3])));
					exp_ip_late_yield = (pr_rating / pr_max_hay_yield *  ((Variables.getexpected_yield_list()[3] * 0.6)));
					exp_ip_fall_yield = (pr_rating / pr_max_hay_yield * ((Variables.getexpected_yield_list()[3] * 0.2)));
					exp_ip_early_yield_bale_one = (pr_rating / pr_max_hay_yield * Variables.getexpected_yield_list()[3]);				
					exp_ip_late_yield_bale_two = (exp_ip_early_yield + (0.6 * exp_ip_early_yield)) ;	
					exp_mcals_ip_early_yield = (exp_ip_early_yield * Variables.getmcals_ton_ip_early());
					exp_mcals_ip_late_yield = (exp_ip_late_yield * Variables.getmcals_ton_ip_late());
					exp_mcals_ip_fall_yield = (exp_ip_fall_yield * Variables.getmcals_ton_ip_fall());
				}				
				if(fdl.getHayQuality() > pr_max_hay_yield) {
					pr_rating = pr_max_hay_yield;				
					exp_hay_early_yield = (pr_rating / pr_max_hay_yield * ((Variables.getexpected_yield_list()[3])));
					exp_hay_late_yield = (pr_rating / pr_max_hay_yield *  ((Variables.getexpected_yield_list()[3] * 0.6)));
					exp_hay_fall_yield = (pr_rating / pr_max_hay_yield * ((Variables.getexpected_yield_list()[3] * 0.2)));
					exp_hay_early_yield_bale_one = (pr_rating / pr_max_hay_yield * Variables.getexpected_yield_list()[3]);				
					exp_hay_late_yield_bale_two = (exp_hay_early_yield + (0.6 * exp_hay_early_yield)) ;	
					exp_mcals_hayland_early_yield = (exp_hay_early_yield * Variables.getmcals_ton_hayland_early());
					exp_mcals_hayland_late_yield = (exp_hay_late_yield * Variables.getmcals_ton_hayland_late());
					exp_mcals_hayland_fall_yield = (exp_hay_fall_yield * Variables.getmcals_ton_hayland_fall());
				}				
				else {
					pr_rating = fdl.getHayQuality();				
					exp_hay_early_yield = (pr_rating / pr_max_hay_yield * ((Variables.getexpected_yield_list()[3])));
					exp_hay_late_yield = (pr_rating / pr_max_hay_yield *  ((Variables.getexpected_yield_list()[3] * 0.6)));
					exp_hay_fall_yield = (pr_rating / pr_max_hay_yield * ((Variables.getexpected_yield_list()[3] * 0.2)));
					exp_hay_early_yield_bale_one = (pr_rating / pr_max_hay_yield * Variables.getexpected_yield_list()[3]);				
					exp_hay_late_yield_bale_two = (exp_hay_early_yield + (0.6 * exp_hay_early_yield)) ;	
					exp_mcals_hayland_early_yield = (exp_hay_early_yield * Variables.getmcals_ton_hayland_early());
					exp_mcals_hayland_late_yield = (exp_hay_late_yield * Variables.getmcals_ton_hayland_late());
					exp_mcals_hayland_fall_yield = (exp_hay_fall_yield * Variables.getmcals_ton_hayland_fall());
				}
				
				haybaleone = total_hay;
				
				
							
				
				set_yield_exp();
				if(total_crop_acres >= 2000){
				 barley_mcals = ((fdl.getBarleyYieldIndex() * yield_mult * yield_exp_list[1])/45.93) * 3394 * total_crop_acres * 0.1375;				
				}
				if(total_crop_acres < 2000) {
					 barley_mcals = ((fdl.getBarleyYieldIndex()  * yield_exp_list[1])/45.93) * 3394 * total_crop_acres * 0.15;					
				}
				
				total_mcals = (exp_mcals_np_early_yield + exp_mcals_np_late_yield + exp_mcals_np_fall_yield) * total_natural_pasture +
				(exp_mcals_ip_early_yield + exp_mcals_ip_late_yield + exp_mcals_ip_fall_yield) * total_improved_pasture +
				(exp_mcals_hayland_early_yield + exp_mcals_hayland_late_yield + exp_mcals_hayland_fall_yield) * total_hay + barley_mcals + straw_mcals;
			}
		}
	}
	
	public void set_initial_number_cows () {  //winter mcals set at 1.3 times required to represent 30% hay reserves for haystoragemax
		
		if(will_cows == true) {
			if(farmer_type == 3) {
				setn_cows((int) (total_mcals/(Variables.getmcals_required_early_summer() + Variables.getmcals_required_late_summer() + Variables.getmcals_required_fall() + (Variables.getmcals_required_winter()*1.3))));
				
				if(n_cows < 15) {
				setn_cows(0);
			}
			}
			if(farmer_type == 2) {				
				setn_cows((int) (total_mcals/(Variables.getmcals_required_early_summer() + Variables.getmcals_required_late_summer() + Variables.getmcals_required_fall() + (Variables.getmcals_required_winter()*1.3))));

				if(n_cows < 15) {
				setn_cows(0);
			}
			}
			}
		else {
			setn_cows(0);
			}
	}
	
	public void set_initial_cow_machinery_and_handling_system() {
		int random_age = (int) (Math.random() * 2);		
		Parameters p = RunEnvironment.getInstance().getParameters();
		double inv_handling = (Double) p.getValue("invhandling");
		double inv_cow_machine = (Double) p.getValue("invcowmachine");
				
		if(getn_cows() > 0) {
			//System.out.println("Has Cows");
			if(getn_cows() > 10 && getn_cows() <= 30) {
				//System.out.println("10 to 30 cows");
			handling_system_age = (int) (15 + random_age);
			cow_machine_age = (int) (15 + random_age);
			handling_system_value = (int) (Math.round(inv_handling * 0.948 * Math.pow(0.901, (handling_system_age -1))));
			cow_machine_value = (int) (Math.round(inv_cow_machine * 0.948 * Math.pow(0.901, (cow_machine_age -1))));
			livestock_equipment_value = handling_system_value + cow_machine_value;
			}		
		if(getn_cows() > 30 && getn_cows() <= 70) {
			//System.out.println("30 to 70 cows");
			handling_system_age = (int) (10 + random_age);
			cow_machine_age = (int) (10 + random_age);
			handling_system_value = (int) (Math.round(inv_handling * 0.948 * Math.pow(0.901, (handling_system_age -1))));
			cow_machine_value = (int) (Math.round(inv_cow_machine * 0.948 * Math.pow(0.901, (cow_machine_age -1))));
			livestock_equipment_value = handling_system_value + cow_machine_value;
			}		
		if(getn_cows() > 70 && getn_cows() <= 100) {
			//System.out.println("70 to 100 cows");
			handling_system_age = (int) (5 + random_age);
			cow_machine_age = (int) (5 + random_age);
			handling_system_value = (int) (Math.round(inv_handling * 0.948 * Math.pow(0.901, (handling_system_age -1))));
			cow_machine_value = (int) (Math.round(inv_cow_machine * 0.948 * Math.pow(0.901, (cow_machine_age -1))));
			livestock_equipment_value = handling_system_value + cow_machine_value;
			}		
		if(getn_cows() > 100 && getn_cows() <=300) {
			//System.out.println("100 to 300 cows");
			handling_system_age = (int) (random_age);
			cow_machine_age = (int) (random_age);
			handling_system_value = (int) (Math.round(inv_handling * 0.948 * Math.pow(0.901, (handling_system_age -1))));
			//System.out.println("handling" + handling_system_value);
			cow_machine_value = (int) (Math.round(inv_cow_machine * 0.948 * Math.pow(0.901, (cow_machine_age -1))));
			livestock_equipment_value = (int) (handling_system_value + cow_machine_value);
			//System.out.println("livestock equipment value" + livestock_equipment_value);
			}		
		if(getn_cows() > 300 && getn_cows() <=600) {
			//System.out.println("300 to 600 cows");
			handling_system_age = (int) (random_age);
			cow_machine_age = (int) (random_age);
			handling_system_value = (int) (Math.round((2*inv_handling) * 0.948 * Math.pow(0.901, (handling_system_age -1))));
			cow_machine_value = (int) (Math.round((2*inv_cow_machine) * 0.948 * Math.pow(0.901, (cow_machine_age -1))));
			livestock_equipment_value = handling_system_value + cow_machine_value;
			
			}		
		if(getn_cows() > 600 && getn_cows() <=900) {
			//System.out.println("600 to 900 cows");
			handling_system_age = (int) (random_age);
			cow_machine_age = (int) (random_age);
			handling_system_value = (int) (Math.round((3*inv_handling) * 0.948 * Math.pow(0.901, (handling_system_age -1))));
			cow_machine_value = (int) (Math.round((3*inv_cow_machine) * 0.948 * Math.pow(0.901, (cow_machine_age -1))));
			livestock_equipment_value = handling_system_value + cow_machine_value;
			}
		}
	}
	
	public void set_initial_crop_machinery () {
		int random_age = (int) (Math.random() * 2);
		
		Parameters p = RunEnvironment.getInstance().getParameters();
		double Inv_Mach_0 = (Double) p.getValue("inv_Mach_0"); // Investment
		double Inv_Mach_1 = (Double) p.getValue("inv_Mach_1"); // Investment
		double Inv_Mach_2 = (Double) p.getValue("inv_Mach_2"); // Investment
		double Inv_Mach_3 = (Double) p.getValue("inv_Mach_3"); // Investment
		double Inv_Mach_4 = (Double) p.getValue("inv_Mach_4"); // Investment
		double Inv_Mach_5 = (Double) p.getValue("inv_Mach_5"); // Investment
		double Inv_Mach_6 = (Double) p.getValue("inv_Mach_6"); // Investment
		double Inv_Mach_7 = (Double) p.getValue("inv_Mach_7"); // Investment
		double Inv_Mach_8 = (Double) p.getValue("inv_Mach_8"); // Investment
		double Inv_Mach_9 = (Double) p.getValue("inv_Mach_9"); // Investment
		double newcost0 = (Double) p.getValue("newcost0");
		double newcost1 = (Double) p.getValue("newcost1");
		double newcost2 = (Double) p.getValue("newcost2");	
		double newcost3 = (Double) p.getValue("newcost3");
		double newcost4 = (Double) p.getValue("newcost4");
		double newcost5 = (Double) p.getValue("newcost5");
		double newcost6 = (Double) p.getValue("newcost6");	
		double newcost7 = (Double) p.getValue("newcost7");
		double newcost8 = (Double) p.getValue("newcost8");	
		double newcost9 = (Double) p.getValue("newcost9");
		
		int newValue = 0;
		if(total_crop_acres > 0 && total_crop_acres <= 500) {
			crop_machine_option = 0;
			crop_machine_age = (int) (15 + random_age);
			newValue = (int) newcost0;
			crop_machine_value = (int) (Math.round(newValue * 0.948 * Math.pow(0.901, (crop_machine_age -1))));
		}		
		if(total_crop_acres > 500 && total_crop_acres <= 1300) {
			crop_machine_option = 1;
			crop_machine_age = (int) (10 + random_age);
			newValue = (int) newcost1;
			crop_machine_value = (int) (Math.round(newValue * 0.948 * Math.pow(0.901, (crop_machine_age -1))));
		}		
		if(total_crop_acres > 1300 && total_crop_acres <= 2000) {
			crop_machine_option = 2;
			crop_machine_age = 5;
			newValue = (int) newcost2;
			crop_machine_value = (int) (Math.round(newValue * 0.948 * Math.pow(0.901, (crop_machine_age -1))));
		}		
		if(total_crop_acres > 2000 && total_crop_acres <= 3200) {
			crop_machine_option = 3;
			crop_machine_age = 0;
			newValue = (int) newcost3;
			crop_machine_value = (int) (Math.round(newValue));
			}		
		if(total_crop_acres > 3200 && total_crop_acres <= 4300) {
			crop_machine_option = 4;
			crop_machine_age = 0;
			newValue = (int) newcost4;
			crop_machine_value = (int) (Math.round(newValue));
		}		
		if(total_crop_acres > 4300 && total_crop_acres <= 9000) {
			crop_machine_option = 5;
			crop_machine_age = 0;
			newValue = (int) newcost5;
			crop_machine_value = (int) (Math.round(newValue));
		}		
		if(total_crop_acres > 9000 && total_crop_acres <= 12300) {
			crop_machine_option = 6;
			crop_machine_age = 0;
			newValue = (int) newcost6;
			crop_machine_value = (int) (Math.round(newValue));
		}		
		if(total_crop_acres > 12300 && total_crop_acres <= 18000) {
			crop_machine_option = 7;
			crop_machine_age = 0;
			newValue = (int) newcost7;
			crop_machine_value = (int) (Math.round(newValue));
		}		
		if(total_crop_acres > 18000 && total_crop_acres <= 23500) {
			crop_machine_option = 8;
			crop_machine_age = 0;
			newValue = (int) newcost8;
			crop_machine_value = (int) (Math.round(newValue));
		}		
		if(total_crop_acres > 23500) {
			crop_machine_option = 9;
			crop_machine_age = 0;
			newValue = (int) newcost9;
			crop_machine_value = (int) (Math.round(newValue));
		}		
	}
	
	public void update_acres() {

		total_crop_acres = 0;
		total_hay = 0;
		total_improved_pasture = 0;
		total_natural_pasture = 0;
		total_acres_farmed = 0; 
		total_acres_owned = 0;
		total_acres_leased = 0;
		total_plots_owned = 0;
		total_plots_leased = 0;
		
		for (int i = 0; i < getmylandList().size(); i++) {
			SAMA fdl1 = (SAMA) getmylandList().get(i);
				if (fdl1.getOwner() == getfarmer_name()) {
				total_acres_owned = total_acres_owned + fdl1.getacres();
				total_plots_owned = total_plots_owned + 1;
				total_land_owned = total_land_owned + 1;  // this is used in land markets
				total_crop_acres = total_crop_acres + fdl1.gettilled_crop();
				total_hay = total_hay + fdl1.gettilled_hay() + fdl1.gethay_hay();
				total_improved_pasture = total_improved_pasture + fdl1.gettilled_pasture() + fdl1.gethay_pasture() + fdl1.getIP();
				total_natural_pasture = total_natural_pasture + fdl1.getnp();
				
			} else if (fdl1.getrenter() == getfarmer_name()) {
				total_plots_leased = total_plots_leased + 1;
				total_land_leased = total_land_leased + 1; // this is used in land markets
				total_acres_leased = total_acres_leased + fdl1.getacres();
				total_crop_acres = total_crop_acres + fdl1.gettilled_crop();
				total_hay = total_hay + fdl1.gettilled_hay() + fdl1.gethay_hay();
				total_improved_pasture = total_improved_pasture + fdl1.gettilled_pasture() + fdl1.gethay_pasture() + fdl1.getIP();
				total_natural_pasture = total_natural_pasture + fdl1.getnp();
			}
		}
		total_acres_farmed =  total_acres_owned + total_acres_leased; 
		marginal_and_cropland_plots();
	}

	public void marginal_and_cropland_plots() {
		total_marginal_plots = 0;
		total_cropland_plots = 0;
		total_marginal_plots_owned = 0;
		total_marginal_plots_leased = 0;
		total_cropland_plots_owned = 0;
		total_cropland_plots_leased = 0;
		for (int i = 0; i < getmylandList().size(); i++) {
			SAMA fdl1 = (SAMA) getmylandList().get(i);
			if(fdl1.getpatchtype() == 1) {
				if (fdl1.getOwner() == getfarmer_name()) {
					total_cropland_plots_owned = total_cropland_plots_owned + 1;
				}
				else if (fdl1.getrenter() == getfarmer_name()) {
					total_cropland_plots_leased = total_cropland_plots_leased + 1;
				}
			}
			if(fdl1.getpatchtype() == 2 || fdl1.getpatchtype() == 3) {
				if (fdl1.getOwner() == getfarmer_name()) {
					total_marginal_plots_owned = total_marginal_plots_owned + 1;
				}
				else if (fdl1.getrenter() == getfarmer_name()) {
					total_marginal_plots_leased = total_marginal_plots_leased + 1;
				}
			}
			}
			total_marginal_plots = total_marginal_plots_owned + total_marginal_plots_leased;
			total_cropland_plots = total_cropland_plots_owned + total_cropland_plots_leased;
			total_plots = total_marginal_plots + total_cropland_plots;
		}
	
	
	
	public void set_debt() {
		
		Parameters p = RunEnvironment.getInstance().getParameters();		
		double interest_rate = (Double) p.getValue("interestRate");
		double loan_factor_payment_10 = (interest_rate / (1 - (1 / (Math.pow(
				1 + interest_rate, 10)))));
					
		debt = (int) Math.round(debt * total_acres_farmed);
	
		double payment = Math.round(debt * loan_factor_payment_10 * 100.0) / 100.0;
		debtList debtLst = new debtList();
		debtLst.setyears_remaining(10);
		debtLst.setannual_payment(payment);
		debtLst.setdebt((int) debt);
		this.debt_list.add(debtLst);
		debt_payment = payment;
	}

	public void buy_machine() {
		Parameters p = RunEnvironment.getInstance().getParameters();
		double down_payment = (Double) p.getValue("downPayment");
		double buy_new_machine = 0;
		if(getselloldequipment() == true) {
			buy_new_machine = crop_machine_value;
		}
		else {
			buy_new_machine = 0;
		}
		if(buy_new_machine > 0) {	
					
				double money_down = down_payment * buy_new_machine;
				cash = (int) (Math.round(cash - money_down));
				double payment = Math.round((1 - down_payment)
						* buy_new_machine
						* Variables.getloan_factor_payment_5() * 100.0) / 100.0;
				debtList debtLst = new debtList();
				debtLst.setyears_remaining(5);
				debtLst.setannual_payment(payment);
				debtLst.setdebt((int) (Math.round((1 - down_payment)
						* buy_new_machine)));
				this.debt_list.add(debtLst);
				debt = (int) (debt + (1 - down_payment) * buy_new_machine);
			
				debt_payment = debt_payment + payment;
			}
	}


	public void balance_sheet() {
		if(Variables.getyear()== 0) {
			double calf_price_2007 = 1.0971;
			NewCostCow = ((0.7679 * calf_price_2007))* 1300;
		}else {
		NewCostCow = ((0.7679 * Variables.getprice_calf()))* 1300;		
		}
		double all_patches_avg_prod = Variables.getall_patches_avg_prod();
		double avg_land_q = 0;
		double avg_land_m = 0;
		int NumOfOwn = 0;
		int NumOfOwn1 = 0;
		if (total_plots_owned > 0) {
			
			for (int i = 0; i < getmylandList().size(); i++) {
				SAMA fdl1 = (SAMA) getmylandList().get(i);
				if (fdl1.getOwner() == getfarmer_name()) {
					if(fdl1.getpatchtype() == 1) {
					avg_land_q = avg_land_q + fdl1.getAvg_prod_patch();
					NumOfOwn = NumOfOwn + 1;
					}
					else {
						if(fdl1.getpatchtype() == 2 || fdl1.getpatchtype() == 3) {
							avg_land_m = avg_land_m + fdl1.getAvg_prod_patch();
							NumOfOwn1 = NumOfOwn1 + 1;
					}
				}
			}
			}
			
			}
		avg_land_q = avg_land_q / NumOfOwn;		
		avg_land_m = avg_land_m / NumOfOwn1;
		cropland_value_int =  (int) ((Variables.getcropland_price() * avg_land_q
				/ all_patches_avg_prod * total_crop_acres));
		marginalland_value_int =  (int) ((Variables.getmarginalland_price() * avg_land_m / all_patches_avg_prod * (total_hay + total_improved_pasture + total_natural_pasture)));
		
		land_value = cropland_value_int + marginalland_value_int;
	
		cow_value = (int) (n_cows * Variables.getprice_calf() * 495 + (n_cows * NewCostCow)); //1300 lbs average includes cow/calf
		capital_value = crop_machine_value + livestock_equipment_value;
		assets = (int) (land_value + misc_value + capital_value + cash + cow_value + total_contribution_agriinvest);
		equity = (int) (assets - debt);
	}

	public void set_assets() {

		Parameters p = RunEnvironment.getInstance().getParameters();
		int min_initial_cash = (Integer) p.getValue("mininitialcash");	
		double calf_price_2007 = 1.0971;
		NewCostCow = ((0.7679 * calf_price_2007))* 1300;	

		if (total_plots_owned > 0) {
			//System.out.println("INSIDE LAND ASSETS");
			cropland_value_int = 0;
			marginalland_value_int = 0;
			for (int i = 0; i < mylandList.size(); i++) {
				SAMA sama = (SAMA) mylandList.get(i);
				if (sama.getOwner() == getfarmer_name()) {
					//System.out.println("inside own land");
					if(sama.getpatchtype() == 1) {
						//System.out.println("inside cropland");
					cropland_value_int = (int) (cropland_value_int + sama.getAvg_prod_patch()
							/ Variables.getmean_patch_quality()
							* Variables.getcropland_price() * sama.getacres());
					} 
					if(sama.getpatchtype() == 3 || sama.getpatchtype() == 2) {
						//System.out.println("inside marginalland");
						marginalland_value_int = (int) (marginalland_value_int + sama.getAvg_prod_patch()
						/ Variables.getmean_patch_quality()
						* Variables.getmarginalland_price() * sama.getacres());
					}
				}
				}
			
		}
		land_value = (int) (Math.round(cropland_value_int + marginalland_value_int));
		capital_value = (int) (Math.round(crop_machine_value + livestock_equipment_value));
		cow_value = (int) ((n_cows * NewCostCow) + (n_cows * calf_price_2007 * 495));  //expected price list for calf is zero at initialization
		int random_cash = (int) (Math.random() * 5);
		cash = (int) (((50 + random_cash) *(total_crop_acres + 4 * n_cows)) + off_farm_inc);
		
		initialagriinvest_account_balance();
		government_payments();
		
		assets = (int) (land_value + misc_value + capital_value + cow_value + cash + agriinvest_account_balance);
		set_debt();
		equity = (int) (Math.round(assets - debt));
	}

	public void update_age() {
		Parameters p = RunEnvironment.getInstance().getParameters();
		int pre_retirement_age = (Integer) p.getValue("pre_retirement_age");
		double retirement_tendency_55_59 = (Double) p
		.getValue("retirementtendency5559");
		double retirement_tendency_60_64 = (Double) p
		.getValue("retirementtendency6064");
		double retirement_tendency_65_69 = (Double) p
		.getValue("retirementtendency6569");
		double retirement_tendency_70_over = (Double) p
		.getValue("retirementtendency70over");
		age = age + 1;
		for(int i = 0; i<mylandList.size();i++){
			SAMA sama = (SAMA) mylandList.get(i);
			if(sama.getin_willows() == true) {
				sama.setyears_in_willows(sama.getyears_in_willows()+1);
			}
			if(sama.getin_poplar()== true){
				sama.setyears_in_poplar(sama.getyears_in_poplar()+1);
			}
			if(sama.getin_grass()== true){
				sama.setyears_in_grass(sama.getyears_in_grass()+1);
				//System.out.println("in grass true");
				if(sama.getyears_in_grass()== 7){
					//System.out.println("grass is 7" + "farmer" + getfarmer_name());
					breaking_cost = breaking_cost + sama.getacres();
					sama.setyears_in_grass(0);
				}
			}
			if(sama.getin_prairiesandreed()== true){
				sama.setyears_in_prairie_sandreed(sama.getyears_in_prairie_sandreed()+1);
			}
			
			if(sama.getrenter() != 9999){
				sama.setlease_term(sama.getlease_term()+1);
				if(sama.getlease_term()==7){					
					if(age <  pre_retirement_age){ //farmer will renew lease if under pre-retirement age
						//System.out.println("renew lease" + getfarmer_name() + "plot" + sama.getID());
						sama.setlease_term(0);
					}
					else if (age >= 57 && age < 63 && Math.random() > retirement_tendency_55_59 || total_plots == 1) {
						sama.setlease_term(3);		//renew lease for four more years
						//System.out.println("renew lease" + getfarmer_name() + "plot" + sama.getID());
					}else if (age >= 64 && age < 68 && Math.random() > retirement_tendency_60_64 || total_plots == 1) {
						//System.out.println("renew lease" + getfarmer_name() + "plot" + sama.getID());
						sama.setlease_term(4);  	//renew lease for three more years	
					} else if (age >= 69 && age < 74 && Math.random() > retirement_tendency_65_69 || total_plots == 1) {
						sama.setlease_term(5); 		//renew lease for two more years
					} else if (age >= 75 && age < 80 && total_plots == 1) {					
						sama.setlease_term(6);		//renew lease for one more year			
					}else{
						//System.out.println("LEASE EXPIRE" + getfarmer_name() + "plot" + sama.getID());
					sama.setcurrent_producer(9999);
					sama.setrenter(9999);
					deleteland(sama);
					sama.setfor_sale(true);	
					}
				}
				}
			}
			
		
		set_breaking();
		update_acres();
	}

	public void production() {
		crop_production();
	}

	public void crop_production() {
		
		Parameters p = RunEnvironment.getInstance().getParameters();
		
				
		income_margin();
		
					
			if(old_cows > 0){ //the old herd size the farmer just sold off affects reference margin
				total_farm_reference_margin = (total_crop_acres * crop_reference_margin) + (old_cows * calf_reference_margin);
		//	System.out.println("OLD OLD COWS" + "farmer" + getfarmer_name());
			}
			else {		
				total_farm_reference_margin = (total_crop_acres * crop_reference_margin) + (n_cows * calf_reference_margin);
			}
		
		crop_insurance();
		agriinvest();
		agristability();
		
		if(getparticipate_agristability() == true){
			
			
			total_farm_income_margin = gross_income/total_farm_reference_margin;
			
			if(total_farm_income_margin < 0){
//			System.out.println("total_Farm_income_margin"+ total_farm_income_margin);
//			System.out.println("total_farm_reference_margin" + total_farm_reference_margin);
//			System.out.println("Margin Decline" + gross_income);
		
			double program_year_negative_margin = total_farm_reference_margin - gross_income;
			
			//System.out.println("program_year_negative_margin" + program_year_negative_margin);
			}
			if(total_farm_income_margin > 0 && total_farm_income_margin <= 0.85){ // Does not take into account negative ref
				
		//	System.out.println("ref margin " + total_farm_income_margin + "farmer" + getfarmer_name());
			agristability_payment = 0.7 * (0.85 * total_farm_reference_margin - (gross_income + total_insurance_payout)); 
			if(agristability_payment > 3000000) {
				agristability_payment = 3000000;
			}
			cash = (int) (cash + agristability_payment);
			
		//	System.out.println("agristability_payment" + agristability_payment);
			if(agristability_payment < 0) {
			//	System.out.println("negative");
				agristability_payment = 0;
			}
			}
			
			}
		
		if(cash < 0 || total_farm_income_margin <= 0.90) {
			agriinvest_withdrawal = (total_farm_reference_margin - gross_income);
			if(agriinvest_withdrawal < 0){
				agriinvest_withdrawal = -agriinvest_withdrawal;
			}
			
				if(fund_2 > 0 ) {
					if(fund_2 > agriinvest_withdrawal) {
						//System.out.println("fund 2 balance" + fund_2 +"farmer" + getfarmer_name());
				agriinvest_withdrawal_fund_2 = agriinvest_withdrawal;
				//System.out.println("agriinvest_withdrawal_fund_2 =" + agriinvest_withdrawal_fund_2);
				fund_2 = fund_2 - agriinvest_withdrawal_fund_2;
				//System.out.println("fund 2 here" + fund_2);
					}
					else{
						agriinvest_withdrawal_fund_2 = fund_2;
						//System.out.println("agriinvest_withdrawal_fund_2 =" + agriinvest_withdrawal_fund_2);
						fund_2 = fund_2 - agriinvest_withdrawal_fund_2;
						//System.out.println("fund 2 there" + fund_2);
					}
					
			}
			else if(getfund_1() > 0) {
					if(getfund_1() > agriinvest_withdrawal) {
						agriinvest_withdrawal_fund_1 = agriinvest_withdrawal;
						fund_1 = fund_1 - agriinvest_withdrawal_fund_1;
				}
					else{
						agriinvest_withdrawal_fund_1 = fund_1;
						fund_1 = fund_1 - agriinvest_withdrawal_fund_1;
					}
			}
		}
		agriinvest_account_balance = fund_1 + fund_2;
		}
		
	
	
	public void fixed_costs() {
		debt_service();
		set_total_land_lease_payment();
	}

	public void debt_service() {

		Parameters p = RunEnvironment.getInstance().getParameters();
		double interest_rate = (Double) p.getValue("interestRate");

		double result2 = add1(this.debt_list); // calculates annual debt payment
		debt_payment = result2;

		for (int i = 0; i < debt_list.size(); i++) {
			debtList debtLst = (debtList) debt_list.get(i);
			debtLst.setyears_remaining(debtLst.getyears_remaining() - 1); // reduces
			// years left on debt
		}

		for (int i = (debt_list.size() - 1); i >= 0; i--) {
			debtList debtLst = (debtList) debt_list.get(i);
			if (debtLst.getyears_remaining() == 0) {
				debt_list.remove(i); // remove paid off debt
				}
		}

		for (int i = 0; i < debt_list.size(); i++) {
			debtList debtLst = (debtList) debt_list.get(i);
			debtLst.setdebt((int) (Math.round(debtLst.getannual_payment()
					* ((1 - (1 / Math.pow((1 + interest_rate), debtLst
							.getyears_remaining()))) / interest_rate))));
		}

		int result3 = add2(debt_list);// update total debt-value (principal
		// remaining for all debts)
		debt = result3;
	}

	public void set_total_land_lease_payment() {
		Parameters p = RunEnvironment.getInstance().getParameters();
		
		int initial_lease_rate = (Integer)p.getValue("initialleaserate");
		total_land_lease_payment = 0;
		total_crop_lease_payment = 0;
		total_marginal_lease_payment = 0;
		for (int i = 0; i < mylandList.size(); i++) {
			SAMA fdl1 = (SAMA) mylandList.get(i);
			
			if(fdl1.getpatchtype()== 1){
			total_crop_lease_payment = total_crop_lease_payment
					+ fdl1.getlease_payment() * fdl1.getacres();
			}
			if(fdl1.getpatchtype()==2 || fdl1.getpatchtype()==3){
				total_marginal_lease_payment = total_marginal_lease_payment
				+ fdl1.getlease_payment_pasture() * fdl1.getacres();
			}
			
		}
		total_crop_lease_payment = Math.round(total_crop_lease_payment);
		total_marginal_lease_payment = Math.round(total_marginal_lease_payment);
		
		
	}

	public double add1(ArrayList a) {
		if (a == null) {
			
		}
		double result = 0;
		for (int i = 0; i < a.size(); i++) {
			debtList debtLst = (debtList) a.get(i);
			result = result + debtLst.getannual_payment();
		}
		return result;
	}

	public int add2(ArrayList a) {
		int result = 0;
		for (int i = 0; i < a.size(); i++) {
			debtList debtLst = (debtList) a.get(i);
			result = result + debtLst.getdebt();
		}
		return result;
	}
	
	public void cow_equip_depreciation() {
		Parameters p = RunEnvironment.getInstance().getParameters();
		double inv_handling = (Double) p.getValue("invhandling");
		double inv_cow_machine = (Double) p.getValue("invcowmachine");
		cow_machine_age = cow_machine_age + 1;
		handling_system_age = handling_system_age + 1;
		
		
		if(getn_cows() > 10 && getn_cows() <=300) {
			handling_system_value = (int) (Math.round(inv_handling * 0.948 * Math.pow(0.901, (handling_system_age))));
			cow_machine_value = (int) (Math.round(inv_cow_machine * 0.948 * Math.pow(0.901, (cow_machine_age))));
			livestock_equipment_value = handling_system_value + cow_machine_value;
		}		
		if(getn_cows() > 300 && getn_cows() <=600) {
			handling_system_value = (int) (Math.round(inv_handling*2 * 0.948 * Math.pow(0.901, (handling_system_age))));
			cow_machine_value = (int) (Math.round(inv_cow_machine*2 * 0.948 * Math.pow(0.901, (cow_machine_age))));
			livestock_equipment_value = handling_system_value + cow_machine_value;		
		}		
		if(getn_cows() > 600 && getn_cows() <=900) {
			handling_system_value = (int) (Math.round(inv_handling*3 * 0.948 * Math.pow(0.901, (handling_system_age))));
			cow_machine_value = (int) (Math.round(inv_cow_machine*3 * 0.948 * Math.pow(0.901, (cow_machine_age))));
			livestock_equipment_value = handling_system_value + cow_machine_value;				
		}
		if(getn_cows() > 900 && getn_cows() <=1200) {
			handling_system_value = (int) (Math.round(inv_handling*4 * 0.948 * Math.pow(0.901, (handling_system_age))));
			cow_machine_value = (int) (Math.round(inv_cow_machine*4 * 0.948 * Math.pow(0.901, (cow_machine_age))));
			livestock_equipment_value = handling_system_value + cow_machine_value;				
		}
		if(getn_cows() > 1200 && getn_cows() <=1500) {
			handling_system_value = (int) (Math.round(inv_handling*5 * 0.948 * Math.pow(0.901, (handling_system_age))));
			cow_machine_value = (int) (Math.round(inv_cow_machine*5 * 0.948 * Math.pow(0.901, (cow_machine_age))));
			livestock_equipment_value = handling_system_value + cow_machine_value;				
		}
		if(getn_cows() > 1500 && getn_cows() <=1800) {
			handling_system_value = (int) (Math.round(inv_handling*6 * 0.948 * Math.pow(0.901, (handling_system_age))));
			cow_machine_value = (int) (Math.round(inv_cow_machine*6 * 0.948 * Math.pow(0.901, (cow_machine_age))));
			livestock_equipment_value = handling_system_value + cow_machine_value;				
		}
		if(getn_cows() > 1800) {
			handling_system_value = (int) (Math.round(inv_handling*7 * 0.948 * Math.pow(0.901, (handling_system_age))));
			cow_machine_value = (int) (Math.round(inv_cow_machine*7 * 0.948 * Math.pow(0.901, (cow_machine_age))));
			livestock_equipment_value = handling_system_value + cow_machine_value;				
		}
	}

	public void simulate_depreciation() {

		Parameters p = RunEnvironment.getInstance().getParameters();

		double newcost0 = (Double) p.getValue("newcost0");
		double newcost1 = (Double) p.getValue("newcost1");
		double newcost2 = (Double) p.getValue("newcost2");	
		double newcost3 = (Double) p.getValue("newcost3");
		double newcost4 = (Double) p.getValue("newcost4");
		double newcost5 = (Double) p.getValue("newcost5");
		double newcost6 = (Double) p.getValue("newcost6");	
		double newcost7 = (Double) p.getValue("newcost7");
		double newcost8 = (Double) p.getValue("newcost8");	
		double newcost9 = (Double) p.getValue("newcost9");
		
		crop_machine_age = crop_machine_age + 1;
		int newValue = 0;
		if (crop_machine_option == 0)
			newValue = (int) newcost0;
		if (crop_machine_option == 1)
			newValue = (int) newcost1;
		if (crop_machine_option == 2)
			newValue = (int) newcost2;
		if (crop_machine_option == 3)
			newValue = (int) newcost3;
		if (crop_machine_option == 4)
			newValue = (int) newcost4;
		if (crop_machine_option == 5)
			newValue = (int) newcost5;
		if (crop_machine_option == 6)
			newValue = (int) newcost6;
		if (crop_machine_option == 7)
			newValue = (int) newcost7;
		if (crop_machine_option == 8)
			newValue = (int) newcost8;
		if (crop_machine_option == 9)
			newValue = (int) newcost9;
		crop_machine_value = (int) (Math.round(newValue * 0.948
				* Math.pow(0.901, crop_machine_age)));
	}

	public void farm_accounting() {
		total_repairs = 0;
		simulate_repairs();
		cash_flow();
		balance_sheet();
		refinance_loan();
		positive_cash();
		balance_sheet();
		
	}

	public void simulate_repairs() {

		Parameters p = RunEnvironment.getInstance().getParameters();

		double repairs_option_0 = (Double) p.getValue("repairsoption0");
		double repairs_option_1 = (Double) p.getValue("repairsoption1");
		double repairs_option_2 = (Double) p.getValue("repairsoption2");
		double repairs_option_3 = (Double) p.getValue("repairsoption3");
		double repairs_option_4 = (Double) p.getValue("repairsoption4");
		double repairs_option_5 = (Double) p.getValue("repairsoption5");
		double repairs_option_6 = (Double) p.getValue("repairsoption6");
		double repairs_option_7 = (Double) p.getValue("repairsoption7");
		double repairs_option_8 = (Double) p.getValue("repairsoption8");
		double repairs_option_9 = (Double) p.getValue("repairsoption9");

		if (crop_machine_option == 0)
			total_repairs = Math.round(total_crop_acres * repairs_option_0);
		if (crop_machine_option == 1)
			total_repairs = Math.round(total_crop_acres * repairs_option_1);
		if (crop_machine_option == 2)
			total_repairs = Math.round(total_crop_acres * repairs_option_2);
		if (crop_machine_option == 3)
			total_repairs = Math.round(total_crop_acres * repairs_option_3);
		if (crop_machine_option == 4)
			total_repairs = Math.round(total_crop_acres * repairs_option_4);
		if (crop_machine_option == 5)
			total_repairs = Math.round(total_crop_acres * repairs_option_5);
		if (crop_machine_option == 6)
			total_repairs = Math.round(total_crop_acres * repairs_option_6);
		if (crop_machine_option == 7)
			total_repairs = Math.round(total_crop_acres * repairs_option_7);
		if (crop_machine_option == 8)
			total_repairs = Math.round(total_crop_acres * repairs_option_8);
		if (crop_machine_option == 9)
			total_repairs = Math.round(total_crop_acres * repairs_option_9);
	}

	public void cash_flow() {
		
		Parameters p = RunEnvironment.getInstance().getParameters();
		double family_living_profits = (Double) p
				.getValue("familyLivingProfits");
		int min_family_withdrawal = (Integer) p.getValue("minFamilyWithdrawal");
		int max_family_withdrawal = (Integer) p.getValue("maxFamilyWithdrawal");
		double tax_rate = (Double) p.getValue("taxrate");

		total_annual_gross_inc = Math.round(getgross_income() + sell_old_cows);
				
		total_net_inc = Math.round(total_net_inc);
		
//		if(getfarmer_name() == 90 || getfarmer_name() == 365 || getfarmer_name() == 433 || getfarmer_name() == 443 || getfarmer_name() == 474 || getfarmer_name() == 391){
//			System.out.println("TOTAL NET INC" + total_net_inc + "farmer" + getfarmer_name());
//		}
		
	
		ncfbi = Math.round(total_net_inc + agriinvest_withdrawal_fund_2 + total_insurance_payout + agristability_payment) *100/100;
		
//		if(getfarmer_name() == 90 || getfarmer_name() == 365 || getfarmer_name() == 433 || getfarmer_name() == 443 || getfarmer_name() == 474 || getfarmer_name() == 391){
//			System.out.println("ncfbi one" + ncfbi + "farmer" + getfarmer_name());
//		}
		
		ncfbi = Math.round(ncfbi - debt_payment - total_crop_lease_payment - total_marginal_lease_payment) *100/100;
		
//		if(getfarmer_name() == 90 || getfarmer_name() == 365 || getfarmer_name() == 433 || getfarmer_name() == 443 || getfarmer_name() == 474 || getfarmer_name() == 391){
//			System.out.println("ncfbi SECOND" + ncfbi + "farmer" + getfarmer_name());
//		}
		
		
		income_tax = (int) Math.round(ncfbi * tax_rate);
		if(income_tax < 0) {
			income_tax = 0;
		}
	
		double fl_profits = 0;
		if (ncfbi > 0) {
			fl_profits = Math.round(family_living_profits * ncfbi);
		}
		family_living = Math.max(min_family_withdrawal, fl_profits);
		if (family_living > max_family_withdrawal) {
			family_living = max_family_withdrawal;
		}
		ncfbi = Math.round(ncfbi - family_living) * 100/100;
		
//		if(getfarmer_name() == 90 || getfarmer_name() == 365 || getfarmer_name() == 433 || getfarmer_name() == 443 || getfarmer_name() == 474 || getfarmer_name() == 391){
//			System.out.println("ncfbi THIRD" + ncfbi + "farmer" + getfarmer_name());
//		}
		
		ncfbi = Math.round(ncfbi - income_tax) *100/100;
		
//		if(getfarmer_name() == 90 || getfarmer_name() == 365 || getfarmer_name() == 433 || getfarmer_name() == 443 || getfarmer_name() == 474 || getfarmer_name() == 391){
//			System.out.println("ncfbi FOURTH" + ncfbi + "farmer" + getfarmer_name());
//		}
		
		cash = (int) (Math.round(cash + ncfbi + agriinvest_withdrawal_fund_1 + strategic_borrow + off_farm_inc));
	
		if (ncfbi < 0) {
			years_neg_cash = years_neg_cash + 1;
		} else {
			years_neg_cash = 0;
		}
	}
	
	public void refinance_loan() {

		Parameters p = RunEnvironment.getInstance().getParameters();
		double interest_rate = (Double) p.getValue("interestRate");

		if (debt > 0.75 * (assets - cash)
				&& cash > debt - 0.75 * (assets - cash)) { // if debt is greater
			// than 75% of assets without cash
	
			cash = (int) (cash - (debt - 0.75 * (assets - cash))); // reduce
			// debt to 75% by paying it down with cash and
			double payment = Math.round(0.75 * (assets - cash)
					* Variables.getloan_factor_payment_20() * 100.0) / 100.0; // update-debt
																				// list
			debt_list = new ArrayList();
			debtList debtLst = new debtList();
			debtLst.setyears_remaining(20);
			debtLst.setannual_payment(payment);
			debtLst.setdebt((int) (Math.round(0.75 * (assets - cash))));
			debt_list.add(debtLst);
			update_debt();
		}
	}

	public void positive_cash() {
		if (cash < 0) {
			
			
		
			double payment = Math.round(-1 * cash
					* Variables.getloan_factor_payment_5() * 100.0) / 100.0;
			debtList debtLst = new debtList();
			debtLst.setyears_remaining(5);
			debtLst.setannual_payment(payment);
			debtLst.setdebt((int) (-1 * cash));
			debt_list.add(debtLst);
			update_debt();
			cash = 0;
		}
	}

	public void update_debt() {

		Parameters p = RunEnvironment.getInstance().getParameters();
		double interest_rate = (Double) p.getValue("interestRate");		
		
		double result2 = add1(debt_list); // calculates annual debt payment
		debt_payment = result2;

		for (int i = 0; i < debt_list.size(); i++) {
			debtList debtLst = (debtList) debt_list.get(i);
			debtLst.setdebt((int) (Math.round(debtLst.getannual_payment()
					* ((1 - (1 / Math.pow(1 + interest_rate, debtLst
							.getyears_remaining()))) / interest_rate)))); // calculate
			// principal balance of each loan
		}
		int result3 = add2(debt_list); // update total debt-value (principal
		// remaining for all debts)
		debt = result3;
		}

	public void exit_industry() {

		Parameters p = RunEnvironment.getInstance().getParameters();
		double retirement_tendency_55_59 = (Double) p
				.getValue("retirementtendency5559");
		double retirement_tendency_60_64 = (Double) p
				.getValue("retirementtendency6064");
		double retirement_tendency_65_69 = (Double) p
				.getValue("retirementtendency6569");
		double retirement_tendency_70_over = (Double) p
				.getValue("retirementtendency70over");

		if (years_neg_cash == 5 && Math.random() < 0.15) {
			determine_sell_rent();
			Variables.setcashflow(Variables.getcashflow() + 1);
			why_exit = " cash flow";
			export_exits();
			setdie(true);
		} else if (years_neg_cash == 6 && Math.random() < 0.2) {
			determine_sell_rent();
			Variables.setcashflow(Variables.getcashflow() + 1);
			why_exit = " cash flow";
			export_exits();
			setdie(true);
		} else if (years_neg_cash == 7 && Math.random() < 0.3) {
			determine_sell_rent();
			Variables.setcashflow(Variables.getcashflow() + 1);
			why_exit = " cash flow";
			export_exits();
			setdie(true);
		} else if (years_neg_cash == 8 && Math.random() < 0.4) {
			determine_sell_rent();
			Variables.setcashflow(Variables.getcashflow() + 1);
			why_exit = " cash flow";
			export_exits();
			setdie(true);
		} else if (years_neg_cash >= 9) {
			determine_sell_rent();
			Variables.setcashflow(Variables.getcashflow() + 1);
			why_exit = " cash flow";
			export_exits();
			setdie(true);
		}
		if (!getdie()) {
			if (debt > (0.9 * assets) || assets == 0) {
				for (int i = mylandList.size() -1; i >= 0; i--) { 
				SAMA fdl1 = (SAMA) mylandList.get(i);

					if (fdl1.getOwner() == this.getfarmer_name()) {
						fdl1.setOwner(9999);
						fdl1.setcurrent_producer(9999);					
						deleteland(fdl1);
						fdl1.setfor_sale(true);
						fdl1.setneed_sell(true);
					} else if (fdl1.getrenter() == this.getfarmer_name()) {
						fdl1.setrenter(9999);
						fdl1.setcurrent_producer(9999);
						deleteland(fdl1);
						fdl1.setfor_sale(true);
					}
				}
				Variables.setbankrupt(Variables.getbankrupt() + 1);
				why_exit = " bankrupt";
				export_exits();
				setdie(true);
			}
		}

		if (!getdie()) {
			if (age >= 57 && age < 63
					&& Math.random() < retirement_tendency_55_59) {
				retire();
			} else if (age >= 64 && age < 68
					&& Math.random() < retirement_tendency_60_64) {
				retire();
			} else if (age >= 69 && age < 74
					&& Math.random() < retirement_tendency_65_69) {
				retire();
			} else if (age >= 75 && age < 80
					&& Math.random() < retirement_tendency_70_over) {
				retire();
			} else if (age >= 80) {
				retire();
			}
		}
	}

	
	public void determine_sell_rent() {
		Parameters p = RunEnvironment.getInstance().getParameters();
		double sell_prob_retired = (Double) p.getValue("sellprobretired");

		if (Math.random() >= sell_prob_retired) {						
			for (int i = mylandList.size() - 1; i >= 0; i--) {
				SAMA fdl1 = (SAMA) mylandList.get(i);
				if (fdl1.getOwner() == this.getfarmer_name()) {
					fdl1.setOwner(9999);
					fdl1.setcurrent_producer(9999);
					deleteland(fdl1);
					fdl1.setfor_sale(true);
				} else if (fdl1.getrenter() == this.getfarmer_name()) {
					fdl1.setrenter(9999);
					fdl1.setcurrent_producer(9999);
					deleteland(fdl1);
					fdl1.setfor_sale(true);
				}
			}
		} 
		else {					
			if (!mylandList.isEmpty()) {
				for (int i = (mylandList.size() - 1); i >= 0; i--) {
					SAMA fdl1 = (SAMA) mylandList.get(i);
					if (fdl1.getOwner() == getfarmer_name()) {
						fdl1.setOwner(9999);
						fdl1.setcurrent_producer(9999);
						deleteland(fdl1);
						fdl1.setfor_rent(true);
					} else if (fdl1.getrenter() == this.getfarmer_name()) {
						fdl1.setrenter(9999);
						fdl1.setcurrent_producer(9999);
						deleteland(fdl1);				
						fdl1.setfor_rent(true);
					} 
				}
			}
		}
	}

	
	public void retire() {
		
		Parameters p = RunEnvironment.getInstance().getParameters();
		double transfer_prob = (Double) p.getValue("transferprob");
		if (Math.random() < transfer_prob) {
			transfer();
		} else {
			determine_sell_rent();
			Variables.setoldage(Variables.getoldage() + 1);
			why_exit = " retire";
			export_exits();
			setdie(true);
		}
	}
	
	public void transfer() {

		Parameters p = RunEnvironment.getInstance().getParameters();
		int min_cash_retire = (Integer) p.getValue("mincashretire");
		double transfer_rate = (Double) p.getValue("transferrate");

		int old_equity = equity;
		int old_cash = cash;
		int old_assets = assets;

		double buy_value = Math.round(min_cash_retire + transfer_rate
				* (equity - min_cash_retire));

		if (equity - min_cash_retire < 0) {
			buy_value = assets - cash;
			cash = 0;
		}
		cash = (int) (Math.round(cash - buy_value));

		int borrow = -1 * cash;

		if (borrow < 0) {
			cash = -1 * borrow;
			borrow = 0;
		} else {
			cash = 0;
		}

		double payment = Math.round(borrow
				* Variables.getloan_factor_payment_25() * 100.0) / 100.0;

		debt_list = new ArrayList();
		debtList debtLst = new debtList();
		debtLst.setyears_remaining(25);
		debtLst.setannual_payment(payment);
		debtLst.setdebt((int) borrow);
		debt_list.add(debtLst);
		debt_payment = payment;
		debt = borrow;
		update_debt();
		set_off_farm_income();
		set_expected_income();

		double exp_net_cf = exp_cf;
		if (exp_net_cf > debt_payment) {
			Random generator = new Random();
			cash = (int) (cash + (generator.nextGaussian() * 10000 + 50000));
			balance_sheet();
			if (debt / assets < 0.6) {
				transfer_value = buy_value;
				transfer_borrow = borrow;
				age = age - 30;
				Variables.settransfers(Variables.gettransfers() + 1);
				generation = generation + 1;
				//export_transfer();
			} else {
				determine_sell_rent();
				Variables.setoldage(Variables.getoldage() + 1);
				why_exit = " retire";
				export_exits();
				setdie(true);
			}
		} else {
			determine_sell_rent();
			Variables.setoldage(Variables.getoldage() + 1);
			why_exit = " retire";
			export_exits();
			setdie(true);
		}
	}

	public void set_off_farm_income() {

		Parameters p = RunEnvironment.getInstance().getParameters();
		double off_farm_employment_640_1280 = (Double) p
				.getValue("off_farm_employment_640_1280");
		double off_farm_employment_1280_1920 = (Double) p
				.getValue("off_farm_employment_1280_1920");
		double off_farm_employment_1920_3200 = (Double) p
				.getValue("off_farm_employment_1920_3200");
		double off_farm_employment_greater_3200 = (Double) p
				.getValue("off_farm_employment_greater_3200");

		if (total_acres_farmed < 640) {
			off_farm_employ = true;
		}
		if (total_acres_farmed > 640 && total_acres_farmed < 1280) {
			if (Math.random() < off_farm_employment_640_1280) {
				off_farm_employ = true;
			}
			else {
				off_farm_employ = false;
			}
		}

		if (total_acres_farmed > 1280 && total_acres_farmed < 1920) {
			if (Math.random() < off_farm_employment_1280_1920) {
				off_farm_employ = true;
			} else {
				off_farm_employ = false;
			}
		}
		if (total_acres_farmed > 1920 && total_acres_farmed < 3200) {
			if (Math.random() < off_farm_employment_1920_3200) {
				off_farm_employ = true;
			} else {
				off_farm_employ = false;
			}
		}
		if (total_acres_farmed > 3200) {
			if (Math.random() < off_farm_employment_greater_3200) {
				off_farm_employ = true;
			} else {
				off_farm_employ = false;
			}
		}
		if (off_farm_employ == false) {
			off_farm_inc = 0;
		}
		if (off_farm_employ == true) {
			Random generator = new Random();
			off_farm_inc = (int) (generator.nextGaussian() * 36493 + 50943);
		}
		if (off_farm_inc < 0) {
			off_farm_inc = 0;
		}
	}

	public void set_expected_income() {

		Parameters p = RunEnvironment.getInstance().getParameters();

		double family_living_profits = (Double) p
				.getValue("familyLivingProfits");
		int min_family_withdrawal = (Integer) p.getValue("minFamilyWithdrawal");
		int max_family_withdrawal = (Integer) p.getValue("maxFamilyWithdrawal");

		double total_exp_income = Math.round(((int) getexpected_income())
				+ off_farm_inc);
		double lease_payments = 0;
		for (int i = 0; i < mylandList.size(); i++) {
			SAMA fdl1 = (SAMA) mylandList.get(i);
			lease_payments = lease_payments + fdl1.getlease_payment();
		}

		double exp_net_cf = total_exp_income - debt_payment - lease_payments;
		double exp_fl = Math.max(exp_net_cf * family_living_profits,
				min_family_withdrawal);
		if (exp_fl > max_family_withdrawal) {
			exp_fl = max_family_withdrawal;
		}
		exp_cf = total_exp_income - lease_payments - debt_payment - exp_fl;
	}

	public void deleteland(SAMA fdl1) {
		for (int i = mylandList.size() - 1; i >= 0; i--) {
			SAMA sama = (SAMA) mylandList.get(i);
			if (fdl1.getID() == sama.getID()) {
				mylandList.remove(i);
				setmylandList(mylandList);
				break;
			}
		}
	}

	
	public void update_farmers_land_info() {

		if (die == true) {			
			die();
			}		

		for (int i = (Variables.getfarmerlist().size() -1); i >= 0; i--) {
			Producer cda = (Producer) Variables.getfarmerlist().get(i);
			if (cda.getdie()) {
				for (int j = 0; j < Variables.getfarmerlist().size(); j++) {
					Producer cda1 = (Producer) Variables.getfarmerlist().get(j);
					if (cda1.getID() > cda.getID()) {
						cda1.setID(cda1.getID()-1);
					}
				}
			ArrayList fl = Variables.getfarmerlist();
				fl.remove(i);
				Variables.setfarmerlist(fl);
			}
		}
	}
	
		
	public void export_exits() {

		int idd = Variables.getexitOutID();
		int scenario = Variables.getscenario();
		int run_number = Variables.getrun_number();
		int yearOut = Variables.getyear();
		int farmerNameOut = getfarmer_name();
		int lease_pay_crop = (int) total_crop_lease_payment;
		int lease_pay_marginal = (int)  total_marginal_lease_payment;

		try {
			Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
		} catch (ClassNotFoundException ce) {
			System.out.println("SQLExceptiong:" + ce.getMessage());
		}
		try {
			Connection conn = DriverManager.getConnection(
					"jdbc:odbc:producerDB", "java", "1234");
			Statement stmt = conn.createStatement();
			stmt.executeUpdate("insert into ExitOut values ('" + idd + "', '"
					+ scenario + "', '" + run_number + "', '" + yearOut
					+ "', '" + farmerNameOut + "', '" + why_exit + "', '" + age
					+ "', '" + total_acres_farmed + "', '" + total_plots_owned
					+ "', '" + total_plots_leased + "', '" + total_acres_owned
					+ "','" + total_acres_leased + "', '" + total_crop_acres
					+ "','" + debt + "', '" + assets + "', '" + equity + "', '"
					+ cash + "', '" + equity + "','" + family_living + "', '"
					+ ncfbi + "','" + off_farm_inc + "', '" + generation
					+ "', '" + debt_payment + "', '" + land_value + "', '"
					+ capital_value + "', '"
					+ crop_machine_value + "', '"
					+ livestock_equipment_value + "', '"
					+ cow_value + "', '" + n_cows + "', '"
					+ total_hay + "', '" + total_improved_pasture + "', '"
					+ total_natural_pasture + "', '" + fallow + "', '"
					+ wheatfallow + "', '" + durumstubble + "', '"
					+ canolastubble + "', '" + feedbarleycon + "', '"
					+ barleystubble + "', '" + feedwheatcon + "', '"
					+ wheatstubble + "', '" + flaxstubble + "', '"
					+ peasstubble + "', '" + feedwheatnotill + "', '"
					+ wheatnotill + "', '"
					+ durumnotill + "', '" 
					+ canolanotill + "', '" + feedbarleynotill + "', '"
					+ barleynotill + "', '" + lentilsnotill + "', '"
					+ flaxnotill + "', '" + peasnotill + "', '"	
					+ willowsnaturalpasture + "', '"
					+ willowsimprovedpasture + "', '"
					+ willowshaylandpasture + "', '"
					+ poplarnaturalpasture + "', '"
					+ poplarimprovedpasture + "', '"
					+ poplarhaylandpasture + "', '"
					+ prairiesandreednaturalpasture + "', '"
					+ prairiesandreedimprovedpasture + "', '"
					+ prairiesandreedhaylandpasture + "', '"
					+ lease_pay_crop + "','" + lease_pay_marginal + "', '" 		
					+ crop_machine_age + "', '" + total_repairs + "', '"
					+ total_gross_crop_inc + "', '" + total_net_inc + "', '"
					+ total_annual_gross_inc + "', '" + gross_income_hay + "', '" 
					+ gross_income_energycrops + "', '"
					+ total_net_energy_income + "', '" + total_net_crop_income + "', '"
					+ total_net_hay_income + "', '"
					+ trucking_distance_energy_crops + "', '"
					+ improvedbaleone + "', '"
					+ improvedbaletwo + "', '"
					+ haybaleone + "', '"
					+ haybaletwo + "')");
					
			
			
			stmt.close();
		} catch (SQLException ce) {
			//System.out.println("SQLException:" + ce.getMessage());
		}
		Variables.setexitOutID(idd + 1);
	}

	
	public void export_transfer() {

		int idd = Variables.gettransferOutID();
		int scenario = Variables.getscenario();
		int run_number = Variables.getrun_number();
		int year = Variables.getyear();
		int who = getfarmer_name();
		//System.out.println("transfer");

		try {
			Class.forName("sun.jdbc.odbc.JdbcDriver");
		} catch (ClassNotFoundException ce) {
			//System.out.println("SQLExceptiong:" + ce.getMessage());
		}
		try {
			Connection conn = DriverManager.getConnection(
					"jdbc:odbc:producerDB", "java", "1234");
			Statement stmt = conn.createStatement();
			stmt.executeUpdate("insert into TransferOut values ('" + idd
					+ "', '" + run_number + "', '"
					+ year + "', '" + who + "', '"
					+ transfer_value + "', '"
					+ transfer_borrow + "', '" 
					+ age + "', '"
					+ total_acres_farmed + "', '"
					+ total_plots_owned + "', '"
					+ total_plots_leased + "', '"
					+ total_acres_owned + "', '"
					+ total_acres_leased + "', '"
					+ total_crop_acres + "', '"
					+ debt + "', '"
					+ assets + "', '"
					+ equity + "', '"
					+ cash + "', '"
					+ family_living + "', '"
					+ ncfbi + "', '"
					+ off_farm_inc + "', '"
					+ generation + "', '"
					+ debt_payment + "', '"
					+ land_value + "', '"
					+ capital_value + "', '"
					+ risk_parameter + "', '"
					+ crop_machine_age + "', '"
					+ total_repairs + "')");
					
					
					
					
			stmt.close();
			conn.close();
		} catch (SQLException ce) {
			System.out.println("SQLException transfer:" + ce.getMessage() +"farmer" + getfarmer_name());
		}
		Variables.settransferOutID(idd + 1);
	}

	
	public void report() {

		int idd = Variables.getfarmerOutID();
		int yearOut = Variables.getyear();
		int farmerNameOut = getfarmer_name();
		int net_worth = equity;
		int family_living_out = (int) family_living;
		int lease_pay_crop = (int) total_crop_lease_payment;
		int lease_pay_marginal = (int)  total_marginal_lease_payment;
			if(getfarmer_name()== 350){
			//System.out.println("farmer inside report" + getfarmer_name() +"year" + Variables.getyear());	
			
			}
		try {
			Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
		} catch (ClassNotFoundException ce) {
			//System.out.println("SQLExceptiong:" + ce.getMessage());
		}
		try {
			Connection conn = DriverManager.getConnection(
					"jdbc:odbc:producerDB", "java", "1234");
			Statement stmt = conn.createStatement();
			stmt.executeUpdate("insert into farmerOut values ('" + idd + "', '"
					+ farmerNameOut + "', '" + Variables.getrun_number() + "', '" 
					+ yearOut + "', '" + age + "', '"
					+ total_acres_farmed + "', '" + total_plots_owned + "', '"
					+ total_plots_leased + "', '" + total_acres_owned + "', '"
					+ total_acres_leased + "', '" + total_crop_acres + "', '"
					+ total_hay + "', '" 
					+ total_improved_pasture + "', '"
					+ total_natural_pasture + "', '"
					+ fallow + "', '"
					+ wheatfallow + "', '"
					+ durumstubble + "', '"
					+ canolastubble + "', '"
					+ feedbarleycon + "', '"					
					+ barleystubble + "', '"
					+ feedwheatcon + "', '"
					+ wheatstubble + "', '"
					+ flaxstubble + "', '"
					+ peasstubble + "', '"
					+ feedwheatnotill + "', '"
					+ wheatnotill + "', '"
					+ durumnotill + "', '"
					+ canolanotill + "', '"
					+ feedbarleynotill + "', '"
					+ barleynotill + "', '"
					+ lentilsnotill + "', '"
					+ flaxnotill + "', '"
					+ peasnotill + "', '"	
					+ willowsnaturalpasture + "', '"
					+ willowsimprovedpasture + "', '"
					+ willowshaylandpasture + "', '"
					+ poplarnaturalpasture + "', '"
					+ poplarimprovedpasture + "', '"
					+ poplarhaylandpasture + "', '"
					+ prairiesandreednaturalpasture + "', '"
					+ prairiesandreedimprovedpasture + "', '"
					+ prairiesandreedhaylandpasture + "', '"
					+ debt + "', '" + assets + "', '" + equity + "', '" + cash
					+ "', '" + net_worth + "', '" + family_living_out + "', '"
					+ ncfbi + "', '" + off_farm_inc + "', '" + generation
					+ "', '" + debt_payment + "', '"
					+ lease_pay_crop + "', '"
					+ lease_pay_marginal + "', '"
					+ land_value + "', '"
					+ capital_value + "', '" 
					+ crop_machine_value + "', '"
					+ livestock_equipment_value + "', '"
					+ cow_value + "', '" + n_cows + "', '" + risk_parameter + "', '"
					+ crop_machine_age + "', '" + total_repairs + "', '"
					+ total_gross_crop_inc + "', '" + total_net_inc + "', '"
					+ gross_income_hay + "', '" + gross_income_energycrops + "', '"
					+ total_net_energy_income + "', '" + total_net_crop_income + "', '"
					+ total_net_hay_income + "', '"
					+ total_annual_gross_inc + "', '"
					+ trucking_distance_energy_crops + "', '"
					+ improvedbaleone + "', '"
					+ improvedbaletwo + "', '"
					+ haybaleone + "', '"
					+ haybaletwo + "', '"
					+ farmer_type + "')");
			stmt.close();
			conn.close();
		} catch (SQLException ce) {
			System.out.println("SQLException: Report" + ce.getMessage() );
		}
		Variables.setfarmerOutID(idd + 1);
	}

	public void plot_screening(SAMA sama) {

		int distance_plot = (int) (Math.sqrt(Math.pow(getX() - sama.getX(), 2)
				+ Math.pow(getY(), 2)));
		
		if(Variables.getunmanaged() > 60){
			can_bid_on_plot = true;
		}
		else{
		
		if (distance_plot < Variables.getmax_distance()) {
			setcan_bid_on_plot(true);
		}
		if(sama.getpatchtype() == 3 && getfarmer_type() == 1){
			setcan_bid_on_plot(false);
			//System.out.println("crop farmer doesn't want crap land");
		}
		}
	}
	
	public void trucking_distance () {
		double trucking_distance_alameda = 0;
		double trucking_distance_carievale = 0;
		double trucking_distance_carnduff = 0;
		double trucking_distance_estevan = 0;
		double trucking_distance_northgate = 0;
		double trucking_distance_redvers = 0;
		double trucking_distance_stoughton = 0;
		
		
		for (int i = 0; i < mylandList.size(); i++){
		SAMA sama = (SAMA) mylandList.get(i);
		farmers_x_distance = sama.getX();
		farmers_y_distance = sama.getY();
		}
		
		int estevan_x_coordinate = 2;
		int estevan_y_coordinate = 9;
		
		int stoughton_x_coordinate = 2;
		int stoughton_y_coordinate = 39;
		
		int alameda_x_coordinate = 24;
		int alameda_y_coordinate = 19;
		
		int northgate_x_coordinate = 23;
		int northgate_y_coordinate = 1;
		
		int carnduff_x_coordinate = 38;
		int carnduff_y_coordinate = 13;
		
		int redvers_x_coordinate = 45;
		int redvers_y_coordinate = 38;
		
		int carievale_x_coordinate = 45;
		int carievale_y_coordinate = 14;
				
		trucking_distance_alameda = (int) Math.sqrt((alameda_x_coordinate - farmers_x_distance)*(alameda_x_coordinate - farmers_x_distance) + (alameda_y_coordinate - farmers_y_distance)*(alameda_y_coordinate - farmers_y_distance));
		trucking_distance_carievale = (int) Math.sqrt((carievale_x_coordinate - farmers_x_distance)*(carievale_x_coordinate - farmers_x_distance) + (carievale_y_coordinate - farmers_y_distance)*(carievale_y_coordinate - farmers_y_distance));
		trucking_distance_carnduff = (int) Math.sqrt((carnduff_x_coordinate - farmers_x_distance)*(carnduff_x_coordinate - farmers_x_distance) + (carnduff_y_coordinate - farmers_y_distance)*(carnduff_y_coordinate - farmers_y_distance));
		trucking_distance_estevan = (int) Math.sqrt((estevan_x_coordinate - farmers_x_distance)*(estevan_x_coordinate - farmers_x_distance) + (estevan_y_coordinate - farmers_y_distance)*(estevan_y_coordinate - farmers_y_distance));
		trucking_distance_northgate = (int) Math.sqrt((northgate_x_coordinate - farmers_x_distance)*(northgate_x_coordinate - farmers_x_distance) + (northgate_y_coordinate - farmers_y_distance)*(northgate_y_coordinate - farmers_y_distance));
		trucking_distance_redvers = (int) Math.sqrt((redvers_x_coordinate - farmers_x_distance)*(redvers_x_coordinate - farmers_x_distance) + (redvers_y_coordinate - farmers_y_distance)*(redvers_y_coordinate - farmers_y_distance));
		trucking_distance_stoughton = (int) Math.sqrt((stoughton_x_coordinate - farmers_x_distance)*(stoughton_x_coordinate - farmers_x_distance) + (stoughton_y_coordinate - farmers_y_distance)*(stoughton_y_coordinate - farmers_y_distance));
		
		
		double[] min_trucking_distance = new double[] {trucking_distance_alameda, trucking_distance_carievale, trucking_distance_carnduff, trucking_distance_estevan, 
				trucking_distance_northgate, trucking_distance_redvers, trucking_distance_stoughton};
		
				
		trucking_distance_energy_crops = trucking_distance_estevan * 2.2;
		trucking_distance = getMinValue(min_trucking_distance) *2.2;
	}

	public void create_bid_cropland(SAMA fdl1) {

		Parameters p = RunEnvironment.getInstance().getParameters();

		double increase_no_till = (Double) p.getValue("increaseNoTill");
		clear_parameters(fdl1);
		set_bid_value_cropland(fdl1);
		financial_bid(fdl1);
				
		if (Variables.get_buy_bid_list_cropland() == null) {
			ArrayList bidL = new ArrayList();
			
			bidL.add(new BidListCropland(getfarmer_name(), current_bid));
			Variables.set_buy_bid_list_cropland(bidL);
			
		} else {
			ArrayList bidL = Variables.get_buy_bid_list_cropland();
			bidL.add(new BidListCropland(getfarmer_name(), current_bid));
			Variables.set_buy_bid_list_cropland(bidL);
		}				
		fdl1.setcurrent_producer(9999);
		deleteland(fdl1);
	}

	public void create_bid_marginalland(SAMA fdl1) {
		Parameters p = RunEnvironment.getInstance().getParameters();

		double increase_no_till = (Double) p.getValue("increaseNoTill");
		clear_parameters(fdl1);
		set_bid_value_marginalland(fdl1);
		financial_bid_marginalland(fdl1);
		
		if (Variables.get_buy_bid_list_marginalland() == null) {
			ArrayList bidL = new ArrayList();
			
			bidL.add(new BidListMarginalland(getfarmer_name(), current_bid_marginalland));
			Variables.set_buy_bid_list_marginalland(bidL);
			
		} else {
			ArrayList bidL = Variables.get_buy_bid_list_marginalland();
			bidL.add(new BidListMarginalland(getfarmer_name(), current_bid_marginalland));
			Variables.set_buy_bid_list_marginalland(bidL);
			
		}		
		fdl1.setcurrent_producer(9999);
		deleteland(fdl1);
	}	
	
	public void clear_parameters(SAMA fdl1) {
		fdl1.setnet_income_crop(0);
		fdl1.setcame_from_bid(true);
		fdl1.setcurrent_producer(ID);
		add_land(fdl1);
		fdl1.settilled_crop(fdl1.getTilled());
	}	

	public void add_land(SAMA sama) {
		this.mylandList.add(sama);
	}

	public void set_bid_value_cropland(SAMA fdl1) {

		Parameters p = RunEnvironment.getInstance().getParameters();
		double land_inflate = (Double) p.getValue("land_inflate");
		double tax_rate = (Double) p.getValue("taxrate");
		int min_family_withdrawal = (Integer) p.getValue("minFamilyWithdrawal");
		double current_value_land = 0;
		SAMA sama = (SAMA) Variables.getlandlist().get(
				Variables.getcurrent_plot_on_market());
		
		if(sama.getpatchtype() == 1){
			current_value_land = fdl1.getAvg_prod_patch()
				/ Variables.getmean_patch_quality() * Variables.getcropland_price();
		}
		if(sama.getpatchtype() == 2 || sama.getpatchtype() == 3){
			current_value_land = fdl1.getAvg_prod_patch()
			/ Variables.getmean_patch_quality() * Variables.getmarginalland_price();
		}
		double incometax = getexpected_income() * tax_rate;
		double total_acres = (getoption_0_acres() + getoption_1_acres() + getoption_2_acres() + getoption_3_acres() + getoption_4_acres() + getoption_5_acres() +
				getoption_6_acres() + getoption_7_acres() + getoption_8_acres() + getoption_9_acres() 
				+ getrent_out_natural_pasture()	+ getrent_out_improved_pasture()+ getrent_out_hayland_pasture()
				+ getwillows_on_natural_pasture() + getwillows_on_improved_pasture() + getwillows_on_hayland_pasture() 
				+ getpoplar_on_natural_pasture() + getpoplar_on_improved_pasture() + getpoplar_on_hayland_pasture()
				+ getprairie_sandreed_on_natural_pasture() + getprairie_sandreed_on_improved_pasture() + getprairie_sandreed_on_hayland_pasture()
				+ getnatural_pasture() + getimproved_pasture() + gethayland_pasture() + getimproved_bale_first_cut() + getimproved_bale_second_cut() + gethay_production_one_cut() + gethay_production_two_cuts()
				+ getrent_out_natural_pasture() + getrent_out_improved_pasture() + getrent_out_hayland_pasture()); 
		
		double income = getexpected_income() - incometax - family_living - debt_payment + off_farm_inc;
		if(income <= 0){
			income = 0;
		}
		if(income > 0) {
		double error = 1 + ((int) (Math.random()*10)-5.0)/100.0;
		double income_land_value = income / total_acres
				* Variables.getpv_annuity_land();
					
		double end_value_land = current_value_land
				* Math.pow(1 + land_inflate, 20)
				* Variables.getyear_20_factor();
		current_bid = (income_land_value + end_value_land) * risk_parameter;
		}
		else {
			current_bid = 0;
		}
	}
	
	public void set_bid_value_marginalland(SAMA fdl1) {

		Parameters p = RunEnvironment.getInstance().getParameters();
		double land_inflate = (Double) p.getValue("land_inflate");
		double tax_rate = (Double) p.getValue("taxrate");
		int min_family_withdrawal = (Integer) p.getValue("minFamilyWithdrawal");
			
		double current_value_land = fdl1.getAvg_prod_patch()
				/ Variables.getmean_patch_quality() * Variables.getmarginalland_price();
				
		double incometax = getexpected_income() * tax_rate;
		double total_acres = (getoption_0_acres() + getoption_1_acres() + getoption_2_acres() + getoption_3_acres() + getoption_4_acres() + getoption_5_acres() +
				getoption_6_acres() + getoption_7_acres() + getoption_8_acres() + getoption_9_acres() + getwillows_on_natural_pasture() + getwillows_on_improved_pasture() + getwillows_on_hayland_pasture() + getnatural_pasture() + getimproved_pasture() + gethayland_pasture() + getimproved_bale_first_cut() + getimproved_bale_second_cut() + gethay_production_one_cut() + gethay_production_two_cuts()
				+ getrent_out_natural_pasture() + getrent_out_improved_pasture() + getrent_out_hayland_pasture()); 
		double income = getexpected_income() - incometax - min_family_withdrawal - debt_payment + off_farm_inc;
		if(income > 0) {
		double income_land_value = income / total_acres
				* Variables.getpv_annuity_land();
	
		double end_value_land = current_value_land
				* Math.pow(1 + land_inflate, 20)
				* Variables.getyear_20_factor();
		current_bid_marginalland = (income_land_value + end_value_land) * risk_parameter;
		}
	}
	
	public void financial_bid(SAMA fdl) {
		set_expected_income();
		Parameters p = RunEnvironment.getInstance().getParameters();
		int min_family_withdrawal = (Integer) p.getValue("minFamilyWithdrawal");
		double option_0_limit = (Double) p.getValue("option0Limit");
		double option_1_limit = (Double) p.getValue("option1Limit");
		double option_2_limit = (Double) p.getValue("option2Limit");
		double option_3_limit = (Double) p.getValue("option3Limit");
		double option_4_limit = (Double) p.getValue("option4Limit");
		double option_5_limit = (Double) p.getValue("option5Limit");
		double option_6_limit = (Double) p.getValue("option6Limit");
		double option_7_limit = (Double) p.getValue("option7Limit");
		double option_8_limit = (Double) p.getValue("option8Limit");
		double option_9_limit = (Double) p.getValue("option9Limit");
		double cash_reserve_percent = (Double) p.getValue("cashReservePercent");
		int min_cash_crop_acre = (Integer) p.getValue("minCashCropAcre");
		double down_payment = (Double) p.getValue("downPayment");
		double d_a_ratio = (Double) p.getValue("daRatio");
		double max_percent_cf = (Double) p.getValue("maxPercentCF");
		double interest_rate = (Double) p.getValue("interestRate");
		double tax_rate = (Double) p.getValue("taxrate");
		double min_ratio = (Double) p.getValue("minRatio");
		double inv_mach_0 = (Double) p.getValue("inv_Mach_0");
		double inv_mach_1 = (Double) p.getValue("inv_Mach_1");
		double inv_mach_2 = (Double) p.getValue("inv_Mach_2");
		double inv_mach_3 = (Double) p.getValue("inv_Mach_3");
		double inv_mach_4 = (Double) p.getValue("inv_Mach_4");
		double inv_mach_5 = (Double) p.getValue("inv_Mach_5");
		double inv_mach_6 = (Double) p.getValue("inv_Mach_6");
		double inv_mach_7 = (Double) p.getValue("inv_Mach_7");
		double inv_mach_8 = (Double) p.getValue("inv_Mach_8");
		double inv_mach_9 = (Double) p.getValue("inv_Mach_9");
		double inv_handling = (Double) p.getValue("invhandling");
		double inv_cow_machine = (Double) p.getValue("invcowmachine");
		int min_cash_hay_acre = (Integer) p.getValue("mincashhayacre");
		double old_cows = getn_cows();
		double new_cows = 0;
		double market_value_land = 0;
		
		SAMA sama = (SAMA) Variables.getlandlist().get(
				Variables.getcurrent_plot_on_market());
		
		livestock_variables = new double[] {cows_head, cows_labour, natural_pasture, improved_pasture, hayland_pasture, pasture_carryover_one,
				pasture_carryover_two, improved_bale_first_cut, improved_bale_second_cut, hay_production_one_cut, hay_production_two_cuts,
				breaking_cost, buy_hay, buy_feed_wheat, buy_feed_barley, feed_early_summer_hay, feed_late_summer_hay, feed_fall_hay, 
				feed_winter_hay, feed_wheat, feed_barley, wheat_straw, barley_straw, sell_hay};
		new_cows = livestock_variables[0];
		
		
		int capacity_current_mach = 0;
		if (crop_machine_option == 0)
			capacity_current_mach = (int) option_0_limit;
		if (crop_machine_option == 1)
			capacity_current_mach = (int) option_1_limit;
		if (crop_machine_option == 2)
			capacity_current_mach = (int) option_2_limit;
		if (crop_machine_option == 3)
			capacity_current_mach = (int) option_3_limit;
		if (crop_machine_option == 4)
			capacity_current_mach = (int) option_4_limit;
		if (crop_machine_option == 5)
			capacity_current_mach = (int) option_5_limit;
		if (crop_machine_option == 6)
			capacity_current_mach = (int) option_6_limit;
		if (crop_machine_option == 7)
			capacity_current_mach = (int) option_7_limit;
		if (crop_machine_option == 8)
			capacity_current_mach = (int) option_8_limit;
		if (crop_machine_option == 9)
			capacity_current_mach = (int) option_9_limit;

		double cash_reserve = cash * cash_reserve_percent;

		double min_cash = (capacity_current_mach * min_cash_crop_acre) + ((livestock_variables[2] + livestock_variables[3] + livestock_variables[4]) * min_cash_hay_acre);
		
		new_machinery_inv = (int) + ((inv_mach_0 * min_ratio * getoption_0_number_machines())
				+ (inv_mach_1 * min_ratio * getoption_1_number_machines())
				+ (inv_mach_2 * min_ratio * getoption_2_number_machines())
				+ (inv_mach_3 * min_ratio * getoption_3_number_machines())
				+ (inv_mach_4 * min_ratio * getoption_4_number_machines())
				+ (inv_mach_5 * min_ratio * getoption_5_number_machines())
				+ (inv_mach_6 * min_ratio * getoption_6_number_machines())
				+ (inv_mach_7 * min_ratio * getoption_7_number_machines())
				+ (inv_mach_8 * min_ratio * getoption_8_number_machines()) + (inv_mach_9
				* min_ratio * getoption_9_number_machines() + inv_handling * min_ratio * getcows_fc_handling_system()) + 
				(inv_cow_machine * min_ratio * getcows_fc_machinery()));
		
		if(sama.getpatchtype() == 1){
				market_value_land = fdl.getAvg_prod_patch()
		/ Variables.getmean_patch_quality() * Variables.getcropland_price()
		* fdl.getacres() ;
		}
		if(sama.getpatchtype() == 2 || sama.getpatchtype() == 3){
			 	market_value_land = fdl.getAvg_prod_patch()
				/ Variables.getmean_patch_quality() * Variables.getmarginalland_price()
				* fdl.getacres();	
		}		
		double capital_available = cash - min_cash - down_payment 
				* (new_machinery_inv) - cash_reserve; 

		bid_finances = (int) (capital_available / down_payment);
	
		double new_debt = debt + (1 - down_payment) * (new_machinery_inv + market_value_land);
		double new_assets = assets + new_machinery_inv + market_value_land - down_payment
				* (new_machinery_inv + market_value_land);
		
		double max_debt_asset_bid = (d_a_ratio * new_assets  - new_debt)
				/ (d_a_ratio * down_payment + (1 - down_payment));

		if (max_debt_asset_bid < bid_finances) {
			bid_finances = (int) max_debt_asset_bid;
		}
		
		double incometax = getexpected_income() * tax_rate;
		double exp_total_cf = getexpected_income() -  incometax - family_living - total_crop_lease_payment - total_marginal_lease_payment - debt_payment + off_farm_inc - min_cash ;
		
		if(exp_total_cf > 0) {
		
		double new_debt_pay_cow_mach = (1 - down_payment) * (new_machinery_inv)
				* Variables.getloan_factor_payment_5();
	
		double new_exp_cf = (exp_total_cf - new_debt_pay_cow_mach)
				* max_percent_cf;
			
		int max_cf_bid = (int) (new_exp_cf / interest_rate
				* (1 - 1 / Math.pow(1 + interest_rate, 20)) / (1 - down_payment));
			
		if (max_cf_bid < bid_finances) {
			bid_finances = max_cf_bid;
			}
		} else {
			current_bid = 0;
		}
		
		bid_finances = (int) (bid_finances / fdl.getacres() * risk_parameter);
		if(bid_finances <= 0){
			bid_finances = 0;
		}				
		if (bid_finances < current_bid) {
			current_bid = bid_finances;
		}
		if (getcurrent_bid() <= 0) {
			current_bid = 0;
		}
	}
	
	public void financial_bid_marginalland (SAMA fdl) {
		set_expected_income();
		Parameters p = RunEnvironment.getInstance().getParameters();
		double option_0_limit = (Double) p.getValue("option0Limit");
		double option_1_limit = (Double) p.getValue("option1Limit");
		double option_2_limit = (Double) p.getValue("option2Limit");
		double option_3_limit = (Double) p.getValue("option3Limit");
		double option_4_limit = (Double) p.getValue("option4Limit");
		double option_5_limit = (Double) p.getValue("option5Limit");
		double option_6_limit = (Double) p.getValue("option6Limit");
		double option_7_limit = (Double) p.getValue("option7Limit");
		double option_8_limit = (Double) p.getValue("option8Limit");
		double option_9_limit = (Double) p.getValue("option9Limit");
		double inv_mach_0 = (Double) p.getValue("inv_Mach_0");
		double inv_mach_1 = (Double) p.getValue("inv_Mach_1");
		double inv_mach_2 = (Double) p.getValue("inv_Mach_2");
		double inv_mach_3 = (Double) p.getValue("inv_Mach_3");
		double inv_mach_4 = (Double) p.getValue("inv_Mach_4");
		double inv_mach_5 = (Double) p.getValue("inv_Mach_5");
		double inv_mach_6 = (Double) p.getValue("inv_Mach_6");
		double inv_mach_7 = (Double) p.getValue("inv_Mach_7");
		double inv_mach_8 = (Double) p.getValue("inv_Mach_8");
		double inv_mach_9 = (Double) p.getValue("inv_Mach_9");
		double tax_rate = (Double) p.getValue("taxrate");
		double cash_reserve_percent = (Double) p.getValue("cashReservePercent");
		double down_payment = (Double) p.getValue("downPayment");
		double d_a_ratio = (Double) p.getValue("daRatio");
		double max_percent_cf = (Double) p.getValue("maxPercentCF");
		double interest_rate = (Double) p.getValue("interestRate");
		double old_cows = getn_cows();
		double new_cows = 0;
		double min_ratio = (Double) p.getValue("minRatio");
		double inv_handling = (Double) p.getValue("invhandling");
		double inv_cow_machine = (Double) p.getValue("invcowmachine");
		int min_family_withdrawal = (Integer) p.getValue("minFamilyWithdrawal");
		int min_cash_crop_acre = (Integer) p.getValue("minCashCropAcre");
		int min_cash_hay_acre = (Integer) p.getValue("mincashhayacre");
		livestock_variables = new double[] {cows_head, cows_labour, natural_pasture, improved_pasture, hayland_pasture, pasture_carryover_one,
				pasture_carryover_two, improved_bale_first_cut, improved_bale_second_cut, hay_production_one_cut, hay_production_two_cuts,
				breaking_cost, buy_hay, buy_feed_wheat, buy_feed_barley, feed_early_summer_hay, feed_late_summer_hay, feed_fall_hay, 
				feed_winter_hay, feed_wheat, feed_barley, wheat_straw, barley_straw, sell_hay};
		new_cows = livestock_variables[0];
		
		int capacity_current_mach = 0;
		if (crop_machine_option == 0)
			capacity_current_mach = (int) option_0_limit;
		if (crop_machine_option == 1)
			capacity_current_mach = (int) option_1_limit;
		if (crop_machine_option == 2)
			capacity_current_mach = (int) option_2_limit;
		if (crop_machine_option == 3)
			capacity_current_mach = (int) option_3_limit;
		if (crop_machine_option == 4)
			capacity_current_mach = (int) option_4_limit;
		if (crop_machine_option == 5)
			capacity_current_mach = (int) option_5_limit;
		if (crop_machine_option == 6)
			capacity_current_mach = (int) option_6_limit;
		if (crop_machine_option == 7)
			capacity_current_mach = (int) option_7_limit;
		if (crop_machine_option == 8)
			capacity_current_mach = (int) option_8_limit;
		if (crop_machine_option == 9)
			capacity_current_mach = (int) option_9_limit;
		
		double cash_reserve = cash * cash_reserve_percent;
		double min_cash = (capacity_current_mach * min_cash_crop_acre) + (livestock_variables[2] + livestock_variables[3] + livestock_variables[4]) * min_cash_hay_acre;
		
		new_machinery_inv =  (int) ((int) + (inv_mach_0 * min_ratio * getoption_0_number_machines())
				+ (inv_mach_1 * min_ratio * getoption_1_number_machines())
				+ (inv_mach_2 * min_ratio * getoption_2_number_machines())
				+ (inv_mach_3 * min_ratio * getoption_3_number_machines())
				+ (inv_mach_4 * min_ratio * getoption_4_number_machines())
				+ (inv_mach_5 * min_ratio * getoption_5_number_machines())
				+ (inv_mach_6 * min_ratio * getoption_6_number_machines())
				+ (inv_mach_7 * min_ratio * getoption_7_number_machines())
				+ (inv_mach_8 * min_ratio * getoption_8_number_machines()) + (inv_mach_9
				* min_ratio * getoption_9_number_machines() + inv_handling * min_ratio * getcows_fc_handling_system()) + 
		(inv_cow_machine * min_ratio * getcows_fc_machinery()));
		
		double capital_available = cash - min_cash - min_family_withdrawal - down_payment 
		* new_machinery_inv - cash_reserve;
		
		bid_finances = (int) (capital_available / down_payment);
		double market_value_land = fdl.getAvg_prod_patch()
		/ Variables.getmean_patch_quality() * Variables.getmarginalland_price()
		* fdl.getacres();
		double new_debt = debt + (1 - down_payment) * (new_machinery_inv + market_value_land);
		double new_assets = assets + new_machinery_inv + market_value_land - down_payment
				* (new_machinery_inv + market_value_land);
				
		double max_debt_asset_bid = (d_a_ratio * new_assets + d_a_ratio
		* market_value_land - new_debt)
		/ (d_a_ratio * down_payment + (1 - down_payment));

		if (max_debt_asset_bid < bid_finances) {
			bid_finances = (int) max_debt_asset_bid;
		}
		
		double incometax = getexpected_income() * tax_rate;
		double exp_total_cf = getexpected_income() -  incometax - min_family_withdrawal - total_crop_lease_payment - total_marginal_lease_payment - debt_payment + off_farm_inc - min_cash;
		
		if(exp_total_cf > 0) {
		double new_debt_pay_cow_mach = (1 - down_payment) * (new_machinery_inv)
		* Variables.getloan_factor_payment_5();
			
		double new_exp_cf = (exp_total_cf - new_debt_pay_cow_mach)
		* max_percent_cf;
		
		int max_cf_bid = (int) (new_exp_cf / interest_rate
				* (1 - 1 / Math.pow(1 + interest_rate, 20)) / (1 - down_payment));
		
		if (max_cf_bid < bid_finances) {
			bid_finances = max_cf_bid;
		}
		} else {
			setcurrent_bid_marginalland(0);
		}
		
		bid_finances = (int) (bid_finances / fdl.getacres() * risk_parameter);
		
		if(bid_finances <= 0){
			bid_finances = 0;
		}				
		if (bid_finances < current_bid_marginalland) {
			setcurrent_bid_marginalland(bid_finances);
		}
		if (getcurrent_bid_marginalland() <= 0) {
			setcurrent_bid_marginalland(0);
		}
	}

	public void screen_farmers_plot(SAMA fdl1) {
		if (can_bid == true) {
			int distance_plot = (int) (Math.sqrt(Math.pow(x - fdl1.getX(), 2)
					+ Math.pow(y - fdl1.getY(), 2)));
			if(Variables.getunmanaged() > 60){
				can_bid_on_plot = true;
			}
			else{
			
			if (distance_plot < Variables.getmax_distance()) {
				can_bid_on_plot = true;
			}
			if(fdl1.getpatchtype() == 3 && getfarmer_type() == 1){
				can_bid_on_plot = false;
				//System.out.println("crop farmer doesn't want crap land");
			}
			}
		}
	}
	
	public void energy_crop_production () {
		Parameters p = RunEnvironment.getInstance().getParameters();
		double psr_gj_tonne = (Double)p.getValue("psrgjtonne");
		double gjprice = (Double)p.getValue("gjprice");
		double willow_gj_tonne = (Double)p.getValue("willowgjtonne");
		double poplar_gj_tonne = (Double)p.getValue("poplargjtonne");
		double Per_Tonne_Willow_Custom_Rate = (Double) p.getValue("perTonneWillowCustomRate");	
		double Per_Tonne_Poplar_Custom_Rate = (Double) p.getValue("perTonneWillowCustomRate");
		double Per_Tonne_VC_Willows = (Double) p.getValue("perTonneVCWillow");
		double Per_Tonne_VC_Poplar =(Double) p.getValue("perTonneVCWillow");
		double Per_Tonne_PrairieSandReed_Custom_Rate = (Double) p.getValue("per_Tonne_PrairieSandreed_Custom_Rate");
		double pr_rating = 0;
		double pr_max_psr_yield = (Double)p.getValue("pr_max_psr_yield");
		double hay_psr_ratio = (Double)p.getValue("haypsrratio");
		Iterator<SAMA> it = mylandList.iterator();
		
		double loc_tonnes_willow = 0, loc_tonnes_poplar = 0, loc_tonnes_prairiesandreed = 0;
		
		while(it.hasNext()){
			SAMA sama = it.next();
			
			if(sama.getyears_in_willows()== 3){
				loc_tonnes_willow = (getwillowsnaturalpasture() * willow_yield_np_3) + (getwillowsimprovedpasture() * willow_yield_ip_3) + 
				(getwillowshaylandpasture() * willow_yield_hayland_3);
				
			}
			if(sama.getyears_in_willows()== 6){
				loc_tonnes_willow = (getwillowsnaturalpasture() * willow_yield_np_6) + (getwillowsimprovedpasture() * willow_yield_ip_6) + 
				(getwillowshaylandpasture() * willow_yield_hayland_6);
			}
			if(sama.getyears_in_willows()==9){
				loc_tonnes_willow = (getwillowsnaturalpasture() * willow_yield_np_9) + (getwillowsimprovedpasture() * willow_yield_ip_9) + 
				(getwillowshaylandpasture() * willow_yield_hayland_9);
			}
			if(sama.getyears_in_willows()== 12 || sama.getyears_in_willows()==15 || sama.getyears_in_willows()== 18 || sama.getyears_in_willows()== 21){
				loc_tonnes_willow = (getwillowsnaturalpasture() * willow_yield_np_12_21) + (getwillowsimprovedpasture() * willow_yield_ip_12_21) + 
				(getwillowshaylandpasture() * willow_yield_hayland_12_21);
			}
			
			if(sama.getyears_in_poplar()== 3){
				loc_tonnes_poplar = (getpoplarnaturalpasture() * poplar_yield_np_3) + (getpoplarimprovedpasture() * poplar_yield_ip_3)
				+ (getpoplarhaylandpasture() * poplar_yield_hayland_3);
								
			}
			if(sama.getyears_in_poplar()== 6){
				loc_tonnes_poplar = (getpoplarnaturalpasture() * poplar_yield_np_6) + (getpoplarimprovedpasture() * poplar_yield_ip_6)
				+ (getpoplarhaylandpasture() * poplar_yield_hayland_6);
			}
			if(sama.getyears_in_poplar()== 9){
				loc_tonnes_poplar = (getpoplarnaturalpasture() * poplar_yield_np_9) + (getpoplarimprovedpasture() * poplar_yield_ip_9)
				+ (getpoplarhaylandpasture() * poplar_yield_hayland_9);
			}
			if(sama.getyears_in_poplar()== 12 || sama.getyears_in_poplar()== 15 || sama.getyears_in_poplar()==18 || sama.getyears_in_poplar()==21){
				loc_tonnes_poplar = (getpoplarnaturalpasture() * poplar_yield_np_12_21) + (getpoplarimprovedpasture() * poplar_yield_ip_12_21)
				+ (getpoplarhaylandpasture() * poplar_yield_hayland_12_21);
			}
			
			if(sama.getyears_in_willows() ==  21){
				willowsnaturalpasture = willowsnaturalpasture - sama.getnp();
				willowsimprovedpasture = willowsimprovedpasture - (sama.gettilled_pasture() + sama.gethay_pasture() + sama.getIP());
				willowshaylandpasture = willowshaylandpasture - (sama.gettilled_hay() + sama.gethay_hay());
				if(willowsnaturalpasture< 0){
					willowsnaturalpasture = 0;
				}
				if(willowsimprovedpasture < 0){
					willowsimprovedpasture = 0;
				}
				if(willowshaylandpasture < 0) {
					willowshaylandpasture = 0;
				}
				sama.setin_willows(false);
			}
			if(sama.getyears_in_poplar() == 21){
				poplarnaturalpasture = poplarnaturalpasture - sama.getnp();
				poplarimprovedpasture = poplarimprovedpasture - (sama.gettilled_pasture() + sama.gethay_pasture() + sama.getIP());
				poplarhaylandpasture = poplarhaylandpasture - (sama.gettilled_hay() + sama.gethay_hay());
				sama.setin_poplar(false);
				if(poplarnaturalpasture< 0){
					poplarnaturalpasture = 0;
				}
				if(poplarimprovedpasture < 0){
					poplarimprovedpasture = 0;
				}
				if(poplarhaylandpasture < 0) {
					poplarhaylandpasture = 0;
				}
			}
			if(sama.getin_prairiesandreed() == true){
				
				
					if(sama.getnpQuality() > pr_max_psr_yield) {
						pr_rating = pr_max_psr_yield;
						
						loc_tonnes_prairiesandreed = getprairiesandreednaturalpasture() * hay_psr_ratio * pr_rating/pr_max_psr_yield * Variables.gethay_yield_1() * pr_max_psr_yield/50;
						
							}
					else {
						pr_rating = sama.getnpQuality();
						loc_tonnes_prairiesandreed = getprairiesandreednaturalpasture() * hay_psr_ratio * pr_rating/pr_max_psr_yield * Variables.gethay_yield_1() * pr_max_psr_yield/50;
						
						}
					if(sama.getIPQuality() > pr_max_psr_yield) {
						pr_rating = pr_max_psr_yield;
						loc_tonnes_prairiesandreed = getprairiesandreedimprovedpasture() * hay_psr_ratio * pr_rating/pr_max_psr_yield * Variables.gethay_yield_1() * pr_max_psr_yield/50;
					
							}
					else {
						pr_rating = sama.getIPQuality();
						loc_tonnes_prairiesandreed = getprairiesandreedimprovedpasture() * hay_psr_ratio * pr_rating/pr_max_psr_yield * Variables.gethay_yield_1() * pr_max_psr_yield/50;
						
						}
					if(sama.getHayQuality() > pr_max_psr_yield) {
						pr_rating = pr_max_psr_yield;
						loc_tonnes_prairiesandreed = getprairiesandreedhaylandpasture() * hay_psr_ratio * pr_rating/pr_max_psr_yield * Variables.gethay_yield_1() * pr_max_psr_yield/50;
						
							}
					else {
						pr_rating = sama.getHayQuality();
						loc_tonnes_prairiesandreed = getprairiesandreedhaylandpasture() * hay_psr_ratio * pr_rating/pr_max_psr_yield * Variables.gethay_yield_1() * pr_max_psr_yield/50;
						
						}
					}
			
			
			if(sama.getyears_in_prairie_sandreed() == 7){
				prairiesandreednaturalpasture = prairiesandreednaturalpasture - sama.getnp();
				prairiesandreedimprovedpasture = prairiesandreedimprovedpasture - (sama.gettilled_pasture() + sama.gethay_pasture() + sama.getIP());
				prairiesandreedhaylandpasture = prairiesandreedhaylandpasture - (sama.gettilled_hay() + sama.gethay_hay());
				sama.setin_prairiesandreed(false);
				if(prairiesandreednaturalpasture< 0){
					prairiesandreednaturalpasture = 0;
				}
				if(prairiesandreedimprovedpasture < 0){
					prairiesandreedimprovedpasture = 0;
				}
				if(prairiesandreedhaylandpasture < 0) {
					prairiesandreedhaylandpasture = 0;
				}

			}
			

		}
		gross_income_energycrops = (loc_tonnes_willow * willow_gj_tonne * gjprice + loc_tonnes_poplar * poplar_gj_tonne * gjprice + loc_tonnes_prairiesandreed * psr_gj_tonne * gjprice);
		
		double energycropproductioncosts = loc_tonnes_willow * trucking_distance * Per_Tonne_VC_Willows + loc_tonnes_willow * Per_Tonne_Willow_Custom_Rate	+ loc_tonnes_poplar * trucking_distance * Per_Tonne_VC_Poplar + loc_tonnes_poplar * Per_Tonne_Poplar_Custom_Rate  	+ loc_tonnes_prairiesandreed * Per_Tonne_PrairieSandReed_Custom_Rate;
				
		total_net_energy_income = gross_income_energycrops - energycropproductioncosts;
	}

	public void actual_crop_production() {
		Parameters p = RunEnvironment.getInstance().getParameters();

		double Per_Acre_VC_Summer_Fallow = (Double) p
				.getValue("perAcreVCSummerFallow"); // Variable cost per acre
		double Per_Acre_VC_Wheat_on_Fallow = (Double) p
				.getValue("perAcreVCWheatonFallow"); // 
		double Per_Acre_VC_Canola_on_Stubble = (Double) p
				.getValue("perAcreVCCanolaonStubble"); // 
		double Per_Acre_VC_Barley_on_Stubble = (Double) p
				.getValue("perAcreVCBarleyonStubble"); // 
		double Per_Acre_VC_Wheat_on_Stubble = (Double) p
				.getValue("perAcreVCWheatonStubble"); // 
		double Per_Acre_VC_Flax_on_Stubble = (Double) p.getValue("perAcreVCFlaxonStubble");
		double Per_Acre_VC_Peas_on_Stubble = (Double) p.getValue("perAcreVCPeasonStubble");
		double Per_Acre_VC_Willows = (Double) p.getValue("perAcreVCWillows");
		double Per_Acre_VC_Wheat = (Double) p.getValue("perAcreVCWheat"); // 
		double Per_Acre_VC_Canola = (Double) p.getValue("perAcreVCCanola"); // 
		double Per_Acre_VC_Barley = (Double) p.getValue("perAcreVCBarley"); // 
		double Per_Tonne_VC_Wheat = (Double) p.getValue("perTonneVCWheat"); // 
		double Per_Tonne_VC_Canola = (Double) p.getValue("perTonneVCCanola"); // 
		double Per_Tonne_VC_Barley = (Double) p.getValue("perTonneVCBarley"); // 
		double Per_Acre_VC_Flax = (Double) p.getValue("perAcreVCFlax");
		double Per_Acre_VC_Durum_on_Stubble = (Double) p.getValue("perAcreVCDurumonStubble");
		double Per_Tonne_VC_Durum = (Double) p.getValue("perTonneVCDurum");
	 	double Per_Acre_VC_Peas = (Double) p.getValue("perAcreVCPeas");
	 	double Per_Acre_VC_Lentils = (Double) p.getValue("perAcreVCLentils");			
		double Per_Tonne_VC_Flax = (Double) p.getValue("perTonneVCFlax");
		double Per_Tonne_VC_Lentils = (Double) p.getValue("perTonneVCLentils");
	 	double Per_Tonne_VC_Peas = (Double) p.getValue("perTonneVCPeas");	
	 	double per_Tonne_Willow_Custom_Rate = (Double) p.getValue("perTonneWillowCustomRate");	
		double trans_rate_crop_mile_1 = (Double) p
				.getValue("transratecropmile1");
		double trans_rate_crop_mile = (Double) p.getValue("transratecropmile");
		double tonnes_crop_canola; // 	
		double tonnes_crop_barley;
		double tonnes_crop_wheat;
		double Increase_NoTill = (Double) p.getValue("increaseNoTill"); // 
		yield_mult = 1 + Increase_NoTill;
		double Machine_VC_0 = (Double) p.getValue("machineVC0"); // 
		double Machine_VC_1 = (Double) p.getValue("machineVC1"); // 
		double Machine_VC_2 = (Double) p.getValue("machineVC2"); // 
		double Machine_VC_3 = (Double) p.getValue("machineVC3"); // 
		double Machine_VC_4 = (Double) p.getValue("machineVC4"); // 
		double Machine_VC_5 = (Double) p.getValue("machineVC5"); // 
		double Machine_VC_6 = (Double) p.getValue("machineVC6"); // 
		double Machine_VC_7 = (Double) p.getValue("machineVC7"); //
		double Machine_VC_8 = (Double) p.getValue("machineVC8"); // 
		double Machine_VC_9 = (Double) p.getValue("machineVC9"); // 
		double Per_Acre_Annualized_Breaking = (Double) p.getValue("peracreannualizedbreaking");
		double Per_Acre_VC_NP = (Double) p.getValue("peracrevcnp");
		double Per_Acre_VC_IP = (Double) p.getValue("peracrevcip");
		double Per_Acre_VC_HL = (Double) p.getValue("peracrevchl");
		double Per_Acre_VC_Bale_IP_1 = (Double) p.getValue("peracrevcbaleip1");
		double Per_Acre_VC_Bale_IP_2 = (Double) p.getValue("peracrevcbaleip2");
		double Per_Acre_VC_Hayproduction_1 = (Double) p.getValue("peracrevchayproduction1");
		double Per_Acre_VC_Hayproduction_2 = (Double) p.getValue("peracrevchayproduction2");
		double VC_Cow = (Double) p.getValue("vccow");
		double FC_Cow_Labour = (Double) p.getValue("fccowlabour");
		int min_family_withdrawal = (Integer) p.getValue("minFamilyWithdrawal");		
		double pr_max_hay_yield = (Double)p.getValue("prmaxhayyield");	
		double threshold_hay_1 = (Double)p.getValue("thresholdhay1");	
		double Per_Acre_VC_Durum = (Double) p.getValue("perAcreVCDurum");
		double fallow_yield_mult = (Double) p.getValue("fallow_yield_mult");
		double pr_rating_np = 0;
		double pr_rating_ip = 0;
		double pr_rating_hay = 0;
		double gross_crop_inc;
		double bu;
		double trans_cost_crop;
		double vc_acre;
		double vc_tonne;
		double net_crop_inc;
		double crop_inc;			
		double error = 1 + ((int) (Math.random()*10)-5.0)/100.0;
		double Per_ton_feed_hay_cost = (Double) p.getValue("pertonfeedhaycost");
		double Per_ton_grain_cost = (Double) p.getValue("pertonfeedgraincost");
		double transaction_fee_hay = (Double) p.getValue("transactionfeehay");
		
		if(will_cows == false){
		
		Iterator<SAMA> it = mylandList.iterator();
		double loc_tonnes_crop_canola_stubble = 0, loc_tonnes_crop_wheat_sf = 0, loc_tonnes_crop_barley_stubble = 0, loc_tonnes_crop_wheat_stubble = 0, loc_tonnes_crop_canola_notill = 0, loc_tonnes_crop_barley_notill = 0, loc_tonnes_crop_wheat_notill = 0, loc_tonnes_crop_flax_stubble = 0, loc_tonnes_crop_peas_stubble = 0, loc_tonnes_crop_flax_notill = 0, loc_tonnes_crop_peas_notill = 0, loc_tonnes_crop_lentils_notill = 0,
		loc_tonnes_crop_durum_stubble = 0, loc_tonnes_crop_durum_notill = 0;
		while (it.hasNext()) {
			SAMA sama = it.next();
						
				loc_tonnes_crop_canola_stubble += ((getcanolastubble() * 1
						* sama.getCanolaYieldIndex())*(error
						* Variables.getyield_canola())) / 44.09;
				
				loc_tonnes_crop_wheat_sf += ((getwheatfallow() * fallow_yield_mult * 1
						* sama.getWheatSfYieldIndex()) * (error
						* Variables.getyield_wheat())) / 36.74;
				
				loc_tonnes_crop_barley_stubble += ((getbarleystubble() * 1
						* sama.getBarleyYieldIndex()) * (error
						* Variables.getyield_barley())) / 45.93;
				
				loc_tonnes_crop_wheat_stubble += ((getwheatstubble() * 1
						* sama.getWheatYieldIndex()) * (error
						* Variables.getyield_wheat())) / 36.74;
				
				loc_tonnes_crop_durum_stubble += ((getdurumstubble() * 1 * sama.getDurumYieldIndex() * error * Variables.getyield_durum()))/36.74;
				
				loc_tonnes_crop_flax_stubble += ((getflaxstubble() * 1 * sama.getFlaxYieldIndex()) * (error * Variables.getyield_flax()))/39.37;
				 				
				loc_tonnes_crop_peas_stubble += ((getpeasstubble() *1 * sama.getPeasYieldIndex()) * (error * Variables.getyield_peas()))/36.74;
								
				loc_tonnes_crop_canola_notill += ((getcanolanotill() * yield_mult
						* sama.getCanolaYieldIndex()) * (error * Variables.getyield_canola())) / 44.09;

				loc_tonnes_crop_barley_notill += ((getbarleynotill() * yield_mult
						* sama.getBarleyYieldIndex()) * (error
						* Variables.getyield_barley())) / 45.93;

				loc_tonnes_crop_wheat_notill += ((getwheatnotill() * yield_mult
						* sama.getWheatYieldIndex()) * (error
						* Variables.getyield_wheat())) / 36.74;
				
				loc_tonnes_crop_durum_notill += ((getdurumnotill() * yield_mult
						* sama.getDurumYieldIndex()) * (error
						* Variables.getyield_durum()))/36.74;
				
				loc_tonnes_crop_flax_notill += ((getflaxnotill() * yield_mult * sama.getFlaxYieldIndex()) * (error
						* Variables.getyield_flax()))/ 39.37;
				
				loc_tonnes_crop_peas_notill += ((getpeasnotill() * yield_mult * sama.getPeasYieldIndex()) * (error
						* Variables.getyield_peas()))/ 36.74;
				
				loc_tonnes_crop_lentils_notill += ((getlentilsnotill() * yield_mult * sama.getLentilsYieldIndex()) * (error
						* Variables.getyield_lentils()))/ 36.74;
								
		}
		
		loc_tonnes_crop_canola_stubble = loc_tonnes_crop_canola_stubble/total_plots;
		loc_tonnes_crop_flax_stubble = loc_tonnes_crop_flax_stubble/total_plots;
		loc_tonnes_crop_peas_stubble = loc_tonnes_crop_peas_stubble/total_plots;
		loc_tonnes_crop_flax_notill = loc_tonnes_crop_flax_notill/total_plots;
		loc_tonnes_crop_peas_notill = loc_tonnes_crop_peas_notill/total_plots;
		loc_tonnes_crop_lentils_notill = loc_tonnes_crop_lentils_notill/total_plots;
		loc_tonnes_crop_wheat_sf = loc_tonnes_crop_wheat_sf/total_plots;
		loc_tonnes_crop_barley_stubble = loc_tonnes_crop_barley_stubble/total_plots;
		loc_tonnes_crop_wheat_stubble = loc_tonnes_crop_wheat_stubble/total_plots;
		loc_tonnes_crop_durum_stubble = loc_tonnes_crop_durum_stubble/total_plots;
		loc_tonnes_crop_canola_notill = loc_tonnes_crop_canola_notill/total_plots;
		loc_tonnes_crop_barley_notill = loc_tonnes_crop_barley_notill/total_plots;
		loc_tonnes_crop_wheat_notill = loc_tonnes_crop_wheat_notill/total_plots;
		loc_tonnes_crop_barley_stubble = loc_tonnes_crop_barley_stubble/total_plots;
		loc_tonnes_crop_wheat_stubble = loc_tonnes_crop_wheat_stubble/total_plots;
		loc_tonnes_crop_barley_notill = loc_tonnes_crop_barley_notill/total_plots;
		loc_tonnes_crop_wheat_notill = loc_tonnes_crop_wheat_notill/total_plots;
		loc_tonnes_crop_durum_notill = loc_tonnes_crop_durum_notill/total_plots;
		
				gross_crop_inc = loc_tonnes_crop_canola_stubble * 44.09
						* Variables.getprice_canola()
						+ loc_tonnes_crop_wheat_stubble * 36.74
						* Variables.getprice_wheat()
						+ loc_tonnes_crop_barley_stubble * 45.93
						* Variables.getprice_barley()
						+ loc_tonnes_crop_wheat_sf * 36.74
						* Variables.getprice_wheat()
						+ loc_tonnes_crop_durum_stubble * 36.74 
						* Variables.getprice_durum()						
						+ loc_tonnes_crop_canola_notill * 44.09
						* Variables.getprice_canola()
						+ loc_tonnes_crop_barley_notill * 45.93
						* Variables.getprice_barley()
						+ loc_tonnes_crop_wheat_notill * 36.74
						* Variables.getprice_wheat()
						+ loc_tonnes_crop_durum_notill * 36.74
						+ Variables.getprice_durum()
						+ loc_tonnes_crop_flax_stubble * 39.37
						* Variables.getprice_flax()
						+ loc_tonnes_crop_peas_stubble * 36.74
						* Variables.getprice_peas()
						+ loc_tonnes_crop_flax_notill * 39.37
						* Variables.getprice_flax()
						+ loc_tonnes_crop_peas_notill * 36.74
						* Variables.getprice_peas()
						+ loc_tonnes_crop_lentils_notill * 36.74
						* Variables.getprice_lentils();
				
				vc_acre = getfallow() * Per_Acre_VC_Summer_Fallow 
						+ getwheatfallow() * (Per_Acre_VC_Wheat_on_Fallow + producer_premium_wheat_fallow)
						+ getcanolastubble() * (Per_Acre_VC_Canola_on_Stubble + producer_premium_canola_stubble)
						+ getbarleystubble() * (Per_Acre_VC_Barley_on_Stubble + producer_premium_barley_stubble)
						+ getwheatstubble() * (Per_Acre_VC_Wheat_on_Stubble + producer_premium_wheat_stubble)
						+ getdurumstubble() * (Per_Acre_VC_Durum_on_Stubble + producer_premium_durum_stubble)
						+ getflaxstubble() * (Per_Acre_VC_Flax_on_Stubble + producer_premium_flax_stubble)
						+ getpeasstubble() * (Per_Acre_VC_Peas_on_Stubble + producer_premium_peas_stubble)
						+ getbarleynotill() * (Per_Acre_VC_Barley + producer_premium_barley_notill)
						+ getcanolanotill() * (Per_Acre_VC_Canola + producer_premium_canola_notill)
						+ getwheatnotill() * (Per_Acre_VC_Wheat + producer_premium_wheat_notill)
						+ getdurumnotill() * (Per_Acre_VC_Durum + producer_premium_durum_notill)
						+ getflaxnotill() * (Per_Acre_VC_Flax + producer_premium_flax_notill)
						+ getpeasnotill() * (Per_Acre_VC_Peas + producer_premium_peas_notill)
						+ getlentilsnotill() * (Per_Acre_VC_Lentils + producer_premium_lentils_notill)
						+ getoption0acres() * Machine_VC_0 + getoption1acres()
						* Machine_VC_1 + getoption2acres() * Machine_VC_2
						+ getoption3acres() * Machine_VC_3 + getoption4acres()
						* Machine_VC_4 + getoption5acres() * Machine_VC_5
						+ getoption6acres() * Machine_VC_6 + getoption7acres()
						* Machine_VC_7 + getoption8acres() * Machine_VC_8
						+ getoption9acres() * Machine_VC_9;

				vc_tonne = loc_tonnes_crop_canola_stubble * Per_Tonne_VC_Canola * trucking_distance
						+ loc_tonnes_crop_wheat_stubble * Per_Tonne_VC_Wheat * trucking_distance
						+ loc_tonnes_crop_barley_stubble * Per_Tonne_VC_Barley * trucking_distance
						+ loc_tonnes_crop_flax_stubble * Per_Tonne_VC_Flax * trucking_distance
						+ loc_tonnes_crop_peas_stubble * Per_Tonne_VC_Peas * trucking_distance
						+ loc_tonnes_crop_durum_stubble * Per_Tonne_VC_Durum * trucking_distance
						+ loc_tonnes_crop_wheat_sf * Per_Tonne_VC_Wheat * trucking_distance
						+ loc_tonnes_crop_canola_notill * Per_Tonne_VC_Canola * trucking_distance
						+ loc_tonnes_crop_barley_notill * Per_Tonne_VC_Barley * trucking_distance
						+ loc_tonnes_crop_wheat_notill * Per_Tonne_VC_Wheat * trucking_distance
						+ loc_tonnes_crop_durum_notill * Per_Tonne_VC_Durum * trucking_distance
						+ loc_tonnes_crop_flax_notill * Per_Tonne_VC_Flax * trucking_distance
						+ loc_tonnes_crop_peas_notill * Per_Tonne_VC_Peas * trucking_distance
						+ loc_tonnes_crop_lentils_notill * Per_Tonne_VC_Lentils * trucking_distance;

				crop_inc = Math.round((gross_crop_inc - vc_acre - vc_tonne) * 100 / 100);
				
				double hayproductioncosts = improved_bale_first_cut * Per_Acre_VC_Bale_IP_1 
				+ improved_bale_second_cut * Per_Acre_VC_Bale_IP_2 + hay_production_one_cut * Per_Acre_VC_Hayproduction_1 + hay_production_two_cuts * Per_Acre_VC_Hayproduction_2;
				
				gross_income_hay = Math.round((hayforsale * Variables.getprice_hay() - (transaction_fee_hay)) + (sell_hay * Variables.getprice_hay() - (transaction_fee_hay)));
				
				
					
				gross_income_crop = gross_crop_inc;
				
				gross_income = gross_income_crop + gross_income_hay;
				
				total_net_hay_income = gross_income_hay - hayproductioncosts;
				
				total_net_crop_income = Math
				.round((gross_crop_inc - vc_acre - vc_tonne) * 100 / 100);
				total_net_inc = total_net_crop_income + total_net_hay_income + total_net_energy_income;
				
			
		}
			
	if (will_cows == true){
		
		 Iterator<SAMA> it = mylandList.iterator();
			double loc_tonnes_crop_canola_stubble = 0, loc_tonnes_crop_flax_stubble = 0, loc_tonnes_crop_peas_stubble = 0, loc_tonnes_crop_flax_notill = 0, loc_tonnes_crop_peas_notill = 0, loc_tonnes_crop_lentils_notill = 0, loc_tonnes_crop_wheat_sf = 0, loc_tonnes_crop_barley_stubble = 0, loc_tonnes_crop_wheat_stubble = 0, loc_tonnes_crop_canola_notill = 0, loc_tonnes_crop_barley_notill = 0, loc_tonnes_crop_wheat_notill = 0,
			loc_tonnes_crop_durum_stubble = 0, loc_tonnes_crop_durum_notill = 0;
			while (it.hasNext()) {
				SAMA sama = it.next();
					
					loc_tonnes_crop_flax_stubble += ((getflaxstubble() * 1 * sama.getFlaxYieldIndex()) * (error * Variables.getyield_flax()))/39.37;
				
					loc_tonnes_crop_peas_stubble += ((getpeasstubble() * 1 * sama.getPeasYieldIndex()) * (error * Variables.getyield_peas()))/36.74;
					
					loc_tonnes_crop_durum_stubble += ((getdurumstubble() * 1 * sama.getDurumYieldIndex() * error * Variables.getyield_durum()))/36.74;
					
					
					loc_tonnes_crop_canola_stubble += ((getcanolastubble() * 1
							* sama.getCanolaYieldIndex()) * (error
							* Variables.getyield_canola())) / 44.09;
					
					tonnes_crop_wheat_sf += getwheatfallow() * 1
							* sama.getWheatSfYieldIndex()
							* Variables.getyield_wheat() / 36.74;
					
					tonnes_crop_barley_stubble += getbarleystubble() * 1
							* sama.getBarleyYieldIndex()
							* Variables.getyield_barley() / 45.93;
					
					tonnes_crop_wheat_stubble += getwheatstubble() * 1
							* sama.getWheatYieldIndex()
							* Variables.getyield_wheat() / 36.74;
					
					loc_tonnes_crop_canola_notill += getcanolanotill() * yield_mult
							* sama.getCanolaYieldIndex()
							* Variables.getyield_canola() / 44.09;
					
					loc_tonnes_crop_flax_notill += getflaxnotill() * yield_mult * sama.getFlaxYieldIndex() / 39.37;

					loc_tonnes_crop_peas_notill += getpeasnotill() * yield_mult * sama.getPeasYieldIndex() / 36.74;
					
					loc_tonnes_crop_lentils_notill += getlentilsnotill() * yield_mult * sama.getLentilsYieldIndex() / 36.74;
					
					loc_tonnes_crop_durum_notill += ((getdurumnotill() * yield_mult
							* sama.getDurumYieldIndex()) * (error * Variables.getyield_durum()))/36.74;
										
					tonnes_crop_barley_notill += getbarleynotill() * yield_mult
							* sama.getBarleyYieldIndex()
							* Variables.getyield_barley() / 45.93;

					tonnes_crop_wheat_notill += getwheatnotill() * yield_mult
							* sama.getWheatYieldIndex()
							* Variables.getyield_wheat() / 36.74;
					
					tonnes_crop_feed_barley_notill += getfeedbarleynotill() * yield_mult * sama.getBarleyYieldIndex() * Variables.getyield_barley()/45.93;
					
					tonnes_crop_feed_wheat_notill += getfeedwheatnotill() * yield_mult * sama.getWheatYieldIndex() * Variables.getyield_wheat()/36.74;
					
					tonnes_crop_feed_barley_con += getfeedbarleycon() * sama.getBarleyYieldIndex() * Variables.getyield_barley()/45.93;
					
					tonnes_crop_feed_wheat_con += getfeedwheatcon() * sama.getWheatYieldIndex() * Variables.getyield_wheat()/36.74;
					
					
					
					
			}	
			
			loc_tonnes_crop_canola_stubble = loc_tonnes_crop_canola_stubble/total_plots;
			loc_tonnes_crop_flax_stubble = loc_tonnes_crop_flax_stubble/total_plots;
			loc_tonnes_crop_peas_stubble = loc_tonnes_crop_peas_stubble/total_plots;
			loc_tonnes_crop_flax_notill = loc_tonnes_crop_flax_notill/total_plots;
			loc_tonnes_crop_peas_notill = loc_tonnes_crop_peas_notill/total_plots;
			loc_tonnes_crop_lentils_notill = loc_tonnes_crop_lentils_notill/total_plots;		
			loc_tonnes_crop_durum_stubble = loc_tonnes_crop_durum_stubble/total_plots;					
			loc_tonnes_crop_canola_notill = loc_tonnes_crop_canola_notill/total_plots;			
			loc_tonnes_crop_durum_notill = loc_tonnes_crop_durum_notill/total_plots;
			tonnes_crop_barley_stubble = tonnes_crop_barley_stubble/total_plots;
			tonnes_crop_wheat_stubble = tonnes_crop_wheat_stubble/total_plots;
			tonnes_crop_barley_notill = tonnes_crop_barley_notill/total_plots;
			tonnes_crop_wheat_notill = tonnes_crop_wheat_notill/total_plots;
			tonnes_crop_wheat_sf = tonnes_crop_wheat_sf/total_plots;
			tonnes_crop_feed_barley_notill = tonnes_crop_feed_barley_notill/total_plots;			
			tonnes_crop_feed_wheat_notill = tonnes_crop_feed_wheat_notill/total_plots;			
			tonnes_crop_feed_barley_con = tonnes_crop_feed_barley_con/total_plots;			
			tonnes_crop_feed_wheat_con = tonnes_crop_feed_wheat_con/total_plots;
			
			
					actual_early_pasture_production();
					actual_late_pasture_production();
					actual_fall_pasture_production();
					actual_first_cut_bale_production();
					actual_second_cut_bale_production();
					
					recourse_lp();
					
					
					gross_crop_inc = Math.round(loc_tonnes_crop_canola_stubble * 44.09 * Variables.getprice_canola() 
					+ loc_tonnes_crop_canola_notill * 44.09 * Variables.getprice_canola() 
					+ loc_tonnes_crop_flax_stubble * 39.37 	* Variables.getprice_flax()
					+ loc_tonnes_crop_peas_stubble * 36.74 * Variables.getprice_peas()
					+ loc_tonnes_crop_durum_stubble * 36.74 * Variables.getprice_durum()
					+ loc_tonnes_crop_flax_notill * 39.37 * Variables.getprice_flax()
					+ loc_tonnes_crop_peas_notill * 36.74 * Variables.getprice_peas()
					+ loc_tonnes_crop_lentils_notill * 36.74 * Variables.getprice_lentils()
					+ loc_tonnes_crop_durum_notill * 36.74 * Variables.getprice_durum()
					+ barleyforsale * Variables.getprice_barley()*45.93 + wheatforsale * Variables.getprice_wheat()*36.74);
										
					vc_acre = Math.round(getfallow() * Per_Acre_VC_Summer_Fallow
					+ getwheatfallow() * (Per_Acre_VC_Wheat_on_Fallow + producer_premium_wheat_fallow)
					+ getcanolastubble() * (Per_Acre_VC_Canola_on_Stubble + producer_premium_canola_stubble)
					+ getbarleystubble() * (Per_Acre_VC_Barley_on_Stubble + producer_premium_barley_stubble)
					+ getwheatstubble() * (Per_Acre_VC_Wheat_on_Stubble + producer_premium_wheat_stubble)
					+ getdurumstubble() * (Per_Acre_VC_Durum_on_Stubble + producer_premium_durum_stubble)
					+ getflaxstubble() * (Per_Acre_VC_Flax_on_Stubble + producer_premium_flax_stubble)
					+ getpeasstubble() * (Per_Acre_VC_Peas_on_Stubble + producer_premium_peas_stubble)
					+ getbarleynotill() * (Per_Acre_VC_Barley + producer_premium_barley_notill)
					+ getcanolanotill() * (Per_Acre_VC_Canola + producer_premium_canola_notill)
					+ getwheatnotill() * (Per_Acre_VC_Wheat + producer_premium_wheat_notill)
					+ getdurumnotill() * (Per_Acre_VC_Durum + producer_premium_durum_notill)
					+ getflaxnotill() * (Per_Acre_VC_Flax + producer_premium_flax_notill)
					+ getpeasnotill() * (Per_Acre_VC_Peas + producer_premium_peas_notill)
					+ getlentilsnotill() * (Per_Acre_VC_Lentils + producer_premium_lentils_notill)
					+ getfeedwheatnotill() * Per_Acre_VC_Wheat
					+ getfeedbarleynotill() * Per_Acre_VC_Barley
					+ getfeedwheatcon() * Per_Acre_VC_Wheat_on_Stubble
					+ getfeedbarleycon() * Per_Acre_VC_Barley_on_Stubble
					+ getoption0acres() * Machine_VC_0 + getoption1acres()
					* Machine_VC_1 + getoption2acres() * Machine_VC_2
					+ getoption3acres() * Machine_VC_3 + getoption4acres()
					* Machine_VC_4 + getoption5acres() * Machine_VC_5
					+ getoption6acres() * Machine_VC_6 + getoption7acres()
					* Machine_VC_7 + getoption8acres() * Machine_VC_8
					+ getoption9acres() * Machine_VC_9);

			vc_tonne = Math.round(loc_tonnes_crop_canola_stubble * Per_Tonne_VC_Canola * trucking_distance
					+ tonnes_crop_wheat_stubble * Per_Tonne_VC_Wheat * trucking_distance
					+ tonnes_crop_barley_stubble * Per_Tonne_VC_Barley * trucking_distance
					+ loc_tonnes_crop_durum_stubble * Per_Tonne_VC_Durum * trucking_distance
					+ loc_tonnes_crop_flax_stubble * Per_Tonne_VC_Flax * trucking_distance
					+ loc_tonnes_crop_peas_stubble * Per_Tonne_VC_Peas * trucking_distance
					+ tonnes_crop_wheat_sf * Per_Tonne_VC_Wheat * trucking_distance
					+ loc_tonnes_crop_canola_notill * Per_Tonne_VC_Canola * trucking_distance
					+ tonnes_crop_barley_notill * Per_Tonne_VC_Barley * trucking_distance
					+ tonnes_crop_wheat_notill * Per_Tonne_VC_Wheat * trucking_distance
					+ loc_tonnes_crop_flax_notill * Per_Tonne_VC_Flax * trucking_distance
					+ loc_tonnes_crop_peas_notill * Per_Tonne_VC_Peas * trucking_distance
					+ loc_tonnes_crop_lentils_notill * Per_Tonne_VC_Lentils * trucking_distance
					+ loc_tonnes_crop_durum_notill * Per_Tonne_VC_Durum * trucking_distance);
			
			double livestock_costs = 0;
		
			livestock_costs = Math.round(natural_pasture * Per_Acre_VC_NP + improved_pasture * Per_Acre_VC_IP + hayland_pasture * Per_Acre_VC_HL + improved_bale_first_cut * Per_Acre_VC_Bale_IP_1 
			+ improved_bale_second_cut * Per_Acre_VC_Bale_IP_2 + hay_production_one_cut * Per_Acre_VC_Hayproduction_1 + hay_production_two_cuts * Per_Acre_VC_Hayproduction_2 + n_cows * VC_Cow + cows_labour * FC_Cow_Labour
			+ (purchase_hay * Variables.getprice_hay()) + purchase_barley * Variables.getprice_barley() * 45.93 + earlyhay * Per_ton_feed_hay_cost  + latehay * Per_ton_feed_hay_cost + fallhay * Per_ton_feed_hay_cost + winterhay * Per_ton_feed_hay_cost + winterbarley * Per_ton_grain_cost + winterwheat * Per_ton_grain_cost + barleystraw * Per_ton_feed_hay_cost + wheatstraw * Per_ton_feed_hay_cost);
			
			gross_income_hay = Math.round((hayforsale * Variables.getprice_hay() - (transaction_fee_hay)) + (sell_hay * Variables.getprice_hay() - (transaction_fee_hay)));
			
			gross_income_livestock = Math.round((Variables.getprice_calf() * 495 * n_cows) + sell_old_cows);
					
			gross_income_crop = Math.round(gross_crop_inc);
			gross_income = gross_income_crop + gross_income_livestock + gross_income_hay;
			
		
			total_net_crop_income = Math.round(gross_crop_inc - vc_acre - vc_tonne);
			total_net_calf_income = Math.round(gross_income_livestock - livestock_costs);
			
			total_net_inc = Math.round(gross_crop_inc + gross_income_hay + total_net_energy_income + gross_income_livestock - livestock_costs - vc_acre - vc_tonne)*100/100;
			
		
			
			
			
			
			}
		 
	 }

	
	public void actual_early_pasture_production() {
		Parameters p = RunEnvironment.getInstance().getParameters();
		double pr_rating_np = 0;
		double pr_rating_ip = 0;
		double pr_rating_hay = 0;
		double pr_max_hay_yield = (Double)p.getValue("prmaxhayyield");	
		 
		Iterator<SAMA> it = mylandList.iterator();
		 while (it.hasNext()) {
				SAMA sama = it.next();
		if(sama.getnpQuality() > pr_max_hay_yield) {
			pr_rating_np = pr_max_hay_yield;
		}
		else {
			pr_rating_np = sama.getnpQuality();
		}
		if(sama.getIPQuality() > pr_max_hay_yield) {
			pr_rating_ip = pr_max_hay_yield;
		}
		else {
			pr_rating_ip = sama.getIPQuality();
		}
		if(sama.getHayQuality() > pr_max_hay_yield) {
			pr_rating_hay= pr_max_hay_yield;
		}		
		else {
			pr_rating_hay = sama.getHayQuality();
		}				
		
		double np_yield_early = pr_rating_np / pr_max_hay_yield * Variables.getmax_hay_yield_earlypasture();
		double ip_yield_early = pr_rating_ip / pr_max_hay_yield * Variables.getmax_hay_yield_earlypasture();
		double hay_yield_early = pr_rating_hay / pr_max_hay_yield * Variables.getmax_hay_yield_earlypasture();
			total_np_mcals_early = ((np_yield_early * Variables.getmcals_ton_np_early() * naturalpasture));
			total_ip_mcals_early = ((ip_yield_early * Variables.getmcals_ton_ip_early() * improvedpasture));
			total_hayland_mcals_early = ((hay_yield_early * Variables.getmcals_ton_hayland_early()));
		 }
	}
	
	public void actual_late_pasture_production() {
		Parameters p = RunEnvironment.getInstance().getParameters();
		double pr_rating_np = 0;
		double pr_rating_ip = 0;
		double pr_rating_hay = 0;
		double pr_max_hay_yield = (Double)p.getValue("prmaxhayyield");	
		 
		Iterator<SAMA> it = mylandList.iterator();
		 while (it.hasNext()) {
				SAMA sama = it.next();
		if(sama.getnpQuality() > pr_max_hay_yield) {
			pr_rating_np = pr_max_hay_yield;
		}		
		else {
			pr_rating_np = sama.getnpQuality();
		}		
		if(sama.getIPQuality() > pr_max_hay_yield) {
			pr_rating_ip = pr_max_hay_yield;
		}		
		else {
			pr_rating_ip = sama.getIPQuality();
		}		
		if(sama.getHayQuality() > pr_max_hay_yield) {
			pr_rating_hay= pr_max_hay_yield;
		}		
		else {
			pr_rating_hay = sama.getHayQuality();
		}				
		
		double np_yield_late = pr_rating_np / pr_max_hay_yield * Variables.getmax_hay_yield_latepasture();
		double ip_yield_late = pr_rating_ip / pr_max_hay_yield * Variables.getmax_hay_yield_latepasture();
		double hay_yield_late = pr_rating_hay / pr_max_hay_yield * Variables.getmax_hay_yield_latepasture();
			total_np_mcals_late = ((np_yield_late * Variables.getmcals_ton_np_late() * naturalpasture));
			total_ip_mcals_late = ((ip_yield_late * Variables.getmcals_ton_ip_late() * improvedpasture));
			total_hayland_mcals_late = ((hay_yield_late * Variables.getmcals_ton_hayland_late()));
		 }
	}
	
	public void actual_fall_pasture_production() {
		Parameters p = RunEnvironment.getInstance().getParameters();
		double pr_rating_np = 0;
		double pr_rating_ip = 0;
		double pr_rating_hay = 0;
		double pr_max_hay_yield = (Double)p.getValue("prmaxhayyield");	
		 
		Iterator<SAMA> it = mylandList.iterator();
		 while (it.hasNext()) {
				SAMA sama = it.next();
		if(sama.getnpQuality() > pr_max_hay_yield) {
			pr_rating_np = pr_max_hay_yield;
		}		
		else {
			pr_rating_np = sama.getnpQuality();
		}		
		if(sama.getIPQuality() > pr_max_hay_yield) {
			pr_rating_ip = pr_max_hay_yield;
		}		
		else {
			pr_rating_ip = sama.getIPQuality();
		}		
		if(sama.getHayQuality() > pr_max_hay_yield) {
			pr_rating_hay= pr_max_hay_yield;
		}		
		else {
			pr_rating_hay = sama.getHayQuality();
		}				
		
		double np_yield_fall = pr_rating_np / pr_max_hay_yield * Variables.getmax_hay_yield_fall();
		double ip_yield_fall = pr_rating_ip / pr_max_hay_yield * Variables.getmax_hay_yield_fall();
		double hay_yield_fall = pr_rating_hay / pr_max_hay_yield * Variables.getmax_hay_yield_fall();
			total_np_mcals_fall = ((np_yield_fall * Variables.getmcals_ton_np_fall() * naturalpasture));
			total_ip_mcals_fall = ((ip_yield_fall * Variables.getmcals_ton_ip_fall() * improvedpasture));
			total_hayland_mcals_fall = ((hay_yield_fall * Variables.getmcals_ton_hayland_fall()));
		 }
	}
	
	public void actual_first_cut_bale_production () {
		Parameters p = RunEnvironment.getInstance().getParameters();
		double pr_rating_ip = 0;
		double pr_rating_hay = 0;
		double pr_max_hay_yield = (Double)p.getValue("prmaxhayyield");	
		 
		Iterator<SAMA> it = mylandList.iterator();
		 while (it.hasNext()) {
				SAMA sama = it.next();
		if(sama.getIPQuality() > pr_max_hay_yield) {
			pr_rating_ip = pr_max_hay_yield;
		}		
		else {
			pr_rating_ip = sama.getIPQuality();
		}		
		if(sama.getHayQuality() > pr_max_hay_yield) {
			pr_rating_hay= pr_max_hay_yield;
		}		
		else {
			pr_rating_hay = sama.getHayQuality();
		}
		
		if(improvedbaleone > 0) {
			ip_bale_one_yield = pr_rating_ip / pr_max_hay_yield * Variables.getmax_hay_yield_earlypasture();
			total_ip_bale_yield_one = ip_bale_one_yield * improvedbaleone;
			total_improved_bale_one_mcals = ((ip_bale_one_yield * Variables.getmcals_ton_ip_baled_one()) * improvedbaleone);
		}
		if(haybaleone > 0) {
			hay_bale_one_yield = pr_rating_hay / pr_max_hay_yield * Variables.getmax_hay_yield_earlypasture();
			total_hay_bale_yield_one = hay_bale_one_yield * haybaleone;
			total_haybaleone_mcals = ((hay_bale_one_yield * Variables.getmcals_ton_hayland_baled_one()) * haybaleone);
		}
	 }
   }
	
	public void actual_second_cut_bale_production () {
		Parameters p = RunEnvironment.getInstance().getParameters();
		double pr_rating_ip = 0;
		double pr_rating_hay = 0;
		double pr_max_hay_yield = (Double)p.getValue("prmaxhayyield");	
		 
		Iterator<SAMA> it = mylandList.iterator();
		 while (it.hasNext()) {
				SAMA sama = it.next();
		if(sama.getIPQuality() > pr_max_hay_yield) {
			pr_rating_ip = pr_max_hay_yield;
		}		
		else {
			pr_rating_ip = sama.getIPQuality();
		}		
		if(sama.getHayQuality() > pr_max_hay_yield) {
			pr_rating_hay= pr_max_hay_yield;
		}		
		else {
			pr_rating_hay = sama.getHayQuality();
		}
		if(improvedbaletwo > 0) {
			ip_bale_two_yield = ip_bale_one_yield + (0.6*(pr_rating_ip / pr_max_hay_yield * Variables.getmax_hay_yield_earlypasture()));
			total_ip_bale_yield_two = ip_bale_two_yield * improvedbaletwo;
			total_improved_bale_two_mcals = ((ip_bale_one_yield * Variables.getmcals_ton_ip_baled_one()) + ip_bale_two_yield * Variables.getmcals_ton_ip_baled_two()) * improvedbaletwo;
		}
		if(haybaletwo > 0) {
			hay_bale_two_yield = hay_bale_one_yield + (0.6*(pr_rating_hay / pr_max_hay_yield *  Variables.getmax_hay_yield_earlypasture()));
			total_hay_bale_yield_two = hay_bale_two_yield * haybaletwo;
			total_haybaletwo_mcals = ((hay_bale_one_yield * Variables.getmcals_ton_hayland_baled_one()) + hay_bale_two_yield * Variables.getmcals_ton_hayland_baled_two() * haybaletwo);
		}
	  }
	}
	
	public void recourse_lp() {
		Parameters p = RunEnvironment.getInstance().getParameters();
		
		double Per_ton_feed_hay_cost = (Double) p.getValue("pertonfeedhaycost");
		double Per_ton_grain_cost = (Double) p.getValue("pertonfeedgraincost");
		double transaction_fee_hay = (Double) p.getValue("transactionfeehay");
		
		early_summer_mcals_required = Variables.getmcals_required_early_summer() * n_cows;
		late_summer_mcals_required = Variables.getmcals_required_late_summer() * n_cows;
		fall_mcals_required = Variables.getmcals_required_fall() * n_cows;
		winter_mcals_required = Variables.getmcals_required_winter() * n_cows;
		
		if(gettotal_ip_bale_yield_one() > 0 && gettotal_hay_bale_yield_one() > 0) {
			early_bale_avg_mcals = (gettotal_improved_bale_one_mcals()/gettotal_ip_bale_yield_one() + gettotal_haybaleone_mcals()/gettotal_hay_bale_yield_one()/2);
		}
		if (gettotal_ip_bale_yield_one() == 0 && gettotal_hay_bale_yield_one() > 0) {
			early_bale_avg_mcals = Variables.getmcals_ton_hayland_baled_one();
		}
		if (gettotal_ip_bale_yield_one() > 0 && gettotal_hay_bale_yield_one() == 0) {
			early_bale_avg_mcals = Variables.getmcals_ton_ip_baled_one();
		}		
		
		if(early_bale_avg_mcals == 0){
			early_bale_avg_mcals = (Variables.getmcals_ton_hayland_baled_one() + Variables.getmcals_ton_ip_baled_one())/2;
		}
		if (gettotal_ip_bale_yield_two() > 0 && gettotal_hay_bale_yield_two() > 0) {
			late_bale_avg_mcals = (gettotal_improved_bale_two_mcals()/gettotal_ip_bale_yield_two() + gettotal_haybaletwo_mcals()/gettotal_hay_bale_yield_two()/2);
		}
		if (gettotal_ip_bale_yield_two() == 0 && gettotal_hay_bale_yield_two() > 0) {
			late_bale_avg_mcals = Variables.getmcals_ton_hayland_baled_one()*0.6 + Variables.getmcals_ton_hayland_baled_two();
		}
		if (gettotal_ip_bale_yield_two() > 0 && gettotal_hay_bale_yield_two() == 0) {
			late_bale_avg_mcals = Variables.getmcals_ton_ip_baled_one()*0.6 + Variables.getmcals_ton_ip_baled_two();
		}
		if (gettotal_ip_bale_yield_two() <= 0 && gettotal_hay_bale_yield_two() <= 0) {
			late_bale_avg_mcals = ((Variables.getmcals_ton_ip_baled_one() + Variables.getmcals_ton_hayland_baled_one())/2);
		}
		
		contribution = new double[] { -(Variables.getprice_hay()), -(Variables.getprice_barley()*45.93), -(Per_ton_feed_hay_cost), -(Per_ton_feed_hay_cost), -(Per_ton_feed_hay_cost), -(Per_ton_feed_hay_cost), -(Per_ton_grain_cost), -(Per_ton_grain_cost), -(Per_ton_feed_hay_cost), -(Per_ton_feed_hay_cost), (Variables.getprice_hay() - (transaction_fee_hay)), (Variables.getprice_barley()*45.93), (Variables.getprice_wheat()*36.74)};
				
		early_mcal_energy_content = new double[] {0, 0, (early_bale_avg_mcals), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
		
		late_mcal_energy_content = new double[] {0, 0, 0, (early_bale_avg_mcals), 0, 0, 0, 0, 0, 0, 0, 0, 0};
		
		fall_mcal_energy_content = new double[] {0, 0, 0, 0, (late_bale_avg_mcals), 0, 0, 0, 0, 0, 0, 0, 0};
		
		winter_mcal_energy_content = new double[] {0, 0, 0, 0, 0, (late_bale_avg_mcals), 3394, 3724, 664, 823, 0, 0, 0};
		
		try{  //create a problem with 13 variables and 12 constraints 
			LpSolve solver = LpSolve.makeLp(12, 13);
			
			solver.strAddConstraint("0 0 0 0 0 0 0 1 0 0 0 0 1", LpSolve.LE, (tonnes_crop_wheat_sf + tonnes_crop_wheat_stubble + tonnes_crop_wheat_notill + tonnes_crop_feed_wheat_notill + tonnes_crop_feed_wheat_con));
			solver.strAddConstraint("0 -1 0 0 0 0 1 0 0 0 0 1 0",  LpSolve.LE, (tonnes_crop_barley_stubble + tonnes_crop_barley_notill + tonnes_crop_feed_barley_notill + tonnes_crop_feed_barley_con));
			solver.strAddConstraint("-1 0 1 0 0 0 0 0 0 0 1 0 0", LpSolve.LE, (total_ip_bale_yield_one + total_hay_bale_yield_one));   
			solver.strAddConstraint("-1 0 0 1 0 0 0 0 0 0 1 0 0", LpSolve.LE, (total_ip_bale_yield_one + total_hay_bale_yield_one));
			solver.strAddConstraint("-1 0 0 0 1 0 0 0 0 0 1 0 0", LpSolve.LE, (total_ip_bale_yield_two + total_hay_bale_yield_two));
			solver.strAddConstraint("-1 0 0 0 0 1 0 0 0 0 1 0 0", LpSolve.LE, (total_ip_bale_yield_two + total_hay_bale_yield_two));
			solver.strAddConstraint("0 0 0 0 0 0 0 0 0 1 0 0 0", LpSolve.LE, (tonnes_crop_wheat_stubble + tonnes_crop_wheat_notill + tonnes_crop_feed_wheat_notill + tonnes_crop_feed_wheat_con));
			solver.strAddConstraint("0 0 0 0 0 0 0 0 1 0 0 0 0", LpSolve.LE, (tonnes_crop_barley_stubble + tonnes_crop_barley_notill + tonnes_crop_feed_barley_notill + tonnes_crop_feed_barley_con));
		
			String str2 = convertDoubleArrayToString(early_mcal_energy_content);
			solver.strAddConstraint(str2, LpSolve.GE, early_summer_mcals_required);
			
			String str3 = convertDoubleArrayToString(late_mcal_energy_content);
			solver.strAddConstraint(str3, LpSolve.GE, late_summer_mcals_required);
			
			String str4 = convertDoubleArrayToString(fall_mcal_energy_content);
			solver.strAddConstraint(str4, LpSolve.GE, fall_mcals_required);

			String str5 = convertDoubleArrayToString(winter_mcal_energy_content);
			solver.strAddConstraint(str5, LpSolve.GE, winter_mcals_required);
			
			String str6 = convertDoubleArrayToString(contribution);
			solver.strSetObjFn(str6);
			solver.setMaxim();
			
			solver.solve();
			solver.getPtrVariables();
			solver.getObjective();
			//solver.printLp();
			
			recourse_income = solver.getObjective();
			double[] var = solver.getPtrVariables();
			for (double d : var) {
				
			}			
			for(int i = 0; i < var.length; i++) {
				purchase_hay = var[0];
				purchase_barley = var[1];
				earlyhay = var[2];
				latehay = var[3];
				fallhay = var[4];
				winterhay = var[5];
				winterbarley = var[6];
				winterwheat = var[7];
				barleystraw = var[8];
				wheatstraw = var[9];
				hayforsale = var[10];
				barleyforsale = var[11];
				wheatforsale = var[12];
			}			
//			int idd = this.getID();
//			int farmerID = this.getfarmer_name();
//			int run_number = Variables.getrun_number();
//			int year = Variables.getyear();
//			int purchase_hay = (int) getpurchase_hay();
//			int purchase_barley = (int) getpurchase_barley();
//			int earlyhay = (int) getearlyhay();
//			int latehay = (int) getlatehay();
//			int fallhay = (int) getfallhay();
//			int winterhay = (int) getwinterhay();
//			int winterbarley = (int) getwinterbarley();
//			int winterwheat = (int) getwinterwheat();
//			int barleystraw = (int) getbarleystraw();
//			int wheatstraw = (int) getwheatstraw();
//			int hayforsale = (int) gethayforsale();
//			int barleyforsale = (int) getbarleyforsale();
//			int wheatforsale = (int) getwheatforsale();
//			int recourse_income = (int) getrecourse_income();
//			
//			try {
//				Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
//			} catch (ClassNotFoundException ce) {
//				System.out.println("SQLExceptiong:" + ce.getMessage());
//			}
//			try {
//				Connection conn = DriverManager.getConnection(
//						"jdbc:odbc:producerDB", "java", "1234");
//				Statement stmt = conn.createStatement();
//				
//				stmt.executeUpdate("insert into Recourse values ('"
//						+ idd
//						+ "', '" + farmerID
//						+ "', '" + run_number
//						+ "', '" + year 
//						+ "', '" + purchase_hay
//						+ "', '" + purchase_barley
//						+ "', '" + earlyhay
//						+ "', '" + latehay
//						+ "', '" + fallhay
//						+ "', '" + winterhay
//						+ "', '" + winterbarley
//						+ "', '" + winterwheat
//						+ "', '" + barleystraw
//						+ "', '" + wheatstraw
//						+ "', '" + hayforsale
//						+ "', '" + barleyforsale
//						+ "', '" + wheatforsale 
//						+ "', '" + recourse_income + "')");
//				stmt.close();
//				conn.close();
//			}catch (SQLException ce) {
//				ce.printStackTrace();
//				System.out.println("HELL 7 SQLException:" + ce.getMessage());
//			}						
			solver.deleteLp();
		} catch (LpSolveException e) {
			e.printStackTrace();
		}
	}	
	
	public void crop_insurance_payout() {
		total_insurance_payout = insurance_payout;
	}
	
	public void crop_insurance() {
		
		Parameters p = RunEnvironment.getInstance().getParameters();
		
		double Increase_NoTill = (Double) p.getValue("increaseNoTill"); // 
		yield_mult = 1 + Increase_NoTill;
		
		if(mylandList.size()>0) {
		Iterator<SAMA> it = mylandList.iterator();
		SAMA sama = it.next();
				
		double insured_production_canolastubble = ((getcanolastubble() * getcrop_insurance_coverage_level() * sama.getCanolaYieldIndex()  * yield_exp_list[0]) /44.09 ) ; //
		double insured_production_barleystubble = ((getbarleystubble() * getcrop_insurance_coverage_level() * sama.getBarleyYieldIndex()  * yield_exp_list[2]) /45.93);
		double insured_production_wheatstubble = ((getwheatstubble() * getcrop_insurance_coverage_level() * sama.getWheatYieldIndex() * yield_exp_list[1]) / 36.74);
		double insured_production_durumstubble = ((getdurumstubble() * getcrop_insurance_coverage_level() * sama.getDurumYieldIndex() * yield_exp_list[7])/36.74);
		double insured_production_flaxstubble = ((getflaxstubble() * getcrop_insurance_coverage_level() * sama.getFlaxYieldIndex() * yield_exp_list[4]) / 39.37);
		double insured_production_peastubble = ((getpeasstubble() * getcrop_insurance_coverage_level() * sama.getPeasYieldIndex() * yield_exp_list[5]) / 36.74);
		
		double insured_production_wheatfallow = ((getwheatfallow() * getcrop_insurance_coverage_level() * sama.getWheatSfYieldIndex() * yield_exp_list[1])/ 36.74);
		double insured_production_wheatnotill = ((getwheatnotill() * getcrop_insurance_coverage_level() * sama.getWheatYieldIndex() * yield_mult * yield_exp_list[1]) / 36.74);
		double insured_production_durumnotill = ((getdurumnotill() * getcrop_insurance_coverage_level() * sama.getDurumYieldIndex() * yield_mult * yield_exp_list[7])/36.74);
		double insured_production_canolanotill = ((getcanolanotill() * getcrop_insurance_coverage_level() * sama.getCanolaYieldIndex()  * yield_mult * yield_exp_list[0]) /44.09 ) ; //
		double insured_production_barleynotill = ((getbarleynotill() * getcrop_insurance_coverage_level() * sama.getBarleyYieldIndex()  * yield_mult * yield_exp_list[2]) /45.93);
		double insured_production_flaxnotill = ((getflaxnotill() * getcrop_insurance_coverage_level() * sama.getFlaxYieldIndex()  * yield_mult * yield_exp_list[4]) /39.37);
		double insured_production_peasnotill = ((getpeasnotill() * getcrop_insurance_coverage_level() * sama.getPeasYieldIndex()  * yield_mult * yield_exp_list[5]) /36.74);
		double insured_production_lentilsnotill = ((getlentilsnotill() * getcrop_insurance_coverage_level() * sama.getLentilsYieldIndex()  * yield_mult * yield_exp_list[6]) /36.74);
				
		double actual_canolastubble_production = (getcanolastubble()* sama.getCanolaYieldIndex() * Variables.getyield_canola() )/ 44.09; 
		double actual_barleystubble_production = (getbarleystubble() * sama.getBarleyYieldIndex() * Variables.getyield_barley())/45.93;
		double actual_wheatstubble_production = (getwheatstubble() * sama.getWheatYieldIndex() * Variables.getyield_wheat()) / 36.74;
		double actual_durumstubble_production = (getdurumstubble() * sama.getDurumYieldIndex() * Variables.getyield_durum())/36.74;
		double actual_flaxstubble_production = (getflaxstubble() * sama.getFlaxYieldIndex() * Variables.getyield_flax()) / 39.37;
		double actual_peasstubble_production = (getpeasstubble() * sama.getPeasYieldIndex() * Variables.getyield_peas()) / 36.74;
		double actual_wheatfallow_production = (getwheatfallow() * sama.getWheatSfYieldIndex() * Variables.getyield_wheat()) / 36.74;
		double actual_canolanotill_production = (getcanolanotill()* sama.getCanolaYieldIndex() * yield_mult * Variables.getyield_canola() )/ 44.09; 
		double actual_barleynotill_production = (getbarleynotill() * sama.getBarleyYieldIndex() * yield_mult * Variables.getyield_barley())/45.93;
		double actual_wheatnotill_production = (getwheatnotill() * sama.getWheatYieldIndex() * yield_mult * Variables.getyield_wheat()) / 36.74;
		double actual_durumnotill_production = (getdurumnotill() * sama.getDurumYieldIndex() * yield_mult * Variables.getyield_durum()) / 36.74;
		double actual_flaxnotill_production = (getflaxnotill() * sama.getFlaxYieldIndex() * yield_mult * Variables.getyield_flax()) / 39.37;
		double actual_peasnotill_production = (getpeasnotill() * sama.getPeasYieldIndex() * yield_mult * Variables.getyield_peas()) / 36.74;
		double actual_lentilsnotill_production = (getlentilsnotill() * sama.getLentilsYieldIndex() * yield_mult * Variables.getyield_lentils()) / 36.74;
		
		double insurance_payout_canola_stubble = (insured_production_canolastubble - actual_canolastubble_production ) * (Variables.getprice_canola() *44.09) ;
		double insurance_payout_barley_stubble = (insured_production_barleystubble - actual_barleystubble_production ) * (Variables.getprice_barley() * 45.93);
		double insurance_payout_wheat_stubble = (insured_production_wheatstubble - actual_wheatstubble_production ) * (Variables.getprice_wheat() * 36.74);
		double insurance_payout_durum_stubble = (insured_production_durumstubble - actual_durumstubble_production ) * (Variables.getprice_durum() * 36.74);
		double insurance_payout_flax_stubble = (insured_production_flaxstubble - actual_flaxstubble_production ) * (Variables.getprice_flax() * 39.37);
		double insurance_payout_peas_stubble = (insured_production_peastubble - actual_peasstubble_production ) * (Variables.getprice_peas() * 36.74);
		double insurance_payout_wheat_fallow = (insured_production_wheatfallow - actual_wheatfallow_production ) * (Variables.getprice_wheat() * 36.74);
		
		double insurance_payout_wheat_notill = (insured_production_wheatnotill - actual_wheatnotill_production ) * (Variables.getprice_wheat() * 36.74);
		double insurance_payout_durum_notill = (insured_production_durumnotill - actual_durumnotill_production ) * (Variables.getprice_durum() * 36.74);
		double insurance_payout_canola_notill = (insured_production_canolanotill - actual_canolanotill_production ) * (Variables.getprice_canola() * 44.09);
		double insurance_payout_barley_notill = (insured_production_barleynotill - actual_barleynotill_production ) * (Variables.getprice_barley() * 45.93);
		double insurance_payout_flax_notill = (insured_production_flaxnotill - actual_flaxnotill_production ) * (Variables.getprice_flax() * 39.37);
		double insurance_payout_peas_notill = (insured_production_lentilsnotill - actual_peasnotill_production ) * (Variables.getprice_peas() * 36.74);
		double insurance_payout_lentils_notill = (insured_production_peasnotill - actual_lentilsnotill_production ) * (Variables.getprice_lentils() * 36.74);
		
		insurance_payout = insurance_payout_canola_stubble + insurance_payout_barley_stubble + insurance_payout_wheat_fallow + insurance_payout_wheat_stubble + insurance_payout_durum_stubble 
		+ insurance_payout_wheat_notill + insurance_payout_durum_notill + insurance_payout_barley_notill + insurance_payout_canola_notill + insurance_payout_flax_stubble 
		+ insurance_payout_peas_stubble + insurance_payout_flax_notill + insurance_payout_peas_notill + insurance_payout_lentils_notill;
		if(insurance_payout < 0) {
			insurance_payout = 0;
		}			
		crop_insurance_payout();
		}
	}
	
	public void crop_insurance_premium() {
		Parameters p = RunEnvironment.getInstance().getParameters();
		
		double Increase_NoTill = (Double) p.getValue("increaseNoTill"); // 
		yield_mult = 1 + Increase_NoTill;
		
		
		//Iterator<SAMA> it = mylandList.iterator();
		//SAMA sama = it.next();
		for(int i = 0; i < getmylandList().size(); i++){
			SAMA sama = (SAMA) getmylandList().get(i);
		
		
		double liability_peas_stubble_acre = sama.getPeasYieldIndex() * yield_exp_list[5] * Variables.getprice_peas() * getcrop_insurance_coverage_level();
		producer_premium_peas_stubble = liability_peas_stubble_acre * peas_premium;
		government_premium_peas_stubble = liability_peas_stubble_acre * peas_premium_gov;
		
		double liability_flax_stubble_acre =  sama.getFlaxYieldIndex() * yield_exp_list[4] * Variables.getprice_flax() * getcrop_insurance_coverage_level();
		producer_premium_flax_stubble = liability_flax_stubble_acre * flax_premium;
		government_premium_flax_stubble = liability_flax_stubble_acre * flax_premium_gov;
		
		double liability_canola_stubble_acre =  sama.getCanolaYieldIndex() * yield_exp_list[0] * Variables.getprice_canola() * getcrop_insurance_coverage_level();
		producer_premium_canola_stubble = liability_canola_stubble_acre * canola_premium;
		government_premium_canola_stubble = liability_canola_stubble_acre * canola_premium_gov;
		
		double liability_wheat_fallow_acre = sama.getWheatSfYieldIndex() * yield_exp_list[1] * Variables.getprice_wheat() * getcrop_insurance_coverage_level();
		producer_premium_wheat_fallow = liability_wheat_fallow_acre * wheat_premium;
		government_premium_wheat_fallow = liability_wheat_fallow_acre * wheat_premium_gov;
		
		double liability_wheat_stubble_acre = sama.getWheatYieldIndex() * yield_exp_list[1] * Variables.getprice_wheat() * getcrop_insurance_coverage_level();
		producer_premium_wheat_stubble = liability_wheat_stubble_acre * wheat_premium;
		government_premium_wheat_stubble = liability_wheat_stubble_acre * wheat_premium_gov;
		
		double liability_durum_stubble_acre = sama.getDurumYieldIndex() * yield_exp_list[7] * Variables.getprice_durum() * getcrop_insurance_coverage_level();
		producer_premium_durum_stubble = liability_durum_stubble_acre * durum_premium;
		government_premium_durum_stubble = liability_durum_stubble_acre * durum_premium_gov;
				
		double liability_barley_stubble_acre = sama.getBarleyYieldIndex() * yield_exp_list[2] * Variables.getprice_barley() * getcrop_insurance_coverage_level();
		producer_premium_barley_stubble = liability_barley_stubble_acre * barley_premium;
		government_premium_barley_stubble = liability_barley_stubble_acre * barley_premium_gov;
		
		double cereal_premium_con = (producer_premium_wheat_fallow + producer_premium_wheat_stubble + producer_premium_durum_stubble + producer_premium_barley_stubble)/4;
		double oilseed_premium_con = (producer_premium_canola_stubble + producer_premium_flax_stubble)/2;
		
		avg_producer_premium_con = cereal_premium_con * 0.6 + oilseed_premium_con * 0.30 + producer_premium_peas_stubble * 0.10;
		
		double liability_canola_notill_acre = sama.getCanolaYieldIndex() * yield_mult * yield_exp_list[0] * Variables.getprice_canola() * getcrop_insurance_coverage_level();
		producer_premium_canola_notill = liability_canola_notill_acre * canola_premium;
		government_premium_canola_notill = liability_canola_notill_acre * canola_premium_gov;
				
		double liability_wheat_notill_acre = sama.getWheatYieldIndex() * yield_mult * yield_exp_list[1] * Variables.getprice_wheat() * getcrop_insurance_coverage_level();
		producer_premium_wheat_notill = liability_wheat_notill_acre * wheat_premium;
		government_premium_wheat_notill = liability_wheat_notill_acre * wheat_premium_gov;
		
		double liability_durum_notill_acre = sama.getDurumYieldIndex() * yield_mult * yield_exp_list[7] * Variables.getprice_durum() * getcrop_insurance_coverage_level();
		producer_premium_durum_notill = liability_durum_notill_acre * durum_premium;
		government_premium_durum_notill = liability_durum_notill_acre * durum_premium_gov;
		
		double liability_barley_notill_acre = sama.getBarleyYieldIndex() * yield_mult * yield_exp_list[2] * Variables.getprice_barley() * getcrop_insurance_coverage_level();
		producer_premium_barley_notill = liability_barley_notill_acre * barley_premium;
		government_premium_barley_notill = liability_barley_notill_acre * barley_premium_gov;
	
		double liability_flax_notill_acre = sama.getFlaxYieldIndex() * yield_mult * yield_exp_list[4] * Variables.getprice_flax() * getcrop_insurance_coverage_level();
		producer_premium_flax_notill = liability_flax_notill_acre * flax_premium;
		government_premium_flax_notill = liability_flax_notill_acre * flax_premium_gov;
		
		double liability_peas_notill_acre = sama.getPeasYieldIndex() * yield_mult * yield_exp_list[5] * Variables.getprice_peas() * getcrop_insurance_coverage_level();
		producer_premium_peas_notill = liability_peas_notill_acre * peas_premium;
		government_premium_peas_notill = liability_peas_notill_acre * peas_premium_gov;
		
		double liability_lentils_notill_acre = sama.getLentilsYieldIndex() * yield_mult * yield_exp_list[6] * Variables.getprice_lentils() * getcrop_insurance_coverage_level();
		producer_premium_lentils_notill = liability_lentils_notill_acre * lentils_premium;
		government_premium_lentils_notill = liability_lentils_notill_acre * lentils_premium_gov;
		
		double cereal_premium_notill = (producer_premium_wheat_notill + producer_premium_durum_notill + producer_premium_barley_notill)/4;
		double oilseed_premium_notill = (producer_premium_canola_notill + producer_premium_flax_notill)/2;
		double pulse_premium_notill = (producer_premium_peas_notill + producer_premium_lentils_notill)/2;
		
		avg_producer_premium_notill = cereal_premium_notill * 0.55 + oilseed_premium_notill * 0.33 + pulse_premium_notill * 0.12;
	
		
		}
		
	}
	
	public void initialagriinvest_account_balance() {
		Parameters p = RunEnvironment.getInstance().getParameters();
		double VC_Cow = (Double) p.getValue("vccow");
		int min_family_withdrawal = (Integer) p.getValue("minFamilyWithdrawal");
		double cash_reserve_percent = (Double) p.getValue("cashReservePercent");
		double Per_Tonne_VC = (Double)p.getValue("perTonneVCWheat");
		double Increase_NoTill = (Double) p.getValue("increaseNoTill");
		double Per_Acre_VC_NP = (Double) p.getValue("peracrevcnp");
		double Per_Acre_VC_IP = (Double) p.getValue("peracrevcip");
		double Per_Acre_VC_HL = (Double) p.getValue("peracrevchl");
		yield_mult = 1 + Increase_NoTill;
		int min_cash_crop_acre = (Integer) p.getValue("minCashCropAcre");
		int min_cash_hay_acre = (Integer) p.getValue("mincashhayacre");
		double Avg_RM_Con_2007 = 162.08;
		double Avg_RM_NoTill_2007 = 177.91;
		double Avg_RM_Con_2006 = 125.32;
		double Avg_RM_NoTill_2006 = 128.92;
		double Avg_RM_Calf_2006 = 940.03;
		double Avg_RM_Calf_2007 = 1034.76;
		double Avg_Con_VC = 73.91;
		double Avg_NoTill_VC = 79.47;
		double count = 0;
		
		double tonnes_crop_canola_stubble = 0, loc_tonnes_crop_wheat_stubble = 0, loc_tonnes_crop_barley_stubble = 0, loc_tonnes_crop_wheat_sf = 0,
		tonnes_crop_flax_stubble = 0, tonnes_crop_peas_stubble = 0, tonnes_crop_flax_notill = 0, tonnes_crop_peas_notill = 0, tonnes_crop_lentils_notill = 0, tonnes_crop_durum_stubble = 0, tonnes_crop_durum_notill = 0;
		
		double tonnes_crop_canola_notill = 0, loc_tonnes_crop_barley_notill = 0, loc_tonnes_crop_wheat_notill = 0;
		
		
		
		for (int i = 0; i < mylandList.size(); i++) {
			SAMA sama = (SAMA) mylandList.get(i);
			count++;
			RM_2007_Con = (RM_2007_Con + sama.getAvg_prod_patch()
			/ Variables.getmean_patch_quality() * Avg_RM_Con_2007)/count;
			RM_2007_NoTill = RM_2007_NoTill + sama.getAvg_prod_patch()
			/ Variables.getmean_patch_quality() * Avg_RM_NoTill_2007/count;
			RM_2006_Con = RM_2006_Con + sama.getAvg_prod_patch()
			/ Variables.getmean_patch_quality() * Avg_RM_Con_2006/count;
			RM_2006_NoTill = RM_2006_NoTill + sama.getAvg_prod_patch()
			/ Variables.getmean_patch_quality() * Avg_RM_NoTill_2006/count;
			
			tonnes_crop_canola_stubble += sama.getCanolaYieldIndex() * yield_exp_list[0] / 44.09; 
			loc_tonnes_crop_wheat_stubble += sama.getWheatYieldIndex()	* yield_exp_list[1] / 36.74;
			loc_tonnes_crop_barley_stubble += sama.getBarleyYieldIndex() * yield_exp_list[2] / 45.93;
			loc_tonnes_crop_wheat_sf += sama.getWheatSfYieldIndex() * yield_exp_list[1] / 36.74;
			tonnes_crop_flax_stubble += sama.getFlaxYieldIndex() * yield_exp_list[4] / 39.37;
			tonnes_crop_peas_stubble += sama.getPeasYieldIndex() * yield_exp_list[5] / 39.37;
			tonnes_crop_durum_stubble += sama.getDurumYieldIndex() * yield_exp_list[7] /36.37;
			
			tonnes_crop_canola_notill += yield_mult	* sama.getCanolaYieldIndex() * yield_exp_list[0] / 44.09;
			loc_tonnes_crop_barley_notill += yield_mult	* sama.getBarleyYieldIndex() * yield_exp_list[2] / 45.93;
			loc_tonnes_crop_wheat_notill += (yield_mult * sama.getWheatYieldIndex()	* yield_exp_list[1] / 36.74);
			tonnes_crop_durum_notill += yield_mult * sama.getDurumYieldIndex() * yield_exp_list[7]/36.74;
			tonnes_crop_flax_notill += yield_mult * sama.getFlaxYieldIndex() * yield_exp_list[4]/39.37;
			tonnes_crop_lentils_notill += yield_mult * sama.getLentilsYieldIndex() * yield_exp_list[6]/36.74;
			tonnes_crop_peas_notill += yield_mult * sama.getPeasYieldIndex() * yield_exp_list[5]/39.37;
			
			
			
	}		
		
		tonnes_crop_canola_stubble = tonnes_crop_canola_stubble/total_plots; 
		loc_tonnes_crop_wheat_stubble = loc_tonnes_crop_wheat_stubble/total_plots;
		loc_tonnes_crop_barley_stubble = loc_tonnes_crop_barley_stubble/total_plots; 
		loc_tonnes_crop_wheat_sf = loc_tonnes_crop_wheat_sf/total_plots;
		tonnes_crop_flax_stubble = tonnes_crop_flax_stubble/total_plots;
		tonnes_crop_peas_stubble = tonnes_crop_peas_stubble/total_plots;
		tonnes_crop_durum_stubble = tonnes_crop_durum_stubble/total_plots;
		
		tonnes_crop_canola_notill = tonnes_crop_canola_notill/total_plots;
		loc_tonnes_crop_barley_notill = loc_tonnes_crop_barley_notill/total_plots;
		loc_tonnes_crop_wheat_notill = loc_tonnes_crop_wheat_notill/total_plots;
		tonnes_crop_durum_notill = tonnes_crop_durum_notill/total_plots;
		tonnes_crop_flax_notill = tonnes_crop_flax_notill/total_plots;
		tonnes_crop_lentils_notill = tonnes_crop_lentils_notill/total_plots;
		tonnes_crop_peas_notill = tonnes_crop_peas_notill/total_plots;
		
		double avg_cereal_tonnes_con = (loc_tonnes_crop_wheat_stubble + loc_tonnes_crop_barley_stubble + loc_tonnes_crop_wheat_sf + tonnes_crop_durum_stubble)/4;
		double avg_oilseed_tonnes_con = (tonnes_crop_canola_stubble + tonnes_crop_flax_stubble)/2;
		
		double avg_cereal_tonnes_notill = (loc_tonnes_crop_wheat_notill + loc_tonnes_crop_barley_notill + tonnes_crop_durum_notill)/3;
		double avg_oilseed_tonnes_notill = (tonnes_crop_canola_notill + tonnes_crop_flax_notill)/2;
		double avg_pulse_tonnes_notill = (tonnes_crop_peas_notill + tonnes_crop_lentils_notill)/2;
		
		double avg_tonnes_con = (avg_cereal_tonnes_con * 0.5) + (avg_oilseed_tonnes_con * 0.25) + (tonnes_crop_peas_stubble * 0.25);
		double avg_tonnes_notill = (avg_cereal_tonnes_notill * 0.5) + (avg_oilseed_tonnes_notill * 0.25) + (avg_pulse_tonnes_notill * 0.25);
		
		RM_Calf_2006 = (Avg_RM_Calf_2006 * n_cows) - ((VC_Cow * n_cows) + (total_natural_pasture * Per_Acre_VC_NP + total_improved_pasture * Per_Acre_VC_IP + total_hay * Per_Acre_VC_HL));
		RM_Calf_2007 = (Avg_RM_Calf_2007 * n_cows) - ((VC_Cow * n_cows) + (total_natural_pasture * Per_Acre_VC_NP + total_improved_pasture * Per_Acre_VC_IP + total_hay * Per_Acre_VC_HL));
				
		if(total_crop_acres <= 2000) {			
			eligible_sales_2006 = (int) ((int) (RM_2006_Con * total_crop_acres) - ((Avg_Con_VC * total_crop_acres) + (getavg_producer_premium_con() * total_crop_acres) + (Per_Tonne_VC * avg_tonnes_con * trucking_distance)));
			eligible_sales_2007 = (int) ((int) (RM_2007_Con * total_crop_acres) - ((Avg_Con_VC * total_crop_acres) + (getavg_producer_premium_con() * total_crop_acres) + (Per_Tonne_VC * avg_tonnes_con * trucking_distance)));
		}
		if(total_crop_acres > 2000) {			
			eligible_sales_2006 = (int) ((int) RM_2006_NoTill * total_crop_acres - ((Avg_NoTill_VC * total_crop_acres) + (getavg_producer_premium_notill() * total_crop_acres) + (Per_Tonne_VC * avg_tonnes_notill * trucking_distance)));
			eligible_sales_2007 = (int) ((int) RM_2007_NoTill * total_crop_acres - ((Avg_NoTill_VC * total_crop_acres) + (getavg_producer_premium_notill() * total_crop_acres) + (Per_Tonne_VC * avg_tonnes_notill * trucking_distance)));
		}		
		if(geteligible_sales_2007()+ getRM_Calf_2007() >= 1500000) {
			total_eligible_netsales = 1500000;
		}
		else {
			total_eligible_netsales = geteligible_sales_2007() + getRM_Calf_2007();
			
		}			
		
		double min_cash = (total_crop_acres * min_cash_crop_acre)  + (total_hay * min_cash_hay_acre);
		
		
		if(cash > farmer_contribution_agriinvest + debt_payment + total_crop_lease_payment + total_marginal_lease_payment + min_cash + min_family_withdrawal + (cash * cash_reserve_percent)) {
			farmer_contribution_agriinvest = total_eligible_netsales * 0.015;
			if(farmer_contribution_agriinvest < 0) {
				farmer_contribution_agriinvest = 0;
			}
			cash = (int) (cash - farmer_contribution_agriinvest);
			
		} else {
			farmer_contribution_agriinvest = 0;
						
		}
		government_match_agriinvest = farmer_contribution_agriinvest;		
		fund_1 = farmer_contribution_agriinvest;
		fund_2 = government_match_agriinvest;
		total_contribution_agriinvest = farmer_contribution_agriinvest + government_match_agriinvest;
		agriinvest_account_balance = total_contribution_agriinvest;
		Variables.setlast_2_years_eligible_netsales(new double[] {geteligible_sales_2007(), geteligible_sales_2006()});
		
		
		
		}
		
	public void agriinvest() {
		old_fund_1_balance = fund_1; 
		old_fund_2_balance = fund_2; 
		farmer_contribution_agriinvest = 0;
		government_match_agriinvest = 0;
		
		Parameters p = RunEnvironment.getInstance().getParameters();
		
		int min_family_withdrawal = (Integer) p.getValue("minFamilyWithdrawal");
		double cash_reserve_percent = (Double) p.getValue("cashReservePercent");
		double threemonthtbillrate = (Double)p.getValue("threemonthtbillrate");		
		double current_year = Variables.getyear();
		double last_year = 0;
		double two_years_ago = 0;		
		double twoyearsago_eligible_netsales = 0;
		
		interest_earned_fund_1 = old_fund_1_balance * threemonthtbillrate;	
		interest_earned_fund_2 = old_fund_2_balance * threemonthtbillrate;
		
		fund_2 = fund_2 + interest_earned_fund_1 + interest_earned_fund_2;
		
		agriinvest_account_balance = fund_1 + fund_2;
				
				if(gettotal_net_crop_income() + gettotal_net_calf_income() >= 1500000) {
					total_eligible_netsales = 1500000;
					total_crop_eligible_netsales = gettotal_net_crop_income();
					total_calf_eligible_netsales = gettotal_net_calf_income();
					total_energycrop_eligible_netsales = gettotal_net_energy_income();
					
				}
				else {
					total_crop_eligible_netsales = gettotal_net_crop_income();
					total_calf_eligible_netsales = gettotal_net_calf_income();
					total_energycrop_eligible_netsales = gettotal_net_energy_income();
					total_eligible_netsales = total_crop_eligible_netsales + total_calf_eligible_netsales;
				}							
				maximum_balance = ((total_eligible_netsales + Variables.getlast_2_years_eligible_netsales()[0] + Variables.getlast_2_years_eligible_netsales()[1])/3 * 0.25); // need to get last two previous years allowable netsales
						 
			 
		 if(agriinvest_account_balance < maximum_balance) {
				can_contribute = true; 
		 } 
		 else {
			can_contribute = false;		 
		 
		 	 	
			if(agriinvest_account_balance > maximum_balance) {
				agriinvest_withdrawal = agriinvest_account_balance - maximum_balance;
				if(agriinvest_withdrawal >  fund_2) {
					agriinvest_withdrawal_fund_2 = fund_2;
					fund_2 = fund_2 - agriinvest_withdrawal_fund_2;
					if(agriinvest_withdrawal - agriinvest_withdrawal_fund_2 > fund_1){
						agriinvest_withdrawal_fund_1 = fund_1;
						fund_1 = fund_1 - agriinvest_withdrawal_fund_1;
						
					}else {
					agriinvest_withdrawal_fund_1 = agriinvest_withdrawal - agriinvest_withdrawal_fund_2;
					fund_1 = fund_1 - agriinvest_withdrawal_fund_1;
					}
				}
				else {
				fund_2 = fund_2 - agriinvest_withdrawal;
				agriinvest_withdrawal_fund_2 = agriinvest_withdrawal;
				}
				
			}
		 }
					
		if(can_contribute) {			
			if(family_living == 0){
				family_living = min_family_withdrawal;
			}
			
			if(cash > farmer_contribution_agriinvest + debt_payment + family_living + total_marginal_lease_payment + total_crop_lease_payment  + (cash * cash_reserve_percent)) {
					farmer_contribution_agriinvest = total_eligible_netsales * 0.015;
					if(farmer_contribution_agriinvest < 0) {
						farmer_contribution_agriinvest = 0;
					}
					cash = (int) (cash - farmer_contribution_agriinvest);
					fund_2 = fund_2 + farmer_contribution_agriinvest;
					government_match_agriinvest = farmer_contribution_agriinvest;		
					fund_1 = fund_1 + government_match_agriinvest;
				} else {
					farmer_contribution_agriinvest = 0;
					government_match_agriinvest = farmer_contribution_agriinvest;						
					fund_2 = fund_2;
					fund_1 = fund_1;
				}
			}
			
		
			agriinvest_account_balance = (fund_1 + fund_2);
			Variables.setlast_2_years_eligible_netsales(ReNew_2_years_Values(Variables.getlast_2_years_eligible_netsales(), gettotal_eligible_netsales()));
		
	}
	
	public void agristability () {
		
		Parameters p = RunEnvironment.getInstance().getParameters();
		int min_cash_crop_acre = (Integer) p.getValue("minCashCropAcre");
		int min_cash_hay_acre = (Integer) p.getValue("mincashhayacre");
		int min_family_withdrawal = (Integer) p.getValue("minFamilyWithdrawal");
		double cash_reserve_percent = (Double) p.getValue("cashReservePercent");	
		double pre_reference_margin_cost = ((total_farm_reference_margin/1000) * 4.5 * .85);
	//	System.out.println("pre RMC" + pre_reference_margin_cost);
		if(pre_reference_margin_cost < 0){
			pre_reference_margin_cost = 0;
			reference_margin_cost = 0;
		}else {
		reference_margin_cost = 55 + pre_reference_margin_cost;
		}
		double min_cash = (total_crop_acres * min_cash_crop_acre)  + (total_hay * min_cash_hay_acre);
		
		if(reference_margin_cost > 0) {
		if(cash > reference_margin_cost + min_cash + debt_payment + total_crop_lease_payment + total_marginal_lease_payment + family_living + farmer_contribution_agriinvest  + (cash * cash_reserve_percent)){
			reference_margin_cost = reference_margin_cost;
			setparticipate_agristability(true);
			cash = (int) (cash - reference_margin_cost);
		}
		
		else {
			reference_margin_cost = 0;
			setparticipate_agristability(false);
			//System.out.println("do not particpate");
		}
		}
		else {
			reference_margin_cost = 0;
			setparticipate_agristability(false);
			//System.out.println("do not particpate");
		}
		
		//System.out.println("reference_margin_cost" + reference_margin_cost);
		}
	
	
	public void initial_reference_margins() {
		
		double Avg_RM_Con_2007 = 162.08;
		double Avg_RM_NoTill_2007 = 177.91;
		double Avg_RM_Con_2006 = 125.32;
		double Avg_RM_NoTill_2006 = 128.92;
		double Avg_RM_Con_2005 = 97.37;
		double Avg_RM_NoTill_2005 = 99.73;
		double Avg_RM_Con_2004 = 117.1;
		double Avg_RM_NoTill_2004 = 119.60;
		double Avg_RM_Con_2003 = 196.18;
		double Avg_RM_NoTill_2003 = 101.24;
		double Avg_RM_Calf_2006 = 940.03;
		double Avg_RM_Calf_2007 = 1034.76;
		double Avg_RM_Calf_2005 = 890.55;
		double Avg_RM_Calf_2004 = 742.49;
		double Avg_RM_Calf_2003 = 751.03;
				
		double count = 0;
		for (int i = 0; i < mylandList.size(); i++) {
			SAMA sama = (SAMA) mylandList.get(i);
			count++;
			RM_2007_Con = (RM_2007_Con + sama.getAvg_prod_patch()
			/ Variables.getmean_patch_quality() * Avg_RM_Con_2007)/count;
			RM_2007_NoTill = RM_2007_NoTill + sama.getAvg_prod_patch()
			/ Variables.getmean_patch_quality() * Avg_RM_NoTill_2007/count;
			RM_2006_Con = RM_2006_Con + sama.getAvg_prod_patch()
			/ Variables.getmean_patch_quality() * Avg_RM_Con_2006/count;
			RM_2006_NoTill = RM_2006_NoTill + sama.getAvg_prod_patch()
			/ Variables.getmean_patch_quality() * Avg_RM_NoTill_2006/count;
			RM_2005_Con = RM_2005_Con + sama.getAvg_prod_patch()
			/ Variables.getmean_patch_quality() * Avg_RM_Con_2005/count;
			RM_2005_NoTill = RM_2005_NoTill + sama.getAvg_prod_patch()
			/ Variables.getmean_patch_quality() * Avg_RM_NoTill_2005/count;
			RM_2004_Con = RM_2004_Con + sama.getAvg_prod_patch()
			/ Variables.getmean_patch_quality() * Avg_RM_Con_2004/count;
			RM_2004_NoTill = RM_2004_NoTill + sama.getAvg_prod_patch()
			/ Variables.getmean_patch_quality() * Avg_RM_NoTill_2004/count;
			RM_2003_Con = RM_2003_Con + sama.getAvg_prod_patch()
			/ Variables.getmean_patch_quality() * Avg_RM_Con_2003/count;
			RM_2003_NoTill = RM_2003_NoTill + sama.getAvg_prod_patch()
			/ Variables.getmean_patch_quality() * Avg_RM_NoTill_2003/count;
			
			
					
		}
		RM_Calf_2007 = Avg_RM_Calf_2007;
		RM_Calf_2006 = Avg_RM_Calf_2006;
		RM_Calf_2005 = Avg_RM_Calf_2005;
		RM_Calf_2004 = Avg_RM_Calf_2004;
		RM_Calf_2003 = Avg_RM_Calf_2003;
	}
	
	public void government_payments() {
			if(getdie()== false){
		int idd = this.getID();
		int farmerID = this.getfarmer_name();
		int run_number = Variables.getrun_number();
		int year = Variables.getyear();
		int premiums_paid_producer = (int) getpremiums_paid_producer();
		int premiums_paid_government = (int) getpremiums_paid_government();
		int agristability_payments = (int) getagristability_payment();
		int agristability_premiums = (int) getreference_margin_cost();
		int total_agriinvest_account_balance = (int) getagriinvest_account_balance();
		int income_tax = (int) getincome_tax();
		int cropins_payout = (int) getinsurance_payout();
		int govt_matchagriinvest = (int) getgovernment_match_agriinvest();
		int farmer_contribution = (int) getfarmer_contribution_agriinvest();
		int fund_1 = (int) getfund_1();
		int fund_2 = (int) getfund_2();
		int eligible_netsales = (int) gettotal_eligible_netsales();
		int crop_sales = (int) gettotal_crop_eligible_netsales();
		int calf_sales = (int) gettotal_calf_eligible_netsales();
		int energycrop_sales = (int) gettotal_energycrop_eligible_netsales();
		
		try {
			Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
		} catch (ClassNotFoundException ce) {
			//System.out.println("SQLExceptiong:" + ce.getMessage());
		}
		try {
			Connection conn = DriverManager.getConnection(
					"jdbc:odbc:producerDB", "java", "1234");
			Statement stmt = conn.createStatement();

			stmt.executeUpdate("insert into GovernmentPayments values ('" + idd
					+ "', '" + farmerID 
					+ "', '" + run_number
					+ "','" + year + "', '"
					+ premiums_paid_producer + "', '" + premiums_paid_government + "', '" + agristability_payments + "', '"
					+ agristability_premiums + "', '"
					+ total_agriinvest_account_balance + "', '" + income_tax + "', '"
					+ cropins_payout + " ', '" + govt_matchagriinvest + " ', '"
					+ farmer_contribution + "', '"
					+ fund_1 + " ', '" + fund_2 + "', '"
					+ eligible_netsales + "', '"
					+ crop_sales + "', '"
					+ calf_sales + "', '"
					+ energycrop_sales + "', '"
					+ total_crop_acres + "', '"
					+ n_cows + "') ");

			stmt.close();
			conn.close();
		} catch (SQLException ce) {
			ce.printStackTrace();
			//System.out.println("Devil SQLException:" + ce.getMessage());
		}
		this.setID(idd+1);
			}
		}
	
	public int geteligible_netsales_lastyear (int ProducerID) {
		Connection conn;
		int eligible_netsales_lastyear =0;
		int agriinvest_account =0;
		int current_year = Variables.getyear();
		int last_year = current_year -1;
		int run_number = Variables.getrun_number();
		try {
			conn = DriverManager.getConnection("jdbc:odbc:producerDB", "java",
					"1234");
			Statement stmt = conn.createStatement();
			ResultSet rs = stmt
					.executeQuery("SELECT eligible_netsales FROM GovernmentPayments WHERE "
							+ "farmerID=" + ProducerID +  "and " + "run_number=" + run_number + "and " + "year="
							+ last_year);
			

			while (rs.next()) {
				eligible_netsales_lastyear = rs.getInt("eligible_netsales");
				
			}
			rs.close();
			stmt.close();
			conn.close();
		} catch (SQLException e) {
			System.out.println("Statement is not correct: " + e.getMessage());
			e.printStackTrace();
		}		
		return eligible_netsales_lastyear;
	}
	
	
		
	
	
	public int gettotalagriinvestaccountbalance (int ProducerID) {
		Connection conn;
		
		int total_agriinvest_account_balance =0;
		int current_year = Variables.getyear();
		int last_year = current_year -1;
		try {
			conn = DriverManager.getConnection("jdbc:odbc:producerDB", "java",
					"1234");
			Statement stmt = conn.createStatement();
			ResultSet rs = stmt
					.executeQuery("SELECT total_agriinvest_account_balance FROM GovernmentPayments WHERE "
							+ "farmerID=" + ProducerID + "and " + "year="
							+ last_year);
			
			while (rs.next()) {
				total_agriinvest_account_balance = rs.getInt("total_agriinvest_account_balance");
				
			}
			rs.close();
			stmt.close();
			conn.close();
		} catch (SQLException e) {
			//System.out.println("Statement is not correct: " + e.getMessage());
			e.printStackTrace();
		}		
		return total_agriinvest_account_balance;
	}
	
	public int geteligible_netsales_twoyearsago (int ProducerID) {
		Connection conn;
		int eligible_netsales_twoyearsago =0;
		int current_year = Variables.getyear();
		int twoyearsago = current_year -2;
		try {
			conn = DriverManager.getConnection("jdbc:odbc:producerDB", "java",
					"1234");
			Statement stmt = conn.createStatement();
			ResultSet rs = stmt
					.executeQuery("SELECT eligible_netsales FROM GovernmentPayments WHERE "
							+ "farmerID=" + ProducerID + "and " + "year="
							+ twoyearsago);
			

			while (rs.next()) {
				eligible_netsales_twoyearsago = rs.getInt("eligible_netsales");
			}
			rs.close();
			stmt.close();
			conn.close();
		} catch (SQLException e) {
			//System.out.println("Statement is not correct: " + e.getMessage());
			e.printStackTrace();
		}	
		return eligible_netsales_twoyearsago;
	}
	
	public int geteligible_netsales_threeyearsago (int ProducerID) {
		Connection conn;
		int eligible_netsales_threeyearsago =0;
		int current_year = Variables.getyear();
		int threeyearsago = current_year -3;
		try {
			conn = DriverManager.getConnection("jdbc:odbc:producerDB", "java",
					"1234");
			Statement stmt = conn.createStatement();
			ResultSet rs = stmt
					.executeQuery("SELECT eligible_netsales FROM GovernmentPayments WHERE "
							+ "farmerID=" + ProducerID + "and " + "year="
							+ threeyearsago);
			

			while (rs.next()) {
				eligible_netsales_threeyearsago = rs.getInt("eligible_netsales");
			}

			rs.close();
			stmt.close();
			conn.close();
		} catch (SQLException e) {
			//System.out.println("Statement is not correct: " + e.getMessage());
			e.printStackTrace();
		}		
		return eligible_netsales_threeyearsago;
	}
	
	public int geteligible_netsales_fouryearsago (int ProducerID) {
		Connection conn;
		int eligible_netsales_fouryearsago =0;
		int current_year = Variables.getyear();
		int fouryearsago = current_year -4;
		try {
			conn = DriverManager.getConnection("jdbc:odbc:producerDB", "java",
					"1234");
			Statement stmt = conn.createStatement();
			ResultSet rs = stmt
					.executeQuery("SELECT eligible_netsales FROM GovernmentPayments WHERE "
							+ "farmerID=" + ProducerID + "and " + "year="
							+ fouryearsago);
			
			while (rs.next()) {
				eligible_netsales_fouryearsago = rs.getInt("eligible_netsales");
			}
			rs.close();
			stmt.close();
			conn.close();
		} catch (SQLException e) {
			//System.out.println("Statement is not correct: " + e.getMessage());
			e.printStackTrace();
		}		
		return eligible_netsales_fouryearsago;
	}
	
	public int geteligible_netsales_fiveyearsago (int ProducerID) {
		Connection conn;
		int eligible_netsales_fiveyearsago =0;
		int current_year = Variables.getyear();
		int fiveyearsago = current_year -5;
		try {
			conn = DriverManager.getConnection("jdbc:odbc:producerDB", "java",
					"1234");
			Statement stmt = conn.createStatement();
			ResultSet rs = stmt
					.executeQuery("SELECT eligible_netsales FROM GovernmentPayments WHERE "
							+ "farmerID=" + ProducerID + "and " + "year="
							+ fiveyearsago);
			
			while (rs.next()) {
				eligible_netsales_fiveyearsago = rs.getInt("eligible_netsales");
			}
			rs.close();
			stmt.close();
			conn.close();
		} catch (SQLException e) {
			//System.out.println("Statement is not correct: " + e.getMessage());
			e.printStackTrace();
		}
		return eligible_netsales_fiveyearsago;
	}
		
	public int getfund_1_lastyear (int ProducerID) {
		Connection conn;
		int fund_1_lastyear = 0;
		int current_year = Variables.getyear();
		int last_year = current_year -1;
		try {
			conn = DriverManager.getConnection("jdbc:odbc:producerDB", "java",
					"1234");
			Statement stmt = conn.createStatement();
			ResultSet rs = stmt
					.executeQuery("SELECT fund_1 FROM GovernmentPayments WHERE "
							+ "farmerID=" + ProducerID + "and " + "year="
							+ last_year);
			
			while (rs.next()) {
				fund_1_lastyear = rs.getInt("fund_1");
			}
			rs.close();
			stmt.close();
			conn.close();
		} catch (SQLException e) {
			System.out.println("Statement is not correct: " + e.getMessage());
			e.printStackTrace();
		}		
		return fund_1_lastyear;
	}
	
	public int getfund_2_lastyear (int ProducerID) {
		Connection conn;
		int fund_2_lastyear = 0;
		int current_year = Variables.getyear();
		int last_year = current_year -1;
		try {
			conn = DriverManager.getConnection("jdbc:odbc:producerDB", "java",
					"1234");
			Statement stmt = conn.createStatement();
			ResultSet rs = stmt
					.executeQuery("SELECT fund_2 FROM GovernmentPayments WHERE "
							+ "farmerID=" + ProducerID + "and " + "year="
							+ last_year);
			
			while (rs.next()) {
				fund_2_lastyear = rs.getInt("fund_2");
				
			}
			rs.close();
			stmt.close();
			conn.close();
		} catch (SQLException e) {
			System.out.println("Statement is not correct: " + e.getMessage());
			e.printStackTrace();
		}		
		return fund_2_lastyear;
	}
	
	public void income_margin () {
	
		Parameters p = RunEnvironment.getInstance().getParameters();
		double VC_Cow = (Double) p.getValue("vccow");
		double Per_Acre_VC_NP = (Double) p.getValue("peracrevcnp");
		double Per_Acre_VC_IP = (Double) p.getValue("peracrevcip");
		double Per_Acre_VC_HL = (Double) p.getValue("peracrevchl");
		double Per_Acre_VC_Bale_IP_1 = (Double) p.getValue("peracrevcbaleip1");
		double Per_Acre_VC_Bale_IP_2 = (Double) p.getValue("peracrevcbaleip2");
		double Per_Acre_VC_Hayproduction_1 = (Double) p.getValue("peracrevchayproduction1");
		double Per_Acre_VC_Hayproduction_2 = (Double) p.getValue("peracrevchayproduction2");
		double FC_Cow_Labour = (Double) p.getValue("fccowlabour");
		double Avg_RM_Calf_2006 = 940.03;
		double Avg_RM_Calf_2007 = 1034.76;
		double Avg_RM_Calf_2005 = 890.55;
		double Avg_RM_Calf_2004 = 742.49;
		double Avg_RM_Calf_2003 = 751.03;
		RM_Calf_2007 = Avg_RM_Calf_2007;
		RM_Calf_2006 = Avg_RM_Calf_2006;
		RM_Calf_2005 = Avg_RM_Calf_2005;
		RM_Calf_2004 = Avg_RM_Calf_2004;
		RM_Calf_2003 = Avg_RM_Calf_2003;
//		double livestock_costs = cows_labour * FC_Cow_Labour + total_natural_pasture * Per_Acre_VC_NP + total_improved_pasture * Per_Acre_VC_IP + total_hay * Per_Acre_VC_HL + improved_bale_first_cut * Per_Acre_VC_Bale_IP_1 
//		+ improved_bale_second_cut * Per_Acre_VC_Bale_IP_2 + hay_production_one_cut * Per_Acre_VC_Hayproduction_1 + hay_production_two_cuts * Per_Acre_VC_Hayproduction_2;
//		
//		if(n_cows > 0) {
//			livestock_costs = livestock_costs/n_cows;
//		}
		
			if(Variables.getyear()== 1) {
				crop_rm_lastyear = (getRM_2007_NoTill());  //Already in per acre basis
				crop_rm_two_years_ago = (getRM_2006_NoTill());		
				crop_rm_three_years_ago = (getRM_2005_NoTill());
				crop_rm_four_years_ago = (getRM_2004_NoTill());
				crop_rm_five_years_ago = (getRM_2003_NoTill());
				
				calf_rm_lastyear = ((getRM_Calf_2007())); 
				calf_rm_two_years_ago = ((getRM_Calf_2006())); 	
				calf_rm_three_years_ago = ((getRM_Calf_2005())); 
				calf_rm_four_years_ago = ((getRM_Calf_2004()));
				calf_rm_five_years_ago = ((getRM_Calf_2003()));
				
				if(n_cows > 0){
				}
				if(total_crop_acres > 0) {
				pre_farm_reference_margin_crop = new double[] { crop_rm_lastyear,  crop_rm_two_years_ago, crop_rm_three_years_ago, crop_rm_four_years_ago, crop_rm_five_years_ago};
				crop_reference_margin = (((getcrop_rm_lastyear() + getcrop_rm_two_years_ago() + getcrop_rm_three_years_ago() + getcrop_rm_four_years_ago() + getcrop_rm_five_years_ago() - getMaxValue(pre_farm_reference_margin_crop) - getMinValue(pre_farm_reference_margin_crop)))/3);
				Variables.setreference_margin_crop(new double[] {getcrop_rm_lastyear(), getcrop_rm_two_years_ago(), getcrop_rm_three_years_ago(), getcrop_rm_four_years_ago(), getcrop_rm_five_years_ago()});
				}
				
				
				if(n_cows > 0){
				pre_farm_reference_margin_calf = new double[] { calf_rm_lastyear,  calf_rm_two_years_ago, calf_rm_three_years_ago, calf_rm_four_years_ago, calf_rm_five_years_ago};
				calf_reference_margin = (((getcalf_rm_lastyear() + getcalf_rm_two_years_ago() + getcalf_rm_three_years_ago() + getcalf_rm_four_years_ago() + getcalf_rm_five_years_ago() - getMaxValue(pre_farm_reference_margin_calf) - getMinValue(pre_farm_reference_margin_calf)))/3);
				Variables.setreference_margin_calf(new double[] {getcalf_rm_lastyear(), getcalf_rm_two_years_ago(), getcalf_rm_three_years_ago(), getcalf_rm_four_years_ago(), getcalf_rm_five_years_ago()});
				}
				
				
			}
			if(Variables.getyear()> 1) {
				double total_herd = 0;
				if(total_crop_acres > 0) {
				Variables.setreference_margin_crop(ReNew_5_years_Values(Variables.getreference_margin_crop(), (total_crop_eligible_netsales/total_crop_acres)));
				pre_farm_reference_margin_crop = new double[] {Variables.getreference_margin_crop()[0], Variables.getreference_margin_crop()[1], Variables.getreference_margin_crop()[2], Variables.getreference_margin_crop()[3], Variables.getreference_margin_crop()[4]};
				crop_reference_margin = ((Variables.getreference_margin_crop()[0] + Variables.getreference_margin_crop()[1] + Variables.getreference_margin_crop()[2] + Variables.getreference_margin_crop()[3] + Variables.getreference_margin_crop()[4] - getMaxValue(pre_farm_reference_margin_crop) - getMinValue(pre_farm_reference_margin_crop))/3);
				
				}
				if(n_cows > 0 || old_cows > 0) {
					if(n_cows > old_cows){
						total_herd = n_cows;
					}
					else {
						total_herd = old_cows;
					}
					
				Variables.setreference_margin_calf(ReNew_5_years_Values(Variables.getreference_margin_calf(), (total_calf_eligible_netsales/total_herd)));
				pre_farm_reference_margin_calf = new double[] {Variables.getreference_margin_calf()[0], Variables.getreference_margin_calf()[1], Variables.getreference_margin_calf()[2], Variables.getreference_margin_calf()[3], Variables.getreference_margin_calf()[4]};
				calf_reference_margin = ((Variables.getreference_margin_calf()[0] + Variables.getreference_margin_calf()[1] + Variables.getreference_margin_calf()[2] + Variables.getreference_margin_calf()[3] + Variables.getreference_margin_calf()[4] - getMaxValue(pre_farm_reference_margin_calf) - getMinValue(pre_farm_reference_margin_calf))/3);
				
				}	
				
				if(will_cows ==  true && n_cows == 0 && old_cows == 0){
					
					Variables.setreference_margin_calf(ReNew_5_years_Values(Variables.getreference_margin_calf(), (0)));
					pre_farm_reference_margin_calf = new double[] {Variables.getreference_margin_calf()[0], Variables.getreference_margin_calf()[1], Variables.getreference_margin_calf()[2], Variables.getreference_margin_calf()[3], Variables.getreference_margin_calf()[4]};
					calf_reference_margin = ((Variables.getreference_margin_calf()[0] + Variables.getreference_margin_calf()[1] + Variables.getreference_margin_calf()[2] + Variables.getreference_margin_calf()[3] + Variables.getreference_margin_calf()[4] - getMaxValue(pre_farm_reference_margin_calf) - getMinValue(pre_farm_reference_margin_calf))/3);
					
				}
								
//			
			}
				
		}
			
		
	
		
	
	private double Avg_RM_Calf_2007() {
		// TODO Auto-generated method stub
		return 0;
	}

	public static double getMaxValue(double[] numbers) {
		double maxValue = numbers[0];
		for(int i=1; i < numbers.length;i++ ) {
			if(numbers[i] > maxValue){
				maxValue = numbers[i];
			}
		}
		return maxValue;
	}
	
	public static double getMinValue(double[] numbers) {
		double minValue = numbers[0];
		for(int i=1; i < numbers.length; i++) {
			if(numbers[i] < minValue){
				minValue = numbers[i];
			}
		}
		return minValue;
	}
	
	public void set_individual_price_expectations () {
		
		Parameters p = RunEnvironment.getInstance().getParameters();
		double discount_rate = (Double)p.getValue("discountRate");
		double interest_rate = (Double) p.getValue("interestRate");
		double crcbull = (Double) p.getValue("crcbull");
		double alpha = (Double) p.getValue("alpha");
		double gama = (Double)p.getValue("gama");
		double cv_canola = (Double) p.getValue("cv_canola");
		double cv_wheat = (Double) p.getValue("cv_wheat");
		double cv_durum = (Double) p.getValue("cv_durum");
		double cv_flax = (Double) p.getValue("cv_flax");
		double cv_peas = (Double) p.getValue("cv_peas");
		double cv_lentils = (Double) p.getValue("cv_lentils");
		double cv_barley = (Double) p.getValue("cv_barley");
		double cv_hay = (Double) p.getValue("cv_hay");
		double cv_calf = (Double) p.getValue("cv_calf");
		double FixedR1 = Math.random();
		double FixedR2 = Math.random();
				
		double farmeroptimismcanola = ((Math.sqrt(-2*(Math.log(FixedR1))))*(Math.cos(2*Math.PI*(FixedR2)))* ((Variables.getexpected_price_list()[0]*cv_canola*alpha)*gama));
		double canola_error = ((Math.sqrt(-2*(Math.log(Math.random()))))*(Math.cos(2*Math.PI*(Math.random())))* ((Variables.getexpected_price_list()[0]* cv_canola*alpha)*(1-gama)));
		
		double farmeroptimismwheat = ((Math.sqrt(-2*(Math.log(FixedR1))))*(Math.cos(2*Math.PI*(FixedR2)))* ((Variables.getexpected_price_list()[1]*cv_wheat*alpha)*gama));
		double wheat_error = ((Math.sqrt(-2*(Math.log(Math.random()))))*(Math.cos(2*Math.PI*(Math.random())))* ((Variables.getexpected_price_list()[1]* cv_wheat*alpha)*(1-gama)));
		
		double farmeroptimismdurum = ((Math.sqrt(-2*(Math.log(FixedR1))))*(Math.cos(2*Math.PI*(FixedR2)))* ((Variables.getexpected_price_list()[8]*cv_durum*alpha)*gama));
		double durum_error = ((Math.sqrt(-2*(Math.log(Math.random()))))*(Math.cos(2*Math.PI*(Math.random())))* ((Variables.getexpected_price_list()[8]* cv_durum*alpha)*(1-gama)));
		
		double farmeroptimismflax = ((Math.sqrt(-2*(Math.log(FixedR1))))*(Math.cos(2*Math.PI*(FixedR2)))* ((Variables.getexpected_price_list()[5]*cv_flax*alpha)*gama));
		double flax_error = ((Math.sqrt(-2*(Math.log(Math.random()))))*(Math.cos(2*Math.PI*(Math.random())))* ((Variables.getexpected_price_list()[5]* cv_flax*alpha)*(1-gama)));
		
		double farmeroptimismpeas = ((Math.sqrt(-2*(Math.log(FixedR1))))*(Math.cos(2*Math.PI*(FixedR2)))* ((Variables.getexpected_price_list()[6]*cv_peas*alpha)*gama));
		double peas_error = ((Math.sqrt(-2*(Math.log(Math.random()))))*(Math.cos(2*Math.PI*(Math.random())))* ((Variables.getexpected_price_list()[6]* cv_peas*alpha)*(1-gama)));
		
		double farmeroptimismlentils = ((Math.sqrt(-2*(Math.log(FixedR1))))*(Math.cos(2*Math.PI*(FixedR2)))* ((Variables.getexpected_price_list()[7]*cv_lentils*alpha)*gama));
		double lentils_error = ((Math.sqrt(-2*(Math.log(Math.random()))))*(Math.cos(2*Math.PI*(Math.random())))* ((Variables.getexpected_price_list()[7]* cv_lentils*alpha)*(1-gama)));
		
		double farmeroptimismbarley = ((Math.sqrt(-2*(Math.log(FixedR1))))*(Math.cos(2*Math.PI*(FixedR2)))* ((Variables.getexpected_price_list()[2]*cv_barley*alpha)*gama));
		double barley_error = ((Math.sqrt(-2*(Math.log(Math.random()))))*(Math.cos(2*Math.PI*(Math.random())))* ((Variables.getexpected_price_list()[2]* cv_barley*alpha)*(1-gama)));
		
		double farmeroptimismhay = ((Math.sqrt(-2*(Math.log(FixedR1))))*(Math.cos(2*Math.PI*(FixedR2)))* ((Variables.getexpected_price_list()[4]*cv_hay*alpha)*gama));
		double hay_error = ((Math.sqrt(-2*(Math.log(Math.random()))))*(Math.cos(2*Math.PI*(Math.random())))* ((Variables.getexpected_price_list()[4]* cv_hay*alpha)*(1-gama)));
		
		double farmeroptimismcalf = ((Math.sqrt(-2*(Math.log(FixedR1))))*(Math.cos(2*Math.PI*(FixedR2)))* ((Variables.getexpected_price_list()[3]*cv_calf*alpha)*gama));
		double calf_error = ((Math.sqrt(-2*(Math.log(Math.random()))))*(Math.cos(2*Math.PI*(Math.random())))* ((Variables.getexpected_price_list()[3]* cv_calf*alpha)*(1-gama)));
				
		farmer_exp_canola_price = Variables.getexpected_price_list()[0] + farmeroptimismcanola + canola_error;
		
		farmer_exp_wheat_price = Variables.getexpected_price_list()[1] + farmeroptimismwheat + wheat_error;
		
		farmer_exp_durum_price = Variables.getexpected_price_list()[8] + farmeroptimismdurum + durum_error;
		
		farmer_exp_flax_price =  Variables.getexpected_price_list()[5] + farmeroptimismflax + flax_error;
		
		farmer_exp_peas_price = Variables.getexpected_price_list()[6] + farmeroptimismpeas + peas_error;
		
		farmer_exp_lentils_price = Variables.getexpected_price_list()[7] + farmeroptimismlentils + lentils_error;
		
		farmer_exp_barley_price = Variables.getexpected_price_list()[2] + farmeroptimismbarley + barley_error;
			
		farmer_exp_hay_price = Variables.getexpected_price_list()[4] + farmeroptimismhay + hay_error;
		
	
		
		farmer_exp_calf_price = Variables.getexpected_price_list()[3] + farmeroptimismcalf + calf_error;
					
		farmer_exp_heifer_price = ((0.7679 * farmer_exp_calf_price)) * 845;  //845 lb heifer is 65% of mature weight of cow
				
		farmer_exp_cull_price = ((0.3038 * farmer_exp_calf_price)) * 1300; //Cows are 1300 lbs when culled
				
		crccow = (farmer_exp_heifer_price - farmer_exp_cull_price) * (interest_rate/(1-(Math.pow(1 + interest_rate, -8)))) + (interest_rate * farmer_exp_cull_price) + crcbull;
		
		NewCostCow = farmer_exp_heifer_price;
		
		
		
	}
		
	public void check_credit_borrowing_ability() {	
		Parameters p = RunEnvironment.getInstance().getParameters();
		int pre_retirement_age = (Integer) p.getValue("pre_retirement_age");
		double min_ratio = (Double) p.getValue("minRatio");
		int min_cash_crop_acre = (Integer) p.getValue("minCashCropAcre");
		int min_cash_hay_acre = (Integer) p.getValue("mincashhayacre");
		int min_family_withdrawal = (Integer) p.getValue("minFamilyWithdrawal");
		double cash_reserve_percent = (Double) p.getValue("cashReservePercent");
		double retirement_tendency_55_59 = (Double) p
		.getValue("retirementtendency5559");
		double retirement_tendency_60_64 = (Double) p
		.getValue("retirementtendency6064");
		double retirement_tendency_65_69 = (Double) p
		.getValue("retirementtendency6569");
		double retirement_tendency_70_over = (Double) p
		.getValue("retirementtendency70over");
			
		
		setinfeasiblesolution(false);
		trucking_distance();
		set_yield_exp();
		set_individual_price_expectations();
		crop_insurance_premium();
		tree_yields();
		tree_margin();
		
		
		current_debt = debt;
		current_assets = assets;
		current_daratio = debt / assets;
		
		settotal_acres_before(total_crop_acres); 
				
		set_parameters();
		
		
		if (current_daratio <= min_ratio && age <= pre_retirement_age ) {
			
			
			update_strategic_MIP_conventional();
			update_strategic_MIP_notill();
			setchecklandmarketresults(true);
			
		}else {
			
			setchecklandmarketresults(false);
			settacticalused(true);
			tactical_crops_notill();
			tactical_crops_conventional_farmer();
		}
		
	}

	public void tactical_crops_conventional_farmer() {
		if (this.gettotal_crop_acres() > 0 && this.gettotal_crop_acres() <= 2000) { 		
		Parameters p = RunEnvironment.getInstance().getParameters();
		double min_ratio = (Double) p.getValue("minRatio");
		double Per_Acre_VC_Summer_Fallow = (Double) p.getValue("perAcreVCSummerFallow");
		double Per_Acre_VC_Wheat_on_Fallow = (Double) p.getValue("perAcreVCWheatonFallow");
		double Per_Acre_VC_Canola_on_Stubble = (Double) p.getValue("perAcreVCCanolaonStubble");
		double Per_Acre_VC_Barley_on_Stubble = (Double) p.getValue("perAcreVCBarleyonStubble");
		double Per_Acre_VC_Wheat_on_Stubble = (Double) p.getValue("perAcreVCWheatonStubble");
		double Per_Tonne_VC_Wheat = (Double) p.getValue("perTonneVCWheat");
		double Per_Tonne_VC_Canola = (Double) p.getValue("perTonneVCCanola");
		double Per_Tonne_VC_Barley = (Double) p.getValue("perTonneVCBarley");		
		double Per_ton_grain_cost = (Double) p.getValue("pertonfeedgraincost");	
		double Per_Acre_VC_Flax_on_Stubble = (Double) p.getValue("perAcreVCFlaxonStubble");
		double Per_Acre_VC_Peas_on_Stubble = (Double) p.getValue("perAcreVCPeasonStubble");
		double Per_Acre_VC_Durum_on_Stubble = (Double) p.getValue("perAcreVCDurumonStubble");
		double Per_Tonne_VC_Durum = (Double) p.getValue("perTonneVCDurum");
		double Per_Tonne_VC_Flax = (Double) p.getValue("perTonneVCFlax");	
	 	double Per_Tonne_VC_Peas = (Double) p.getValue("perTonneVCPeas");	
	 	double fallow_yield_mult = (Double) p.getValue("fallow_yield_mult");
	 	double interest_rate = (Double) p.getValue("discountRate");
	 	double cereallimit_con = (Double)p.getValue("cereallimit_con");
		double oilseedlimit_con = (Double)p.getValue("oilseedlimit_con");
		double pulselimit_con = (Double)p.getValue("pulselimit_con");
		double maxwheat_limit = (Double)p.getValue("maxwheatlimit");
		double maxbarley_limit = (Double)p.getValue("maxbarleylimit");
		double maxdurum_limit = (Double)p.getValue("maxdurumlimit");
		double maxflax_limit = (Double)p.getValue("maxflaxlimit");
		double maxcanola_limit = (Double)p.getValue("maxcanolalimit");
	 	
		expected_income = 0;
		tillage_fallow = 0;
		wheat_on_fallow = 0;
		durum_stubble = 0;
		canola_stubble = 0;
		barley_stubble = 0;
		wheat_stubble = 0;
		flax_stubble = 0;
		peas_stubble = 0;
		barley_notill = 0;
		canola_notill = 0;
		wheat_notill = 0;
		durum_notill = 0;
		flax_notill = 0;
		peas_notill = 0;
		lentils_notill = 0;		
		amount_borrow = 0;
		yield_mult = 1;

		Iterator<SAMA> it = mylandList.iterator();
		double tonnes_crop_canola_stubble = 0, loc_tonnes_crop_wheat_stubble = 0, loc_tonnes_crop_barley_stubble = 0, loc_tonnes_crop_wheat_sf = 0,
		tonnes_crop_flax_stubble = 0, tonnes_crop_peas_stubble = 0, tonnes_crop_flax_notill = 0, tonnes_crop_peas_notill = 0, tonnes_crop_lentils_notill = 0, tonnes_crop_durum_stubble = 0, tonnes_crop_durum_notill = 0;
			
		for(int i = 0; i < getmylandList().size(); i++){
			SAMA sama = (SAMA) getmylandList().get(i);
			
			tonnes_crop_canola_stubble += yield_mult
			* sama.getCanolaYieldIndex() * yield_exp_list[0] / 44.09; 
																		
			loc_tonnes_crop_wheat_stubble += yield_mult * sama.getWheatYieldIndex()
			* yield_exp_list[1] / 36.74;
			loc_tonnes_crop_barley_stubble += yield_mult
			* sama.getBarleyYieldIndex() * yield_exp_list[2] / 45.93;
			loc_tonnes_crop_wheat_sf += yield_mult * sama.getWheatSfYieldIndex()
			* yield_exp_list[1] / 36.74;
	
			tonnes_crop_flax_stubble += yield_mult * sama.getFlaxYieldIndex() * yield_exp_list[4] / 39.37;
			tonnes_crop_peas_stubble += yield_mult * sama.getPeasYieldIndex() * yield_exp_list[5] / 39.37;
			tonnes_crop_durum_stubble += yield_mult * sama.getDurumYieldIndex() * yield_exp_list[7] /36.37;
	
		}
		
		tonnes_crop_canola_stubble = tonnes_crop_canola_stubble/total_plots; 																	
		loc_tonnes_crop_wheat_stubble = loc_tonnes_crop_wheat_stubble/total_plots;		
		loc_tonnes_crop_barley_stubble = loc_tonnes_crop_barley_stubble/total_plots;		
		loc_tonnes_crop_wheat_sf = loc_tonnes_crop_wheat_sf/total_plots;
		tonnes_crop_flax_stubble = tonnes_crop_flax_stubble/total_plots;
		tonnes_crop_peas_stubble = tonnes_crop_peas_stubble/total_plots;
		tonnes_crop_durum_stubble = tonnes_crop_durum_stubble/total_plots;

			yield_mult = 1;
			double barley_exp_yield = yield_exp_list[2];
			double wheat_exp_yield = yield_exp_list[1];		
						
				
			contribution_margin = new double[] {
					-(Per_Acre_VC_Summer_Fallow),
					(fallow_yield_mult * yield_mult * wheat_exp_yield * farmer_exp_wheat_price)
							- ((Per_Acre_VC_Wheat_on_Fallow + producer_premium_wheat_fallow) + (Per_Tonne_VC_Wheat * loc_tonnes_crop_wheat_sf * trucking_distance)),
					(yield_mult * yield_exp_list[7] * farmer_exp_durum_price) - ((Per_Acre_VC_Durum_on_Stubble + producer_premium_durum_stubble) + (Per_Tonne_VC_Durum * tonnes_crop_durum_stubble * trucking_distance)),		
					(yield_mult * yield_exp_list[0] * farmer_exp_canola_price)
							- ((Per_Acre_VC_Canola_on_Stubble + producer_premium_canola_stubble)
							+ (Per_Tonne_VC_Canola * tonnes_crop_canola_stubble * trucking_distance)),
					(yield_mult * barley_exp_yield * farmer_exp_barley_price)
							- ((Per_Acre_VC_Barley_on_Stubble + producer_premium_barley_stubble) + (Per_Tonne_VC_Barley * loc_tonnes_crop_barley_stubble * trucking_distance)),
					(yield_mult * wheat_exp_yield * farmer_exp_wheat_price)
							- ((Per_Acre_VC_Wheat_on_Stubble + producer_premium_wheat_stubble) + (Per_Tonne_VC_Wheat * loc_tonnes_crop_wheat_stubble * trucking_distance)), 
							(yield_mult * yield_exp_list[4] * farmer_exp_flax_price) - ((Per_Acre_VC_Flax_on_Stubble + producer_premium_flax_stubble) + (Per_Tonne_VC_Flax * tonnes_crop_flax_stubble * trucking_distance)),
							(yield_mult * yield_exp_list[5] * farmer_exp_peas_price) - ((Per_Acre_VC_Peas_on_Stubble + producer_premium_peas_stubble) + (Per_Tonne_VC_Flax * tonnes_crop_peas_stubble * trucking_distance)), -(interest_rate)};
						
			operating_captial = new double[] {
					Per_Acre_VC_Summer_Fallow,
					Per_Acre_VC_Wheat_on_Fallow + producer_premium_wheat_fallow + (Per_Tonne_VC_Wheat * loc_tonnes_crop_wheat_sf * trucking_distance),
					Per_Acre_VC_Durum_on_Stubble + producer_premium_durum_stubble + (Per_Tonne_VC_Durum * tonnes_crop_durum_stubble * trucking_distance),
					Per_Acre_VC_Canola_on_Stubble + producer_premium_canola_stubble + (Per_Tonne_VC_Canola * tonnes_crop_canola_stubble * trucking_distance),
					(Per_Acre_VC_Barley_on_Stubble) + producer_premium_barley_stubble + (Per_Tonne_VC_Barley * loc_tonnes_crop_barley_stubble * trucking_distance),
					(Per_Acre_VC_Wheat_on_Stubble) + producer_premium_wheat_stubble + (Per_Tonne_VC_Wheat * loc_tonnes_crop_wheat_stubble * trucking_distance), 
					(Per_Acre_VC_Flax_on_Stubble) + producer_premium_flax_stubble + (Per_Tonne_VC_Flax * tonnes_crop_flax_stubble * trucking_distance),
					(Per_Acre_VC_Peas_on_Stubble) + producer_premium_peas_stubble + (Per_Tonne_VC_Peas * tonnes_crop_peas_stubble * trucking_distance), -1};
			
			
			
		
			double cropland = this.gettotal_crop_acres() - feed_wheat_notill - feed_barley_notill - feed_wheat_con - feed_barley_con;
			double chemfallow = 0; //summer_fallow_percent * cropland;
			double cerealland = Math.round(cereallimit_con * cropland);
			double oilseedland = Math.round(oilseedlimit_con * cropland);
			double maxcanolalimit = Math.round(maxcanola_limit * oilseedland);
			double maxflaxlimit = Math.round(maxflax_limit * oilseedland);
			double maxwheatlimit = Math.round(maxwheat_limit * cerealland);
			double maxbarleylimit = Math.round(maxbarley_limit * cerealland);
			double maxdurumlimit = Math.round(maxdurum_limit * cerealland);
			double pulseland = Math.round(pulselimit_con * cropland);
			
			int oldasset_olddebt = (int) (assets - (debt - debt_payment));
			if(oldasset_olddebt < 0) {
				//System.out.println("borrowing is negative");
				oldasset_olddebt = 0;
			}
			
			
			try {				
				LpSolve solver = LpSolve.makeLp(10, 8);					
				
				// add constraints
				
				solver.strAddConstraint("1 1 1 1 1 1 1 1", LpSolve.EQ, cropland); // Crop land (acres)
				
				solver.strAddConstraint("-1 1 0 0 0 0 0 0", LpSolve.LE, chemfallow); // Fallow
				
				solver.strAddConstraint("0 1 1 0 1 1 0 0", LpSolve.LE, cerealland); // Cereal (wheat and Barley)
				
				solver.strAddConstraint("0 0 0 1 0 0 1 0", LpSolve.LE, oilseedland); // Oilseed (Canola and Flax) Limit
				
				solver.strAddConstraint("0 1 0 0 0 1 0 0", LpSolve.LE, maxwheatlimit);
				
				solver.strAddConstraint("0 0 0 0 1 0 0 0", LpSolve.LE, maxbarleylimit);
				
				solver.strAddConstraint("0 0 1 0 0 0 0 0", LpSolve.LE, maxdurumlimit);
				
				solver.strAddConstraint("0 0 0 1 0 0 0 0", LpSolve.LE, maxcanolalimit);
				
				solver.strAddConstraint("0 0 0 0 0 0 1 0", LpSolve.LE, maxflaxlimit);
				
				solver.strAddConstraint("0 0 0 0 0 0 0 1", LpSolve.LE, pulseland);
				
			//	solver.strAddConstraint("0 0 0 0 0 0 0 0 1", LpSolve.LE, oldasset_olddebt);
				
				
			//	String strOpr = convertDoubleArrayToString(operating_captial);
			//	solver.strAddConstraint(strOpr, LpSolve.LE, this.getcash()); //							
				
				// set objective function
				String newStr = convertDoubleArrayToString(contribution_margin);
				solver.strSetObjFn(newStr);
				solver.setMaxim();
				solver.solve();
				solver.getPtrVariables(); // Store this value to a string for
				solver.getObjective(); // Store this value to a string

				
				
				
				expected_income = solver.getObjective();
				double[] var = solver.getPtrVariables(); // This is the crop mix
				for (double d : var) {
					
				}				
				for (int i = 0; i < var.length; i++) {
					tillage_fallow = var[0];
					wheat_on_fallow = var[1];
					durum_stubble = var[2];
					canola_stubble = var[3];
					barley_stubble = var[4];
					wheat_stubble = var[5];
					flax_stubble = var[6];
					peas_stubble = var[7];
				//	amount_borrow = var[8];
															
				}
//				int idd = this.getID();
//				int farmerID = this.getfarmer_name();
//				int run_number = Variables.getrun_number();
//				int year = Variables.getyear();
//				int tillage_fallow = (int) gettillage_fallow();
//				int wheat_on_fallow = (int) getwheat_on_fallow();
//				int durum_stubble = (int) getdurum_stubble();
//				int canola_stubble = (int) getcanola_stubble();
//				int barley_stubble = (int) getbarley_stubble();
//				int wheat_stubble = (int) getwheat_stubble();
//				int flax_stubble = (int) getflax_stubble();
//				int peas_stubble = (int) getpeas_stubble();
//				int barley_notill = (int) getbarley_notill();
//				int canola_notill = (int) getcanola_notill();
//				int wheat_notill = (int) getwheat_notill();
//				int durum_notill = (int) getdurum_notill();
//				int flax_notill = (int) getflax_notill();
//				int lentils_notill = (int) getlentils_notill();
//				int peas_notill = (int) getpeas_notill();		
//				int amount_borrow = (int) getamount_borrow();
//				int expected_income = (int) getexpected_income();
//				
//				
//				try {
//					Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
//				} catch (ClassNotFoundException ce) {
//					System.out.println("SQLExceptiong:" + ce.getMessage());
//				}
//				try {
//					Connection conn = DriverManager.getConnection(
//							"jdbc:odbc:producerDB", "java", "1234");
//					Statement stmt = conn.createStatement();
//
//					stmt.executeUpdate("insert into Tactical values ('" 
//							+ idd 
//							+ "', '" + farmerID 
//							+ "', '" + run_number
//							+ "','" + year 
//							+ "', '" + tillage_fallow 
//							+ "', '" + wheat_on_fallow
//							+ "', '" + durum_stubble
//							+ "', '" + canola_stubble 
//							+ "', '" + barley_stubble
//							+ "', '" + wheat_stubble 
//							+ "', '" + flax_stubble
//							+ "', '" + peas_stubble
//							+ "', '" + barley_notill
//							+ "', '" + canola_notill 
//							+ "', '" + wheat_notill
//							+ "', '" + durum_notill
//							+ "', '" + flax_notill
//							+ "', '" + lentils_notill
//							+ "', '" + peas_notill	
//							+ "', '" + amount_borrow
//							+ "', '" + expected_income + "')");
//
//					stmt.close();
//					conn.close();
//				} catch (SQLException ce) {
//					ce.printStackTrace();
//					System.out.println("HELL SQLException Tactical Conventional:" + ce.getMessage());
//				}
				
				double[] duals = new double[0];
				double[] dualsfrom = new double[0];
				double[] dualstill = new double[0];
				
							
					

					solver.getSensitivityRhs(duals, dualsfrom, 
					dualstill);
					solver.getPtrSensitivityRhs();
					System.out.println("Duals" + duals[0]);
					System.out.println(dualsfrom[0]);
					System.out.println(dualstill[0]);

					solver.printDuals();
				
				
				
				solver.deleteLp();
			} catch (LpSolveException e) {				
				e.printStackTrace();
			}
		}
	}

	public void tactical_crops_notill() {
		if (this.gettotal_crop_acres() > 2000) {
			
		Parameters p = RunEnvironment.getInstance().getParameters();	
		double min_ratio = (Double) p.getValue("minRatio");
		double Per_Acre_VC_Wheat = (Double) p.getValue("perAcreVCWheat");
		double Per_Acre_VC_Canola = (Double) p.getValue("perAcreVCCanola");
		double Per_Acre_VC_Barley = (Double) p.getValue("perAcreVCBarley");
		double Per_Tonne_VC_Wheat = (Double) p.getValue("perTonneVCWheat");
		double Per_Tonne_VC_Canola = (Double) p.getValue("perTonneVCCanola");
		double Per_Tonne_VC_Barley = (Double) p.getValue("perTonneVCBarley");
		double Per_Acre_VC_Durum = (Double) p.getValue("perAcreVCDurum");
		double Per_Acre_VC_Flax = (Double) p.getValue("perAcreVCFlax");
	 	double Per_Acre_VC_Peas = (Double) p.getValue("perAcreVCPeas");
	 	double Per_Acre_VC_Lentils = (Double) p.getValue("perAcreVCLentils");			
		double Per_Tonne_VC_Durum = (Double) p.getValue("perTonneVCDurum");		
		double Per_Tonne_VC_Flax = (Double) p.getValue("perTonneVCFlax");
		double Per_Tonne_VC_Lentils = (Double) p.getValue("perTonneVCLentils");
	 	double Per_Tonne_VC_Peas = (Double) p.getValue("perTonneVCPeas");			
		double Increase_NoTill = (Double) p.getValue("increaseNoTill");
		double interest_rate = (Double) p.getValue("discountRate");
		double cereallimit_notill = (Double)p.getValue("cereallimit_notill");
		double oilseedlimit_notill = (Double)p.getValue("oilseedlimit_notill");
		double pulselimit_notill = (Double)p.getValue("pulselimit_notill");
		double maxwheat_limit = (Double)p.getValue("maxwheatlimit");
		double maxbarley_limit = (Double)p.getValue("maxbarleylimit");
		double maxdurum_limit = (Double)p.getValue("maxdurumlimit");
		double maxflax_limit = (Double)p.getValue("maxflaxlimit");
		double maxcanola_limit = (Double)p.getValue("maxcanolalimit");
		double maxpeas_limit = (Double)p.getValue("maxpeaslimit");
		double maxlentils_limit = (Double)p.getValue("maxlentilslimit");
		tillage_fallow = 0;
		wheat_on_fallow = 0;
		durum_stubble = 0;
		canola_stubble = 0;
		barley_stubble = 0;
		wheat_stubble = 0;
		flax_stubble = 0;
		peas_stubble = 0;
		barley_notill = 0;
		canola_notill = 0;
		wheat_notill = 0;
		durum_notill = 0;
		flax_notill = 0;
		peas_notill = 0;
		lentils_notill = 0;		
		expected_income = 0;
		amount_borrow = 0;
		yield_mult = 1 + Increase_NoTill;
		double barley_exp_yield = yield_exp_list[2];
		double wheat_exp_yield = yield_exp_list[1];
		
		Iterator<SAMA> it = mylandList.iterator();
		double tonnes_crop_canola_notill = 0, tonnes_crop_flax_notill = 0, tonnes_crop_peas_notill = 0, tonnes_crop_lentils_notill = 0, tonnes_crop_durum_notill = 0, 
		loc_tonnes_crop_barley_notill = 0, loc_tonnes_crop_wheat_notill = 0;
		
		for(int i = 0; i < getmylandList().size(); i++) {
			SAMA sama = (SAMA) getmylandList().get(i);
				
			tonnes_crop_canola_notill += yield_mult	* sama.getCanolaYieldIndex() * yield_exp_list[0] / 44.09;
			loc_tonnes_crop_barley_notill += yield_mult * sama.getBarleyYieldIndex() * yield_exp_list[2] / 45.93;
			loc_tonnes_crop_wheat_notill += yield_mult * sama.getWheatYieldIndex() * yield_exp_list[1] / 36.74;
			tonnes_crop_durum_notill += yield_mult * sama.getDurumYieldIndex() * yield_exp_list[7]/36.74;
			tonnes_crop_flax_notill += yield_mult * sama.getFlaxYieldIndex() * yield_exp_list[4]/39.37;
			tonnes_crop_lentils_notill += yield_mult * sama.getLentilsYieldIndex() * yield_exp_list[6]/36.74;
			tonnes_crop_peas_notill += yield_mult * sama.getPeasYieldIndex() * yield_exp_list[5]/39.37;						
		}
							
		tonnes_crop_canola_notill = tonnes_crop_canola_notill/total_plots;
		loc_tonnes_crop_barley_notill = loc_tonnes_crop_barley_notill/total_plots;
		loc_tonnes_crop_wheat_notill = loc_tonnes_crop_wheat_notill/total_plots;
		tonnes_crop_durum_notill = tonnes_crop_durum_notill/total_plots;
		tonnes_crop_flax_notill = tonnes_crop_flax_notill/total_plots;
		tonnes_crop_lentils_notill = tonnes_crop_lentils_notill/total_plots;
		tonnes_crop_peas_notill = tonnes_crop_peas_notill/total_plots;
						
			yield_mult = 1 + Increase_NoTill;
			
			
			contribution_margin = new double[] {
					((yield_mult * barley_exp_yield) * farmer_exp_barley_price)
					- ((Per_Acre_VC_Barley + producer_premium_barley_notill) + (Per_Tonne_VC_Barley * loc_tonnes_crop_barley_notill * trucking_distance)),
			((yield_mult * yield_exp_list[0]) * farmer_exp_canola_price)
					- ((Per_Acre_VC_Canola + producer_premium_canola_notill) + (Per_Tonne_VC_Canola * tonnes_crop_canola_notill * trucking_distance)),
			((yield_mult * wheat_exp_yield) * farmer_exp_wheat_price)
					- ((Per_Acre_VC_Wheat + producer_premium_wheat_notill) + (Per_Tonne_VC_Wheat * loc_tonnes_crop_wheat_notill * trucking_distance)), 
			((yield_mult * yield_exp_list[7]) * farmer_exp_durum_price)
			        - ((Per_Acre_VC_Durum + producer_premium_durum_notill) + (Per_Tonne_VC_Durum * tonnes_crop_durum_notill * trucking_distance)),
			((yield_mult * yield_exp_list[4]) * farmer_exp_flax_price)
					- ((Per_Acre_VC_Flax + producer_premium_flax_notill) + (Per_Tonne_VC_Flax * tonnes_crop_flax_notill * trucking_distance)),
			((yield_mult * yield_exp_list[5]) * farmer_exp_peas_price)
			        - ((Per_Acre_VC_Peas + producer_premium_peas_notill) + (Per_Tonne_VC_Peas * tonnes_crop_peas_notill * trucking_distance)),
			((yield_mult * yield_exp_list[6]) * farmer_exp_lentils_price)
					- ((Per_Acre_VC_Lentils + producer_premium_lentils_notill) + (Per_Tonne_VC_Lentils * tonnes_crop_lentils_notill * trucking_distance)), -(interest_rate)};
			
			
			operating_captial = new double[] {
					Per_Acre_VC_Barley + producer_premium_barley_notill
					+ (Per_Tonne_VC_Barley * loc_tonnes_crop_barley_notill * trucking_distance),
			Per_Acre_VC_Canola + producer_premium_canola_notill
					+ (Per_Tonne_VC_Canola * tonnes_crop_canola_notill * trucking_distance),
			Per_Acre_VC_Wheat + producer_premium_wheat_notill
					+ (Per_Tonne_VC_Wheat * loc_tonnes_crop_wheat_notill * trucking_distance),
			Per_Acre_VC_Durum + producer_premium_durum_notill
					+ (Per_Tonne_VC_Durum * tonnes_crop_durum_notill * trucking_distance),
			Per_Acre_VC_Flax + producer_premium_flax_notill
					+ (Per_Tonne_VC_Flax * tonnes_crop_flax_notill * trucking_distance),
			Per_Acre_VC_Peas + producer_premium_peas_notill
					+ (Per_Tonne_VC_Peas * tonnes_crop_peas_notill * trucking_distance),
			Per_Acre_VC_Lentils + producer_premium_lentils_notill
					+ (Per_Tonne_VC_Lentils * tonnes_crop_lentils_notill * trucking_distance), -1};		

					
			double cropland = this.gettotal_crop_acres() - feed_wheat_notill - feed_barley_notill - feed_wheat_con - feed_barley_con;
			double cerealland = Math.round(cereallimit_notill * cropland);
			double maxwheatlimit = Math.round(maxwheat_limit * cerealland);
			double maxbarleylimit = Math.round(maxbarley_limit * cerealland);
			double maxdurumlimit = Math.round(maxdurum_limit * cerealland);
			double oilseedland = Math.round(oilseedlimit_notill * cropland);
			double maxflaxlimit = Math.round(maxflax_limit * oilseedland);
			double maxcanolalimit = Math.round(maxcanola_limit * oilseedland);
			double pulseland = Math.round(pulselimit_notill * cropland);
			double maxpeaslimit = Math.round(maxpeas_limit * pulseland);
			double maxlentilslimit = Math.round(maxlentils_limit * pulseland);
			int oldasset_olddebt = (int) (assets - (debt - debt_payment));
			if(oldasset_olddebt < 0) {
				oldasset_olddebt = 0;
			}
			
			try {
				// // Create a problem with 7 variables and 11 constraints
				LpSolve solver = LpSolve.makeLp(11, 7);
				
				// add constraints
								
				solver.strAddConstraint("1 1 1 1 1 1 1", LpSolve.EQ, cropland); // Crop land (acres)
								
				solver.strAddConstraint("1 0 1 1 0 0 0", LpSolve.LE, cerealland); // Cereal (wheat, durum, and Barley)
							
				solver.strAddConstraint("0 0 1 0 0 0 0", LpSolve.LE, maxwheatlimit); // Max Acres a farme can seed spring wheat
				
				solver.strAddConstraint("0 0 0 1 0 0 0", LpSolve.LE, maxdurumlimit);
							
				solver.strAddConstraint("1 0 0 0 0 0 0", LpSolve.LE, maxbarleylimit);
							
				solver.strAddConstraint("0 1 0 0 1 0 0", LpSolve.LE, oilseedland);
								
				solver.strAddConstraint("0 1 0 0 0 0 0", LpSolve.LE, maxcanolalimit);
								
				solver.strAddConstraint("0 0 0 0 1 0 0", LpSolve.LE, maxflaxlimit);
								
				solver.strAddConstraint("0 0 0 0 0 1 1", LpSolve.LE, pulseland);
								
				solver.strAddConstraint("0 0 0 0 0 1 0", LpSolve.LE, maxpeaslimit);
								
				solver.strAddConstraint("0 0 0 0 0 0 1", LpSolve.LE, maxlentilslimit);
				
				//solver.strAddConstraint("0 0 0 0 0 0 0 1", LpSolve.LE, oldasset_olddebt);
							
		//		String strOprNotill = convertDoubleArrayToString(operating_captial);
			//	solver.strAddConstraint(strOprNotill, LpSolve.LE, this.getcash()); //			
				
				String newStr = convertDoubleArrayToString(contribution_margin);
				solver.strSetObjFn(newStr);
				solver.setMaxim();			
				solver.solve();
				solver.getPtrVariables(); // Store this value to a string
				solver.getObjective(); // Store this value to a string

				expected_income = solver.getObjective();
				double[] var = solver.getPtrVariables(); // This is the crop mix
				for (double d : var) {
					
				}			
				for (int i = 0; i < var.length; i++) {
					barley_notill = var[0];
					canola_notill = var[1];
					wheat_notill = var[2];
					durum_notill = var[3];
					flax_notill = var[4];
					peas_notill = var[5];
					lentils_notill = var[6];
				//	amount_borrow = var[7];
				}					
			
//				int idd = this.getID();
//				int farmerID = this.getfarmer_name();
//				int run_number = Variables.getrun_number();
//				int year = Variables.getyear();
//				int tillage_fallow = (int) gettillage_fallow();
//				int wheat_on_fallow = (int) getwheat_on_fallow();
//				int durum_stubble = (int) getdurum_stubble();
//				int canola_stubble = (int) getcanola_stubble();
//				int barley_stubble = (int) getbarley_stubble();
//				int wheat_stubble = (int) getwheat_stubble();
//				int flax_stubble = (int) getflax_stubble();
//				int peas_stubble = (int) getpeas_stubble();
//				int barley_notill = (int) getbarley_notill();
//				int canola_notill = (int) getcanola_notill();
//				int wheat_notill = (int) getwheat_notill();
//				int durum_notill = (int) getdurum_notill();
//				int flax_notill = (int) getflax_notill();
//				int lentils_notill = (int) getlentils_notill();
//				int peas_notill = (int) getpeas_notill();	
//				int amount_borrow = (int) getamount_borrow();
//				int expected_income = (int) getexpected_income();				
//
//				try {
//					Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
//				} catch (ClassNotFoundException ce) {
//					System.out.println("SQLExceptiong:" + ce.getMessage());
//				}
//				try {
//					Connection conn = DriverManager.getConnection(
//							"jdbc:odbc:producerDB", "java", "1234");
//					Statement stmt = conn.createStatement();
//
//					stmt.executeUpdate("insert into Tactical values ('" 
//							+ idd 
//							+ "', '" + farmerID 
//							+ "', '" + run_number
//							+ "','" + year 
//							+ "', '" + tillage_fallow 
//							+ "', '" + wheat_on_fallow
//							+ "', '" + durum_stubble
//							+ "', '" + canola_stubble 
//							+ "', '" + barley_stubble
//							+ "', '" + wheat_stubble 
//							+ "', '" + flax_stubble
//							+ "', '" + peas_stubble
//							+ "', '" + barley_notill
//							+ "', '" + canola_notill 
//							+ "', '" + wheat_notill
//							+ "', '" + durum_notill
//							+ "', '" + flax_notill
//							+ "', '" + lentils_notill
//							+ "', '" + peas_notill		
//							+ "', '" + amount_borrow
//							+ "', '" + expected_income + "')");
//								
//					stmt.close();
//					conn.close();
//				} catch (SQLException ce) {
//					ce.printStackTrace();
//					System.out.println("HELL 2 SQLException:" + ce.getMessage());
//				}
				solver.deleteLp();
			} catch (LpSolveException e) {
				e.printStackTrace();
			}
		}
	}

	public void update_strategic_MIP_conventional() {		
		if (this.gettotal_crop_acres() <= 2000) { // conventional farmer
			sizing_cropland_value = 0;		
			sizing_pastureland_value = 0; 
			expected_income = 0;
			tillage_fallow = 0;
			wheat_on_fallow = 0;
			durum_stubble = 0;
			canola_stubble = 0;
			barley_stubble = 0;
			wheat_stubble = 0;
			flax_stubble = 0;
			peas_stubble = 0;
			willows_on_natural_pasture = 0;
			willows_on_improved_pasture = 0;
			willows_on_hayland_pasture = 0;
			willows_initial_investment = 0;
			poplar_on_natural_pasture = 0;
			poplar_on_improved_pasture = 0;
			poplar_on_hayland_pasture = 0;
			poplar_initial_investment = 0;
			prairie_sandreed_on_natural_pasture = 0;
			prairie_sandreed_on_improved_pasture = 0;
			prairie_sandreed_on_hayland_pasture = 0;
			prairie_sandreed_initial_investment = 0;
			natural_pasture = 0;
			improved_pasture = 0;
			hayland_pasture = 0;
			rent_out_cropland = 0;
			rent_out_natural_pasture = 0;
			rent_out_improved_pasture = 0;
			rent_out_hayland_pasture = 0;
			pasture_carryover_one = 0;
			pasture_carryover_two = 0;
			improved_bale_first_cut = 0;
			improved_bale_second_cut = 0;
			hay_production_one_cut = 0;
			hay_production_two_cuts = 0;
			breaking_cost = 0;
			buy_hay = 0;
			buy_feed_wheat = 0;
			buy_feed_barley = 0;
			feed_early_summer_hay = 0;
			feed_late_summer_hay = 0;
			feed_fall_hay = 0;
			feed_winter_hay = 0;
			feed_wheat = 0;
			feed_barley = 0;
			wheat_straw = 0;
			barley_straw = 0;					
			sell_hay = 0;
			cows_head = 0;
			cows_labour = 0;   
			cows_fc_handling_system = 0;
			cows_fc_machinery = 0; 
			option_0_acres = 0;
			option_1_acres = 0;
			option_0_number_machines = 0;
			option_1_number_machines = 0;
			rent_pasture_land = 0;
			rent_cropland = 0;
			amount_borrow = 0;						
		Parameters p = RunEnvironment.getInstance().getParameters();
		double cereal_mcal_limit = (Double)p.getValue("cereal_mcal_limit");
		double must_sell_min = (Double) p.getValue("must_sell_min");
		double min_ratio = (Double) p.getValue("minRatio");
		double inv_mach_0 = (Double) p.getValue("inv_Mach_0");
		double inv_mach_1 = (Double) p.getValue("inv_Mach_1");
		double rent_crop_land = (Double) p.getValue("rentCropLand");	
		double rent_pastureland = (Double) p.getValue("rentpastureland");
		double interest_rate = (Double) p.getValue("discountRate");
		double Per_Acre_VC_Summer_Fallow = (Double) p
				.getValue("perAcreVCSummerFallow"); // Variable cost per acre
		double Per_Acre_VC_Wheat_on_Fallow = (Double) p
				.getValue("perAcreVCWheatonFallow"); // Variable cost per acre
		double Per_Acre_VC_Canola_on_Stubble = (Double) p
				.getValue("perAcreVCCanolaonStubble"); // Variable cost per acre
		double Per_Acre_VC_Barley_on_Stubble = (Double) p
				.getValue("perAcreVCBarleyonStubble"); // Variable cost per acre
		double Per_Acre_VC_Wheat_on_Stubble = (Double) p
				.getValue("perAcreVCWheatonStubble"); // Variable cost per acre
		double Per_Acre_VC_Flax_on_Stubble = (Double) p.getValue("perAcreVCFlaxonStubble");
		double Per_Acre_VC_Peas_on_Stubble = (Double) p.getValue("perAcreVCPeasonStubble");
		double Per_Acre_VC_Durum_on_Stubble = (Double) p.getValue("perAcreVCDurumonStubble");
		double Per_Acre_VC_Willows = (Double) p.getValue("perAcreVCWillows");		
		double Per_Tonne_VC_Durum = (Double) p.getValue("perTonneVCDurum");
		double Per_Tonne_VC_Wheat = (Double) p.getValue("perTonneVCWheat"); // Variable
		double Per_Tonne_VC_Canola = (Double) p.getValue("perTonneVCCanola"); // Variable
		double Per_Tonne_VC_Barley = (Double) p.getValue("perTonneVCBarley"); // Variable
		double Per_Tonne_VC_Flax = (Double) p.getValue("perTonneVCFlax");
		double Per_Tonne_VC_Lentils = (Double) p.getValue("perTonneVCLentils");
	 	double Per_Tonne_VC_Peas = (Double) p.getValue("perTonneVCPeas");	
	 	double Per_Tonne_Willow_Custom_Rate = (Double) p.getValue("perTonneWillowCustomRate");			
		double Per_Acre_VC_NP = (Double) p.getValue("peracrevcnp");
		double Per_Acre_VC_IP = (Double) p.getValue("peracrevcip");
		double Per_Acre_VC_HL = (Double) p.getValue("peracrevchl");
		double Per_Acre_VC_Bale_IP_1 = (Double) p.getValue("peracrevcbaleip1");
		double Per_Acre_VC_Bale_IP_2 = (Double) p.getValue("peracrevcbaleip2");
		double Per_Acre_VC_Hayproduction_1 = (Double) p.getValue("peracrevchayproduction1");
		double Per_Acre_VC_Hayproduction_2 = (Double) p.getValue("peracrevchayproduction2");
		double Per_ton_feed_hay_cost = (Double) p.getValue("pertonfeedhaycost");
		double Per_ton_grain_cost = (Double) p.getValue("pertonfeedgraincost");
		double transaction_fee_hay = (Double) p.getValue("transactionfeehay");
		double VC_Cow = (Double) p.getValue("vccow");
		double FC_Cow_Labour = (Double) p.getValue("fccowlabour");
		double Per_ton_straw_bale_cost = (Double) p.getValue("pertonstrawbalecost");
		double pr_rating = 0;
		double pr_max_hay_yield = (Double)p.getValue("prmaxhayyield");	
		double threshold_hay_1 = (Double)p.getValue("thresholdhay1");
		int initial_lease_rate = (Integer)p.getValue("initialleaserate");
		int initial_lease_rate_pasture = (Integer)p.getValue("initialleaseratepasture");
		double lease_man_fee_percent = (Double)p.getValue("lease_man_fee_percent");
		double pr_max_psr_yield = (Double)p.getValue("pr_max_psr_yield");
		double avg_willow_yield = (Double)p.getValue("willowyield");
		double avg_willow_price = (Double)p.getValue("willowprice");
		double min_prairiesandreed_yield = (Double)p.getValue("min_psr_yield");
		double max_prairiesandreed_yield = (Double)p.getValue("max_psr_yield");		
		double propertytaxescropland = 6;
		double propertytaxespasture = 3;
		double fallow_yield_mult = (Double) p.getValue("fallow_yield_mult");
		double Per_Tonne_VC_Hay = (Double) p.getValue("perTonneVCHay");
		double psr_gj_tonne = (Double)p.getValue("psrgjtonne");
		double gjprice = (Double)p.getValue("gjprice");
		yield_mult = 1;

		Iterator<SAMA> it = mylandList.iterator();
		double tonnes_crop_canola_stubble = 0, loc_tonnes_crop_wheat_stubble = 0, loc_tonnes_crop_barley_stubble = 0, loc_tonnes_crop_wheat_sf = 0,
		tonnes_crop_flax_stubble = 0, tonnes_crop_peas_stubble = 0, tonnes_crop_flax_notill = 0, tonnes_crop_peas_notill = 0, tonnes_crop_lentils_notill = 0, tonnes_crop_durum_stubble = 0, tonnes_crop_durum_notill = 0;
			
		for(int i = 0; i < getmylandList().size(); i++){
			SAMA sama = (SAMA) getmylandList().get(i);
				
			tonnes_crop_canola_stubble += yield_mult * sama.getCanolaYieldIndex() * yield_exp_list[0] / 44.09; 
			loc_tonnes_crop_wheat_stubble += yield_mult * sama.getWheatYieldIndex()	* yield_exp_list[1] / 36.74;
			loc_tonnes_crop_barley_stubble += yield_mult * sama.getBarleyYieldIndex() * yield_exp_list[2] / 45.93;
			loc_tonnes_crop_wheat_sf += yield_mult * sama.getWheatSfYieldIndex() * yield_exp_list[1] / 36.74;
			tonnes_crop_flax_stubble += yield_mult * sama.getFlaxYieldIndex() * yield_exp_list[4] / 39.37;
			tonnes_crop_peas_stubble += yield_mult * sama.getPeasYieldIndex() * yield_exp_list[5] / 39.37;
			tonnes_crop_durum_stubble += yield_mult * sama.getDurumYieldIndex() * yield_exp_list[7] /36.37;
					
				if(sama.getpatchtype() == 1){
					
					
						sizing_cropland_value += (Variables.getcrop_exp_lease() * sama.getAvg_prod_patch()/Variables.getmean_patch_quality());
							
					}
					
				if(sama.getpatchtype() == 2 || sama.getpatchtype() == 3) {
				sizing_pastureland_value += (Variables.getmarginal_exp_lease() * sama.getAvg_prod_patch()/Variables.getmean_patch_quality());
				}
				
				if(Variables.getunmanaged() > 60){
					sizing_cropland_value = sizing_cropland_value * must_sell_min;
					sizing_pastureland_value = sizing_pastureland_value * must_sell_min;
						}
				
				if(sama.getnpQuality() > pr_max_psr_yield) {
					pr_rating = pr_max_psr_yield;
					prairiesandreed_yield_np = (pr_rating/pr_max_psr_yield * (max_prairiesandreed_yield - min_prairiesandreed_yield) + min_prairiesandreed_yield);
				}
				else {
					pr_rating = sama.getnpQuality();
					prairiesandreed_yield_np = (pr_rating/pr_max_psr_yield * (max_prairiesandreed_yield - min_prairiesandreed_yield) + min_prairiesandreed_yield);
				}
				if(sama.getIPQuality() > pr_max_psr_yield) {
					pr_rating = pr_max_psr_yield;
					prairiesandreed_yield_ip = (pr_rating/pr_max_psr_yield * (max_prairiesandreed_yield - min_prairiesandreed_yield) + min_prairiesandreed_yield);
				}
				else {
					pr_rating = sama.getIPQuality();
					prairiesandreed_yield_ip = (pr_rating/pr_max_psr_yield * (max_prairiesandreed_yield - min_prairiesandreed_yield) + min_prairiesandreed_yield);
				}
				if(sama.getHayQuality() > pr_max_psr_yield) {
					pr_rating = pr_max_psr_yield;
					prairiesandreed_yield_hayland = (pr_rating/pr_max_psr_yield * (max_prairiesandreed_yield - min_prairiesandreed_yield) + min_prairiesandreed_yield);
				}
				else {
					pr_rating = sama.getHayQuality();
					prairiesandreed_yield_hayland = (pr_rating/pr_max_psr_yield * (max_prairiesandreed_yield - min_prairiesandreed_yield) + min_prairiesandreed_yield);
				}
						
			if(sama.getnpQuality() > pr_max_hay_yield) {
				pr_rating = pr_max_hay_yield;				
				exp_np_early_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3])));
				exp_np_late_yield = (pr_rating / pr_max_hay_yield *  ((yield_exp_list[3] * 0.6)));
				exp_np_fall_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3] * 0.2)));
				exp_mcals_np_early_yield = (exp_np_early_yield * Variables.getmcals_ton_np_early());
				exp_mcals_np_late_yield = (exp_np_late_yield * Variables.getmcals_ton_np_late());
				exp_mcals_np_fall_yield =(exp_np_fall_yield * Variables.getmcals_ton_np_fall());
			}			
			else {
				pr_rating = sama.getnpQuality();				
				exp_np_early_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3])));
				exp_np_late_yield = (pr_rating / pr_max_hay_yield *  ((yield_exp_list[3] * 0.6)));
				exp_np_fall_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3] * 0.2)));
				exp_mcals_np_early_yield = (exp_np_early_yield * Variables.getmcals_ton_np_early());
				exp_mcals_np_late_yield = (exp_np_late_yield * Variables.getmcals_ton_np_late());
				exp_mcals_np_fall_yield =(exp_np_fall_yield * Variables.getmcals_ton_np_fall());
			}			
			if(sama.getIPQuality() > pr_max_hay_yield) {
				pr_rating = pr_max_hay_yield;				
				exp_ip_early_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3])));
				exp_ip_late_yield = (pr_rating / pr_max_hay_yield *  ((yield_exp_list[3] * 0.6)));
				exp_ip_fall_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3] * 0.2)));
				exp_ip_early_yield_bale_one = (pr_rating / pr_max_hay_yield * yield_exp_list[3]);				
				exp_ip_late_yield_bale_two = (exp_ip_early_yield + (0.6 * exp_ip_early_yield)) ;	
				exp_mcals_ip_early_yield = (exp_ip_early_yield * Variables.getmcals_ton_ip_early());
				exp_mcals_ip_late_yield = (exp_ip_late_yield * Variables.getmcals_ton_ip_late());
				exp_mcals_ip_fall_yield = (exp_ip_fall_yield * Variables.getmcals_ton_ip_fall());
			}
			else {
				pr_rating = sama.getIPQuality();				
				exp_ip_early_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3])));
				exp_ip_late_yield = (pr_rating / pr_max_hay_yield *  ((yield_exp_list[3] * 0.6)));
				exp_ip_fall_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3] * 0.2)));
				exp_ip_early_yield_bale_one = (pr_rating / pr_max_hay_yield * yield_exp_list[3]);				
				exp_ip_late_yield_bale_two = (exp_ip_early_yield + (0.6 * exp_ip_early_yield)) ;	
				exp_mcals_ip_early_yield = (exp_ip_early_yield * Variables.getmcals_ton_ip_early());
				exp_mcals_ip_late_yield = (exp_ip_late_yield * Variables.getmcals_ton_ip_late());
				exp_mcals_ip_fall_yield = (exp_ip_fall_yield * Variables.getmcals_ton_ip_fall());				
			}		
			if(sama.getHayQuality() > pr_max_hay_yield) {
				pr_rating = pr_max_hay_yield;				
				exp_hay_early_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3])));
				exp_hay_late_yield = (pr_rating / pr_max_hay_yield *  ((yield_exp_list[3] * 0.6)));
				exp_hay_fall_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3] * 0.2)));
				exp_hay_early_yield_bale_one = (pr_rating / pr_max_hay_yield * yield_exp_list[3]);				
				exp_hay_late_yield_bale_two = (exp_hay_early_yield + (0.6 * exp_hay_early_yield)) ;	
				exp_mcals_hayland_early_yield = (exp_hay_early_yield * Variables.getmcals_ton_hayland_early());
				exp_mcals_hayland_late_yield = (exp_hay_late_yield * Variables.getmcals_ton_hayland_late());
				exp_mcals_hayland_fall_yield = (exp_hay_fall_yield * Variables.getmcals_ton_hayland_fall());						
			}			
			else {
				pr_rating = sama.getHayQuality();			
				exp_hay_early_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3])));
				exp_hay_late_yield = (pr_rating / pr_max_hay_yield *  ((yield_exp_list[3] * 0.6)));
				exp_hay_fall_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3] * 0.2)));
				exp_hay_early_yield_bale_one = (pr_rating / pr_max_hay_yield * yield_exp_list[3]);				
				exp_hay_late_yield_bale_two = (exp_hay_early_yield + (0.6 * exp_hay_early_yield)) ;	
				exp_mcals_hayland_early_yield = (exp_hay_early_yield * Variables.getmcals_ton_hayland_early());
				exp_mcals_hayland_late_yield = (exp_hay_late_yield * Variables.getmcals_ton_hayland_late());
				exp_mcals_hayland_fall_yield = (exp_hay_fall_yield * Variables.getmcals_ton_hayland_fall());			
			}
			if(gettotal_improved_pasture() + gettotal_hay() > 0) {
				weighted_avg_mcals_bale_one = ((((gettotal_improved_pasture()/(gettotal_improved_pasture() + gettotal_hay()))*Variables.getmcals_ton_ip_baled_one()) + 
						(((gettotal_hay()/(gettotal_improved_pasture() + gettotal_hay()))*Variables.getmcals_ton_hayland_baled_one()))));
				
				weighted_avg_mcals_bale_two = (((weighted_avg_mcals_bale_one) + ((((gettotal_improved_pasture()/(gettotal_improved_pasture() + gettotal_hay()))*Variables.getmcals_ton_ip_baled_two()) + 
						(((gettotal_hay()/(gettotal_improved_pasture() + gettotal_hay()))*Variables.getmcals_ton_hayland_baled_two()))))/2)/2);
				}				
				else {
				weighted_avg_mcals_bale_one = ((Variables.getmcals_ton_ip_baled_one() + Variables.getmcals_ton_hayland_baled_one())/2);
					
				weighted_avg_mcals_bale_two = ((((Variables.getmcals_ton_ip_baled_one() + Variables.getmcals_ton_hayland_baled_one())/2) + ((Variables.getmcals_ton_ip_baled_two() + Variables.getmcals_ton_hayland_baled_two())/2))/2);
				}
			}

		tonnes_crop_canola_stubble = tonnes_crop_canola_stubble/total_plots; 
		loc_tonnes_crop_wheat_stubble = loc_tonnes_crop_wheat_stubble/total_plots;
		loc_tonnes_crop_barley_stubble = loc_tonnes_crop_barley_stubble/total_plots; 
		loc_tonnes_crop_wheat_sf = loc_tonnes_crop_wheat_sf/total_plots;
		tonnes_crop_flax_stubble = tonnes_crop_flax_stubble/total_plots;
		tonnes_crop_peas_stubble = tonnes_crop_peas_stubble/total_plots;
		tonnes_crop_durum_stubble = tonnes_crop_durum_stubble/total_plots;
		
			if(n_cows > 0){
			np_cow_acre = 0.5; //total_natural_pasture/n_cows;
			ip_cow_acre = 1; ///total_improved_pasture/n_cows;
			hayland_cow_acre = 2; //total_hay/n_cows;
			
			total_cow_acre = 4; //(total_natural_pasture +  total_improved_pasture + total_hay)/n_cows;
			
			
			}
		
		
		
		if(total_cropland_plots > 0) {
			sizing_cropland_value = sizing_cropland_value/total_cropland_plots;
			}
			else {
				sizing_cropland_value = Variables.getcrop_exp_lease();
			}
			if(total_marginal_plots > 0) {
			sizing_pastureland_value = sizing_pastureland_value/total_marginal_plots;
			}
			else {
				sizing_pastureland_value = Variables.getmarginal_exp_lease();
			}
		
		

		
			
				
		
					
		for (int i = 0; i < getmylandList().size(); i++) {
			SAMA fdl1 = (SAMA) getmylandList().get(i);
			int countgrass = i;
			int countpsr = i;
				if(fdl1.getyears_in_grass() > 0) {
				countgrass++;				
			
			average_years_in_grass = average_years_in_grass + fdl1.getyears_in_grass();

				
				}
				
				if(fdl1.getyears_in_prairie_sandreed() > 0){
					countpsr++;
					
					average_years_in_prairie_sandreed = average_years_in_prairie_sandreed + fdl1.getyears_in_prairie_sandreed();
				}

				if(getplots_in_grass() > 0){
					
					average_years_in_grass = average_years_in_grass/getplots_in_grass();
					}	
				if(getplots_in_prairie_sandreed() > 0){
					average_years_in_prairie_sandreed = average_years_in_prairie_sandreed/getplots_in_prairie_sandreed();
				}
				
		}
				
		
		
		if(average_years_in_prairie_sandreed > 0 && average_years_in_prairie_sandreed < 7){
			prairiesandreed_yield_np = prairiesandreed_yield_np * -1;
			prairiesandreed_yield_ip = prairiesandreed_yield_np * -1;
			prairiesandreed_yield_hayland = prairiesandreed_yield_hayland * -1;
		}
		if(average_years_in_willows > 0 && average_years_in_willows < 21){
			willows_annualized_return_np = willows_annualized_return_np * -1;
			willows_annualized_return_ip = willows_annualized_return_ip * -1;
			willows_annualized_return_hayland = willows_annualized_return_hayland * -1;
		}
		if(average_years_in_poplar > 0 && average_years_in_poplar < 21){
			poplar_annualized_return_np = poplar_annualized_return_np * -1;
			poplar_annualized_return_ip = poplar_annualized_return_ip * -1;
			poplar_annualized_return_hayland = poplar_annualized_return_hayland * -1;
		
		}
			if(average_years_in_grass < 7) {
				
					forage_breaking = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0.5, 1, 0, 0, 0, 0, 0, 0, 0.5, 0.5, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			}
				else {
					
					forage_breaking = new double[] {0, 0, 0, 0, 0,	0, 0, 0, 0,	0, 0, 0, 0,	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0.5, 1, 0, 0, 0, 0, 0, 0, 0.5, 0.5, 1, 1, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
				}
			
			willow_transfer = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			poplar_transfer = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			prairie_sandreed_transfer = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			handling_transfer = 1;
			cows_handling_system_limit = 300;
			cows_machine_limit = 300;
		
				
		double Machine_VC_0 = (Double) p.getValue("machineVC0");
		double Machine_VC_1 = (Double) p.getValue("machineVC1");
		double Machine_FC_0 = (Double) p.getValue("machineFC0"); // Fixed cost
		double Machine_FC_1 = (Double) p.getValue("machineFC1"); // Fixed cost
		double Per_Acre_Annualized_Breaking = (Double) p.getValue("peracreannualizedbreaking");
		double per_acre_breaking = (Double) p.getValue("peracrebreaking");
		double FC_Cow_Handling = (Double) p.getValue("fccowhandling");
		double FC_Cow_Machinery = (Double) p.getValue("fccowmachinery");
		double inv_handling = (Double) p.getValue("invhandling");
		double inv_cow_machine = (Double) p.getValue("invcowmachine");
		double int_inv_willows = (Double) p.getValue("intinvwillows");
		double annualizedbreakingwillows = (Double) p.getValue("annualizedbreakingwillows");
		double annualizedbreakingpoplar = (Double) p.getValue("annualizedbreakingpoplar");
		double annualizedbreakingprairesandreed = (Double) p.getValue("annualizedbreakingprairiesandreed");
		double Per_Tonne_Poplar_Custom_Rate = (Double) p.getValue("perTonneWillowCustomRate");
		double Per_Tonne_PrairieSandReed_Custom_Rate = (Double) p.getValue("per_Tonne_PrairieSandreed_Custom_Rate");
		double int_inv_poplar = (Double) p.getValue("int_inv_poplar");
		double int_inv_prairiesandreed = (Double) p.getValue("int_inv_prairiesandreed");
		double cereallimit_con = (Double)p.getValue("cereallimit_con");
		double oilseedlimit_con = (Double)p.getValue("oilseedlimit_con");
		double pulselimit_con = (Double)p.getValue("pulselimit_con");
		double maxwheat_limit = (Double)p.getValue("maxwheatlimit");
		double maxbarley_limit = (Double)p.getValue("maxbarleylimit");
		double maxdurum_limit = (Double)p.getValue("maxdurumlimit");
		double maxflax_limit = (Double)p.getValue("maxflaxlimit");
		double maxcanola_limit = (Double)p.getValue("maxcanolalimit");
		double cull_transaction_cost = (Double)p.getValue("cull_transaction_cost");
		double sell_cows_fee = (Double)p.getValue("sellherdcost");
		double alpha = (Double) p.getValue("alpha");
		double gama = (Double)p.getValue("gama");
		double No_Buy_Hay = (Double)p.getValue("NoBuyHay");
		//System.out.println("NoBuyHay" + No_Buy_Hay);
		
			yield_mult = 1;
			double error = 1 + ((int) (Math.random()*10)-5.0)/100.0;	
			double barley_exp_yield = yield_exp_list[2];
			double wheat_exp_yield = yield_exp_list[1];			
			double prairiesandreed_price = (Double)p.getValue("psr_price");
			
			
						
		
				if(getfarmer_type() == 2 || getfarmer_type() == 3){
			contribution_margin = new double[] {					
					(fallow_yield_mult * yield_mult * wheat_exp_yield * farmer_exp_wheat_price)
							- ((Per_Acre_VC_Wheat_on_Fallow + producer_premium_wheat_fallow) + (Per_Tonne_VC_Wheat * loc_tonnes_crop_wheat_sf * trucking_distance)),
							-(Per_Acre_VC_Summer_Fallow),	
					(yield_mult * yield_exp_list[7] * farmer_exp_durum_price) - ((Per_Acre_VC_Durum_on_Stubble + producer_premium_durum_stubble) + (Per_Tonne_VC_Durum * tonnes_crop_durum_stubble * trucking_distance)),		
					(yield_mult * yield_exp_list[0] * farmer_exp_canola_price)
							- ((Per_Acre_VC_Canola_on_Stubble + producer_premium_canola_stubble)
							+ (Per_Tonne_VC_Canola * tonnes_crop_canola_stubble * trucking_distance)),
					-(yield_mult * barley_exp_yield * (farmer_exp_barley_price * 0.6529))
							- ((Per_Acre_VC_Barley_on_Stubble)),						
					(yield_mult * barley_exp_yield * farmer_exp_barley_price)
							- ((Per_Acre_VC_Barley_on_Stubble + producer_premium_barley_stubble) + (Per_Tonne_VC_Barley * loc_tonnes_crop_barley_stubble * trucking_distance)),
					-(yield_mult * wheat_exp_yield * farmer_exp_wheat_price)
							- ((Per_Acre_VC_Wheat_on_Stubble)), 							
					(yield_mult * wheat_exp_yield * farmer_exp_wheat_price)
							- ((Per_Acre_VC_Wheat_on_Stubble + producer_premium_wheat_stubble) + (Per_Tonne_VC_Wheat * loc_tonnes_crop_wheat_stubble)), 
							(yield_mult * yield_exp_list[4] * farmer_exp_flax_price) - ((Per_Acre_VC_Flax_on_Stubble + producer_premium_flax_stubble) + (Per_Tonne_VC_Flax * tonnes_crop_flax_stubble * trucking_distance)),
							(yield_mult * yield_exp_list[5] * farmer_exp_peas_price) - ((Per_Acre_VC_Peas_on_Stubble + producer_premium_peas_stubble) + (Per_Tonne_VC_Flax * tonnes_crop_peas_stubble * trucking_distance)),
							(willows_annualized_return_np),
							(willows_annualized_return_ip),
							(willows_annualized_return_hayland),
							-(annualizedbreakingwillows),
							(poplar_annualized_return_np),
							(poplar_annualized_return_ip),
							(poplar_annualized_return_hayland),
							-(annualizedbreakingpoplar),
							(prairiesandreed_yield_np * psr_gj_tonne * gjprice) - ((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_np)),
							(prairiesandreed_yield_ip * psr_gj_tonne * gjprice) - ((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_ip)),
							(prairiesandreed_yield_hayland * psr_gj_tonne * gjprice) - ((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_hayland)),
							-(annualizedbreakingprairesandreed),
							-(Per_Acre_VC_NP), -(Per_Acre_VC_IP), -(Per_Acre_VC_HL), 
							(-100), (-100), (-100), (-100),
							0, 0, -(Per_Acre_VC_Bale_IP_1),
							-(Per_Acre_VC_Bale_IP_2), -(Per_Acre_VC_Hayproduction_1), -(Per_Acre_VC_Hayproduction_2), -(Per_Acre_Annualized_Breaking),
							-(farmer_exp_hay_price + transaction_fee_hay + (Per_Tonne_VC_Hay * trucking_distance)*No_Buy_Hay), -(farmer_exp_wheat_price*36.74 + transaction_fee_hay + (Per_Tonne_VC_Wheat * trucking_distance)), -(farmer_exp_barley_price*45.93 + transaction_fee_hay + (Per_Tonne_VC_Barley * trucking_distance)), 
							-(Per_ton_feed_hay_cost), -(Per_ton_feed_hay_cost), -(Per_ton_feed_hay_cost), -(Per_ton_feed_hay_cost), 
							-(Per_ton_grain_cost), -(Per_ton_grain_cost), -(Per_ton_straw_bale_cost), -(Per_ton_straw_bale_cost), (farmer_exp_hay_price -(transaction_fee_hay)), -(crccow),
							((farmer_exp_calf_price*495) - (VC_Cow)), -(FC_Cow_Labour), -(FC_Cow_Handling), -(FC_Cow_Machinery), (crccow - ((crccow * cull_transaction_cost) + sell_cows_fee)),		
					-(Machine_VC_0), -(Machine_VC_1), -(Machine_FC_0),
					-(Machine_FC_1), -(sizing_pastureland_value * 640), -(sizing_cropland_value * 640), -(interest_rate) };

			}
			else {			
				contribution_margin = new double[] {					
						(fallow_yield_mult * yield_mult * wheat_exp_yield * farmer_exp_wheat_price)
						- ((Per_Acre_VC_Wheat_on_Fallow + producer_premium_wheat_fallow) + (Per_Tonne_VC_Wheat * loc_tonnes_crop_wheat_sf * trucking_distance)),
						-(Per_Acre_VC_Summer_Fallow),	
				(yield_mult * yield_exp_list[7] * farmer_exp_durum_price) - ((Per_Acre_VC_Durum_on_Stubble + producer_premium_durum_stubble) + (Per_Tonne_VC_Durum * tonnes_crop_durum_stubble * trucking_distance)),		
				(yield_mult * yield_exp_list[0] * farmer_exp_canola_price)
						- ((Per_Acre_VC_Canola_on_Stubble + producer_premium_canola_stubble)
						+ (Per_Tonne_VC_Canola * tonnes_crop_canola_stubble * trucking_distance)),
				-(yield_mult * barley_exp_yield * farmer_exp_barley_price * 0.6529)
						- ((Per_Acre_VC_Barley_on_Stubble)),						
				(yield_mult * barley_exp_yield * farmer_exp_barley_price)
						- ((Per_Acre_VC_Barley_on_Stubble + producer_premium_barley_stubble) + (Per_Tonne_VC_Barley * loc_tonnes_crop_barley_stubble * trucking_distance)),
				-(yield_mult * wheat_exp_yield * farmer_exp_wheat_price)
						- ((Per_Acre_VC_Wheat_on_Stubble)), 							
				(yield_mult * wheat_exp_yield * farmer_exp_wheat_price)
						- ((Per_Acre_VC_Wheat_on_Stubble + producer_premium_wheat_stubble) + (Per_Tonne_VC_Wheat * loc_tonnes_crop_wheat_stubble)), 
						(yield_mult * yield_exp_list[4] * farmer_exp_flax_price) - ((Per_Acre_VC_Flax_on_Stubble + producer_premium_flax_stubble) + (Per_Tonne_VC_Flax * tonnes_crop_flax_stubble * trucking_distance)),
						(yield_mult * yield_exp_list[5] * farmer_exp_peas_price) - ((Per_Acre_VC_Peas_on_Stubble + producer_premium_peas_stubble) + (Per_Tonne_VC_Flax * tonnes_crop_peas_stubble * trucking_distance)),
						(willows_annualized_return_np),
						(willows_annualized_return_ip),
						(willows_annualized_return_hayland),
						-(annualizedbreakingwillows),
						(poplar_annualized_return_np),
						(poplar_annualized_return_ip),
						(poplar_annualized_return_hayland),
						-(annualizedbreakingpoplar),
						(prairiesandreed_yield_np * psr_gj_tonne * gjprice) - ((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_np)),
						(prairiesandreed_yield_ip * psr_gj_tonne * gjprice) - ((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_ip)),
						(prairiesandreed_yield_hayland * psr_gj_tonne * gjprice) - ((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_hayland)),
						-(annualizedbreakingprairesandreed),
						-(Per_Acre_VC_NP), -(Per_Acre_VC_IP), -(Per_Acre_VC_HL), 
						(-100), (-100), (-100), (-100),
						0, 0, -(Per_Acre_VC_Bale_IP_1),
						-(Per_Acre_VC_Bale_IP_2), -(Per_Acre_VC_Hayproduction_1), -(Per_Acre_VC_Hayproduction_2), -(Per_Acre_Annualized_Breaking),
						-(farmer_exp_hay_price + transaction_fee_hay + (Per_Tonne_VC_Hay * trucking_distance)*No_Buy_Hay), -(farmer_exp_wheat_price*36.74 + transaction_fee_hay + (Per_Tonne_VC_Wheat * trucking_distance)), -(farmer_exp_barley_price*45.93 + transaction_fee_hay + (Per_Tonne_VC_Barley * trucking_distance)), 
						-(Per_ton_feed_hay_cost), -(Per_ton_feed_hay_cost), -(Per_ton_feed_hay_cost), -(Per_ton_feed_hay_cost), 
						-(Per_ton_grain_cost), -(Per_ton_grain_cost), -(Per_ton_straw_bale_cost), -(Per_ton_straw_bale_cost), (farmer_exp_hay_price -(transaction_fee_hay)), (0),
						(0), -(FC_Cow_Labour), -(FC_Cow_Handling), -(FC_Cow_Machinery),	(0),	
				-(Machine_VC_0), -(Machine_VC_1), -(Machine_FC_0),
				-(Machine_FC_1), -(sizing_pastureland_value * 640), -(sizing_cropland_value * 640), -(interest_rate)};
			}			
			borrowing = new double[] {
					Per_Acre_VC_Wheat_on_Fallow + producer_premium_wheat_fallow + (Per_Tonne_VC_Wheat * loc_tonnes_crop_wheat_sf * trucking_distance),
					Per_Acre_VC_Summer_Fallow,
					Per_Acre_VC_Durum_on_Stubble + producer_premium_durum_stubble + (Per_Tonne_VC_Durum * tonnes_crop_durum_stubble * trucking_distance),
					Per_Acre_VC_Canola_on_Stubble + producer_premium_canola_stubble + (Per_Tonne_VC_Canola * tonnes_crop_canola_stubble * trucking_distance),
					Per_Acre_VC_Barley_on_Stubble,
					(Per_Acre_VC_Barley_on_Stubble) + producer_premium_barley_stubble + (Per_Tonne_VC_Barley * loc_tonnes_crop_barley_stubble * trucking_distance),
					Per_Acre_VC_Wheat_on_Stubble,
					(Per_Acre_VC_Wheat_on_Stubble) + producer_premium_wheat_stubble + (Per_Tonne_VC_Wheat * loc_tonnes_crop_wheat_stubble * trucking_distance), 
					(Per_Acre_VC_Flax_on_Stubble) + producer_premium_flax_stubble + (Per_Tonne_VC_Flax * tonnes_crop_flax_stubble * trucking_distance),
					(Per_Acre_VC_Peas_on_Stubble) + producer_premium_peas_stubble + (Per_Tonne_VC_Peas * tonnes_crop_peas_stubble * trucking_distance),
					(willows_annualized_cost_np), (willows_annualized_cost_np), (willows_annualized_cost_hayland), (int_inv_willows), 
					(poplar_annualized_cost_np), (poplar_annualized_cost_ip), 
					(poplar_annualized_cost_hayland), (int_inv_poplar), 
					((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_np)), ((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_ip)), 
					((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_hayland)), (int_inv_prairiesandreed), 			
					(Per_Acre_VC_NP), (Per_Acre_VC_IP), (Per_Acre_VC_HL), propertytaxescropland, propertytaxespasture + (sizing_pastureland_value * 0.5 * lease_man_fee_percent), propertytaxespasture + (sizing_pastureland_value * 0.75 * lease_man_fee_percent), 
					propertytaxespasture + (sizing_pastureland_value * lease_man_fee_percent), 0, 0, (Per_Acre_VC_Bale_IP_1), (Per_Acre_VC_Bale_IP_2), (Per_Acre_VC_Hayproduction_1),
					(Per_Acre_VC_Hayproduction_2), (per_acre_breaking),  (farmer_exp_hay_price + transaction_fee_hay + (Per_Tonne_VC_Hay * trucking_distance)*No_Buy_Hay), (farmer_exp_wheat_price*36.74 + transaction_fee_hay + (Per_Tonne_VC_Wheat * trucking_distance)), (farmer_exp_barley_price*45.93 + transaction_fee_hay + (Per_Tonne_VC_Barley * trucking_distance)), 
					(Per_ton_feed_hay_cost), (Per_ton_feed_hay_cost), (Per_ton_feed_hay_cost), (Per_ton_feed_hay_cost), 
					(Per_ton_grain_cost), (Per_ton_grain_cost), (Per_ton_straw_bale_cost), (Per_ton_straw_bale_cost), (transaction_fee_hay), (NewCostCow), 
					(VC_Cow), (FC_Cow_Labour),	(inv_handling), (inv_cow_machine),	((farmer_exp_cull_price * cull_transaction_cost) + sell_cows_fee),	
					Machine_VC_0, Machine_VC_1, inv_mach_0, inv_mach_1, (sizing_pastureland_value * 640),
					(sizing_cropland_value * 640), -1 };
					
			daratio = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(int_inv_willows * min_ratio), 0, 0, 0, -(int_inv_poplar * min_ratio), 0, 0, 0, -(int_inv_prairiesandreed * min_ratio), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(per_acre_breaking * min_ratio), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(NewCostCow * min_ratio), 0, 0, -(inv_handling * min_ratio), -(inv_cow_machine * min_ratio), 0, 0, 0,
					-(inv_mach_0 * min_ratio), -(inv_mach_1 * min_ratio), -(sizing_pastureland_value * 640 * min_ratio), -(sizing_cropland_value * 640 * min_ratio), 1};

			hay_transfer = new double[] {0,	0, 0, 0, 0, 0,	0, 0, 0, 0,	0, 0, 0, 0,	0, 0, 0, 0,	0, 0, 0, 0,	0, 0, 0, 0,	0, 0, 0, 0, 0, -(exp_ip_early_yield_bale_one*error), -(exp_ip_late_yield_bale_two*error), -(exp_hay_early_yield_bale_one*error), -(exp_hay_late_yield_bale_two*error), 0, -1, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
						
			barley_transfer = new double[] {0, 0, 0, 0, -(barley_exp_yield/45.93), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			wheat_transfer = new double[] {0, 0, 0, 0, 0, 0, -(wheat_exp_yield/36.74), 0, 0, 0, 0,	0, 0, 0, 0,	0, 0, 0, 0,	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			barley_strawtransfer = new double[] {0,	0, 0, 0, -(barley_exp_yield/45.93), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			wheat_strawtransfer = new double[] {0, 0, 0, 0, 0, 0, -(wheat_exp_yield/36.74), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			early_pasture_mcals = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(exp_mcals_np_early_yield), -(exp_mcals_ip_early_yield), -(exp_mcals_hayland_early_yield), 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(weighted_avg_mcals_bale_one), 0, 0, 0, 0, 0, 0, 0, 0, 0, (Variables.getmcals_required_early_summer()), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			late_pasture_mcals = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(exp_mcals_np_late_yield), -(exp_mcals_ip_late_yield), -(exp_mcals_hayland_late_yield), 0, 0, 0, 0, -0.5, 1, -(Variables.getmcals_ton_ip_baled_one()), 0, -(Variables.getmcals_ton_hayland_baled_one()), 0, 0, 0, 0, 0, 0, -(weighted_avg_mcals_bale_one), 0, 0, 0, 0, 0, 0, 0, 0, (Variables.getmcals_required_late_summer()), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			fall_pasture_mcals = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(exp_mcals_np_fall_yield), -(exp_mcals_ip_fall_yield), -(exp_mcals_hayland_fall_yield), 0, 0, 0, 0, 0, -0.5, -(Variables.getmcals_ton_ip_baled_two()), -(Variables.getmcals_ton_ip_baled_two()), -(Variables.getmcals_ton_hayland_baled_two()), -(Variables.getmcals_ton_hayland_baled_two()), 0, 0, 0, 0, 0, 0, -(weighted_avg_mcals_bale_two), 0, 0, 0, 0, 0, 0, 0, (Variables.getmcals_required_fall()), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			winter_pasture_mcals = new double[] {0,	0, 0, 0, -3394, 0, -3724, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(weighted_avg_mcals_bale_two), -3724, -3394, -664, -823, 0, 0, (Variables.getmcals_required_winter()), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			max_feeding_mcals = new double[] {0, 0, 0, 0, -((1-alpha)*3394), 0, -((1-alpha)*3724), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(alpha*weighted_avg_mcals_bale_two), ((1-alpha)*3724), ((1-alpha)*3394), -((1-alpha)*664), -((1-alpha)*823), 0, 0, (Variables.getmcals_required_winter()), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
						
			cows_handling_constraint = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (handling_transfer), 0, -(cows_handling_system_limit), 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			cows_machine_constraint = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (handling_transfer), 0, 0, -(cows_machine_limit), 0, 0, 0, 0, 0, 0, 0, 0};
			
			cows_acres_required = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(np_cow_acre), -(ip_cow_acre), -(hayland_cow_acre), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (total_cow_acre), 0, 0, 0, 0, 0, 0, 0, 0, -640, 0, 0};
			
			
			double cropland = this.gettotal_crop_acres();
			double chemfallow = 0; 
			double maxwheatlimit = 0;
			double maxbarleylimit = 0;
			double maxdurumlimit = 0;
			
			double cerealland = Math.round(cereallimit_con * cropland);
			double oilseedland = Math.round(oilseedlimit_con * cropland);
			double maxcanolalimit = Math.round(maxcanola_limit * oilseedland);
			double maxflaxlimit = Math.round(maxflax_limit * oilseedland);
			
				if(getfarmer_type() == 2 || getfarmer_type() == 3){	
			maxwheatlimit = Math.round(0.025 * cerealland * maxwheat_limit);
			maxbarleylimit = Math.round(0.025 * cerealland * maxbarley_limit);
			maxdurumlimit = Math.round(0.00 * cerealland * maxdurum_limit);
			
			maxwheatlimit_constraint = new double[] {1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(640 * cereallimit_con * maxwheat_limit * 0.025), 0};  
			maxbarleylimit_constraint = new double[] {0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(640 * cereallimit_con * maxbarley_limit * 0.025), 0};
			maxdurumlimit_constraint = new double[] {0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(640 * cereallimit_con * maxdurum_limit * 0.0), 0};
			
			}
			else{
				maxwheatlimit = Math.round(maxwheat_limit * cerealland);
				maxbarleylimit = Math.round(maxbarley_limit * cerealland);
				maxdurumlimit = Math.round(maxdurum_limit * cerealland);
				
				maxwheatlimit_constraint = new double[] {1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(640 * cereallimit_con * maxwheat_limit), 0};  
				maxbarleylimit_constraint = new double[] {0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(640 * cereallimit_con * maxbarley_limit), 0};
				maxdurumlimit_constraint = new double[] {0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(640 * cereallimit_con * maxdurum_limit), 0};
			}
			
			double pulseland = Math.round(pulselimit_con * cropland);
			double haystoragemax = 0;
			double cow_constraint = 300; 
			double cow_mach_constraint = 300;
			double maxfeedwheatlimit = cerealland;
			double maxfeedbarleylimit = cerealland;

			double haylandpastureland = gettotal_hay() - (getwillowshaylandpasture() + getpoplarhaylandpasture() + getprairiesandreedhaylandpasture());
			
			double improvedpastureland = haylandpastureland + gettotal_improved_pasture() - (getwillowsimprovedpasture() + getpoplarimprovedpasture() + getprairiesandreedimprovedpasture());
			
			double naturalpastureland = improvedpastureland + gettotal_natural_pasture() - (getwillowsnaturalpasture() + getpoplarnaturalpasture() + getprairiesandreednaturalpasture());
						
			int oldasset_olddebt = (int) (min_ratio* assets - (debt - debt_payment));
			if(oldasset_olddebt < 0) {
				oldasset_olddebt = 0;
			}
	
			try {
				// // Create a problem with 61 variables and 41 constraints
				LpSolve solver = LpSolve.makeLp(41, 61);

			
				solver.setInt(51, true); //cowslabour
				solver.setInt(52,true); //cows handling system
				solver.setInt(53, true); //cows machine
				solver.setInt(57, true); // Machine option 0
				solver.setInt(58, true); // Machine option 1
				solver.setInt(59, true); // Size pasture Land
				solver.setInt(60,true); //Size crop land
			
				
				
				solver.strAddConstraint("1 1 1 1 1 1 1 1 1 1 1 1 1 0 1 1 1 0 1 1 1 0 1 1 1 1 1 1 1 0 0 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -640 -640 0", LpSolve.LE, gettotal_acres_farmed());
				
				solver.strAddConstraint("1 1 1 1 1 1 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -640 0", LpSolve.LE, cropland);
								
				solver.strAddConstraint("1 -1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, chemfallow); //Chem Fallow Constraint
								
				solver.strAddConstraint("1 0 1 0 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -384 0", LpSolve.LE, cerealland);
								
				solver.strAddConstraint("0 0 0 1 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -192 0", LpSolve.LE, oilseedland);
				
				solver.strAddConstraint("0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -144 0", LpSolve.LE, maxcanolalimit);
				
				solver.strAddConstraint("0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -144 0", LpSolve.LE, maxflaxlimit);
				
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -64 0", LpSolve.LE, pulseland);
				
				solver.strAddConstraint("0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -384 0", LpSolve.LE, maxfeedwheatlimit);				
				
				solver.strAddConstraint("0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -384 0", LpSolve.LE, maxfeedbarleylimit);
				
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 -500 0 0 0 0", LpSolve.LE, 0); //Machine Operate 0
								
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 -1300 0 0 0", LpSolve.LE, 0); // Machine Operate 1
				
			    solver.strAddConstraint("1 0 1 1 1 1 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -1 -1 0 0 0 0 0", LpSolve.LE, 0);
			   
			    solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 1 1 1 0 1 1 1 0 1 1 1 0 1 1 1 0 1 1 1 0 0 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -640 0 0", LpSolve.LE, naturalpastureland);
				    
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 1 1 0 0 1 1 0 0 1 1 0 0 1 1 0 0 1 1 0 0 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -640 0 0", LpSolve.LE, improvedpastureland);
				    
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 0 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -640 0 0", LpSolve.LE, haylandpastureland);
					
			    solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 -300 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, cow_constraint); // Cows Labour Limit
				
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -1 1 0 0 0 1 0 0 0 0 0 0 0", LpSolve.LE, getn_cows()); // Cows Labour Limit
				
			
				String str = convertDoubleArrayToString(borrowing);
				solver.strAddConstraint(str, LpSolve.LE, this.getcash()); //
				
				String str1 = convertDoubleArrayToString(daratio);
				solver.strAddConstraint(str1, LpSolve.LE, oldasset_olddebt); // Debt-Asset
																				// Ratio
				String str2 = convertDoubleArrayToString(hay_transfer);
				solver.strAddConstraint(str2, LpSolve.LE, 0);
				
				String str3 = convertDoubleArrayToString(barley_transfer);
				solver.strAddConstraint(str3, LpSolve.LE, 0);
				
				String str4 = convertDoubleArrayToString(wheat_transfer);
				solver.strAddConstraint(str4, LpSolve.LE, 0);
				
				String str5 = convertDoubleArrayToString(barley_strawtransfer);
				solver.strAddConstraint(str5, LpSolve.LE, 0);
				
				String str6 = convertDoubleArrayToString(wheat_strawtransfer);
				solver.strAddConstraint(str6, LpSolve.LE, 0);
				
				String str7 = convertDoubleArrayToString(early_pasture_mcals);
				solver.strAddConstraint(str7, LpSolve.LE, 0);
				
				String str8 = convertDoubleArrayToString(late_pasture_mcals);
				solver.strAddConstraint(str8, LpSolve.LE, 0);
				
				String str9 = convertDoubleArrayToString(fall_pasture_mcals);
				solver.strAddConstraint(str9, LpSolve.LE, 0);
				
				String str10 = convertDoubleArrayToString(winter_pasture_mcals);
				solver.strAddConstraint(str10, LpSolve.LE, 0);
				
				String str11 = convertDoubleArrayToString(forage_breaking);
				solver.strAddConstraint(str11, LpSolve.LE, 0);
				
				String str12 = convertDoubleArrayToString(cows_handling_constraint);
				solver.strAddConstraint(str12, LpSolve.LE, cow_constraint);
				
				String str13 = convertDoubleArrayToString(cows_machine_constraint);
				solver.strAddConstraint(str13, LpSolve.LE, cow_mach_constraint);
				
				String str14 = convertDoubleArrayToString(willow_transfer);
				solver.strAddConstraint(str14, LpSolve.LE, 0);
				
				String str15 = convertDoubleArrayToString(poplar_transfer);
				solver.strAddConstraint(str15, LpSolve.LE, 0);
				
				String str16 = convertDoubleArrayToString(maxwheatlimit_constraint);
				solver.strAddConstraint(str16, LpSolve.LE, maxwheatlimit);						
				
				String str17 = convertDoubleArrayToString(maxbarleylimit_constraint);
				solver.strAddConstraint(str17, LpSolve.LE, maxbarleylimit);
				
				String str18 = convertDoubleArrayToString(maxdurumlimit_constraint);
				solver.strAddConstraint(str18, LpSolve.LE, maxdurumlimit);
				
				String str19 = convertDoubleArrayToString(prairie_sandreed_transfer);
				solver.strAddConstraint(str19, LpSolve.LE, 0);						
				
				String str20 = convertDoubleArrayToString(cows_acres_required);
				solver.strAddConstraint(str20, LpSolve.LE, (0));
				
				String str21 = convertDoubleArrayToString(max_feeding_mcals);
				solver.strAddConstraint(str21, LpSolve.LE, 0);
				
				String newStrCon = convertDoubleArrayToString(contribution_margin);
				solver.strSetObjFn(newStrCon);
				
				solver.setMaxim();				
				solver.solve();
				solver.getPtrVariables(); // Store this value to a string
				solver.getObjective(); // Store this value to a string
				
				
				
				expected_income = solver.getObjective();
				if(getexpected_income() == - solver.getInfinite()|| getexpected_income() == solver.getInfinite() || solver.getPtrVariables()[57] == solver.getInfinite() || solver.getPtrVariables()[56] == solver.getInfinite() || solver.getPtrVariables()[58] == solver.getInfinite()
						|| solver.getPtrVariables()[26] == solver.getInfinite()	|| getexpected_income() == 2147483647){
					
					
					
					
					expected_income = 0;
					tillage_fallow = 0;
					wheat_on_fallow = 0;
					durum_stubble = 0;
					canola_stubble = 0;
					barley_stubble = 0;
					wheat_stubble = 0;
					flax_stubble = 0;
					peas_stubble = 0;
					willows_on_natural_pasture = 0;
					willows_on_improved_pasture = 0;
					willows_on_hayland_pasture = 0;
					willows_initial_investment = 0;
					poplar_on_natural_pasture = 0;
					poplar_on_improved_pasture = 0;
					poplar_on_hayland_pasture = 0;
					poplar_initial_investment = 0;
					prairie_sandreed_on_natural_pasture = 0;
					prairie_sandreed_on_improved_pasture = 0;
					prairie_sandreed_on_hayland_pasture = 0;
					prairie_sandreed_initial_investment = 0;
					natural_pasture = 0;
					improved_pasture = 0;
					hayland_pasture = 0;
					rent_out_cropland = 0;
					rent_out_natural_pasture = 0;
					rent_out_improved_pasture = 0;
					rent_out_hayland_pasture = 0;
					pasture_carryover_one = 0;
					pasture_carryover_two = 0;
					improved_bale_first_cut = 0;
					improved_bale_second_cut = 0;
					hay_production_one_cut = 0;
					hay_production_two_cuts = 0;
					breaking_cost = 0;
					buy_hay = 0;
					buy_feed_wheat = 0;
					buy_feed_barley = 0;
					feed_early_summer_hay = 0;
					feed_late_summer_hay = 0;
					feed_fall_hay = 0;
					feed_winter_hay = 0;
					feed_wheat = 0;
					feed_barley = 0;
					wheat_straw = 0;
					barley_straw = 0;					
					sell_hay = 0;
					cows_head = 0;
					cows_labour = 0;   
					cows_fc_handling_system = 0;
					cows_fc_machinery = 0; 
					option_0_acres = 0;
					option_1_acres = 0;
					option_0_number_machines = 0;
					option_1_number_machines = 0;
					rent_pasture_land = 0;
					rent_cropland = 0;
					amount_borrow = 0;

				}
				else {
				double[] var = solver.getPtrVariables(); // This is the crop mix
				for (double d : var) {

				}
				for (int i = 0; i < var.length; i++) {	
					
					wheat_on_fallow = var[0];
					tillage_fallow = var[1];
					durum_stubble = var[2];
					canola_stubble = var[3];
					feed_barley_con = var[4];
					barley_stubble = var[5];
					feed_wheat_con = var[6];
					wheat_stubble = var[7];
					flax_stubble = var[8];
					peas_stubble = var[9];
					willows_on_natural_pasture = var[10];
					willows_on_improved_pasture = var[11];
					willows_on_hayland_pasture = var[12];
					willows_initial_investment = var[13];
					poplar_on_natural_pasture = var[14];
					poplar_on_improved_pasture = var[15];
					poplar_on_hayland_pasture = var[16];
					poplar_initial_investment = var[17];
					prairie_sandreed_on_natural_pasture = var[18];
					prairie_sandreed_on_improved_pasture = var[19];
					prairie_sandreed_on_hayland_pasture = var[20];
					prairie_sandreed_initial_investment = var[21];
					natural_pasture = var[22];
					improved_pasture = var[23];
					hayland_pasture = var[24];
					rent_out_cropland = var[25];
					rent_out_natural_pasture = var[26];
					rent_out_improved_pasture = var[27];
					rent_out_hayland_pasture = var[28];
					pasture_carryover_one = var[29];
					pasture_carryover_two = var[30];
					improved_bale_first_cut = var[31];
					improved_bale_second_cut = var[32];
					hay_production_one_cut = var[33];
					hay_production_two_cuts = var[34];
					breaking_cost = var[35];
					buy_hay = var[36];
					buy_feed_wheat = var[37];
					buy_feed_barley = var[38];
					feed_early_summer_hay = var[39];
					feed_late_summer_hay = var[40];
					feed_fall_hay = var[41];
					feed_winter_hay = var[42];
					feed_wheat = var[43];
					feed_barley = var[44];
					wheat_straw = var[45];
					barley_straw = var[46];					
					sell_hay = var[47];
					invest_cows = var[48];
					cows_head = var[49];
					cows_labour = (int) var[50];   
					cows_fc_handling_system = (int) var[51];
					cows_fc_machinery = (int) var[52]; 
					sell_cull_cows = (int) var[53];
					option_0_acres = (int) var[54];
					option_1_acres = (int) var[55];
					option_0_number_machines = (int) var[56];
					option_1_number_machines = (int) var[57];
					rent_pasture_land = (int) var[58];
					rent_cropland = (int) var[59];
					amount_borrow = (int) var[60];

				}
			}
				int idd = this.getID();
				int farmerID = this.getfarmer_name();
				int run_number = Variables.getrun_number();
				int year = Variables.getyear();
				int tillage_fallow = (int) gettillage_fallow();
				int wheat_on_fallow = (int) getwheat_on_fallow();
				int durum_stubble = (int) getdurum_stubble();
				int canola_stubble = (int) getcanola_stubble();
				int feed_barley_con = (int) getfeed_barley_con();
				int barley_stubble = (int) getbarley_stubble();
				int feed_wheat_con = (int) getfeed_wheat_con();
				int wheat_stubble = (int) getwheat_stubble();
				int flax_stubble = (int) getflax_stubble();
				int peas_stubble = (int) getpeas_stubble();
				int feed_barley_notill = (int) getfeed_barley_notill();
				int barley_notill = (int) getbarley_notill();
				int canola_notill = (int) getcanola_notill();
				int feed_wheat_notill = (int) getfeed_wheat_notill();
				int wheat_notill = (int) getwheat_notill();
				int durum_notill = (int) getdurum_notill();
				int flax_notill = (int) getflax_notill();
				int lentils_notill = (int) getlentils_notill();
				int peas_notill = (int) getpeas_notill();
				int willows_on_natural_pasture = (int) getwillows_on_natural_pasture();
				int willows_on_improved_pasture = (int) getwillows_on_improved_pasture();
				int willows_on_hayland_pasture = (int) getwillows_on_hayland_pasture();
				int willows_initial_investment = (int) getwillows_initial_investment();
				int poplar_on_natural_pasture = (int) getpoplar_on_natural_pasture();
				int poplar_on_improved_pasture = (int) getpoplar_on_improved_pasture();
				int poplar_on_hayland_pasture = (int) getpoplar_on_hayland_pasture();
				int poplarinitial_investment = (int) getpoplar_initial_investment();
				int prairie_sandreed_on_natural_pasture = (int) getprairie_sandreed_on_natural_pasture();
				int prairie_sandreed_on_improved_pasture = (int) getprairie_sandreed_on_improved_pasture();
				int prairie_sandreed_on_hayland_pasture = (int) getprairie_sandreed_on_hayland_pasture();
				int prairiesandreed_initial_investment = (int) getprairie_sandreed_initial_investment();
				int natural_pasture = (int) getnatural_pasture();
				int improved_pasture = (int) getimproved_pasture();
				int hayland_pasture = (int) gethayland_pasture();
				int rent_out_cropland = (int) getrent_out_cropland();
				int rent_out_natural_pasture = (int) getrent_out_natural_pasture();
				int rent_out_improved_pasture = (int) getrent_out_improved_pasture();
				int rent_out_hayland_pasture = (int) getrent_out_hayland_pasture();
				int pasture_carryover_one = (int) getpasture_carryover_one();
				int pasture_carryover_two = (int) getpasture_carryover_two();
				int improved_bale_first_cut = (int) getimproved_bale_first_cut();
				int improved_bale_second_cut = (int) getimproved_bale_second_cut();
				int hay_production_one_cut = (int) gethay_production_one_cut();
				int hay_production_two_cuts = (int) gethay_production_two_cuts();
				int breaking_cost = (int) getbreaking_cost();
				int buy_hay = (int) getbuy_hay();
				int buy_feed_wheat = (int) getbuy_feed_wheat();
				int buy_feed_barley = (int) getbuy_feed_barley();
				int feed_early_summer_hay = (int) getfeed_early_summer_hay();
				int feed_late_summer_hay = (int) getfeed_late_summer_hay();
				int feed_fall_hay = (int) getfeed_fall_hay();
				int feed_winter_hay = (int) getfeed_winter_hay();
				int feed_wheat = (int) getfeed_wheat();
				int feed_barley = (int) getfeed_barley();
				int wheat_straw = (int) getwheat_straw();
				int barley_straw = (int) getbarley_straw();
				int sell_hay = (int) getsell_hay();
				int invest_cows = (int) getinvest_cows();
				int cows_head = (int) getcows_head();
				int cows_labour = (int) getcows_labour();
				int cows_fc_handling_system = (int) getcows_fc_handling_system();
				int cows_fc_machinery = (int) getcows_fc_machinery();
				int sell_cull_cows = (int) getsell_cull_cows();
				int crop_custom_hire = (int) getcrop_custom_hire();
				int option_0_acres = (int) getoption_0_acres();
				int option_1_acres = (int) getoption_1_acres();
				int option_2_acres = (int) getoption_2_acres();
				int option_3_acres = (int) getoption_3_acres();
				int option_4_acres = (int) getoption_4_acres();
				int option_5_acres = (int) getoption_5_acres();
				int option_6_acres = (int) getoption_6_acres();
				int option_7_acres = (int) getoption_7_acres();
				int option_8_acres = (int) getoption_8_acres();
				int option_9_acres = (int) getoption_9_acres();
				int option_0_number_machines = (int) getoption_0_number_machines();
				int option_1_number_machines = (int) getoption_1_number_machines();
				int option_2_number_machines = (int) getoption_2_number_machines();
				int option_3_number_machines = (int) getoption_3_number_machines();
				int option_4_number_machines = (int) getoption_4_number_machines();
				int option_5_number_machines = (int) getoption_5_number_machines();
				int option_6_number_machines = (int) getoption_6_number_machines();
				int option_7_number_machines = (int) getoption_7_number_machines();
				int option_8_number_machines = (int) getoption_8_number_machines();
				int option_9_number_machines = (int) getoption_9_number_machines();
				int rent_pasture_land =   (int) getrent_pasture_land();
				int rent_cropland = (int) getrent_cropland();				
				int amount_borrow = (int) getamount_borrow();
				int expected_income = (int) getexpected_income();
				
				if(expected_income == 2147483647){
					System.out.println("2147483647");
				}

				try {
					Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
				} catch (ClassNotFoundException ce) {
					System.out.println("SQLExceptiong:" + ce.getMessage());
				}
				try {
					Connection conn = DriverManager.getConnection(
							"jdbc:odbc:producerDB", "java", "1234");
					Statement stmt = conn.createStatement();

					stmt.executeUpdate("insert into MIP values ('" 
							+ idd 
							+ "', '" + farmerID 
							+ "', '" + run_number
							+ "','" + year 
							+ "', '" + tillage_fallow 
							+ "', '" + wheat_on_fallow
							+ "', '" + durum_stubble
							+ "', '" + canola_stubble 
							+ "', '" + feed_barley_con
							+ "', '" + barley_stubble
							+ "', '" + feed_wheat_con
							+ "', '" + wheat_stubble 
							+ "', '" + flax_stubble
							+ "', '" + peas_stubble
							+ "', '" + feed_barley_notill
							+ "', '" + barley_notill
							+ "', '" + canola_notill
							+ "', '" + feed_wheat_notill
							+ "', '" + wheat_notill
							+ "', '" + durum_notill
							+ "', '" + flax_notill
							+ "', '" + lentils_notill
							+ "', '" + peas_notill
							+ "', '" + willows_on_natural_pasture
							+ "', '" + willows_on_improved_pasture
							+ "', '" + willows_on_hayland_pasture
							+ "', '" + willows_initial_investment
							+ "', '" + poplar_on_natural_pasture
							+ "', '" + poplar_on_improved_pasture
							+ "', '" + poplar_on_hayland_pasture
							+ "', '" + poplarinitial_investment
							+ "', '" + prairie_sandreed_on_natural_pasture
							+ "', '" + prairie_sandreed_on_improved_pasture
							+ "', '" + prairie_sandreed_on_hayland_pasture
							+ "', '" + prairiesandreed_initial_investment
							+ "', '" + natural_pasture 
							+ "' , '" + improved_pasture
							+ "', '" + hayland_pasture 
							+ "', '" + rent_out_cropland
							+ "', '" + rent_out_natural_pasture
							+ "', '" + rent_out_improved_pasture
							+ "', '" + rent_out_hayland_pasture
							+ "', '"  + pasture_carryover_one 
							+ "', '" + pasture_carryover_two 
							+ "', '"+ improved_bale_first_cut 
							+ "', '" + improved_bale_second_cut 
							+ "', '" + hay_production_one_cut 
							+ "', '" + hay_production_two_cuts 
							+ "', '" + breaking_cost
							+ "', '" + buy_hay
							+ "', '" + buy_feed_wheat 
							+ "', '" + buy_feed_barley 
							+ "', '" + feed_early_summer_hay 
							+ "', '" + feed_late_summer_hay 
							+ "', '" + feed_fall_hay 
							+ "', '" + feed_winter_hay 
							+ "', '" + feed_wheat 
							+ "', '" + feed_barley 
							+ "', '" + wheat_straw
							+ "', '" + barley_straw
							+ "', '" + sell_hay 
							+ "', '" + invest_cows
							+ "', '" + cows_head 
							+ "', '" + cows_labour 
							+ "', '" + cows_fc_handling_system
							+ "', '" + cows_fc_machinery
							+ "', '" + sell_cull_cows
							+ "', '" + crop_custom_hire
							+ "', '" + option_0_acres 
							+ "', '" + option_1_acres
							+ "', '" + option_2_acres 
							+ "', '" + option_3_acres
							+ "', '" + option_4_acres 
							+ "', '" + option_5_acres
							+ "', '" + option_6_acres 
							+ "', '" + option_7_acres
							+ "', '" + option_8_acres 
							+ "', '" + option_9_acres
							+ "', '" + option_0_number_machines 
							+ "', '" + option_1_number_machines 
							+ "', '" + option_2_number_machines 
							+ "', '" + option_3_number_machines 
							+ "', '" + option_4_number_machines 
							+ "', '" + option_5_number_machines 
							+ "', '" + option_6_number_machines 
							+ "', '" + option_7_number_machines 
							+ "', '" + option_8_number_machines 
							+ "', '" + option_9_number_machines 
							+ "', '" + rent_pasture_land 
							+ "', '" + rent_cropland	
							+ "', '" + amount_borrow 
							+ "', '" + expected_income + "')");

					stmt.close();
					conn.close();
				} catch (SQLException ce) {
					ce.printStackTrace();
					System.out.println("HELL 3 SQLException:" + ce.getMessage());
				}
				solver.deleteLp();
			} catch (LpSolveException e) {
				e.printStackTrace();
			}
		}
	}

	public void update_strategic_MIP_notill() {
		if (this.gettotal_crop_acres() > 2000) { 
			sizing_cropland_value = 0;		
			sizing_pastureland_value = 0; 
			expected_income = 0;
			tillage_fallow = 0;
			wheat_on_fallow = 0;
			durum_stubble = 0;
			canola_stubble = 0;
			barley_stubble = 0;
			wheat_stubble = 0;
			flax_stubble = 0;
			peas_stubble = 0;
			willows_on_natural_pasture = 0;
			willows_on_improved_pasture = 0;
			willows_on_hayland_pasture = 0;
			willows_initial_investment = 0;
			poplar_on_natural_pasture = 0;
			poplar_on_improved_pasture = 0;
			poplar_on_hayland_pasture = 0;
			poplar_initial_investment = 0;
			prairie_sandreed_on_natural_pasture = 0;
			prairie_sandreed_on_improved_pasture = 0;
			prairie_sandreed_on_hayland_pasture = 0;
			prairie_sandreed_initial_investment = 0;
			natural_pasture = 0;
			improved_pasture = 0;
			hayland_pasture = 0;
			rent_out_cropland = 0;
			rent_out_natural_pasture = 0;
			rent_out_improved_pasture = 0;
			rent_out_hayland_pasture = 0;
			pasture_carryover_one = 0;
			pasture_carryover_two = 0;
			improved_bale_first_cut = 0;
			improved_bale_second_cut = 0;
			hay_production_one_cut = 0;
			hay_production_two_cuts = 0;
			breaking_cost = 0;
			buy_hay = 0;
			buy_feed_wheat = 0;
			buy_feed_barley = 0;
			feed_early_summer_hay = 0;
			feed_late_summer_hay = 0;
			feed_fall_hay = 0;
			feed_winter_hay = 0;
			feed_wheat = 0;
			feed_barley = 0;
			wheat_straw = 0;
			barley_straw = 0;					
			sell_hay = 0;
			cows_head = 0;
			cows_labour = 0;   
			cows_fc_handling_system = 0;
			cows_fc_machinery = 0; 
			option_0_acres = 0;
			option_1_acres = 0;
			option_0_number_machines = 0;
			option_1_number_machines = 0;
			rent_pasture_land = 0;
			rent_cropland = 0;
			amount_borrow = 0;				
		Parameters p = RunEnvironment.getInstance().getParameters();
		double cereal_mcal_limit = (Double)p.getValue("cereal_mcal_limit");
		double must_sell_min = (Double) p.getValue("must_sell_min");
		double min_ratio = (Double) p.getValue("minRatio");
		double inv_mach_2 = (Double) p.getValue("inv_Mach_2");
		double inv_mach_3 = (Double) p.getValue("inv_Mach_3");
		double inv_mach_4 = (Double) p.getValue("inv_Mach_4");
		double inv_mach_5 = (Double) p.getValue("inv_Mach_5");
		double inv_mach_6 = (Double) p.getValue("inv_Mach_6");
		double inv_mach_7 = (Double) p.getValue("inv_Mach_7");
		double inv_mach_8 = (Double) p.getValue("inv_Mach_8");
		double inv_mach_9 = (Double) p.getValue("inv_Mach_9");
		double rent_crop_land = (Double) p.getValue("rentCropLand");		
		double interest_rate = (Double) p.getValue("discountRate");
		double Per_Acre_VC_Durum = (Double) p.getValue("perAcreVCDurum");
		double Per_Acre_VC_Wheat = (Double) p.getValue("perAcreVCWheat");
		double Per_Acre_VC_Canola = (Double) p.getValue("perAcreVCCanola");
		double Per_Acre_VC_Barley = (Double) p.getValue("perAcreVCBarley");
		double Per_Acre_VC_Flax = (Double) p.getValue("perAcreVCFlax");
	 	double Per_Acre_VC_Peas = (Double) p.getValue("perAcreVCPeas");
	 	double Per_Acre_VC_Lentils = (Double) p.getValue("perAcreVCLentils");	
		double Per_Acre_VC_Willows = (Double) p.getValue("perAcreVCWillows");			
		double Per_Tonne_VC_Durum = (Double) p.getValue("perTonneVCDurum");
		double Per_Tonne_VC_Wheat = (Double) p.getValue("perTonneVCWheat");
		double Per_Tonne_VC_Flax = (Double) p.getValue("perTonneVCFlax");
		double Per_Tonne_VC_Lentils = (Double) p.getValue("perTonneVCLentils");
	 	double Per_Tonne_VC_Peas = (Double) p.getValue("perTonneVCPeas");	
	 	double Per_Tonne_Willow_Custom_Rate = (Double) p.getValue("perTonneWillowCustomRate");			
		double Per_Tonne_VC_Canola = (Double) p.getValue("perTonneVCCanola");
		double Per_Tonne_VC_Barley = (Double) p.getValue("perTonneVCBarley");		
		double Increase_NoTill = (Double) p.getValue("increaseNoTill");
		double Machine_VC_2 = (Double) p.getValue("machineVC2");
		double Machine_VC_3 = (Double) p.getValue("machineVC3");
		double Machine_VC_4 = (Double) p.getValue("machineVC4");
		double Machine_VC_5 = (Double) p.getValue("machineVC5");
		double Machine_VC_6 = (Double) p.getValue("machineVC6");
		double Machine_VC_7 = (Double) p.getValue("machineVC7");
		double Machine_VC_8 = (Double) p.getValue("machineVC8");
		double Machine_VC_9 = (Double) p.getValue("machineVC9");
		double Machine_FC_2 = (Double) p.getValue("machineFC2");
		double Machine_FC_3 = (Double) p.getValue("machineFC3");
		double Machine_FC_4 = (Double) p.getValue("machineFC4");
		double Machine_FC_5 = (Double) p.getValue("machineFC5");
		double Machine_FC_6 = (Double) p.getValue("machineFC6");
		double Machine_FC_7 = (Double) p.getValue("machineFC7");
		double Machine_FC_8 = (Double) p.getValue("machineFC8");
		double Machine_FC_9 = (Double) p.getValue("machineFC9");
		double Per_Acre_VC_NP = (Double) p.getValue("peracrevcnp");
		double Per_Acre_VC_IP = (Double) p.getValue("peracrevcip");
		double Per_Acre_VC_HL = (Double) p.getValue("peracrevchl");
		double Per_Acre_VC_Bale_IP_1 = (Double) p.getValue("peracrevcbaleip1");
		double Per_Acre_VC_Bale_IP_2 = (Double) p.getValue("peracrevcbaleip2");
		double Per_Acre_VC_Hayproduction_1 = (Double) p.getValue("peracrevchayproduction1");
		double Per_Acre_VC_Hayproduction_2 = (Double) p.getValue("peracrevchayproduction2");
		double Per_ton_feed_hay_cost = (Double) p.getValue("pertonfeedhaycost");
		double Per_ton_grain_cost = (Double) p.getValue("pertonfeedgraincost");
		double transaction_fee_hay = (Double) p.getValue("transactionfeehay");
		double VC_Cow = (Double) p.getValue("vccow");
		double FC_Cow_Labour = (Double) p.getValue("fccowlabour");
		double rent_pastureland = (Double) p.getValue("rentpastureland");
		double Per_Acre_Annualized_Breaking = (Double) p.getValue("peracreannualizedbreaking");
		double per_acre_breaking = (Double) p.getValue("peracrebreaking");
		double Per_ton_straw_bale_cost = (Double) p.getValue("pertonstrawbalecost"); 
		double pr_rating = 0;
		double pr_max_hay_yield = (Double)p.getValue("prmaxhayyield");	
		double pr_max_psr_yield = (Double)p.getValue("pr_max_psr_yield");
		double threshold_hay_1 = (Double)p.getValue("thresholdhay1");
		double avg_willow_yield = (Double)p.getValue("willowyield");
		double avg_willow_price = (Double)p.getValue("willowprice");
		double FC_Cow_Handling = (Double) p.getValue("fccowhandling");
		double FC_Cow_Machinery = (Double) p.getValue("fccowmachinery");
		double inv_handling = (Double) p.getValue("invhandling");
		double inv_cow_machine = (Double) p.getValue("invcowmachine");
		int initial_lease_rate = (Integer)p.getValue("initialleaserate");
		int initial_lease_rate_pasture = (Integer)p.getValue("initialleaseratepasture");
		double int_inv_willows = (Double) p.getValue("intinvwillows");
		double annualizedbreakingwillows = (Double) p.getValue("annualizedbreakingwillows");
		double annualizedbreakingpoplar = (Double) p.getValue("annualizedbreakingpoplar");
		double annualizedbreakingprairesandreed = (Double) p.getValue("annualizedbreakingprairiesandreed");
		double Per_Tonne_Poplar_Custom_Rate = (Double) p.getValue("perTonneWillowCustomRate");
		double Per_Tonne_PrairieSandReed_Custom_Rate = (Double) p.getValue("per_Tonne_PrairieSandreed_Custom_Rate");
		double Per_Tonne_VC_Willows = (Double) p.getValue("perTonneVCWillow");
		double Per_Tonne_VC_Poplar =(Double) p.getValue("perTonneVCWillow");
		double int_inv_poplar = (Double) p.getValue("int_inv_poplar");
		double int_inv_prairiesandreed = (Double) p.getValue("int_inv_prairiesandreed");
		double error = 1 + ((int) (Math.random()*10)-5.0)/100.0;			
		double min_prairiesandreed_yield = (Double)p.getValue("min_psr_yield");
		double max_prairiesandreed_yield = (Double)p.getValue("max_psr_yield");
		double poplar_price = 0;
		double prairiesandreed_price = (Double)p.getValue("psr_price");
		double propertytaxescropland = 6;
		double propertytaxespasture = 3;
		double average_count = 0;
		double cereallimit_notill = (Double)p.getValue("cereallimit_notill");
		double oilseedlimit_notill = (Double)p.getValue("oilseedlimit_notill");
		double pulselimit_notill = (Double)p.getValue("pulselimit_notill");
		double maxwheat_limit = (Double)p.getValue("maxwheatlimit");
		double maxbarley_limit = (Double)p.getValue("maxbarleylimit");
		double maxdurum_limit = (Double)p.getValue("maxdurumlimit");
		double maxflax_limit = (Double)p.getValue("maxflaxlimit");
		double maxcanola_limit = (Double)p.getValue("maxcanolalimit");
		double maxpeas_limit = (Double)p.getValue("maxpeaslimit");
		double maxlentils_limit = (Double)p.getValue("maxlentilslimit");
		double lease_man_fee_percent = (Double)p.getValue("lease_man_fee_percent");
		double customhire = (Double)p.getValue("customhire");
		double cull_transaction_cost = (Double)p.getValue("cull_transaction_cost");
		double sell_cows_fee = (Double)p.getValue("sellherdcost");
		double alpha = (Double) p.getValue("alpha");
		double gama = (Double)p.getValue("gama");
		double Per_Tonne_VC_Hay = (Double)p.getValue("perTonneVCHay");
		double psr_gj_tonne = (Double)p.getValue("psrgjtonne");
		double gjprice = (Double)p.getValue("gjprice");
		double No_Buy_Hay = (Double)p.getValue("NoBuyHay");
		yield_mult = 1 + Increase_NoTill;

		Iterator<SAMA> it = mylandList.iterator();
		double tonnes_crop_canola_notill = 0, tonnes_crop_flax_notill = 0, tonnes_crop_peas_notill = 0, tonnes_crop_lentils_notill = 0, tonnes_crop_durum_notill = 0, 
		loc_tonnes_crop_barley_notill = 0, loc_tonnes_crop_wheat_notill = 0;
				
			for (int i = 0; i < getmylandList().size(); i++) {
				SAMA sama = (SAMA) getmylandList().get(i);
										
			tonnes_crop_canola_notill += yield_mult	* sama.getCanolaYieldIndex() * yield_exp_list[0] / 44.09;
			loc_tonnes_crop_barley_notill += yield_mult	* sama.getBarleyYieldIndex() * yield_exp_list[2] / 45.93;
			loc_tonnes_crop_wheat_notill += (yield_mult * sama.getWheatYieldIndex()	* yield_exp_list[1] / 36.74);
			tonnes_crop_durum_notill += yield_mult * sama.getDurumYieldIndex() * yield_exp_list[7]/36.74;
			tonnes_crop_flax_notill += yield_mult * sama.getFlaxYieldIndex() * yield_exp_list[4]/39.37;
			tonnes_crop_lentils_notill += yield_mult * sama.getLentilsYieldIndex() * yield_exp_list[6]/36.74;
			tonnes_crop_peas_notill += yield_mult * sama.getPeasYieldIndex() * yield_exp_list[5]/39.37;
			
			if(sama.getpatchtype() == 1){
			sizing_cropland_value += (Variables.getcrop_exp_lease() * sama.getAvg_prod_patch()/Variables.getmean_patch_quality());
			}
			if(sama.getpatchtype() == 2 || sama.getpatchtype() == 3){
			sizing_pastureland_value += (Variables.getmarginal_exp_lease() * sama.getAvg_prod_patch()/Variables.getmean_patch_quality());
			}	
			
			if(Variables.getunmanaged() > 60){
				sizing_cropland_value = sizing_cropland_value * must_sell_min;
				sizing_pastureland_value = sizing_pastureland_value * must_sell_min;
			}
			
			if(sama.getnpQuality() > pr_max_psr_yield) {
				pr_rating = pr_max_psr_yield;
				prairiesandreed_yield_np = (pr_rating/pr_max_psr_yield * (max_prairiesandreed_yield - min_prairiesandreed_yield) + min_prairiesandreed_yield);
			}
			else {
				pr_rating = sama.getnpQuality();
				prairiesandreed_yield_np = (pr_rating/pr_max_psr_yield * (max_prairiesandreed_yield - min_prairiesandreed_yield) + min_prairiesandreed_yield);
			}
			if(sama.getIPQuality() > pr_max_psr_yield) {
				pr_rating = pr_max_psr_yield;
				prairiesandreed_yield_ip = (pr_rating/pr_max_psr_yield * (max_prairiesandreed_yield - min_prairiesandreed_yield) + min_prairiesandreed_yield);
			}
			else {
				pr_rating = sama.getIPQuality();
				prairiesandreed_yield_ip = (pr_rating/pr_max_psr_yield * (max_prairiesandreed_yield - min_prairiesandreed_yield) + min_prairiesandreed_yield);
			}
			if(sama.getHayQuality() > pr_max_psr_yield) {
				pr_rating = pr_max_psr_yield;
				prairiesandreed_yield_hayland = (pr_rating/pr_max_psr_yield * (max_prairiesandreed_yield - min_prairiesandreed_yield) + min_prairiesandreed_yield);
			}
			else {
				pr_rating = sama.getHayQuality();
				prairiesandreed_yield_hayland = (pr_rating/pr_max_psr_yield * (max_prairiesandreed_yield - min_prairiesandreed_yield) + min_prairiesandreed_yield);
			}
			if(sama.getnpQuality() > pr_max_hay_yield) {
				pr_rating = pr_max_hay_yield;				
				exp_np_early_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3])));
				exp_np_late_yield = (pr_rating / pr_max_hay_yield *  ((yield_exp_list[3] * 0.6)));
				exp_np_fall_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3] * 0.2)));
				exp_mcals_np_early_yield = (exp_np_early_yield * Variables.getmcals_ton_np_early());
				exp_mcals_np_late_yield = (exp_np_late_yield * Variables.getmcals_ton_np_late());
				exp_mcals_np_fall_yield =(exp_np_fall_yield * Variables.getmcals_ton_np_fall());
			}
			else {
				pr_rating = sama.getnpQuality();				
				exp_np_early_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3])));
				exp_np_late_yield = (pr_rating / pr_max_hay_yield *  ((yield_exp_list[3] * 0.6)));
				exp_np_fall_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3] * 0.2)));
				exp_mcals_np_early_yield = (exp_np_early_yield * Variables.getmcals_ton_np_early());
				exp_mcals_np_late_yield = (exp_np_late_yield * Variables.getmcals_ton_np_late());
				exp_mcals_np_fall_yield =(exp_np_fall_yield * Variables.getmcals_ton_np_fall());
			}
			if(sama.getIPQuality() > pr_max_hay_yield) {
				pr_rating = pr_max_hay_yield;				
				exp_ip_early_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3])));
				exp_ip_late_yield = (pr_rating / pr_max_hay_yield *  ((yield_exp_list[3] * 0.6)));
				exp_ip_fall_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3] * 0.2)));
				exp_ip_early_yield_bale_one = (pr_rating / pr_max_hay_yield * yield_exp_list[3]);				
				exp_ip_late_yield_bale_two = (exp_ip_early_yield + (0.6 * exp_ip_early_yield)) ;	
				exp_mcals_ip_early_yield = (exp_ip_early_yield * Variables.getmcals_ton_ip_early());
				exp_mcals_ip_late_yield = (exp_ip_late_yield * Variables.getmcals_ton_ip_late());
				exp_mcals_ip_fall_yield = (exp_ip_fall_yield * Variables.getmcals_ton_ip_fall());
			}
			else {
				pr_rating = sama.getIPQuality();				
				exp_ip_early_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3])));
				exp_ip_late_yield = (pr_rating / pr_max_hay_yield *  ((yield_exp_list[3] * 0.6)));
				exp_ip_fall_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3] * 0.2)));
				exp_ip_early_yield_bale_one = (pr_rating / pr_max_hay_yield * yield_exp_list[3]);				
				exp_ip_late_yield_bale_two = (exp_ip_early_yield + (0.6 * exp_ip_early_yield)) ;	
				exp_mcals_ip_early_yield = (exp_ip_early_yield * Variables.getmcals_ton_ip_early());
				exp_mcals_ip_late_yield = (exp_ip_late_yield * Variables.getmcals_ton_ip_late());
				exp_mcals_ip_fall_yield = (exp_ip_fall_yield * Variables.getmcals_ton_ip_fall());
			}
			if(sama.getHayQuality() > pr_max_hay_yield) {
				pr_rating = pr_max_hay_yield;				
				exp_hay_early_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3])));
				exp_hay_late_yield = (pr_rating / pr_max_hay_yield *  ((yield_exp_list[3] * 0.6)));
				exp_hay_fall_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3] * 0.2)));
				exp_hay_early_yield_bale_one = (pr_rating / pr_max_hay_yield * yield_exp_list[3]);				
				exp_hay_late_yield_bale_two = (exp_hay_early_yield + (0.6 * exp_hay_early_yield)) ;	
				exp_mcals_hayland_early_yield = (exp_hay_early_yield * Variables.getmcals_ton_hayland_early());
				exp_mcals_hayland_late_yield = (exp_hay_late_yield * Variables.getmcals_ton_hayland_late());
				exp_mcals_hayland_fall_yield = (exp_hay_fall_yield * Variables.getmcals_ton_hayland_fall());
			}
			else {
				pr_rating = sama.getHayQuality();				
				exp_hay_early_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3])));
				exp_hay_late_yield = (pr_rating / pr_max_hay_yield *  ((yield_exp_list[3] * 0.6)));
				exp_hay_fall_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3] * 0.2)));
				exp_hay_early_yield_bale_one = (pr_rating / pr_max_hay_yield * yield_exp_list[3]);				
				exp_hay_late_yield_bale_two = (exp_hay_early_yield + (0.6 * exp_hay_early_yield)) ;	
				exp_mcals_hayland_early_yield = (exp_hay_early_yield * Variables.getmcals_ton_hayland_early());
				exp_mcals_hayland_late_yield = (exp_hay_late_yield * Variables.getmcals_ton_hayland_late());
				exp_mcals_hayland_fall_yield = (exp_hay_fall_yield * Variables.getmcals_ton_hayland_fall());
			}
			
			if(gettotal_improved_pasture() + gettotal_hay() > 0) {
				weighted_avg_mcals_bale_one = ((((gettotal_improved_pasture()/(gettotal_improved_pasture() + gettotal_hay()))*Variables.getmcals_ton_ip_baled_one()) + 
						(((gettotal_hay()/(gettotal_improved_pasture() + gettotal_hay()))*Variables.getmcals_ton_hayland_baled_one()))));
				
				weighted_avg_mcals_bale_two = (((weighted_avg_mcals_bale_one) + ((((gettotal_improved_pasture()/(gettotal_improved_pasture() + gettotal_hay()))*Variables.getmcals_ton_ip_baled_two()) + 
						(((gettotal_hay()/(gettotal_improved_pasture() + gettotal_hay()))*Variables.getmcals_ton_hayland_baled_two()))))/2)/2);
				}
				else {
				weighted_avg_mcals_bale_one = ((Variables.getmcals_ton_ip_baled_one() + Variables.getmcals_ton_hayland_baled_one())/2);
					
				weighted_avg_mcals_bale_two = ((((Variables.getmcals_ton_ip_baled_one() + Variables.getmcals_ton_hayland_baled_one())/2) + ((Variables.getmcals_ton_ip_baled_two() + Variables.getmcals_ton_hayland_baled_two())/2))/2);
				}		
			}
			

		tonnes_crop_canola_notill = tonnes_crop_canola_notill/total_plots;
		loc_tonnes_crop_barley_notill = loc_tonnes_crop_barley_notill/total_plots;
		loc_tonnes_crop_wheat_notill = loc_tonnes_crop_wheat_notill/total_plots;
		tonnes_crop_durum_notill = tonnes_crop_durum_notill/total_plots;
		tonnes_crop_flax_notill = tonnes_crop_flax_notill/total_plots;
		tonnes_crop_lentils_notill = tonnes_crop_lentils_notill/total_plots;
		tonnes_crop_peas_notill = tonnes_crop_peas_notill/total_plots;
		
		if(n_cows > 0){
			np_cow_acre = 0.5; //total_natural_pasture/n_cows;
			ip_cow_acre = 1; //total_improved_pasture/n_cows;
			hayland_cow_acre = 2; //total_hay/n_cows;
			
			total_cow_acre = 4; //(total_natural_pasture +  total_improved_pasture + total_hay)/n_cows;
			
			
			}
		
		if(total_cropland_plots > 0) {
		sizing_cropland_value = sizing_cropland_value/total_cropland_plots;
		}
		else {
			sizing_cropland_value = Variables.getcrop_exp_lease();
		}
		if(total_marginal_plots > 0) {
		sizing_pastureland_value = sizing_pastureland_value/total_marginal_plots;
		}
		else {
			sizing_pastureland_value = Variables.getmarginal_exp_lease();
		}
		
		

				
		for (int i = 0; i < getmylandList().size(); i++) {
			SAMA fdl1 = (SAMA) getmylandList().get(i);
			int countgrass = i;
			int countpsr = i;
				if(fdl1.getyears_in_grass() > 0) {
				countgrass++;
							
			average_years_in_grass = average_years_in_grass + fdl1.getyears_in_grass();
				}

		
			
		}
		if(getplots_in_grass() > 0){
			
			average_years_in_grass = average_years_in_grass/getplots_in_grass();
			
		}
						
			if(average_years_in_grass < 7) {
					forage_breaking = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0.5, 1, 0, 0, 0, 0, 0, 0, 0.5, 0.5, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}; 
					//System.out.println("NO SGB yrs in grass" + average_years_in_grass);
			}
			else {
					forage_breaking = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0.5, 1, 0, 0, 0, 0, 0, 0, 0.5, 0.5, 1, 1, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}; 
						//System.out.println("SGB yrs in grass" + average_years_in_grass);
			}
			

			if(average_years_in_prairie_sandreed > 0 && average_years_in_prairie_sandreed < 7){
				prairiesandreed_yield_np = prairiesandreed_yield_np * -1;
				prairiesandreed_yield_ip = prairiesandreed_yield_np * -1;
				prairiesandreed_yield_hayland = prairiesandreed_yield_hayland * -1;
				System.out.println("Negative " + prairiesandreed_yield_np + "Year" + Variables.getyear() + "yrs psr" +average_years_in_prairie_sandreed);
			}
			if(average_years_in_willows > 0 && average_years_in_willows < 21){
				willows_annualized_return_np = willows_annualized_return_np * -1;
				willows_annualized_return_ip = willows_annualized_return_ip * -1;
				willows_annualized_return_hayland = willows_annualized_return_hayland * -1;
			}
			if(average_years_in_poplar > 0 && average_years_in_poplar < 21){
				poplar_annualized_return_np = poplar_annualized_return_np * -1;
				poplar_annualized_return_ip = poplar_annualized_return_ip * -1;
				poplar_annualized_return_hayland = poplar_annualized_return_hayland * -1;
			
			}	
			
			willow_transfer = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			

			poplar_transfer = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			prairie_sandreed_transfer = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
		
			handling_transfer = 1;
			cows_handling_system_limit = 300;
			cows_machine_limit = 300;	
			yield_mult = 1 + Increase_NoTill;
				
			double barley_exp_yield = yield_exp_list[2];
			double wheat_exp_yield = yield_exp_list[1];
			set_parameters();			
			
			
		
			if(getfarmer_type() == 2 || getfarmer_type() == 3){
			contribution_margin = new double[] {
					-((yield_mult * barley_exp_yield) * (farmer_exp_barley_price * 0.6529))
					- ((Per_Acre_VC_Barley)),
					((yield_mult * barley_exp_yield) * farmer_exp_barley_price)
							- ((Per_Acre_VC_Barley + producer_premium_barley_notill) + (Per_Tonne_VC_Barley * loc_tonnes_crop_barley_notill * trucking_distance)),
					((yield_mult * yield_exp_list[0]) * farmer_exp_canola_price)
							- ((Per_Acre_VC_Canola + producer_premium_canola_notill) + (Per_Tonne_VC_Canola * tonnes_crop_canola_notill * trucking_distance)),
					-((yield_mult * wheat_exp_yield) * farmer_exp_wheat_price)
							- ((Per_Acre_VC_Wheat)), 
					((yield_mult * wheat_exp_yield) * farmer_exp_wheat_price)
							- ((Per_Acre_VC_Wheat + producer_premium_wheat_notill) + (Per_Tonne_VC_Wheat * loc_tonnes_crop_wheat_notill * trucking_distance)), 
					((yield_mult * yield_exp_list[7]) * farmer_exp_durum_price)
					        - ((Per_Acre_VC_Durum + producer_premium_durum_notill) + (Per_Tonne_VC_Durum * tonnes_crop_durum_notill * trucking_distance)),
					((yield_mult * yield_exp_list[4]) * farmer_exp_flax_price)
							- ((Per_Acre_VC_Flax + producer_premium_flax_notill) + (Per_Tonne_VC_Flax * tonnes_crop_flax_notill * trucking_distance)),
					((yield_mult * yield_exp_list[5]) * farmer_exp_peas_price)
					        - ((Per_Acre_VC_Peas + producer_premium_peas_notill) + (Per_Tonne_VC_Peas * tonnes_crop_peas_notill * trucking_distance)),
					((yield_mult * yield_exp_list[6]) * farmer_exp_lentils_price)
							- ((Per_Acre_VC_Lentils + producer_premium_lentils_notill) + (Per_Tonne_VC_Lentils * tonnes_crop_lentils_notill * trucking_distance)),
							(willows_annualized_return_np),
							(willows_annualized_return_ip),
							(willows_annualized_return_hayland),
							-(annualizedbreakingwillows),
							(poplar_annualized_return_np),
							(poplar_annualized_return_ip),
							(poplar_annualized_return_hayland),
							-(annualizedbreakingpoplar),
							(prairiesandreed_yield_np * psr_gj_tonne * gjprice) - ((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_np)),
							(prairiesandreed_yield_ip * psr_gj_tonne * gjprice) - ((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_ip)),
							(prairiesandreed_yield_hayland * psr_gj_tonne * gjprice) - ((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_hayland)),
							-(annualizedbreakingprairesandreed),
							-(Per_Acre_VC_NP), -(Per_Acre_VC_IP), -(Per_Acre_VC_HL), 
							(-100), (-100), (-100), (-100),
							0, 0, -(Per_Acre_VC_Bale_IP_1),
							-(Per_Acre_VC_Bale_IP_2), -(Per_Acre_VC_Hayproduction_1), -(Per_Acre_VC_Hayproduction_2), -(Per_Acre_Annualized_Breaking),
							-(farmer_exp_hay_price + transaction_fee_hay + (Per_Tonne_VC_Hay * trucking_distance)*No_Buy_Hay), -(farmer_exp_wheat_price*36.74 + transaction_fee_hay + (Per_Tonne_VC_Wheat * trucking_distance)), -(farmer_exp_barley_price*45.93 + transaction_fee_hay + (Per_Tonne_VC_Barley * trucking_distance)), 
							-(Per_ton_feed_hay_cost), -(Per_ton_feed_hay_cost), -(Per_ton_feed_hay_cost), -(Per_ton_feed_hay_cost), 
							-(Per_ton_grain_cost), -(Per_ton_grain_cost), -(Per_ton_straw_bale_cost), -(Per_ton_straw_bale_cost), (farmer_exp_hay_price -(transaction_fee_hay)), -(crccow),
							((farmer_exp_calf_price*495) - (VC_Cow)), -(FC_Cow_Labour), -(FC_Cow_Handling), -(FC_Cow_Machinery), (crccow - ((crccow * cull_transaction_cost) + sell_cows_fee)), -(customhire),
					-(Machine_VC_2), -(Machine_VC_3), -(Machine_VC_4),
					-(Machine_VC_5), -(Machine_VC_6), -(Machine_VC_7),
					-(Machine_VC_8), -(Machine_VC_9), -(Machine_FC_2),
					-(Machine_FC_3), -(Machine_FC_4), -(Machine_FC_5),
					-(Machine_FC_6), -(Machine_FC_7), -(Machine_FC_8),
					-(Machine_FC_9), -(sizing_pastureland_value * 640), -(sizing_cropland_value * 640), -(interest_rate) };
			}
			else {
				contribution_margin = new double[] {
						-((yield_mult * barley_exp_yield) * farmer_exp_barley_price * 0.6529)
						- ((Per_Acre_VC_Barley)),
						((yield_mult * barley_exp_yield) * farmer_exp_barley_price)
								- ((Per_Acre_VC_Barley + producer_premium_barley_notill) + (Per_Tonne_VC_Barley * loc_tonnes_crop_barley_notill * trucking_distance)),
						((yield_mult * yield_exp_list[0]) * farmer_exp_canola_price)
								- ((Per_Acre_VC_Canola + producer_premium_canola_notill) + (Per_Tonne_VC_Canola * tonnes_crop_canola_notill * trucking_distance)),
						-((yield_mult * wheat_exp_yield) * farmer_exp_wheat_price)
								- ((Per_Acre_VC_Wheat)), 
						((yield_mult * wheat_exp_yield) * farmer_exp_wheat_price)
								- ((Per_Acre_VC_Wheat + producer_premium_wheat_notill) + (Per_Tonne_VC_Wheat * loc_tonnes_crop_wheat_notill * trucking_distance)), 
						((yield_mult * yield_exp_list[7]) * farmer_exp_durum_price)
						        - ((Per_Acre_VC_Durum + producer_premium_durum_notill) + (Per_Tonne_VC_Durum * tonnes_crop_durum_notill * trucking_distance)),
						((yield_mult * yield_exp_list[4]) * farmer_exp_flax_price)
								- ((Per_Acre_VC_Flax + producer_premium_flax_notill) + (Per_Tonne_VC_Flax * tonnes_crop_flax_notill * trucking_distance)),
						((yield_mult * yield_exp_list[5]) * farmer_exp_peas_price)
						        - ((Per_Acre_VC_Peas + producer_premium_peas_notill) + (Per_Tonne_VC_Peas * tonnes_crop_peas_notill * trucking_distance)),
						((yield_mult * yield_exp_list[6]) * farmer_exp_lentils_price)
								- ((Per_Acre_VC_Lentils + producer_premium_lentils_notill) + (Per_Tonne_VC_Lentils * tonnes_crop_lentils_notill * trucking_distance)),
								(willows_annualized_return_np),
								(willows_annualized_return_ip),
								(willows_annualized_return_hayland),
								-(annualizedbreakingwillows),
								(poplar_annualized_return_np),
								(poplar_annualized_return_ip),
								(poplar_annualized_return_hayland),
								-(annualizedbreakingpoplar),
								(prairiesandreed_yield_np * psr_gj_tonne * gjprice) - ((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_np)),
								(prairiesandreed_yield_ip * psr_gj_tonne * gjprice) - ((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_ip)),
								(prairiesandreed_yield_hayland * psr_gj_tonne * gjprice) - ((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_hayland)),
								-(annualizedbreakingprairesandreed),
								-(Per_Acre_VC_NP), -(Per_Acre_VC_IP), -(Per_Acre_VC_HL), 
								(-100), (-100), (-100), (-100),
								0, 0, -(Per_Acre_VC_Bale_IP_1),
								-(Per_Acre_VC_Bale_IP_2), -(Per_Acre_VC_Hayproduction_1), -(Per_Acre_VC_Hayproduction_2), -(Per_Acre_Annualized_Breaking),
								-(farmer_exp_hay_price + transaction_fee_hay + (Per_Tonne_VC_Hay * trucking_distance)*No_Buy_Hay), -(farmer_exp_wheat_price*36.74 + transaction_fee_hay + (Per_Tonne_VC_Wheat * trucking_distance)), -(farmer_exp_barley_price*45.93 + transaction_fee_hay + (Per_Tonne_VC_Barley * trucking_distance)), 
								-(Per_ton_feed_hay_cost), -(Per_ton_feed_hay_cost), -(Per_ton_feed_hay_cost), -(Per_ton_feed_hay_cost), 
								-(Per_ton_grain_cost), -(Per_ton_grain_cost), -(Per_ton_straw_bale_cost), -(Per_ton_straw_bale_cost), (farmer_exp_hay_price -(transaction_fee_hay)), 
								(0), (0), -(FC_Cow_Labour), -(FC_Cow_Handling), -(FC_Cow_Machinery), (0), -(customhire),
						-(Machine_VC_2), -(Machine_VC_3), -(Machine_VC_4),
						-(Machine_VC_5), -(Machine_VC_6), -(Machine_VC_7),
						-(Machine_VC_8), -(Machine_VC_9), -(Machine_FC_2),
						-(Machine_FC_3), -(Machine_FC_4), -(Machine_FC_5),
						-(Machine_FC_6), -(Machine_FC_7), -(Machine_FC_8),
						-(Machine_FC_9), -(sizing_pastureland_value * 640), -(sizing_cropland_value * 640), -(interest_rate)
						 };
			}
			borrowing = new double[] {
					Per_Acre_VC_Barley,
					Per_Acre_VC_Barley + producer_premium_barley_notill
							+ (Per_Tonne_VC_Barley * loc_tonnes_crop_barley_notill * trucking_distance),
					Per_Acre_VC_Canola + producer_premium_canola_notill
							+ (Per_Tonne_VC_Canola * tonnes_crop_canola_notill * trucking_distance),
					Per_Acre_VC_Wheat,		
					Per_Acre_VC_Wheat + producer_premium_wheat_notill
							+ (Per_Tonne_VC_Wheat * loc_tonnes_crop_wheat_notill * trucking_distance),
					Per_Acre_VC_Durum + producer_premium_durum_notill
							+ (Per_Tonne_VC_Durum * tonnes_crop_durum_notill * trucking_distance),
					Per_Acre_VC_Flax + producer_premium_flax_notill
							+ (Per_Tonne_VC_Flax * tonnes_crop_flax_notill * trucking_distance),
					Per_Acre_VC_Peas + producer_premium_peas_notill
							+ (Per_Tonne_VC_Peas * tonnes_crop_peas_notill * trucking_distance),
					Per_Acre_VC_Lentils + producer_premium_lentils_notill
							+ (Per_Tonne_VC_Lentils * tonnes_crop_lentils_notill * trucking_distance),
							(willows_annualized_cost_np), (willows_annualized_cost_ip), (willows_annualized_cost_hayland), (int_inv_willows), 
							(poplar_annualized_cost_np), (poplar_annualized_cost_ip), 
							(poplar_annualized_cost_hayland), (int_inv_poplar), 
							((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_np)), ((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_ip)), 
							((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_hayland)), (int_inv_prairiesandreed), 			
							(Per_Acre_VC_NP), (Per_Acre_VC_IP), (Per_Acre_VC_HL), propertytaxescropland, propertytaxespasture + (sizing_pastureland_value * 0.5 * lease_man_fee_percent), propertytaxespasture + (sizing_pastureland_value * 0.75 * lease_man_fee_percent), 
							propertytaxespasture + (sizing_pastureland_value * lease_man_fee_percent), 0, 0, (Per_Acre_VC_Bale_IP_1), (Per_Acre_VC_Bale_IP_2), (Per_Acre_VC_Hayproduction_1),
							(Per_Acre_VC_Hayproduction_2), (per_acre_breaking),  (farmer_exp_hay_price + transaction_fee_hay + (Per_Tonne_VC_Hay * trucking_distance)*No_Buy_Hay), (farmer_exp_wheat_price*36.74 + transaction_fee_hay + (Per_Tonne_VC_Wheat * trucking_distance)), (farmer_exp_barley_price*45.93 + transaction_fee_hay + (Per_Tonne_VC_Barley * trucking_distance)), 
							(Per_ton_feed_hay_cost), (Per_ton_feed_hay_cost), (Per_ton_feed_hay_cost), (Per_ton_feed_hay_cost), 
							(Per_ton_grain_cost), (Per_ton_grain_cost), (Per_ton_straw_bale_cost), (Per_ton_straw_bale_cost), (transaction_fee_hay), 
							(NewCostCow), (VC_Cow), (FC_Cow_Labour), (inv_handling), (inv_cow_machine), ((farmer_exp_cull_price * cull_transaction_cost) + sell_cows_fee), customhire,			
					Machine_VC_2, Machine_VC_3, Machine_VC_4, Machine_VC_5,
					Machine_VC_6, Machine_VC_7, Machine_VC_8, Machine_VC_9,
					inv_mach_2, inv_mach_3, inv_mach_4, inv_mach_5, inv_mach_6,
					inv_mach_7, inv_mach_8, inv_mach_9, (sizing_pastureland_value * 640), (sizing_cropland_value * 640), 
					-1 };
			
			daratio = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(int_inv_willows * min_ratio), 0, 0, 0, -(int_inv_poplar * min_ratio), 0, 0, 0, -(int_inv_prairiesandreed * min_ratio), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(per_acre_breaking * min_ratio), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(NewCostCow * min_ratio), 0, 0, -(inv_handling * min_ratio), -(inv_cow_machine * min_ratio), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(inv_mach_2 * min_ratio), -(inv_mach_3 * min_ratio), -(inv_mach_4 * min_ratio), -(inv_mach_5 * min_ratio), -(inv_mach_6 * min_ratio), -(inv_mach_7 * min_ratio), -(inv_mach_8 * min_ratio), -(inv_mach_9 * min_ratio), -(sizing_pastureland_value * 640 * min_ratio), -(sizing_cropland_value * 640 * min_ratio), 1};
									
			hay_transfer = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(exp_ip_early_yield_bale_one*error), -(exp_ip_late_yield_bale_two*error), -(exp_hay_early_yield_bale_one*error), -(exp_hay_late_yield_bale_two*error), 0, -1, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			barley_transfer = new double[] {-(barley_exp_yield/45.93), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			wheat_transfer = new double[] {0, 0, 0, -(wheat_exp_yield/36.74), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			barley_strawtransfer = new double[] {-(barley_exp_yield/45.93), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			wheat_strawtransfer = new double[] {0, 0, 0, -(wheat_exp_yield/36.74), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			early_pasture_mcals = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(exp_mcals_np_early_yield), -(exp_mcals_ip_early_yield), -(exp_mcals_hayland_early_yield), 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(weighted_avg_mcals_bale_one), 0, 0, 0, 0, 0, 0, 0, 0, 0, (Variables.getmcals_required_early_summer()), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			late_pasture_mcals = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(exp_mcals_np_late_yield), -(exp_mcals_np_late_yield), -(exp_mcals_hayland_late_yield), 0, 0, 0, 0, -0.5, 1, -(Variables.getmcals_ton_ip_baled_one()), 0, -(Variables.getmcals_ton_hayland_baled_one()), 0, 0, 0, 0, 0, 0, -(weighted_avg_mcals_bale_one), 0, 0, 0, 0, 0, 0, 0, 0, (Variables.getmcals_required_late_summer()), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			fall_pasture_mcals = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(exp_mcals_np_fall_yield), -(exp_mcals_ip_fall_yield), -(exp_mcals_hayland_fall_yield), 0, 0, 0, 0, 0, -0.5, -(Variables.getmcals_ton_ip_baled_two()), -(Variables.getmcals_ton_ip_baled_two()), -(Variables.getmcals_ton_hayland_baled_two()), -(Variables.getmcals_ton_hayland_baled_two()), 0, 0, 0, 0, 0, 0, -(weighted_avg_mcals_bale_two), 0, 0, 0, 0, 0, 0, 0, (Variables.getmcals_required_fall()), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};	
			
			winter_pasture_mcals = new double[] {-3394, 0, 0, -3724, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(weighted_avg_mcals_bale_two), -3724, -3394, -664, -823, 0, 0, (Variables.getmcals_required_winter()), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			max_feeding_mcals = new double[] {-((1-alpha)*3394), 0, 0, -((1-alpha)*3724), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(alpha*weighted_avg_mcals_bale_two), ((1-alpha)*3724), ((1-alpha)*3394), -((1-alpha)*664), -((1-alpha)*823), 0, 0, (Variables.getmcals_required_winter()), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
						
			cows_handling_constraint = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (handling_transfer), 0, -(cows_handling_system_limit), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			cows_machine_constraint = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (handling_transfer), 0, 0, -(cows_machine_limit), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			cows_acres_required = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(np_cow_acre), -(ip_cow_acre), -(hayland_cow_acre), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (total_cow_acre), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -640, 0, 0};
			
			
			double maxwheatlimit = 0;
			double maxbarleylimit = 0;
			double maxdurumlimit = 0;
			
			double cropland = this.gettotal_crop_acres();
			double cerealland = Math.round(cereallimit_notill * cropland);
			if(getfarmer_type() == 2 || getfarmer_type() == 3){
				maxwheatlimit = Math.round(0.025 * cerealland * maxwheat_limit);
				maxbarleylimit = Math.round(0.025 * cerealland * maxbarley_limit);
				maxdurumlimit = Math.round(0.00 * cerealland * maxdurum_limit);
				
				maxwheatlimit_constraint = new double[] {0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(640 * cereallimit_notill * maxwheat_limit * 0.025), 0};
				maxbarleylimit_constraint = new double[] {0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(640 * cereallimit_notill * maxbarley_limit * 0.025), 0};
				maxdurumlimit_constraint = new double[] {0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(640 * cereallimit_notill * maxdurum_limit * 0.0), 0};
			}
				else{
					maxwheatlimit = Math.round(maxwheat_limit * cerealland);
					maxbarleylimit = Math.round(maxbarley_limit * cerealland);
					maxdurumlimit = Math.round(maxdurum_limit * cerealland);
					
					maxwheatlimit_constraint = new double[] {0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(640 * cereallimit_notill * maxwheat_limit), 0};
					maxbarleylimit_constraint = new double[] {0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(640 * cereallimit_notill * maxbarley_limit), 0};
					maxdurumlimit_constraint = new double[] {0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(640 * cereallimit_notill * maxdurum_limit), 0};
				}
							
			double oilseedland = Math.round(oilseedlimit_notill * cropland);
			double maxflaxlimit = Math.round(maxflax_limit * oilseedland);
			double maxcanolalimit = Math.round(maxcanola_limit * oilseedland);
			double pulseland = Math.round(pulselimit_notill * cropland);
			double maxpeaslimit = Math.round(maxpeas_limit * pulseland);
			double maxlentilslimit = Math.round(maxlentils_limit * pulseland);
			double cow_constraint = 300; //getn_cows();
			double cow_mach_constraint = 300;
			double customhirelimit = (Double)p.getValue("option0Limit");
			double SizeLandNP = 0;
			double SizeLandIP = 0;
			double SizeLandHP = 0;
			double maxfeedwheatlimit = cerealland;
			double maxfeedbarleylimit = cerealland;
			
			double haylandpastureland = gettotal_hay() - (getwillowshaylandpasture() + getpoplarhaylandpasture() + getprairiesandreedhaylandpasture());
			
			double improvedpastureland = haylandpastureland + gettotal_improved_pasture() - (getwillowsimprovedpasture() + getpoplarimprovedpasture() + getprairiesandreedimprovedpasture());
			
			double naturalpastureland = improvedpastureland + gettotal_natural_pasture() - (getwillowsnaturalpasture() + getpoplarnaturalpasture() + getprairiesandreednaturalpasture());
						
			if(naturalpastureland > 0){
			SizeLandNP = (naturalpastureland/naturalpastureland) * 640;
			SizeLandIP = (improvedpastureland/naturalpastureland) * 640;
			SizeLandHP = (haylandpastureland/naturalpastureland) * 640;
			}
			else{
				SizeLandNP = (640/640) * 640;
				SizeLandIP = (improvedpastureland/640) * 640;
				SizeLandHP = (haylandpastureland/640) * 640;	
			}
			
			
			int oldasset_olddebt = (int) (min_ratio* assets - (debt - debt_payment));
			if(oldasset_olddebt < 0) {
				oldasset_olddebt = 0;
			}
			
			
		
			try {
				LpSolve solver = LpSolve.makeLp(48, 73);
				
				
				solver.setInt(50, true); // Cows Labour
				solver.setInt(51, true); //cows fc handling
				solver.setInt(52, true); //cows fc machinery
				solver.setInt(63, true); // Machine option 2
				solver.setInt(64, true); // Machine option 3
				solver.setInt(65, true); // Machine option 4
				solver.setInt(66, true); // Machine option 5
				solver.setInt(67, true); // Machine option 6
				solver.setInt(68, true); // Machine option 7
				solver.setInt(69, true); // Machine option 8
				solver.setInt(70, true); // Machine option 9
				solver.setInt(71, true); // Rent PastureLand
				solver.setInt(72, true); // Rent Crop Land
				
				// add constraints
				solver.strAddConstraint("1 1 1 1 1 1 1 1 1 1 1 1 0 1 1 1 0 1 1 1 0 1 1 1 1 1 1 1 0 0 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -640 -640 0", LpSolve.LE, gettotal_acres_farmed());
								
				solver.strAddConstraint("1 1 1 1 1 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -640 0", LpSolve.LE, cropland); // Crop land (acres)
								
				solver.strAddConstraint("1 1 0 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -352 0", LpSolve.LE, cerealland); // Cereal (wheat, durum, and Barley)
				
				solver.strAddConstraint("0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -352 0", LpSolve.LE, maxfeedwheatlimit); // Max Acres a farme can seed spring wheat
							
				solver.strAddConstraint("1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -352 0", LpSolve.LE, maxfeedbarleylimit);
									
				solver.strAddConstraint("0 0 1 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -211 0", LpSolve.LE, oilseedland);
								
				solver.strAddConstraint("0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -158 0", LpSolve.LE, maxcanolalimit);
								
				solver.strAddConstraint("0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -158 0", LpSolve.LE, maxflaxlimit);
								
				solver.strAddConstraint("0 0 0 0 0 0 0 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -77 0", LpSolve.LE, pulseland);
								
				solver.strAddConstraint("0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -54 0", LpSolve.LE, maxpeaslimit);
								
				solver.strAddConstraint("0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -23 0", LpSolve.LE, maxlentilslimit);
							
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, customhirelimit); // Custom Hire
				
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 -2000 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, 0); // Machine operate 2
								
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 -3200 0 0 0 0 0 0 0 0 0", LpSolve.LE, 0); // Machine operate 3
								
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 -4300 0 0 0 0 0 0 0 0", LpSolve.LE, 0); // Machine operate 4
								
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 -9000 0 0 0 0 0 0 0", LpSolve.LE, 0); // Machine operate 5
							
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 -12300 0 0 0 0 0 0", LpSolve.LE, 0); // Machine operate 6
								
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 -18000 0 0 0 0 0", LpSolve.LE, 0); // Machine operate 7
							
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 -23500 0 0 0 0", LpSolve.LE, 0); // Machine operate 8
								
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 -28000 0 0 0", LpSolve.LE, 0); // Machine operate 9
								
				solver.strAddConstraint("1 1 1 1 1 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -1 -1 -1 -1 -1 -1 -1 -1 -1 0 0 0 0 0 0 0 0 0 0 0",LpSolve.LE, 0); // Machine acres required no-till farmer
								
				
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 1 1 1 0 1 1 1 0 1 1 1 0 1 1 1 0 1 1 1 0 0 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -640 0 0", LpSolve.LE, naturalpastureland);
					
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 1 1 0 0 1 1 0 0 1 1 0 0 1 1 0 0 1 1 0 0 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -640 0 0", LpSolve.LE, improvedpastureland);
								
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 0 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -640 0 0", LpSolve.LE, haylandpastureland);
						
				
				
				
				
				
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 -300 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, cow_constraint); //Cows Labour Limit
					
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -1 1 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, getn_cows()); //Cows Labour Limit
				

				String str = convertDoubleArrayToString(borrowing);
				solver.strAddConstraint(str, LpSolve.LE, this.getcash()); //
				
				String str1 = convertDoubleArrayToString(daratio);
				solver.strAddConstraint(str1, LpSolve.LE, oldasset_olddebt); // Debt-Asset
												
				String str2 = convertDoubleArrayToString(hay_transfer);
				solver.strAddConstraint(str2, LpSolve.LE, 0);
								
				String str3 = convertDoubleArrayToString(barley_transfer);
				solver.strAddConstraint(str3, LpSolve.LE, 0);
								
				String str4 = convertDoubleArrayToString(wheat_transfer);
				solver.strAddConstraint(str4, LpSolve.LE, 0);
				
				String str5 = convertDoubleArrayToString(barley_strawtransfer);
				solver.strAddConstraint(str5, LpSolve.LE, 0);
								
				String str6 = convertDoubleArrayToString(wheat_strawtransfer);
				solver.strAddConstraint(str6, LpSolve.LE, 0);
				
				String str7 = convertDoubleArrayToString(early_pasture_mcals);
				solver.strAddConstraint(str7, LpSolve.LE, 0);
								
				String str8 = convertDoubleArrayToString(late_pasture_mcals);
				solver.strAddConstraint(str8, LpSolve.LE, 0);
								
				String str9 = convertDoubleArrayToString(fall_pasture_mcals);
				solver.strAddConstraint(str9, LpSolve.LE, 0);
								
				String str10 = convertDoubleArrayToString(winter_pasture_mcals);
				solver.strAddConstraint(str10, LpSolve.LE, 0);
								
				String str11 = convertDoubleArrayToString(forage_breaking);
				solver.strAddConstraint(str11, LpSolve.LE, 0);
								
				String str12 = convertDoubleArrayToString(cows_handling_constraint);
				solver.strAddConstraint(str12, LpSolve.LE, cow_constraint);
								
				String str13 = convertDoubleArrayToString(cows_machine_constraint);
				solver.strAddConstraint(str13, LpSolve.LE, cow_mach_constraint);
				
				String str14 = convertDoubleArrayToString(willow_transfer);
				solver.strAddConstraint(str14, LpSolve.LE, 0);
				
				String str15 = convertDoubleArrayToString(poplar_transfer);
				solver.strAddConstraint(str15, LpSolve.LE, 0);
				
				String str16 = convertDoubleArrayToString(prairie_sandreed_transfer);
				solver.strAddConstraint(str16, LpSolve.LE, 0);
				
				String str17 = convertDoubleArrayToString(maxwheatlimit_constraint);
				solver.strAddConstraint(str17, LpSolve.LE, maxwheatlimit);						
				
				String str18 = convertDoubleArrayToString(maxbarleylimit_constraint);
				solver.strAddConstraint(str18, LpSolve.LE, maxbarleylimit);
				
				String str19 = convertDoubleArrayToString(maxdurumlimit_constraint);
				solver.strAddConstraint(str19, LpSolve.LE, maxdurumlimit);
				
				String str20 = convertDoubleArrayToString(cows_acres_required);
				solver.strAddConstraint(str20, LpSolve.LE, (0));
				
				String str21 = convertDoubleArrayToString(max_feeding_mcals);
				solver.strAddConstraint(str21, LpSolve.LE, 0);
							
				String newStrCon = convertDoubleArrayToString(contribution_margin);

				solver.strSetObjFn(newStrCon);
				solver.setMaxim();				
				solver.solve();
				solver.getPtrVariables(); // Store this value to a string
				solver.getObjective(); // Store this value to a string
				
				
				
				expected_income = solver.getObjective();
				if(getexpected_income() == - solver.getInfinite() || getexpected_income() == solver.getInfinite() || solver.getPtrVariables()[68] == solver.getInfinite() || solver.getPtrVariables()[69] == solver.getInfinite() || solver.getPtrVariables()[67] == solver.getInfinite() ) {
					expected_income = 0;
					barley_notill = 0;
					canola_notill = 0;
					wheat_notill = 0;
					durum_notill = 0;
					flax_notill = 0;
					peas_notill = 0;
					lentils_notill = 0;
					willows_on_natural_pasture = 0;
					willows_on_improved_pasture = 0;
					willows_on_hayland_pasture = 0;
					willows_initial_investment = 0;
					poplar_on_natural_pasture = 0;
					poplar_on_improved_pasture = 0;
					poplar_on_hayland_pasture = 0;
					poplar_initial_investment = 0;
					prairie_sandreed_on_natural_pasture = 0;
					prairie_sandreed_on_improved_pasture = 0;
					prairie_sandreed_on_hayland_pasture = 0;
					prairie_sandreed_initial_investment = 0;					
					natural_pasture = 0;
					improved_pasture = 0;
					hayland_pasture = 0;
					rent_out_cropland = 0;
					rent_out_natural_pasture = 0;
					rent_out_improved_pasture = 0;
					rent_out_hayland_pasture = 0;					
					pasture_carryover_one = 0;
					pasture_carryover_two = 0;
					improved_bale_first_cut = 0;
					improved_bale_second_cut = 0;
					hay_production_one_cut = 0;
					hay_production_two_cuts = 0;
					breaking_cost = 0;
					buy_hay = 0;
					buy_feed_wheat = 0;
					buy_feed_barley = 0;
					feed_early_summer_hay = 0;
					feed_late_summer_hay = 0;
					feed_fall_hay = 0;
					feed_winter_hay = 0;
					feed_wheat = 0;
					feed_barley = 0;
					wheat_straw = 0;
					barley_straw = 0;
					sell_hay = 0;
					cows_head = 0;
					cows_labour = 0;	
					cows_fc_handling_system = 0;
					cows_fc_machinery = 0; 
					option_2_acres = 0;
					option_3_acres = 0;
					option_4_acres = 0;
					option_5_acres = 0;
					option_6_acres = 0;
					option_7_acres = 0;
					option_8_acres = 0;
					option_9_acres = 0;
					option_2_number_machines = 0;
					option_3_number_machines = 0;
					option_4_number_machines = 0;
					option_5_number_machines = 0;
					option_6_number_machines = 0;
					option_7_number_machines = 0;
					option_8_number_machines = 0;
					option_9_number_machines = 0;
					rent_pasture_land = 0;
					rent_cropland = 0;
					amount_borrow = 0;
				}
			 else {
				double[] var = solver.getPtrVariables(); // This is the crop mix
				for (double d : var) {

				}
				for (int i = 0; i < var.length; i++) {
					feed_barley_notill = var[0];
					barley_notill = var[1];
					canola_notill = var[2];
					feed_wheat_notill = var[3];
					wheat_notill = var[4];					
					durum_notill = var[5];
					flax_notill = var[6];
					peas_notill = var[7];
					lentils_notill = var[8];
					willows_on_natural_pasture = var[9];
					willows_on_improved_pasture = var[10];
					willows_on_hayland_pasture = var[11];
					willows_initial_investment = var[12];
					poplar_on_natural_pasture = var[13];
					poplar_on_improved_pasture = var[14];
					poplar_on_hayland_pasture = var[15];
					poplar_initial_investment = var[16];
					prairie_sandreed_on_natural_pasture = var[17];
					prairie_sandreed_on_improved_pasture = var[18];
					prairie_sandreed_on_hayland_pasture = var[19];
					prairie_sandreed_initial_investment = var[20];		
					natural_pasture = var[21];
					improved_pasture = var[22];
					hayland_pasture = var[23];
					rent_out_cropland = var[24];
					rent_out_natural_pasture = var[25];
					rent_out_improved_pasture = var[26];
					rent_out_hayland_pasture = var[27];
					pasture_carryover_one = var[28];
					pasture_carryover_two = var[29];
					improved_bale_first_cut = var[30];
					improved_bale_second_cut = var[31];
					hay_production_one_cut = var[32];
					hay_production_two_cuts = var[33];
					breaking_cost = var[34];
					buy_hay = var[35];
					buy_feed_wheat = var[36];
					buy_feed_barley = var[37];
					feed_early_summer_hay = var[38];
					feed_late_summer_hay = var[39];
					feed_fall_hay = var[40];
					feed_winter_hay = var[41];
					feed_wheat = var[42];
					feed_barley = var[43];
					wheat_straw = var[44];
					barley_straw = var[45];
					sell_hay = var[46];
					invest_cows = var[47];
					cows_head = (int) var[48];
					cows_labour = (int) var[49];	
					cows_fc_handling_system = (int) var[50];
					cows_fc_machinery = (int) var[51];
					sell_cull_cows = (int) var[52];
					crop_custom_hire = (int) var[53];
					option_2_acres = (int) var[54];
					option_3_acres = (int) var[55];
					option_4_acres = (int) var[56];
					option_5_acres = (int) var[57];
					option_6_acres = (int) var[58];
					option_7_acres = (int) var[59];
					option_8_acres = (int) var[60];
					option_9_acres = (int) var[61];
					option_2_number_machines = (int) var[62];
					option_3_number_machines = (int) var[63];
					option_4_number_machines = (int) var[64];
					option_5_number_machines = (int) var[65];
					option_6_number_machines = (int) var[66];
					option_7_number_machines = (int) var[67];
					option_8_number_machines = (int) var[68];
					option_9_number_machines = (int) var[69];
					rent_pasture_land = (int) var[70];
					rent_cropland = (int) var[71];
					amount_borrow = (int) var[72];

				}
			}
				int idd = this.getID();
				int farmerID = this.getfarmer_name();
				int run_number = Variables.getrun_number();
				int year = Variables.getyear();
				int tillage_fallow = (int) gettillage_fallow();
				int wheat_on_fallow = (int) getwheat_on_fallow();
				int durum_stubble = (int) getdurum_stubble();
				int canola_stubble = (int) getcanola_stubble();
				int feed_barley_con = (int) getfeed_barley_con();
				int barley_stubble = (int) getbarley_stubble();
				int feed_wheat_con = (int) getfeed_wheat_con();
				int wheat_stubble = (int) getwheat_stubble();
				int flax_stubble = (int) getflax_stubble();
				int peas_stubble = (int) getpeas_stubble();
				int feed_barley_notill = (int) getfeed_barley_notill();
				int barley_notill = (int) getbarley_notill();
				int canola_notill = (int) getcanola_notill();
				int feed_wheat_notill = (int) getfeed_wheat_notill();
				int wheat_notill = (int) getwheat_notill();
				int durum_notill = (int) getdurum_notill();
				int flax_notill = (int) getflax_notill();
				int lentils_notill = (int) getlentils_notill();
				int peas_notill = (int) getpeas_notill();
				int willows_on_natural_pasture = (int) getwillows_on_natural_pasture();
				int willows_on_improved_pasture = (int) getwillows_on_improved_pasture();
				int willows_on_hayland_pasture = (int) getwillows_on_hayland_pasture();
				int willows_initial_investment = (int) getwillows_initial_investment();
				int poplar_on_natural_pasture = (int) getpoplar_on_natural_pasture();
				int poplar_on_improved_pasture = (int) getpoplar_on_improved_pasture();
				int poplar_on_hayland_pasture = (int) getpoplar_on_hayland_pasture();
				int poplarinitial_investment = (int) getpoplar_initial_investment();
				int prairie_sandreed_on_natural_pasture = (int) getprairie_sandreed_on_natural_pasture();
				int prairie_sandreed_on_improved_pasture = (int) getprairie_sandreed_on_improved_pasture();
				int prairie_sandreed_on_hayland_pasture = (int) getprairie_sandreed_on_hayland_pasture();
				int prairiesandreed_initial_investment = (int) getprairie_sandreed_initial_investment();
				int natural_pasture = (int) getnatural_pasture();
				int improved_pasture = (int) getimproved_pasture();
				int hayland_pasture = (int) gethayland_pasture();
				int rent_out_cropland = (int) getrent_out_cropland();
				int rent_out_natural_pasture = (int) getrent_out_natural_pasture();
				int rent_out_improved_pasture = (int) getrent_out_improved_pasture();
				int rent_out_hayland_pasture = (int) getrent_out_hayland_pasture();
				int pasture_carryover_one = (int) getpasture_carryover_one();
				int pasture_carryover_two = (int) getpasture_carryover_two();
				int improved_bale_first_cut = (int) getimproved_bale_first_cut();
				int improved_bale_second_cut = (int) getimproved_bale_second_cut();
				int hay_production_one_cut = (int) gethay_production_one_cut();
				int hay_production_two_cuts = (int) gethay_production_two_cuts();
				int breaking_cost = (int) getbreaking_cost();
				int buy_hay = (int) getbuy_hay();
				int buy_feed_wheat = (int) getbuy_feed_wheat();
				int buy_feed_barley = (int) getbuy_feed_barley();
				int feed_early_summer_hay = (int) getfeed_early_summer_hay();
				int feed_late_summer_hay = (int) getfeed_late_summer_hay();
				int feed_fall_hay = (int) getfeed_fall_hay();
				int feed_winter_hay = (int) getfeed_winter_hay();
				int feed_wheat = (int) getfeed_wheat();
				int feed_barley = (int) getfeed_barley();
				int wheat_straw = (int) getwheat_straw();
				int barley_straw = (int) getbarley_straw();
				int sell_hay = (int) getsell_hay();
				int invest_cows = (int) getinvest_cows();
				int cows_head = (int) getcows_head();
				int cows_labour = (int) getcows_labour();
				int cows_fc_handling_system = (int) getcows_fc_handling_system();
				int cows_fc_machinery = (int) getcows_fc_machinery();
				int sell_cull_cows = (int) getsell_cull_cows();
				int crop_custom_hire = (int) getcrop_custom_hire();
				int option_0_acres = (int) getoption_0_acres();
				int option_1_acres = (int) getoption_1_acres();
				int option_2_acres = (int) getoption_2_acres();
				int option_3_acres = (int) getoption_3_acres();
				int option_4_acres = (int) getoption_4_acres();
				int option_5_acres = (int) getoption_5_acres();
				int option_6_acres = (int) getoption_6_acres();
				int option_7_acres = (int) getoption_7_acres();
				int option_8_acres = (int) getoption_8_acres();
				int option_9_acres = (int) getoption_9_acres();
				int option_0_number_machines = (int) getoption_0_number_machines();
				int option_1_number_machines = (int) getoption_1_number_machines();
				int option_2_number_machines = (int) getoption_2_number_machines();
				int option_3_number_machines = (int) getoption_3_number_machines();
				int option_4_number_machines = (int) getoption_4_number_machines();
				int option_5_number_machines = (int) getoption_5_number_machines();
				int option_6_number_machines = (int) getoption_6_number_machines();
				int option_7_number_machines = (int) getoption_7_number_machines();
				int option_8_number_machines = (int) getoption_8_number_machines();
				int option_9_number_machines = (int) getoption_9_number_machines();
				int rent_pasture_land =   (int) getrent_pasture_land();
				int rent_cropland = (int) getrent_cropland();				
				int amount_borrow = (int) getamount_borrow();
				int expected_income = (int) getexpected_income();
				
				try {
					Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
				} catch (ClassNotFoundException ce) {
					System.out.println("SQLExceptiong:" + ce.getMessage());
				}
				try {
					Connection conn = DriverManager.getConnection(
							"jdbc:odbc:producerDB", "java", "1234");
					Statement stmt = conn.createStatement();

					stmt.executeUpdate("insert into MIP values ('" 
							+ idd 
							+ "', '" + farmerID 
							+ "', '" + run_number
							+ "','" + year 
							+ "', '" + tillage_fallow 
							+ "', '" + wheat_on_fallow
							+ "', '" + durum_stubble
							+ "', '" + canola_stubble 
							+ "', '" + feed_barley_con
 							+ "', '" + barley_stubble
 							+ "', '" + feed_wheat_con
							+ "', '" + wheat_stubble 
							+ "', '" + flax_stubble
							+ "', '" + peas_stubble
							+ "', '" + feed_barley_notill
							+ "', '" + barley_notill
							+ "', '" + canola_notill 
							+ "', '" + feed_wheat_notill
							+ "', '" + wheat_notill
							+ "', '" + durum_notill
							+ "', '" + flax_notill
							+ "', '" + lentils_notill
							+ "', '" + peas_notill
							+ "', '" + willows_on_natural_pasture
							+ "', '" + willows_on_improved_pasture
							+ "', '" + willows_on_hayland_pasture
							+ "', '" + willows_initial_investment
							+ "', '" + poplar_on_natural_pasture
							+ "', '" + poplar_on_improved_pasture
							+ "', '" + poplar_on_hayland_pasture
							+ "', '" + poplarinitial_investment
							+ "', '" + prairie_sandreed_on_natural_pasture
							+ "', '" + prairie_sandreed_on_improved_pasture
							+ "', '" + prairie_sandreed_on_hayland_pasture
							+ "', '" + prairiesandreed_initial_investment
							+ "', '" + natural_pasture 
							+ "', '" + improved_pasture
							+ "', '" + hayland_pasture 
							+ "', '" + rent_out_cropland
							+ "', '" + rent_out_natural_pasture
							+ "', '" + rent_out_improved_pasture
							+ "', '" + rent_out_hayland_pasture
							+ "', '"  + pasture_carryover_one 
							+ "', '" + pasture_carryover_two 
							+ "', '"+ improved_bale_first_cut 
							+ "', '" + improved_bale_second_cut 
							+ "', '" + hay_production_one_cut 
							+ "', '" + hay_production_two_cuts 
							+ "', '" + breaking_cost
							+ "', '" + buy_hay
							+ "', '" + buy_feed_wheat 
							+ "', '" + buy_feed_barley 
							+ "', '" + feed_early_summer_hay 
							+ "', '" + feed_late_summer_hay 
							+ "', '" + feed_fall_hay 
							+ "', '" + feed_winter_hay 
							+ "', '" + feed_wheat 
							+ "', '" + feed_barley 
							+ "', '" + wheat_straw
							+ "', '" + barley_straw
							+ "', '" + sell_hay 
							+ "', '" + invest_cows
 							+ "', '" + cows_head 
							+ "', '" + cows_labour 
							+ "', '" + cows_fc_handling_system
							+ "', '" + cows_fc_machinery
							+ "', '" + sell_cull_cows
							+ "', '" + crop_custom_hire
							+ "', '" + option_0_acres 
							+ "', '" + option_1_acres
							+ "', '" + option_2_acres 
							+ "', '" + option_3_acres
							+ "', '" + option_4_acres 
							+ "', '" + option_5_acres
							+ "', '" + option_6_acres 
							+ "', '" + option_7_acres
							+ "', '" + option_8_acres 
							+ "', '" + option_9_acres
							+ "', '" + option_0_number_machines 
							+ "', '" + option_1_number_machines 
							+ "', '" + option_2_number_machines 
							+ "', '" + option_3_number_machines 
							+ "', '" + option_4_number_machines 
							+ "', '" + option_5_number_machines 
							+ "', '" + option_6_number_machines 
							+ "', '" + option_7_number_machines 
							+ "', '" + option_8_number_machines 
							+ "', '" + option_9_number_machines 
							+ "', '" + rent_pasture_land 
							+ "', '" + rent_cropland	
							+ "', '" + amount_borrow 
							+ "', '" + expected_income + "')");	

					stmt.close();
					conn.close();
				} catch (SQLException ce) {
					ce.printStackTrace();
					System.out.println("HELL 4 SQLException:" + ce.getMessage());
				}
				solver.deleteLp();
			} catch (LpSolveException e) {
				e.printStackTrace();
			}
		}
	}

	
	
	public void set_livestock_equipment_expansion () {
		
	Parameters p = RunEnvironment.getInstance().getParameters();
	double down_payment = (Double) p.getValue("downPayment");
	double FC_Cow_Handling = (Double) p.getValue("fccowhandling");
	double FC_Cow_Machinery = (Double) p.getValue("fccowmachinery");
	double inv_handling = (Double) p.getValue("invhandling");
	double inv_cow_machine = (Double) p.getValue("invcowmachine");
	double new_cow_machine_age = 0;
	double new_handling_system_age = 0;
	int newValue = 0;
	double old_livestock_equipment_value = livestock_equipment_value;
	
	double new_livestock_equipment_value = 0;
	
	
	if(getcows_fc_handling_system() > 0 || getcows_fc_machinery() > 0){
		new_cow_machine_age = 0;
		new_handling_system_age = 0;
		new_livestock_equipment_value = (int) (Math.round(inv_handling)*getcows_fc_handling_system() + inv_cow_machine * getcows_fc_machinery());
		double money_down = down_payment * new_livestock_equipment_value;
		cash = (int) (Math.round(cash - money_down));
		double payment = Math.round((1 - down_payment) * new_livestock_equipment_value * Variables.getloan_factor_payment_5() *100.0)/100.0;
		debtList debtLst = new debtList();
		debtLst.setyears_remaining(5);
		debtLst.setannual_payment(payment);
		debtLst.setdebt((int) (Math.round((1 - down_payment) * new_livestock_equipment_value)));
		this.debt_list.add(debtLst);
		debt = (int) (debt + (1 - down_payment) * new_livestock_equipment_value);
		
		debt_payment = debt_payment + payment;
		
		livestock_equipment_value = (int) (old_equipment_value + new_livestock_equipment_value);
		cow_machine_age = (int) ((cow_machine_age + new_cow_machine_age)/2);
		handling_system_age = (int) ((handling_system_age + new_handling_system_age)/2);
	}
	
	
	
	}
	
	
	
	public void set_breaking() {        

		Parameters p = RunEnvironment.getInstance().getParameters();
		double interest_rate = (Double) p.getValue("interestRate");
		double Per_Acre_VC_Wheat = (Double) p.getValue("perAcreVCWheat");
		double Per_Acre_VC_Canola = (Double) p.getValue("perAcreVCCanola");
		double Per_Acre_VC_Barley = (Double) p.getValue("perAcreVCBarley");
		double Per_Tonne_VC_Wheat = (Double) p.getValue("perTonneVCWheat");
		double Per_Tonne_VC_Canola = (Double) p.getValue("perTonneVCCanola");
		double Per_Tonne_VC_Barley = (Double) p.getValue("perTonneVCBarley");
		double Machine_VC_2 = (Double) p.getValue("machineVC2");
		double Machine_VC_3 = (Double) p.getValue("machineVC3");
		double Machine_VC_4 = (Double) p.getValue("machineVC4");
		double Machine_VC_5 = (Double) p.getValue("machineVC5");
		double Machine_VC_6 = (Double) p.getValue("machineVC6");
		double Machine_VC_7 = (Double) p.getValue("machineVC7");
		double Machine_VC_8 = (Double) p.getValue("machineVC8");
		double Machine_VC_9 = (Double) p.getValue("machineVC9");
		double Per_Acre_VC_NP = (Double) p.getValue("peracrevcnp");
		double Per_Acre_VC_IP = (Double) p.getValue("peracrevcip");
		double Per_Acre_VC_HL = (Double) p.getValue("peracrevchl");
		double Per_Acre_VC_Bale_IP_1 = (Double) p.getValue("peracrevcbaleip1");
		double Per_Acre_VC_Bale_IP_2 = (Double) p.getValue("peracrevcbaleip2");
		double Per_Acre_VC_Hayproduction_1 = (Double) p.getValue("peracrevchayproduction1");
		double Per_Acre_VC_Hayproduction_2 = (Double) p.getValue("peracrevchayproduction2");
		double Per_ton_feed_hay_cost = (Double) p.getValue("pertonfeedhaycost");
		double Per_ton_grain_cost = (Double) p.getValue("pertonfeedgraincost");
		double transaction_fee_hay = (Double) p.getValue("transactionfeehay");
		double VC_Cow = (Double) p.getValue("vccow");
		double FC_Cow_Labour = (Double) p.getValue("fccowlabour");
		double rent_pastureland = (Double) p.getValue("rentpastureland");
		double Per_Acre_Annualized_Breaking = (Double) p.getValue("peracreannualizedbreaking");
		double per_acre_breaking = (Double) p.getValue("peracrebreaking");
		double Machine_VC_0 = (Double) p.getValue("machineVC0");
		double Machine_VC_1 = (Double) p.getValue("machineVC1");
		double Per_Acre_VC_Summer_Fallow = (Double) p
		.getValue("perAcreVCSummerFallow"); // Variable cost per acre
		double Per_Acre_VC_Wheat_on_Fallow = (Double) p
		.getValue("perAcreVCWheatonFallow"); // Variable cost per acre
		double Per_Acre_VC_Canola_on_Stubble = (Double) p
		.getValue("perAcreVCCanolaonStubble"); // Variable cost per acre
		double Per_Acre_VC_Barley_on_Stubble = (Double) p
		.getValue("perAcreVCBarleyonStubble"); // Variable cost per acre
		double Per_Acre_VC_Wheat_on_Stubble = (Double) p
		.getValue("perAcreVCWheatonStubble"); // Variable cost per acre
				
		
		double operating_capital_required = breaking_cost * per_acre_breaking; 
		
		
			
		
		if(cash < operating_capital_required) {
			strategic_borrow = operating_capital_required;	
		cash = (int) (cash + strategic_borrow);
		
		double loan_factor_payment_10 = (interest_rate / (1 - (1 / (Math.pow(
				1 + interest_rate, 10)))));

		loan_payment = Math.round(strategic_borrow * loan_factor_payment_10
				* 100) / 100.00;
		
		interest_payment = interest_rate * strategic_borrow;		

		principal_payment = loan_payment - interest_payment;
		}
		else {
			cash = (int) (cash - operating_capital_required);
		}
	}

	public void set_machinery_mix() {
		int random_age = (int) (Math.random() * 2);
		setselloldequipment(false);
		Parameters p = RunEnvironment.getInstance().getParameters();
		double Inv_Mach_0 = (Double) p.getValue("inv_Mach_0"); // Investment
		double Inv_Mach_1 = (Double) p.getValue("inv_Mach_1"); // Investment
		double Inv_Mach_2 = (Double) p.getValue("inv_Mach_2"); // Investment
		double Inv_Mach_3 = (Double) p.getValue("inv_Mach_3"); // Investment
		double Inv_Mach_4 = (Double) p.getValue("inv_Mach_4"); // Investment
		double Inv_Mach_5 = (Double) p.getValue("inv_Mach_5"); // Investment
		double Inv_Mach_6 = (Double) p.getValue("inv_Mach_6"); // Investment
		double Inv_Mach_7 = (Double) p.getValue("inv_Mach_7"); // Investment
		double Inv_Mach_8 = (Double) p.getValue("inv_Mach_8"); // Investment
		double Inv_Mach_9 = (Double) p.getValue("inv_Mach_9"); // Investment
		double newcost0 = (Double) p.getValue("newcost0");
		double newcost1 = (Double) p.getValue("newcost1");
		double newcost2 = (Double) p.getValue("newcost2");	
		double newcost3 = (Double) p.getValue("newcost3");
		double newcost4 = (Double) p.getValue("newcost4");
		double newcost5 = (Double) p.getValue("newcost5");
		double newcost6 = (Double) p.getValue("newcost6");	
		double newcost7 = (Double) p.getValue("newcost7");
		double newcost8 = (Double) p.getValue("newcost8");	
		double newcost9 = (Double) p.getValue("newcost9");
		
		machinery_variables = new double[] { option_0_acres, option_1_acres,
				option_2_acres, option_3_acres, option_4_acres, option_5_acres,
				option_6_acres, option_7_acres, option_8_acres, option_9_acres,
				option_0_number_machines, option_1_number_machines,
				option_2_number_machines, option_3_number_machines,
				option_4_number_machines, option_5_number_machines,
				option_6_number_machines, option_7_number_machines,
				option_8_number_machines, option_9_number_machines };

		option0acres = getmachinery_variables()[0];
		option1acres = getmachinery_variables()[1];
		option2acres = getmachinery_variables()[2];
		option3acres = getmachinery_variables()[3];
		option4acres = getmachinery_variables()[4];
		option5acres = getmachinery_variables()[5];
		option6acres = getmachinery_variables()[6];
		option7acres = getmachinery_variables()[7];
		option8acres = getmachinery_variables()[8];
		option9acres = getmachinery_variables()[9];
		option0numbermachines = getmachinery_variables()[10];
		option1numbermachines = getmachinery_variables()[11];
		option2numbermachines = getmachinery_variables()[12];
		option3numbermachines = getmachinery_variables()[13];
		option4numbermachines = getmachinery_variables()[14];
		option5numbermachines = getmachinery_variables()[15];
		option6numbermachines = getmachinery_variables()[16];
		option7numbermachines = getmachinery_variables()[17];
		option8numbermachines = getmachinery_variables()[18];
		option9numbermachines = getmachinery_variables()[19];
		double machine_value_0 = 0;
		double machine_value_1 = 0;
        double machine_value_2 = 0;
        double machine_value_3 = 0;
        double machine_value_4 = 0;
        double machine_value_5 = 0;
        double machine_value_6 = 0;
        double machine_value_7 = 0;
        double machine_value_8 = 0;
        double machine_value_9 = 0;
		int newValue = 0;
		
		old_equipment_value = crop_machine_value;
		
		//System.out.println("old machine option" + crop_machine_option + "farmer" + getfarmer_name() + "year" + Variables.getyear());
		
		if(gettotal_acres_before() != total_crop_acres){ //resize equipment
		
	
		
		if(option0numbermachines > 0 && crop_machine_option != 0) { //if farmer already has option 0 no need to re purchase it
			//System.out.println("option0numbermachines" + option0numbermachines + "farmer" + getfarmer_name() + "year" + Variables.getyear());
			setselloldequipment(true);
			crop_machine_option = 0;
			crop_machine_age = (int) (15 + random_age);
			newValue = (int) newcost0;
			machine_value_0 = (int) (Math.round(newValue * option0numbermachines * 0.948 * Math.pow(0.901, crop_machine_age)));
		}
		if(option1numbermachines > 0 && crop_machine_option != 1) {
			//System.out.println("option1numbermachines" + option1numbermachines + "farmer" + getfarmer_name()+ "year" + Variables.getyear());
			setselloldequipment(true);
			crop_machine_option = 1;
			crop_machine_age = (int) (10 + random_age);
			newValue = (int) newcost1;
			machine_value_1 = (int) (Math.round(newValue * option1numbermachines * 0.948 * Math.pow(0.901, crop_machine_age)));
		}
		if(option2numbermachines > 0 && crop_machine_option != 2) {
			//System.out.println("option2numbermachines" + option2numbermachines + "farmer" + getfarmer_name()+ "year" + Variables.getyear());
			setselloldequipment(true);
			crop_machine_option = 2;
			crop_machine_age = 5;
			newValue = (int) newcost2;
			machine_value_2 = (int) (Math.round(newValue * option2numbermachines * 0.948 * Math.pow(0.901, crop_machine_age)));
		}
		if(option3numbermachines > 0 && crop_machine_option != 3) {
			//System.out.println("option3numbermachines" + option3numbermachines + "farmer" + getfarmer_name()+ "year" + Variables.getyear());
			setselloldequipment(true);
			crop_machine_option = 3;
			crop_machine_age = 0;
			newValue = (int) ((int) newcost3 * option3numbermachines);
			machine_value_3 = (int) (Math.round(newValue));
		}
		if(option4numbermachines > 0 && crop_machine_option != 4) {
			//System.out.println("option4numbermachines" + option4numbermachines + "farmer" + getfarmer_name()+ "year" + Variables.getyear());
			setselloldequipment(true);
			crop_machine_option = 4;
			crop_machine_age = 0;
			newValue = (int) ((int) newcost4 * option4numbermachines);
			machine_value_4 = (int) (Math.round(newValue));
		}
		if(option5numbermachines > 0 && crop_machine_option != 5) {
			//System.out.println("option5numbermachines" + option5numbermachines + "farmer" + getfarmer_name()+ "year" + Variables.getyear());
			setselloldequipment(true);
			crop_machine_option = 5;
			crop_machine_age = 0;
			newValue = (int) ((int) newcost5 * option5numbermachines);
			machine_value_5 = (int) (Math.round(newValue));
		}
		if(option6numbermachines > 0 && crop_machine_option != 6) {
			//System.out.println("option6numbermachines" + option6numbermachines + "farmer" + getfarmer_name()+ "year" + Variables.getyear());
			setselloldequipment(true);
			crop_machine_option = 6;
			crop_machine_age = 0;
			newValue = (int) ((int) newcost6 * option6numbermachines);
			machine_value_6 = (int) (Math.round(newValue));
		}
		if(option7numbermachines > 0 && crop_machine_option != 7) {
			//System.out.println("option7numbermachines" + option7numbermachines + "farmer" + getfarmer_name()+ "year" + Variables.getyear());
			setselloldequipment(true);
			crop_machine_option = 7;
			crop_machine_age = 0;
			newValue = (int) ((int) newcost7 * option7numbermachines);
			machine_value_7 = (int) (Math.round(newValue));
		}
		if(option8numbermachines > 0 && crop_machine_option != 8) {
			//System.out.println("option8numbermachines" + option8numbermachines + "farmer" + getfarmer_name()+ "year" + Variables.getyear());
			setselloldequipment(true);
			crop_machine_option = 8;
			crop_machine_age = 0;
			newValue = (int) ((int) newcost8 * option8numbermachines);
			machine_value_8 = (int) (Math.round(newValue));
		}
		if(option9numbermachines > 0 && crop_machine_option != 9) {
			//System.out.println("option9numbermachines" + option9numbermachines + "farmer" + getfarmer_name()+ "year" + Variables.getyear());
			setselloldequipment(true);
			crop_machine_option = 9;
			crop_machine_age = 0;
			newValue = (int) ((int) newcost9 * option9numbermachines);
			machine_value_9 = (int) (Math.round(newValue));
		}
		}
		if(getselloldequipment() == true) {
		crop_machine_value = (int) (machine_value_0 + machine_value_1 + machine_value_2 + machine_value_3 + 
				machine_value_4 + machine_value_5 + machine_value_6 + machine_value_7 +	
				machine_value_8 + machine_value_9); 
		cash = cash + old_equipment_value; //sale of old machine
		}
		else {
			crop_machine_value = (int) old_equipment_value;
		}
	}

	public void set_crop_mix() {
				
		crop_mix = new double[] { tillage_fallow, wheat_on_fallow, durum_stubble, 
				canola_stubble, barley_stubble, wheat_stubble, flax_stubble, peas_stubble, barley_notill,
				canola_notill, wheat_notill, durum_notill, flax_notill, peas_notill, lentils_notill, feed_barley_con, feed_wheat_con, feed_barley_notill, feed_wheat_notill };

		fallow = crop_mix[0];
		wheatfallow = crop_mix[1];
		durumstubble = crop_mix[2];
		canolastubble = crop_mix[3];
		barleystubble = crop_mix[4];
		wheatstubble = crop_mix[5];
		flaxstubble = crop_mix[6];
		peasstubble = crop_mix[7];
		barleynotill = crop_mix[8];
		canolanotill = crop_mix[9];
		wheatnotill = crop_mix[10];
		durumnotill = crop_mix[11];
		flaxnotill = crop_mix[12];
		peasnotill = crop_mix[13];
		lentilsnotill = crop_mix[14];
		feedbarleycon = crop_mix[15];
		feedwheatcon = crop_mix[16];
		feedbarleynotill = crop_mix[17];
		feedwheatnotill = crop_mix[18];
		
		premiums_paid_producer = (wheatfallow * producer_premium_wheat_fallow) + (durumstubble * producer_premium_durum_stubble) + (canolastubble * producer_premium_canola_stubble) 
		+ (barleystubble * producer_premium_barley_stubble) + (wheatstubble * producer_premium_wheat_stubble) + (barleynotill * producer_premium_barley_notill)
		+ (flaxstubble * producer_premium_flax_stubble) + (peasstubble * producer_premium_peas_stubble) 
		+ (canolanotill * producer_premium_canola_notill) + (wheatnotill * producer_premium_wheat_notill)
		+ (durumnotill * producer_premium_durum_notill) + (flaxnotill * producer_premium_flax_notill)
		+ (peasnotill * producer_premium_peas_notill) + (lentilsnotill * producer_premium_lentils_notill);
		
		premiums_paid_government = (wheatfallow * government_premium_wheat_fallow) + (canolastubble * government_premium_canola_stubble) 
		+ (barleystubble * government_premium_barley_stubble) + (wheatstubble * government_premium_wheat_stubble) 
		+ (durumstubble * government_premium_durum_stubble) + (flaxstubble * government_premium_flax_stubble) 
		+ (peasstubble * government_premium_peas_stubble)		
		+ (barleynotill * government_premium_barley_notill)
		+ (canolanotill * government_premium_canola_notill) + (wheatnotill * government_premium_wheat_notill)
		+ (durumnotill * government_premium_durum_notill) + (flaxnotill * government_premium_flax_notill)
		+ (peasnotill * government_premium_peas_notill) + (lentilsnotill * government_premium_lentils_notill);
	}

	public void set_pasture_mix() {
		
		pasture_mix = new double[] { natural_pasture, improved_pasture, hayland_pasture, 
				improved_bale_first_cut, improved_bale_second_cut, hay_production_one_cut, hay_production_two_cuts};
				
		naturalpasture = pasture_mix[0];
		improvedpasture = pasture_mix[1];
		haylandpasture = pasture_mix[2];
		improvedbaleone = pasture_mix[3];
		improvedbaletwo = pasture_mix[4];
		haybaleone = pasture_mix[5];
		haybaletwo = pasture_mix[6];				
	}
	
	
	public void check_land_market_results() {
				
		if(getchecklandmarketresults() == true){
			
				reoptimized_mip_conventional();
				reoptimized_mip_notill();
			
				if(getinfeasiblesolution()== false){
				postProcess();
				
				}
				else {
					tactical_crops_conventional_farmer();
					tactical_crops_notill();
					existing_machinery_package();
					set_crop_mix();
					set_livestock();
					set_livestock_equipment_expansion();
					cow_equip_depreciation();
					actual_crop_production();
					production();
					//crop_insurance();
					government_payments();
					fixed_costs();
					update_age();
					farm_accounting();
					exit_industry();
					update_farmers_land_info();
					
				}
			}
    	}
	
	public void reoptimized_mip_notill() {		
		if (this.gettotal_crop_acres() > 2000) { 
			expected_income = 0;
			tillage_fallow = 0;
			wheat_on_fallow = 0;
			durum_stubble = 0;
			canola_stubble = 0;
			barley_stubble = 0;
			wheat_stubble = 0;
			flax_stubble = 0;
			peas_stubble = 0;
			willows_on_natural_pasture = 0;
			willows_on_improved_pasture = 0;
			willows_on_hayland_pasture = 0;
			willows_initial_investment = 0;
			poplar_on_natural_pasture = 0;
			poplar_on_improved_pasture = 0;
			poplar_on_hayland_pasture = 0;
			poplar_initial_investment = 0;
			prairie_sandreed_on_natural_pasture = 0;
			prairie_sandreed_on_improved_pasture = 0;
			prairie_sandreed_on_hayland_pasture = 0;
			prairie_sandreed_initial_investment = 0;
			natural_pasture = 0;
			improved_pasture = 0;
			hayland_pasture = 0;
			rent_out_cropland = 0;
			rent_out_natural_pasture = 0;
			rent_out_improved_pasture = 0;
			rent_out_hayland_pasture = 0;
			pasture_carryover_one = 0;
			pasture_carryover_two = 0;
			improved_bale_first_cut = 0;
			improved_bale_second_cut = 0;
			hay_production_one_cut = 0;
			hay_production_two_cuts = 0;
			breaking_cost = 0;
			buy_hay = 0;
			buy_feed_wheat = 0;
			buy_feed_barley = 0;
			feed_early_summer_hay = 0;
			feed_late_summer_hay = 0;
			feed_fall_hay = 0;
			feed_winter_hay = 0;
			feed_wheat = 0;
			feed_barley = 0;
			wheat_straw = 0;
			barley_straw = 0;					
			sell_hay = 0;
			cows_head = 0;
			cows_labour = 0;   
			cows_fc_handling_system = 0;
			cows_fc_machinery = 0; 
			option_0_acres = 0;
			option_1_acres = 0;
			option_0_number_machines = 0;
			option_1_number_machines = 0;
			rent_pasture_land = 0;
			rent_cropland = 0;
			amount_borrow = 0;				
		Parameters p = RunEnvironment.getInstance().getParameters();
		double cereal_mcal_limit = (Double)p.getValue("cereal_mcal_limit");
		double Per_Tonne_Willow_Custom_Rate = (Double) p.getValue("perTonneWillowCustomRate");			
		double min_ratio = (Double) p.getValue("minRatio");
		double inv_mach_2 = (Double) p.getValue("inv_Mach_2");
		double inv_mach_3 = (Double) p.getValue("inv_Mach_3");
		double inv_mach_4 = (Double) p.getValue("inv_Mach_4");
		double inv_mach_5 = (Double) p.getValue("inv_Mach_5");
		double inv_mach_6 = (Double) p.getValue("inv_Mach_6");
		double inv_mach_7 = (Double) p.getValue("inv_Mach_7");
		double inv_mach_8 = (Double) p.getValue("inv_Mach_8");
		double inv_mach_9 = (Double) p.getValue("inv_Mach_9");		
		double interest_rate = (Double) p.getValue("discountRate");
		double Per_Acre_VC_Wheat = (Double) p.getValue("perAcreVCWheat");
		double Per_Acre_VC_Canola = (Double) p.getValue("perAcreVCCanola");
		double Per_Acre_VC_Barley = (Double) p.getValue("perAcreVCBarley");
		double Per_Tonne_VC_Wheat = (Double) p.getValue("perTonneVCWheat");
		double Per_Tonne_VC_Canola = (Double) p.getValue("perTonneVCCanola");
		double Per_Tonne_VC_Barley = (Double) p.getValue("perTonneVCBarley");
		double Per_Acre_VC_Durum = (Double) p.getValue("perAcreVCDurum");
		double Per_Acre_VC_Flax = (Double) p.getValue("perAcreVCFlax");
	 	double Per_Acre_VC_Peas = (Double) p.getValue("perAcreVCPeas");
	 	double Per_Acre_VC_Lentils = (Double) p.getValue("perAcreVCLentils");	
		double Per_Acre_VC_Willows = (Double) p.getValue("perAcreVCWillows");			
		double Per_Tonne_VC_Durum = (Double) p.getValue("perTonneVCDurum");		
		double Per_Tonne_VC_Flax = (Double) p.getValue("perTonneVCFlax");
		double Per_Tonne_VC_Lentils = (Double) p.getValue("perTonneVCLentils");
	 	double Per_Tonne_VC_Peas = (Double) p.getValue("perTonneVCPeas");			
		double Increase_NoTill = (Double) p.getValue("increaseNoTill");
		double Machine_VC_2 = (Double) p.getValue("machineVC2");
		double Machine_VC_3 = (Double) p.getValue("machineVC3");
		double Machine_VC_4 = (Double) p.getValue("machineVC4");
		double Machine_VC_5 = (Double) p.getValue("machineVC5");
		double Machine_VC_6 = (Double) p.getValue("machineVC6");
		double Machine_VC_7 = (Double) p.getValue("machineVC7");
		double Machine_VC_8 = (Double) p.getValue("machineVC8");
		double Machine_VC_9 = (Double) p.getValue("machineVC9");
		double Machine_FC_2 = (Double) p.getValue("machineFC2");
		double Machine_FC_3 = (Double) p.getValue("machineFC3");
		double Machine_FC_4 = (Double) p.getValue("machineFC4");
		double Machine_FC_5 = (Double) p.getValue("machineFC5");
		double Machine_FC_6 = (Double) p.getValue("machineFC6");
		double Machine_FC_7 = (Double) p.getValue("machineFC7");
		double Machine_FC_8 = (Double) p.getValue("machineFC8");
		double Machine_FC_9 = (Double) p.getValue("machineFC9");
		double Per_Acre_VC_NP = (Double) p.getValue("peracrevcnp");
		double Per_Acre_VC_IP = (Double) p.getValue("peracrevcip");
		double Per_Acre_VC_HL = (Double) p.getValue("peracrevchl");
		double Per_Acre_VC_Bale_IP_1 = (Double) p.getValue("peracrevcbaleip1");
		double Per_Acre_VC_Bale_IP_2 = (Double) p.getValue("peracrevcbaleip2");
		double Per_Acre_VC_Hayproduction_1 = (Double) p.getValue("peracrevchayproduction1");
		double Per_Acre_VC_Hayproduction_2 = (Double) p.getValue("peracrevchayproduction2");
		double Per_ton_feed_hay_cost = (Double) p.getValue("pertonfeedhaycost");
		double Per_ton_grain_cost = (Double) p.getValue("pertonfeedgraincost");
		double transaction_fee_hay = (Double) p.getValue("transactionfeehay");
		double VC_Cow = (Double) p.getValue("vccow");
		double FC_Cow_Labour = (Double) p.getValue("fccowlabour");		
		double Per_Acre_Annualized_Breaking = (Double) p.getValue("peracreannualizedbreaking");
		double per_acre_breaking = (Double) p.getValue("peracrebreaking");
		double Per_ton_straw_bale_cost = (Double) p.getValue("pertonstrawbalecost"); 
		double pr_rating = 0;
		double pr_max_hay_yield = (Double)p.getValue("prmaxhayyield");	
		double threshold_hay_1 = (Double)p.getValue("thresholdhay1");
		double int_inv_willows = (Double) p.getValue("intinvwillows");
		double annualizedbreakingwillows = (Double) p.getValue("annualizedbreakingwillows");
		double annualizedbreakingpoplar = (Double) p.getValue("annualizedbreakingpoplar");
		double annualizedbreakingprairiesandreed = (Double) p.getValue("annualizedbreakingprairiesandreed");
		double Per_Tonne_Poplar_Custom_Rate = (Double) p.getValue("perTonneWillowCustomRate");
		double Per_Tonne_PrairieSandReed_Custom_Rate = (Double) p.getValue("per_Tonne_PrairieSandreed_Custom_Rate");
		double int_inv_poplar = (Double) p.getValue("int_inv_poplar");
		double int_inv_prairiesandreed = (Double) p.getValue("int_inv_prairiesandreed");
		double FC_Cow_Handling = (Double) p.getValue("fccowhandling");
		double FC_Cow_Machinery = (Double) p.getValue("fccowmachinery");
		double inv_handling = (Double) p.getValue("invhandling");
		double inv_cow_machine = (Double) p.getValue("invcowmachine");
		double pr_max_psr_yield = (Double)p.getValue("pr_max_psr_yield");
		double error = 1 + ((int) (Math.random()*10)-5.0)/100.0;
		double min_prairiesandreed_yield = (Double)p.getValue("min_psr_yield");
		double max_prairiesandreed_yield = (Double)p.getValue("max_psr_yield");
		double prairiesandreed_price = (Double)p.getValue("psr_price");
		double propertytaxescropland = 6;
		double propertytaxespasture = 3;
		double lease_man_fee_percent = (Double)p.getValue("lease_man_fee_percent");
		double cereallimit_notill = (Double)p.getValue("cereallimit_notill");
		double oilseedlimit_notill = (Double)p.getValue("oilseedlimit_notill");
		double pulselimit_notill = (Double)p.getValue("pulselimit_notill");
		double cull_transaction_cost = (Double)p.getValue("cull_transaction_cost");
		double maxwheat_limit = (Double)p.getValue("maxwheatlimit");
		double maxbarley_limit = (Double)p.getValue("maxbarleylimit");
		double maxdurum_limit = (Double)p.getValue("maxdurumlimit");
		double maxflax_limit = (Double)p.getValue("maxflaxlimit");
		double maxcanola_limit = (Double)p.getValue("maxcanolalimit");
		double maxpeas_limit = (Double)p.getValue("maxpeaslimit");
		double maxlentils_limit = (Double)p.getValue("maxlentilslimit");
		double customhire = (Double)p.getValue("customhire");		
		double sell_cows_fee = (Double)p.getValue("sellherdcost");
		double alpha = (Double) p.getValue("alpha");
		double gama = (Double)p.getValue("gama");
		double Per_Tonne_VC_Hay = (Double)p.getValue("perTonneVCHay");
		double psr_gj_tonne = (Double)p.getValue("psrgjtonne");
		double gjprice = (Double)p.getValue("gjprice");
		double No_Buy_Hay = (Double)p.getValue("NoBuyHay");
		expected_income = 0;
		barley_notill = 0;
		canola_notill = 0;
		wheat_notill = 0;
		durum_notill = 0;
		flax_notill = 0;
		peas_notill = 0;
		lentils_notill = 0;
		willows_on_natural_pasture = 0;
		willows_on_improved_pasture = 0;
		willows_on_hayland_pasture = 0;
		willows_initial_investment = 0;
		poplar_on_natural_pasture = 0;
		poplar_on_improved_pasture = 0;
		poplar_on_hayland_pasture = 0;
		poplar_initial_investment = 0;
		prairie_sandreed_on_natural_pasture = 0;
		prairie_sandreed_on_improved_pasture = 0;
		prairie_sandreed_on_hayland_pasture = 0;
		prairie_sandreed_initial_investment = 0;					
		natural_pasture = 0;
		improved_pasture = 0;
		hayland_pasture = 0;
		rent_out_cropland = 0;
		rent_out_natural_pasture = 0;
		rent_out_improved_pasture = 0;
		rent_out_hayland_pasture = 0;					
		pasture_carryover_one = 0;
		pasture_carryover_two = 0;
		improved_bale_first_cut = 0;
		improved_bale_second_cut = 0;
		hay_production_one_cut = 0;
		hay_production_two_cuts = 0;
		breaking_cost = 0;
		buy_hay = 0;
		buy_feed_wheat = 0;
		buy_feed_barley = 0;
		feed_early_summer_hay = 0;
		feed_late_summer_hay = 0;
		feed_fall_hay = 0;
		feed_winter_hay = 0;
		feed_wheat = 0;
		feed_barley = 0;
		wheat_straw = 0;
		barley_straw = 0;
		sell_hay = 0;
		cows_head = 0;
		cows_labour = 0;	
		cows_fc_handling_system = 0;
		cows_fc_machinery = 0; 
		option_2_acres = 0;
		option_3_acres = 0;
		option_4_acres = 0;
		option_5_acres = 0;
		option_6_acres = 0;
		option_7_acres = 0;
		option_8_acres = 0;
		option_9_acres = 0;
		option_2_number_machines = 0;
		option_3_number_machines = 0;
		option_4_number_machines = 0;
		option_5_number_machines = 0;
		option_6_number_machines = 0;
		option_7_number_machines = 0;
		option_8_number_machines = 0;
		option_9_number_machines = 0;
		rent_pasture_land = 0;
		rent_cropland = 0;
		amount_borrow = 0;		
		
		yield_mult = 1 + Increase_NoTill;

		Iterator<SAMA> it = mylandList.iterator();
		double tonnes_crop_canola_notill = 0, tonnes_crop_flax_notill = 0, tonnes_crop_peas_notill = 0, tonnes_crop_lentils_notill = 0, tonnes_crop_durum_notill = 0, 
		loc_tonnes_crop_barley_notill = 0, loc_tonnes_crop_wheat_notill = 0;
		
		for(int i = 0; i < getmylandList().size(); i++) {
			SAMA sama = (SAMA) getmylandList().get(i);

			tonnes_crop_canola_notill += yield_mult * sama.getCanolaYieldIndex() * yield_exp_list[0] / 44.09;
			loc_tonnes_crop_barley_notill += yield_mult * sama.getBarleyYieldIndex() * yield_exp_list[2] / 45.93;
			loc_tonnes_crop_wheat_notill += yield_mult * sama.getWheatYieldIndex() * yield_exp_list[1] / 36.74;
			tonnes_crop_durum_notill += yield_mult * sama.getDurumYieldIndex() * yield_exp_list[7]/36.74;
			tonnes_crop_flax_notill += yield_mult * sama.getFlaxYieldIndex() * yield_exp_list[4]/39.37;
			tonnes_crop_lentils_notill += yield_mult * sama.getLentilsYieldIndex() * yield_exp_list[6]/36.74;
			tonnes_crop_peas_notill += yield_mult * sama.getPeasYieldIndex() * yield_exp_list[5]/39.37;
			
			if(sama.getnpQuality() > pr_max_hay_yield) {
				pr_rating = pr_max_hay_yield;				
				exp_np_early_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3])));
				exp_np_late_yield = (pr_rating / pr_max_hay_yield *  ((yield_exp_list[3] * 0.6)));
				exp_np_fall_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3] * 0.2)));
				exp_mcals_np_early_yield = (exp_np_early_yield * Variables.getmcals_ton_np_early());
				exp_mcals_np_late_yield = (exp_np_late_yield * Variables.getmcals_ton_np_late());
				exp_mcals_np_fall_yield =(exp_np_fall_yield * Variables.getmcals_ton_np_fall());
			}
			else {
				pr_rating = sama.getnpQuality();				
				exp_np_early_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3])));
				exp_np_late_yield = (pr_rating / pr_max_hay_yield *  ((yield_exp_list[3] * 0.6)));
				exp_np_fall_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3] * 0.2)));
				exp_mcals_np_early_yield = (exp_np_early_yield * Variables.getmcals_ton_np_early());
				exp_mcals_np_late_yield = (exp_np_late_yield * Variables.getmcals_ton_np_late());
				exp_mcals_np_fall_yield =(exp_np_fall_yield * Variables.getmcals_ton_np_fall());
			}
			if(sama.getIPQuality() > pr_max_hay_yield) {
				pr_rating = pr_max_hay_yield;				
				exp_ip_early_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3])));
				exp_ip_late_yield = (pr_rating / pr_max_hay_yield *  ((yield_exp_list[3] * 0.6)));
				exp_ip_fall_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3] * 0.2)));
				exp_ip_early_yield_bale_one = (pr_rating / pr_max_hay_yield * yield_exp_list[3]);				
				exp_ip_late_yield_bale_two = (exp_ip_early_yield + (0.6 * exp_ip_early_yield)) ;	
				exp_mcals_ip_early_yield = (exp_ip_early_yield * Variables.getmcals_ton_ip_early());
				exp_mcals_ip_late_yield = (exp_ip_late_yield * Variables.getmcals_ton_ip_late());
				exp_mcals_ip_fall_yield = (exp_ip_fall_yield * Variables.getmcals_ton_ip_fall());
			}
			else {
				pr_rating = sama.getIPQuality();				
				exp_ip_early_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3])));
				exp_ip_late_yield = (pr_rating / pr_max_hay_yield *  ((yield_exp_list[3] * 0.6)));
				exp_ip_fall_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3] * 0.2)));
				exp_ip_early_yield_bale_one = (pr_rating / pr_max_hay_yield * yield_exp_list[3]);				
				exp_ip_late_yield_bale_two = (exp_ip_early_yield + (0.6 * exp_ip_early_yield)) ;	
				exp_mcals_ip_early_yield = (exp_ip_early_yield * Variables.getmcals_ton_ip_early());
				exp_mcals_ip_late_yield = (exp_ip_late_yield * Variables.getmcals_ton_ip_late());
				exp_mcals_ip_fall_yield = (exp_ip_fall_yield * Variables.getmcals_ton_ip_fall());
			}
			if(sama.getHayQuality() > pr_max_hay_yield) {
				pr_rating = pr_max_hay_yield;				
				exp_hay_early_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3])));
				exp_hay_late_yield = (pr_rating / pr_max_hay_yield *  ((yield_exp_list[3] * 0.6)));
				exp_hay_fall_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3] * 0.2)));
				exp_hay_early_yield_bale_one = (pr_rating / pr_max_hay_yield * yield_exp_list[3]);				
				exp_hay_late_yield_bale_two = (exp_hay_early_yield + (0.6 * exp_hay_early_yield)) ;	
				exp_mcals_hayland_early_yield = (exp_hay_early_yield * Variables.getmcals_ton_hayland_early());
				exp_mcals_hayland_late_yield = (exp_hay_late_yield * Variables.getmcals_ton_hayland_late());
				exp_mcals_hayland_fall_yield = (exp_hay_fall_yield * Variables.getmcals_ton_hayland_fall());
			}
			else {
				pr_rating = sama.getHayQuality();				
				exp_hay_early_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3])));
				exp_hay_late_yield = (pr_rating / pr_max_hay_yield *  ((yield_exp_list[3] * 0.6)));
				exp_hay_fall_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3] * 0.2)));
				exp_hay_early_yield_bale_one = (pr_rating / pr_max_hay_yield * yield_exp_list[3]);				
				exp_hay_late_yield_bale_two = (exp_hay_early_yield + (0.6 * exp_hay_early_yield)) ;	
				exp_mcals_hayland_early_yield = (exp_hay_early_yield * Variables.getmcals_ton_hayland_early());
				exp_mcals_hayland_late_yield = (exp_hay_late_yield * Variables.getmcals_ton_hayland_late());
				exp_mcals_hayland_fall_yield = (exp_hay_fall_yield * Variables.getmcals_ton_hayland_fall());
			}
			if(gettotal_improved_pasture() + gettotal_hay() > 0) {
				weighted_avg_mcals_bale_one = ((((gettotal_improved_pasture()/(gettotal_improved_pasture() + gettotal_hay()))*Variables.getmcals_ton_ip_baled_one()) + 
						(((gettotal_hay()/(gettotal_improved_pasture() + gettotal_hay()))*Variables.getmcals_ton_hayland_baled_one()))));
				
				weighted_avg_mcals_bale_two = (((weighted_avg_mcals_bale_one) + ((((gettotal_improved_pasture()/(gettotal_improved_pasture() + gettotal_hay()))*Variables.getmcals_ton_ip_baled_two()) + 
						(((gettotal_hay()/(gettotal_improved_pasture() + gettotal_hay()))*Variables.getmcals_ton_hayland_baled_two()))))/2)/2);
				}				
				else {
				weighted_avg_mcals_bale_one = ((Variables.getmcals_ton_ip_baled_one() + Variables.getmcals_ton_hayland_baled_one())/2);
					
				weighted_avg_mcals_bale_two = ((((Variables.getmcals_ton_ip_baled_one() + Variables.getmcals_ton_hayland_baled_one())/2) + ((Variables.getmcals_ton_ip_baled_two() + Variables.getmcals_ton_hayland_baled_two())/2))/2);
				}
		}
		
		tonnes_crop_canola_notill = tonnes_crop_canola_notill/total_plots;
		loc_tonnes_crop_barley_notill = loc_tonnes_crop_barley_notill/total_plots;
		loc_tonnes_crop_wheat_notill = loc_tonnes_crop_wheat_notill/total_plots;
		tonnes_crop_durum_notill = tonnes_crop_durum_notill/total_plots;
		tonnes_crop_flax_notill = tonnes_crop_flax_notill/total_plots;
		tonnes_crop_lentils_notill = tonnes_crop_lentils_notill/total_plots;
		tonnes_crop_peas_notill = tonnes_crop_peas_notill/total_plots;
		
		if(n_cows > 0){
			np_cow_acre = 0.5; //total_natural_pasture/n_cows;
			ip_cow_acre = 1; //total_improved_pasture/n_cows;
			hayland_cow_acre = 2; //total_hay/n_cows;
			
			total_cow_acre = 4; //(total_natural_pasture +  total_improved_pasture + total_hay)/n_cows;
			
		}
		
			
			
		
		for (int i = 0; i < getmylandList().size(); i++) {
			SAMA fdl1 = (SAMA) getmylandList().get(i);
			int countgrass = i;
			int countpsr = i;
				if(fdl1.getyears_in_grass() > 0) {
					countgrass++;
					average_years_in_grass = average_years_in_grass + fdl1.getyears_in_grass();
			
				}
				if(fdl1.getyears_in_prairie_sandreed() > 0){
					countpsr++;
					
					average_years_in_prairie_sandreed = average_years_in_prairie_sandreed + fdl1.getyears_in_prairie_sandreed();
				}
		}
		if(getplots_in_grass() > 0){
			
			average_years_in_grass = average_years_in_grass/getplots_in_grass();
			}
		
			if(average_years_in_grass < 7) {
			
				forage_breaking = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0.5, 1, 0, 0, 0, 0, 0, 0, 0.5, 0.5, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}; 
				}
			
			if(average_years_in_prairie_sandreed > 0 && average_years_in_prairie_sandreed < 7){
				prairiesandreed_yield_np = prairiesandreed_yield_np * -1;
				prairiesandreed_yield_ip = prairiesandreed_yield_np * -1;
				prairiesandreed_yield_hayland = prairiesandreed_yield_hayland * -1;
				}
			if(average_years_in_willows > 0 && average_years_in_willows < 21){
				willows_annualized_return_np = willows_annualized_return_np * -1;
				willows_annualized_return_ip = willows_annualized_return_ip * -1;
				willows_annualized_return_hayland = willows_annualized_return_hayland * -1;
			}
			if(average_years_in_poplar > 0 && average_years_in_poplar < 21){
				poplar_annualized_return_np = poplar_annualized_return_np * -1;
				poplar_annualized_return_ip = poplar_annualized_return_ip * -1;
				poplar_annualized_return_hayland = poplar_annualized_return_hayland * -1;
			
			}	
			
				prairie_sandreed_transfer = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
					willow_transfer = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
					poplar_transfer = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
						
			handling_transfer = 1;
			cows_handling_system_limit = 300;
			cows_machine_limit = 300;
		
		
			yield_mult = 1 + Increase_NoTill;			
			double barley_exp_yield = yield_exp_list[2];
			double wheat_exp_yield = yield_exp_list[1];
							
			if(getfarmer_type() == 2 || getfarmer_type() == 3){	
			contribution_margin = new double[] {
					-((yield_mult * barley_exp_yield) * (farmer_exp_barley_price))
					- ((Per_Acre_VC_Barley)),
					((yield_mult * barley_exp_yield) * farmer_exp_barley_price)
					- ((Per_Acre_VC_Barley + producer_premium_barley_notill) + (Per_Tonne_VC_Barley * loc_tonnes_crop_barley_notill * trucking_distance)),
			((yield_mult * yield_exp_list[0]) * farmer_exp_canola_price)
					- ((Per_Acre_VC_Canola + producer_premium_canola_notill) + (Per_Tonne_VC_Canola * tonnes_crop_canola_notill * trucking_distance)),
			-((yield_mult * wheat_exp_yield) * farmer_exp_wheat_price)
					- ((Per_Acre_VC_Wheat)), 						
			((yield_mult * wheat_exp_yield) * farmer_exp_wheat_price)
					- ((Per_Acre_VC_Wheat + producer_premium_wheat_notill) + (Per_Tonne_VC_Wheat * loc_tonnes_crop_wheat_notill * trucking_distance)), 
			((yield_mult * yield_exp_list[7]) * farmer_exp_durum_price)
			        - ((Per_Acre_VC_Durum + producer_premium_durum_notill) + (Per_Tonne_VC_Durum * tonnes_crop_durum_notill * trucking_distance)),
			((yield_mult * yield_exp_list[4]) * farmer_exp_flax_price)
					- ((Per_Acre_VC_Flax + producer_premium_flax_notill) + (Per_Tonne_VC_Flax * tonnes_crop_flax_notill * trucking_distance)),
			((yield_mult * yield_exp_list[5]) * farmer_exp_peas_price)
			        - ((Per_Acre_VC_Peas + producer_premium_peas_notill) + (Per_Tonne_VC_Peas * tonnes_crop_peas_notill * trucking_distance)),
			((yield_mult * yield_exp_list[6]) * farmer_exp_lentils_price)
					- ((Per_Acre_VC_Lentils + producer_premium_lentils_notill) + (Per_Tonne_VC_Lentils * tonnes_crop_lentils_notill * trucking_distance)),
					(willows_annualized_return_np),
					(willows_annualized_return_ip),
					(willows_annualized_return_hayland),
					-(annualizedbreakingwillows),
					(poplar_annualized_return_np),
					(poplar_annualized_return_ip),
					(poplar_annualized_return_hayland),
					-(annualizedbreakingpoplar),
					(prairiesandreed_yield_np * psr_gj_tonne * gjprice) - ((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_np)),
					(prairiesandreed_yield_ip * psr_gj_tonne * gjprice) - ((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_ip)),
					(prairiesandreed_yield_hayland * psr_gj_tonne * gjprice) - ((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_hayland)),
					-(annualizedbreakingprairiesandreed),
					-(Per_Acre_VC_NP), -(Per_Acre_VC_IP), -(Per_Acre_VC_HL), 
					(0), (0), (0), (0),
					0, 0, -(Per_Acre_VC_Bale_IP_1),
					-(Per_Acre_VC_Bale_IP_2), -(Per_Acre_VC_Hayproduction_1), -(Per_Acre_VC_Hayproduction_2), -(Per_Acre_Annualized_Breaking),
					-(farmer_exp_hay_price + transaction_fee_hay + (Per_Tonne_VC_Hay * trucking_distance)*No_Buy_Hay), -(farmer_exp_wheat_price*36.74 + transaction_fee_hay + (Per_Tonne_VC_Wheat * trucking_distance)), -(farmer_exp_barley_price*45.93 + transaction_fee_hay + (Per_Tonne_VC_Barley * trucking_distance)), 
					-(Per_ton_feed_hay_cost), -(Per_ton_feed_hay_cost), -(Per_ton_feed_hay_cost), -(Per_ton_feed_hay_cost), 
					-(Per_ton_grain_cost), -(Per_ton_grain_cost), -(Per_ton_straw_bale_cost), -(Per_ton_straw_bale_cost), (farmer_exp_hay_price -(transaction_fee_hay)), -(crccow),
					((farmer_exp_calf_price*495) - (VC_Cow)), -(FC_Cow_Labour), -(FC_Cow_Handling), -(FC_Cow_Machinery), ((crccow) - ((crccow * cull_transaction_cost) + sell_cows_fee)), -(customhire),
			-(Machine_VC_2), -(Machine_VC_3), -(Machine_VC_4),
			-(Machine_VC_5), -(Machine_VC_6), -(Machine_VC_7),
			-(Machine_VC_8), -(Machine_VC_9), -(Machine_FC_2),
			-(Machine_FC_3), -(Machine_FC_4), -(Machine_FC_5),
			-(Machine_FC_6), -(Machine_FC_7), -(Machine_FC_8),
			-(Machine_FC_9), -(interest_rate)};
			}
			else {
				contribution_margin = new double[] {
				-((yield_mult * barley_exp_yield) * farmer_exp_barley_price * 0.6529)
						- ((Per_Acre_VC_Barley)),					
						((yield_mult * barley_exp_yield) * farmer_exp_barley_price)
						- ((Per_Acre_VC_Barley + producer_premium_barley_notill) + (Per_Tonne_VC_Barley * loc_tonnes_crop_barley_notill * trucking_distance)),
				((yield_mult * yield_exp_list[0]) * farmer_exp_canola_price)
						- ((Per_Acre_VC_Canola + producer_premium_canola_notill) + (Per_Tonne_VC_Canola * tonnes_crop_canola_notill * trucking_distance)),
				-((yield_mult * wheat_exp_yield) * farmer_exp_wheat_price)
						- ((Per_Acre_VC_Wheat)), 							
				((yield_mult * wheat_exp_yield) * farmer_exp_wheat_price)
						- ((Per_Acre_VC_Wheat + producer_premium_wheat_notill) + (Per_Tonne_VC_Wheat * loc_tonnes_crop_wheat_notill * trucking_distance)), 
				((yield_mult * yield_exp_list[7]) * farmer_exp_durum_price)
				        - ((Per_Acre_VC_Durum + producer_premium_durum_notill) + (Per_Tonne_VC_Durum * tonnes_crop_durum_notill * trucking_distance)),
				((yield_mult * yield_exp_list[4]) * farmer_exp_flax_price)
						- ((Per_Acre_VC_Flax + producer_premium_flax_notill) + (Per_Tonne_VC_Flax * tonnes_crop_flax_notill * trucking_distance)),
				((yield_mult * yield_exp_list[5]) * farmer_exp_peas_price)
				        - ((Per_Acre_VC_Peas + producer_premium_peas_notill) + (Per_Tonne_VC_Peas * tonnes_crop_peas_notill * trucking_distance)),
				((yield_mult * yield_exp_list[6]) * farmer_exp_lentils_price)
						- ((Per_Acre_VC_Lentils + producer_premium_lentils_notill) + (Per_Tonne_VC_Lentils * tonnes_crop_lentils_notill * trucking_distance)),
						(willows_annualized_return_np),
						(willows_annualized_return_ip),
						(willows_annualized_return_hayland),
						-(annualizedbreakingwillows),
						(poplar_annualized_return_np),
						(poplar_annualized_return_ip),
						(poplar_annualized_return_hayland),
						-(annualizedbreakingpoplar),
						(prairiesandreed_yield_np * psr_gj_tonne * gjprice) - ((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_np)),
						(prairiesandreed_yield_ip * psr_gj_tonne * gjprice) - ((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_ip)),
						(prairiesandreed_yield_hayland * psr_gj_tonne * gjprice) - ((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_hayland)),
						-(annualizedbreakingprairiesandreed),
						-(Per_Acre_VC_NP), -(Per_Acre_VC_IP), -(Per_Acre_VC_HL), 
						(0), ((sizing_pastureland_value * 0.5)- (propertytaxespasture + (sizing_pastureland_value * 0.5 * lease_man_fee_percent))), ((sizing_pastureland_value * 0.75)- (propertytaxespasture + (sizing_pastureland_value * 0.75 * lease_man_fee_percent))), (sizing_pastureland_value - (propertytaxespasture + (sizing_pastureland_value * lease_man_fee_percent))),
						0, 0, -(Per_Acre_VC_Bale_IP_1),
						-(Per_Acre_VC_Bale_IP_2), -(Per_Acre_VC_Hayproduction_1), -(Per_Acre_VC_Hayproduction_2), -(Per_Acre_Annualized_Breaking),
						-(farmer_exp_hay_price + transaction_fee_hay + (Per_Tonne_VC_Hay * trucking_distance)*No_Buy_Hay), -(farmer_exp_wheat_price*36.74 + transaction_fee_hay + (Per_Tonne_VC_Wheat * trucking_distance)), -(farmer_exp_barley_price*45.93 + transaction_fee_hay + (Per_Tonne_VC_Barley * trucking_distance)), 
						-(Per_ton_feed_hay_cost), -(Per_ton_feed_hay_cost), -(Per_ton_feed_hay_cost), -(Per_ton_feed_hay_cost), 
						-(Per_ton_grain_cost), -(Per_ton_grain_cost), -(Per_ton_straw_bale_cost), -(Per_ton_straw_bale_cost), (farmer_exp_hay_price -(transaction_fee_hay)), 0,
						(0), -(FC_Cow_Labour), -(FC_Cow_Handling), -(FC_Cow_Machinery), 0, -(customhire),
				-(Machine_VC_2), -(Machine_VC_3), -(Machine_VC_4),
				-(Machine_VC_5), -(Machine_VC_6), -(Machine_VC_7),
				-(Machine_VC_8), -(Machine_VC_9), -(Machine_FC_2),
				-(Machine_FC_3), -(Machine_FC_4), -(Machine_FC_5),
				-(Machine_FC_6), -(Machine_FC_7), -(Machine_FC_8),
				-(Machine_FC_9), -(interest_rate)};	
			}
			if(average_years_in_grass < 7) {
				borrowing = new double[] {
						Per_Acre_VC_Barley,
						Per_Acre_VC_Barley + producer_premium_barley_notill
						+ (Per_Tonne_VC_Barley * loc_tonnes_crop_barley_notill * trucking_distance),
				Per_Acre_VC_Canola + producer_premium_canola_notill
						+ (Per_Tonne_VC_Canola * tonnes_crop_canola_notill * trucking_distance),
				Per_Acre_VC_Wheat,		
				Per_Acre_VC_Wheat + producer_premium_wheat_notill
						+ (Per_Tonne_VC_Wheat * loc_tonnes_crop_wheat_notill * trucking_distance),
				Per_Acre_VC_Durum + producer_premium_durum_notill
						+ (Per_Tonne_VC_Durum * tonnes_crop_durum_notill * trucking_distance),
				Per_Acre_VC_Flax + producer_premium_flax_notill
						+ (Per_Tonne_VC_Flax * tonnes_crop_flax_notill * trucking_distance),
				Per_Acre_VC_Peas + producer_premium_peas_notill
						+ (Per_Tonne_VC_Peas * tonnes_crop_peas_notill * trucking_distance),
				Per_Acre_VC_Lentils + producer_premium_lentils_notill
						+ (Per_Tonne_VC_Lentils * tonnes_crop_lentils_notill * trucking_distance),
						(willows_annualized_cost_np*100), (willows_annualized_cost_ip*100), (willows_annualized_cost_hayland*100), (int_inv_willows), 
						(poplar_annualized_cost_np*100), (poplar_annualized_cost_ip*100), 
						(poplar_annualized_cost_hayland*100), (int_inv_poplar), 
						((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_np)*100), ((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_ip)*100), 
						((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_hayland)*100), (int_inv_prairiesandreed), 			
						(Per_Acre_VC_NP), (Per_Acre_VC_IP), (Per_Acre_VC_HL), propertytaxescropland + (0), propertytaxespasture + (sizing_pastureland_value * 0.5 * lease_man_fee_percent), propertytaxespasture + (sizing_pastureland_value * 0.75 * lease_man_fee_percent), 
						propertytaxespasture + (sizing_pastureland_value * lease_man_fee_percent), 0, 0, (Per_Acre_VC_Bale_IP_1), (Per_Acre_VC_Bale_IP_2), (Per_Acre_VC_Hayproduction_1),
						(Per_Acre_VC_Hayproduction_2), (per_acre_breaking),  (farmer_exp_hay_price + transaction_fee_hay + (Per_Tonne_VC_Hay * trucking_distance)*No_Buy_Hay), (farmer_exp_wheat_price*36.74 + transaction_fee_hay + (Per_Tonne_VC_Wheat * trucking_distance)), (farmer_exp_barley_price*45.93 + transaction_fee_hay + (Per_Tonne_VC_Barley * trucking_distance)), 
						(Per_ton_feed_hay_cost), (Per_ton_feed_hay_cost), (Per_ton_feed_hay_cost), (Per_ton_feed_hay_cost), 
						(Per_ton_grain_cost), (Per_ton_grain_cost), (Per_ton_straw_bale_cost), (Per_ton_straw_bale_cost), (transaction_fee_hay), 
						(NewCostCow), (VC_Cow), (FC_Cow_Labour), (inv_handling), (inv_cow_machine), ((farmer_exp_cull_price * cull_transaction_cost) + sell_cows_fee), customhire,		
				Machine_VC_2, Machine_VC_3, Machine_VC_4, Machine_VC_5,
				Machine_VC_6, Machine_VC_7, Machine_VC_8, Machine_VC_9,
				inv_mach_2, inv_mach_3, inv_mach_4, inv_mach_5, inv_mach_6,
				inv_mach_7, inv_mach_8, inv_mach_9, -1};
			}
			else{
				borrowing = new double[] {
						Per_Acre_VC_Barley,
						Per_Acre_VC_Barley + producer_premium_barley_notill
						+ (Per_Tonne_VC_Barley * loc_tonnes_crop_barley_notill * trucking_distance),
				Per_Acre_VC_Canola + producer_premium_canola_notill
						+ (Per_Tonne_VC_Canola * tonnes_crop_canola_notill * trucking_distance),
				Per_Acre_VC_Wheat,		
				Per_Acre_VC_Wheat + producer_premium_wheat_notill
						+ (Per_Tonne_VC_Wheat * loc_tonnes_crop_wheat_notill * trucking_distance),
				Per_Acre_VC_Durum + producer_premium_durum_notill
						+ (Per_Tonne_VC_Durum * tonnes_crop_durum_notill * trucking_distance),
				Per_Acre_VC_Flax + producer_premium_flax_notill
						+ (Per_Tonne_VC_Flax * tonnes_crop_flax_notill * trucking_distance),
				Per_Acre_VC_Peas + producer_premium_peas_notill
						+ (Per_Tonne_VC_Peas * tonnes_crop_peas_notill * trucking_distance),
				Per_Acre_VC_Lentils + producer_premium_lentils_notill
						+ (Per_Tonne_VC_Lentils * tonnes_crop_lentils_notill * trucking_distance),
						(willows_annualized_cost_np), (willows_annualized_cost_ip), (willows_annualized_cost_hayland), (int_inv_willows), 
						(poplar_annualized_cost_np), (poplar_annualized_cost_ip), 
						(poplar_annualized_cost_hayland), (int_inv_poplar), 
						((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_np)), ((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_ip)), 
						((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_hayland)), (int_inv_prairiesandreed), 			
						(Per_Acre_VC_NP), (Per_Acre_VC_IP), (Per_Acre_VC_HL), propertytaxescropland + (0), propertytaxespasture + (sizing_pastureland_value * 0.5 * lease_man_fee_percent), propertytaxespasture + (sizing_pastureland_value * 0.75 * lease_man_fee_percent), 
						propertytaxespasture + (sizing_pastureland_value * lease_man_fee_percent), 0, 0, (Per_Acre_VC_Bale_IP_1), (Per_Acre_VC_Bale_IP_2), (Per_Acre_VC_Hayproduction_1),
						(Per_Acre_VC_Hayproduction_2), (per_acre_breaking),  (farmer_exp_hay_price + transaction_fee_hay + (Per_Tonne_VC_Hay * trucking_distance)*No_Buy_Hay), (farmer_exp_wheat_price*36.74 + transaction_fee_hay + (Per_Tonne_VC_Wheat * trucking_distance)), (farmer_exp_barley_price*45.93 + transaction_fee_hay + (Per_Tonne_VC_Barley * trucking_distance)), 
						(Per_ton_feed_hay_cost), (Per_ton_feed_hay_cost), (Per_ton_feed_hay_cost), (Per_ton_feed_hay_cost), 
						(Per_ton_grain_cost), (Per_ton_grain_cost), (Per_ton_straw_bale_cost), (Per_ton_straw_bale_cost), (transaction_fee_hay), 
						(NewCostCow), (VC_Cow), (FC_Cow_Labour), (inv_handling), (inv_cow_machine), ((farmer_exp_cull_price * cull_transaction_cost) + sell_cows_fee), customhire,		
				Machine_VC_2, Machine_VC_3, Machine_VC_4, Machine_VC_5,
				Machine_VC_6, Machine_VC_7, Machine_VC_8, Machine_VC_9,
				inv_mach_2, inv_mach_3, inv_mach_4, inv_mach_5, inv_mach_6,
				inv_mach_7, inv_mach_8, inv_mach_9, -1};	
			}
			
			
			daratio = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(int_inv_willows * min_ratio), 0, 0, 0, -(int_inv_poplar * min_ratio), 0, 0, 0, -(int_inv_prairiesandreed * min_ratio), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(per_acre_breaking * min_ratio), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(NewCostCow * min_ratio), 0, 0, -(inv_handling * min_ratio), -(inv_cow_machine * min_ratio), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(inv_mach_2 * min_ratio), -(inv_mach_3 * min_ratio), -(inv_mach_4 * min_ratio), -(inv_mach_5 * min_ratio), -(inv_mach_6 * min_ratio), -(inv_mach_7 * min_ratio), -(inv_mach_8 * min_ratio), -(inv_mach_9 * min_ratio), 1  };

			hay_transfer = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(exp_ip_early_yield_bale_one*error), -(exp_ip_late_yield_bale_two*error), -(exp_hay_early_yield_bale_one*error), -(exp_hay_late_yield_bale_two*error), 0, -1, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			barley_transfer = new double[] {-(barley_exp_yield/45.93), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			wheat_transfer = new double[] {0, 0, 0, -(wheat_exp_yield/36.74), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			barley_strawtransfer = new double[] {-(barley_exp_yield/45.93), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			wheat_strawtransfer = new double[] {0, 0, 0, -(wheat_exp_yield/36.74), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			early_pasture_mcals = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(exp_mcals_np_early_yield), -(exp_mcals_ip_early_yield), -(exp_mcals_hayland_early_yield), 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(weighted_avg_mcals_bale_one), 0, 0, 0, 0, 0, 0, 0, 0, 0, (Variables.getmcals_required_early_summer()), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			late_pasture_mcals = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(exp_mcals_np_late_yield), -(exp_mcals_np_late_yield), -(exp_mcals_hayland_late_yield), 0, 0, 0, 0, -0.5, 1, -(Variables.getmcals_ton_ip_baled_one()), 0, -(Variables.getmcals_ton_hayland_baled_one()), 0, 0, 0, 0, 0, 0, -(weighted_avg_mcals_bale_one), 0, 0, 0, 0, 0, 0, 0, 0, (Variables.getmcals_required_late_summer()), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			fall_pasture_mcals = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(exp_mcals_np_fall_yield), -(exp_mcals_ip_fall_yield), -(exp_mcals_hayland_fall_yield), 0, 0, 0, 0, 0, -0.5, -(Variables.getmcals_ton_ip_baled_two()), -(Variables.getmcals_ton_ip_baled_two()), -(Variables.getmcals_ton_hayland_baled_two()), -(Variables.getmcals_ton_hayland_baled_two()), 0, 0, 0, 0, 0, 0, -(weighted_avg_mcals_bale_two), 0, 0, 0, 0, 0, 0, 0, (Variables.getmcals_required_fall()), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};	
			
			winter_pasture_mcals = new double[] {-3394, 0, 0, -3724, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(weighted_avg_mcals_bale_two), -3724, -3394, -664, -823, 0, 0, (Variables.getmcals_required_winter()), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			max_feeding_mcals = new double[] {-((1-alpha)*3394), 0, 0, -((1-alpha)*3724), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(alpha*weighted_avg_mcals_bale_two), ((1-alpha)*3724), ((1-alpha)*3394), -((1-alpha)*664), -((1-alpha)*823), 0, 0, (Variables.getmcals_required_winter()), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			
			cows_handling_constraint = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (handling_transfer), 0, -(cows_handling_system_limit), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			cows_machine_constraint = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (handling_transfer), 0, 0, -(cows_machine_limit), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
				
			cows_acres_required = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(np_cow_acre), -(ip_cow_acre), -(hayland_cow_acre), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (total_cow_acre), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			
			double cropland = this.gettotal_crop_acres();		
			double cerealland = Math.round(cereallimit_notill * cropland);
			double maxwheatlimit = 0;
			double maxbarleylimit = 0;
			double maxdurumlimit = 0;
		
			if(getfarmer_type() == 2 || getfarmer_type() == 3){	
				maxwheatlimit = Math.round(0.025 * cerealland * maxwheat_limit);
				maxbarleylimit = Math.round(0.025 * cerealland * maxbarley_limit);
				maxdurumlimit = Math.round(0.0 * cerealland * maxdurum_limit);
				}
				else{
					maxwheatlimit = Math.round(maxwheat_limit * cerealland);
					maxbarleylimit = Math.round(maxbarley_limit * cerealland);
					maxdurumlimit = Math.round(maxdurum_limit * cerealland);
				}
			
			double oilseedland = Math.round(oilseedlimit_notill * cropland);
			double maxflaxlimit = Math.round(maxflax_limit * oilseedland);
			double maxcanolalimit = Math.round(maxcanola_limit * oilseedland);
			double pulseland = Math.round(pulselimit_notill * cropland);
			double maxpeaslimit = Math.round(maxpeas_limit * pulseland);
			double maxlentilslimit = Math.round(maxlentils_limit * pulseland);
			double maxfeedwheatlimit = cerealland;
			double maxfeedbarleylimit = cerealland;
			
			double cow_constraint = 300; 
			double cow_mach_constraint = 300;
			double customhirelimit = (Double)p.getValue("option0Limit");
			
			double haylandpastureland = gettotal_hay() - (getwillowshaylandpasture() + getpoplarhaylandpasture() + getprairiesandreedhaylandpasture());
			
			double improvedpastureland = haylandpastureland + gettotal_improved_pasture() - (getwillowsimprovedpasture() + getpoplarimprovedpasture() + getprairiesandreedimprovedpasture());
			
			double naturalpastureland = improvedpastureland + gettotal_natural_pasture() - (getwillowsnaturalpasture() + getpoplarnaturalpasture() + getprairiesandreednaturalpasture());
						
						
			int oldasset_olddebt = (int) (min_ratio* assets - (debt - debt_payment));
			if(oldasset_olddebt < 0) {
				oldasset_olddebt = 0;
			}
			
			
			try {
				// // Create a problem with 71 variables and 48 constraints
				LpSolve solver = LpSolve.makeLp(48, 71);
				
				
				solver.setInt(50, true); // Cows Labour
				solver.setInt(51, true); //cow fc handling system
				solver.setInt(52, true); //cow fc machinery
				solver.setInt(63, true); // Machine option 2
				solver.setInt(64, true); // Machine option 3
				solver.setInt(65, true); // Machine option 4
				solver.setInt(66, true); // Machine option 5
				solver.setInt(67, true); // Machine option 6
				solver.setInt(68, true); // Machine option 7
				solver.setInt(69, true); // Machine option 8
				solver.setInt(70, true); // Machine option 9
				
				// // // add constraints
				
				solver.strAddConstraint("1 1 1 1 1 1 1 1 1 1 1 1 0 1 1 1 0 1 1 1 0 1 1 1 1 1 1 1 0 0 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, gettotal_acres_farmed());
						
				solver.strAddConstraint("1 1 1 1 1 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, cropland); // Crop land (acres)
								
				solver.strAddConstraint("1 1 0 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, cerealland); // Cereal (wheat, durum, and Barley)
				
				solver.strAddConstraint("0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, maxfeedwheatlimit); // Max Acres a farme can seed spring wheat
							
				solver.strAddConstraint("0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, maxwheatlimit); // Max Acres a farme can seed spring wheat
				
				solver.strAddConstraint("0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, maxdurumlimit);
				
				solver.strAddConstraint("1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, maxfeedbarleylimit);
							
				solver.strAddConstraint("0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, maxbarleylimit);
							
				solver.strAddConstraint("0 0 1 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, oilseedland);
								
				solver.strAddConstraint("0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, maxcanolalimit);
								
				solver.strAddConstraint("0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, maxflaxlimit);
								
				solver.strAddConstraint("0 0 0 0 0 0 0 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, pulseland);
								
				solver.strAddConstraint("0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, maxpeaslimit);
								
				solver.strAddConstraint("0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, maxlentilslimit);
				
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, customhirelimit); // customhire limit
							
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 -2000 0 0 0 0 0 0 0 0", LpSolve.LE, 0); // Machine operate 2
								
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 -3200 0 0 0 0 0 0 0", LpSolve.LE, 0); // Machine operate 3
								
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 -4300 0 0 0 0 0 0", LpSolve.LE, 0); // Machine operate 4
								
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 -9000 0 0 0 0 0", LpSolve.LE, 0); // Machine operate 5
							
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 -12300 0 0 0 0", LpSolve.LE, 0); // Machine operate 6
								
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 -18000 0 0 0", LpSolve.LE, 0); // Machine operate 7
							
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 -23500 0 0", LpSolve.LE, 0); // Machine operate 8
								
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 -28000 0", LpSolve.LE, 0); // Machine operate 9
								
				solver.strAddConstraint("1 1 1 1 1 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -1 -1 -1 -1 -1 -1 -1 -1 -1 0 0 0 0 0 0 0 0 0",LpSolve.LE, 0); // Machine acres required no-till farmer
				
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 1 1 1 0 1 1 1 0 1 1 1 0 1 1 1 0 1 1 1 0 0 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, naturalpastureland);
					
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 1 1 0 0 1 1 0 0 1 1 0 0 1 1 0 0 1 1 0 0 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, improvedpastureland);
								
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 0 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, haylandpastureland);
						
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 -300 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, cow_constraint); //Cows Labour Limit
			
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -1 1 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, getn_cows()); //Cows Labour Limit
				
				
				String str = convertDoubleArrayToString(borrowing);
				solver.strAddConstraint(str, LpSolve.LE, this.getcash()); //

				String str1 = convertDoubleArrayToString(daratio);
				solver.strAddConstraint(str1, LpSolve.LE, oldasset_olddebt); // Debt-Asset
																				// Ratio
				String str2 = convertDoubleArrayToString(hay_transfer);
				solver.strAddConstraint(str2, LpSolve.LE, 0);
				
				String str3 = convertDoubleArrayToString(barley_transfer);
				solver.strAddConstraint(str3, LpSolve.LE, 0);
				
				String str4 = convertDoubleArrayToString(wheat_transfer);
				solver.strAddConstraint(str4, LpSolve.LE, 0);

				String str5 = convertDoubleArrayToString(barley_strawtransfer);
				solver.strAddConstraint(str5, LpSolve.LE, 0);
				
				String str6 = convertDoubleArrayToString(wheat_strawtransfer);
				solver.strAddConstraint(str6, LpSolve.LE, 0);
				
				String str7 = convertDoubleArrayToString(early_pasture_mcals);
				solver.strAddConstraint(str7, LpSolve.LE, 0);
				
				String str8 = convertDoubleArrayToString(late_pasture_mcals);
				solver.strAddConstraint(str8, LpSolve.LE, 0);
				
				String str9 = convertDoubleArrayToString(fall_pasture_mcals);
				solver.strAddConstraint(str9, LpSolve.LE, 0);
				
				String str10 = convertDoubleArrayToString(winter_pasture_mcals);
				solver.strAddConstraint(str10, LpSolve.LE, 0);
				
				String str11 = convertDoubleArrayToString(forage_breaking);
				solver.strAddConstraint(str11, LpSolve.LE, 0);
				
				String str12 = convertDoubleArrayToString(cows_handling_constraint);
				solver.strAddConstraint(str12, LpSolve.LE, cow_constraint);
				
				String str13 = convertDoubleArrayToString(cows_machine_constraint);
				solver.strAddConstraint(str13, LpSolve.LE, cow_mach_constraint);
		
				String str14 = convertDoubleArrayToString(cows_acres_required);
				solver.strAddConstraint(str14, LpSolve.LE, (0));
				
				String str15 = convertDoubleArrayToString(max_feeding_mcals);
				solver.strAddConstraint(str15, LpSolve.LE, 0);
				
				String newStrCon = convertDoubleArrayToString(contribution_margin);

			
				
				solver.strSetObjFn(newStrCon);
				solver.setMaxim();
				solver.solve();
				solver.getPtrVariables(); // Store this value to a string
				solver.getObjective(); // Store this value to a string
				
				
				
				expected_income = solver.getObjective();
				if(getexpected_income() == - solver.getInfinite() || getexpected_income() == solver.getInfinite() || solver.getPtrVariables()[46] == solver.getInfinite() || solver.getPtrVariables()[45] == solver.getInfinite() || solver.getPtrVariables()[47] == solver.getInfinite() || solver.getPtrVariables()[65] == solver.getInfinite()) {
					setinfeasiblesolution(true);
					expected_income = 0;
					barley_notill = 0;
					canola_notill = 0;
					wheat_notill = 0;
					durum_notill = 0;
					flax_notill = 0;
					peas_notill = 0;
					lentils_notill = 0;
					willows_on_natural_pasture = 0;
					willows_on_improved_pasture = 0;
					willows_on_hayland_pasture = 0;
					willows_initial_investment = 0;
					poplar_on_natural_pasture = 0;
					poplar_on_improved_pasture = 0;
					poplar_on_hayland_pasture = 0;
					poplar_initial_investment = 0;
					prairie_sandreed_on_natural_pasture = 0;
					prairie_sandreed_on_improved_pasture = 0;
					prairie_sandreed_on_hayland_pasture = 0;
					prairie_sandreed_initial_investment = 0;					
					natural_pasture = 0;
					improved_pasture = 0;
					hayland_pasture = 0;
					rent_out_cropland = 0;
					rent_out_natural_pasture = 0;
					rent_out_improved_pasture = 0;
					rent_out_hayland_pasture = 0;					
					pasture_carryover_one = 0;
					pasture_carryover_two = 0;
					improved_bale_first_cut = 0;
					improved_bale_second_cut = 0;
					hay_production_one_cut = 0;
					hay_production_two_cuts = 0;
					breaking_cost = 0;
					buy_hay = 0;
					buy_feed_wheat = 0;
					buy_feed_barley = 0;
					feed_early_summer_hay = 0;
					feed_late_summer_hay = 0;
					feed_fall_hay = 0;
					feed_winter_hay = 0;
					feed_wheat = 0;
					feed_barley = 0;
					wheat_straw = 0;
					barley_straw = 0;
					sell_hay = 0;
					cows_head = 0;
					cows_labour = 0;	
					cows_fc_handling_system = 0;
					cows_fc_machinery = 0; 
					option_2_acres = 0;
					option_3_acres = 0;
					option_4_acres = 0;
					option_5_acres = 0;
					option_6_acres = 0;
					option_7_acres = 0;
					option_8_acres = 0;
					option_9_acres = 0;
					option_2_number_machines = 0;
					option_3_number_machines = 0;
					option_4_number_machines = 0;
					option_5_number_machines = 0;
					option_6_number_machines = 0;
					option_7_number_machines = 0;
					option_8_number_machines = 0;
					option_9_number_machines = 0;
					rent_pasture_land = 0;
					rent_cropland = 0;
					amount_borrow = 0;
				}
			 else {
				double[] var = solver.getPtrVariables(); // This is the crop mix
				for (double d : var) {

				}
				for (int i = 0; i < var.length; i++) {
					feed_barley_notill = var[0];
					barley_notill = var[1];
					canola_notill = var[2];
					feed_wheat_notill = var[3];
					wheat_notill = var[4];
					durum_notill = var[5];
					flax_notill = var[6];
					peas_notill = var[7];
					lentils_notill = var[8];
					willows_on_natural_pasture = var[9];
					willows_on_improved_pasture = var[10];
					willows_on_hayland_pasture = var[11];
					willows_initial_investment = var[12];
					poplar_on_natural_pasture = var[13];
					poplar_on_improved_pasture = var[14];
					poplar_on_hayland_pasture = var[15];
					poplar_initial_investment = var[16];
					prairie_sandreed_on_natural_pasture = var[17];
					prairie_sandreed_on_improved_pasture = var[18];
					prairie_sandreed_on_hayland_pasture = var[19];
					prairie_sandreed_initial_investment = var[20];		
					natural_pasture = var[21];
					improved_pasture = var[22];
					hayland_pasture = var[23];
					rent_out_cropland = var[24];
					rent_out_natural_pasture = var[25];
					rent_out_improved_pasture = var[26];
					rent_out_hayland_pasture = var[27];
					pasture_carryover_one = var[28];
					pasture_carryover_two = var[29];
					improved_bale_first_cut = var[30];
					improved_bale_second_cut = var[31];
					hay_production_one_cut = var[32];
					hay_production_two_cuts = var[33];
					breaking_cost = var[34];
					buy_hay = var[35];
					buy_feed_wheat = var[36];
					buy_feed_barley = var[37];
					feed_early_summer_hay = var[38];
					feed_late_summer_hay = var[39];
					feed_fall_hay = var[40];
					feed_winter_hay = var[41];
					feed_wheat = var[42];
					feed_barley = var[43];
					wheat_straw = var[44];
					barley_straw = var[45];
					sell_hay = var[46];
					invest_cows = var[47];
					cows_head = var[48];
					cows_labour = (int) var[49];	
					cows_fc_handling_system = (int) var[50];
					cows_fc_machinery = (int) var[51]; 
					sell_cull_cows = (int) var[52];
					crop_custom_hire = (int) var[53];
					option_2_acres = (int) var[54];
					option_3_acres = (int) var[55];
					option_4_acres = (int) var[56];
					option_5_acres = (int) var[57];
					option_6_acres = (int) var[58];
					option_7_acres = (int) var[59];
					option_8_acres = (int) var[60];
					option_9_acres = (int) var[61];
					option_2_number_machines = (int) var[62];
					option_3_number_machines = (int) var[63];
					option_4_number_machines = (int) var[64];
					option_5_number_machines = (int) var[65];
					option_6_number_machines = (int) var[66];
					option_7_number_machines = (int) var[67];
					option_8_number_machines = (int) var[68];
					option_9_number_machines = (int) var[69];
					amount_borrow = (int) var[70];
										
					}
//				}
//				int idd = this.getID();
//				int farmerID = this.getfarmer_name();
//				int run_number = Variables.getrun_number();
//				int year = Variables.getyear();
//				int tillage_fallow = (int) gettillage_fallow();
//				int wheat_on_fallow = (int) getwheat_on_fallow();
//				int durum_stubble = (int) getdurum_stubble();
//				int canola_stubble = (int) getcanola_stubble();
//				int feed_barley_con = (int) getfeed_barley_con();
//				int barley_stubble = (int) getbarley_stubble();
//				int feed_wheat_con = (int) getfeed_wheat_con();
//				int wheat_stubble = (int) getwheat_stubble();
//				int flax_stubble = (int) getflax_stubble();
//				int peas_stubble = (int) getpeas_stubble();
//				int feed_barley_notill = (int) getfeed_barley_notill();
//				int barley_notill = (int) getbarley_notill();
//				int canola_notill = (int) getcanola_notill();
//				int feed_wheat_notill = (int) getfeed_wheat_notill();
//				int wheat_notill = (int) getwheat_notill();
//				int durum_notill = (int) getdurum_notill();
//				int flax_notill = (int) getflax_notill();
//				int lentils_notill = (int) getlentils_notill();
//				int peas_notill = (int) getpeas_notill();
//				int willows_on_natural_pasture = (int) getwillows_on_natural_pasture();
//				int willows_on_improved_pasture = (int) getwillows_on_improved_pasture();
//				int willows_on_hayland_pasture = (int) getwillows_on_hayland_pasture();
//				int willows_initial_investment = (int) getwillows_initial_investment();
//				int poplar_on_natural_pasture = (int) getpoplar_on_natural_pasture();
//				int poplar_on_improved_pasture = (int) getpoplar_on_improved_pasture();
//				int poplar_on_hayland_pasture = (int) getpoplar_on_hayland_pasture();
//				int poplarinitial_investment = (int) getpoplar_initial_investment();
//				int prairie_sandreed_on_natural_pasture = (int) getprairie_sandreed_on_natural_pasture();
//				int prairie_sandreed_on_improved_pasture = (int) getprairie_sandreed_on_improved_pasture();
//				int prairie_sandreed_on_hayland_pasture = (int) getprairie_sandreed_on_hayland_pasture();
//				int prairiesandreed_initial_investment = (int) getprairie_sandreed_initial_investment();
//				int natural_pasture = (int) getnatural_pasture();
//				int improved_pasture = (int) getimproved_pasture();
//				int hayland_pasture = (int) gethayland_pasture();
//				int rent_out_cropland = (int) getrent_out_cropland();
//				int rent_out_natural_pasture = (int) getrent_out_natural_pasture();
//				int rent_out_improved_pasture = (int) getrent_out_improved_pasture();
//				int rent_out_hayland_pasture = (int) getrent_out_hayland_pasture();
//				int pasture_carryover_one = (int) getpasture_carryover_one();
//				int pasture_carryover_two = (int) getpasture_carryover_two();
//				int improved_bale_first_cut = (int) getimproved_bale_first_cut();
//				int improved_bale_second_cut = (int) getimproved_bale_second_cut();
//				int hay_production_one_cut = (int) gethay_production_one_cut();
//				int hay_production_two_cuts = (int) gethay_production_two_cuts();
//				int breaking_cost = (int) getbreaking_cost();
//				int buy_hay = (int) getbuy_hay();
//				int buy_feed_wheat = (int) getbuy_feed_wheat();
//				int buy_feed_barley = (int) getbuy_feed_barley();
//				int feed_early_summer_hay = (int) getfeed_early_summer_hay();
//				int feed_late_summer_hay = (int) getfeed_late_summer_hay();
//				int feed_fall_hay = (int) getfeed_fall_hay();
//				int feed_winter_hay = (int) getfeed_winter_hay();
//				int feed_wheat = (int) getfeed_wheat();
//				int feed_barley = (int) getfeed_barley();
//				int wheat_straw = (int) getwheat_straw();
//				int barley_straw = (int) getbarley_straw();
//				int sell_hay = (int) getsell_hay();
//				int invest_cows = (int) getinvest_cows();
//				int cows_head = (int) getcows_head();
//				int cows_labour = (int) getcows_labour();
//				int cows_fc_handling_system = (int) getcows_fc_handling_system();
//				int cows_fc_machinery = (int) getcows_fc_machinery();
//				int sell_cull_cows = (int) getsell_cull_cows();
//				int crop_custom_hire = (int) getcrop_custom_hire();
//				int option_0_acres = (int) getoption_0_acres();
//				int option_1_acres = (int) getoption_1_acres();
//				int option_2_acres = (int) getoption_2_acres();
//				int option_3_acres = (int) getoption_3_acres();
//				int option_4_acres = (int) getoption_4_acres();
//				int option_5_acres = (int) getoption_5_acres();
//				int option_6_acres = (int) getoption_6_acres();
//				int option_7_acres = (int) getoption_7_acres();
//				int option_8_acres = (int) getoption_8_acres();
//				int option_9_acres = (int) getoption_9_acres();
//				int option_0_number_machines = (int) getoption_0_number_machines();
//				int option_1_number_machines = (int) getoption_1_number_machines();
//				int option_2_number_machines = (int) getoption_2_number_machines();
//				int option_3_number_machines = (int) getoption_3_number_machines();
//				int option_4_number_machines = (int) getoption_4_number_machines();
//				int option_5_number_machines = (int) getoption_5_number_machines();
//				int option_6_number_machines = (int) getoption_6_number_machines();
//				int option_7_number_machines = (int) getoption_7_number_machines();
//				int option_8_number_machines = (int) getoption_8_number_machines();
//				int option_9_number_machines = (int) getoption_9_number_machines();
//				int rent_pasture_land =   0;
//				int rent_cropland = 0;				
//				int amount_borrow = (int) getamount_borrow();
//				int expected_income = (int) getexpected_income();
//
//				try {
//					Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
//				} catch (ClassNotFoundException ce) {
//					System.out.println("SQLExceptiong:" + ce.getMessage());
//				}
//				try {
//				Connection conn = DriverManager.getConnection(
//							"jdbc:odbc:producerDB", "java", "1234");
//					Statement stmt = conn.createStatement();
//
//					stmt.executeUpdate("insert into Reoptimized values ('" 
//							+ idd 
//							+ "', '" + farmerID 
//							+ "', '" + run_number
//							+ "','" + year 
//							+ "', '" + tillage_fallow 
//							+ "', '" + wheat_on_fallow
//							+ "', '" + durum_stubble
//							+ "', '" + canola_stubble 
//							+ "', '" + feed_barley_con
//							+ "', '" + barley_stubble
//							+ "', '" + feed_wheat_con
//							+ "', '" + wheat_stubble 
//							+ "', '" + flax_stubble
//							+ "', '" + peas_stubble
//							+ "', '" + feed_barley_notill
//							+ "', '" + barley_notill
//							+ "', '" + canola_notill
//							+ "', '" + feed_wheat_notill
//							+ "', '" + wheat_notill
//							+ "', '" + durum_notill
//							+ "', '" + flax_notill
//							+ "', '" + lentils_notill
//							+ "', '" + peas_notill
//							+ "', '" + willows_on_natural_pasture
//							+ "', '" + willows_on_improved_pasture
//							+ "', '" + willows_on_hayland_pasture
//							+ "', '" + willows_initial_investment
//							+ "', '" + poplar_on_natural_pasture
//							+ "', '" + poplar_on_improved_pasture
//							+ "', '" + poplar_on_hayland_pasture
//							+ "', '" + poplarinitial_investment
//							+ "', '" + prairie_sandreed_on_natural_pasture
//							+ "', '" + prairie_sandreed_on_improved_pasture
//							+ "', '" + prairie_sandreed_on_hayland_pasture
//							+ "', '" + prairiesandreed_initial_investment
//							+ "', '" + natural_pasture 
//							+ "' , '" + improved_pasture
//							+ "', '" + hayland_pasture 
//							+ "', '" + rent_out_cropland
//							+ "', '" + rent_out_natural_pasture
//							+ "', '" + rent_out_improved_pasture
//							+ "', '" + rent_out_hayland_pasture
//							+ "', '"  + pasture_carryover_one 
//							+ "', '" + pasture_carryover_two 
//							+ "', '"+ improved_bale_first_cut 
//							+ "', '" + improved_bale_second_cut 
//							+ "', '" + hay_production_one_cut 
//							+ "', '" + hay_production_two_cuts 
//							+ "', '" + breaking_cost
//							+ "', '" + buy_hay
//							+ "', '" + buy_feed_wheat 
//							+ "', '" + buy_feed_barley 
//							+ "', '" + feed_early_summer_hay 
//							+ "', '" + feed_late_summer_hay 
//							+ "', '" + feed_fall_hay 
//							+ "', '" + feed_winter_hay 
//							+ "', '" + feed_wheat 
//							+ "', '" + feed_barley 
//							+ "', '" + wheat_straw
//							+ "', '" + barley_straw
//							+ "', '" + sell_hay 
//							+ "', '" + invest_cows
//							+ "', '" + cows_head 
//							+ "', '" + cows_labour 
//							+ "', '" + cows_fc_handling_system
//							+ "', '" + cows_fc_machinery
//							+ "', '" + sell_cull_cows
//							+ "', '" + crop_custom_hire
//							+ "', '" + option_0_acres 
//							+ "', '" + option_1_acres
//							+ "', '" + option_2_acres 
//							+ "', '" + option_3_acres
//							+ "', '" + option_4_acres 
//							+ "', '" + option_5_acres
//							+ "', '" + option_6_acres 
//							+ "', '" + option_7_acres
//							+ "', '" + option_8_acres 
//							+ "', '" + option_9_acres
//							+ "', '" + option_0_number_machines 
//							+ "', '" + option_1_number_machines 
//							+ "', '" + option_2_number_machines 
//							+ "', '" + option_3_number_machines 
//							+ "', '" + option_4_number_machines 
//							+ "', '" + option_5_number_machines 
//							+ "', '" + option_6_number_machines 
//							+ "', '" + option_7_number_machines 
//							+ "', '" + option_8_number_machines 
//							+ "', '" + option_9_number_machines 
//							+ "', '" + rent_pasture_land 
//							+ "', '" + rent_cropland	
//							+ "', '" + amount_borrow 
//							+ "', '" + expected_income + "')");	
//
//					stmt.close();
//					conn.close();
//				} catch (SQLException ce) {
//					ce.printStackTrace();
//					System.out.println("HELL 6 SQLException:" + ce.getMessage());
				}
				solver.deleteLp();
			} catch (LpSolveException e) {
				e.printStackTrace();
			}
		}
	}

			
	
	public void reoptimized_mip_conventional() {	
		if (this.gettotal_crop_acres() <= 2000) { // conventional farmer
			expected_income = 0;
			tillage_fallow = 0;
			wheat_on_fallow = 0;
			durum_stubble = 0;
			canola_stubble = 0;
			barley_stubble = 0;
			wheat_stubble = 0;
			flax_stubble = 0;
			peas_stubble = 0;
			willows_on_natural_pasture = 0;
			willows_on_improved_pasture = 0;
			willows_on_hayland_pasture = 0;
			willows_initial_investment = 0;
			poplar_on_natural_pasture = 0;
			poplar_on_improved_pasture = 0;
			poplar_on_hayland_pasture = 0;
			poplar_initial_investment = 0;
			prairie_sandreed_on_natural_pasture = 0;
			prairie_sandreed_on_improved_pasture = 0;
			prairie_sandreed_on_hayland_pasture = 0;
			prairie_sandreed_initial_investment = 0;
			natural_pasture = 0;
			improved_pasture = 0;
			hayland_pasture = 0;
			rent_out_cropland = 0;
			rent_out_natural_pasture = 0;
			rent_out_improved_pasture = 0;
			rent_out_hayland_pasture = 0;
			pasture_carryover_one = 0;
			pasture_carryover_two = 0;
			improved_bale_first_cut = 0;
			improved_bale_second_cut = 0;
			hay_production_one_cut = 0;
			hay_production_two_cuts = 0;
			breaking_cost = 0;
			buy_hay = 0;
			buy_feed_wheat = 0;
			buy_feed_barley = 0;
			feed_early_summer_hay = 0;
			feed_late_summer_hay = 0;
			feed_fall_hay = 0;
			feed_winter_hay = 0;
			feed_wheat = 0;
			feed_barley = 0;
			wheat_straw = 0;
			barley_straw = 0;					
			sell_hay = 0;
			cows_head = 0;
			cows_labour = 0;   
			cows_fc_handling_system = 0;
			cows_fc_machinery = 0; 
			option_0_acres = 0;
			option_1_acres = 0;
			option_0_number_machines = 0;
			option_1_number_machines = 0;
			rent_pasture_land = 0;
			rent_cropland = 0;
			amount_borrow = 0;				
		Parameters p = RunEnvironment.getInstance().getParameters();
		double cereal_mcal_limit = (Double)p.getValue("cereal_mcal_limit");
		double min_ratio = (Double) p.getValue("minRatio");
		double inv_mach_0 = (Double) p.getValue("inv_Mach_0");
		double inv_mach_1 = (Double) p.getValue("inv_Mach_1");
		double rent_crop_land = (Double) p.getValue("rentCropLand");	
		double rent_pastureland = (Double) p.getValue("rentpastureland");
		double interest_rate = (Double) p.getValue("discountRate");
		double Per_Acre_VC_Flax_on_Stubble = (Double) p.getValue("perAcreVCFlaxonStubble");
		double Per_Acre_VC_Peas_on_Stubble = (Double) p.getValue("perAcreVCPeasonStubble");
		double Per_Acre_VC_Durum_on_Stubble = (Double) p.getValue("perAcreVCDurumonStubble");
		double Per_Acre_VC_Willows = (Double) p.getValue("perAcreVCWillows");		
		double Per_Tonne_VC_Durum = (Double) p.getValue("perTonneVCDurum");
		double Per_Tonne_VC_Wheat = (Double) p.getValue("perTonneVCWheat"); // Variable
		double Per_Tonne_VC_Canola = (Double) p.getValue("perTonneVCCanola"); // Variable
		double Per_Tonne_VC_Barley = (Double) p.getValue("perTonneVCBarley"); // Variable
		double Per_Tonne_VC_Flax = (Double) p.getValue("perTonneVCFlax");
		double Per_Tonne_VC_Lentils = (Double) p.getValue("perTonneVCLentils");
	 	double Per_Tonne_VC_Peas = (Double) p.getValue("perTonneVCPeas");			
		double Per_Acre_VC_Summer_Fallow = (Double) p
				.getValue("perAcreVCSummerFallow"); // Variable cost per acre
		double Per_Acre_VC_Wheat_on_Fallow = (Double) p
				.getValue("perAcreVCWheatonFallow"); // Variable cost per acre
		double Per_Acre_VC_Canola_on_Stubble = (Double) p
				.getValue("perAcreVCCanolaonStubble"); // Variable cost per acre
		double Per_Acre_VC_Barley_on_Stubble = (Double) p
				.getValue("perAcreVCBarleyonStubble"); // Variable cost per acre
		double Per_Acre_VC_Wheat_on_Stubble = (Double) p
				.getValue("perAcreVCWheatonStubble"); // Variable cost per acre
		double Per_Acre_VC_NP = (Double) p.getValue("peracrevcnp");
		double Per_Acre_VC_IP = (Double) p.getValue("peracrevcip");
		double Per_Acre_VC_HL = (Double) p.getValue("peracrevchl");
		double Per_Acre_VC_Bale_IP_1 = (Double) p.getValue("peracrevcbaleip1");
		double Per_Acre_VC_Bale_IP_2 = (Double) p.getValue("peracrevcbaleip2");
		double Per_Acre_VC_Hayproduction_1 = (Double) p.getValue("peracrevchayproduction1");
		double Per_Acre_VC_Hayproduction_2 = (Double) p.getValue("peracrevchayproduction2");
		double Per_ton_feed_hay_cost = (Double) p.getValue("pertonfeedhaycost");
		double Per_ton_grain_cost = (Double) p.getValue("pertonfeedgraincost");
		double transaction_fee_hay = (Double) p.getValue("transactionfeehay");
		double VC_Cow = (Double) p.getValue("vccow");
		double FC_Cow_Labour = (Double) p.getValue("fccowlabour");
		double Per_ton_straw_bale_cost = (Double) p.getValue("pertonstrawbalecost");
		double pr_rating = 0;
		double pr_max_hay_yield = (Double)p.getValue("prmaxhayyield");	
		double threshold_hay_1 = (Double)p.getValue("thresholdhay1");
		double min_prairiesandreed_yield = (Double)p.getValue("min_psr_yield");
		double max_prairiesandreed_yield = (Double)p.getValue("max_psr_yield");
		double pr_max_psr_yield = (Double)p.getValue("pr_max_psr_yield");
		double fallow_yield_mult = (Double) p.getValue("fallow_yield_mult");
		double cereallimit_con = (Double)p.getValue("cereallimit_con");
		double oilseedlimit_con = (Double)p.getValue("oilseedlimit_con");
		double pulselimit_con = (Double)p.getValue("pulselimit_con");
		double maxwheat_limit = (Double)p.getValue("maxwheatlimit");
		double maxbarley_limit = (Double)p.getValue("maxbarleylimit");
		double maxdurum_limit = (Double)p.getValue("maxdurumlimit");
		double maxflax_limit = (Double)p.getValue("maxflaxlimit");
		double maxcanola_limit = (Double)p.getValue("maxcanolalimit");
		double psr_gj_tonne = (Double)p.getValue("psrgjtonne");
		double gjprice = (Double)p.getValue("gjprice");
		double No_Buy_Hay = (Double)p.getValue("NoBuyHay");
		tillage_fallow = 0;
		wheat_on_fallow = 0;
		durum_stubble = 0;
		canola_stubble = 0;
		barley_stubble = 0;
		wheat_stubble = 0;
		flax_stubble = 0;
		peas_stubble = 0;
		barley_notill = 0;
		canola_notill = 0;
		wheat_notill = 0;		
		natural_pasture = 0;
		improved_pasture = 0;
		hayland_pasture = 0;
		pasture_carryover_one = 0;
		pasture_carryover_two = 0;
		improved_bale_first_cut = 0;
		improved_bale_second_cut = 0;
		hay_production_one_cut = 0;
		hay_production_two_cuts = 0;
		breaking_cost = 0;
		buy_hay = 0;
		buy_feed_wheat = 0;
		buy_feed_barley = 0;
		feed_early_summer_hay = 0;
		feed_late_summer_hay = 0;
		feed_fall_hay = 0;
		feed_winter_hay = 0;
		feed_wheat = 0;
		feed_barley = 0;
		wheat_straw = 0;
		barley_straw = 0;					
		sell_hay = 0;
		cows_head = 0;
		cows_labour = 0;       //int 
		option_0_acres = 0;
		option_1_acres = 0;
		option_2_acres = 0;
		option_3_acres = 0;
		option_4_acres = 0;
		option_5_acres = 0;
		option_6_acres = 0;
		option_7_acres = 0;
		option_8_acres = 0;
		option_9_acres = 0;
		option_0_number_machines = 0;
		option_1_number_machines = 0;
		option_2_number_machines = 0;
		option_3_number_machines = 0;
		option_4_number_machines = 0;
		option_5_number_machines = 0;
		option_6_number_machines = 0;
		option_7_number_machines = 0;
		option_8_number_machines = 0;
		option_9_number_machines = 0;
		rent_pasture_land = 0;
		rent_cropland = 0;
		amount_borrow = 0;
		
		yield_mult = 1;

		Iterator<SAMA> it = mylandList.iterator();
		double tonnes_crop_canola_stubble = 0, loc_tonnes_crop_wheat_stubble = 0, loc_tonnes_crop_barley_stubble = 0, loc_tonnes_crop_wheat_sf = 0,
		tonnes_crop_flax_stubble = 0, tonnes_crop_peas_stubble = 0, tonnes_crop_flax_notill = 0, tonnes_crop_peas_notill = 0, tonnes_crop_lentils_notill = 0, tonnes_crop_durum_stubble = 0, tonnes_crop_durum_notill = 0;
	
		for (int i = 0; i < getmylandList().size(); i++) {
			SAMA sama = (SAMA) getmylandList().get(i);
			
			tonnes_crop_canola_stubble += yield_mult * sama.getCanolaYieldIndex() * yield_exp_list[0] / 44.09; 
			loc_tonnes_crop_wheat_stubble += yield_mult * sama.getWheatYieldIndex() * yield_exp_list[1] / 36.74;
			loc_tonnes_crop_barley_stubble += yield_mult * sama.getBarleyYieldIndex() * yield_exp_list[2] / 45.93;
			loc_tonnes_crop_wheat_sf += yield_mult * sama.getWheatSfYieldIndex() * yield_exp_list[1] / 36.74;
			tonnes_crop_flax_stubble += yield_mult * sama.getFlaxYieldIndex() * yield_exp_list[4] / 39.37;
			tonnes_crop_peas_stubble += yield_mult * sama.getPeasYieldIndex() * yield_exp_list[5] / 39.37;
			tonnes_crop_durum_stubble += yield_mult * sama.getDurumYieldIndex() * yield_exp_list[7] /36.37;
	
			
			if(sama.getnpQuality() > pr_max_psr_yield) {
				pr_rating = pr_max_psr_yield;
				prairiesandreed_yield_np = (pr_rating/pr_max_psr_yield * (max_prairiesandreed_yield - min_prairiesandreed_yield) + min_prairiesandreed_yield);
			}
			else {
				pr_rating = sama.getnpQuality();
				prairiesandreed_yield_np = (pr_rating/pr_max_psr_yield * (max_prairiesandreed_yield - min_prairiesandreed_yield) + min_prairiesandreed_yield);
			}
			if(sama.getIPQuality() > pr_max_psr_yield) {
				pr_rating = pr_max_psr_yield;
				prairiesandreed_yield_ip = (pr_rating/pr_max_psr_yield * (max_prairiesandreed_yield - min_prairiesandreed_yield) + min_prairiesandreed_yield);
			}
			else {
				pr_rating = sama.getIPQuality();
				prairiesandreed_yield_ip = (pr_rating/pr_max_psr_yield * (max_prairiesandreed_yield - min_prairiesandreed_yield) + min_prairiesandreed_yield);
			}			
			if(sama.getHayQuality() > pr_max_psr_yield) {
				pr_rating = pr_max_psr_yield;
				prairiesandreed_yield_hayland = (pr_rating/pr_max_psr_yield * (max_prairiesandreed_yield - min_prairiesandreed_yield) + min_prairiesandreed_yield);
			}
			else {
				pr_rating = sama.getHayQuality();
				prairiesandreed_yield_hayland = (pr_rating/pr_max_psr_yield * (max_prairiesandreed_yield - min_prairiesandreed_yield) + min_prairiesandreed_yield);
			}
			if(sama.getnpQuality() > pr_max_hay_yield) {
				pr_rating = pr_max_hay_yield;				
				exp_np_early_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3])));
				exp_np_late_yield = (pr_rating / pr_max_hay_yield *  ((yield_exp_list[3] * 0.6)));
				exp_np_fall_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3] * 0.2)));
				exp_mcals_np_early_yield = (exp_np_early_yield * Variables.getmcals_ton_np_early());
				exp_mcals_np_late_yield = (exp_np_late_yield * Variables.getmcals_ton_np_late());
				exp_mcals_np_fall_yield =(exp_np_fall_yield * Variables.getmcals_ton_np_fall());
			}
			else {
				pr_rating = sama.getnpQuality();				
				exp_np_early_yield = (pr_rating / pr_max_hay_yield * yield_exp_list[3]);
				exp_np_late_yield = ((pr_rating / pr_max_hay_yield *  (yield_exp_list[3]))*0.6);
				exp_np_fall_yield = ((pr_rating / pr_max_hay_yield * (yield_exp_list[3] ))*0.2);
				exp_mcals_np_early_yield = (exp_np_early_yield * Variables.getmcals_ton_np_early());
				exp_mcals_np_late_yield = (exp_np_late_yield * Variables.getmcals_ton_np_late());
				exp_mcals_np_fall_yield = (exp_np_fall_yield * Variables.getmcals_ton_np_fall());
			}
			if(sama.getIPQuality() > pr_max_hay_yield) {
				pr_rating = pr_max_hay_yield;				
				exp_ip_early_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3])));
				exp_ip_late_yield = (pr_rating / pr_max_hay_yield *  ((yield_exp_list[3] * 0.6)));
				exp_ip_fall_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3] * 0.2)));
				exp_ip_early_yield_bale_one = (pr_rating / pr_max_hay_yield * yield_exp_list[3]);				
				exp_ip_late_yield_bale_two = (exp_ip_early_yield + (0.6 * exp_ip_early_yield)) ;	
				exp_mcals_ip_early_yield = (exp_ip_early_yield * Variables.getmcals_ton_ip_early());
				exp_mcals_ip_late_yield = (exp_ip_late_yield * Variables.getmcals_ton_ip_late());
				exp_mcals_ip_fall_yield = (exp_ip_fall_yield * Variables.getmcals_ton_ip_fall());
			}
			else {
				pr_rating = sama.getIPQuality();				
				exp_ip_early_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3])));
				exp_ip_late_yield = (pr_rating / pr_max_hay_yield *  ((yield_exp_list[3] * 0.6)));
				exp_ip_fall_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3] * 0.2)));
				exp_ip_early_yield_bale_one = (pr_rating / pr_max_hay_yield * yield_exp_list[3]);				
				exp_ip_late_yield_bale_two = (exp_ip_early_yield + (0.6 * exp_ip_early_yield)) ;	
				exp_mcals_ip_early_yield = (exp_ip_early_yield * Variables.getmcals_ton_ip_early());
				exp_mcals_ip_late_yield = (exp_ip_late_yield * Variables.getmcals_ton_ip_late());
				exp_mcals_ip_fall_yield = (exp_ip_fall_yield * Variables.getmcals_ton_ip_fall());
			}
			if(sama.getHayQuality() > pr_max_hay_yield) {
				pr_rating = pr_max_hay_yield;				
				exp_hay_early_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3])));
				exp_hay_late_yield = (pr_rating / pr_max_hay_yield *  ((yield_exp_list[3] * 0.6)));
				exp_hay_fall_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3] * 0.2)));
				exp_hay_early_yield_bale_one = (pr_rating / pr_max_hay_yield * yield_exp_list[3]);				
				exp_hay_late_yield_bale_two = (exp_hay_early_yield + (0.6 * exp_hay_early_yield)) ;	
				exp_mcals_hayland_early_yield = (exp_hay_early_yield * Variables.getmcals_ton_hayland_early());
				exp_mcals_hayland_late_yield = (exp_hay_late_yield * Variables.getmcals_ton_hayland_late());
				exp_mcals_hayland_fall_yield = (exp_hay_fall_yield * Variables.getmcals_ton_hayland_fall());
			}
			else {
				pr_rating = sama.getHayQuality();				
				exp_hay_early_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3])));
				exp_hay_late_yield = (pr_rating / pr_max_hay_yield *  ((yield_exp_list[3] * 0.6)));
				exp_hay_fall_yield = (pr_rating / pr_max_hay_yield * ((yield_exp_list[3] * 0.2)));
				exp_hay_early_yield_bale_one = (pr_rating / pr_max_hay_yield * yield_exp_list[3]);				
				exp_hay_late_yield_bale_two = (exp_hay_early_yield + (0.6 * exp_hay_early_yield)) ;	
				exp_mcals_hayland_early_yield = (exp_hay_early_yield * Variables.getmcals_ton_hayland_early());
				exp_mcals_hayland_late_yield = (exp_hay_late_yield * Variables.getmcals_ton_hayland_late());
				exp_mcals_hayland_fall_yield = (exp_hay_fall_yield * Variables.getmcals_ton_hayland_fall());
			}
			
			if(gettotal_improved_pasture() + gettotal_hay() > 0) {
			weighted_avg_mcals_bale_one = ((((gettotal_improved_pasture()/(gettotal_improved_pasture() + gettotal_hay()))*Variables.getmcals_ton_ip_baled_one()) + 
					(((gettotal_hay()/(gettotal_improved_pasture() + gettotal_hay()))*Variables.getmcals_ton_hayland_baled_one()))));
		
			weighted_avg_mcals_bale_two = (((weighted_avg_mcals_bale_one) + ((((gettotal_improved_pasture()/(gettotal_improved_pasture() + gettotal_hay()))*Variables.getmcals_ton_ip_baled_two()) + 
					(((gettotal_hay()/(gettotal_improved_pasture() + gettotal_hay()))*Variables.getmcals_ton_hayland_baled_two()))))/2)/2);
					
			}			
			else {
			weighted_avg_mcals_bale_one = ((Variables.getmcals_ton_ip_baled_one() + Variables.getmcals_ton_hayland_baled_one())/2);
		
			weighted_avg_mcals_bale_two = ((((Variables.getmcals_ton_ip_baled_one() + Variables.getmcals_ton_hayland_baled_one())/2) + ((Variables.getmcals_ton_ip_baled_two() + Variables.getmcals_ton_hayland_baled_two())/2))/2);
			}
		}
		
		tonnes_crop_canola_stubble = tonnes_crop_canola_stubble/total_plots; 
		loc_tonnes_crop_wheat_stubble = loc_tonnes_crop_wheat_stubble/total_plots;
		loc_tonnes_crop_barley_stubble = loc_tonnes_crop_barley_stubble/total_plots;
		loc_tonnes_crop_wheat_sf = loc_tonnes_crop_wheat_sf/total_plots;
		tonnes_crop_flax_stubble = tonnes_crop_flax_stubble/total_plots;
		tonnes_crop_peas_stubble = tonnes_crop_peas_stubble/total_plots;
		tonnes_crop_durum_stubble = tonnes_crop_durum_stubble/total_plots;
		
		if(n_cows > 0){
		np_cow_acre = 0.5; //total_natural_pasture/n_cows;
		ip_cow_acre = 1; //total_improved_pasture/n_cows;
		hayland_cow_acre = 2; // total_hay/n_cows;
		
		total_cow_acre = 4; //(total_natural_pasture +  total_improved_pasture + total_hay)/n_cows;
		
		
		}
			
					
		
				average_years_in_grass = 0;
		for (int i = 0; i < getmylandList().size(); i++) {
			SAMA fdl1 = (SAMA) getmylandList().get(i);
			int countgrass = i;
			int countpsr = i;
				if(fdl1.getyears_in_grass() > 0) {
				countgrass++;
							
				average_years_in_grass = average_years_in_grass + fdl1.getyears_in_grass();
				
				}	
				if(fdl1.getyears_in_prairie_sandreed() > 0){
					countpsr++;
					
					average_years_in_prairie_sandreed = average_years_in_prairie_sandreed + fdl1.getyears_in_prairie_sandreed();
				}
		}
		
		
		
		if(getplots_in_grass() > 0){
			
			average_years_in_grass = average_years_in_grass/getplots_in_grass();
			}
		
		
			if(average_years_in_grass < 7) {
			
					forage_breaking = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0.5, 1, 0, 0, 0, 0, 0, 0, 0.5, 0.5, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
					}
				else {
					
					forage_breaking = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0.5, 1, 0, 0, 0, 0, 0, 0, 0.5, 0.5, 1, 1, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
				}			

			if(average_years_in_prairie_sandreed > 0 && average_years_in_prairie_sandreed < 7){
				prairiesandreed_yield_np = prairiesandreed_yield_np * -1;
				prairiesandreed_yield_ip = prairiesandreed_yield_np * -1;
				prairiesandreed_yield_hayland = prairiesandreed_yield_hayland * -1;
				}
			if(average_years_in_willows > 0 && average_years_in_willows < 21){
				willows_annualized_return_np = willows_annualized_return_np * -1;
				willows_annualized_return_ip = willows_annualized_return_ip * -1;
				willows_annualized_return_hayland = willows_annualized_return_hayland * -1;
			}
			if(average_years_in_poplar > 0 && average_years_in_poplar < 21){
				poplar_annualized_return_np = poplar_annualized_return_np * -1;
				poplar_annualized_return_ip = poplar_annualized_return_ip * -1;
				poplar_annualized_return_hayland = poplar_annualized_return_hayland * -1;
			
			}	
			prairie_sandreed_transfer = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0};
			willow_transfer = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			poplar_transfer = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
		
			handling_transfer = 1;
			cows_handling_system_limit = 300;
			cows_machine_limit = 300;
				
		double Machine_VC_0 = (Double) p.getValue("machineVC0");
		double Machine_VC_1 = (Double) p.getValue("machineVC1");
		double Machine_FC_0 = (Double) p.getValue("machineFC0"); // Fixed cost
		double Machine_FC_1 = (Double) p.getValue("machineFC1"); // Fixed cost
		double Per_Acre_Annualized_Breaking = (Double) p.getValue("peracreannualizedbreaking");
		double per_acre_breaking = (Double) p.getValue("peracrebreaking");
		double FC_Cow_Handling = (Double) p.getValue("fccowhandling");
		double FC_Cow_Machinery = (Double) p.getValue("fccowmachinery");
		double inv_handling = (Double) p.getValue("invhandling");
		double inv_cow_machine = (Double) p.getValue("invcowmachine");
		double int_inv_willows = (Double) p.getValue("intinvwillows");
		double annualizedbreakingwillows = (Double) p.getValue("annualizedbreakingwillows");
		double annualizedbreakingpoplar = (Double) p.getValue("annualizedbreakingpoplar");
		double annualizedbreakingprairiesandreed = (Double) p.getValue("annualizedbreakingprairiesandreed");
		double Per_Tonne_Poplar_Custom_Rate = (Double) p.getValue("perTonneWillowCustomRate");
		double Per_Tonne_PrairieSandReed_Custom_Rate = (Double) p.getValue("per_Tonne_PrairieSandreed_Custom_Rate");
		double int_inv_poplar = (Double) p.getValue("int_inv_poplar");
		double int_inv_prairiesandreed = (Double) p.getValue("int_inv_prairiesandreed");
		double avg_willow_yield = (Double)p.getValue("willowyield");
		double avg_willow_price = (Double)p.getValue("willowprice");
		double Per_Tonne_Willow_Custom_Rate = (Double) p.getValue("perTonneWillowCustomRate");	
		double lease_man_fee_percent = (Double)p.getValue("lease_man_fee_percent");
		double cull_transaction_cost = (Double)p.getValue("cull_transaction_cost");
		double sell_cows_fee = (Double)p.getValue("sellherdcost");
		double alpha = (Double) p.getValue("alpha");
		double gama = (Double)p.getValue("gama");
		double Per_Tonne_VC_Hay = (Double)p.getValue("perTonneVCHay");
			yield_mult = 1;
			double error = 1 + ((int) (Math.random()*10)-5.0)/100.0;
			double barley_exp_yield = yield_exp_list[2];
			double wheat_exp_yield = yield_exp_list[1];
			double prairiesandreed_price = (Double)p.getValue("psr_price");
			double propertytaxescropland = 6;
			double propertytaxespasture = 3;
			
			
			
				if(getfarmer_type() == 2 || getfarmer_type() == 3){
			contribution_margin = new double[] {
					-(Per_Acre_VC_Summer_Fallow),
					(fallow_yield_mult * yield_mult * wheat_exp_yield * farmer_exp_wheat_price)
							- ((Per_Acre_VC_Wheat_on_Fallow + producer_premium_wheat_fallow) + (Per_Tonne_VC_Wheat * loc_tonnes_crop_wheat_sf * trucking_distance )),
					(yield_mult * yield_exp_list[7] * farmer_exp_durum_price) - ((Per_Acre_VC_Durum_on_Stubble + producer_premium_durum_stubble) + (Per_Tonne_VC_Durum * tonnes_crop_durum_stubble * trucking_distance)),		
					(yield_mult * yield_exp_list[0] * farmer_exp_canola_price)
							- ((Per_Acre_VC_Canola_on_Stubble + producer_premium_canola_stubble)
							+ (Per_Tonne_VC_Canola * tonnes_crop_canola_stubble * trucking_distance)),
					-(yield_mult * barley_exp_yield * (farmer_exp_barley_price * 0.6529))
							- ((Per_Acre_VC_Barley_on_Stubble)),		
					(yield_mult * barley_exp_yield * farmer_exp_barley_price)
							- ((Per_Acre_VC_Barley_on_Stubble + producer_premium_barley_stubble) + (Per_Tonne_VC_Barley * loc_tonnes_crop_barley_stubble * trucking_distance)),
					-(yield_mult * wheat_exp_yield * farmer_exp_wheat_price)
							- ((Per_Acre_VC_Wheat_on_Stubble)),
					(yield_mult * wheat_exp_yield * farmer_exp_wheat_price)
							- ((Per_Acre_VC_Wheat_on_Stubble + producer_premium_wheat_stubble) + (Per_Tonne_VC_Wheat * loc_tonnes_crop_wheat_stubble * trucking_distance)), 
							(yield_mult * yield_exp_list[4] * farmer_exp_flax_price) - ((Per_Acre_VC_Flax_on_Stubble + producer_premium_flax_stubble) + (Per_Tonne_VC_Flax * tonnes_crop_flax_stubble * trucking_distance)),
							(yield_mult * yield_exp_list[5] * farmer_exp_peas_price) - ((Per_Acre_VC_Peas_on_Stubble + producer_premium_peas_stubble) + (Per_Tonne_VC_Flax * tonnes_crop_peas_stubble * trucking_distance)),
							(willows_annualized_return_np),
							(willows_annualized_return_ip),
							(willows_annualized_return_hayland),
							-(annualizedbreakingwillows),
							(poplar_annualized_return_np),
							(poplar_annualized_return_ip),
							(poplar_annualized_return_hayland),
							-(annualizedbreakingpoplar),
							(prairiesandreed_yield_np * psr_gj_tonne * gjprice) - ((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_np)),
							(prairiesandreed_yield_ip * psr_gj_tonne * gjprice) - ((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_ip)),
							(prairiesandreed_yield_hayland * psr_gj_tonne * gjprice) - ((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_hayland)),
							-(annualizedbreakingprairiesandreed),
							-(Per_Acre_VC_NP), -(Per_Acre_VC_IP), -(Per_Acre_VC_HL), 
							(-100), (-100), (-100), (-100),
							0, 0, -(Per_Acre_VC_Bale_IP_1),
							-(Per_Acre_VC_Bale_IP_2), -(Per_Acre_VC_Hayproduction_1), -(Per_Acre_VC_Hayproduction_2), -(Per_Acre_Annualized_Breaking),
							-(farmer_exp_hay_price + transaction_fee_hay + (Per_Tonne_VC_Hay * trucking_distance)*No_Buy_Hay), -(farmer_exp_wheat_price*36.74 + transaction_fee_hay + (Per_Tonne_VC_Wheat * trucking_distance)), -(farmer_exp_barley_price*45.93 + transaction_fee_hay + (Per_Tonne_VC_Barley * trucking_distance)), 
							-(Per_ton_feed_hay_cost), -(Per_ton_feed_hay_cost), -(Per_ton_feed_hay_cost), -(Per_ton_feed_hay_cost), 
							-(Per_ton_grain_cost), -(Per_ton_grain_cost), -(Per_ton_straw_bale_cost), -(Per_ton_straw_bale_cost), (farmer_exp_hay_price -(transaction_fee_hay)), -(crccow),
							((farmer_exp_calf_price*495) - VC_Cow), -(FC_Cow_Labour), -(FC_Cow_Handling), -(FC_Cow_Machinery), (crccow - ((crccow * cull_transaction_cost) + sell_cows_fee)),		
					-(Machine_VC_0), -(Machine_VC_1), -(Machine_FC_0),
					-(Machine_FC_1), -(interest_rate)};

			}
			else {
				contribution_margin = new double[] {
						-(Per_Acre_VC_Summer_Fallow),
						(fallow_yield_mult * yield_mult * wheat_exp_yield * farmer_exp_wheat_price)
								- ((Per_Acre_VC_Wheat_on_Fallow + producer_premium_wheat_fallow) + (Per_Tonne_VC_Wheat * loc_tonnes_crop_wheat_sf * trucking_distance)),
						(yield_mult * yield_exp_list[7] * farmer_exp_durum_price) - ((Per_Acre_VC_Durum_on_Stubble + producer_premium_durum_stubble) + (Per_Tonne_VC_Durum * tonnes_crop_durum_stubble * trucking_distance)),		
						(yield_mult * yield_exp_list[0] * farmer_exp_canola_price)
								- ((Per_Acre_VC_Canola_on_Stubble + producer_premium_canola_stubble))
								+ (Per_Tonne_VC_Canola * tonnes_crop_canola_stubble * trucking_distance),
						-(yield_mult * barley_exp_yield * farmer_exp_barley_price * 0.6529)
								- ((Per_Acre_VC_Barley_on_Stubble)),		
						(yield_mult * barley_exp_yield * farmer_exp_barley_price)
								- ((Per_Acre_VC_Barley_on_Stubble + producer_premium_barley_stubble) + (Per_Tonne_VC_Barley * loc_tonnes_crop_barley_stubble * trucking_distance)),
								-(yield_mult * wheat_exp_yield * farmer_exp_wheat_price)
						- ((Per_Acre_VC_Wheat_on_Stubble)),
						(yield_mult * wheat_exp_yield * farmer_exp_wheat_price)
								- ((Per_Acre_VC_Wheat_on_Stubble + producer_premium_wheat_stubble) + (Per_Tonne_VC_Wheat * loc_tonnes_crop_wheat_stubble * trucking_distance)), 
								(yield_mult * yield_exp_list[4] * farmer_exp_flax_price) - ((Per_Acre_VC_Flax_on_Stubble + producer_premium_flax_stubble) + (Per_Tonne_VC_Flax * tonnes_crop_flax_stubble * trucking_distance)),
								(yield_mult * yield_exp_list[5] * farmer_exp_peas_price) - ((Per_Acre_VC_Peas_on_Stubble + producer_premium_peas_stubble) + (Per_Tonne_VC_Flax * tonnes_crop_peas_stubble * trucking_distance)),
								(willows_annualized_return_np),
								(willows_annualized_return_ip),
								(willows_annualized_return_hayland),
								-(annualizedbreakingwillows),
								(poplar_annualized_return_np),
								(poplar_annualized_return_ip),
								(poplar_annualized_return_hayland),
								-(annualizedbreakingpoplar),
								(prairiesandreed_yield_np * psr_gj_tonne * gjprice) - ((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_np)),
								(prairiesandreed_yield_ip * psr_gj_tonne * gjprice) - ((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_ip)),
								(prairiesandreed_yield_hayland * psr_gj_tonne * gjprice) - ((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_hayland)),
								-(annualizedbreakingprairiesandreed),
								-(Per_Acre_VC_NP), -(Per_Acre_VC_IP), -(Per_Acre_VC_HL), 
								0, ((sizing_pastureland_value * .5) - (propertytaxespasture + (sizing_pastureland_value *0.5 * lease_man_fee_percent))), ((sizing_pastureland_value * .75)- (propertytaxespasture + (sizing_pastureland_value * 0.75 * lease_man_fee_percent))), (sizing_pastureland_value - (propertytaxespasture + (sizing_pastureland_value * lease_man_fee_percent))),
								0, 0, -(Per_Acre_VC_Bale_IP_1),
								-(Per_Acre_VC_Bale_IP_2), -(Per_Acre_VC_Hayproduction_1), -(Per_Acre_VC_Hayproduction_2), -(Per_Acre_Annualized_Breaking),
								-(farmer_exp_hay_price + transaction_fee_hay + (Per_Tonne_VC_Hay * trucking_distance)*No_Buy_Hay), -(farmer_exp_wheat_price*36.74 + transaction_fee_hay + (Per_Tonne_VC_Wheat * trucking_distance)), -(farmer_exp_barley_price*45.93 + transaction_fee_hay + (Per_Tonne_VC_Barley * trucking_distance)), 
								-(Per_ton_feed_hay_cost), -(Per_ton_feed_hay_cost), -(Per_ton_feed_hay_cost), -(Per_ton_feed_hay_cost), 
								-(Per_ton_grain_cost), -(Per_ton_grain_cost), -(Per_ton_straw_bale_cost), -(Per_ton_straw_bale_cost), (farmer_exp_hay_price -(transaction_fee_hay)), 
								(0), (0), -(FC_Cow_Labour), -(FC_Cow_Handling), -(FC_Cow_Machinery), (0), 
						-(Machine_VC_0), -(Machine_VC_1), -(Machine_FC_0),
						-(Machine_FC_1), -(interest_rate)};
			}	
			if(average_years_in_grass < 7) {
				borrowing = new double[] {
						Per_Acre_VC_Summer_Fallow,
						Per_Acre_VC_Wheat_on_Fallow + producer_premium_wheat_fallow + (Per_Tonne_VC_Wheat * loc_tonnes_crop_wheat_sf * trucking_distance),
						Per_Acre_VC_Durum_on_Stubble + producer_premium_durum_stubble + (Per_Tonne_VC_Durum * tonnes_crop_durum_stubble * trucking_distance),
						Per_Acre_VC_Canola_on_Stubble + producer_premium_canola_stubble + (Per_Tonne_VC_Canola * tonnes_crop_canola_stubble * trucking_distance),
						Per_Acre_VC_Barley_on_Stubble,
						Per_Acre_VC_Barley_on_Stubble + producer_premium_barley_stubble + (Per_Tonne_VC_Barley * loc_tonnes_crop_barley_stubble * trucking_distance),
						Per_Acre_VC_Wheat_on_Stubble,
						Per_Acre_VC_Wheat_on_Stubble + producer_premium_wheat_stubble + (Per_Tonne_VC_Wheat * loc_tonnes_crop_wheat_stubble * trucking_distance), 
						Per_Acre_VC_Flax_on_Stubble + producer_premium_flax_stubble + (Per_Tonne_VC_Flax * tonnes_crop_flax_stubble * trucking_distance),
						Per_Acre_VC_Peas_on_Stubble + producer_premium_peas_stubble + (Per_Tonne_VC_Peas * tonnes_crop_peas_stubble * trucking_distance),
						(willows_annualized_cost_np*100), 
						(willows_annualized_cost_ip*100),
						(willows_annualized_cost_hayland*100), 
						(int_inv_willows), 
						(poplar_annualized_cost_np*100), 
						(poplar_annualized_cost_ip*100), 
						(poplar_annualized_cost_hayland*100),
						(int_inv_poplar), 
						((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_np)*100), 
						((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_ip)*100), 
						((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_hayland)*100), 
						(int_inv_prairiesandreed), 			
						(Per_Acre_VC_NP), 
						(Per_Acre_VC_IP), 
						(Per_Acre_VC_HL),
						(propertytaxescropland + (0)),
						(propertytaxespasture + (sizing_pastureland_value * 0.5 * lease_man_fee_percent)),
						(propertytaxespasture + (sizing_pastureland_value * 0.75 * lease_man_fee_percent)), 
						(propertytaxespasture + (sizing_pastureland_value * lease_man_fee_percent)), 
						(0), 
						(0),
						(Per_Acre_VC_Bale_IP_1),
						(Per_Acre_VC_Bale_IP_2), 
						(Per_Acre_VC_Hayproduction_1),
						(Per_Acre_VC_Hayproduction_2), 
						(per_acre_breaking),
						(farmer_exp_hay_price + transaction_fee_hay + (Per_Tonne_VC_Hay * trucking_distance)*No_Buy_Hay), 
						(farmer_exp_wheat_price*36.74 + transaction_fee_hay + (Per_Tonne_VC_Wheat * trucking_distance)),
						(farmer_exp_barley_price*45.93 + transaction_fee_hay + (Per_Tonne_VC_Barley * trucking_distance)), 
						(Per_ton_feed_hay_cost),
						(Per_ton_feed_hay_cost),
						(Per_ton_feed_hay_cost),
						(Per_ton_feed_hay_cost), 
						(Per_ton_grain_cost), 
						(Per_ton_grain_cost), 
						(Per_ton_straw_bale_cost),
						(Per_ton_straw_bale_cost),
						(transaction_fee_hay),
						(NewCostCow),
						(VC_Cow), 
						(FC_Cow_Labour),
						(inv_handling), 
						(inv_cow_machine), 
						((farmer_exp_cull_price * cull_transaction_cost) + sell_cows_fee),					
						Machine_VC_0,
						Machine_VC_1, 
						inv_mach_0, 
						inv_mach_1, 
						-1};	
			}
			else{
				borrowing = new double[] {
						Per_Acre_VC_Summer_Fallow,
						Per_Acre_VC_Wheat_on_Fallow + producer_premium_wheat_fallow + (Per_Tonne_VC_Wheat * loc_tonnes_crop_wheat_sf * trucking_distance),
						Per_Acre_VC_Durum_on_Stubble + producer_premium_durum_stubble + (Per_Tonne_VC_Durum * tonnes_crop_durum_stubble * trucking_distance),
						Per_Acre_VC_Canola_on_Stubble + producer_premium_canola_stubble + (Per_Tonne_VC_Canola * tonnes_crop_canola_stubble * trucking_distance),
						Per_Acre_VC_Barley_on_Stubble,
						Per_Acre_VC_Barley_on_Stubble + producer_premium_barley_stubble + (Per_Tonne_VC_Barley * loc_tonnes_crop_barley_stubble * trucking_distance),
						Per_Acre_VC_Wheat_on_Stubble,
						Per_Acre_VC_Wheat_on_Stubble + producer_premium_wheat_stubble + (Per_Tonne_VC_Wheat * loc_tonnes_crop_wheat_stubble * trucking_distance), 
						Per_Acre_VC_Flax_on_Stubble + producer_premium_flax_stubble + (Per_Tonne_VC_Flax * tonnes_crop_flax_stubble * trucking_distance),
						Per_Acre_VC_Peas_on_Stubble + producer_premium_peas_stubble + (Per_Tonne_VC_Peas * tonnes_crop_peas_stubble * trucking_distance),
						(willows_annualized_cost_np), 
						(willows_annualized_cost_ip),
						(willows_annualized_cost_hayland), 
						(int_inv_willows), 
						(poplar_annualized_cost_np), 
						(poplar_annualized_cost_ip), 
						(poplar_annualized_cost_hayland),
						(int_inv_poplar), 
						((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_np)), 
						((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_ip)), 
						((Per_Tonne_PrairieSandReed_Custom_Rate * prairiesandreed_yield_hayland)), 
						(int_inv_prairiesandreed), 			
						(Per_Acre_VC_NP), 
						(Per_Acre_VC_IP), 
						(Per_Acre_VC_HL),
						(propertytaxescropland + (0)),
						(propertytaxespasture + (sizing_pastureland_value * 0.5 * lease_man_fee_percent)),
						(propertytaxespasture + (sizing_pastureland_value * 0.75 * lease_man_fee_percent)), 
						(propertytaxespasture + (sizing_pastureland_value * lease_man_fee_percent)), 
						(0), 
						(0),
						(Per_Acre_VC_Bale_IP_1),
						(Per_Acre_VC_Bale_IP_2), 
						(Per_Acre_VC_Hayproduction_1),
						(Per_Acre_VC_Hayproduction_2), 
						(per_acre_breaking),
						(farmer_exp_hay_price + transaction_fee_hay + (Per_Tonne_VC_Hay * trucking_distance)*No_Buy_Hay), 
						(farmer_exp_wheat_price*36.74 + transaction_fee_hay + (Per_Tonne_VC_Wheat * trucking_distance)),
						(farmer_exp_barley_price*45.93 + transaction_fee_hay + (Per_Tonne_VC_Barley * trucking_distance)), 
						(Per_ton_feed_hay_cost),
						(Per_ton_feed_hay_cost),
						(Per_ton_feed_hay_cost),
						(Per_ton_feed_hay_cost), 
						(Per_ton_grain_cost), 
						(Per_ton_grain_cost), 
						(Per_ton_straw_bale_cost),
						(Per_ton_straw_bale_cost),
						(transaction_fee_hay),
						(NewCostCow),
						(VC_Cow), 
						(FC_Cow_Labour),
						(inv_handling), 
						(inv_cow_machine), 
						((farmer_exp_cull_price * cull_transaction_cost) + sell_cows_fee),					
						Machine_VC_0,
						Machine_VC_1, 
						inv_mach_0, 
						inv_mach_1, 
						-1};	
			}
			
			daratio = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(int_inv_willows * min_ratio), 0, 0, 0, -(int_inv_poplar * min_ratio), 0, 0, 0, -(int_inv_prairiesandreed * min_ratio), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(per_acre_breaking * min_ratio), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(NewCostCow * min_ratio), 0, 0, -(inv_handling * min_ratio), -(inv_cow_machine * min_ratio), 0, 0, 0,
					-(inv_mach_0 * min_ratio), -(inv_mach_1 * min_ratio), 1 };
			
			hay_transfer = new double[] {0,	0, 0, 0, 0, 0,	0, 0, 0, 0,	0, 0, 0, 0,	0, 0, 0, 0,	0, 0, 0, 0,	0, 0, 0, 0,	0, 0, 0, 0, 0, -(exp_ip_early_yield_bale_one*error), -(exp_ip_late_yield_bale_two*error), -(exp_hay_early_yield_bale_one*error), -(exp_hay_late_yield_bale_two*error), 0, -1, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

			barley_transfer = new double[] {0, 0, 0, 0, -(barley_exp_yield/45.93), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			wheat_transfer = new double[] {0, 0, 0, 0, 0, 0, -(wheat_exp_yield/36.74), 0, 0, 0,	0, 0, 0, 0,	0, 0, 0, 0,	0, 0, 0, 0, 0, 0, 0, 0,	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			barley_strawtransfer = new double[] {0,	0, 0, 0, -(barley_exp_yield/45.93), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			wheat_strawtransfer = new double[] {0, 0, 0, 0, 0, 0, -(wheat_exp_yield/36.74), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			early_pasture_mcals = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(exp_mcals_np_early_yield), -(exp_mcals_ip_early_yield), -(exp_mcals_hayland_early_yield), 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(weighted_avg_mcals_bale_one), 0, 0, 0, 0, 0, 0, 0, 0, 0, (Variables.getmcals_required_early_summer()), 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			late_pasture_mcals = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(exp_mcals_np_late_yield), -(exp_mcals_ip_late_yield), -(exp_mcals_hayland_late_yield), 0, 0, 0, 0, -0.5, 1, -(Variables.getmcals_ton_ip_baled_one()), 0, -(Variables.getmcals_ton_hayland_baled_one()), 0, 0, 0, 0, 0, 0, -(weighted_avg_mcals_bale_one), 0, 0, 0, 0, 0, 0, 0, 0, (Variables.getmcals_required_late_summer()), 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			fall_pasture_mcals = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(exp_mcals_np_fall_yield), -(exp_mcals_ip_fall_yield), -(exp_mcals_hayland_fall_yield), 0, 0, 0, 0, 0, -0.5, -(Variables.getmcals_ton_ip_baled_two()), -(Variables.getmcals_ton_ip_baled_two()), -(Variables.getmcals_ton_hayland_baled_two()), -(Variables.getmcals_ton_hayland_baled_two()), 0, 0, 0, 0, 0, 0, -(weighted_avg_mcals_bale_two), 0, 0, 0, 0, 0, 0, 0, (Variables.getmcals_required_fall()), 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			winter_pasture_mcals = new double[] {0,	0, 0, 0, -3394, 0, -3724, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(weighted_avg_mcals_bale_two), -3724, -3394, -664, -823, 0, 0, (Variables.getmcals_required_winter()), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};			
			
			max_feeding_mcals = new double[] {0, 0, 0, 0, -((1-alpha)*3394), 0, -((1-alpha)*3724), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(alpha*weighted_avg_mcals_bale_two), ((1-alpha)*3724), ((1-alpha)*3394), -((1-alpha)*664), -((1-alpha)*823), 0, 0, (Variables.getmcals_required_winter()), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};			
			
			
			cows_handling_constraint = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (handling_transfer), 0, -(cows_handling_system_limit), 0, 0, 0, 0, 0, 0, 0};
			
			cows_machine_constraint = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (handling_transfer), 0, 0, -(cows_machine_limit), 0, 0, 0, 0, 0, 0};
					
			cows_acres_required = new double[] {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(np_cow_acre), -(ip_cow_acre), -(hayland_cow_acre), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (total_cow_acre), 0, 0, 0, 0, 0, 0, 0, 0, 0};
			
			
			double haylandpastureland = gettotal_hay() - (getwillowshaylandpasture() + getpoplarhaylandpasture() + getprairiesandreedhaylandpasture());
			
			double improvedpastureland = haylandpastureland + gettotal_improved_pasture() - (getwillowsimprovedpasture() + getpoplarimprovedpasture() + getprairiesandreedimprovedpasture());
			
			double naturalpastureland = improvedpastureland + gettotal_natural_pasture() - (getwillowsnaturalpasture() + getpoplarnaturalpasture() + getprairiesandreednaturalpasture());
				
			double maxwheatlimit = 0;
			double maxbarleylimit = 0;
			double maxdurumlimit = 0;
			double cropland = this.gettotal_crop_acres();
			double chemfallow = 0;
			double cerealland = Math.round(cereallimit_con * cropland);
			double oilseedland = Math.round(oilseedlimit_con * cropland);
			double maxcanolalimit = Math.round(maxcanola_limit * oilseedland);
			double maxflaxlimit = Math.round(maxflax_limit * oilseedland);
			
			double pulseland = Math.round(pulselimit_con * cropland);
			double cow_constraint = 300; 
			double cow_mach_constraint = 300;
			double maxfeedwheatlimit = cerealland;
			double maxfeedbarleylimit = cerealland;
			
			
			
				if(getfarmer_type() == 2 || getfarmer_type() == 3){
				maxwheatlimit = Math.round(0.025 * cerealland * maxwheat_limit);
				maxbarleylimit = Math.round(0.025 * cerealland * maxbarley_limit);
				maxdurumlimit = Math.round(0.0 * cerealland * maxdurum_limit);
				}
				else{
					maxwheatlimit = Math.round(maxwheat_limit * cerealland);
					maxbarleylimit = Math.round(maxbarley_limit * cerealland);
					maxdurumlimit = Math.round(maxdurum_limit * cerealland);
				}
			
			
		
			
			
			int oldasset_olddebt = (int) (min_ratio* assets - (debt - debt_payment));
			if(oldasset_olddebt < 0) {
				oldasset_olddebt = 0;
			}
		
			try {
				// // Create a problem with 59 variables and 37 constraints
				LpSolve solver = LpSolve.makeLp(37, 59);

				
				solver.setInt(51, true); //cowslabour
				solver.setInt(52, true); //cows fc handling system
				solver.setInt(53, true); //cows fc machinery
				solver.setInt(57, true); // Machine option 0
				solver.setInt(58, true); // Machine option 1
				
				// // add constraints
				
				solver.strAddConstraint("1 1 1 1 1 1 1 1 1 1 1 1 1 0 1 1 1 0 1 1 1 0 1 1 1 1 1 1 1 0 0 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE,	gettotal_acres_farmed());
								
				solver.strAddConstraint("1 1 1 1 1 1 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, cropland); // Crop land (acres)
				
				solver.strAddConstraint("-1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, chemfallow); // Fallow
				
				solver.strAddConstraint("0 1 1 0 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, cerealland); // Cereal (wheat and Barley)
				
				solver.strAddConstraint("0 0 0 1 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, oilseedland); // Oilseed (Canola and Flax) Limit
				
				solver.strAddConstraint("0 1 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, maxfeedwheatlimit);
								
				solver.strAddConstraint("0 1 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, maxwheatlimit);
				
				solver.strAddConstraint("0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, maxbarleylimit);
								
				solver.strAddConstraint("0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, maxfeedbarleylimit);
				
				solver.strAddConstraint("0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, maxdurumlimit);
				
				solver.strAddConstraint("0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, maxcanolalimit);
				
				solver.strAddConstraint("0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, maxflaxlimit);
				
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, pulseland);
				
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 -500 0 0", LpSolve.LE, 0); // Machine operate 0
				
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 -1300 0", LpSolve.LE, 0); // Machine operate 1
				
				solver.strAddConstraint("0 1 1 1 1 1 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -1 -1 0 0 0", LpSolve.LE, 0); // Machine acres required conventional farmer
				
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 1 1 1 0 1 1 1 0 1 1 1 0 1 1 1 0 1 1 1 0 0 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, naturalpastureland);
					
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 1 1 0 0 1 1 0 0 1 1 0 0 1 1 0 0 1 1 0 0 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, improvedpastureland);
					
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 0 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0", LpSolve.LE, haylandpastureland);
					
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 -300 0 0 0 0 0 0 0 0", LpSolve.LE, cow_constraint); //Cows Labour Limit
							
				solver.strAddConstraint("0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 -1 1 0 0 0 1 0 0 0 0 0 0", LpSolve.LE, getn_cows()); //Herd Size
				
				
				String str = convertDoubleArrayToString(borrowing);
				solver.strAddConstraint(str, LpSolve.LE, this.getcash()); //
											
				String str1 = convertDoubleArrayToString(daratio);
				solver.strAddConstraint(str1, LpSolve.LE, oldasset_olddebt); // Debt-Asset
																				// Ratio
				String str2 = convertDoubleArrayToString(hay_transfer);
				solver.strAddConstraint(str2, LpSolve.LE, 0);
				
				String str3 = convertDoubleArrayToString(barley_transfer);
				solver.strAddConstraint(str3, LpSolve.LE, 0);
				
				String str4 = convertDoubleArrayToString(wheat_transfer);
				solver.strAddConstraint(str4, LpSolve.LE, 0);
				
				String str5 = convertDoubleArrayToString(barley_strawtransfer);
				solver.strAddConstraint(str5, LpSolve.LE, 0);
				
				String str6 = convertDoubleArrayToString(wheat_strawtransfer);
				solver.strAddConstraint(str6, LpSolve.LE, 0);
				
				String str7 = convertDoubleArrayToString(early_pasture_mcals);
				solver.strAddConstraint(str7, LpSolve.LE, 0);
				
				String str8 = convertDoubleArrayToString(late_pasture_mcals);
				solver.strAddConstraint(str8, LpSolve.LE, 0);
				
				String str9 = convertDoubleArrayToString(fall_pasture_mcals);
				solver.strAddConstraint(str9, LpSolve.LE, 0);
				
				String str10 = convertDoubleArrayToString(winter_pasture_mcals);
				solver.strAddConstraint(str10, LpSolve.LE, 0);
				
				String str11 = convertDoubleArrayToString(forage_breaking);
				solver.strAddConstraint(str11, LpSolve.LE, 0);
				
				String str12 = convertDoubleArrayToString(cows_handling_constraint);
				solver.strAddConstraint(str12, LpSolve.LE, cow_constraint);
				
				String str13 = convertDoubleArrayToString(cows_machine_constraint);
				solver.strAddConstraint(str13, LpSolve.LE, cow_mach_constraint);
				
				String str14 = convertDoubleArrayToString(cows_acres_required);
				solver.strAddConstraint(str14, LpSolve.LE, (0));
				
				String str15 = convertDoubleArrayToString(max_feeding_mcals);
				solver.strAddConstraint(str15, LpSolve.LE, 0);
				
			
				String newStrCon = convertDoubleArrayToString(contribution_margin);

				solver.strSetObjFn(newStrCon);
				solver.setMaxim();				
				solver.solve();
				solver.getPtrVariables(); // Store this value to a string
				solver.getObjective(); // Store this value to a string
				
				
				
				expected_income = solver.getObjective();
				if(getexpected_income() == - solver.getInfinite() || getexpected_income() == solver.getInfinite() || solver.getPtrVariables()[46] == solver.getInfinite() || solver.getPtrVariables()[45] == solver.getInfinite() || solver.getPtrVariables()[47] == solver.getInfinite() || solver.getPtrVariables()[54] == solver.getInfinite() ) {
					setinfeasiblesolution(true);
					expected_income = 0;
					tillage_fallow = 0;
					wheat_on_fallow = 0;
					durum_stubble = 0;
					canola_stubble = 0;
					barley_stubble = 0;
					wheat_stubble = 0;
					flax_stubble = 0;
					peas_stubble = 0;
					willows_on_natural_pasture = 0;
					willows_on_improved_pasture = 0;
					willows_on_hayland_pasture = 0;
					willows_initial_investment = 0;
					poplar_on_natural_pasture = 0;
					poplar_on_improved_pasture = 0;
					poplar_on_hayland_pasture = 0;
					poplar_initial_investment = 0;
					prairie_sandreed_on_natural_pasture = 0;
					prairie_sandreed_on_improved_pasture = 0;
					prairie_sandreed_on_hayland_pasture = 0;
					prairie_sandreed_initial_investment = 0;					
					natural_pasture = 0;
					improved_pasture = 0;
					hayland_pasture = 0;
					rent_out_cropland = 0;
					rent_out_natural_pasture = 0;
					rent_out_improved_pasture = 0;
					rent_out_hayland_pasture = 0;
					pasture_carryover_one = 0;
					pasture_carryover_two = 0;
					improved_bale_first_cut = 0;
					improved_bale_second_cut = 0;
					hay_production_one_cut = 0;
					hay_production_two_cuts = 0;
					breaking_cost = 0;
					buy_hay = 0;
					long_run_hay_storage_in = 0;
					long_run_hay_storage_out = 0;
					buy_feed_wheat = 0;
					buy_feed_barley = 0;
					feed_early_summer_hay = 0;
					feed_late_summer_hay = 0;
					feed_fall_hay = 0;
					feed_winter_hay = 0;
					feed_wheat = 0;
					feed_barley = 0;
					wheat_straw = 0;
					barley_straw = 0;					
					sell_hay = 0;
					cows_head = 0;
					cows_labour = 0;   
					cows_fc_handling_system = 0;
					cows_fc_machinery = 0; 
					option_0_acres = 0;
					option_1_acres = 0;
					option_0_number_machines = 0;
					option_1_number_machines = 0;
					amount_borrow = 0;
				}
				else {
				double[] var = solver.getPtrVariables(); // This is the crop mix
				for (double d : var) {

				}
				for (int i = 0; i < var.length; i++) {
					tillage_fallow = var[0];
					wheat_on_fallow = var[1];
					durum_stubble = var[2];
					canola_stubble = var[3];
					feed_barley_con = var[4];
					barley_stubble = var[5];
					feed_wheat_con = var[6];
					wheat_stubble = var[7];
					flax_stubble = var[8];
					peas_stubble = var[9];
					willows_on_natural_pasture = var[10];
					willows_on_improved_pasture = var[11];
					willows_on_hayland_pasture = var[12];
					willows_initial_investment = var[13];
					poplar_on_natural_pasture = var[14];
					poplar_on_improved_pasture = var[15];
					poplar_on_hayland_pasture = var[16];
					poplar_initial_investment = var[17];
					prairie_sandreed_on_natural_pasture = var[18];
					prairie_sandreed_on_improved_pasture = var[19];
					prairie_sandreed_on_hayland_pasture = var[20];
					prairie_sandreed_initial_investment = var[21];					
					natural_pasture = var[22];
					improved_pasture = var[23];
					hayland_pasture = var[24];
					rent_out_cropland = var[25];
					rent_out_natural_pasture = var[26];
					rent_out_improved_pasture = var[27];
					rent_out_hayland_pasture = var[28];
					pasture_carryover_one = var[29];
					pasture_carryover_two = var[30];
					improved_bale_first_cut = var[31];
					improved_bale_second_cut = var[32];
					hay_production_one_cut = var[33];
					hay_production_two_cuts = var[34];
					breaking_cost = var[35];
					buy_hay = var[36];
					buy_feed_wheat = var[37];
					buy_feed_barley = var[38];
					feed_early_summer_hay = var[39];
					feed_late_summer_hay = var[40];
					feed_fall_hay = var[41];
					feed_winter_hay = var[42];
					feed_wheat = var[43];
					feed_barley = var[44];
					wheat_straw = var[45];
					barley_straw = var[46];					
					sell_hay = var[47];
					invest_cows = var[48];
					cows_head = var[49];
					cows_labour = (int) var[50];   
					cows_fc_handling_system = (int) var[51];
					cows_fc_machinery = (int) var[52]; 
					sell_cull_cows = var[53];
					option_0_acres = (int) var[54];
					option_1_acres = (int) var[55];
					option_0_number_machines = (int) var[56];
					option_1_number_machines = (int) var[57];
					amount_borrow = (int) var[58];
				}
//			}				
//				int idd = this.getID();
//				int farmerID = this.getfarmer_name();
//				int run_number = Variables.getrun_number();
//				int year = Variables.getyear();
//				int tillage_fallow = (int) gettillage_fallow();
//				int wheat_on_fallow = (int) getwheat_on_fallow();
//				int durum_stubble = (int) getdurum_stubble();
//				int canola_stubble = (int) getcanola_stubble();
//				int feed_barley_con = (int) getfeed_barley_con();
//				int barley_stubble = (int) getbarley_stubble();
//				int feed_wheat_con = (int) getfeed_wheat_con();
//				int wheat_stubble = (int) getwheat_stubble();
//				int flax_stubble = (int) getflax_stubble();
//				int peas_stubble = (int) getpeas_stubble();
//				int feed_barley_notill = (int) getfeed_barley_notill();
//				int barley_notill = (int) getbarley_notill();
//				int canola_notill = (int) getcanola_notill();
//				int feed_wheat_notill = (int) getfeed_wheat_notill();
//				int wheat_notill = (int) getwheat_notill();
//				int durum_notill = (int) getdurum_notill();
//				int flax_notill = (int) getflax_notill();
//				int lentils_notill = (int) getlentils_notill();
//				int peas_notill = (int) getpeas_notill();
//				int willows_on_natural_pasture = (int) getwillows_on_natural_pasture();
//				int willows_on_improved_pasture = (int) getwillows_on_improved_pasture();
//				int willows_on_hayland_pasture = (int) getwillows_on_hayland_pasture();
//				int willows_initial_investment = (int) getwillows_initial_investment();
//				int poplar_on_natural_pasture = (int) getpoplar_on_natural_pasture();
//				int poplar_on_improved_pasture = (int) getpoplar_on_improved_pasture();
//				int poplar_on_hayland_pasture = (int) getpoplar_on_hayland_pasture();
//				int poplarinitial_investment = (int) getpoplar_initial_investment();
//				int prairie_sandreed_on_natural_pasture = (int) getprairie_sandreed_on_natural_pasture();
//				int prairie_sandreed_on_improved_pasture = (int) getprairie_sandreed_on_improved_pasture();
//				int prairie_sandreed_on_hayland_pasture = (int) getprairie_sandreed_on_hayland_pasture();
//				int prairiesandreed_initial_investment = (int) getprairie_sandreed_initial_investment();
//				int natural_pasture = (int) getnatural_pasture();
//				int improved_pasture = (int) getimproved_pasture();
//				int hayland_pasture = (int) gethayland_pasture();
//				int rent_out_cropland = (int) getrent_out_cropland();
//				int rent_out_natural_pasture = (int) getrent_out_natural_pasture();
//				int rent_out_improved_pasture = (int) getrent_out_improved_pasture();
//				int rent_out_hayland_pasture = (int) getrent_out_hayland_pasture();
//				int pasture_carryover_one = (int) getpasture_carryover_one();
//				int pasture_carryover_two = (int) getpasture_carryover_two();
//				int improved_bale_first_cut = (int) getimproved_bale_first_cut();
//				int improved_bale_second_cut = (int) getimproved_bale_second_cut();
//				int hay_production_one_cut = (int) gethay_production_one_cut();
//				int hay_production_two_cuts = (int) gethay_production_two_cuts();
//				int breaking_cost = (int) getbreaking_cost();
//				int buy_hay = (int) getbuy_hay();
//				int buy_feed_wheat = (int) getbuy_feed_wheat();
//				int buy_feed_barley = (int) getbuy_feed_barley();
//				int feed_early_summer_hay = (int) getfeed_early_summer_hay();
//				int feed_late_summer_hay = (int) getfeed_late_summer_hay();
//				int feed_fall_hay = (int) getfeed_fall_hay();
//				int feed_winter_hay = (int) getfeed_winter_hay();
//				int feed_wheat = (int) getfeed_wheat();
//				int feed_barley = (int) getfeed_barley();
//				int wheat_straw = (int) getwheat_straw();
//				int barley_straw = (int) getbarley_straw();
//				int sell_hay = (int) getsell_hay();
//				int invest_cows = (int) getinvest_cows();
//				int cows_head = (int) getcows_head();
//				int cows_labour = (int) getcows_labour();
//				int cows_fc_handling_system = (int) getcows_fc_handling_system();
//				int cows_fc_machinery = (int) getcows_fc_machinery();
//				int sell_cull_cows = (int) getsell_cull_cows();
//				int crop_custom_hire = (int) getcrop_custom_hire();
//				int option_0_acres = (int) getoption_0_acres();
//				int option_1_acres = (int) getoption_1_acres();
//				int option_2_acres = (int) getoption_2_acres();
//				int option_3_acres = (int) getoption_3_acres();
//				int option_4_acres = (int) getoption_4_acres();
//				int option_5_acres = (int) getoption_5_acres();
//				int option_6_acres = (int) getoption_6_acres();
//				int option_7_acres = (int) getoption_7_acres();
//				int option_8_acres = (int) getoption_8_acres();
//				int option_9_acres = (int) getoption_9_acres();
//				int option_0_number_machines = (int) getoption_0_number_machines();
//				int option_1_number_machines = (int) getoption_1_number_machines();
//				int option_2_number_machines = (int) getoption_2_number_machines();
//				int option_3_number_machines = (int) getoption_3_number_machines();
//				int option_4_number_machines = (int) getoption_4_number_machines();
//				int option_5_number_machines = (int) getoption_5_number_machines();
//				int option_6_number_machines = (int) getoption_6_number_machines();
//				int option_7_number_machines = (int) getoption_7_number_machines();
//				int option_8_number_machines = (int) getoption_8_number_machines();
//				int option_9_number_machines = (int) getoption_9_number_machines();
//				int rent_pasture_land =   0;
//				int rent_cropland = 0;				
//				int amount_borrow = (int) getamount_borrow();
//				int expected_income = (int) getexpected_income();
//			
//				try {
//					Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
//				} catch (ClassNotFoundException ce) {
//					System.out.println("SQLExceptiong:" + ce.getMessage());
//				}
//				try {
//					Connection conn = DriverManager.getConnection(
//							"jdbc:odbc:producerDB", "java", "1234");
//					Statement stmt = conn.createStatement();
//
//					stmt.executeUpdate("insert into Reoptimized values ('" 
//							+ idd 
//							+ "', '" + farmerID 
//							+ "', '" + run_number
//							+ "','" + year 
//							+ "', '" + tillage_fallow 
//							+ "', '" + wheat_on_fallow
//							+ "', '" + durum_stubble
//							+ "', '" + canola_stubble 
//							+ "', '" + feed_barley_con
//							+ "', '" + barley_stubble
//							+ "', '" + feed_wheat_con
//							+ "', '" + wheat_stubble 
//							+ "', '" + flax_stubble
//							+ "', '" + peas_stubble
//							+ "', '" + feed_barley_notill
//							+ "', '" + barley_notill
//							+ "', '" + canola_notill
//							+ "', '" + feed_wheat_notill
//							+ "', '" + wheat_notill
//							+ "', '" + durum_notill
//							+ "', '" + flax_notill
//							+ "', '" + lentils_notill
//							+ "', '" + peas_notill
//							+ "', '" + willows_on_natural_pasture
//							+ "', '" + willows_on_improved_pasture
//							+ "', '" + willows_on_hayland_pasture
//							+ "', '" + willows_initial_investment
//							+ "', '" + poplar_on_natural_pasture
//							+ "', '" + poplar_on_improved_pasture
//							+ "', '" + poplar_on_hayland_pasture
//							+ "', '" + poplarinitial_investment
//							+ "', '" + prairie_sandreed_on_natural_pasture
//							+ "', '" + prairie_sandreed_on_improved_pasture
//							+ "', '" + prairie_sandreed_on_hayland_pasture
//							+ "', '" + prairiesandreed_initial_investment
//							+ "', '" + natural_pasture 
//							+ "' , '" + improved_pasture
//							+ "', '" + hayland_pasture 
//							+ "', '" + rent_out_cropland
//							+ "', '" + rent_out_natural_pasture
//							+ "', '" + rent_out_improved_pasture
//							+ "', '" + rent_out_hayland_pasture
//							+ "', '"  + pasture_carryover_one 
//							+ "', '" + pasture_carryover_two 
//							+ "', '"+ improved_bale_first_cut 
//							+ "', '" + improved_bale_second_cut 
//							+ "', '" + hay_production_one_cut 
//							+ "', '" + hay_production_two_cuts 
//							+ "', '" + breaking_cost
//							+ "', '" + buy_hay
//							+ "', '" + buy_feed_wheat 
//							+ "', '" + buy_feed_barley 
//							+ "', '" + feed_early_summer_hay 
//							+ "', '" + feed_late_summer_hay 
//							+ "', '" + feed_fall_hay 
//							+ "', '" + feed_winter_hay 
//							+ "', '" + feed_wheat 
//							+ "', '" + feed_barley 
//							+ "', '" + wheat_straw
//							+ "', '" + barley_straw
//							+ "', '" + sell_hay 
//							+ "', '" + invest_cows
//							+ "', '" + cows_head 
//							+ "', '" + cows_labour 
//							+ "', '" + cows_fc_handling_system
//							+ "', '" + cows_fc_machinery
//							+ "', '" + sell_cull_cows
//							+ "', '" + crop_custom_hire
//							+ "', '" + option_0_acres 
//							+ "', '" + option_1_acres
//							+ "', '" + option_2_acres 
//							+ "', '" + option_3_acres
//							+ "', '" + option_4_acres 
//							+ "', '" + option_5_acres
//							+ "', '" + option_6_acres 
//							+ "', '" + option_7_acres
//							+ "', '" + option_8_acres 
//							+ "', '" + option_9_acres
//							+ "', '" + option_0_number_machines 
//							+ "', '" + option_1_number_machines 
//							+ "', '" + option_2_number_machines 
//							+ "', '" + option_3_number_machines 
//							+ "', '" + option_4_number_machines 
//							+ "', '" + option_5_number_machines 
//							+ "', '" + option_6_number_machines 
//							+ "', '" + option_7_number_machines 
//							+ "', '" + option_8_number_machines 
//							+ "', '" + option_9_number_machines 
//							+ "', '" + rent_pasture_land 
//							+ "', '" + rent_cropland	
//							+ "', '" + amount_borrow 
//							+ "', '" + expected_income + "')");
//
//					stmt.close();
//					conn.close();
//				} catch (SQLException ce) {
//					ce.printStackTrace();
//					System.out.println("HELL 5 SQLException:" + ce.getMessage());
				}
				solver.deleteLp();
			} catch (LpSolveException e) {
				
				e.printStackTrace();
			}
		}
	}
	
	public void set_livestock() {
		Parameters p = RunEnvironment.getInstance().getParameters();
		double cull_transaction_cost = (Double)p.getValue("cull_transaction_cost");
		double sell_cows_fee = (Double)p.getValue("sellherdcost");
		sell_old_cows = 0;			
		NewCostCow = ((0.7679 * Variables.getprice_calf()))* 845;	
		livestock_variables = new double[] {invest_cows, cows_head, sell_cull_cows, cows_labour, natural_pasture, improved_pasture, hayland_pasture, pasture_carryover_one,
			pasture_carryover_two, improved_bale_first_cut, improved_bale_second_cut, hay_production_one_cut, hay_production_two_cuts,
			breaking_cost, buy_hay, buy_feed_wheat, buy_feed_barley, feed_early_summer_hay, feed_late_summer_hay, feed_fall_hay, 
			feed_winter_hay, feed_wheat, feed_barley, wheat_straw, barley_straw, sell_hay};
		
			old_cows = getn_cows();
			
			if(getinfeasiblesolution()== false){
			if(cows_head < old_cows && invest_cows == 0 && sell_cull_cows == 0){
				setn_cows(getn_cows());
				new_cows = 0;
				if(will_cows == true){
				
				}
			}
			else if(cows_head > old_cows && sell_cull_cows == 0 && cows_head > 10){
				if(invest_cows > 0){
					new_cows = invest_cows;
					cash = (int) (cash - (new_cows * NewCostCow));
					setn_cows(cows_head);
				
				}
			}
			
			else if(sell_cull_cows > 0) {
				if(cows_head > 10){
				setn_cows(cows_head);
				}
				else{
					setn_cows(0);
				}
				
				new_cows = invest_cows;
				NewCostCow = ((0.7679 * Variables.getprice_calf()))* 1300;
				double transaction_sell_cows = ((int) ((sell_cull_cows) * NewCostCow + ((sell_cull_cows) * Variables.getprice_calf() * 495)) * cull_transaction_cost) + (sell_cows_fee * sell_cull_cows);
				double revenue_old_cows = (int) (sell_cull_cows) * NewCostCow + ((sell_cull_cows) * Variables.getprice_calf() * 495); //sell herd
				sell_old_cows = (int) revenue_old_cows - transaction_sell_cows;
				cash = (int) ((int) cash + sell_old_cows);
				
			}
			livestock_labour = (int) livestock_variables[3];
			naturalpasture = livestock_variables[4];
			improvedpasture = livestock_variables[5];
			haylandpasture = livestock_variables[6];
			pasturecarryoverone = livestock_variables[7];
			pasturecarryovertwo = livestock_variables[8];
			improvedbaleone = livestock_variables[9];
			improvedbaletwo = livestock_variables[10];
			haybaleone = livestock_variables[11];
			haybaletwo = livestock_variables[12];
			breakingcost = livestock_variables[13];
			buyhay = livestock_variables[14];
			buyfeedwheat = livestock_variables[15];
			buyfeedbarley = livestock_variables[16];
			feedearlysummerhay = livestock_variables[17];
			feedlatesummerhay = livestock_variables[18];
			feedfallhay = livestock_variables[19];
			feedwinterhay = livestock_variables[20];				
			feedwheat = livestock_variables[21];
			feedbarley = livestock_variables[22];
			feedwheatstraw = livestock_variables[23];
			feedbarleystraw = livestock_variables[24];
			sellhay = livestock_variables[25];	
								
						for(int i = 0; i<mylandList.size();i++){
							SAMA sama = (SAMA) mylandList.get(i);
							int countpsr = i;
							if(livestock_variables[4] > 0){
						livestock_variables[4] = livestock_variables[4] - sama.getnp();
						if(breaking_cost > 0){
						sama.setyears_in_grass(0);
						}
						sama.setin_grass(true);
						sama.setin_willows(false);
						sama.setin_poplar(false);
						sama.setin_prairiesandreed(false);
					}
					}
					
						for(int i = 0; i<mylandList.size();i++){
							SAMA sama = (SAMA) mylandList.get(i);
							int countpsr = i;
							if(livestock_variables[5] > 0){
						livestock_variables[5] = energy_crops_variables[5] - (sama.gettilled_pasture() + sama.gethay_pasture() + sama.getIP());
						if(breaking_cost > 0){
							sama.setyears_in_grass(0);
						}
						sama.setin_grass(true);
						sama.setin_willows(false);
						sama.setin_poplar(false);
						sama.setin_prairiesandreed(false);
						}
					}
					
					for(int i = 0; i<mylandList.size();i++){
						SAMA sama = (SAMA) mylandList.get(i);
						int count = i;
						if(livestock_variables[6] > 0){
					livestock_variables[6] = livestock_variables[6] - (sama.gettilled_hay() + sama.gethay_hay());
					
					if(breaking_cost > 0){
						sama.setyears_in_grass(0);
					}
					sama.setin_grass(true);
					sama.setin_willows(false);
					sama.setin_poplar(false);
					sama.setin_prairiesandreed(false);
					}
					}
			
				
			
			}
			else{
				setn_cows(old_cows);
			}
			
			
			
			
			
	}
	
	
	
	public void set_energy_crops () {
		Parameters p = RunEnvironment.getInstance().getParameters();
		double int_inv_poplar = (Double) p.getValue("int_inv_poplar");
		double int_inv_prairiesandreed = (Double) p.getValue("int_inv_prairiesandreed");
		double int_inv_willows = (Double) p.getValue("intinvwillows");
		energy_crops_variables = new double[] {willows_on_natural_pasture, willows_on_improved_pasture, willows_on_hayland_pasture, willows_initial_investment,
				poplar_on_natural_pasture, poplar_on_improved_pasture, poplar_on_hayland_pasture, poplar_initial_investment, prairie_sandreed_on_natural_pasture,
				prairie_sandreed_on_improved_pasture, prairie_sandreed_on_hayland_pasture, prairie_sandreed_initial_investment};
	
	willowsnaturalpasture = getwillowsnaturalpasture() + (int) energy_crops_variables[0];
	willowsimprovedpasture = getwillowsimprovedpasture() + (int) energy_crops_variables[1];
	willowshaylandpasture = getwillowshaylandpasture() + (int) energy_crops_variables[2];
	willowsinitialinvestment = (int) energy_crops_variables[3];
	poplarnaturalpasture = getpoplarnaturalpasture() + (int) energy_crops_variables[4];
	poplarimprovedpasture = getpoplarimprovedpasture() + (int) energy_crops_variables[5];
	poplarhaylandpasture = getpoplarhaylandpasture() + (int) energy_crops_variables[6];
	poplarinitialinvestment = (int) energy_crops_variables[7];
	prairiesandreednaturalpasture = getprairiesandreednaturalpasture() + (int) energy_crops_variables[8];
	prairiesandreedimprovedpasture = getprairiesandreedimprovedpasture() + (int) energy_crops_variables[9];
	prairiesandreedhaylandpasture = getprairiesandreedhaylandpasture() + (int) energy_crops_variables[10];
	prairiesandreedinitialinvestment = (int) energy_crops_variables[11];
	
	cash = (int) (cash - (willowsinitialinvestment * int_inv_willows + poplarinitialinvestment * int_inv_poplar + prairiesandreedinitialinvestment * int_inv_prairiesandreed));
		
	
	
		for(int i = 0; i<mylandList.size();i++){
			SAMA sama = (SAMA) mylandList.get(i);
			if(energy_crops_variables[0] > 0) { 
			energy_crops_variables[0] = energy_crops_variables[0] - sama.getnp();
			sama.setin_willows(true);
			sama.setyears_in_willows(0);
			sama.setin_grass(false);
			sama.setin_prairiesandreed(false);
			sama.setin_poplar(false);
		}
		}
				for(int i = 0; i<mylandList.size();i++){
					SAMA sama = (SAMA) mylandList.get(i);
					if(energy_crops_variables[1] > 0){
					energy_crops_variables[1] = energy_crops_variables[1] - (sama.gettilled_pasture() + sama.gethay_pasture() + sama.getIP());
					sama.setin_willows(true);
					sama.setyears_in_willows(0);
					sama.setin_grass(false);
					sama.setin_prairiesandreed(false);
					sama.setin_poplar(false);
				}
				}
				
					for(int i = 0; i<mylandList.size();i++){							
					SAMA sama = (SAMA) mylandList.get(i);
					if(energy_crops_variables[2] > 0){
					energy_crops_variables[2] = energy_crops_variables[2] - (sama.gettilled_hay() + sama.gethay_hay());
					sama.setin_willows(true);
					sama.setyears_in_willows(0);
					sama.setin_grass(false);
					sama.setin_prairiesandreed(false);
					sama.setin_poplar(false);
				}
				}
				for(int i = 0; i<mylandList.size();i++){
						SAMA sama = (SAMA) mylandList.get(i);
					if(energy_crops_variables[4] > 0){	
					energy_crops_variables[4] = energy_crops_variables[4] - sama.getnp();
					sama.setin_poplar(true);
					sama.setyears_in_poplar(0);
					sama.setin_grass(false);
					sama.setin_prairiesandreed(false);
					sama.setin_willows(false);
				}
				}
				
					for(int i = 0; i<mylandList.size();i++){
					SAMA sama = (SAMA) mylandList.get(i);
					if(energy_crops_variables[5] > 0){
					energy_crops_variables[5] = energy_crops_variables[5] - (sama.gettilled_pasture() + sama.gethay_pasture() + sama.getIP());
					sama.setin_poplar(true);
					sama.setyears_in_poplar(0);
					sama.setin_grass(false);
					sama.setin_prairiesandreed(false);
					sama.setin_willows(false);
				}
				}
				
					for(int i = 0; i<mylandList.size();i++){
						SAMA sama = (SAMA) mylandList.get(i);
						if(energy_crops_variables[6] > 0){
					energy_crops_variables[6] = energy_crops_variables[6] - (sama.gettilled_hay() + sama.gethay_hay());
					sama.setin_poplar(true);
					sama.setyears_in_poplar(0);
					sama.setin_grass(false);
					sama.setin_prairiesandreed(false);
					sama.setin_willows(false);
				}
				}
				
					for(int i = 0; i<mylandList.size();i++){
						SAMA sama = (SAMA) mylandList.get(i);
						int countpsr = i;
						if(energy_crops_variables[8] > 0){
					energy_crops_variables[8] = energy_crops_variables[8] - sama.getnp();
					sama.setin_prairiesandreed(true);
					sama.setyears_in_prairie_sandreed(0);
					sama.setin_grass(false);
					sama.setin_willows(false);
					sama.setin_poplar(false);
				}
				}
				
					for(int i = 0; i<mylandList.size();i++){
						SAMA sama = (SAMA) mylandList.get(i);
						int countpsr = i;
						if(energy_crops_variables[9] > 0){
					energy_crops_variables[9] = energy_crops_variables[9] - (sama.gettilled_pasture() + sama.gethay_pasture() + sama.getIP());
					sama.setin_prairiesandreed(true);
					sama.setyears_in_prairie_sandreed(0);
					sama.setin_grass(false);
					sama.setin_willows(false);
					sama.setin_poplar(false);
					}
				}
				
				for(int i = 0; i<mylandList.size();i++){
					SAMA sama = (SAMA) mylandList.get(i);
					int countpsr = i;
					if(energy_crops_variables[10] > 0){
				energy_crops_variables[10] = energy_crops_variables[10] - (sama.gettilled_hay() + sama.gethay_hay());
				sama.setin_prairiesandreed(true);
				sama.setyears_in_prairie_sandreed(0);
				sama.setin_grass(false);
				sama.setin_willows(false);
				sama.setin_poplar(false);
				}
		
	}
				}


	public int getRentCropland(int ProducerID) {
		Connection conn;
		int rent = 0;
		try {
			conn = DriverManager.getConnection("jdbc:odbc:producerDB", "java",
					"1234");
			Statement stmt = conn.createStatement();
			ResultSet rs = stmt
					.executeQuery("SELECT rent_cropland FROM MIP WHERE "
							+ "farmerID=" + ProducerID + "and " + "year="
							+ Variables.getyear());

			while (rs.next()) {
				rent = rs.getInt("rent_cropland");
			}
			rs.close();
			stmt.close();
			conn.close();
		} catch (SQLException e) {
			//System.out.println("Statement is wrong: " + e.getMessage());
			e.printStackTrace();
		}		
		return rent;
	}

	public void select_lease_plot() {
		boolean flag_for_rent = false;
		ArrayList rent_land_list = new ArrayList();
		for (int i = 0; i < Variables.getlandlist().size(); i++) {
			SAMA fdl4 = (SAMA) Variables.getlandlist().get(i);
			if (fdl4.getfor_rent() == true) {
				flag_for_rent = true;
				rent_land_list.add(fdl4);
			}
		}
		if (rent_land_list.size() != 0) {
			SAMA fdl3 = (SAMA) rent_land_list
					.get((int) (Math.random() * rent_land_list.size()));
			if (flag_for_rent == true) {
				Variables.setcurrent_plot_on_market(fdl3.getid_land_market());
				for (int i = 0; i < Variables.getfarmerlist().size(); i++) {
					Producer prod = (Producer) Variables.getfarmerlist().get(i);
					screen_farmers_plot(fdl3);
				}
			}
		}
	}

	String convertDoubleArrayToString(double[] array) {
		StringBuffer buffer = new StringBuffer();
		for (double d : array) {
			buffer.append(String.valueOf(d) + " ");
		}
		String resultStr = buffer.toString();
		resultStr = resultStr.trim();

		return resultStr;
	}

	public void existing_machinery_package() {

		simulate_depreciation();
	}

	public double[] getcontribution_margin() {
		return contribution_margin;
	}

	public void setcontribution_margin(double[] i) {
		contribution_margin = i;
	}
	
	public double[] getcontribution() {
		return contribution;
	}
	
	public void setcontribution (double[] i){
		contribution = i;
	}
	public double[] getborrowing() {
		return borrowing;
	}

	public void setborrowing(double[] i) {
		borrowing = i;
	}

	public double gettillage_fallow() {
		return tillage_fallow;
	}

	public void settillage_fallow(double i) {
		tillage_fallow = i;
	}

	public double getwheat_on_fallow() {
		return wheat_on_fallow;
	}

	public void setwheat_on_fallow(double i) {
		wheat_on_fallow = i;
	}

	public double getcanola_stubble() {
		return canola_stubble;
	}

	public void setcanola_stubble(double i) {
		canola_stubble = i;
	}

	public double getbarley_stubble() {
		return barley_stubble;
	}

	public void setbarley_stubble(double i) {
		barley_stubble = i;
	}

	public double getwheat_stubble() {
		return wheat_stubble;
	}

	public void setwheat_stubble(double i) {
		wheat_stubble = i;
	}

	public double getwheat_notill() {
		return wheat_notill;
	}

	public void setwheat_notill(double i) {
		wheat_notill = i;
	}

	public double getbarley_notill() {
		return barley_notill;
	}

	public void setbarley_notill(double i) {
		barley_notill = i;
	}

	public double getcanola_notill() {
		return canola_notill;
	}

	public void setcanola_notill(double i) {
		canola_notill = i;
	}

	public double getoption_0_acres() {
		return option_0_acres;
	}

	public void setoption_0_acres(double i) {
		option_0_acres = (int) i;
	}

	public double getoption_1_acres() {
		return option_1_acres;
	}

	public void setoption_1_acres(double i) {
		option_1_acres = (int) i;
	}

	public double getoption_2_acres() {
		return option_2_acres;
	}

	public void setoption_2_acres(double i) {
		option_2_acres = (int) i;
	}

	public double getoption_3_acres() {
		return option_3_acres;
	}

	public void setoption_3_acres(double i) {
		option_3_acres = (int) i;
	}

	public double getoption_4_acres() {
		return option_4_acres;
	}

	public void setoption_4_acres(double i) {
		option_4_acres = (int) i;
	}

	public double getoption_5_acres() {
		return option_5_acres;
	}

	public void setoption_5_acres(double i) {
		option_5_acres = (int) i;
	}

	public double getoption_6_acres() {
		return option_6_acres;
	}

	public void setoption_6_acres(double i) {
		option_6_acres = (int) i;
	}

	public double getoption_7_acres() {
		return option_7_acres;
	}

	public void setoption_7_acres(double i) {
		option_7_acres = (int) i;
	}

	public double getoption_8_acres() {
		return option_8_acres;
	}

	public void setoption_8_acres(double i) {
		option_8_acres = (int) i;
	}

	public double getoption_9_acres() {
		return option_9_acres;
	}

	public void setoption_9_acres(double i) {
		option_9_acres = (int) i;
	}

	public double getexpected_income() {
		return expected_income;
	}

	public void setexpected_income(double i) {
		expected_income = i;
	}

	public double getyield_mult() {
		return yield_mult;
	}

	public void setyield_mult(double i) {
		yield_mult = i;
	}

	public double getoption_0_number_machines() {
		return option_0_number_machines;
	}

	public void setoption_0_number_machines(double i) {
		option_0_number_machines = (int) i;
	}

	public double getoption_1_number_machines() {
		return option_1_number_machines;
	}

	public void setoption_1_number_machines(double i) {
		option_1_number_machines = (int) i;
	}

	public double getoption_2_number_machines() {
		return option_2_number_machines;
	}

	public void setoption_2_number_machines(double i) {
		option_2_number_machines = (int) i;
	}

	public double getoption_3_number_machines() {
		return option_3_number_machines;
	}

	public void setoption_3_number_machines(double i) {
		option_3_number_machines = (int) i;
	}

	public double getoption_4_number_machines() {
		return option_4_number_machines;
	}

	public void setoption_4_number_machines(double i) {
		option_4_number_machines = (int) i;
	}

	public double getoption_5_number_machines() {
		return option_5_number_machines;
	}

	public void setoption_5_number_machines(double i) {
		option_5_number_machines = (int) i;
	}

	public double getoption_6_number_machines() {
		return option_6_number_machines;
	}

	public void setoption_6_number_machines(double i) {
		option_6_number_machines = (int) i;
	}

	public double getoption_7_number_machines() {
		return option_7_number_machines;
	}

	public void setoption_7_number_machines(double i) {
		option_7_number_machines = (int) i;
	}

	public double getoption_8_number_machines() {
		return option_8_number_machines;
	}

	public void setoption_8_number_machines(double i) {
		option_8_number_machines = (int) i;
	}

	public double getoption_9_number_machines() {
		return option_9_number_machines;
	}

	public void setoption_9_number_machines(double i) {
		option_9_number_machines = (int) i;
	}

	public double[] getcrop_mix() {
		return crop_mix;
	}

	public void setcrop_mix(double[] i) {
		crop_mix = i;
	}

	public double[] getlivestock_variables() {
		return livestock_variables;
	}
	
	public void setlivestock_variables (double[] i) {
		livestock_variables = i;
	}
	
	public double[] getpasture_mix() {
		return pasture_mix;
	}
	
	public void setpasture_mix (double[] i) {
		pasture_mix = i;
	}
	
	public double[] getmachinery_variables() {
		return machinery_variables;
	}

	public void setmachinery_variables(double[] i) {
		machinery_variables = i;
	}
	
	public double[] gethay_transfer() {
		return hay_transfer;
	}
	
	public void sethay_transfer (double[] i) {
		hay_transfer = i;
	}

	public double[] getwinter_pasture_mcals() {
		return winter_pasture_mcals;
	}
	
	public void setwinter_pasture_mcals (double[] i) {
		winter_pasture_mcals = i;
	}
	
	public double getfallow() {
		return fallow;
	}

	public void setfallow(double i) {
		fallow = i;
	}

	public double getwheatfallow() {
		return wheatfallow;
	}

	public void setwheatfallow(double i) {
		wheatfallow = i;
	}

	public double getcanolastubble() {
		return canolastubble;
	}

	public void setcanolastubble(double i) {
		canolastubble = i;
	}

	public double getbarleystubble() {
		return barleystubble;
	}

	public void setbarleystubble(double i) {
		barleystubble = i;
	}

	public double getwheatstubble() {
		return wheatstubble;
	}

	public void setwheatstubble(double i) {
		wheatstubble = i;
	}

	public double getbarleynotill() {
		return barleynotill;
	}

	public void setbarleynotill(double i) {
		barleynotill = i;
	}

	public double getwheatnotill() {
		return wheatnotill;
	}

	public void setwheatnotill(double i) {
		wheatnotill = i;
	}

	public double getcanolanotill() {
		return canolanotill;
	}

	public void setcanolanotill(double i) {
		canolanotill = i;
	}

	public double getoption0acres() {
		return option0acres;
	}

	public void setoption0acres(double i) {
		option0acres = i;
	}

	public double getoption1acres() {
		return option1acres;
	}

	public void setoption1acres(double i) {
		option1acres = i;
	}

	public double getoption2acres() {
		return option2acres;
	}

	public void setoption2acres(double i) {
		option2acres = i;
	}

	public double getoption3acres() {
		return option3acres;
	}

	public void setoption3acres(double i) {
		option3acres = i;
	}

	public double getoption4acres() {
		return option4acres;
	}

	public void setoption4acres(double i) {
		option4acres = i;
	}

	public double getoption5acres() {
		return option5acres;
	}

	public void setoption5acres(double i) {
		option5acres = i;
	}

	public void setoption6acres(double i) {
		option6acres = i;
	}

	public double getoption6acres() {
		return option6acres;
	}

	public void setoption7acres(double i) {
		option7acres = i;
	}

	public double getoption7acres() {
		return option7acres;
	}

	public void setoption8acres(double i) {
		option8acres = i;
	}

	public double getoption8acres() {
		return option8acres;
	}

	public void setoption9acres(double i) {
		option9acres = i;
	}

	public double getoption9acres() {
		return option9acres;
	}

	public static double getoption0numbermachines() {
		return option0numbermachines;
	}

	public void setoption0numbermachines(double i) {
		option0numbermachines = i;
	}

	public static double getoption1numbermachines() {
		return option1numbermachines;
	}

	public void setoption1numbermachines(double i) {
		option1numbermachines = i;
	}

	public static double getoption2numbermachines() {
		return option2numbermachines;
	}

	public void setoption2numbermachines(double i) {
		option2numbermachines = i;
	}

	public static double getoption3numbermachines() {
		return option3numbermachines;
	}

	public void setoption3numbermachines(double i) {
		option3numbermachines = i;
	}

	public static double getoption4numbermachines() {
		return option4numbermachines;
	}

	public void setoption4numbermachines(double i) {
		option4numbermachines = i;
	}

	public static double getoption5numbermachines() {
		return option5numbermachines;
	}

	public void setoption5numbermachines(double i) {
		option5numbermachines = i;
	}

	public static double getoption6numbermachines() {
		return option6numbermachines;
	}

	public void setoption6numbermachines(double i) {
		option6numbermachines = i;
	}

	public static double getoption7numbermachines() {
		return option7numbermachines;
	}

	public void setoption7numbermachines(double i) {
		option7numbermachines = i;
	}

	public static double getoption8numbermachines() {
		return option8numbermachines;
	}

	public void setoption8numbermachines(double i) {
		option8numbermachines = i;
	}

	public static double getoption9numbermachines() {
		return option9numbermachines;
	}

	public void setoption9numbermachines(double i) {
		option9numbermachines = i;
	}

	public double getBarleyYieldIndex() {
		return barley_yield_index;
	}

	public double getCanolaYieldIndex() {
		return canola_yield_index;
	}

	public double getWheatYieldIndex() {
		return wheat_yield_index;
	}

	public double getWheatSfYieldIndex() {
		return wheat_sf_yield_index;
	}
	
	public double getflax_yield_index() {
		return flax_yield_index;
	}

	public void set_yield_exp() {
		yield_exp_list = Variables.getexpected_yield_list();
	}

	public void set_parameters() {
		price_exp_list = Variables.getexpected_price_list();
	}

	public double gettotal_net_inc() {
		return total_net_inc;
	}

	public double gettotal_net_hay_income () {
		return total_net_hay_income;
	}
	
	public void settotal_net_hay_income (double i) {
		total_net_hay_income = i;
	}
	
	public void settotal_net_inc(double i) {
		total_net_inc = i;
	}

	public double gettotal_gross_crop_inc() {
		return total_gross_crop_inc;
	}

	public void settotal_gross_crop_inc(double i) {
		total_gross_crop_inc = i;
	}

	public void setrent_cropland(double i) {
		rent_cropland = i;
	}

	public double getrent_cropland() {
		return rent_cropland;
	}

	public void setbuy_cropland(double i) {
		buy_cropland = i;
	}
	
	public double getbuy_cropland() {
		return buy_cropland;
	}
		
	public void setamount_borrow(double i) {
		amount_borrow = i;
	}

	public double getamount_borrow() {
		return amount_borrow;
	}

	public void setrenter_cropland(int i) {
		renter_cropland = i;
	}

	public double getrenter_land() {
		return renter_cropland;
	}

	public void setbuyer_cropland(int i) {
		buyer_cropland = i;
	}

	public double getbuyer_cropland() {
		return buyer_cropland;
	}

	public int getfarmer_name() {
		return farmer_id;
	}

	public void setfarmer_name(int i) {
		farmer_id = i;
	}

	public void setID(int i) {
		ID = i;
	}

	public int getID() {
		return ID;
	}

	public void setX(int i) {
		x = i;
	}

	public int getX() {
		return x;
	}

	public void setY(int i) {
		y = i;
	}

	public int getY() {
		return y;
	}

	public int getbegin_patch_ID() {
		return begin_patch_ID;
	}

	public int getplots_needed() {
		return plots_needed;
	}

	public void setmylandList(ArrayList i) {
		mylandList = i;
	}

	public ArrayList getmylandList() {
		return mylandList;
	}	

	public double[] getyield_exp_list() {
		return yield_exp_list;
	}

	public void setyield_exp_list(double[] i) {
		yield_exp_list = i;
	}

	public boolean getdie() {
		return die;
	}

	public void setdie(boolean i) {
		die = i;
	}

	public double getcrop_machine_option() {
		return crop_machine_option;
	}

	public ArrayList getdebt_list() {

		return debt_list;
	}

	public void setdebt_list(ArrayList i) {
		debt_list = i;
	}

	public void setcash(int i) {
		cash = i;
	}

	public int getcash() {
		return cash;
	}

	public double gettotal_acres_farmed() {
		return total_acres_farmed;
	}

	public void settotal_acres_farmed(double i) {
		total_acres_farmed = i;
	}

	public int gettotal_crop_acres() {
		return total_crop_acres;
	}

	public void settotal_crop_acres(int i) {
		total_crop_acres = i;
	}

	public int gettotal_hay() {
		return total_hay;
	}
	
	public void settotal_hay (int i) {
		total_hay = i;
	}
	
	public void settotal_improved_pasture (int i) {
		total_improved_pasture = i;
	}
	
	public int gettotal_improved_pasture () {
		return total_improved_pasture;
	}
	
	public int gettotal_natural_pasture () {
		return total_natural_pasture;
	}
	
	public void settotal_natural_pasture (int i) {
		total_natural_pasture = i;
	}
	
	public int gettotal_acres_owned() {
		return total_acres_owned;
	}

	public void settotal_acres_owned(int i) {
		total_acres_owned = i;
	}

	public double getvc_acre() {
		return vc_acre;

	}

	public void setvc_acre(double i) {
		vc_acre = i;
	}

	public void setcan_bid(boolean i) {
		can_bid = i;
	}

	public boolean getcan_bid() {
		return can_bid;
	}

	public void setshould_bid_rent(boolean i) {
		should_bid_rent = i;
	}

	public boolean getshould_bid_rent() {
		return should_bid_rent;
	}
	
	public void setchecklandmarketresults (boolean i) {
		checklandmarketresults = i;
	}
	
	public boolean getchecklandmarketresults () {
		return checklandmarketresults;
	}

	public void settacticalused (boolean i) {
		tacticalused = i;
	}
	
	public boolean gettacticalused () {
		return tacticalused;
	}
	
	public void setinfeasiblesolution (boolean i) {
		infeasiblesolution = i;
	}
	
	public boolean getinfeasiblesolution () {
		return infeasiblesolution;
	}
	
	public boolean getcan_bid_on_plot() {
		return can_bid_on_plot;
	}

	public void setcan_bid_on_plot(boolean i) {
		can_bid_on_plot = i;
	}

	public boolean getcan_contribute() {
		return can_contribute;
	}
	
	public void setcan_contribute (boolean i) {
		can_contribute = i;
	}
	
	
	public int getbid_finances() {
		return bid_finances;
	}

	public void setbid_finances(int i) {
		bid_finances = i;
	}

	public double getcurrent_bid() {
		return current_bid;
	}

	public void setcurrent_bid(double i) {
		current_bid = i;
	}

	public double getcurrent_bid_marginalland() {
		return current_bid_marginalland;
	}

	public void setcurrent_bid_marginalland(double i) {
		current_bid_marginalland = i;
	}
	
	
	public double getplot_income_crop() {
		return plot_income_crop;
	}

	public void setplot_income_crop(double i) {
		plot_income_crop = i;
	}

	public double getgross_income_crop() {
		return gross_income_crop;
	}

	public void setgross_income_crop(double i) {
		gross_income_crop = i;
	}

	public double getgross_income_livestock() {
		return gross_income_livestock;
	}

	public void setgross_income_livestock(double i) {
		gross_income_livestock = i;
	}
	
	public double getgross_income_hay () {
		return gross_income_hay;
	}
	
	public void setgross_income_hay (double i) {
		gross_income_hay = i;
	}
	
	public double getgross_income_energycrops() {
		return gross_income_energycrops;
	}

	public void setgross_income_energycrops(double i) {
		gross_income_energycrops = i;
	}
	
	public double getgross_income() {
		return gross_income;
	}

	public void setgross_incom(double i) {
		gross_income = i;
	}
	
	public void setoption_0_acres(int i) {
		option_0_acres = i;
	}

	public void setoption_1_acres(int i) {
		option_1_acres = i;
	}

	public void setoption_0_number_machines(int i) {
		option_0_number_machines = i;
	}

	public void setoption_1_number_machines(int i) {
		option_1_number_machines = i;
	}

	public void setexpected_income(int i) {
		expected_income = i;
	}
	
	public void setincome_tax(int i) {
		income_tax = i;
	}
	
	public int getincome_tax() {
		return income_tax;
	}

	public void setcrop_insurance_coverage_level(double i) {
		crop_insurance_coverage_level = i;
	}
	
	public double getcrop_insurance_coverage_level() {
		return crop_insurance_coverage_level;
	}
	
	public void setinsurance_payout (double i) {
		 insurance_payout = i;;
	}
	
	public double getinsurance_payout () {
		return insurance_payout;
	}
	
	public void settotal_eligible_netsales(double i) {
		total_eligible_netsales = i;
	}
	
	public double gettotal_eligible_netsales () {
		return total_eligible_netsales;
	}
	
	public void settotal_crop_eligible_netsales(double i) {
		total_crop_eligible_netsales = i;
	}
	
	public double gettotal_crop_eligible_netsales () {
		return total_crop_eligible_netsales;
	}
	
	public void settotal_calf_eligible_netsales(double i) {
		total_calf_eligible_netsales = i;
	}
	
	public double gettotal_calf_eligible_netsales () {
		return total_calf_eligible_netsales;
	}
	
	
	public void setfarmer_contribution_agriinvest(double i) {
		farmer_contribution_agriinvest = i;
	}
	
	public double getfarmer_contribution_agriinvest () {
		return farmer_contribution_agriinvest;
	}
	
	public void setfund_1 (double i) {
		fund_1 = i;
	}
	
	public double getfund_1 () {
		return fund_1;
	}
	
	public void setfund_2 (double i) {
		fund_2 = i;
	}
	
	public double getfund_2 () {
		return fund_2;
	}
	
	
	public void setinterest_earned_fund_1 (double i) {
		interest_earned_fund_1 = i;
	}
	
	public double getinterest_earned_fund_1 () {
		return interest_earned_fund_1;
	}
	
	public void setinterest_earned_fund_2 (double i) {
		interest_earned_fund_2 = i;
	}
	
	public double getinterest_earned_fund_2 () {
		return interest_earned_fund_2;
	}
	
	
	public void settotal_contribution_agriinvest(double i) {
		total_contribution_agriinvest = i;
	}
	
	public double gettotal_contribution_agriinvest () {
		return total_contribution_agriinvest;
	}
	
	public void setgovernment_match_agriinvest (double i) {
		government_match_agriinvest = i;
	}
	
	public double getgovernment_match_agriinvest () {
		return government_match_agriinvest;
	}
	
	public void setlast_year_eligible_netsales(int i) {
		last_year_eligible_netsales = i;
	}
	
	public int getlast_year_eligible_netsales () {
		return last_year_eligible_netsales;
	}
	
	public void settwo_yearsago_eligible_netsales(int i) {
		two_yearsago_eligible_netsales = i;
	}
	
	public int gettwo_yearsago_eligible_netsales () {
		return two_yearsago_eligible_netsales;
	}
	
	public void setthree_yearsago_eligible_netsales(int i) {
		three_yearsago_eligible_netsales = i;
	}
	
	public int getthree_yearsago_eligible_netsales () {
		return three_yearsago_eligible_netsales;
	}
	
	public void setfour_yearsago_eligible_netsales(int i) {
		four_yearsago_eligible_netsales = i;
	}
	
	public int getfour_yearsago_eligible_netsales () {
		return four_yearsago_eligible_netsales;
	}
	
	public void setfive_yearsago_eligible_netsales(int i) {
		five_yearsago_eligible_netsales = i;
	}
	
	public int getfive_yearsago_eligible_netsales () {
		return five_yearsago_eligible_netsales;
	}
		
	public void setagriinvest_account_balance (double i) {
		agriinvest_account_balance = i;
	}
	
	public double getagriinvest_account_balance () {
		return agriinvest_account_balance;
	}
	
	public void setagriinvest_withdrawal_fund_2 (double i) {
		agriinvest_withdrawal_fund_2 = i;
	}
	
	public double getagriinvest_withdrawal_fund_2 () {
		return agriinvest_withdrawal_fund_2;
	}
	
	public void setagriinvest_withdrawal_fund_1 (double i) {
		agriinvest_withdrawal_fund_1 = i;
	}
	
	public double getagriinvest_withdrawal_fund_1 () {
		return agriinvest_withdrawal_fund_1;
	}
	
	public void setagriinvest_withdrawal (double i) {
		agriinvest_withdrawal = i;
	}
	
	public double getagriinvest_withdrawal () {
		return agriinvest_withdrawal;
	}
	
	public void setcrop_rm_lastyear (double i) {
		crop_rm_lastyear = i;
	}
	
	public double getcrop_rm_lastyear () {
		return crop_rm_lastyear;
	}
	
	public void setcrop_rm_two_years_ago (double i) {
		crop_rm_two_years_ago = i;
	}
	
	public double getcrop_rm_two_years_ago () {
		return crop_rm_two_years_ago;
	}
	
	public void setcrop_rm_three_years_ago (double i) {
		crop_rm_three_years_ago = i;
	}
	
	public double getcrop_rm_three_years_ago () {
		return crop_rm_three_years_ago;
	}
	
	public void setcrop_rm_four_years_ago (double i) {
		crop_rm_four_years_ago = i;
	}
	
	public double getcrop_rm_four_years_ago () {
		return crop_rm_four_years_ago;
	}
	
	public void setcrop_rm_five_years_ago (double i) {
		crop_rm_five_years_ago = i;
	}
	
	public double getcrop_rm_five_years_ago () {
		return crop_rm_five_years_ago;
	}
	
	public void setcalf_rm_lastyear (double i) {
		calf_rm_lastyear = i;
	}
	
	public double getcalf_rm_lastyear () {
		return calf_rm_lastyear;
	}
	
	public void setcalf_rm_two_years_ago (double i) {
		calf_rm_two_years_ago = i;
	}
	
	public double getcalf_rm_two_years_ago () {
		return calf_rm_two_years_ago;
	}
	
	public void setcalf_rm_three_years_ago (double i) {
		calf_rm_three_years_ago = i;
	}
	
	public double getcalf_rm_three_years_ago () {
		return calf_rm_three_years_ago;
	}
	
	public void setcalf_rm_four_years_ago (double i) {
		calf_rm_four_years_ago = i;
	}
	
	public double getcalf_rm_four_years_ago () {
		return calf_rm_four_years_ago;
	}
	
	public void setcalf_rm_five_years_ago (double i) {
		calf_rm_five_years_ago = i;
	}
	
	public double getcalf_rm_five_years_ago () {
		return calf_rm_five_years_ago;
	}
		
	public void settotal_farm_reference_margin (double i) {
		total_farm_reference_margin = i;
	}
	
	public double gettotal_farm_reference_margin () {
		return total_farm_reference_margin;
	}
	
	public void setpre_farm_reference_margin_crop(double[] i) {
		pre_farm_reference_margin_crop = i;
	}
	
	public double[] getpre_farm_reference_margin_crop () {
		return pre_farm_reference_margin_crop;
	}
	
	public void setpre_farm_reference_margin_calf(double[] i) {
		pre_farm_reference_margin_calf = i;
	}
	
	public double[] getpre_farm_reference_margin_calf () {
		return pre_farm_reference_margin_calf;
	}
	
	public void setpre_farm_reference_margin_energycrop(double[] i) {
		pre_farm_reference_margin_energycrop = i;
	}
	
	public double[] getpre_farm_reference_margin_energycrop () {
		return pre_farm_reference_margin_energycrop;
	}
	
	
	public void settotal_farm_income_margin (double i) {
		total_farm_income_margin = i;
	}
	
	public double gettotal_farm_income_margin () {
		return total_farm_income_margin;
	}
	
	public void settotal_net_crop_income_per_acre (double i) {
		total_net_crop_income_per_acre = i;
	}
	
	public double gettotal_net_crop_income_per_acre () {
		return total_net_crop_income_per_acre;
	}
	
	public double gettotal_net_crop_income () {
		return total_net_crop_income;
	}
	
	public void settotal_net_crop_income (double i) {
		total_net_crop_income = i;
	}
	
	public double gettotal_net_calf_income () {
		return total_net_calf_income;
	}
	
	public void settotal_net_calf_income (double i) {
		total_net_calf_income = i;
	}
	
	public double gettotal_net_energy_income () {
		return total_net_energy_income;
	}
	
	public void settotal_net_energy_income (double i) {
		total_net_energy_income = i;
	}
	
	public void setnatural_pasture (double i) {
		natural_pasture = i;
	}
	
	public double getnatural_pasture () {
		return natural_pasture;
	}
	
	public void setimproved_pasture (double i) {
		improved_pasture = i;
	}
	
	public double getimproved_pasture () {
		return improved_pasture;
	}
	
	private void sethayland_pasture (double i) {
		hayland_pasture = i;
	}
	
	public double gethayland_pasture () {
		return hayland_pasture;
	}
	
	public void setpasture_carryover_1 (double i) {
		pasture_carryover_one = i;
	}
	
	public double getpasture_carryover_one () {
		return pasture_carryover_one;
	}
	
	public void setpasture_carryover_2 (double i) {
		pasture_carryover_two = i;
	}
	
	public double getpasture_carryover_two () {
		return pasture_carryover_two;
	}
	
	public void setimproved_bale_first_cut (double i) {
		improved_bale_first_cut = i;
	}
	
	public double getimproved_bale_first_cut () {
		return improved_bale_first_cut;
	}
	
	public void setimproved_bale_second_cut (double i) {
		improved_bale_second_cut = i;
	}
	
	public double getimproved_bale_second_cut () {
		return improved_bale_second_cut;
	}
	
	public void sethay_production_one_cut (double i) {
		hay_production_one_cut = i;
	}
	
	public double gethay_production_one_cut () {
		return hay_production_one_cut;
	}
	
	public void sethay_production_two_cuts (double i) {
		hay_production_two_cuts = i;
	}
	
	public double gethay_production_two_cuts () {
		return hay_production_two_cuts;
	}
	
	public void setbuy_hay (double i) {
		buy_hay = i;
	}
	
	public double getbuy_hay () {
		return buy_hay;
	}
	
	public void setbuy_feed_wheat (double i) {
		buy_feed_wheat = i;
	}
	
	public double getbuy_feed_wheat () {
		return buy_feed_wheat;
	}
	
	public void setbuy_feed_barley (double i) {
		buy_feed_barley = i;
	}
	
	public double getbuy_feed_barley () {
		return buy_feed_barley;
	}
	
	public void setfeed_early_summer_hay (double i) {
		feed_early_summer_hay = i;
	}
	
	public double getfeed_early_summer_hay () {
		return feed_early_summer_hay;
	}
	
	public void setfeed_late_summer_hay (double i) {
		feed_late_summer_hay = i;
	}
	
	public double getfeed_late_summer_hay () {
		return feed_late_summer_hay;
	}
	
	public void setfeed_fall_hay (double i) {
		feed_fall_hay = i;
	}
	
	public double getfeed_fall_hay () {
		return feed_fall_hay;
	}
	
	public void setfeed_winter_hay (double i) {
		feed_winter_hay = i;
	}
	
	public double getfeed_winter_hay () {
		return feed_winter_hay;
	}
	
	public void setfeed_wheat (double i) {
		feed_wheat = i;
	}
	
	public double getfeed_wheat () {
		return feed_wheat;
	}
	
	public void setfeed_barley (double i) {
		feed_barley = i;
	}
	
	public double getfeed_barley () {
		return feed_barley;
	}
	
	public void setsell_hay (double i) {
		sell_hay = i;
	}
	
	public double getsell_hay () {
		return sell_hay;
	}
	
	public void setcows_head (double i) {
		cows_head = i;
	}
	
	public double getcows_head () {
		return cows_head;
	}
	
	public void setcows_labour (int i) {
		cows_labour = i;
	}
	
	public double getcows_labour () {
		return cows_labour;
	}
	
	public void setrent_pasture_land (int i) {
		rent_pasture_land = i;
	}
	
	public double getrent_pasture_land () {
		return rent_pasture_land;
	}
	
	public void setbreaking_cost (double i) {
		breaking_cost = i;
	}
	
	public double getbreaking_cost () {
		return breaking_cost;
	}
	
	public void setbarley_straw (double i) {
		barley_straw = i;
	}
	
	public double getbarley_straw () {
		return barley_straw;
	}
	
	public void setwheat_straw (double i) {
		wheat_straw = i;
	}
	
	public double getwheat_straw () {
		return wheat_straw;
	}
	
	public void setn_cows (double i) {
		n_cows = i;
	}
	
	public double getn_cows () {
		return n_cows;
	}
	
	public void setold_cows (double i) {
		old_cows = i;
	}
	
	public double getold_cows () {
		return old_cows;
	}
	
	public void setlivestock_labour (int i) {
		livestock_labour = i;
	}
	
	public double getlivestock_labour (){
		return livestock_labour;
	}
	
	public void setnaturalpasture (double i) {
		naturalpasture = i;
	}
	
	public double getnaturalpasture () {
		return naturalpasture;
	}
	
	public void setimprovedpasture (double i) {
		improvedpasture = i;
	}
	
	public double getimprovedpasture () {
		return improvedpasture;
	}
	
	public void sethaylandpasture (double i) {
		haylandpasture = i;
	}
	
	public double gethaylandpasture () {
		return haylandpasture;
	}
	
	public void setpasturecarryoverone (double i) {
		pasturecarryoverone = i;
	}
	
	public double getpasturecarryoverone () {
		return pasturecarryoverone;
	}
	
	public void setpasturecarryovertwo (double i) {
		pasturecarryovertwo = i;
	}
	
	public double getpasturecarryovertwo () {
		return pasturecarryovertwo;
	}
	
	public void setimprovedbaleone (double i) {
		improvedbaleone = i;
	}
	
	public double getimprovedbaleone () {
		return improvedbaleone;
	}
	
	public void setimprovedbaletwo (double i) {
		improvedbaletwo = i;
	}
	
	public double getimprovedbaletwo () {
		return improvedbaletwo;
	}
	
	public void sethaybaleone (double i) {
		haybaleone = i;
	}
	
	public double gethaybaleone () {
		return haybaleone;
	}
	
	public void sethaybaletwo (double i) {
		haybaletwo = i;
	}
	
	public double gethaybaletwo () {
		return haybaletwo;
	}
	
	public void setbreakingcost (double i) {
		breakingcost = i;
	}
	
	public double getbreakingcost () {
		return breakingcost;
	}
	
	public void setbuyhay (double i) {
		buyhay = i;
	}
	
	public double getbuyhay () {
		return buyhay;
	}
	
	public void setbuyfeedwheat (double i) {
		buyfeedwheat = i;
	}
	
	public double getbuyfeedwheat () {
		return buyfeedwheat;
	}
	
	public void setbuyfeedbarley (double i) {
		buyfeedbarley = i;
	}
	
	public double getbuyfeedbarley () {
		return buyfeedbarley;
	}
	
	public void setfeedhay (double i) {
		feedhay = i;
	}
	
	public double getfeedhay () {
		return feedhay;
	}
	
	public void setfeedwheat (double i) {
		feedwheat = i;
	}
	
	public double getfeedwheat () {
		return feedwheat;
	}
	
	public void setfeedbarley (double i) {
		feedbarley = i;
	}
	
	public double getfeedbarley () {
		return feedbarley;
	}
	
	public void setfeedwheatstraw (double i) {
		feedwheatstraw = i;
	}
	
	public double getfeedwheatstraw () {
		return feedwheatstraw;
	}
	
	public void setfeedbarleystraw (double i) {
		feedbarleystraw = i;
	}
	
	public double getfeedbarleystraw () {
		return feedbarleystraw;
	}
	
	public void setsellhay (double i) {
		sellhay = i;
	}
	
	public double getsellhay () {
		return sellhay;
	}
	
	public void setfeedearlysummerhay (double i) {
		feedearlysummerhay = i;
	}
	
	public double getfeedearlysummerhay () {
		return feedearlysummerhay;
	}
	
	public void setfeedlatesummerhay (double i) {
		feedlatesummerhay = i;
	}
	
	public double getfeedlatesummerhay () {
		return feedlatesummerhay;
	}
	
	public void setfeedfallhay (double i) {
		feedfallhay = i;
	}
	
	public double getfeedfallhay () {
		return feedfallhay;
	}
	
	public void setfeedwinterhay (double i) {
		feedwinterhay = i;
	}
	
	public double getfeedwinterhay () {
		return feedwinterhay;
	}
	
	public void settotal_acres_before (double i) {
		total_acres_before = i;
	}
	
	public double gettotal_acres_before () {
		return total_acres_before;
	}
	
	public double gettotal_acres_leased () {
		return total_acres_leased;
	}
	
	public void setexp_np_early_yield (double i) {
		exp_np_early_yield = i;
	}
	
	public double getexp_np_early_yield () {
		return exp_np_early_yield;
	}
	
	public void setexp_np_late_yield (double i) {
		exp_np_late_yield = i;
	}
	
	public double getexp_np_late_yield () {
		return exp_np_late_yield;
	}
	
	public void setexp_np_fall_yield (double i) {
		exp_np_fall_yield = i;
	}
	
	public double getexp_np_fall_yield () {
		return exp_np_fall_yield;
	}
	
	public void setexp_ip_early_yield (double i) {
		exp_ip_early_yield = i;
	}
	
	public double getexp_ip_early_yield () {
		return exp_ip_early_yield;
	}
	
	public void setexp_ip_late_yield (double i) {
		exp_ip_late_yield = i;
	}
	
	public double getexp_ip_late_yield () {
		return exp_ip_late_yield;
	}
	
	public void setexp_ip_fall_yield (double i) {
		exp_ip_fall_yield = i;
	}
	
	public double getexp_ip_fall_yield () {
		return exp_ip_fall_yield;
	}
	
	public void setexp_hay_early_yield (double i) {
		exp_hay_early_yield = i;
	}
	
	public double getexp_hay_early_yield () {
		return exp_hay_early_yield;
	}
	
	public void setexp_hay_late_yield (double i) {
		exp_hay_late_yield = i;
	}
	
	public double getexp_hay_late_yield () {
		return exp_hay_late_yield;
	}
	
	public void setexp_hay_fall_yield (double i) {
		exp_hay_fall_yield = i;
	}
	
	public double getexp_hay_fall_yield () {
		return exp_hay_fall_yield;
	}
	
	public void setip_bale_one_yield (double i) {
		ip_bale_one_yield = i;
	}
	
	public double getip_bale_one_yield () {
		return ip_bale_one_yield;
	}
	
	public void setip_bale_two_yield (double i) {
		ip_bale_two_yield = i;
	}
	
	public double getip_bale_two_yield () {
		return ip_bale_two_yield;
	}
	
	public void sethay_bale_one_yield (double i) {
		hay_bale_one_yield = i;
	}
	
	public double gethay_bale_one_yield () {
		return hay_bale_one_yield;
	}
	
	public void sethay_bale_two_yield (double i) {
		hay_bale_two_yield = i;
	}
	
	public double gethay_bale_two_yield () {
		return hay_bale_two_yield;
	}
	
	public double getearly_summer_mcals_required () {
		return early_summer_mcals_required;
	}
	
	public void setearly_summer_mcals_required (double i) {
		early_summer_mcals_required = i;
	}
	 
	public double getlate_summer_mcals_required () {
		return late_summer_mcals_required;
	}
	
	public void setlate_summer_mcals_required (double i) {
		late_summer_mcals_required = i;
	}
	
	public  double getfall_mcals_required () {
		return fall_mcals_required;
	}
	
	public void setfall_mcals_required (double i) {
		fall_mcals_required = i;
	}
	
	public double getwinter_mcals_required () {
		return winter_mcals_required;
	}
	
	public void setwinter_mcals_required (double i) {
		winter_mcals_required = i;
	}
	
	public double gettotal_np_mcals_early () {
		return total_np_mcals_early;
	}
	
	public void settotal_np_mcals_early (double i) {
		total_np_mcals_early = i;
	}
	
	public double gettotal_np_mcals_late () {
		return total_np_mcals_late;
	}
	
	public void settotal_np_mcals_late (double i) {
		total_np_mcals_late = i;
	}
	
	public double gettotal_np_mcals_fall () {
		return total_np_mcals_fall;
	}
	
	public void settotal_np_mcals_fall (double i) {
		total_np_mcals_fall = i;
	}
	
	public double gettotal_ip_mcals_early () {
		return total_ip_mcals_early;
	}
	
	public void settotal_ip_mcals_early (double i) {
		total_ip_mcals_early = i;
	}
	
	public double gettotal_ip_mcals_late () {
		return total_ip_mcals_late;
	}
	
	public void settotal_ip_mcals_late (double i) {
		total_ip_mcals_late = i;
	}
	
	public double gettotal_ip_mcals_fall () {
		return total_ip_mcals_fall;
	}
	
	public void settotal_ip_mcals_fall (double i) {
		total_ip_mcals_fall = i;
	}
	
	public double gettotal_hayland_mcals_early () {
		return total_hayland_mcals_early;
	}
	
	public void settotal_hayland_mcals_early (double i) {
		total_hayland_mcals_early = i;
	}
	
	public double gettotal_hayland_mcals_late () {
		return total_hayland_mcals_late;
	}
	
	public void settotal_hayland_mcals_late (double i) {
		total_hayland_mcals_late = i;
	}
	
	public double gettotal_hayland_mcals_fall () {
		return total_hayland_mcals_fall;
	}
	
	public void settotal_hayland_mcals_fall (double i) {
		total_hayland_mcals_fall = i;
	}
	
	public double gettotal_bale_mcals_early () {
		return total_bale_mcals_early;
	}
	
	public void settotal_bale_mcals_early (double i) {
		total_bale_mcals_early = i;
	}
	 
	public double gettotal_bale_mcals_late () {
		return total_bale_mcals_late;
	}
	
	public void settotal_bale_mcals_late (double i) {
		total_bale_mcals_late = i;
	}
	
	public double getactual_late_summer_mcals () {
		return actual_late_summer_mcals;
	}
	
	public void setactual_late_summer_mcals (double i) {
		actual_late_summer_mcals = i;
	}
	
	public double getactual_fall_mcals () {
		return actual_fall_mcals;
	}
	
	public void setactual_fall_mcals (double i) {
		actual_fall_mcals = i;
	}
	
	public double getactual_winter_mcals () {
		return actual_winter_mcals;
	}
	
	public void setactual_winter_mcals (double i) {
		actual_winter_mcals = i;
	}
	
	public double getrequired_less_actual_early_mcals () {
		return required_less_actual_early_mcals;
	}
	
	public void setrequired_less_actual_early_mcals (double i) {
		required_less_actual_early_mcals = i;
	}
	
	public double getrequired_less_actual_late_mcals() {
		return required_less_actual_late_mcals;
	}
	
	public void setrequired_less_actual_late_mcals (double i) {
		required_less_actual_late_mcals = i;
	}
	public double getrequired_less_actual_fall_mcals () {
		return required_less_actual_fall_mcals;
	}
	
	public void setrequired_less_actual_fall_mcals (double i) {
		required_less_actual_fall_mcals = i;
	}
	
	public double getexp_mcals_np_early_yield () {
		return exp_mcals_np_early_yield;
	}
	
	public void setexp_mcals_np_early_yield (double i) {
		exp_mcals_np_early_yield = i;
	}
	
	public double getexp_mcals_np_late_yield () {
		return exp_mcals_np_late_yield;
	}
	
	public void setexp_mcals_np_late_yield (double i) {
		exp_mcals_np_late_yield = i;
	}
	
	public double getexp_mcals_np_fall_yield () {
		return exp_mcals_np_fall_yield;
	}
	
	public void setexp_mcals_np_fall_yield (double i) {
		exp_mcals_np_fall_yield = i;
	}
	
	public double getexp_mcals_ip_early_yield () {
		return exp_mcals_ip_early_yield;
	}
	
	public void setexp_mcals_ip_early_yield (double i) {
		exp_mcals_ip_early_yield = i;
	}
	
	public double getexp_mcals_ip_late_yield () {
		return exp_mcals_ip_late_yield;
	}
	
	public void setexp_mcals_ip_late_yield (double i) {
		exp_mcals_ip_late_yield = i;
	}
	
	public double getexp_mcals_ip_fall_yield () {
		return exp_mcals_ip_fall_yield;
	}
	
	public void setexp_mcals_ip_fall_yield (double i) {
		exp_mcals_ip_fall_yield = i;
	}
	
	public double getexp_mcals_hayland_early_yield () {
		return exp_mcals_hayland_early_yield;
	}
	
	public void setexp_mcals_hayland_early_yield (double i) {
		exp_mcals_hayland_early_yield = i;
	}
	
	public double getexp_mcals_hayland_late_yield () {
		return exp_mcals_hayland_late_yield;
	}
	
	public void setexp_mcals_hayland_late_yield (double i) {
		exp_mcals_hayland_late_yield = i;
	}
	
	public double getexp_mcals_hayland_fall_yield () {
		return exp_mcals_hayland_fall_yield;
	}
	
	public void setexp_mcals_hayland_fall_yield (double i) {
		exp_mcals_hayland_fall_yield = i;
	}
	
	public double getexp_mcals_ip_bale_one () {
		return exp_mcals_ip_bale_one;
	}
	
	public void setexp_mcals_ip_bale_one (double i) {
		exp_mcals_ip_bale_one = i;
	}
	
	public double getexp_mcals_ip_bale_two () {
		return exp_mcals_ip_bale_two;
	}
	
	public void setexp_mcals_ip_bale_two (double i) {
		exp_mcals_ip_bale_two = i;
	}
	
	public double getexp_mcals_hay_bale_one () {
		return exp_mcals_hay_bale_one;
	}
	
	public void setexp_mcals_hay_bale_one (double i) {
		exp_mcals_hay_bale_one = i;
	}
	
	public double getexp_mcals_hay_bale_two () {
		return exp_mcals_hay_bale_two;
	}
	
	public void setexp_mcals_hay_bale_two (double i) {
		exp_mcals_hay_bale_two = i;
	}
	
	public double gettotal_improved_bale_one_mcals () {
		return total_improved_bale_one_mcals;
	}
	
	public void settotal_improved_bale_one_mcals (double i) {
		total_improved_bale_one_mcals = i;
	}
	
	public double gettotal_improved_bale_two_mcals () {
		return total_improved_bale_two_mcals;
	}
	
	public void settotal_improved_bale_two_mcals (double i) {
		total_improved_bale_two_mcals = i;
	}
	
	public double gettotal_haybaleone_mcals () {
		return total_haybaleone_mcals;
	}
	
	public void settotal_haybaleone_mcals (double i) {
		total_haybaleone_mcals = i;
	}
	
	public double gettotal_haybaletwo_mcals () {
		return total_haybaletwo_mcals;
	}
	
	public void settotal_haybaletwo_mcals (double i) {
		total_haybaletwo_mcals = i;
	}
	
	
	public double getweighted_avg_mcals_bale_one () {
		return weighted_avg_mcals_bale_one;
	}
	
	public void setweighted_avg_mcals_bale_one (double i) {
		weighted_avg_mcals_bale_one = i;
	}
	
	public double getweighted_avg_mcals_bale_two () {
		return weighted_avg_mcals_bale_two;
	}
	
	public void setweighted_avg_mcals_bale_two (double i) {
		weighted_avg_mcals_bale_two = i;
	}
	
	public double gettotal_ip_bale_yield_one () {
		return total_ip_bale_yield_one;
	}
	
	public void settotal_ip_bale_yield_one (double i) {
		total_ip_bale_yield_one = i;
	}
	
	public double gettotal_hay_bale_yield_one () {
		return total_hay_bale_yield_one;
	}
	
	public void settotal_hay_bale_yield_one (double i) {
		total_hay_bale_yield_one = i;
	}
	
	public double getearly_bale_avg_mcals () {
		return early_bale_avg_mcals;
	}
	
	public void setearly_bale_avg_mcals (double i) {
		early_bale_avg_mcals = i;
	}
	
	
	public double gettotal_ip_bale_yield_two () {
		return total_ip_bale_yield_two;
	}
	
	public void settotal_ip_bale_yield_two (double i) {
		total_ip_bale_yield_two = i;
	}
	
	public double gettotal_hay_bale_yield_two () {
		return total_hay_bale_yield_two;
	}
	
	public void settotal_hay_bale_yield_two (double i) {
		total_hay_bale_yield_two = i;
	}
	
	public double getlate_bale_avg_mcals () {
		return late_bale_avg_mcals;
	}
	
	public void setlate_bale_avg_mcals (double i) {
		late_bale_avg_mcals = i;
	}
	
	public double[] getearly_mcal_energy_content () {
		return early_mcal_energy_content;
	}
	
	public void setearly_mcal_energy_content (double[] i) {
		early_mcal_energy_content = i;
	}
	
	public double[] getlate_mcal_energy_content () {
		return late_mcal_energy_content;
	}
	
	public void setlate_mcal_energy_content (double[] i) {
		late_mcal_energy_content = i;
	}
	
	public double[] getfall_mcal_energy_content () {
		return fall_mcal_energy_content;
	}
	
	public void setfall_mcal_energy_content (double[] i) {
		fall_mcal_energy_content = i;
	}
	
	public double[] getwinter_mcal_energy_content () {
		return winter_mcal_energy_content;
	}
	
	public void setwinter_mcal_energy_content (double[] i) {
		winter_mcal_energy_content = i;
	}
	
	public double[] getforage_breaking () {
		return forage_breaking;
	}
	
	public void setforage_breaking (double[] i) {
		forage_breaking = i;
	}
	
	public double gettonnes_crop_wheat_stubble () {
		return tonnes_crop_wheat_stubble;
	}
	
	public void settonnes_crop_wheat_stubble (double i) {
		tonnes_crop_wheat_stubble = i;
	}
	
	public double gettonnes_crop_barley_stubble () {
		return tonnes_crop_barley_stubble;
	}
	
	public void settonnes_crop_barley_stubble (double i) {
		tonnes_crop_barley_stubble = i;
	}
	
	public double gettonnes_crop_wheat_sf () {
		return tonnes_crop_wheat_sf;
	}
	
	public void settonnes_crop_wheat_sf (double i) {
		tonnes_crop_wheat_sf = i;
	}
	
	public double gettonnes_crop_barley_notill () {
		return tonnes_crop_barley_notill;
	}
	
	public void settonnes_crop_barley_notill (double i) {
		tonnes_crop_barley_notill = i;
	}
	
	public double gettonnes_crop_wheat_notill () {
		return tonnes_crop_wheat_notill;
	}
	
	public void settonnes_crop_wheat_notill (double i) {
		tonnes_crop_wheat_notill = i;
	}
	
	public double gettonnes_crop_feed_barley_notill () {
		return tonnes_crop_feed_barley_notill;
	}
	
	public void settonnes_crop_feed_barley_notill (double i){
		tonnes_crop_feed_barley_notill = i;
	}
	public double gettonnes_crop_feed_wheat_notill () {
		return tonnes_crop_feed_wheat_notill;
	}
	public void settonnes_crop_feed_wheat_notill (double i){
		tonnes_crop_feed_wheat_notill = i;
	}
	
	public double gettonnes_crop_feed_barley_con () {
		return tonnes_crop_feed_barley_con;
	}
	
	public void settonnes_crop_feed_barley_con (double i) {
		tonnes_crop_feed_barley_con = i;
	}
	public double gettonnes_crop_feed_wheat_con () {
		return tonnes_crop_feed_wheat_con;
	}
	public void settonnes_crop_feed_wheat_con (double i) {
		tonnes_crop_feed_wheat_con = i;
	}
	
	public double getrecourse_income () {
		return recourse_income;
	}
	
	public void setrecourse_income (double i) {
		recourse_income = i;
	}
	
	public double getpurchase_hay () {
		return purchase_hay;
	}
	
	public void setpurchase_hay (double i) {
		purchase_hay = i;
	}
	
	public double getpurchase_barley () {
		return purchase_barley;
	}
	
	public void setpurchase_barley (double i) {
		purchase_barley = i;
	}
	
	public double getearlyhay () {
		return earlyhay;
	}
	
	public void setearlyhay (double i) {
		earlyhay = i;
	}
	
	public double getlatehay () {
		return latehay;
	}
	
	public void setlatehay (double i) {
		latehay = i;
	}
	
	public double getfallhay () {
		return fallhay;
	}
	
	public void setfallhay (double i) {
		fallhay = i;
	}
	
	public double getwinterhay () {
		return winterhay;
	}
	
	public void setwinterhay (double i) {
		winterhay = i;
	}
	
	public double getbarleystraw () {
		return barleystraw;
	}
	
	public void setbarleystraw (double i) {
		barleystraw = i;
	}
	
	public double getwheatstraw () {
		return wheatstraw;
	}
	
	public void setwheatstraw (double i) {
		wheatstraw = i;
	}
	
	public double gethayforsale () {
		return hayforsale;
	}
	
	public void sethayforsale (double i) {
		hayforsale = i;
	}
	
	public double getbarleyforsale () {
		return barleyforsale;
	}
	
	public void setbarleyforsale (double i) {
		barleyforsale = i;
	}
	
	public double getwheatforsale () {
		return wheatforsale;
	}
	
	public void setwheatforsale (double i) {
		wheatforsale = i;
	}
	
	public double getwinterbarley () {
		return winterbarley;
	}
	
	public void setwinterbarley (double i) {
		winterbarley = i;
	}
	
	public double getwinterwheat () {
		return winterwheat;
	}
	
	public void setwinterwheat (double i) {
		winterwheat = i;
	}
	
	public void setDEBT (int i) {
		debt = i;
	}
	
	public int getDEBT () {
		return debt;
	}
	
	public void setASSETS (int i) {
		assets = i;
	}
	
	public double getASSETS () {
		return assets;
	}
	
	public int getaverage_years_in_grass () {
		return average_years_in_grass;
	}
	
	public void setaverage_years_in_grass (int i) {
		average_years_in_grass = i;
	}
	
	public int getaverage_years_in_trees () {
		return average_years_in_willows;
	}
	
	public void setaverage_years_in_trees (int i) {
		average_years_in_willows = i;
	}
	
	public double getcows_fc_handling_system () {
		return cows_fc_handling_system;
	}
	
	public void setcows_fc_handling_system (double i) {
		cows_fc_handling_system = i;
	}
	
	public double getcows_fc_machinery () {
		return cows_fc_machinery;
	}
	
	public void setcows_fc_machinery (double i) {
		cows_fc_machinery = i;
	}
	
	public boolean getwill_cows() {
		return will_cows;
	}
	
	public void setwill_cows (boolean i){
		will_cows = i;
	}
	
	public void settotal_mcals (double i) {
		total_mcals = i;
	}
	
	public double gettotal_mcals () {
		return total_mcals;
	}

	public double getflax_premium () {
		return flax_premium;
	}
	
	public double getwheat_premium () {
		return wheat_premium;
	}
	
	public void setwheat_premium (double i) {
		wheat_premium = i;
	}
	
	public double getdurum_premium () {
		return durum_premium;
	}
	
	public void setdurum_premium (double i) {
		durum_premium = i;
	}
	
	public double getdurum_premium_gov () {
		return durum_premium_gov;
	}
	
	public void setdurum_premium_gov (double i) {
		durum_premium_gov = i;
	}
	
	public double getproducer_premium_durum_stubble () {
		return producer_premium_durum_stubble;
	}
	
	public void setproducer_premium_durum_stubble (double i) {
		producer_premium_durum_stubble = i;
	}
	
	public double getgovernment_premium_durum_stubble () {
		return government_premium_durum_stubble;
	}
	
	public void setgovernment_premium_durum_stubble (double i) {
		government_premium_durum_stubble = i;
	}
	
	public double getproducer_premium_durum_notill () {
		return producer_premium_durum_notill;
	}
	
	public void setproducer_premium_durum_notill (double i) {
		producer_premium_durum_notill = i;
	}
	
	public double getgovernment_premium_durum_notill () {
		return government_premium_durum_notill;
	}
	
	public void setgovernment_premium_durum_notill (double i) {
		government_premium_durum_notill = i;
	}
	
	public double getbarley_premium () {
		return barley_premium;
	}
	
	public void setbarley_premium (double i) {
		barley_premium = i;
	}
	
	public double getcanola_premium () {
		return canola_premium;
	}
	
	
	public void setcanola_premium (double i) {
		canola_premium = i;
	}
	
	public void setflax_premium (double i) {
		flax_premium = i;
	}

	public double getflax_premium_gov () {
		return flax_premium_gov;
	}
	
	public void setflax_premium_gov (double i) {
		flax_premium_gov = i;
	}
	
	public double getwheat_premium_gov () {
		return wheat_premium_gov;
	}
	
	public void setwheat_premium_gov (double i) {
		wheat_premium_gov = i;
	}
	
	public double getbarley_premium_gov () {
		return barley_premium_gov;
	}
	
	public void setbarley_premium_gov (double i) {
		barley_premium_gov = i;
	}
	
	public double getcanola_premium_gov () {
		return canola_premium_gov;
	}
	
	public void setcanola_premium_gov (double i) {
		canola_premium_gov = i;
	}
	
	public double getproducer_premium_canola_stubble () {
		return producer_premium_canola_stubble;
	}
	
	public double getproducer_premium_flax_stubble () {
		return producer_premium_flax_stubble;
	}
	
	public void setproducer_premium_flax_stubble (double i) {
		producer_premium_flax_stubble = i;
	}
	
	public void setproducer_premium_canola_stubble (double i) {
		producer_premium_canola_stubble = i;
	}
	
	public double getproducer_premium_barley_stubble () {
		return producer_premium_barley_stubble;
	}
	
	public void setproducer_premium_barley_stubble (double i) {
		producer_premium_barley_stubble = i;
	}
	
	public double getproducer_premium_wheat_stubble () {
		return producer_premium_wheat_stubble;
	}
	
	public void setproducer_premium_wheat_stubble (double i) {
		producer_premium_wheat_stubble = i;
	}
	
	public double getgovernment_premium_flax_stubble () {
		return government_premium_flax_stubble;
	}
	
	public void setgovernment_premium_flax_stubble (double i) {
		government_premium_flax_stubble = i;
	}
	
	public double getgovernment_premium_canola_stubble () {
		return government_premium_canola_stubble;
	}
	
	public void setgovernment_premium_canola_stubble (double i) {
		government_premium_canola_stubble = i;
	}
	public double getgovernment_premium_barley_stubble () {
		return government_premium_barley_stubble;
	}
	
	public void setgovernment_premium_barley_stubble (double i) {
		government_premium_barley_stubble = i;
	}
	
	public double getgovernment_premium_wheat_stubble () {
		return government_premium_wheat_stubble;
	}
	
	public void setgovernment_premium_wheat_stubble (double i) {
		government_premium_wheat_stubble = i;
	}
	
	public double getgovernment_premium_wheat_fallow () {
		return government_premium_wheat_fallow;
	}
	
	public void setgovernment_premium_wheat_fallow (double i) {
		government_premium_wheat_fallow = i;
	}
	
	public double getproducer_premium_flax_notill () {
		return producer_premium_flax_notill;
	}
	
	public void setproducer_premium_flax_notill (double i) {
		producer_premium_flax_notill = i;
	}
	
	public double getproducer_premium_canola_notill () {
		return producer_premium_canola_notill;
	}
	
	public void setproducer_premium_canola_notill (double i) {
		producer_premium_canola_notill = i;
	}
	
	public double getproducer_premium_wheat_notill () {
		return producer_premium_wheat_notill;
	}
	
	public void setproducer_premium_wheat_notill (double i) {
		producer_premium_wheat_notill = i;
	}
	
	public double getproducer_premium_barley_notill () {
		return producer_premium_barley_notill;
	}
	
	public void setproducer_premium_barley_notill (double i) {
		producer_premium_barley_notill = i;
	}
	
	public double getgovernment_premium_canola_notill () {
		return government_premium_canola_notill;
	}
	
	public void setgovernment_premium_canola_notill (double i) {
		government_premium_canola_notill = i;
	}
	
	public double getgovernment_premium_wheat_notill () {
		return government_premium_wheat_notill;
	}
	
	public void setgovernment_premium_wheat_notill (double i) {
		government_premium_wheat_notill = i;
	}
	
	public double getgovernment_premium_barley_notill () {
		return government_premium_barley_notill;
	}
	
	public void setgovernment_premium_barley_notill (double i) {
		government_premium_barley_notill = i;
	}
	
	public double getgovernment_premium_flax_notill () {
		return government_premium_flax_notill;
	}
	
	public void setgovernment_premium_flax_notill (double i) {
		government_premium_flax_notill = i;
	}
	
	public double getpremiums_paid_producer () {
		return premiums_paid_producer;
	}
	
	public void setpremiums_paid_producer (double i) {
		premiums_paid_producer = i;
	}
	
	public double getpremiums_paid_government () {
		return premiums_paid_government;
	}
	
	public void setpremiums_paid_government (double i) {
		premiums_paid_government = i;
	}
	
	public double[] getearlymcalsrequired () {
		return earlymcalsrequired;
	}
	
	public void setearlymcalsrequired (double[] i) {
		earlymcalsrequired = i;
	}
	
	public double[] getlatemcalsrequired () {
		return latemcalsrequired;
	}
	
	public void setlatemcalsrequired (double[] i) {
		latemcalsrequired = i;
	}
	
	public double[] getfallmcalsrequired () {
		return fallmcalsrequired;
	}
	
	public void setfallmcalsrequired (double[] i) {
		fallmcalsrequired = i;
	}
	
	public double[] getwintermcalsrequired () {
		return wintermcalsrequired;
	}
	
	public void setwintermcalsrequired (double[] i) {
		wintermcalsrequired =i;
	}
	
	public double[] getsellcalves () {
		return sellcalves;
	}
	
	public void setsellcalves (double[] i) {
		sellcalves = i;
	}
	
	public double getsizing_cropland_value () {
		return sizing_cropland_value;
	}
	
	public void setsizing_cropland_value (double i) {
		sizing_cropland_value = i;
	}
	
	public double getsizing_pastureland_value () {
		return sizing_pastureland_value;
	}
	
	public void setsizing_pastureland_value (double i) {
		sizing_pastureland_value = i;
	}
	
	public int gethandling_system_age () {
		return handling_system_age;
	}
	
	public void sethandling_system_age (int i) {
		handling_system_age = i;
	}
	
	public int getcow_machine_age () {
		return cow_machine_age;
	}
	
	public void setcow_machine_age (int i) {
		cow_machine_age = i;
	}
	
	public int gethandling_system_value () {
		return handling_system_value;
	}
	
	public void sethandling_system_value (int i) {
		handling_system_value = i;
	}
	
	public int getcow_machine_value () {
		return cow_machine_value;
	}
	
	public void setcow_machine_value (int i) {
		cow_machine_value = i;
	}
	
	public int getlivestock_equipment_value () {
		return livestock_equipment_value;
	}
	
	public void setlivestock_equipment_value (int i) {
		livestock_equipment_value = i;
	}
	
	public double gettotal_insurance_payout() {
		return total_insurance_payout;
	}
	
	public void settotal_insurance_payout (double i) {
		total_insurance_payout = i;
	}
	
	public double getcows_handling_system_limit () {
		return cows_handling_system_limit;
	}
	
	public void setcows_handling_system_limit (double i) {
		cows_handling_system_limit = i;
	}
	
	public double getcows_machine_limit () {
		return cows_machine_limit;
	}
	
	public void setcows_machine_limit (double i) {
		cows_machine_limit = i;
	}
	
	public double[] getcows_handling_constraint () {
		return cows_handling_constraint;
	}
	
	public void setcows_handling_constraint (double[] i){
		cows_handling_constraint = i;
	}
	
	public double[] getcows_machine_constraint () {
		return cows_machine_constraint;
	}
	
	public void setcows_machine_constraint (double[] i){
		cows_machine_constraint = i;
	}
	
	public double getflaxstubble () {
		return flaxstubble;
	}
	
	public void setflaxstubble (double i) {
		flaxstubble = i;
	}
	
	public double getdurumstubble () {
		return durumstubble;
	}
	
	public void setdurumstubble (double i) {
		durumstubble = i;
	}
	
	public double getflaxnotill () {
		return flaxnotill;
	}
	
	public void setflaxnotill (double i) {
		flaxnotill = i;
	}
	
	public double getflax_stubble () {
		return flax_stubble;
	}
	
	public void setflax_stubble (double i) {
		flax_stubble = i;
	}
	
	public double getflax_notill () {
		return flax_notill;
	}
	
	public void setflax_notill (double i) {
		flax_notill = i;
	}
	
	public int getfarmer_type () {
		return farmer_type;
	}
	
	public void setfarmer_type (int i) {
		farmer_type = i;
	}
	
	public int getoff_farm_inc () {
		return off_farm_inc;
	}
	
	public void setoff_farm_inc (int i) {
		off_farm_inc = i;
	}
	
	public double getpeas_stubble () {
		return peas_stubble;
	}
	
	public void setpeas_stubble (double i) {
		peas_stubble = i;
	}
	
	public double getpeas_notill () {
		return peas_notill;
	}
	
	public void setpeas_notill (double i) {
		peas_notill = i;
	}
	
	public double getlentils_notill () {
		return lentils_notill;
	}
	
	public void setlentils_notill (double i) {
		lentils_notill = i;
	}
	
	public double getdurum_stubble () {
		return durum_stubble;
	}
	
	public void setdurum_stubble (double i) {
		durum_stubble = i;
	}
	
	public double getdurum_notill () {
		return durum_notill;
	}
	
	public void setdurum_notill (double i) {
		durum_notill = i;
	}
	
	public double getlentils_yield_index () {
		return lentils_yield_index;
	}
	
	public void setlentils_yield_index (double i) {
		lentils_yield_index = i;
	}
	
	public double getpeas_yield_index () {
		return peas_yield_index;
	}
	
	public void setpeas_yield_index (double i) {
		peas_yield_index = i;
	}
	
	public double getpeas_premium () {
		return peas_premium;
	}
	
	public void setpeas_premium (double i) {
		peas_premium = i;
	}
	
	public double getlentils_premium () {
		return lentils_premium;
	}
	
	public void setlentils_premium (double i) {
		lentils_premium = i;
	}
	
	public double getpeas_premium_gov () {
		return peas_premium_gov;
	}
	
	public void setpeas_pemium_gov (double i) {
		peas_premium_gov = i;
	}
	
	public double getlentils_premium_gov () {
		return lentils_premium_gov;
	}
	
	public void setlentils_pemium_gov (double i) {
		lentils_premium_gov = i;
	}
	
	public double getproducer_premium_peas_stubble () {
		return producer_premium_peas_stubble;
	}
	
	public void setproducer_premium_peas_stubble (double i) {
		producer_premium_peas_stubble = i;
	}
	
	public double getgovernment_premium_peas_stubble () {
		return government_premium_peas_stubble;
	}
	
	public void setgovernment_premium_peas_stubble (double i) {
		government_premium_peas_stubble = i;
	}
	
	public double getproducer_premium_peas_notill () {
		return producer_premium_peas_notill;
	}
	
	public void setproducer_premium_peas_notil (double i) {
		producer_premium_peas_notill = i;
	}
	
	public double getproducer_premium_lentils_notill () {
		return producer_premium_lentils_notill;
	}
	
	public void setproducer_premium_lentils_notill (double i) {
		producer_premium_lentils_notill = i;
	}
	
	public double getgovernment_premium_peas_notill () {
		return government_premium_peas_notill;
	}
	
	public void setgovernment_premium_peas_notill (double i) {
		government_premium_peas_notill = i;
	}
	
	public double getgovernment_premium_lentils_notill () {
		return government_premium_lentils_notill;
	}
	
	public void setgovernment_premium_lentils_notill (double i) {
		government_premium_lentils_notill = i;
	}
	
	public double getwillows_on_natural_pasture () {
		return willows_on_natural_pasture;
	}
	
	public void setwillows_on_natural_pasture (double i) {
		willows_on_natural_pasture = i;
	}
	
	public double getwillows_on_improved_pasture () {
		return willows_on_improved_pasture;
	}
	
	public void setwillows_on_improved_pasture (double i) {
		willows_on_improved_pasture = i;
	}
	
	public double getwillows_on_hayland_pasture () {
		return willows_on_hayland_pasture;
	}
	
	public void setwillows_on_hayland_pasture (double i) {
		willows_on_hayland_pasture = i;
	}
	
	public double getwillows_initial_investment () {
		return willows_initial_investment;
	}
	
	public void setwillows_initial_investment (double i) {
		willows_initial_investment = i;
	}
	
	public double getrent_out_cropland () {
		return rent_out_cropland;
	}
	
	public void setrent_out_cropland (double i) {
		rent_out_cropland = i;
	}
	
	public double getrent_out_natural_pasture () {
		return rent_out_natural_pasture;
	}
	
	public void setrent_out_natural_pasture (double i) {
		rent_out_natural_pasture = i;
	}
	
	public double getrent_out_improved_pasture () {
		return rent_out_improved_pasture;
	}
	
	public void setrent_out_improved_pasture (double i) {
		rent_out_improved_pasture = i;
	}
	
	public double getrent_out_hayland_pasture () {
		return rent_out_hayland_pasture;
	}
	
	public void setrent_out_hayland_pasture (double i) {
		rent_out_hayland_pasture = i;
	}
	
	public double getpeasstubble () {
		return peasstubble;
	}
	
	public void setpeasstubble (double i) {
		peasstubble = i;
	}
	
	public double getpeasnotill () {
		return peasnotill;
	}
	
	public void setpeasnotill (double i) {
		peasnotill = i;
	}
	
	public double getfeedwheatnotill() {
		return feedwheatnotill;
	}
	
	public void setfeedwheatnotill (double i) {
		feedwheatnotill = i;
	}
	
	public double getfeedbarleynotill() {
		return feedbarleynotill;
	}
	
	public void setfeedbarleynotill (double i) {
		feedbarleynotill = i;
	}
	
	public double getfeedwheatcon () {
		return feedwheatcon;
	}
	
	public void setfeedwheatcon (double i) {
		feedwheatcon = i;
	}
	
	public double getfeedbarleycon () {
		return feedbarleycon;
	}
	
	public void setfeedbarleycon (double i) {
		feedbarleycon = i;
	}
	
	public double getlentilsnotill () {
		return lentilsnotill;
	}
	
	public void setlentilsnotill (double i) {
		lentilsnotill = i;
	}
	
	public double getdurumnotill () {
		return durumnotill;
	}
	
	public void setdurumnotill (double i) {
		durumnotill = i;
	}
	
	public double[] getenergy_crops_variables () {
		return energy_crops_variables;
	}
	
	public void setenergy_crops_variables (double[] i) {
		energy_crops_variables = i;
	}
	
	public double getwillowsnaturalpasture () {
		return willowsnaturalpasture;
	}
	
	public void setwillowsnaturalpasture (double i) {
		willowsnaturalpasture = i;
	}
	
	public double getwillowsimprovedpasture () {
		return willowsimprovedpasture;
	}
	
	public void setwillowsimprovedpasture (double i) {
		willowsimprovedpasture = i;
	}
	
	public double getwillowshaylandpasture () {
		return willowshaylandpasture;
	}
	
	public void setwillowshaylandpasture (double i) {
		willowshaylandpasture = i;
	}
	
	public double getwillowsinitialinvestment () {
		return willowsinitialinvestment;
	}
	
	public void setwillowsinitialinvestment (double i) {
		willowsinitialinvestment = i;
	}
	
	public double getpoplar_on_natural_pasture () {
		return poplar_on_natural_pasture;
	}
	
	public void setpoplar_on_natural_pasture (double i) {
		poplar_on_natural_pasture = i;
	}
	
	public double getpoplar_on_improved_pasture () {
		return poplar_on_improved_pasture;
	}
	
	public void setpoplar_on_improved_pasture (double i) {
		poplar_on_improved_pasture = i;
	}
	
	public double getpoplar_on_hayland_pasture () {
		return poplar_on_hayland_pasture;
	}
	
	public void setpoplar_on_hayland_pasture (double i) {
		poplar_on_hayland_pasture = i;
	}
	
	public double getpoplar_initial_investment () {
		return poplar_initial_investment;
	}
	
	public void setpoplar_initial_investment (double i) {
		poplar_initial_investment = i;
	}
	
	public double getprairie_sandreed_on_natural_pasture () {
		return prairie_sandreed_on_natural_pasture;
	}
	
	public void setprairie_sandreed_on_natural_pasture (double i) {
		prairie_sandreed_on_natural_pasture = i;
	}
	
	public double getprairie_sandreed_on_improved_pasture () {
		return prairie_sandreed_on_improved_pasture;
	}
	
	public void setprairie_sandreed_on_improved_pasture (double i) {
		prairie_sandreed_on_improved_pasture = i;
	}
	
	public double getprairie_sandreed_on_hayland_pasture () {
		return prairie_sandreed_on_hayland_pasture;
	}
	
	public void setprairie_sandreed_on_hayland_pasture (double i) {
		prairie_sandreed_on_hayland_pasture = i;
	}
	
	public double getprairie_sandreed_initial_investment () {
		return prairie_sandreed_initial_investment;
	}
	
	public void setprairie_sandreed_initial_investment (double i) {
		prairie_sandreed_initial_investment = i;
	}
	
	public double getpoplarnaturalpasture () {
		return poplarnaturalpasture;
	}
	
	public void setpoplarnaturalpasture (double i) {
		poplarnaturalpasture = i;
	}
	
	public double getpoplarimprovedpasture () {
		return poplarimprovedpasture;
	}
	
	public void setpoplarimprovedpasture (double i) {
		poplarimprovedpasture = i;
	}
	
	public double getpoplarhaylandpasture () {
		return poplarhaylandpasture;
	}
	
	public void setpoplarhaylandpasture (double i) {
		poplarhaylandpasture = i;
	}
	
	public double getpoplarinitialinvestment () {
		return poplarinitialinvestment;
	}
	
	public void setpoplarinitialinvestment (double i) {
		poplarinitialinvestment = i;
	}
	
	public double getprairiesandreednaturalpasture () {
		return prairiesandreednaturalpasture;
	}
	
	public void setprairiesandreednaturalpasture (double i) {
		prairiesandreednaturalpasture = i;
	}
	
	public double getprairiesandreedimprovedpasture () {
		return prairiesandreedimprovedpasture;
	}
	
	public void setprairiesandreedimprovedpasture (double i) {
		prairiesandreedimprovedpasture = i;
	}
	
	public double getprairiesandreedhaylandpasture () {
		return prairiesandreedhaylandpasture;
	}
	
	public void setprairiesandreedhaylandpasture (double i) {
		prairiesandreedhaylandpasture = i;
	}
	
	public double getprairiesandreedinitialinvestment () {
		return prairiesandreedinitialinvestment;
	}
	
	public void setprairiesandreedinitialinvestment (double i) {
		prairiesandreedinitialinvestment = i;
	}
	
	public double[] getwillow_transfer () {
		return willow_transfer;
	}
	
	public void setwillow_transfer (double[] i) {
		willow_transfer = i;
	}
	
	public double[] getpoplar_transfer () {
		return poplar_transfer;
	}
	
	public void setpoplar_transfer (double[] i) {
		poplar_transfer = i;
	}
	
	public double[] getprairie_sandreed_transfer () {
		return prairie_sandreed_transfer;
	}
	
	public void setprairie_sandreed_transfer (double[] i) {
		prairie_sandreed_transfer = i;
	}
	
	public int gettotal_land_owned () {
		return total_land_owned;
	}
	
	public void settotal_land_owned (int i) {
		total_land_owned = i;
	}
	
	public int gettotal_land_leased () {
		return total_land_leased;
	}
	
	public void settotal_land_leased (int i) {
		total_land_leased = i;
	}
	
	public boolean getcan_bid_on_cropland () {
		return can_bid_on_cropland;
	}
	
	public void setcan_bid_on_cropland (boolean i) {
		can_bid_on_cropland = i;
	}
	
	public boolean getcan_bid_on_marginalland () {
		return can_bid_on_marginalland;
	}
	
	public void setcan_bid_on_marginalland (boolean i) {
		can_bid_on_marginalland = i;
	}
	
	public double gettotal_plots() {
		return total_plots;
	}
	
	public void settotal_plots (double i) {
		total_plots = i;
	}
	
	public double gettotal_marginal_plots () {
		return total_marginal_plots;
	}
	
	public void settotal_marginal_plots (double i) {
		total_marginal_plots = i;
	}
	
	public double gettotal_marginal_plots_owned () {
		return total_marginal_plots_owned;
	}
	
	public void settotal_marginal_plots_owned (double i) {
		total_marginal_plots_owned = i;
	}
	
	public double gettotal_marginal_plots_leased () {
		return total_marginal_plots_leased;
	}
	
	public void settotal_marginal_plots_leased (double i) {
		total_marginal_plots_leased = i;
	}
	
	public double gettotal_cropland_plots () {
		return total_cropland_plots;
	}
	
	public void settotal_cropland_plots (double i) {
		total_cropland_plots = i;
	}
	
	public double gettotal_cropland_plots_owned () {
		return total_cropland_plots_owned;
	}
	
	public void settotal_cropland_plots_owned (double i) {
		total_cropland_plots_owned = i;
	}
	
	public double gettotal_cropland_plots_leased () {
		return total_cropland_plots_leased;
	}
	
	public void settotal_cropland_plots_leased (double i) {
		total_cropland_plots_leased = i;
	}
	
	public int getafter_purchase_number_of_lands_cropland () {
		return after_purchase_number_of_lands_cropland;
	}
	
	public int getafter_purchase_number_of_lands_marginal () {
		return after_purchase_number_of_lands_marginal;
	}
	
	public double getRM_2007_Con () {
		return RM_2007_Con;
	}
	public double getRM_2006_Con () {
		return RM_2006_Con;
	}
	public double getRM_2005_Con () {
		return RM_2005_Con;
	}
	public double getRM_2004_Con () {
		return RM_2004_Con;
	}
	public double getRM_2003_Con () {
		return RM_2003_Con;
	}
	public double getRM_2007_NoTill () {
		return RM_2007_NoTill;
	}
	public double getRM_2006_NoTill() {
		return RM_2006_NoTill;
	}
	public double getRM_2005_NoTill () {
		return RM_2005_NoTill;
	}
	public double getRM_2004_NoTill () {
		return RM_2004_NoTill;
	}
	public double getRM_2003_NoTill () {
		return RM_2003_NoTill;
	}
	
	public int geteligible_sales_2007 () {
		return eligible_sales_2007;
	}
	
	public int geteligible_sales_2006 () {
		return eligible_sales_2006;
	}
	
	public double getRM_Calf_2007 () {
		return RM_Calf_2007;
	}
	
	public double getRM_Calf_2006 () {
		return RM_Calf_2006;
	}
	
	public double getRM_Calf_2005 () {
		return RM_Calf_2005;
	}
	
	public double getRM_Calf_2004 () {
		return RM_Calf_2004;
	}
	
	public double getRM_Calf_2003 () {
		return RM_Calf_2003;
	}
	
	public double getinitial_d_a_ratio () {
		return initial_d_a_ratio;
	}
	
	public void setinitial_d_a_ratio (double i) {
		initial_d_a_ratio = i;
	}
	
	public boolean getselloldequipment () {
		return selloldequipment;
	}
	
	public void setselloldequipment (boolean i) {
		selloldequipment = i;
	}
	
	public int getold_equipment_value () {
		return old_equipment_value;
	}
	
	public void setold_equipment_value (int i) {
		old_equipment_value = i;
	}
	
	public double getsummer_fallow_percent() {
		return summer_fallow_percent;
	}
	
	public void setsummer_fallow_percent (double i) {
		summer_fallow_percent = i;
	}
	
	public double getfarmer_exp_canola_price () {
		return farmer_exp_canola_price;
	}
	
	public void setfarmer_exp_canola_price (double i) {
		farmer_exp_canola_price = i;
	}
	
	public double getfarmer_exp_wheat_price () {
		return farmer_exp_wheat_price;
	}
	
	public void setfarmer_exp_wheat_price (double i) {
		farmer_exp_wheat_price = i;
	}
	
	public double getfarmer_exp_flax_price () {
		return farmer_exp_flax_price;
	}
	
	public void setfarmer_exp_flax_price (double i) {
		farmer_exp_flax_price = i;
	}
	
	public double getfarmer_exp_barley_price () {
		return farmer_exp_barley_price;
	}
	
	public void setfarmer_exp_barley_price (double i) {
		farmer_exp_barley_price = i;
	}
	
	public double getfarmer_exp_lentils_price () {
		return farmer_exp_lentils_price;
	}
	
	public void setfarmer_exp_lentils_price (double i) {
		farmer_exp_lentils_price = i;
	}
	
	public double getfarmer_exp_durum_price () {
		return farmer_exp_durum_price;
	}
	
	public void setfarmer_exp_durum_price (double i) {
		farmer_exp_durum_price = i;
	}
	
	public double getfarmer_exp_peas_price () {
		return farmer_exp_peas_price;
	}
	
	public void setfarmer_exp_peas_price (double i) {
		farmer_exp_peas_price = i;
	}
	
	public double getfarmer_exp_calf_price () {
		return farmer_exp_calf_price;
	}
	
	public void setfarmer_exp_calf_price (double i) {
		farmer_exp_calf_price = i;
	}
	
	public double getfarmer_exp_cull_price () {
		return farmer_exp_cull_price;
	}
	
	public void setfarmer_exp_cull_price (double i) {
		farmer_exp_cull_price = i;
	}
	
	public double getfarmer_exp_heifer_price () {
		return farmer_exp_heifer_price;
	}
	
	public void setfarmer_exp_heifer_price (double i) {
		farmer_exp_heifer_price = i;
	}
	
	public double getfarmer_exp_hay_price () {
		return farmer_exp_hay_price;
	}
	
	public void setfarmer_exp_hay_price (double i) {
		farmer_exp_hay_price = i;
	}
	
	public double gettrucking_distance() {
		return trucking_distance;
	}
	
	public void settrucking_distance (double i) {
		trucking_distance = i;
	}
	
	public double gettrucking_distance_energy_crops () {
		return trucking_distance_energy_crops;
	}
	
	public void settrucking_distane_energy_crops (double i) {
		trucking_distance_energy_crops = i;
	}
	
	public int getfarmers_x_distance () {
		return farmers_x_distance;
	}
	
	public void setfarmers_x_distance (int i) {
		farmers_x_distance = i;
	}
	
	public int getfarmers_y_distance () {
		return farmers_y_distance;
	}
	
	public void setfarmers_y_distance (int i) {
		farmers_y_distance = i;
	}
	
	public int getaverage_years_in_prairie_sandreed () {
		return average_years_in_prairie_sandreed;
	}
	
	public void setaverage_years_in_prairie_sandreed (int i) {
		average_years_in_prairie_sandreed = i;
	}
	
	public int getaverage_years_in_poplar () {
		return average_years_in_poplar;
	}
	
	public void setaverage_years_in_poplar (int i) {
		average_years_in_poplar = i;
	}
	
	public double getprairiesandreed_yield_np () {
		return prairiesandreed_yield_np;
	}
	
	public double getprairiesandreed_yield_ip () {
		return prairiesandreed_yield_ip;
	}
	
	public double getprairiesandreed_yield_hayland () {
		return prairiesandreed_yield_hayland;
	}
	
	public double getpoplar_yield_np_3 () {
		return poplar_yield_np_3;
	}
	
	public void setpoplar_yield_np_3 (double i) {
		poplar_yield_np_3 = i;
	}
	
	public double getpoplar_yield_np_6 () {
		return poplar_yield_np_6;
	}
	
	public void setpoplar_yield_np_6 (double i) {
		poplar_yield_np_6 = i;
	}
	
	public double getpoplar_yield_np_9 () {
		return poplar_yield_np_9;
	}
	
	public void setpoplar_yield_np_9 (double i) {
		poplar_yield_np_9 = i;
	}
	
	public double getpoplar_yield_np_12_21 () {
		return poplar_yield_np_12_21;
	}
	
	public void setpoplar_yield_np_12_21 (double i) {
		poplar_yield_np_12_21 = i;
	}
	
	public double getpoplar_yield_ip_3 () {
		return poplar_yield_ip_3;
	}
	
	public void setpoplar_yield_ip_3 (double i) {
		poplar_yield_ip_3 = i;
	}
	
	public double getpoplar_yield_ip_6 () {
		return poplar_yield_ip_6;
	}
	
	public void setpoplar_yield_ip_6 (double i) {
		poplar_yield_ip_6 = i;
	}
	
	public double getpoplar_yield_ip_9 () {
		return poplar_yield_ip_9;
	}
	
	public void setpoplar_yield_ip_9 (double i) {
		poplar_yield_ip_9 = i;
	}
	
	public double getpoplar_yield_ip_12_21 () {
		return poplar_yield_ip_12_21;
	}
	
	public void setpoplar_yield_ip_12_21 (double i) {
		poplar_yield_ip_12_21 = i;
	}
	
	public double getpoplar_yield_hayland_3 () {
		return poplar_yield_hayland_3;
	}
	
	public void setpoplar_yield_hayland_3 (double i) {
		poplar_yield_hayland_3 = i;
	}
	
	public double getpoplar_yield_hayland_6 () {
		return poplar_yield_hayland_6;
	}
	
	public void setpoplar_yield_hayland_6 (double i) {
		poplar_yield_hayland_6 = i;
	}
	
	public double getpoplar_yield_hayland_9 () {
		return poplar_yield_hayland_9;
	}
	
	public void setpoplar_yield_hayland_9 (double i) {
		poplar_yield_hayland_9 = i;
	}
	
	public double getpoplar_yield_hayland_12_21 () {
		return poplar_yield_hayland_12_21;
	}
	
	public void setpoplar_yield_hayland_12_21 (double i) {
		poplar_yield_hayland_12_21 = i;
	}
	//
	public double getwillow_yield_np_3 () {
		return willow_yield_np_3;
	}
	
	public void setwillow_yield_np_3 (double i) {
		willow_yield_np_3 = i;
	}
	
	public double getwillow_yield_np_6 () {
		return willow_yield_np_6;
	}
	
	public void setwillow_yield_np_6 (double i) {
		willow_yield_np_6 = i;
	}
	
	public double getwillow_yield_np_9 () {
		return willow_yield_np_9;
	}
	
	public void setwillow_yield_np_9 (double i) {
		willow_yield_np_9 = i;
	}
	
	public double getwillow_yield_np_12_21 () {
		return willow_yield_np_12_21;
	}
	
	public void setwillow_yield_np_12_21 (double i) {
		willow_yield_np_12_21 = i;
	}
	
	public double getwillow_yield_ip_3 () {
		return willow_yield_ip_3;
	}
	
	public void setwillow_yield_ip_3 (double i) {
		willow_yield_ip_3 = i;
	}
	
	public double getwillow_yield_ip_6 () {
		return willow_yield_ip_6;
	}
	
	public void setwillow_yield_ip_6 (double i) {
		willow_yield_ip_6 = i;
	}
	
	public double getwillow_yield_ip_9 () {
		return willow_yield_ip_9;
	}
	
	public void setwillow_yield_ip_9 (double i) {
		willow_yield_ip_9 = i;
	}
	
	public double getwillow_yield_ip_12_21 () {
		return willow_yield_ip_12_21;
	}
	
	public void setwillow_yield_ip_12_21 (double i) {
		willow_yield_ip_12_21 = i;
	}
	
	public double getwillow_yield_hayland_3 () {
		return willow_yield_hayland_3;
	}
	
	public void setwillow_yield_hayland_3 (double i) {
		willow_yield_hayland_3 = i;
	}
	
	public double getwillow_yield_hayland_6 () {
		return willow_yield_hayland_6;
	}
	
	public void setwillow_yield_hayland_6 (double i) {
		willow_yield_hayland_6 = i;
	}
	
	public double getwillow_yield_hayland_9 () {
		return willow_yield_hayland_9;
	}
	
	public void setwillow_yield_hayland_9 (double i) {
		willow_yield_hayland_9 = i;
	}
	
	public double getwillow_yield_hayland_12_21 () {
		return willow_yield_hayland_12_21;
	}
	
	public void setwillow_yield_hayland_12_21 (double i) {
		willow_yield_hayland_12_21 = i;
	}
	
	public double getwillows_annualized_return_np () {
		return willows_annualized_return_np;
	}
	
	public void setwillows_annualized_return_np (double i) {
		willows_annualized_return_np = i;
	}
	
	public double getwillows_annualized_cost_np () {
		return willows_annualized_cost_np;
	}
	
	public void setwillows_annualized_cost_np (double i) {
		willows_annualized_cost_np = i;
	}
	
	public double getwillows_annualized_return_ip () {
		return willows_annualized_return_ip;
	}
	
	public void setwillows_annualized_return_ip (double i) {
		willows_annualized_return_ip = i;
	}
	
	public double getwillows_annualized_cost_ip () {
		return willows_annualized_cost_ip;
	}
	
	public void setwillows_annualized_cost_ip (double i) {
		willows_annualized_cost_ip = i;
	}
	
	public double getwillows_annualized_return_hayland () {
		return willows_annualized_return_hayland;
	}
	
	public void setwillows_annualized_return_hayland (double i) {
		willows_annualized_return_hayland = i;
	}
	
	public double getwillows_annualized_cost_hayland () {
		return willows_annualized_cost_hayland;
	}
	
	public void setwillows_annualized_cost_hayland (double i) {
		willows_annualized_cost_hayland = i;
	}
	//
	public double getpoplar_annualized_return_np () {
		return poplar_annualized_return_np;
	}
	
	public void setpoplar_annualized_return_np (double i) {
		poplar_annualized_return_np = i;
	}
	
	public double getpoplar_annualized_cost_np () {
		return poplar_annualized_cost_np;
	}
	
	public void setpoplar_annualized_cost_np (double i) {
		poplar_annualized_cost_np = i;
	}
	
	public double getpoplar_annualized_return_ip () {
		return poplar_annualized_return_ip;
	}
	
	public void setpoplar_annualized_return_ip (double i) {
		poplar_annualized_return_ip = i;
	}
	
	public double getpoplar_annualized_cost_ip () {
		return poplar_annualized_cost_ip;
	}
	
	public void setpoplar_annualized_cost_ip (double i) {
		poplar_annualized_cost_ip = i;
	}
	
	public double getpoplar_annualized_return_hayland () {
		return poplar_annualized_return_hayland;
	}
	
	public void setpoplar_annualized_return_hayland (double i) {
		poplar_annualized_return_hayland = i;
	}
	
	public double getpoplar_annualized_cost_hayland () {
		return poplar_annualized_cost_hayland;
	}
	
	public void setpoplar_annualized_cost_hayland (double i) {
		poplar_annualized_cost_hayland = i;
	}
	
	
	
	public double gettotal_energycrop_eligible_netsales () {
		return  total_energycrop_eligible_netsales;
	}
	
	public void settotal_energycrop_eligible_netsales (double i) {
		total_energycrop_eligible_netsales = i;
	}
	
	public int getlast_year_crop_eligible_netsales () {
		return last_year_crop_eligible_netsales;
	}
	
	public void setlast_year_crop_eligible_netsales (int i) {
		last_year_crop_eligible_netsales = i;
	}
	
	public int getlast_year_calf_eligible_netsales () {
		return last_year_calf_eligible_netsales;
	}
	
	public void setlast_year_calf_eligible_netsales (int i) {
		last_year_calf_eligible_netsales = i;
	}
	
	public int getlast_year_enerycrop_eligible_netsales () {
		return last_year_energycrop_eligible_netsales;
	}
	
	public void setlast_year_energycrop_eligible_netsales (int i) {
		last_year_energycrop_eligible_netsales = i;
	}
	
	public int gettwo_yearsago_crop_eligible_netsales() {
		return two_yearsago_crop_eligible_netsales;
	}
	
	public int gettwo_yearsago_energycrop_eligible_netsales(){
		return two_yearsago_energycrop_eligible_netsales;
	}
	
	public int gettwo_yearsago_calf_eligible_netsales(){
		return two_yearsago_calf_eligible_netsales;
	}
	
	public int getthree_yearsago_crop_eligible_netsales(){
		return three_yearsago_crop_eligible_netsales;
	}
	
	public int getthree_yearsago_energycrop_eligible_netsales(){
		return three_yearsago_energycrop_eligible_netsales;
	}
	
	public int getthree_yearsago_calf_eligible_netsales(){
		return three_yearsago_calf_eligible_netsales;
	}
	
	public int getfour_yearsago_crop_eligible_netsales(){
		return four_yearsago_crop_eligible_netsales;
	}
	
	public int getfour_yearsago_energycrop_eligible_netsales(){
		return four_yearsago_energycrop_eligible_netsales;
	}
	
	public int getfour_yearsago_calf_eligible_netsales(){
		return four_yearsago_calf_eligible_netsales;
	}
	
	public int getfive_yearsago_crop_eligible_netsales(){
		return five_yearsago_crop_eligible_netsales;
	}
	
	public int getfive_yearsago_energycrop_eligible_netsales(){
		return five_yearsago_energycrop_eligible_netsales;
	}
	
	public int getfive_yearsago_calf_eligible_netsales(){
		return five_yearsago_calf_eligible_netsales;
	}
	
	public int gettotal_crop_acres_last_yr (){
		return total_crop_acres_last_yr;
	}
	
	public int gettotal_crop_acres_two_yrs () {
		return total_crop_acres_two_yrs;
	}
	
	public int gettotal_crop_acres_three_yrs () {
		return total_crop_acres_three_yrs;
	}
	
	public int gettotal_crop_acres_four_yrs () {
		return total_crop_acres_four_yrs;
	}
	
	public int gettotal_crop_acres_five_yrs () {
		return total_crop_acres_five_yrs;
	}
	
	public double getn_cows_last_yr() {
		return n_cows_last_yr;
	}
	
	public double getn_cows_two_yrs() {
		return n_cows_two_yrs;
	}
	
	public double getn_cows_three_yrs() {
		return n_cows_three_yrs;
	}
	
	public double getn_cows_four_yrs() {
		return n_cows_four_yrs;
	}
	
	public double getn_cows_five_yrs() {
		return n_cows_five_yrs;
	}
	
	public double getagristability_payment () {
		return agristability_payment;
	}
	
	public double getreference_margin_cost () {
		return reference_margin_cost;
	}
	
	public boolean getparticipate_agristability () {
		return participate_agristability;
	}
	
	public void setparticipate_agristability (boolean i){
		participate_agristability = i;
	}
	
	public double getavg_producer_premium_con () {
		return avg_producer_premium_con;
	}
	
	public double getavg_producer_premium_notill () {
		return avg_producer_premium_notill;
	}
	
	public void setnew_cows (double i) {
		new_cows = i;
	}
	
	public double getnew_cows () {
		return new_cows;
	}
	
	public double getsell_cull_cows () {
		return sell_cull_cows;
	}
	
	public void setsell_cull_cows (double i) {
		sell_cull_cows = i;
	}
	
	public double getinvest_cows () {
		return invest_cows;
	}
	
	public void setinvest_cows (double i) {
		invest_cows = i;
	}
	
	public int gethandling_transfer () {
		return handling_transfer;
	}
	
	public void sethandling_transfer (int i){
		handling_transfer = i;
	}
	
	public double getsell_old_cows () {
		return sell_old_cows;
	}
	
	public void setsell_old_cows (double i) {
		sell_old_cows = i;
	}
	
	public int getcropland_value_int () {
		return cropland_value_int;
	}
	
	public void setcropland_value_int (int i) {
		cropland_value_int = i;
	}
	
	public int getmarginalland_value_int () {
		return marginalland_value_int;
	}
	
	public void setmarginalland_value_int (int i) {
		marginalland_value_int = i;
	}
	
	public double getlong_run_hay_storage_in () {
		return long_run_hay_storage_in;
	}
	
	public void setlong_run_hay_storage_in (double i){
		long_run_hay_storage_in = i;
	}
	
	public double getlong_run_hay_storage_out () {
		return long_run_hay_storage_out;
	}
	
	public void setlong_run_hay_storage_out (double i){
		long_run_hay_storage_out = i;
	}
	
	public double getcrccow () {
		return crccow;
	}
	
	public void setcrccow (double i) {
		crccow = i;
	}
	
	public double getNewCostCow () {
		return NewCostCow;
	}
	
	public void setNewCostCow (double i){
		NewCostCow = i;
	}
	
	public double getdebt_payment () {
		return debt_payment;
	}
	
	public double gettotal_marginal_lease_payment () {
		return total_marginal_lease_payment;
	}
	
	public void settotal_marginal_lease_payment (double i){
		total_marginal_lease_payment = i;
	}
	
	public double gettotal_crop_lease_payment () {
		return total_crop_lease_payment;
	}
	
	public void settotal_crop_lease_payment (double i){
		total_crop_lease_payment = i;
	}
	
	public int getplots_in_prairie_sandreed () {
		return plots_in_prairie_sandreed;
	}
	
	public void setplots_in_prairie_sandreed (int i) {
		plots_in_prairie_sandreed = i;
	}
	
	public int getplots_in_poplar () {
		return plots_in_poplar;
	}
	
	public void setplots_in_poplar (int i) {
		plots_in_poplar = i;
	}
	
	public int getplots_in_grass () {
		return plots_in_grass;
	}
	
	public void setplots_in_grass (int i) {
		plots_in_grass = i;
	}
	
	public int getplots_in_willows () {
		return plots_in_willows;
	}
	
	public void setplots_in_willows (int i) {
		plots_in_willows = i;
	}
	
	public void setfeed_barley_notill (double i) {
		feed_barley_notill = i;
	}
	
	public double getfeed_barley_notill () {
		return feed_barley_notill;
	}
	
	public void setfeed_wheat_notill (double i) {
		feed_wheat_notill = i;
	}
	
	public double getfeed_wheat_notill () {
		return feed_wheat_notill;
	}
	
	public void setfeed_barley_con (double i) {
		feed_barley_con = i;
	}
	
	public double getfeed_barley_con () {
		return feed_barley_con;
	}
	
	public void setfeed_wheat_con (double i) {
		feed_wheat_con = i;
	}
	
	public double getfeed_wheat_con () {
		return feed_wheat_con;
	}
	
	public double getcrop_custom_hire () {
		return crop_custom_hire;
	}
	
	public void setcrop_custom_hire (double i) {
		crop_custom_hire = i;
	}
	
	public double[] getmaxwheatlimit_constraint () {
		return maxwheatlimit_constraint;
	}
	
	public void setmaxwheatlimit_constraint (double[] i) {
		maxwheatlimit_constraint = i;
	}
	
	public double[] getmaxbarleylimit_constraint () {
		return maxbarleylimit_constraint;
	}
	
	public void setmaxbarleylimit_constraint (double[] i) {
		maxbarleylimit_constraint = i;
	}
	
	public double[] getmaxdurumlimit_constraint () {
		return maxdurumlimit_constraint;
	}
	
	public void setmaxdurumlimit_constraint (double[] i) {
		maxdurumlimit_constraint = i;
	}
	
	public double[] getcows_acres_required () {
		return cows_acres_required;
	}
	
	public void setcows_acres_required (double[] i) {
		cows_acres_required = i;
	}
	
	public double getnp_cow_acre () {
		return np_cow_acre;
	}
	
	public double getip_cow_acre () {
		return ip_cow_acre;
	}
	private double gethayland_cow_acre () {
		return hayland_cow_acre;
	}
	
	public void setnp_cow_acre (double i) {
		np_cow_acre = i;
	}
	
	public void setip_cow_acre (double i) {
		ip_cow_acre = i;
	}
	
	public void sethayland_cow_acre (double i) {
		hayland_cow_acre = i;
	}
	
	public double gettotal_cow_acre () {
		return total_cow_acre;
	}
	
	public void settotal_cow_acre (double i) {
		total_cow_acre = i;
	}
	
	public double[] getmax_feeding_mcals () {
		return max_feeding_mcals;
	}
	
	public void setmax_feeding_mcals (double[] i){
		max_feeding_mcals = i;
	}

	
	public double getfamily_living () {
		return family_living;
	}
	
	public void setfamily_living (double i){
		family_living = i;
	}
	{
		
	}
	
	public void postProcess() {		
	//	System.out.println("farmer" + getfarmer_name() +"year" + Variables.getyear());
		
		set_breaking();
		tactical_crops_conventional_farmer();
		tactical_crops_notill();		
		set_crop_mix();
		set_energy_crops();
		set_machinery_mix();
		buy_machine();
		simulate_depreciation();	
		set_livestock();
		set_livestock_equipment_expansion();
		cow_equip_depreciation();
		set_expected_income();		
		energy_crop_production();
		actual_crop_production();		
		production();
		//crop_insurance();
		government_payments();		
		fixed_costs();		
		update_age();
		farm_accounting();
		exit_industry();
		update_farmers_land_info();		
		
	}

	public void initial_screen_farmers(){
		
		Parameters p = RunEnvironment.getInstance().getParameters();
		int pre_retirement_age = (Integer)p.getValue("pre_retirement_age");		
		double max_before_d_a_ratio = (Double)p.getValue("max_before_d_a_ratio");
		int min_cash_crop_acre = (Integer)p.getValue("minCashCropAcre");
		double cash_reserve_percent = (Double) p.getValue("cashReservePercent");			
		
		if(debt/assets > max_before_d_a_ratio){
    		setcan_bid(false);	
    	}
		else {
			setcan_bid(true);
		}
		if(can_bid == true) {
    	int min_cash = (int) (total_acres_farmed * cash_reserve_percent);
    	
    	if(cash < min_cash){
    		setcan_bid(false);
    	}
    	else {
    		setcan_bid(true);
    	}
		}
		if(can_bid == true) {
    	if(age < pre_retirement_age){
			setcan_bid(true);
		}
		else{
			setcan_bid(false);
		}
	  }
	}
	
	public void tree_margin () {
		Parameters p = RunEnvironment.getInstance().getParameters();
		double interest_rate = (Double) p.getValue("interestRate");
		double willow_price = (Double)p.getValue("willowprice");
		double Per_Tonne_Willow_Custom_Rate = (Double) p.getValue("perTonneWillowCustomRate");	
		double Per_Tonne_Poplar_Custom_Rate = (Double) p.getValue("perTonneWillowCustomRate");
		double Per_Tonne_VC_Willows = (Double) p.getValue("perTonneVCWillow");
		double Per_Tonne_VC_Poplar =(Double) p.getValue("perTonneVCWillow");
		double per_acre_breaking_cost = (Double) p.getValue("peracrebreaking");
		double propertytaxespasture = 3;
		double poplar_price = (Double)p.getValue("poplarprice");
		double willow_gj_tonne = (Double)p.getValue("willowgjtonne");
		double poplar_gj_tonne = (Double)p.getValue("poplargjtonne");
		double psr_gj_tonne = (Double)p.getValue("psrgjtonne");
		double gjprice = (Double)p.getValue("gjprice");
		
		double willow_margin_np = ((willow_yield_np_3 * willow_gj_tonne * gjprice) + (willow_yield_np_6 * willow_gj_tonne * gjprice) + (willow_yield_np_9 * willow_gj_tonne * gjprice) + (willow_yield_np_12_21 * willow_gj_tonne * gjprice) + (willow_yield_np_12_21 * willow_gj_tonne * gjprice) + (willow_yield_np_12_21 * willow_gj_tonne * gjprice) + (willow_yield_np_12_21 * willow_gj_tonne * gjprice)) 
		- ((21*propertytaxespasture)+(willow_yield_np_3 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_np_6 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_np_9 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_np_12_21 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_np_12_21 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_np_12_21 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_np_12_21 * Per_Tonne_Willow_Custom_Rate)+
				(willow_yield_np_3 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + (willow_yield_np_6 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + (willow_yield_np_9 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + (willow_yield_np_12_21 * Per_Tonne_VC_Willows * trucking_distance_energy_crops)
				+ (willow_yield_np_12_21 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + (willow_yield_np_12_21 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + (willow_yield_np_12_21 * Per_Tonne_VC_Willows * trucking_distance_energy_crops)+ per_acre_breaking_cost);
		
		willows_annualized_return_np = (interest_rate * willow_margin_np/1)/(1.0 - Math.pow(((interest_rate/1) + 1.0), (-(1*21))));
				
		double willows_operating_costs_np = ((21*propertytaxespasture)+(willow_yield_np_3 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_np_6 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_np_9 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_np_12_21 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_np_12_21 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_np_12_21 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_np_12_21 * Per_Tonne_Willow_Custom_Rate)+
				(willow_yield_np_3 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + (willow_yield_np_6 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + (willow_yield_np_9 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + (willow_yield_np_12_21 * Per_Tonne_VC_Willows * trucking_distance_energy_crops)
				+ (willow_yield_np_12_21 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + (willow_yield_np_12_21 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + (willow_yield_np_12_21 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + per_acre_breaking_cost);
		
		willows_annualized_cost_np = (interest_rate * willows_operating_costs_np/1)/(1.0 - Math.pow(((interest_rate/1) + 1.0), (-(1*21))));
				
		double willow_margin_ip = ((willow_yield_ip_3 * willow_gj_tonne * gjprice) + (willow_yield_ip_6 * willow_gj_tonne * gjprice) + (willow_yield_ip_9 * willow_gj_tonne * gjprice) + (willow_yield_ip_12_21 * willow_gj_tonne * gjprice) + (willow_yield_ip_12_21 * willow_gj_tonne * gjprice) + (willow_yield_ip_12_21 * willow_gj_tonne * gjprice) + (willow_yield_ip_12_21 * willow_gj_tonne * gjprice)) 
		- ((21*propertytaxespasture)+(willow_yield_ip_3 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_ip_6 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_ip_9 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_ip_12_21 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_ip_12_21 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_ip_12_21 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_ip_12_21 * Per_Tonne_Willow_Custom_Rate)+
				(willow_yield_ip_3 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + (willow_yield_ip_6 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + (willow_yield_ip_9 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + (willow_yield_ip_12_21 * Per_Tonne_VC_Willows * trucking_distance_energy_crops)
				+ (willow_yield_ip_12_21 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + (willow_yield_ip_12_21 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + (willow_yield_ip_12_21 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + per_acre_breaking_cost);
		
		willows_annualized_return_ip = (interest_rate * willow_margin_ip/1)/(1.0 - Math.pow(((interest_rate/1) + 1.0), (-(1*21))));
				
		double willows_operating_costs_ip = ((21*propertytaxespasture)+(willow_yield_ip_3 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_ip_6 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_ip_9 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_ip_12_21 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_ip_12_21 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_ip_12_21 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_ip_12_21 * Per_Tonne_Willow_Custom_Rate)+
				(willow_yield_ip_3 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + (willow_yield_ip_6 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + (willow_yield_ip_9 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + (willow_yield_ip_12_21 * Per_Tonne_VC_Willows * trucking_distance_energy_crops)
				+ (willow_yield_ip_12_21 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + (willow_yield_ip_12_21 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + (willow_yield_ip_12_21 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + per_acre_breaking_cost);
		
		willows_annualized_cost_ip = (interest_rate * willows_operating_costs_ip/1)/(1.0 - Math.pow(((interest_rate/1) + 1.0), (-(1*21))));
		
		double willow_margin_hayland = ((willow_yield_hayland_3 * willow_gj_tonne * gjprice) + (willow_yield_hayland_6 * willow_gj_tonne * gjprice) + (willow_yield_hayland_9 * willow_gj_tonne * gjprice) + (willow_yield_hayland_12_21 * willow_gj_tonne * gjprice) + (willow_yield_hayland_12_21 * willow_gj_tonne * gjprice) + (willow_yield_hayland_12_21 * willow_gj_tonne * gjprice) + (willow_yield_hayland_12_21 * willow_gj_tonne * gjprice)) 
		- ((21*propertytaxespasture)+(willow_yield_hayland_3 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_hayland_6 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_hayland_9 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_hayland_12_21 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_hayland_12_21 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_hayland_12_21 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_hayland_12_21 * Per_Tonne_Willow_Custom_Rate)+
				(willow_yield_hayland_3 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + (willow_yield_hayland_6 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + (willow_yield_hayland_9 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + (willow_yield_hayland_12_21 * Per_Tonne_VC_Willows * trucking_distance_energy_crops)
				+ (willow_yield_hayland_12_21 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + (willow_yield_hayland_12_21 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + (willow_yield_hayland_12_21 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + per_acre_breaking_cost);
		
		willows_annualized_return_hayland = (interest_rate * willow_margin_hayland/1)/(1.0 - Math.pow(((interest_rate/1) + 1.0), (-(1*21))));
		
		double willows_operating_costs_hayland = ((21*propertytaxespasture)+(willow_yield_hayland_3 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_hayland_6 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_hayland_9 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_hayland_12_21 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_hayland_12_21 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_hayland_12_21 * Per_Tonne_Willow_Custom_Rate) + (willow_yield_hayland_12_21 * Per_Tonne_Willow_Custom_Rate)+
				(willow_yield_hayland_3 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + (willow_yield_hayland_6 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + (willow_yield_hayland_9 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + (willow_yield_hayland_12_21 * Per_Tonne_VC_Willows * trucking_distance_energy_crops)
				+ (willow_yield_hayland_12_21 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + (willow_yield_hayland_12_21 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + (willow_yield_hayland_12_21 * Per_Tonne_VC_Willows * trucking_distance_energy_crops) + per_acre_breaking_cost);
		
		willows_annualized_cost_hayland = (interest_rate * willows_operating_costs_hayland/1)/(1.0 - Math.pow(((interest_rate/1) + 1.0), (-(1*21))));
		
		double poplar_margin_np = ((poplar_yield_np_3 * poplar_gj_tonne * gjprice) + (poplar_yield_np_6 * poplar_gj_tonne * gjprice) + (poplar_yield_np_9 * poplar_gj_tonne * gjprice) + (poplar_yield_np_12_21 * poplar_gj_tonne * gjprice) + (poplar_yield_np_12_21 * poplar_gj_tonne * gjprice) + (poplar_yield_np_12_21 * poplar_gj_tonne * gjprice) + (poplar_yield_np_12_21 * poplar_gj_tonne * gjprice)) 
		- ((21*propertytaxespasture)+(poplar_yield_np_3 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_np_6 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_np_9 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_np_12_21 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_np_12_21 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_np_12_21 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_np_12_21 * Per_Tonne_Poplar_Custom_Rate)+
				(poplar_yield_np_3 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + (poplar_yield_np_6 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + (poplar_yield_np_9 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + (poplar_yield_np_12_21 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops)
				+ (poplar_yield_np_12_21 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + (poplar_yield_np_12_21 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + (poplar_yield_np_12_21 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + per_acre_breaking_cost);
		
		poplar_annualized_return_np = (interest_rate * poplar_margin_np/1)/(1.0 - Math.pow(((interest_rate/1) + 1.0), (-(1*21))));
			
		double poplar_operating_costs_np = ((21*propertytaxespasture)+(poplar_yield_np_3 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_np_6 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_np_9 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_np_12_21 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_np_12_21 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_np_12_21 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_np_12_21 * Per_Tonne_Poplar_Custom_Rate)+
				(poplar_yield_np_3 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + (poplar_yield_np_6 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + (poplar_yield_np_9 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + (poplar_yield_np_12_21 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops)
				+ (poplar_yield_np_12_21 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + (poplar_yield_np_12_21 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + (poplar_yield_np_12_21 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + per_acre_breaking_cost);
		
		poplar_annualized_cost_np = (interest_rate * poplar_operating_costs_np/1)/(1.0 - Math.pow(((interest_rate/1) + 1.0), (-(1*21))));
				
		double poplar_margin_ip = ((poplar_yield_ip_3 * poplar_gj_tonne * gjprice) + (poplar_yield_ip_6 * poplar_gj_tonne * gjprice) + (poplar_yield_ip_9 * poplar_gj_tonne * gjprice) + (poplar_yield_ip_12_21 * poplar_gj_tonne * gjprice) + (poplar_yield_ip_12_21 * poplar_gj_tonne * gjprice) + (poplar_yield_ip_12_21 * poplar_gj_tonne * gjprice) + (poplar_yield_ip_12_21 * poplar_gj_tonne * gjprice)) 
		- ((21*propertytaxespasture)+(poplar_yield_ip_3 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_ip_6 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_ip_9 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_ip_12_21 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_ip_12_21 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_ip_12_21 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_ip_12_21 * Per_Tonne_Poplar_Custom_Rate)+
				(poplar_yield_ip_3 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + (poplar_yield_ip_6 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + (poplar_yield_ip_9 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + (poplar_yield_ip_12_21 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops)
				+ (poplar_yield_ip_12_21 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + (poplar_yield_ip_12_21 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + (poplar_yield_ip_12_21 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + per_acre_breaking_cost);
		
		poplar_annualized_return_ip = (interest_rate * poplar_margin_ip/1)/(1.0 - Math.pow(((interest_rate/1) + 1.0), (-(1*21))));
		
		double poplar_operating_costs_ip = ((21*propertytaxespasture)+(poplar_yield_ip_3 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_ip_6 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_ip_9 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_ip_12_21 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_ip_12_21 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_ip_12_21 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_ip_12_21 * Per_Tonne_Poplar_Custom_Rate)+
				(poplar_yield_ip_3 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + (poplar_yield_ip_6 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + (poplar_yield_ip_9 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + (poplar_yield_ip_12_21 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops)
				+ (poplar_yield_ip_12_21 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + (poplar_yield_ip_12_21 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + (poplar_yield_ip_12_21 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + per_acre_breaking_cost);
		
		poplar_annualized_cost_ip = (interest_rate * poplar_operating_costs_ip/1)/(1.0 - Math.pow(((interest_rate/1) + 1.0), (-(1*21))));
				
		double poplar_margin_hayland = ((poplar_yield_hayland_3 * poplar_gj_tonne * gjprice) + (poplar_yield_hayland_6 * poplar_gj_tonne * gjprice) + (poplar_yield_hayland_9 * poplar_gj_tonne * gjprice) + (poplar_yield_hayland_12_21 * poplar_gj_tonne * gjprice) + (poplar_yield_hayland_12_21 * poplar_gj_tonne * gjprice) + (poplar_yield_hayland_12_21 * poplar_gj_tonne * gjprice) + (poplar_yield_hayland_12_21 * poplar_gj_tonne * gjprice)) 
		- ((21*propertytaxespasture)+(poplar_yield_hayland_3 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_hayland_6 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_hayland_9 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_hayland_12_21 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_hayland_12_21 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_hayland_12_21 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_hayland_12_21 * Per_Tonne_Poplar_Custom_Rate)+
				(poplar_yield_hayland_3 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + (poplar_yield_hayland_6 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + (poplar_yield_hayland_9 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + (poplar_yield_hayland_12_21 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops)
				+ (poplar_yield_hayland_12_21 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + (poplar_yield_hayland_12_21 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + (poplar_yield_hayland_12_21 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + per_acre_breaking_cost);
		
		poplar_annualized_return_hayland = (interest_rate * poplar_margin_hayland/1)/(1.0 - Math.pow(((interest_rate/1) + 1.0), (-(1*21))));
		
		double poplar_operating_costs_hayland = ((21*propertytaxespasture)+(poplar_yield_hayland_3 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_hayland_6 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_hayland_9 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_hayland_12_21 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_hayland_12_21 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_hayland_12_21 * Per_Tonne_Poplar_Custom_Rate) + (poplar_yield_hayland_12_21 * Per_Tonne_Poplar_Custom_Rate)+
				(poplar_yield_hayland_3 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + (poplar_yield_hayland_6 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + (poplar_yield_hayland_9 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + (poplar_yield_hayland_12_21 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops)
				+ (poplar_yield_hayland_12_21 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + (poplar_yield_hayland_12_21 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + (poplar_yield_hayland_12_21 * Per_Tonne_VC_Poplar * trucking_distance_energy_crops) + per_acre_breaking_cost);
		
		poplar_annualized_cost_hayland = (interest_rate * poplar_operating_costs_hayland/1)/(1.0 - Math.pow(((interest_rate/1) + 1.0), (-(1*21))));
	}

	
	
	
	
	public void tree_yields () {
		
		Parameters p = RunEnvironment.getInstance().getParameters();		
		double min_poplar_yield_year_3 = (Double)p.getValue("min_pop_yield_yr_3");
		double max_poplar_yield_year_3 = (Double)p.getValue("max_pop_yield_yr_3");
		double min_poplar_yield_year_6 = (Double)p.getValue("min_pop_yield_yr_6");
		double max_poplar_yield_year_6 = (Double)p.getValue("max_pop_yield_yr_6");
		double min_poplar_yield_year_9 = (Double)p.getValue("min_pop_yield_yr_9");
		double max_poplar_yield_year_9 = (Double)p.getValue("max_pop_yield_yr_9");
		double min_poplar_yield_year_12_21 = (Double)p.getValue("min_pop_yield_yr_12_21");
		double max_poplar_yield_year_12_21 = (Double)p.getValue("max_pop_yield_yr_12_21");
		double min_willow_yield_year_3 = (Double)p.getValue("min_will_yield_yr_3");
		double max_willow_yield_year_3 = (Double)p.getValue("max_will_yield_yr_3");
		double min_willow_yield_year_6 = (Double)p.getValue("min_will_yield_yr_6");
		double max_willow_yield_year_6 = (Double)p.getValue("max_will_yield_yr_6");
		double min_willow_yield_year_9 = (Double)p.getValue("min_will_yield_yr_9");
		double max_willow_yield_year_9 = (Double)p.getValue("max_will_yield_yr_9");
		double min_willow_yield_year_12_21 = (Double)p.getValue("min_will_yield_yr_12_21");
		double max_willow_yield_year_12_21 = (Double)p.getValue("max_will_yield_yr_12_21");			
		double pr_max_tree_yield = (Double)p.getValue("pr_max_psr_yield");
		double pr_rating = 0;
		
		for(int i = 0; i < getmylandList().size(); i++) {
			SAMA sama = (SAMA) getmylandList().get(i);
		
		if(sama.getnpQuality() > pr_max_tree_yield) {
			pr_rating = pr_max_tree_yield;
			poplar_yield_np_3 =(pr_rating/pr_max_tree_yield * (max_poplar_yield_year_3 - min_poplar_yield_year_3) + min_poplar_yield_year_3);
			poplar_yield_np_6 = (pr_rating/pr_max_tree_yield * (max_poplar_yield_year_6 - min_poplar_yield_year_6) + min_poplar_yield_year_6);
			poplar_yield_np_9 = (pr_rating/pr_max_tree_yield * (max_poplar_yield_year_9 - min_poplar_yield_year_9) + min_poplar_yield_year_9);
			poplar_yield_np_12_21 = (pr_rating/pr_max_tree_yield * (max_poplar_yield_year_12_21 - min_poplar_yield_year_12_21) + min_poplar_yield_year_12_21);
			willow_yield_np_3 =(pr_rating/pr_max_tree_yield * (max_willow_yield_year_3 - min_willow_yield_year_3) + min_willow_yield_year_3);
			willow_yield_np_6 = (pr_rating/pr_max_tree_yield * (max_willow_yield_year_6 - min_willow_yield_year_6) + min_willow_yield_year_6);
			willow_yield_np_9 = (pr_rating/pr_max_tree_yield * (max_willow_yield_year_9 - min_willow_yield_year_9) + min_willow_yield_year_9);
			willow_yield_np_12_21 = (pr_rating/pr_max_tree_yield * (max_willow_yield_year_12_21 - min_willow_yield_year_12_21) + min_willow_yield_year_12_21);
		}
		else {
			pr_rating = sama.getnpQuality();
			poplar_yield_np_3 =(pr_rating/pr_max_tree_yield * (max_poplar_yield_year_3 - min_poplar_yield_year_3) + min_poplar_yield_year_3);
			poplar_yield_np_6 = (pr_rating/pr_max_tree_yield * (max_poplar_yield_year_6 - min_poplar_yield_year_6) + min_poplar_yield_year_6);
			poplar_yield_np_9 = (pr_rating/pr_max_tree_yield * (max_poplar_yield_year_9 - min_poplar_yield_year_9) + min_poplar_yield_year_9);
			poplar_yield_np_12_21 = (pr_rating/pr_max_tree_yield * (max_poplar_yield_year_12_21 - min_poplar_yield_year_12_21) + min_poplar_yield_year_12_21);
			willow_yield_np_3 =(pr_rating/pr_max_tree_yield * (max_willow_yield_year_3 - min_willow_yield_year_3) + min_willow_yield_year_3);
			willow_yield_np_6 = (pr_rating/pr_max_tree_yield * (max_willow_yield_year_6 - min_willow_yield_year_6) + min_willow_yield_year_6);
			willow_yield_np_9 = (pr_rating/pr_max_tree_yield * (max_willow_yield_year_9 - min_willow_yield_year_9) + min_willow_yield_year_9);
			willow_yield_np_12_21 = (pr_rating/pr_max_tree_yield * (max_willow_yield_year_12_21 - min_willow_yield_year_12_21) + min_willow_yield_year_12_21);
		}
		if(sama.getIPQuality() > pr_max_tree_yield) {
			pr_rating = pr_max_tree_yield;
			poplar_yield_ip_3 =(pr_rating/pr_max_tree_yield * (max_poplar_yield_year_3 - min_poplar_yield_year_3) + min_poplar_yield_year_3);
			poplar_yield_ip_6 = (pr_rating/pr_max_tree_yield * (max_poplar_yield_year_6 - min_poplar_yield_year_6) + min_poplar_yield_year_6);
			poplar_yield_ip_9 = (pr_rating/pr_max_tree_yield * (max_poplar_yield_year_9 - min_poplar_yield_year_9) + min_poplar_yield_year_9);
			poplar_yield_ip_12_21 = (pr_rating/pr_max_tree_yield * (max_poplar_yield_year_12_21 - min_poplar_yield_year_12_21) + min_poplar_yield_year_12_21);
			willow_yield_ip_3 =(pr_rating/pr_max_tree_yield * (max_willow_yield_year_3 - min_willow_yield_year_3) + min_willow_yield_year_3);
			willow_yield_ip_6 = (pr_rating/pr_max_tree_yield * (max_willow_yield_year_6 - min_willow_yield_year_6) + min_willow_yield_year_6);
			willow_yield_ip_9 = (pr_rating/pr_max_tree_yield * (max_willow_yield_year_9 - min_willow_yield_year_9) + min_willow_yield_year_9);
			willow_yield_ip_12_21 = (pr_rating/pr_max_tree_yield * (max_willow_yield_year_12_21 - min_willow_yield_year_12_21) + min_willow_yield_year_12_21);
		}
		else {
			pr_rating = sama.getIPQuality();
			poplar_yield_ip_3 =(pr_rating/pr_max_tree_yield * (max_poplar_yield_year_3 - min_poplar_yield_year_3) + min_poplar_yield_year_3);
			poplar_yield_ip_6 = (pr_rating/pr_max_tree_yield * (max_poplar_yield_year_6 - min_poplar_yield_year_6) + min_poplar_yield_year_6);
			poplar_yield_ip_9 = (pr_rating/pr_max_tree_yield * (max_poplar_yield_year_9 - min_poplar_yield_year_9) + min_poplar_yield_year_9);
			poplar_yield_ip_12_21 = (pr_rating/pr_max_tree_yield * (max_poplar_yield_year_12_21 - min_poplar_yield_year_12_21) + min_poplar_yield_year_12_21);
			willow_yield_ip_3 =(pr_rating/pr_max_tree_yield * (max_willow_yield_year_3 - min_willow_yield_year_3) + min_willow_yield_year_3);
			willow_yield_ip_6 = (pr_rating/pr_max_tree_yield * (max_willow_yield_year_6 - min_willow_yield_year_6) + min_willow_yield_year_6);
			willow_yield_ip_9 = (pr_rating/pr_max_tree_yield * (max_willow_yield_year_9 - min_willow_yield_year_9) + min_willow_yield_year_9);
			willow_yield_ip_12_21 = (pr_rating/pr_max_tree_yield * (max_willow_yield_year_12_21 - min_willow_yield_year_12_21) + min_willow_yield_year_12_21);
		}
		if(sama.getHayQuality() > pr_max_tree_yield) {
			pr_rating = pr_max_tree_yield;
			poplar_yield_hayland_3 =(pr_rating/pr_max_tree_yield * (max_poplar_yield_year_3 - min_poplar_yield_year_3) + min_poplar_yield_year_3);
			poplar_yield_hayland_6 = (pr_rating/pr_max_tree_yield * (max_poplar_yield_year_6 - min_poplar_yield_year_6) + min_poplar_yield_year_6);
			poplar_yield_hayland_9 = (pr_rating/pr_max_tree_yield * (max_poplar_yield_year_9 - min_poplar_yield_year_9) + min_poplar_yield_year_9);
			poplar_yield_hayland_12_21 = (pr_rating/pr_max_tree_yield * (max_poplar_yield_year_12_21 - min_poplar_yield_year_12_21) + min_poplar_yield_year_12_21);
			willow_yield_hayland_3 =(pr_rating/pr_max_tree_yield * (max_willow_yield_year_3 - min_willow_yield_year_3) + min_willow_yield_year_3);
			willow_yield_hayland_6 = (pr_rating/pr_max_tree_yield * (max_willow_yield_year_6 - min_willow_yield_year_6) + min_willow_yield_year_6);
			willow_yield_hayland_9 = (pr_rating/pr_max_tree_yield * (max_willow_yield_year_9 - min_willow_yield_year_9) + min_willow_yield_year_9);
			willow_yield_hayland_12_21 = (pr_rating/pr_max_tree_yield * (max_willow_yield_year_12_21 - min_willow_yield_year_12_21) + min_willow_yield_year_12_21);
		}
		else {
			pr_rating = sama.getHayQuality();
			poplar_yield_hayland_3 =(pr_rating/pr_max_tree_yield * (max_poplar_yield_year_3 - min_poplar_yield_year_3) + min_poplar_yield_year_3);
			poplar_yield_hayland_6 = (pr_rating/pr_max_tree_yield * (max_poplar_yield_year_6 - min_poplar_yield_year_6) + min_poplar_yield_year_6);
			poplar_yield_hayland_9 = (pr_rating/pr_max_tree_yield * (max_poplar_yield_year_9 - min_poplar_yield_year_9) + min_poplar_yield_year_9);
			poplar_yield_hayland_12_21 = (pr_rating/pr_max_tree_yield * (max_poplar_yield_year_12_21 - min_poplar_yield_year_12_21) + min_poplar_yield_year_12_21);
			willow_yield_hayland_3 =(pr_rating/pr_max_tree_yield * (max_willow_yield_year_3 - min_willow_yield_year_3) + min_willow_yield_year_3);
			willow_yield_hayland_6 = (pr_rating/pr_max_tree_yield * (max_willow_yield_year_6 - min_willow_yield_year_6) + min_willow_yield_year_6);
			willow_yield_hayland_9 = (pr_rating/pr_max_tree_yield * (max_willow_yield_year_9 - min_willow_yield_year_9) + min_willow_yield_year_9);
			willow_yield_hayland_12_21 = (pr_rating/pr_max_tree_yield * (max_willow_yield_year_12_21 - min_willow_yield_year_12_21) + min_willow_yield_year_12_21);
			}
		}
	}
		
	public int needCropLand(int ProducerID) {
		Connection conn;
		int rent = 0;
		try {
			conn = DriverManager.getConnection("jdbc:odbc:producerDB", "java",
					"1234");
			Statement stmt = conn.createStatement();
			ResultSet rs = stmt
					.executeQuery("SELECT rent_cropland FROM MIP WHERE "
							+ "farmerID=" + ProducerID + "and " + "year="
							+ Variables.getyear());

			while (rs.next()) {
				rent = rs.getInt("rent_cropland");

			}
			rs.close();
			stmt.close();
			conn.close();
		} catch (SQLException e) {
			System.out.println("Statement is wrong: " + e.getMessage());
			e.printStackTrace();
		}
		return rent;
	}
	
	 public double[] ReNew_5_years_Values(double[] a, double b){
		  a[4] = a[3];
		  a[3] = a[2];
		  a[2] = a[1];
		  a[1] = a[0];
		  a[0] = b;
		  return a;
	  }	  	 
	 
	 public double[] ReNew_2_years_Values(double[] a, double b){
		 
		  a[1] = a[0];
		  a[0] = b;
		  return a;
	  }	  
}
	
